#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 2970
#define LARGE_STATE_COUNT 965
#define SYMBOL_COUNT 277
#define ALIAS_COUNT 6
#define TOKEN_COUNT 144
#define EXTERNAL_TOKEN_COUNT 22
#define FIELD_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_identifier = 1,
  anon_sym___END__ = 2,
  sym_uninterpreted = 3,
  anon_sym_BEGIN = 4,
  anon_sym_LBRACE = 5,
  anon_sym_RBRACE = 6,
  anon_sym_END = 7,
  anon_sym_def = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_DOT = 11,
  anon_sym_COLON_COLON = 12,
  anon_sym_COMMA = 13,
  anon_sym_PIPE = 14,
  anon_sym_SEMI = 15,
  anon_sym_STAR = 16,
  anon_sym_STAR_STAR = 17,
  anon_sym_AMP = 18,
  anon_sym_COLON = 19,
  anon_sym_EQ = 20,
  anon_sym_class = 21,
  anon_sym_LT = 22,
  anon_sym_module = 23,
  anon_sym_end = 24,
  anon_sym_return = 25,
  anon_sym_yield = 26,
  anon_sym_break = 27,
  anon_sym_next = 28,
  anon_sym_redo = 29,
  anon_sym_retry = 30,
  anon_sym_if = 31,
  anon_sym_unless = 32,
  anon_sym_while = 33,
  anon_sym_until = 34,
  anon_sym_rescue = 35,
  anon_sym_for = 36,
  anon_sym_in = 37,
  anon_sym_do = 38,
  anon_sym_case = 39,
  anon_sym_when = 40,
  anon_sym_elsif = 41,
  anon_sym_else = 42,
  anon_sym_then = 43,
  anon_sym_begin = 44,
  anon_sym_ensure = 45,
  anon_sym_EQ_GT = 46,
  anon_sym_LBRACK = 47,
  anon_sym_RBRACK = 48,
  anon_sym_COLON_COLON2 = 49,
  anon_sym_AMP_DOT = 50,
  anon_sym_LPAREN2 = 51,
  anon_sym_PLUS_EQ = 52,
  anon_sym_DASH_EQ = 53,
  anon_sym_STAR_EQ = 54,
  anon_sym_STAR_STAR_EQ = 55,
  anon_sym_SLASH_EQ = 56,
  anon_sym_PIPE_PIPE_EQ = 57,
  anon_sym_PIPE_EQ = 58,
  anon_sym_AMP_AMP_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PERCENT_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_LT_LT_EQ = 63,
  anon_sym_CARET_EQ = 64,
  anon_sym_QMARK = 65,
  anon_sym_COLON2 = 66,
  anon_sym_DOT_DOT = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_and = 69,
  anon_sym_or = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_LT_LT = 73,
  anon_sym_GT_GT = 74,
  anon_sym_LT_EQ = 75,
  anon_sym_GT = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_CARET = 78,
  anon_sym_PLUS = 79,
  anon_sym_SLASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_LT_EQ_GT = 85,
  anon_sym_EQ_TILDE = 86,
  anon_sym_BANG_TILDE = 87,
  anon_sym_defined_QMARK = 88,
  anon_sym_not = 89,
  anon_sym_BANG = 90,
  anon_sym_TILDE = 91,
  sym_constant = 92,
  sym_instance_variable = 93,
  sym_class_variable = 94,
  sym_global_variable = 95,
  anon_sym_DASH = 96,
  anon_sym_PLUS_AT = 97,
  anon_sym_DASH_AT = 98,
  anon_sym_LBRACK_RBRACK = 99,
  anon_sym_LBRACK_RBRACK_EQ = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_undef = 102,
  anon_sym_alias = 103,
  sym_comment = 104,
  sym_integer = 105,
  sym_float = 106,
  sym_complex = 107,
  anon_sym_r = 108,
  sym_super = 109,
  anon_sym_true = 110,
  anon_sym_TRUE = 111,
  anon_sym_false = 112,
  anon_sym_FALSE = 113,
  sym_self = 114,
  anon_sym_nil = 115,
  anon_sym_NIL = 116,
  sym_character = 117,
  anon_sym_POUND_LBRACE = 118,
  aux_sym_string_array_token1 = 119,
  sym_escape_sequence = 120,
  anon_sym_LBRACK2 = 121,
  anon_sym_DASH_GT = 122,
  sym__line_break = 123,
  sym__simple_symbol = 124,
  sym__string_start = 125,
  sym__symbol_start = 126,
  sym__subshell_start = 127,
  sym__regex_start = 128,
  sym__string_array_start = 129,
  sym__symbol_array_start = 130,
  sym__heredoc_body_start = 131,
  sym__string_content = 132,
  sym__heredoc_content = 133,
  sym__string_end = 134,
  sym_heredoc_end = 135,
  sym_heredoc_beginning = 136,
  sym__block_ampersand = 137,
  sym__splat_star = 138,
  sym__unary_minus = 139,
  sym__binary_minus = 140,
  sym__binary_star = 141,
  sym__singleton_class_left_angle_left_langle = 142,
  sym__identifier_hash_key = 143,
  sym_program = 144,
  sym__statements = 145,
  sym_begin_block = 146,
  sym_end_block = 147,
  sym__statement = 148,
  sym_method = 149,
  sym_singleton_method = 150,
  sym__method_rest = 151,
  sym_parameters = 152,
  sym_bare_parameters = 153,
  sym_block_parameters = 154,
  sym__formal_parameter = 155,
  sym__simple_formal_parameter = 156,
  sym_splat_parameter = 157,
  sym_hash_splat_parameter = 158,
  sym_block_parameter = 159,
  sym_keyword_parameter = 160,
  sym_optional_parameter = 161,
  sym_class = 162,
  sym_superclass = 163,
  sym_singleton_class = 164,
  sym_module = 165,
  sym_return_command = 166,
  sym_yield_command = 167,
  sym_break_command = 168,
  sym_next_command = 169,
  sym_return = 170,
  sym_yield = 171,
  sym_break = 172,
  sym_next = 173,
  sym_redo = 174,
  sym_retry = 175,
  sym_if_modifier = 176,
  sym_unless_modifier = 177,
  sym_while_modifier = 178,
  sym_until_modifier = 179,
  sym_rescue_modifier = 180,
  sym_while = 181,
  sym_until = 182,
  sym_for = 183,
  sym_in = 184,
  sym__do = 185,
  sym_case = 186,
  sym_when = 187,
  sym_pattern = 188,
  sym_if = 189,
  sym_unless = 190,
  sym_elsif = 191,
  sym_else = 192,
  sym_then = 193,
  sym_begin = 194,
  sym_ensure = 195,
  sym_rescue = 196,
  sym_exceptions = 197,
  sym_exception_variable = 198,
  sym__body_statement = 199,
  sym__expression = 200,
  sym__arg = 201,
  sym__primary = 202,
  sym_parenthesized_statements = 203,
  sym_element_reference = 204,
  sym_scope_resolution = 205,
  sym_call = 206,
  sym_command_call = 207,
  sym_method_call = 208,
  sym_command_argument_list = 209,
  sym_argument_list = 210,
  sym__argument_list_with_trailing_comma = 211,
  sym__argument = 212,
  sym_splat_argument = 213,
  sym_hash_splat_argument = 214,
  sym_block_argument = 215,
  sym_do_block = 216,
  sym_block = 217,
  sym_assignment = 218,
  sym_command_assignment = 219,
  sym_operator_assignment = 220,
  sym_command_operator_assignment = 221,
  sym_conditional = 222,
  sym_range = 223,
  sym_binary = 224,
  sym_command_binary = 225,
  sym_unary = 226,
  sym_parenthesized_unary = 227,
  sym_unary_literal = 228,
  sym_right_assignment_list = 229,
  sym_left_assignment_list = 230,
  sym__mlhs = 231,
  sym_destructured_left_assignment = 232,
  sym_rest_assignment = 233,
  sym__lhs = 234,
  sym__variable = 235,
  sym_operator = 236,
  sym__method_name = 237,
  sym_setter = 238,
  sym_undef = 239,
  sym_alias = 240,
  sym_rational = 241,
  sym_true = 242,
  sym_false = 243,
  sym_nil = 244,
  sym_chained_string = 245,
  sym_interpolation = 246,
  sym_string = 247,
  sym_subshell = 248,
  sym_string_array = 249,
  sym_symbol_array = 250,
  sym_symbol = 251,
  sym_regex = 252,
  sym_heredoc_body = 253,
  aux_sym__literal_contents = 254,
  sym_array = 255,
  sym_hash = 256,
  sym_pair = 257,
  sym_lambda = 258,
  sym_empty_statement = 259,
  sym__terminator = 260,
  aux_sym__statements_repeat1 = 261,
  aux_sym_parameters_repeat1 = 262,
  aux_sym_block_parameters_repeat1 = 263,
  aux_sym_case_repeat1 = 264,
  aux_sym_case_repeat2 = 265,
  aux_sym_when_repeat1 = 266,
  aux_sym_exceptions_repeat1 = 267,
  aux_sym__body_statement_repeat1 = 268,
  aux_sym_command_argument_list_repeat1 = 269,
  aux_sym__mlhs_repeat1 = 270,
  aux_sym_undef_repeat1 = 271,
  aux_sym_chained_string_repeat1 = 272,
  aux_sym_string_array_repeat1 = 273,
  aux_sym_symbol_array_repeat1 = 274,
  aux_sym_heredoc_body_repeat1 = 275,
  aux_sym_hash_repeat1 = 276,
  anon_alias_sym_DQUOTE = 277,
  alias_sym_bare_string = 278,
  alias_sym_bare_symbol = 279,
  alias_sym_destructured_parameter = 280,
  alias_sym_lambda_parameters = 281,
  alias_sym_method_parameters = 282,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym___END__] = "__END__",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_end] = "end",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [anon_sym_redo] = "redo",
  [anon_sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_rescue] = "rescue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "?",
  [anon_sym_COLON2] = ":",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_CARET] = "^",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_defined_QMARK] = "defined?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [sym_constant] = "constant",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_complex] = "complex",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [anon_sym_true] = "true",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_false] = "false",
  [anon_sym_FALSE] = "FALSE",
  [sym_self] = "self",
  [anon_sym_nil] = "nil",
  [anon_sym_NIL] = "NIL",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_string_array_token1] = "string_array_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT] = "->",
  [sym__line_break] = "_line_break",
  [sym__simple_symbol] = "_simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym__string_content] = "_string_content",
  [sym__heredoc_content] = "_heredoc_content",
  [sym__string_end] = "_string_end",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "&",
  [sym__splat_star] = "*",
  [sym__unary_minus] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym__identifier_hash_key] = "symbol",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_parameters] = "parameters",
  [sym_bare_parameters] = "bare_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return_command] = "return",
  [sym_yield_command] = "yield",
  [sym_break_command] = "break",
  [sym_next_command] = "next",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym__do] = "_do",
  [sym_case] = "case",
  [sym_when] = "when",
  [sym_pattern] = "pattern",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym__body_statement] = "_body_statement",
  [sym__expression] = "_expression",
  [sym__arg] = "_arg",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym_call] = "call",
  [sym_command_call] = "command_call",
  [sym_method_call] = "method_call",
  [sym_command_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_command_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_command_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_command_binary] = "binary",
  [sym_unary] = "unary",
  [sym_parenthesized_unary] = "unary",
  [sym_unary_literal] = "unary",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym_rational] = "rational",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_symbol] = "symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [aux_sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_repeat2] = "case_repeat2",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym__body_statement_repeat1] = "_body_statement_repeat1",
  [aux_sym_command_argument_list_repeat1] = "command_argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_hash_repeat1] = "hash_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_destructured_parameter] = "destructured_parameter",
  [alias_sym_lambda_parameters] = "lambda_parameters",
  [alias_sym_method_parameters] = "method_parameters",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym___END__] = anon_sym___END__,
  [sym_uninterpreted] = sym_uninterpreted,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_next] = anon_sym_next,
  [anon_sym_redo] = anon_sym_redo,
  [anon_sym_retry] = anon_sym_retry,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_rescue] = anon_sym_rescue,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_ensure] = anon_sym_ensure,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON2,
  [anon_sym_AMP_DOT] = anon_sym_AMP_DOT,
  [anon_sym_LPAREN2] = anon_sym_LPAREN2,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON2] = anon_sym_COLON2,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_defined_QMARK] = anon_sym_defined_QMARK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_constant] = sym_constant,
  [sym_instance_variable] = sym_instance_variable,
  [sym_class_variable] = sym_class_variable,
  [sym_global_variable] = sym_global_variable,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_AT] = anon_sym_PLUS_AT,
  [anon_sym_DASH_AT] = anon_sym_DASH_AT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_alias] = anon_sym_alias,
  [sym_comment] = sym_comment,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_complex] = sym_complex,
  [anon_sym_r] = anon_sym_r,
  [sym_super] = sym_super,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_TRUE] = anon_sym_TRUE,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_FALSE] = anon_sym_FALSE,
  [sym_self] = sym_self,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_NIL] = anon_sym_NIL,
  [sym_character] = sym_character,
  [anon_sym_POUND_LBRACE] = anon_sym_POUND_LBRACE,
  [aux_sym_string_array_token1] = aux_sym_string_array_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_LBRACK2] = anon_sym_LBRACK2,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym__line_break] = sym__line_break,
  [sym__simple_symbol] = sym__simple_symbol,
  [sym__string_start] = sym__string_start,
  [sym__symbol_start] = sym__symbol_start,
  [sym__subshell_start] = anon_sym_BQUOTE,
  [sym__regex_start] = anon_sym_SLASH,
  [sym__string_array_start] = sym__string_array_start,
  [sym__symbol_array_start] = sym__symbol_array_start,
  [sym__heredoc_body_start] = sym__heredoc_body_start,
  [sym__string_content] = sym__string_content,
  [sym__heredoc_content] = sym__heredoc_content,
  [sym__string_end] = sym__string_end,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_heredoc_beginning] = sym_heredoc_beginning,
  [sym__block_ampersand] = anon_sym_AMP,
  [sym__splat_star] = anon_sym_STAR,
  [sym__unary_minus] = anon_sym_DASH,
  [sym__binary_minus] = anon_sym_DASH,
  [sym__binary_star] = anon_sym_STAR,
  [sym__singleton_class_left_angle_left_langle] = anon_sym_LT_LT,
  [sym__identifier_hash_key] = sym_symbol,
  [sym_program] = sym_program,
  [sym__statements] = sym__statements,
  [sym_begin_block] = sym_begin_block,
  [sym_end_block] = sym_end_block,
  [sym__statement] = sym__statement,
  [sym_method] = sym_method,
  [sym_singleton_method] = sym_singleton_method,
  [sym__method_rest] = sym__method_rest,
  [sym_parameters] = sym_parameters,
  [sym_bare_parameters] = sym_bare_parameters,
  [sym_block_parameters] = sym_block_parameters,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_splat_parameter] = sym_splat_parameter,
  [sym_hash_splat_parameter] = sym_hash_splat_parameter,
  [sym_block_parameter] = sym_block_parameter,
  [sym_keyword_parameter] = sym_keyword_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_class] = sym_class,
  [sym_superclass] = sym_superclass,
  [sym_singleton_class] = sym_singleton_class,
  [sym_module] = sym_module,
  [sym_return_command] = sym_return,
  [sym_yield_command] = sym_yield,
  [sym_break_command] = sym_break,
  [sym_next_command] = sym_next,
  [sym_return] = sym_return,
  [sym_yield] = sym_yield,
  [sym_break] = sym_break,
  [sym_next] = sym_next,
  [sym_redo] = sym_redo,
  [sym_retry] = sym_retry,
  [sym_if_modifier] = sym_if_modifier,
  [sym_unless_modifier] = sym_unless_modifier,
  [sym_while_modifier] = sym_while_modifier,
  [sym_until_modifier] = sym_until_modifier,
  [sym_rescue_modifier] = sym_rescue_modifier,
  [sym_while] = sym_while,
  [sym_until] = sym_until,
  [sym_for] = sym_for,
  [sym_in] = sym_in,
  [sym__do] = sym__do,
  [sym_case] = sym_case,
  [sym_when] = sym_when,
  [sym_pattern] = sym_pattern,
  [sym_if] = sym_if,
  [sym_unless] = sym_unless,
  [sym_elsif] = sym_elsif,
  [sym_else] = sym_else,
  [sym_then] = sym_then,
  [sym_begin] = sym_begin,
  [sym_ensure] = sym_ensure,
  [sym_rescue] = sym_rescue,
  [sym_exceptions] = sym_exceptions,
  [sym_exception_variable] = sym_exception_variable,
  [sym__body_statement] = sym__body_statement,
  [sym__expression] = sym__expression,
  [sym__arg] = sym__arg,
  [sym__primary] = sym__primary,
  [sym_parenthesized_statements] = sym_parenthesized_statements,
  [sym_element_reference] = sym_element_reference,
  [sym_scope_resolution] = sym_scope_resolution,
  [sym_call] = sym_call,
  [sym_command_call] = sym_command_call,
  [sym_method_call] = sym_method_call,
  [sym_command_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym__argument_list_with_trailing_comma] = sym__argument_list_with_trailing_comma,
  [sym__argument] = sym__argument,
  [sym_splat_argument] = sym_splat_argument,
  [sym_hash_splat_argument] = sym_hash_splat_argument,
  [sym_block_argument] = sym_block_argument,
  [sym_do_block] = sym_do_block,
  [sym_block] = sym_block,
  [sym_assignment] = sym_assignment,
  [sym_command_assignment] = sym_assignment,
  [sym_operator_assignment] = sym_operator_assignment,
  [sym_command_operator_assignment] = sym_operator_assignment,
  [sym_conditional] = sym_conditional,
  [sym_range] = sym_range,
  [sym_binary] = sym_binary,
  [sym_command_binary] = sym_binary,
  [sym_unary] = sym_unary,
  [sym_parenthesized_unary] = sym_unary,
  [sym_unary_literal] = sym_unary,
  [sym_right_assignment_list] = sym_right_assignment_list,
  [sym_left_assignment_list] = sym_left_assignment_list,
  [sym__mlhs] = sym__mlhs,
  [sym_destructured_left_assignment] = sym_destructured_left_assignment,
  [sym_rest_assignment] = sym_rest_assignment,
  [sym__lhs] = sym__lhs,
  [sym__variable] = sym__variable,
  [sym_operator] = sym_operator,
  [sym__method_name] = sym__method_name,
  [sym_setter] = sym_setter,
  [sym_undef] = sym_undef,
  [sym_alias] = sym_alias,
  [sym_rational] = sym_rational,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_nil] = sym_nil,
  [sym_chained_string] = sym_chained_string,
  [sym_interpolation] = sym_interpolation,
  [sym_string] = sym_string,
  [sym_subshell] = sym_subshell,
  [sym_string_array] = sym_string_array,
  [sym_symbol_array] = sym_symbol_array,
  [sym_symbol] = sym_symbol,
  [sym_regex] = sym_regex,
  [sym_heredoc_body] = sym_heredoc_body,
  [aux_sym__literal_contents] = aux_sym__literal_contents,
  [sym_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym_pair] = sym_pair,
  [sym_lambda] = sym_lambda,
  [sym_empty_statement] = sym_empty_statement,
  [sym__terminator] = sym__terminator,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_block_parameters_repeat1] = aux_sym_block_parameters_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_case_repeat2] = aux_sym_case_repeat2,
  [aux_sym_when_repeat1] = aux_sym_when_repeat1,
  [aux_sym_exceptions_repeat1] = aux_sym_exceptions_repeat1,
  [aux_sym__body_statement_repeat1] = aux_sym__body_statement_repeat1,
  [aux_sym_command_argument_list_repeat1] = aux_sym_command_argument_list_repeat1,
  [aux_sym__mlhs_repeat1] = aux_sym__mlhs_repeat1,
  [aux_sym_undef_repeat1] = aux_sym_undef_repeat1,
  [aux_sym_chained_string_repeat1] = aux_sym_chained_string_repeat1,
  [aux_sym_string_array_repeat1] = aux_sym_string_array_repeat1,
  [aux_sym_symbol_array_repeat1] = aux_sym_symbol_array_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_hash_repeat1] = aux_sym_hash_repeat1,
  [anon_alias_sym_DQUOTE] = anon_alias_sym_DQUOTE,
  [alias_sym_bare_string] = alias_sym_bare_string,
  [alias_sym_bare_symbol] = alias_sym_bare_symbol,
  [alias_sym_destructured_parameter] = alias_sym_destructured_parameter,
  [alias_sym_lambda_parameters] = alias_sym_lambda_parameters,
  [alias_sym_method_parameters] = alias_sym_method_parameters,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_redo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_retry] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NIL] = {
    .visible = true,
    .named = false,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_array_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_symbol] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = true,
    .named = false,
  },
  [sym__splat_star] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym__identifier_hash_key] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_bare_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return_command] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_command] = {
    .visible = true,
    .named = true,
  },
  [sym_break_command] = {
    .visible = true,
    .named = true,
  },
  [sym_next_command] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__literal_contents] = {
    .visible = false,
    .named = false,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__body_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hash_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_block = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_exceptions = 8,
  field_handler = 9,
  field_key = 10,
  field_left = 11,
  field_method = 12,
  field_name = 13,
  field_object = 14,
  field_operator = 15,
  field_parameters = 16,
  field_pattern = 17,
  field_receiver = 18,
  field_right = 19,
  field_scope = 20,
  field_value = 21,
  field_variable = 22,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_block] = "block",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_exceptions] = "exceptions",
  [field_handler] = "handler",
  [field_key] = "key",
  [field_left] = "left",
  [field_method] = "method",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_receiver] = "receiver",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[65] = {
  [6] = {.index = 0, .length = 2},
  [7] = {.index = 2, .length = 1},
  [8] = {.index = 3, .length = 1},
  [9] = {.index = 4, .length = 2},
  [10] = {.index = 6, .length = 2},
  [17] = {.index = 8, .length = 1},
  [18] = {.index = 9, .length = 2},
  [20] = {.index = 11, .length = 1},
  [21] = {.index = 12, .length = 2},
  [22] = {.index = 14, .length = 2},
  [23] = {.index = 16, .length = 2},
  [24] = {.index = 18, .length = 3},
  [25] = {.index = 21, .length = 2},
  [26] = {.index = 23, .length = 1},
  [27] = {.index = 24, .length = 2},
  [28] = {.index = 26, .length = 3},
  [29] = {.index = 29, .length = 2},
  [37] = {.index = 31, .length = 2},
  [38] = {.index = 31, .length = 2},
  [39] = {.index = 33, .length = 3},
  [40] = {.index = 36, .length = 2},
  [41] = {.index = 38, .length = 2},
  [42] = {.index = 40, .length = 1},
  [43] = {.index = 41, .length = 2},
  [44] = {.index = 43, .length = 1},
  [45] = {.index = 44, .length = 2},
  [46] = {.index = 46, .length = 1},
  [47] = {.index = 47, .length = 2},
  [52] = {.index = 49, .length = 1},
  [53] = {.index = 50, .length = 3},
  [54] = {.index = 53, .length = 2},
  [55] = {.index = 55, .length = 2},
  [56] = {.index = 57, .length = 1},
  [57] = {.index = 58, .length = 3},
  [58] = {.index = 61, .length = 2},
  [59] = {.index = 63, .length = 3},
  [62] = {.index = 66, .length = 3},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 72, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [2] =
    {field_name, 1},
  [3] =
    {field_body, 1},
  [4] =
    {field_arguments, 1},
    {field_method, 0},
  [6] =
    {field_block, 1},
    {field_method, 0},
  [8] =
    {field_condition, 1},
  [9] =
    {field_alias, 2},
    {field_name, 1},
  [11] =
    {field_name, 0},
  [12] =
    {field_body, 2},
    {field_parameters, 1},
  [14] =
    {field_body, 0},
    {field_condition, 2},
  [16] =
    {field_body, 0},
    {field_handler, 2},
  [18] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [21] =
    {field_method, 2},
    {field_receiver, 0},
  [23] =
    {field_object, 0},
  [24] =
    {field_name, 2},
    {field_scope, 0},
  [26] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0},
  [29] =
    {field_left, 0},
    {field_right, 2},
  [31] =
    {field_key, 0},
    {field_value, 2},
  [33] =
    {field_name, 3, .inherited = true},
    {field_object, 1},
    {field_parameters, 3, .inherited = true},
  [36] =
    {field_name, 0},
    {field_parameters, 1},
  [38] =
    {field_condition, 1},
    {field_consequence, 2},
  [40] =
    {field_value, 1},
  [41] =
    {field_body, 2},
    {field_exceptions, 1},
  [43] =
    {field_exceptions, 1},
  [44] =
    {field_body, 2},
    {field_variable, 1},
  [46] =
    {field_variable, 1},
  [47] =
    {field_name, 0},
    {field_value, 2},
  [49] =
    {field_value, 2},
  [50] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [53] =
    {field_pattern, 1},
    {field_value, 2},
  [55] =
    {field_body, 2},
    {field_pattern, 1},
  [57] =
    {field_pattern, 1},
  [58] =
    {field_body, 3},
    {field_exceptions, 1},
    {field_variable, 2},
  [61] =
    {field_exceptions, 1},
    {field_variable, 2},
  [63] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [66] =
    {field_name, 5, .inherited = true},
    {field_object, 2},
    {field_parameters, 5, .inherited = true},
  [69] =
    {field_body, 3},
    {field_pattern, 1},
    {field_pattern, 2},
  [72] =
    {field_pattern, 1},
    {field_pattern, 2},
};

static TSSymbol ts_alias_sequences[65][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_method_call,
  },
  [2] = {
    [1] = anon_alias_sym_DQUOTE,
  },
  [3] = {
    [1] = anon_sym_BQUOTE,
  },
  [4] = {
    [1] = anon_sym_SLASH,
  },
  [5] = {
    [1] = anon_sym_RPAREN,
  },
  [11] = {
    [2] = anon_alias_sym_DQUOTE,
  },
  [12] = {
    [2] = anon_sym_BQUOTE,
  },
  [13] = {
    [2] = anon_sym_SLASH,
  },
  [14] = {
    [2] = anon_sym_RPAREN,
  },
  [15] = {
    [1] = alias_sym_bare_string,
    [2] = anon_sym_RPAREN,
  },
  [16] = {
    [1] = alias_sym_bare_symbol,
    [2] = anon_sym_RPAREN,
  },
  [19] = {
    [0] = alias_sym_destructured_parameter,
  },
  [21] = {
    [1] = alias_sym_lambda_parameters,
  },
  [30] = {
    [3] = anon_sym_RPAREN,
  },
  [31] = {
    [2] = alias_sym_bare_string,
    [3] = anon_sym_RPAREN,
  },
  [32] = {
    [1] = alias_sym_bare_string,
    [3] = anon_sym_RPAREN,
  },
  [33] = {
    [1] = alias_sym_bare_string,
  },
  [34] = {
    [2] = alias_sym_bare_symbol,
    [3] = anon_sym_RPAREN,
  },
  [35] = {
    [1] = alias_sym_bare_symbol,
    [3] = anon_sym_RPAREN,
  },
  [36] = {
    [1] = alias_sym_bare_symbol,
  },
  [38] = {
    [0] = sym_symbol,
  },
  [40] = {
    [1] = alias_sym_method_parameters,
  },
  [48] = {
    [2] = alias_sym_bare_string,
    [4] = anon_sym_RPAREN,
  },
  [49] = {
    [1] = alias_sym_bare_string,
    [4] = anon_sym_RPAREN,
  },
  [50] = {
    [2] = alias_sym_bare_symbol,
    [4] = anon_sym_RPAREN,
  },
  [51] = {
    [1] = alias_sym_bare_symbol,
    [4] = anon_sym_RPAREN,
  },
  [60] = {
    [2] = alias_sym_bare_string,
    [5] = anon_sym_RPAREN,
  },
  [61] = {
    [2] = alias_sym_bare_symbol,
    [5] = anon_sym_RPAREN,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(199);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(82)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(93)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead)) ADVANCE(235);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(44);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0) ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(15)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(16)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(17)
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(21)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(19)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(22)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(24)
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(29)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(27)
      END_STATE();
    case 11:
      if (lookahead == '\n') ADVANCE(277);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(280);
      if (lookahead != 0) ADVANCE(276);
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(278);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(280);
      if (lookahead != 0) ADVANCE(276);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(31)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(32)
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(47);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(3)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(235);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|') ADVANCE(235);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(179);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 20:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(149);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 21:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(5)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 22:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 23:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 24:
      if (lookahead == '!') ADVANCE(215);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(201);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(235);
      END_STATE();
    case 25:
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 26:
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      END_STATE();
    case 27:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(145);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 28:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 29:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 30:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == ':') ADVANCE(149);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 31:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 32:
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') SKIP(14)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(275);
      END_STATE();
    case 33:
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 34:
      if (lookahead == '*') ADVANCE(143);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(79);
      END_STATE();
    case 36:
      if (lookahead == '.') ADVANCE(161);
      END_STATE();
    case 37:
      if (lookahead == '.') ADVANCE(181);
      END_STATE();
    case 38:
      if (lookahead == '.') ADVANCE(180);
      END_STATE();
    case 39:
      if (lookahead == ':') ADVANCE(160);
      END_STATE();
    case 40:
      if (lookahead == ':') ADVANCE(134);
      END_STATE();
    case 41:
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '~') ADVANCE(212);
      END_STATE();
    case 42:
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(54);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 43:
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == 'b') ADVANCE(54);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 44:
      if (lookahead == '=') ADVANCE(55);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 46:
      if (lookahead == '=') ADVANCE(164);
      if (lookahead == '>') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 47:
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(54);
      END_STATE();
    case 48:
      if (lookahead == '>') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 49:
      if (lookahead == '@') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 50:
      if (lookahead == '\\') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 51:
      if (lookahead == ']') ADVANCE(246);
      END_STATE();
    case 52:
      if (lookahead == 'b') ADVANCE(54);
      END_STATE();
    case 53:
      if (lookahead == 'd') ADVANCE(249);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(60);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 56:
      if (lookahead == 'g') ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(264);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(1);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(53);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 62:
      if (lookahead == '}') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 63:
      if (lookahead == '}') ADVANCE(276);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 64:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      END_STATE();
    case 65:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(256);
      END_STATE();
    case 66:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(252);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(257);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(254);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(262);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(255);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(276);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(281);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 78:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 79:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 80:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(270);
      END_STATE();
    case 81:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(237);
      END_STATE();
    case 82:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(93)
      END_STATE();
    case 83:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(100)
      END_STATE();
    case 84:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(108)
      END_STATE();
    case 85:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(104)
      END_STATE();
    case 86:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(103)
      END_STATE();
    case 87:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(106)
      END_STATE();
    case 88:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(107)
      END_STATE();
    case 89:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(110)
      END_STATE();
    case 90:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(96)
      END_STATE();
    case 91:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(97)
      END_STATE();
    case 92:
      if (eof) ADVANCE(111);
      if (lookahead == '\n') SKIP(99)
      END_STATE();
    case 93:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(250);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(199);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(243);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(82)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '`') ADVANCE(248);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(93)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead)) ADVANCE(235);
      END_STATE();
    case 94:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(90)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(96)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 95:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(91)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(97)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 96:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(90)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(96)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 97:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(200);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(91)
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(97)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 98:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(92)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(99)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 99:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(214);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(177);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(92)
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(99)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 100:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(47);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'B') ADVANCE(220);
      if (lookahead == 'E') ADVANCE(228);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(83)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '~') ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(100)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`') ADVANCE(235);
      END_STATE();
    case 101:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(85)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(104)
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 102:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ':') ADVANCE(179);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(86)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(103)
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 103:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(86)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(103)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 104:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(206);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(152);
      if (lookahead == '>') ADVANCE(192);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(85)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(196);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(104)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 105:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ':') ADVANCE(150);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(87)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '@' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 106:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(148);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '0') ADVANCE(253);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(87)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(254);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 107:
      if (eof) ADVANCE(111);
      if (lookahead == '!') ADVANCE(41);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '%') ADVANCE(205);
      if (lookahead == '&') ADVANCE(147);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(34);
      if (lookahead == '+') ADVANCE(197);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(37);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == ':') ADVANCE(178);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(193);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') SKIP(88)
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(195);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(107)
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(235);
      END_STATE();
    case 108:
      if (eof) ADVANCE(111);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '$') ADVANCE(239);
      if (lookahead == '(') ADVANCE(130);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(202);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '0') ADVANCE(260);
      if (lookahead == ':') ADVANCE(40);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '?') ADVANCE(50);
      if (lookahead == '@') ADVANCE(49);
      if (lookahead == 'F') ADVANCE(218);
      if (lookahead == 'N') ADVANCE(225);
      if (lookahead == 'T') ADVANCE(230);
      if (lookahead == '[') ADVANCE(282);
      if (lookahead == '\\') SKIP(84)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(108)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(233);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 109:
      if (eof) ADVANCE(111);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == '(') ADVANCE(162);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(154);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') SKIP(89)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(110)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 110:
      if (eof) ADVANCE(111);
      if (lookahead == '#') ADVANCE(251);
      if (lookahead == '&') ADVANCE(36);
      if (lookahead == ')') ADVANCE(131);
      if (lookahead == ',') ADVANCE(135);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == ';') ADVANCE(139);
      if (lookahead == '<') ADVANCE(154);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '\\') SKIP(89)
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(110)
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(115);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(116);
      if (lookahead != 0) ADVANCE(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(117);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead != 0) ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(115);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '\\') ADVANCE(112);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != '=') ADVANCE(117);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'b') ADVANCE(116);
      if (lookahead == 'b') ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'd') ADVANCE(117);
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'e') ADVANCE(116);
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'e') ADVANCE(117);
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'g') ADVANCE(116);
      if (lookahead == 'g') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'i') ADVANCE(116);
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'n') ADVANCE(116);
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0 &&
          lookahead != 'n') ADVANCE(117);
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(181);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(169);
      if (lookahead == '|') ADVANCE(184);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(183);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(186);
      if (lookahead == '.') ADVANCE(161);
      if (lookahead == '=') ADVANCE(171);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(185);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '.') ADVANCE(161);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(160);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '~') ADVANCE(211);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(188);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(187);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(160);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(174);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(173);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(210);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(190);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(189);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(175);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(163);
      if (lookahead == '@') ADVANCE(244);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@') ADVANCE(244);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(57);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(208);
      if (lookahead == '~') ADVANCE(212);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~') ADVANCE(212);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_constant);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'A') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'D') ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'E') ADVANCE(223);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'E') ADVANCE(265);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'E') ADVANCE(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'G') ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'I') ADVANCE(229);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'I') ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'L') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'N') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'N') ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'R') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'S') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead == 'U') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '-') ADVANCE(241);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(238);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(242);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= ',') ||
          ('.' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(238);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(242);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(245);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(247);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(251);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(251);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(254);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(73);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(65);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(70);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(252);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(254);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(255);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(257);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == 'i') ADVANCE(264);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(261);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(259);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'i') ADVANCE(264);
      if (lookahead == 'x') ADVANCE(73);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(261);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(65);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(70);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(259);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (lookahead == '.') ADVANCE(69);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'i') ADVANCE(264);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(69);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(262);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_complex);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_TRUE);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_FALSE);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_NIL);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(233);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-') ADVANCE(80);
      if (lookahead == '{') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M') ADVANCE(35);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(269);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(275);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(274);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(12);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(276);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(279);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(276);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\\') SKIP(1)
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 2:
      if (lookahead == '_') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(20);
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'l') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      END_STATE();
    case 12:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(42);
      if (lookahead == 'r') ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'n') ADVANCE(44);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(45);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(46);
      END_STATE();
    case 19:
      if (lookahead == 'E') ADVANCE(47);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(48);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(49);
      END_STATE();
    case 22:
      if (lookahead == 'g') ADVANCE(50);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(52);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(54);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(55);
      END_STATE();
    case 29:
      if (lookahead == 'd') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'x') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 39:
      if (lookahead == 'd') ADVANCE(64);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(67);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(68);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 43:
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 44:
      if (lookahead == 'd') ADVANCE(71);
      if (lookahead == 'l') ADVANCE(72);
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(74);
      if (lookahead == 'i') ADVANCE(75);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 47:
      if (lookahead == 'N') ADVANCE(77);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(79);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'i') ADVANCE(83);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(84);
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 58:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(90);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(91);
      END_STATE();
    case 66:
      if (lookahead == 'r') ADVANCE(92);
      if (lookahead == 'u') ADVANCE(93);
      END_STATE();
    case 67:
      if (lookahead == 'f') ADVANCE(94);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(100);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(101);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(102);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 77:
      if (lookahead == 'D') ADVANCE(104);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 79:
      if (lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 80:
      if (lookahead == 'k') ADVANCE(107);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 85:
      if (lookahead == 'f') ADVANCE(110);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 88:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_redo);
      END_STATE();
    case 91:
      if (lookahead == 'u') ADVANCE(114);
      END_STATE();
    case 92:
      if (lookahead == 'y') ADVANCE(115);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 95:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 98:
      if (lookahead == 'f') ADVANCE(118);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 103:
      if (lookahead == 'd') ADVANCE(122);
      END_STATE();
    case 104:
      if (lookahead == '_') ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_retry);
      END_STATE();
    case 116:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 119:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 123:
      if (lookahead == '_') ADVANCE(130);
      END_STATE();
    case 124:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 131:
      if (lookahead == '?') ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 100, .external_lex_state = 2},
  [2] = {.lex_state = 94, .external_lex_state = 3},
  [3] = {.lex_state = 94, .external_lex_state = 3},
  [4] = {.lex_state = 95, .external_lex_state = 3},
  [5] = {.lex_state = 94, .external_lex_state = 3},
  [6] = {.lex_state = 94, .external_lex_state = 3},
  [7] = {.lex_state = 95, .external_lex_state = 3},
  [8] = {.lex_state = 94, .external_lex_state = 4},
  [9] = {.lex_state = 94, .external_lex_state = 4},
  [10] = {.lex_state = 95, .external_lex_state = 4},
  [11] = {.lex_state = 98, .external_lex_state = 3},
  [12] = {.lex_state = 98, .external_lex_state = 3},
  [13] = {.lex_state = 98, .external_lex_state = 3},
  [14] = {.lex_state = 98, .external_lex_state = 3},
  [15] = {.lex_state = 98, .external_lex_state = 3},
  [16] = {.lex_state = 98, .external_lex_state = 3},
  [17] = {.lex_state = 98, .external_lex_state = 3},
  [18] = {.lex_state = 98, .external_lex_state = 3},
  [19] = {.lex_state = 98, .external_lex_state = 4},
  [20] = {.lex_state = 98, .external_lex_state = 4},
  [21] = {.lex_state = 98, .external_lex_state = 4},
  [22] = {.lex_state = 98, .external_lex_state = 4},
  [23] = {.lex_state = 100, .external_lex_state = 5},
  [24] = {.lex_state = 100, .external_lex_state = 5},
  [25] = {.lex_state = 100, .external_lex_state = 5},
  [26] = {.lex_state = 100, .external_lex_state = 5},
  [27] = {.lex_state = 100, .external_lex_state = 5},
  [28] = {.lex_state = 100, .external_lex_state = 5},
  [29] = {.lex_state = 100, .external_lex_state = 5},
  [30] = {.lex_state = 100, .external_lex_state = 5},
  [31] = {.lex_state = 100, .external_lex_state = 6},
  [32] = {.lex_state = 100, .external_lex_state = 6},
  [33] = {.lex_state = 100, .external_lex_state = 6},
  [34] = {.lex_state = 100, .external_lex_state = 6},
  [35] = {.lex_state = 100, .external_lex_state = 2},
  [36] = {.lex_state = 100, .external_lex_state = 2},
  [37] = {.lex_state = 100, .external_lex_state = 5},
  [38] = {.lex_state = 100, .external_lex_state = 5},
  [39] = {.lex_state = 100, .external_lex_state = 5},
  [40] = {.lex_state = 100, .external_lex_state = 2},
  [41] = {.lex_state = 100, .external_lex_state = 5},
  [42] = {.lex_state = 100, .external_lex_state = 5},
  [43] = {.lex_state = 100, .external_lex_state = 2},
  [44] = {.lex_state = 100, .external_lex_state = 5},
  [45] = {.lex_state = 100, .external_lex_state = 5},
  [46] = {.lex_state = 100, .external_lex_state = 5},
  [47] = {.lex_state = 100, .external_lex_state = 2},
  [48] = {.lex_state = 100, .external_lex_state = 2},
  [49] = {.lex_state = 100, .external_lex_state = 5},
  [50] = {.lex_state = 100, .external_lex_state = 5},
  [51] = {.lex_state = 100, .external_lex_state = 5},
  [52] = {.lex_state = 100, .external_lex_state = 5},
  [53] = {.lex_state = 100, .external_lex_state = 5},
  [54] = {.lex_state = 100, .external_lex_state = 2},
  [55] = {.lex_state = 100, .external_lex_state = 5},
  [56] = {.lex_state = 100, .external_lex_state = 5},
  [57] = {.lex_state = 100, .external_lex_state = 5},
  [58] = {.lex_state = 100, .external_lex_state = 5},
  [59] = {.lex_state = 100, .external_lex_state = 5},
  [60] = {.lex_state = 100, .external_lex_state = 5},
  [61] = {.lex_state = 100, .external_lex_state = 5},
  [62] = {.lex_state = 100, .external_lex_state = 5},
  [63] = {.lex_state = 100, .external_lex_state = 2},
  [64] = {.lex_state = 100, .external_lex_state = 5},
  [65] = {.lex_state = 100, .external_lex_state = 6},
  [66] = {.lex_state = 100, .external_lex_state = 6},
  [67] = {.lex_state = 100, .external_lex_state = 7},
  [68] = {.lex_state = 100, .external_lex_state = 6},
  [69] = {.lex_state = 100, .external_lex_state = 6},
  [70] = {.lex_state = 100, .external_lex_state = 6},
  [71] = {.lex_state = 100, .external_lex_state = 6},
  [72] = {.lex_state = 100, .external_lex_state = 6},
  [73] = {.lex_state = 100, .external_lex_state = 7},
  [74] = {.lex_state = 100, .external_lex_state = 7},
  [75] = {.lex_state = 100, .external_lex_state = 6},
  [76] = {.lex_state = 100, .external_lex_state = 7},
  [77] = {.lex_state = 100, .external_lex_state = 6},
  [78] = {.lex_state = 100, .external_lex_state = 6},
  [79] = {.lex_state = 100, .external_lex_state = 2},
  [80] = {.lex_state = 100, .external_lex_state = 2},
  [81] = {.lex_state = 100, .external_lex_state = 2},
  [82] = {.lex_state = 100, .external_lex_state = 2},
  [83] = {.lex_state = 100, .external_lex_state = 2},
  [84] = {.lex_state = 100, .external_lex_state = 2},
  [85] = {.lex_state = 100, .external_lex_state = 2},
  [86] = {.lex_state = 100, .external_lex_state = 2},
  [87] = {.lex_state = 100, .external_lex_state = 2},
  [88] = {.lex_state = 100, .external_lex_state = 2},
  [89] = {.lex_state = 100, .external_lex_state = 2},
  [90] = {.lex_state = 100, .external_lex_state = 2},
  [91] = {.lex_state = 100, .external_lex_state = 2},
  [92] = {.lex_state = 100, .external_lex_state = 2},
  [93] = {.lex_state = 100, .external_lex_state = 2},
  [94] = {.lex_state = 100, .external_lex_state = 2},
  [95] = {.lex_state = 100, .external_lex_state = 2},
  [96] = {.lex_state = 100, .external_lex_state = 2},
  [97] = {.lex_state = 100, .external_lex_state = 2},
  [98] = {.lex_state = 100, .external_lex_state = 2},
  [99] = {.lex_state = 100, .external_lex_state = 2},
  [100] = {.lex_state = 100, .external_lex_state = 2},
  [101] = {.lex_state = 100, .external_lex_state = 2},
  [102] = {.lex_state = 100, .external_lex_state = 2},
  [103] = {.lex_state = 100, .external_lex_state = 2},
  [104] = {.lex_state = 100, .external_lex_state = 2},
  [105] = {.lex_state = 100, .external_lex_state = 2},
  [106] = {.lex_state = 100, .external_lex_state = 2},
  [107] = {.lex_state = 100, .external_lex_state = 2},
  [108] = {.lex_state = 100, .external_lex_state = 2},
  [109] = {.lex_state = 100, .external_lex_state = 2},
  [110] = {.lex_state = 100, .external_lex_state = 2},
  [111] = {.lex_state = 100, .external_lex_state = 2},
  [112] = {.lex_state = 100, .external_lex_state = 2},
  [113] = {.lex_state = 100, .external_lex_state = 2},
  [114] = {.lex_state = 100, .external_lex_state = 2},
  [115] = {.lex_state = 100, .external_lex_state = 2},
  [116] = {.lex_state = 100, .external_lex_state = 7},
  [117] = {.lex_state = 100, .external_lex_state = 7},
  [118] = {.lex_state = 100, .external_lex_state = 7},
  [119] = {.lex_state = 100, .external_lex_state = 7},
  [120] = {.lex_state = 100, .external_lex_state = 7},
  [121] = {.lex_state = 100, .external_lex_state = 7},
  [122] = {.lex_state = 100, .external_lex_state = 7},
  [123] = {.lex_state = 100, .external_lex_state = 7},
  [124] = {.lex_state = 100, .external_lex_state = 7},
  [125] = {.lex_state = 100, .external_lex_state = 7},
  [126] = {.lex_state = 100, .external_lex_state = 7},
  [127] = {.lex_state = 100, .external_lex_state = 7},
  [128] = {.lex_state = 100, .external_lex_state = 7},
  [129] = {.lex_state = 100, .external_lex_state = 7},
  [130] = {.lex_state = 100, .external_lex_state = 7},
  [131] = {.lex_state = 15, .external_lex_state = 8},
  [132] = {.lex_state = 100, .external_lex_state = 2},
  [133] = {.lex_state = 15, .external_lex_state = 8},
  [134] = {.lex_state = 100, .external_lex_state = 2},
  [135] = {.lex_state = 15, .external_lex_state = 8},
  [136] = {.lex_state = 100, .external_lex_state = 2},
  [137] = {.lex_state = 100, .external_lex_state = 2},
  [138] = {.lex_state = 15, .external_lex_state = 9},
  [139] = {.lex_state = 100, .external_lex_state = 2},
  [140] = {.lex_state = 100, .external_lex_state = 2},
  [141] = {.lex_state = 100, .external_lex_state = 2},
  [142] = {.lex_state = 100, .external_lex_state = 2},
  [143] = {.lex_state = 100, .external_lex_state = 5},
  [144] = {.lex_state = 15, .external_lex_state = 9},
  [145] = {.lex_state = 100, .external_lex_state = 2},
  [146] = {.lex_state = 15, .external_lex_state = 9},
  [147] = {.lex_state = 100, .external_lex_state = 2},
  [148] = {.lex_state = 100, .external_lex_state = 2},
  [149] = {.lex_state = 100, .external_lex_state = 2},
  [150] = {.lex_state = 100, .external_lex_state = 7},
  [151] = {.lex_state = 100, .external_lex_state = 7},
  [152] = {.lex_state = 100, .external_lex_state = 2},
  [153] = {.lex_state = 100, .external_lex_state = 2},
  [154] = {.lex_state = 100, .external_lex_state = 2},
  [155] = {.lex_state = 100, .external_lex_state = 2},
  [156] = {.lex_state = 100, .external_lex_state = 2},
  [157] = {.lex_state = 100, .external_lex_state = 2},
  [158] = {.lex_state = 100, .external_lex_state = 2},
  [159] = {.lex_state = 100, .external_lex_state = 2},
  [160] = {.lex_state = 100, .external_lex_state = 2},
  [161] = {.lex_state = 100, .external_lex_state = 2},
  [162] = {.lex_state = 100, .external_lex_state = 2},
  [163] = {.lex_state = 100, .external_lex_state = 2},
  [164] = {.lex_state = 100, .external_lex_state = 2},
  [165] = {.lex_state = 100, .external_lex_state = 2},
  [166] = {.lex_state = 100, .external_lex_state = 2},
  [167] = {.lex_state = 100, .external_lex_state = 7},
  [168] = {.lex_state = 100, .external_lex_state = 7},
  [169] = {.lex_state = 100, .external_lex_state = 7},
  [170] = {.lex_state = 100, .external_lex_state = 7},
  [171] = {.lex_state = 100, .external_lex_state = 2},
  [172] = {.lex_state = 100, .external_lex_state = 2},
  [173] = {.lex_state = 100, .external_lex_state = 2},
  [174] = {.lex_state = 100, .external_lex_state = 2},
  [175] = {.lex_state = 100, .external_lex_state = 2},
  [176] = {.lex_state = 100, .external_lex_state = 2},
  [177] = {.lex_state = 100, .external_lex_state = 2},
  [178] = {.lex_state = 100, .external_lex_state = 2},
  [179] = {.lex_state = 100, .external_lex_state = 2},
  [180] = {.lex_state = 100, .external_lex_state = 2},
  [181] = {.lex_state = 100, .external_lex_state = 2},
  [182] = {.lex_state = 100, .external_lex_state = 2},
  [183] = {.lex_state = 100, .external_lex_state = 2},
  [184] = {.lex_state = 100, .external_lex_state = 2},
  [185] = {.lex_state = 100, .external_lex_state = 2},
  [186] = {.lex_state = 100, .external_lex_state = 2},
  [187] = {.lex_state = 100, .external_lex_state = 2},
  [188] = {.lex_state = 100, .external_lex_state = 2},
  [189] = {.lex_state = 100, .external_lex_state = 2},
  [190] = {.lex_state = 100, .external_lex_state = 2},
  [191] = {.lex_state = 100, .external_lex_state = 2},
  [192] = {.lex_state = 100, .external_lex_state = 2},
  [193] = {.lex_state = 100, .external_lex_state = 2},
  [194] = {.lex_state = 100, .external_lex_state = 2},
  [195] = {.lex_state = 100, .external_lex_state = 2},
  [196] = {.lex_state = 100, .external_lex_state = 7},
  [197] = {.lex_state = 100, .external_lex_state = 7},
  [198] = {.lex_state = 100, .external_lex_state = 7},
  [199] = {.lex_state = 100, .external_lex_state = 7},
  [200] = {.lex_state = 100, .external_lex_state = 7},
  [201] = {.lex_state = 100, .external_lex_state = 7},
  [202] = {.lex_state = 100, .external_lex_state = 7},
  [203] = {.lex_state = 100, .external_lex_state = 7},
  [204] = {.lex_state = 100, .external_lex_state = 7},
  [205] = {.lex_state = 100, .external_lex_state = 7},
  [206] = {.lex_state = 100, .external_lex_state = 2},
  [207] = {.lex_state = 100, .external_lex_state = 2},
  [208] = {.lex_state = 100, .external_lex_state = 2},
  [209] = {.lex_state = 100, .external_lex_state = 2},
  [210] = {.lex_state = 100, .external_lex_state = 2},
  [211] = {.lex_state = 100, .external_lex_state = 2},
  [212] = {.lex_state = 100, .external_lex_state = 2},
  [213] = {.lex_state = 100, .external_lex_state = 2},
  [214] = {.lex_state = 100, .external_lex_state = 2},
  [215] = {.lex_state = 100, .external_lex_state = 7},
  [216] = {.lex_state = 100, .external_lex_state = 7},
  [217] = {.lex_state = 100, .external_lex_state = 7},
  [218] = {.lex_state = 16, .external_lex_state = 10},
  [219] = {.lex_state = 16, .external_lex_state = 10},
  [220] = {.lex_state = 16, .external_lex_state = 10},
  [221] = {.lex_state = 16, .external_lex_state = 10},
  [222] = {.lex_state = 16, .external_lex_state = 10},
  [223] = {.lex_state = 16, .external_lex_state = 10},
  [224] = {.lex_state = 17, .external_lex_state = 11},
  [225] = {.lex_state = 94, .external_lex_state = 3},
  [226] = {.lex_state = 17, .external_lex_state = 11},
  [227] = {.lex_state = 17, .external_lex_state = 11},
  [228] = {.lex_state = 94, .external_lex_state = 3},
  [229] = {.lex_state = 16, .external_lex_state = 12},
  [230] = {.lex_state = 17, .external_lex_state = 11},
  [231] = {.lex_state = 17, .external_lex_state = 11},
  [232] = {.lex_state = 17, .external_lex_state = 11},
  [233] = {.lex_state = 17, .external_lex_state = 11},
  [234] = {.lex_state = 17, .external_lex_state = 11},
  [235] = {.lex_state = 17, .external_lex_state = 11},
  [236] = {.lex_state = 17, .external_lex_state = 11},
  [237] = {.lex_state = 17, .external_lex_state = 11},
  [238] = {.lex_state = 16, .external_lex_state = 12},
  [239] = {.lex_state = 17, .external_lex_state = 11},
  [240] = {.lex_state = 17, .external_lex_state = 11},
  [241] = {.lex_state = 17, .external_lex_state = 11},
  [242] = {.lex_state = 17, .external_lex_state = 11},
  [243] = {.lex_state = 17, .external_lex_state = 11},
  [244] = {.lex_state = 17, .external_lex_state = 11},
  [245] = {.lex_state = 17, .external_lex_state = 11},
  [246] = {.lex_state = 17, .external_lex_state = 11},
  [247] = {.lex_state = 17, .external_lex_state = 11},
  [248] = {.lex_state = 17, .external_lex_state = 11},
  [249] = {.lex_state = 17, .external_lex_state = 11},
  [250] = {.lex_state = 17, .external_lex_state = 11},
  [251] = {.lex_state = 17, .external_lex_state = 13},
  [252] = {.lex_state = 16, .external_lex_state = 14},
  [253] = {.lex_state = 17, .external_lex_state = 13},
  [254] = {.lex_state = 94, .external_lex_state = 3},
  [255] = {.lex_state = 17, .external_lex_state = 13},
  [256] = {.lex_state = 94, .external_lex_state = 3},
  [257] = {.lex_state = 94, .external_lex_state = 3},
  [258] = {.lex_state = 94, .external_lex_state = 3},
  [259] = {.lex_state = 94, .external_lex_state = 3},
  [260] = {.lex_state = 17, .external_lex_state = 13},
  [261] = {.lex_state = 17, .external_lex_state = 13},
  [262] = {.lex_state = 94, .external_lex_state = 3},
  [263] = {.lex_state = 94, .external_lex_state = 3},
  [264] = {.lex_state = 17, .external_lex_state = 13},
  [265] = {.lex_state = 17, .external_lex_state = 13},
  [266] = {.lex_state = 17, .external_lex_state = 13},
  [267] = {.lex_state = 16, .external_lex_state = 2},
  [268] = {.lex_state = 16, .external_lex_state = 2},
  [269] = {.lex_state = 95, .external_lex_state = 3},
  [270] = {.lex_state = 95, .external_lex_state = 3},
  [271] = {.lex_state = 95, .external_lex_state = 3},
  [272] = {.lex_state = 16, .external_lex_state = 2},
  [273] = {.lex_state = 17, .external_lex_state = 11},
  [274] = {.lex_state = 95, .external_lex_state = 3},
  [275] = {.lex_state = 16, .external_lex_state = 2},
  [276] = {.lex_state = 16, .external_lex_state = 2},
  [277] = {.lex_state = 95, .external_lex_state = 3},
  [278] = {.lex_state = 16, .external_lex_state = 2},
  [279] = {.lex_state = 16, .external_lex_state = 2},
  [280] = {.lex_state = 16, .external_lex_state = 2},
  [281] = {.lex_state = 16, .external_lex_state = 2},
  [282] = {.lex_state = 95, .external_lex_state = 3},
  [283] = {.lex_state = 16, .external_lex_state = 2},
  [284] = {.lex_state = 17, .external_lex_state = 11},
  [285] = {.lex_state = 16, .external_lex_state = 2},
  [286] = {.lex_state = 16, .external_lex_state = 2},
  [287] = {.lex_state = 16, .external_lex_state = 2},
  [288] = {.lex_state = 16, .external_lex_state = 2},
  [289] = {.lex_state = 16, .external_lex_state = 2},
  [290] = {.lex_state = 16, .external_lex_state = 2},
  [291] = {.lex_state = 16, .external_lex_state = 2},
  [292] = {.lex_state = 17, .external_lex_state = 11},
  [293] = {.lex_state = 16, .external_lex_state = 2},
  [294] = {.lex_state = 95, .external_lex_state = 3},
  [295] = {.lex_state = 16, .external_lex_state = 7},
  [296] = {.lex_state = 16, .external_lex_state = 7},
  [297] = {.lex_state = 17, .external_lex_state = 13},
  [298] = {.lex_state = 16, .external_lex_state = 7},
  [299] = {.lex_state = 16, .external_lex_state = 7},
  [300] = {.lex_state = 17, .external_lex_state = 13},
  [301] = {.lex_state = 16, .external_lex_state = 7},
  [302] = {.lex_state = 16, .external_lex_state = 7},
  [303] = {.lex_state = 16, .external_lex_state = 7},
  [304] = {.lex_state = 16, .external_lex_state = 7},
  [305] = {.lex_state = 17, .external_lex_state = 8},
  [306] = {.lex_state = 17, .external_lex_state = 8},
  [307] = {.lex_state = 17, .external_lex_state = 8},
  [308] = {.lex_state = 17, .external_lex_state = 8},
  [309] = {.lex_state = 17, .external_lex_state = 8},
  [310] = {.lex_state = 17, .external_lex_state = 8},
  [311] = {.lex_state = 94, .external_lex_state = 3},
  [312] = {.lex_state = 94, .external_lex_state = 3},
  [313] = {.lex_state = 17, .external_lex_state = 8},
  [314] = {.lex_state = 17, .external_lex_state = 8},
  [315] = {.lex_state = 17, .external_lex_state = 8},
  [316] = {.lex_state = 17, .external_lex_state = 9},
  [317] = {.lex_state = 94, .external_lex_state = 3},
  [318] = {.lex_state = 94, .external_lex_state = 3},
  [319] = {.lex_state = 94, .external_lex_state = 3},
  [320] = {.lex_state = 94, .external_lex_state = 3},
  [321] = {.lex_state = 17, .external_lex_state = 8},
  [322] = {.lex_state = 94, .external_lex_state = 3},
  [323] = {.lex_state = 94, .external_lex_state = 3},
  [324] = {.lex_state = 94, .external_lex_state = 3},
  [325] = {.lex_state = 17, .external_lex_state = 9},
  [326] = {.lex_state = 94, .external_lex_state = 3},
  [327] = {.lex_state = 17, .external_lex_state = 9},
  [328] = {.lex_state = 16, .external_lex_state = 10},
  [329] = {.lex_state = 16, .external_lex_state = 10},
  [330] = {.lex_state = 16, .external_lex_state = 10},
  [331] = {.lex_state = 16, .external_lex_state = 10},
  [332] = {.lex_state = 16, .external_lex_state = 5},
  [333] = {.lex_state = 16, .external_lex_state = 2},
  [334] = {.lex_state = 16, .external_lex_state = 10},
  [335] = {.lex_state = 16, .external_lex_state = 10},
  [336] = {.lex_state = 95, .external_lex_state = 3},
  [337] = {.lex_state = 16, .external_lex_state = 10},
  [338] = {.lex_state = 95, .external_lex_state = 3},
  [339] = {.lex_state = 16, .external_lex_state = 5},
  [340] = {.lex_state = 95, .external_lex_state = 3},
  [341] = {.lex_state = 16, .external_lex_state = 10},
  [342] = {.lex_state = 16, .external_lex_state = 10},
  [343] = {.lex_state = 95, .external_lex_state = 3},
  [344] = {.lex_state = 16, .external_lex_state = 10},
  [345] = {.lex_state = 16, .external_lex_state = 5},
  [346] = {.lex_state = 16, .external_lex_state = 10},
  [347] = {.lex_state = 16, .external_lex_state = 10},
  [348] = {.lex_state = 16, .external_lex_state = 10},
  [349] = {.lex_state = 16, .external_lex_state = 10},
  [350] = {.lex_state = 16, .external_lex_state = 10},
  [351] = {.lex_state = 95, .external_lex_state = 3},
  [352] = {.lex_state = 16, .external_lex_state = 10},
  [353] = {.lex_state = 16, .external_lex_state = 10},
  [354] = {.lex_state = 16, .external_lex_state = 5},
  [355] = {.lex_state = 16, .external_lex_state = 10},
  [356] = {.lex_state = 16, .external_lex_state = 10},
  [357] = {.lex_state = 16, .external_lex_state = 10},
  [358] = {.lex_state = 95, .external_lex_state = 3},
  [359] = {.lex_state = 95, .external_lex_state = 3},
  [360] = {.lex_state = 16, .external_lex_state = 10},
  [361] = {.lex_state = 16, .external_lex_state = 12},
  [362] = {.lex_state = 16, .external_lex_state = 12},
  [363] = {.lex_state = 16, .external_lex_state = 6},
  [364] = {.lex_state = 16, .external_lex_state = 12},
  [365] = {.lex_state = 16, .external_lex_state = 10},
  [366] = {.lex_state = 16, .external_lex_state = 10},
  [367] = {.lex_state = 16, .external_lex_state = 12},
  [368] = {.lex_state = 16, .external_lex_state = 2},
  [369] = {.lex_state = 16, .external_lex_state = 10},
  [370] = {.lex_state = 16, .external_lex_state = 10},
  [371] = {.lex_state = 16, .external_lex_state = 10},
  [372] = {.lex_state = 16, .external_lex_state = 10},
  [373] = {.lex_state = 16, .external_lex_state = 10},
  [374] = {.lex_state = 16, .external_lex_state = 12},
  [375] = {.lex_state = 16, .external_lex_state = 10},
  [376] = {.lex_state = 16, .external_lex_state = 10},
  [377] = {.lex_state = 16, .external_lex_state = 10},
  [378] = {.lex_state = 16, .external_lex_state = 2},
  [379] = {.lex_state = 16, .external_lex_state = 10},
  [380] = {.lex_state = 16, .external_lex_state = 12},
  [381] = {.lex_state = 94, .external_lex_state = 4},
  [382] = {.lex_state = 94, .external_lex_state = 4},
  [383] = {.lex_state = 16, .external_lex_state = 12},
  [384] = {.lex_state = 16, .external_lex_state = 12},
  [385] = {.lex_state = 16, .external_lex_state = 12},
  [386] = {.lex_state = 16, .external_lex_state = 2},
  [387] = {.lex_state = 16, .external_lex_state = 2},
  [388] = {.lex_state = 16, .external_lex_state = 2},
  [389] = {.lex_state = 16, .external_lex_state = 2},
  [390] = {.lex_state = 16, .external_lex_state = 2},
  [391] = {.lex_state = 16, .external_lex_state = 2},
  [392] = {.lex_state = 16, .external_lex_state = 2},
  [393] = {.lex_state = 16, .external_lex_state = 2},
  [394] = {.lex_state = 16, .external_lex_state = 2},
  [395] = {.lex_state = 16, .external_lex_state = 2},
  [396] = {.lex_state = 16, .external_lex_state = 2},
  [397] = {.lex_state = 16, .external_lex_state = 2},
  [398] = {.lex_state = 16, .external_lex_state = 2},
  [399] = {.lex_state = 16, .external_lex_state = 2},
  [400] = {.lex_state = 16, .external_lex_state = 2},
  [401] = {.lex_state = 16, .external_lex_state = 2},
  [402] = {.lex_state = 16, .external_lex_state = 2},
  [403] = {.lex_state = 16, .external_lex_state = 2},
  [404] = {.lex_state = 16, .external_lex_state = 2},
  [405] = {.lex_state = 16, .external_lex_state = 2},
  [406] = {.lex_state = 16, .external_lex_state = 2},
  [407] = {.lex_state = 16, .external_lex_state = 2},
  [408] = {.lex_state = 16, .external_lex_state = 2},
  [409] = {.lex_state = 16, .external_lex_state = 2},
  [410] = {.lex_state = 16, .external_lex_state = 2},
  [411] = {.lex_state = 16, .external_lex_state = 2},
  [412] = {.lex_state = 16, .external_lex_state = 2},
  [413] = {.lex_state = 16, .external_lex_state = 2},
  [414] = {.lex_state = 16, .external_lex_state = 2},
  [415] = {.lex_state = 16, .external_lex_state = 2},
  [416] = {.lex_state = 16, .external_lex_state = 2},
  [417] = {.lex_state = 16, .external_lex_state = 2},
  [418] = {.lex_state = 16, .external_lex_state = 2},
  [419] = {.lex_state = 16, .external_lex_state = 2},
  [420] = {.lex_state = 16, .external_lex_state = 2},
  [421] = {.lex_state = 16, .external_lex_state = 2},
  [422] = {.lex_state = 16, .external_lex_state = 2},
  [423] = {.lex_state = 16, .external_lex_state = 2},
  [424] = {.lex_state = 16, .external_lex_state = 2},
  [425] = {.lex_state = 16, .external_lex_state = 2},
  [426] = {.lex_state = 16, .external_lex_state = 2},
  [427] = {.lex_state = 16, .external_lex_state = 2},
  [428] = {.lex_state = 16, .external_lex_state = 2},
  [429] = {.lex_state = 16, .external_lex_state = 2},
  [430] = {.lex_state = 16, .external_lex_state = 2},
  [431] = {.lex_state = 16, .external_lex_state = 2},
  [432] = {.lex_state = 16, .external_lex_state = 2},
  [433] = {.lex_state = 16, .external_lex_state = 2},
  [434] = {.lex_state = 16, .external_lex_state = 2},
  [435] = {.lex_state = 16, .external_lex_state = 2},
  [436] = {.lex_state = 16, .external_lex_state = 2},
  [437] = {.lex_state = 16, .external_lex_state = 2},
  [438] = {.lex_state = 16, .external_lex_state = 2},
  [439] = {.lex_state = 16, .external_lex_state = 2},
  [440] = {.lex_state = 16, .external_lex_state = 2},
  [441] = {.lex_state = 16, .external_lex_state = 2},
  [442] = {.lex_state = 16, .external_lex_state = 2},
  [443] = {.lex_state = 16, .external_lex_state = 2},
  [444] = {.lex_state = 16, .external_lex_state = 2},
  [445] = {.lex_state = 16, .external_lex_state = 2},
  [446] = {.lex_state = 16, .external_lex_state = 2},
  [447] = {.lex_state = 16, .external_lex_state = 2},
  [448] = {.lex_state = 16, .external_lex_state = 2},
  [449] = {.lex_state = 16, .external_lex_state = 2},
  [450] = {.lex_state = 16, .external_lex_state = 2},
  [451] = {.lex_state = 16, .external_lex_state = 2},
  [452] = {.lex_state = 16, .external_lex_state = 2},
  [453] = {.lex_state = 16, .external_lex_state = 2},
  [454] = {.lex_state = 16, .external_lex_state = 2},
  [455] = {.lex_state = 16, .external_lex_state = 2},
  [456] = {.lex_state = 16, .external_lex_state = 2},
  [457] = {.lex_state = 16, .external_lex_state = 2},
  [458] = {.lex_state = 16, .external_lex_state = 2},
  [459] = {.lex_state = 16, .external_lex_state = 2},
  [460] = {.lex_state = 16, .external_lex_state = 2},
  [461] = {.lex_state = 16, .external_lex_state = 2},
  [462] = {.lex_state = 16, .external_lex_state = 2},
  [463] = {.lex_state = 16, .external_lex_state = 2},
  [464] = {.lex_state = 16, .external_lex_state = 2},
  [465] = {.lex_state = 16, .external_lex_state = 2},
  [466] = {.lex_state = 16, .external_lex_state = 2},
  [467] = {.lex_state = 16, .external_lex_state = 2},
  [468] = {.lex_state = 16, .external_lex_state = 2},
  [469] = {.lex_state = 16, .external_lex_state = 2},
  [470] = {.lex_state = 16, .external_lex_state = 2},
  [471] = {.lex_state = 16, .external_lex_state = 2},
  [472] = {.lex_state = 16, .external_lex_state = 2},
  [473] = {.lex_state = 16, .external_lex_state = 2},
  [474] = {.lex_state = 16, .external_lex_state = 2},
  [475] = {.lex_state = 16, .external_lex_state = 2},
  [476] = {.lex_state = 16, .external_lex_state = 2},
  [477] = {.lex_state = 16, .external_lex_state = 2},
  [478] = {.lex_state = 16, .external_lex_state = 2},
  [479] = {.lex_state = 16, .external_lex_state = 2},
  [480] = {.lex_state = 16, .external_lex_state = 2},
  [481] = {.lex_state = 16, .external_lex_state = 2},
  [482] = {.lex_state = 16, .external_lex_state = 2},
  [483] = {.lex_state = 16, .external_lex_state = 2},
  [484] = {.lex_state = 16, .external_lex_state = 2},
  [485] = {.lex_state = 16, .external_lex_state = 2},
  [486] = {.lex_state = 16, .external_lex_state = 2},
  [487] = {.lex_state = 16, .external_lex_state = 2},
  [488] = {.lex_state = 16, .external_lex_state = 2},
  [489] = {.lex_state = 16, .external_lex_state = 2},
  [490] = {.lex_state = 16, .external_lex_state = 2},
  [491] = {.lex_state = 16, .external_lex_state = 2},
  [492] = {.lex_state = 16, .external_lex_state = 2},
  [493] = {.lex_state = 16, .external_lex_state = 2},
  [494] = {.lex_state = 16, .external_lex_state = 2},
  [495] = {.lex_state = 16, .external_lex_state = 2},
  [496] = {.lex_state = 16, .external_lex_state = 2},
  [497] = {.lex_state = 16, .external_lex_state = 2},
  [498] = {.lex_state = 16, .external_lex_state = 2},
  [499] = {.lex_state = 16, .external_lex_state = 2},
  [500] = {.lex_state = 16, .external_lex_state = 2},
  [501] = {.lex_state = 16, .external_lex_state = 2},
  [502] = {.lex_state = 16, .external_lex_state = 2},
  [503] = {.lex_state = 16, .external_lex_state = 2},
  [504] = {.lex_state = 16, .external_lex_state = 2},
  [505] = {.lex_state = 16, .external_lex_state = 2},
  [506] = {.lex_state = 16, .external_lex_state = 2},
  [507] = {.lex_state = 16, .external_lex_state = 2},
  [508] = {.lex_state = 16, .external_lex_state = 2},
  [509] = {.lex_state = 16, .external_lex_state = 2},
  [510] = {.lex_state = 16, .external_lex_state = 2},
  [511] = {.lex_state = 16, .external_lex_state = 2},
  [512] = {.lex_state = 16, .external_lex_state = 2},
  [513] = {.lex_state = 16, .external_lex_state = 2},
  [514] = {.lex_state = 16, .external_lex_state = 2},
  [515] = {.lex_state = 16, .external_lex_state = 2},
  [516] = {.lex_state = 16, .external_lex_state = 2},
  [517] = {.lex_state = 16, .external_lex_state = 2},
  [518] = {.lex_state = 16, .external_lex_state = 2},
  [519] = {.lex_state = 16, .external_lex_state = 2},
  [520] = {.lex_state = 16, .external_lex_state = 2},
  [521] = {.lex_state = 16, .external_lex_state = 2},
  [522] = {.lex_state = 16, .external_lex_state = 2},
  [523] = {.lex_state = 16, .external_lex_state = 2},
  [524] = {.lex_state = 16, .external_lex_state = 2},
  [525] = {.lex_state = 16, .external_lex_state = 2},
  [526] = {.lex_state = 16, .external_lex_state = 2},
  [527] = {.lex_state = 16, .external_lex_state = 2},
  [528] = {.lex_state = 16, .external_lex_state = 2},
  [529] = {.lex_state = 16, .external_lex_state = 2},
  [530] = {.lex_state = 16, .external_lex_state = 2},
  [531] = {.lex_state = 16, .external_lex_state = 2},
  [532] = {.lex_state = 16, .external_lex_state = 2},
  [533] = {.lex_state = 16, .external_lex_state = 2},
  [534] = {.lex_state = 16, .external_lex_state = 2},
  [535] = {.lex_state = 16, .external_lex_state = 2},
  [536] = {.lex_state = 16, .external_lex_state = 2},
  [537] = {.lex_state = 16, .external_lex_state = 2},
  [538] = {.lex_state = 16, .external_lex_state = 2},
  [539] = {.lex_state = 16, .external_lex_state = 2},
  [540] = {.lex_state = 16, .external_lex_state = 2},
  [541] = {.lex_state = 16, .external_lex_state = 2},
  [542] = {.lex_state = 16, .external_lex_state = 2},
  [543] = {.lex_state = 16, .external_lex_state = 2},
  [544] = {.lex_state = 16, .external_lex_state = 2},
  [545] = {.lex_state = 16, .external_lex_state = 2},
  [546] = {.lex_state = 16, .external_lex_state = 2},
  [547] = {.lex_state = 16, .external_lex_state = 2},
  [548] = {.lex_state = 16, .external_lex_state = 2},
  [549] = {.lex_state = 16, .external_lex_state = 2},
  [550] = {.lex_state = 16, .external_lex_state = 2},
  [551] = {.lex_state = 16, .external_lex_state = 2},
  [552] = {.lex_state = 16, .external_lex_state = 2},
  [553] = {.lex_state = 16, .external_lex_state = 2},
  [554] = {.lex_state = 16, .external_lex_state = 2},
  [555] = {.lex_state = 16, .external_lex_state = 2},
  [556] = {.lex_state = 16, .external_lex_state = 2},
  [557] = {.lex_state = 16, .external_lex_state = 2},
  [558] = {.lex_state = 16, .external_lex_state = 2},
  [559] = {.lex_state = 16, .external_lex_state = 2},
  [560] = {.lex_state = 16, .external_lex_state = 2},
  [561] = {.lex_state = 16, .external_lex_state = 2},
  [562] = {.lex_state = 16, .external_lex_state = 2},
  [563] = {.lex_state = 16, .external_lex_state = 2},
  [564] = {.lex_state = 16, .external_lex_state = 2},
  [565] = {.lex_state = 16, .external_lex_state = 2},
  [566] = {.lex_state = 16, .external_lex_state = 2},
  [567] = {.lex_state = 16, .external_lex_state = 2},
  [568] = {.lex_state = 16, .external_lex_state = 2},
  [569] = {.lex_state = 16, .external_lex_state = 2},
  [570] = {.lex_state = 16, .external_lex_state = 2},
  [571] = {.lex_state = 16, .external_lex_state = 2},
  [572] = {.lex_state = 16, .external_lex_state = 2},
  [573] = {.lex_state = 16, .external_lex_state = 2},
  [574] = {.lex_state = 16, .external_lex_state = 2},
  [575] = {.lex_state = 16, .external_lex_state = 2},
  [576] = {.lex_state = 16, .external_lex_state = 2},
  [577] = {.lex_state = 16, .external_lex_state = 2},
  [578] = {.lex_state = 16, .external_lex_state = 2},
  [579] = {.lex_state = 16, .external_lex_state = 2},
  [580] = {.lex_state = 16, .external_lex_state = 2},
  [581] = {.lex_state = 16, .external_lex_state = 2},
  [582] = {.lex_state = 16, .external_lex_state = 2},
  [583] = {.lex_state = 16, .external_lex_state = 2},
  [584] = {.lex_state = 16, .external_lex_state = 2},
  [585] = {.lex_state = 16, .external_lex_state = 2},
  [586] = {.lex_state = 16, .external_lex_state = 2},
  [587] = {.lex_state = 16, .external_lex_state = 2},
  [588] = {.lex_state = 16, .external_lex_state = 2},
  [589] = {.lex_state = 16, .external_lex_state = 2},
  [590] = {.lex_state = 16, .external_lex_state = 2},
  [591] = {.lex_state = 16, .external_lex_state = 2},
  [592] = {.lex_state = 16, .external_lex_state = 2},
  [593] = {.lex_state = 16, .external_lex_state = 2},
  [594] = {.lex_state = 16, .external_lex_state = 2},
  [595] = {.lex_state = 16, .external_lex_state = 2},
  [596] = {.lex_state = 16, .external_lex_state = 2},
  [597] = {.lex_state = 16, .external_lex_state = 2},
  [598] = {.lex_state = 16, .external_lex_state = 2},
  [599] = {.lex_state = 16, .external_lex_state = 2},
  [600] = {.lex_state = 16, .external_lex_state = 2},
  [601] = {.lex_state = 16, .external_lex_state = 2},
  [602] = {.lex_state = 16, .external_lex_state = 2},
  [603] = {.lex_state = 16, .external_lex_state = 2},
  [604] = {.lex_state = 16, .external_lex_state = 2},
  [605] = {.lex_state = 16, .external_lex_state = 2},
  [606] = {.lex_state = 16, .external_lex_state = 2},
  [607] = {.lex_state = 16, .external_lex_state = 2},
  [608] = {.lex_state = 16, .external_lex_state = 2},
  [609] = {.lex_state = 16, .external_lex_state = 2},
  [610] = {.lex_state = 16, .external_lex_state = 2},
  [611] = {.lex_state = 16, .external_lex_state = 2},
  [612] = {.lex_state = 16, .external_lex_state = 2},
  [613] = {.lex_state = 16, .external_lex_state = 2},
  [614] = {.lex_state = 16, .external_lex_state = 2},
  [615] = {.lex_state = 16, .external_lex_state = 2},
  [616] = {.lex_state = 16, .external_lex_state = 2},
  [617] = {.lex_state = 16, .external_lex_state = 2},
  [618] = {.lex_state = 16, .external_lex_state = 2},
  [619] = {.lex_state = 16, .external_lex_state = 2},
  [620] = {.lex_state = 16, .external_lex_state = 2},
  [621] = {.lex_state = 16, .external_lex_state = 2},
  [622] = {.lex_state = 16, .external_lex_state = 2},
  [623] = {.lex_state = 16, .external_lex_state = 2},
  [624] = {.lex_state = 16, .external_lex_state = 2},
  [625] = {.lex_state = 16, .external_lex_state = 2},
  [626] = {.lex_state = 16, .external_lex_state = 2},
  [627] = {.lex_state = 16, .external_lex_state = 2},
  [628] = {.lex_state = 16, .external_lex_state = 2},
  [629] = {.lex_state = 16, .external_lex_state = 2},
  [630] = {.lex_state = 16, .external_lex_state = 2},
  [631] = {.lex_state = 16, .external_lex_state = 2},
  [632] = {.lex_state = 16, .external_lex_state = 2},
  [633] = {.lex_state = 16, .external_lex_state = 2},
  [634] = {.lex_state = 16, .external_lex_state = 2},
  [635] = {.lex_state = 16, .external_lex_state = 2},
  [636] = {.lex_state = 16, .external_lex_state = 2},
  [637] = {.lex_state = 16, .external_lex_state = 2},
  [638] = {.lex_state = 16, .external_lex_state = 2},
  [639] = {.lex_state = 16, .external_lex_state = 2},
  [640] = {.lex_state = 16, .external_lex_state = 2},
  [641] = {.lex_state = 16, .external_lex_state = 2},
  [642] = {.lex_state = 16, .external_lex_state = 2},
  [643] = {.lex_state = 16, .external_lex_state = 2},
  [644] = {.lex_state = 16, .external_lex_state = 2},
  [645] = {.lex_state = 16, .external_lex_state = 2},
  [646] = {.lex_state = 16, .external_lex_state = 2},
  [647] = {.lex_state = 16, .external_lex_state = 2},
  [648] = {.lex_state = 16, .external_lex_state = 2},
  [649] = {.lex_state = 16, .external_lex_state = 2},
  [650] = {.lex_state = 16, .external_lex_state = 2},
  [651] = {.lex_state = 16, .external_lex_state = 2},
  [652] = {.lex_state = 16, .external_lex_state = 2},
  [653] = {.lex_state = 16, .external_lex_state = 2},
  [654] = {.lex_state = 16, .external_lex_state = 2},
  [655] = {.lex_state = 16, .external_lex_state = 2},
  [656] = {.lex_state = 16, .external_lex_state = 2},
  [657] = {.lex_state = 16, .external_lex_state = 2},
  [658] = {.lex_state = 16, .external_lex_state = 2},
  [659] = {.lex_state = 94, .external_lex_state = 4},
  [660] = {.lex_state = 16, .external_lex_state = 2},
  [661] = {.lex_state = 16, .external_lex_state = 2},
  [662] = {.lex_state = 16, .external_lex_state = 2},
  [663] = {.lex_state = 16, .external_lex_state = 2},
  [664] = {.lex_state = 16, .external_lex_state = 2},
  [665] = {.lex_state = 16, .external_lex_state = 2},
  [666] = {.lex_state = 16, .external_lex_state = 2},
  [667] = {.lex_state = 16, .external_lex_state = 2},
  [668] = {.lex_state = 94, .external_lex_state = 4},
  [669] = {.lex_state = 16, .external_lex_state = 2},
  [670] = {.lex_state = 16, .external_lex_state = 2},
  [671] = {.lex_state = 16, .external_lex_state = 2},
  [672] = {.lex_state = 16, .external_lex_state = 2},
  [673] = {.lex_state = 16, .external_lex_state = 2},
  [674] = {.lex_state = 16, .external_lex_state = 2},
  [675] = {.lex_state = 16, .external_lex_state = 2},
  [676] = {.lex_state = 16, .external_lex_state = 2},
  [677] = {.lex_state = 16, .external_lex_state = 2},
  [678] = {.lex_state = 16, .external_lex_state = 2},
  [679] = {.lex_state = 16, .external_lex_state = 2},
  [680] = {.lex_state = 16, .external_lex_state = 2},
  [681] = {.lex_state = 16, .external_lex_state = 2},
  [682] = {.lex_state = 16, .external_lex_state = 2},
  [683] = {.lex_state = 16, .external_lex_state = 2},
  [684] = {.lex_state = 16, .external_lex_state = 2},
  [685] = {.lex_state = 16, .external_lex_state = 2},
  [686] = {.lex_state = 16, .external_lex_state = 2},
  [687] = {.lex_state = 16, .external_lex_state = 2},
  [688] = {.lex_state = 16, .external_lex_state = 2},
  [689] = {.lex_state = 16, .external_lex_state = 2},
  [690] = {.lex_state = 16, .external_lex_state = 2},
  [691] = {.lex_state = 16, .external_lex_state = 2},
  [692] = {.lex_state = 16, .external_lex_state = 2},
  [693] = {.lex_state = 16, .external_lex_state = 2},
  [694] = {.lex_state = 16, .external_lex_state = 2},
  [695] = {.lex_state = 16, .external_lex_state = 2},
  [696] = {.lex_state = 16, .external_lex_state = 2},
  [697] = {.lex_state = 16, .external_lex_state = 2},
  [698] = {.lex_state = 16, .external_lex_state = 2},
  [699] = {.lex_state = 16, .external_lex_state = 2},
  [700] = {.lex_state = 16, .external_lex_state = 2},
  [701] = {.lex_state = 16, .external_lex_state = 2},
  [702] = {.lex_state = 16, .external_lex_state = 2},
  [703] = {.lex_state = 16, .external_lex_state = 2},
  [704] = {.lex_state = 94, .external_lex_state = 4},
  [705] = {.lex_state = 16, .external_lex_state = 2},
  [706] = {.lex_state = 16, .external_lex_state = 2},
  [707] = {.lex_state = 16, .external_lex_state = 2},
  [708] = {.lex_state = 16, .external_lex_state = 2},
  [709] = {.lex_state = 94, .external_lex_state = 4},
  [710] = {.lex_state = 16, .external_lex_state = 2},
  [711] = {.lex_state = 16, .external_lex_state = 2},
  [712] = {.lex_state = 16, .external_lex_state = 2},
  [713] = {.lex_state = 16, .external_lex_state = 2},
  [714] = {.lex_state = 16, .external_lex_state = 2},
  [715] = {.lex_state = 16, .external_lex_state = 2},
  [716] = {.lex_state = 16, .external_lex_state = 2},
  [717] = {.lex_state = 16, .external_lex_state = 2},
  [718] = {.lex_state = 16, .external_lex_state = 2},
  [719] = {.lex_state = 16, .external_lex_state = 2},
  [720] = {.lex_state = 16, .external_lex_state = 2},
  [721] = {.lex_state = 16, .external_lex_state = 2},
  [722] = {.lex_state = 16, .external_lex_state = 2},
  [723] = {.lex_state = 16, .external_lex_state = 2},
  [724] = {.lex_state = 16, .external_lex_state = 2},
  [725] = {.lex_state = 16, .external_lex_state = 2},
  [726] = {.lex_state = 16, .external_lex_state = 2},
  [727] = {.lex_state = 94, .external_lex_state = 4},
  [728] = {.lex_state = 16, .external_lex_state = 2},
  [729] = {.lex_state = 16, .external_lex_state = 2},
  [730] = {.lex_state = 16, .external_lex_state = 2},
  [731] = {.lex_state = 16, .external_lex_state = 2},
  [732] = {.lex_state = 16, .external_lex_state = 2},
  [733] = {.lex_state = 16, .external_lex_state = 2},
  [734] = {.lex_state = 16, .external_lex_state = 2},
  [735] = {.lex_state = 16, .external_lex_state = 2},
  [736] = {.lex_state = 94, .external_lex_state = 4},
  [737] = {.lex_state = 16, .external_lex_state = 2},
  [738] = {.lex_state = 16, .external_lex_state = 2},
  [739] = {.lex_state = 16, .external_lex_state = 2},
  [740] = {.lex_state = 16, .external_lex_state = 2},
  [741] = {.lex_state = 16, .external_lex_state = 2},
  [742] = {.lex_state = 16, .external_lex_state = 2},
  [743] = {.lex_state = 16, .external_lex_state = 2},
  [744] = {.lex_state = 16, .external_lex_state = 2},
  [745] = {.lex_state = 16, .external_lex_state = 2},
  [746] = {.lex_state = 16, .external_lex_state = 2},
  [747] = {.lex_state = 16, .external_lex_state = 2},
  [748] = {.lex_state = 16, .external_lex_state = 2},
  [749] = {.lex_state = 16, .external_lex_state = 2},
  [750] = {.lex_state = 16, .external_lex_state = 2},
  [751] = {.lex_state = 16, .external_lex_state = 2},
  [752] = {.lex_state = 16, .external_lex_state = 7},
  [753] = {.lex_state = 16, .external_lex_state = 7},
  [754] = {.lex_state = 16, .external_lex_state = 7},
  [755] = {.lex_state = 16, .external_lex_state = 7},
  [756] = {.lex_state = 16, .external_lex_state = 7},
  [757] = {.lex_state = 16, .external_lex_state = 7},
  [758] = {.lex_state = 16, .external_lex_state = 7},
  [759] = {.lex_state = 16, .external_lex_state = 7},
  [760] = {.lex_state = 16, .external_lex_state = 7},
  [761] = {.lex_state = 95, .external_lex_state = 4},
  [762] = {.lex_state = 16, .external_lex_state = 7},
  [763] = {.lex_state = 16, .external_lex_state = 7},
  [764] = {.lex_state = 95, .external_lex_state = 4},
  [765] = {.lex_state = 16, .external_lex_state = 7},
  [766] = {.lex_state = 16, .external_lex_state = 7},
  [767] = {.lex_state = 16, .external_lex_state = 7},
  [768] = {.lex_state = 16, .external_lex_state = 7},
  [769] = {.lex_state = 16, .external_lex_state = 7},
  [770] = {.lex_state = 16, .external_lex_state = 7},
  [771] = {.lex_state = 16, .external_lex_state = 7},
  [772] = {.lex_state = 16, .external_lex_state = 7},
  [773] = {.lex_state = 16, .external_lex_state = 7},
  [774] = {.lex_state = 16, .external_lex_state = 7},
  [775] = {.lex_state = 16, .external_lex_state = 7},
  [776] = {.lex_state = 16, .external_lex_state = 7},
  [777] = {.lex_state = 16, .external_lex_state = 7},
  [778] = {.lex_state = 16, .external_lex_state = 7},
  [779] = {.lex_state = 16, .external_lex_state = 7},
  [780] = {.lex_state = 16, .external_lex_state = 7},
  [781] = {.lex_state = 16, .external_lex_state = 7},
  [782] = {.lex_state = 16, .external_lex_state = 7},
  [783] = {.lex_state = 16, .external_lex_state = 7},
  [784] = {.lex_state = 16, .external_lex_state = 7},
  [785] = {.lex_state = 16, .external_lex_state = 7},
  [786] = {.lex_state = 16, .external_lex_state = 7},
  [787] = {.lex_state = 16, .external_lex_state = 7},
  [788] = {.lex_state = 16, .external_lex_state = 7},
  [789] = {.lex_state = 16, .external_lex_state = 7},
  [790] = {.lex_state = 16, .external_lex_state = 7},
  [791] = {.lex_state = 16, .external_lex_state = 7},
  [792] = {.lex_state = 16, .external_lex_state = 7},
  [793] = {.lex_state = 16, .external_lex_state = 7},
  [794] = {.lex_state = 16, .external_lex_state = 7},
  [795] = {.lex_state = 16, .external_lex_state = 7},
  [796] = {.lex_state = 16, .external_lex_state = 7},
  [797] = {.lex_state = 16, .external_lex_state = 7},
  [798] = {.lex_state = 16, .external_lex_state = 7},
  [799] = {.lex_state = 16, .external_lex_state = 7},
  [800] = {.lex_state = 16, .external_lex_state = 7},
  [801] = {.lex_state = 16, .external_lex_state = 7},
  [802] = {.lex_state = 16, .external_lex_state = 7},
  [803] = {.lex_state = 16, .external_lex_state = 7},
  [804] = {.lex_state = 16, .external_lex_state = 7},
  [805] = {.lex_state = 16, .external_lex_state = 7},
  [806] = {.lex_state = 16, .external_lex_state = 7},
  [807] = {.lex_state = 16, .external_lex_state = 7},
  [808] = {.lex_state = 16, .external_lex_state = 7},
  [809] = {.lex_state = 16, .external_lex_state = 7},
  [810] = {.lex_state = 16, .external_lex_state = 7},
  [811] = {.lex_state = 16, .external_lex_state = 7},
  [812] = {.lex_state = 16, .external_lex_state = 7},
  [813] = {.lex_state = 16, .external_lex_state = 7},
  [814] = {.lex_state = 16, .external_lex_state = 7},
  [815] = {.lex_state = 16, .external_lex_state = 7},
  [816] = {.lex_state = 95, .external_lex_state = 4},
  [817] = {.lex_state = 16, .external_lex_state = 7},
  [818] = {.lex_state = 16, .external_lex_state = 7},
  [819] = {.lex_state = 16, .external_lex_state = 7},
  [820] = {.lex_state = 16, .external_lex_state = 7},
  [821] = {.lex_state = 16, .external_lex_state = 7},
  [822] = {.lex_state = 16, .external_lex_state = 7},
  [823] = {.lex_state = 16, .external_lex_state = 7},
  [824] = {.lex_state = 16, .external_lex_state = 7},
  [825] = {.lex_state = 95, .external_lex_state = 4},
  [826] = {.lex_state = 16, .external_lex_state = 7},
  [827] = {.lex_state = 16, .external_lex_state = 7},
  [828] = {.lex_state = 16, .external_lex_state = 7},
  [829] = {.lex_state = 16, .external_lex_state = 7},
  [830] = {.lex_state = 16, .external_lex_state = 7},
  [831] = {.lex_state = 95, .external_lex_state = 4},
  [832] = {.lex_state = 16, .external_lex_state = 7},
  [833] = {.lex_state = 16, .external_lex_state = 7},
  [834] = {.lex_state = 16, .external_lex_state = 7},
  [835] = {.lex_state = 16, .external_lex_state = 7},
  [836] = {.lex_state = 16, .external_lex_state = 7},
  [837] = {.lex_state = 16, .external_lex_state = 7},
  [838] = {.lex_state = 16, .external_lex_state = 7},
  [839] = {.lex_state = 16, .external_lex_state = 7},
  [840] = {.lex_state = 16, .external_lex_state = 7},
  [841] = {.lex_state = 16, .external_lex_state = 7},
  [842] = {.lex_state = 16, .external_lex_state = 7},
  [843] = {.lex_state = 16, .external_lex_state = 7},
  [844] = {.lex_state = 16, .external_lex_state = 7},
  [845] = {.lex_state = 16, .external_lex_state = 7},
  [846] = {.lex_state = 16, .external_lex_state = 7},
  [847] = {.lex_state = 16, .external_lex_state = 7},
  [848] = {.lex_state = 16, .external_lex_state = 7},
  [849] = {.lex_state = 16, .external_lex_state = 7},
  [850] = {.lex_state = 16, .external_lex_state = 7},
  [851] = {.lex_state = 16, .external_lex_state = 7},
  [852] = {.lex_state = 16, .external_lex_state = 7},
  [853] = {.lex_state = 95, .external_lex_state = 4},
  [854] = {.lex_state = 16, .external_lex_state = 7},
  [855] = {.lex_state = 16, .external_lex_state = 7},
  [856] = {.lex_state = 16, .external_lex_state = 7},
  [857] = {.lex_state = 16, .external_lex_state = 7},
  [858] = {.lex_state = 16, .external_lex_state = 7},
  [859] = {.lex_state = 108, .external_lex_state = 2},
  [860] = {.lex_state = 108, .external_lex_state = 2},
  [861] = {.lex_state = 16, .external_lex_state = 2},
  [862] = {.lex_state = 108, .external_lex_state = 2},
  [863] = {.lex_state = 16, .external_lex_state = 2},
  [864] = {.lex_state = 16, .external_lex_state = 2},
  [865] = {.lex_state = 16, .external_lex_state = 7},
  [866] = {.lex_state = 16, .external_lex_state = 2},
  [867] = {.lex_state = 16, .external_lex_state = 15},
  [868] = {.lex_state = 16, .external_lex_state = 15},
  [869] = {.lex_state = 16, .external_lex_state = 15},
  [870] = {.lex_state = 16, .external_lex_state = 2},
  [871] = {.lex_state = 16, .external_lex_state = 2},
  [872] = {.lex_state = 16, .external_lex_state = 16},
  [873] = {.lex_state = 16, .external_lex_state = 2},
  [874] = {.lex_state = 16, .external_lex_state = 2},
  [875] = {.lex_state = 16, .external_lex_state = 7},
  [876] = {.lex_state = 101, .external_lex_state = 17},
  [877] = {.lex_state = 101, .external_lex_state = 17},
  [878] = {.lex_state = 102, .external_lex_state = 17},
  [879] = {.lex_state = 102, .external_lex_state = 17},
  [880] = {.lex_state = 101, .external_lex_state = 17},
  [881] = {.lex_state = 101, .external_lex_state = 17},
  [882] = {.lex_state = 101, .external_lex_state = 17},
  [883] = {.lex_state = 101, .external_lex_state = 17},
  [884] = {.lex_state = 101, .external_lex_state = 17},
  [885] = {.lex_state = 100, .external_lex_state = 2},
  [886] = {.lex_state = 101, .external_lex_state = 17},
  [887] = {.lex_state = 102, .external_lex_state = 17},
  [888] = {.lex_state = 101, .external_lex_state = 17},
  [889] = {.lex_state = 102, .external_lex_state = 17},
  [890] = {.lex_state = 101, .external_lex_state = 17},
  [891] = {.lex_state = 101, .external_lex_state = 17},
  [892] = {.lex_state = 101, .external_lex_state = 17},
  [893] = {.lex_state = 101, .external_lex_state = 17},
  [894] = {.lex_state = 101, .external_lex_state = 17},
  [895] = {.lex_state = 101, .external_lex_state = 17},
  [896] = {.lex_state = 101, .external_lex_state = 17},
  [897] = {.lex_state = 101, .external_lex_state = 17},
  [898] = {.lex_state = 101, .external_lex_state = 17},
  [899] = {.lex_state = 102, .external_lex_state = 17},
  [900] = {.lex_state = 102, .external_lex_state = 17},
  [901] = {.lex_state = 101, .external_lex_state = 17},
  [902] = {.lex_state = 101, .external_lex_state = 17},
  [903] = {.lex_state = 101, .external_lex_state = 17},
  [904] = {.lex_state = 101, .external_lex_state = 17},
  [905] = {.lex_state = 102, .external_lex_state = 17},
  [906] = {.lex_state = 101, .external_lex_state = 17},
  [907] = {.lex_state = 101, .external_lex_state = 17},
  [908] = {.lex_state = 101, .external_lex_state = 17},
  [909] = {.lex_state = 101, .external_lex_state = 17},
  [910] = {.lex_state = 101, .external_lex_state = 17},
  [911] = {.lex_state = 101, .external_lex_state = 17},
  [912] = {.lex_state = 101, .external_lex_state = 17},
  [913] = {.lex_state = 101, .external_lex_state = 17},
  [914] = {.lex_state = 102, .external_lex_state = 17},
  [915] = {.lex_state = 101, .external_lex_state = 17},
  [916] = {.lex_state = 101, .external_lex_state = 17},
  [917] = {.lex_state = 102, .external_lex_state = 17},
  [918] = {.lex_state = 101, .external_lex_state = 17},
  [919] = {.lex_state = 102, .external_lex_state = 17},
  [920] = {.lex_state = 101, .external_lex_state = 17},
  [921] = {.lex_state = 101, .external_lex_state = 17},
  [922] = {.lex_state = 102, .external_lex_state = 17},
  [923] = {.lex_state = 101, .external_lex_state = 17},
  [924] = {.lex_state = 102, .external_lex_state = 17},
  [925] = {.lex_state = 101, .external_lex_state = 17},
  [926] = {.lex_state = 102, .external_lex_state = 17},
  [927] = {.lex_state = 102, .external_lex_state = 17},
  [928] = {.lex_state = 102, .external_lex_state = 17},
  [929] = {.lex_state = 102, .external_lex_state = 17},
  [930] = {.lex_state = 102, .external_lex_state = 17},
  [931] = {.lex_state = 102, .external_lex_state = 17},
  [932] = {.lex_state = 102, .external_lex_state = 17},
  [933] = {.lex_state = 100, .external_lex_state = 2},
  [934] = {.lex_state = 102, .external_lex_state = 17},
  [935] = {.lex_state = 102, .external_lex_state = 17},
  [936] = {.lex_state = 102, .external_lex_state = 17},
  [937] = {.lex_state = 101, .external_lex_state = 17},
  [938] = {.lex_state = 102, .external_lex_state = 17},
  [939] = {.lex_state = 102, .external_lex_state = 17},
  [940] = {.lex_state = 102, .external_lex_state = 17},
  [941] = {.lex_state = 102, .external_lex_state = 17},
  [942] = {.lex_state = 100, .external_lex_state = 2},
  [943] = {.lex_state = 102, .external_lex_state = 17},
  [944] = {.lex_state = 102, .external_lex_state = 17},
  [945] = {.lex_state = 102, .external_lex_state = 17},
  [946] = {.lex_state = 100, .external_lex_state = 2},
  [947] = {.lex_state = 102, .external_lex_state = 17},
  [948] = {.lex_state = 102, .external_lex_state = 17},
  [949] = {.lex_state = 102, .external_lex_state = 17},
  [950] = {.lex_state = 102, .external_lex_state = 17},
  [951] = {.lex_state = 102, .external_lex_state = 17},
  [952] = {.lex_state = 100, .external_lex_state = 5},
  [953] = {.lex_state = 100, .external_lex_state = 5},
  [954] = {.lex_state = 100, .external_lex_state = 5},
  [955] = {.lex_state = 100, .external_lex_state = 5},
  [956] = {.lex_state = 100, .external_lex_state = 5},
  [957] = {.lex_state = 100, .external_lex_state = 5},
  [958] = {.lex_state = 100, .external_lex_state = 2},
  [959] = {.lex_state = 102, .external_lex_state = 17},
  [960] = {.lex_state = 100, .external_lex_state = 5},
  [961] = {.lex_state = 102, .external_lex_state = 17},
  [962] = {.lex_state = 100, .external_lex_state = 5},
  [963] = {.lex_state = 100, .external_lex_state = 5},
  [964] = {.lex_state = 100, .external_lex_state = 5},
  [965] = {.lex_state = 100, .external_lex_state = 2},
  [966] = {.lex_state = 100, .external_lex_state = 2},
  [967] = {.lex_state = 100, .external_lex_state = 2},
  [968] = {.lex_state = 100, .external_lex_state = 2},
  [969] = {.lex_state = 100, .external_lex_state = 2},
  [970] = {.lex_state = 100, .external_lex_state = 2},
  [971] = {.lex_state = 101, .external_lex_state = 18},
  [972] = {.lex_state = 100, .external_lex_state = 2},
  [973] = {.lex_state = 100, .external_lex_state = 2},
  [974] = {.lex_state = 100, .external_lex_state = 2},
  [975] = {.lex_state = 100, .external_lex_state = 2},
  [976] = {.lex_state = 100, .external_lex_state = 2},
  [977] = {.lex_state = 100, .external_lex_state = 2},
  [978] = {.lex_state = 101, .external_lex_state = 18},
  [979] = {.lex_state = 102, .external_lex_state = 18},
  [980] = {.lex_state = 102, .external_lex_state = 19},
  [981] = {.lex_state = 102, .external_lex_state = 18},
  [982] = {.lex_state = 101, .external_lex_state = 17},
  [983] = {.lex_state = 102, .external_lex_state = 17},
  [984] = {.lex_state = 105, .external_lex_state = 20},
  [985] = {.lex_state = 102, .external_lex_state = 17},
  [986] = {.lex_state = 101, .external_lex_state = 17},
  [987] = {.lex_state = 101, .external_lex_state = 18},
  [988] = {.lex_state = 101, .external_lex_state = 18},
  [989] = {.lex_state = 101, .external_lex_state = 17},
  [990] = {.lex_state = 101, .external_lex_state = 18},
  [991] = {.lex_state = 101, .external_lex_state = 18},
  [992] = {.lex_state = 105, .external_lex_state = 20},
  [993] = {.lex_state = 102, .external_lex_state = 18},
  [994] = {.lex_state = 105, .external_lex_state = 20},
  [995] = {.lex_state = 105, .external_lex_state = 20},
  [996] = {.lex_state = 101, .external_lex_state = 18},
  [997] = {.lex_state = 101, .external_lex_state = 18},
  [998] = {.lex_state = 101, .external_lex_state = 19},
  [999] = {.lex_state = 101, .external_lex_state = 18},
  [1000] = {.lex_state = 101, .external_lex_state = 18},
  [1001] = {.lex_state = 101, .external_lex_state = 18},
  [1002] = {.lex_state = 101, .external_lex_state = 18},
  [1003] = {.lex_state = 102, .external_lex_state = 18},
  [1004] = {.lex_state = 102, .external_lex_state = 19},
  [1005] = {.lex_state = 101, .external_lex_state = 18},
  [1006] = {.lex_state = 101, .external_lex_state = 18},
  [1007] = {.lex_state = 102, .external_lex_state = 19},
  [1008] = {.lex_state = 101, .external_lex_state = 18},
  [1009] = {.lex_state = 105, .external_lex_state = 17},
  [1010] = {.lex_state = 101, .external_lex_state = 18},
  [1011] = {.lex_state = 102, .external_lex_state = 19},
  [1012] = {.lex_state = 101, .external_lex_state = 18},
  [1013] = {.lex_state = 101, .external_lex_state = 18},
  [1014] = {.lex_state = 101, .external_lex_state = 18},
  [1015] = {.lex_state = 105, .external_lex_state = 20},
  [1016] = {.lex_state = 105, .external_lex_state = 17},
  [1017] = {.lex_state = 102, .external_lex_state = 19},
  [1018] = {.lex_state = 102, .external_lex_state = 19},
  [1019] = {.lex_state = 101, .external_lex_state = 18},
  [1020] = {.lex_state = 101, .external_lex_state = 18},
  [1021] = {.lex_state = 101, .external_lex_state = 18},
  [1022] = {.lex_state = 101, .external_lex_state = 18},
  [1023] = {.lex_state = 102, .external_lex_state = 18},
  [1024] = {.lex_state = 102, .external_lex_state = 18},
  [1025] = {.lex_state = 102, .external_lex_state = 18},
  [1026] = {.lex_state = 101, .external_lex_state = 18},
  [1027] = {.lex_state = 101, .external_lex_state = 18},
  [1028] = {.lex_state = 101, .external_lex_state = 18},
  [1029] = {.lex_state = 102, .external_lex_state = 18},
  [1030] = {.lex_state = 105, .external_lex_state = 17},
  [1031] = {.lex_state = 102, .external_lex_state = 18},
  [1032] = {.lex_state = 101, .external_lex_state = 18},
  [1033] = {.lex_state = 102, .external_lex_state = 18},
  [1034] = {.lex_state = 105, .external_lex_state = 17},
  [1035] = {.lex_state = 101, .external_lex_state = 18},
  [1036] = {.lex_state = 105, .external_lex_state = 20},
  [1037] = {.lex_state = 101, .external_lex_state = 18},
  [1038] = {.lex_state = 102, .external_lex_state = 19},
  [1039] = {.lex_state = 105, .external_lex_state = 17},
  [1040] = {.lex_state = 101, .external_lex_state = 18},
  [1041] = {.lex_state = 102, .external_lex_state = 19},
  [1042] = {.lex_state = 101, .external_lex_state = 18},
  [1043] = {.lex_state = 102, .external_lex_state = 18},
  [1044] = {.lex_state = 105, .external_lex_state = 17},
  [1045] = {.lex_state = 102, .external_lex_state = 19},
  [1046] = {.lex_state = 101, .external_lex_state = 18},
  [1047] = {.lex_state = 105, .external_lex_state = 20},
  [1048] = {.lex_state = 101, .external_lex_state = 18},
  [1049] = {.lex_state = 101, .external_lex_state = 18},
  [1050] = {.lex_state = 102, .external_lex_state = 18},
  [1051] = {.lex_state = 102, .external_lex_state = 19},
  [1052] = {.lex_state = 102, .external_lex_state = 19},
  [1053] = {.lex_state = 102, .external_lex_state = 19},
  [1054] = {.lex_state = 102, .external_lex_state = 19},
  [1055] = {.lex_state = 102, .external_lex_state = 19},
  [1056] = {.lex_state = 101, .external_lex_state = 18},
  [1057] = {.lex_state = 102, .external_lex_state = 18},
  [1058] = {.lex_state = 102, .external_lex_state = 19},
  [1059] = {.lex_state = 102, .external_lex_state = 19},
  [1060] = {.lex_state = 102, .external_lex_state = 18},
  [1061] = {.lex_state = 102, .external_lex_state = 19},
  [1062] = {.lex_state = 102, .external_lex_state = 18},
  [1063] = {.lex_state = 102, .external_lex_state = 18},
  [1064] = {.lex_state = 102, .external_lex_state = 19},
  [1065] = {.lex_state = 102, .external_lex_state = 19},
  [1066] = {.lex_state = 102, .external_lex_state = 19},
  [1067] = {.lex_state = 102, .external_lex_state = 19},
  [1068] = {.lex_state = 102, .external_lex_state = 19},
  [1069] = {.lex_state = 102, .external_lex_state = 19},
  [1070] = {.lex_state = 102, .external_lex_state = 19},
  [1071] = {.lex_state = 102, .external_lex_state = 19},
  [1072] = {.lex_state = 102, .external_lex_state = 19},
  [1073] = {.lex_state = 102, .external_lex_state = 18},
  [1074] = {.lex_state = 101, .external_lex_state = 19},
  [1075] = {.lex_state = 102, .external_lex_state = 18},
  [1076] = {.lex_state = 102, .external_lex_state = 18},
  [1077] = {.lex_state = 102, .external_lex_state = 19},
  [1078] = {.lex_state = 102, .external_lex_state = 18},
  [1079] = {.lex_state = 102, .external_lex_state = 18},
  [1080] = {.lex_state = 102, .external_lex_state = 18},
  [1081] = {.lex_state = 102, .external_lex_state = 18},
  [1082] = {.lex_state = 102, .external_lex_state = 18},
  [1083] = {.lex_state = 105, .external_lex_state = 20},
  [1084] = {.lex_state = 101, .external_lex_state = 19},
  [1085] = {.lex_state = 102, .external_lex_state = 18},
  [1086] = {.lex_state = 105, .external_lex_state = 17},
  [1087] = {.lex_state = 102, .external_lex_state = 18},
  [1088] = {.lex_state = 105, .external_lex_state = 17},
  [1089] = {.lex_state = 102, .external_lex_state = 18},
  [1090] = {.lex_state = 102, .external_lex_state = 18},
  [1091] = {.lex_state = 102, .external_lex_state = 19},
  [1092] = {.lex_state = 102, .external_lex_state = 18},
  [1093] = {.lex_state = 102, .external_lex_state = 19},
  [1094] = {.lex_state = 105, .external_lex_state = 17},
  [1095] = {.lex_state = 105, .external_lex_state = 17},
  [1096] = {.lex_state = 105, .external_lex_state = 17},
  [1097] = {.lex_state = 101, .external_lex_state = 19},
  [1098] = {.lex_state = 105, .external_lex_state = 17},
  [1099] = {.lex_state = 105, .external_lex_state = 17},
  [1100] = {.lex_state = 105, .external_lex_state = 17},
  [1101] = {.lex_state = 105, .external_lex_state = 17},
  [1102] = {.lex_state = 105, .external_lex_state = 17},
  [1103] = {.lex_state = 105, .external_lex_state = 17},
  [1104] = {.lex_state = 105, .external_lex_state = 17},
  [1105] = {.lex_state = 105, .external_lex_state = 17},
  [1106] = {.lex_state = 105, .external_lex_state = 17},
  [1107] = {.lex_state = 105, .external_lex_state = 17},
  [1108] = {.lex_state = 105, .external_lex_state = 17},
  [1109] = {.lex_state = 105, .external_lex_state = 17},
  [1110] = {.lex_state = 105, .external_lex_state = 17},
  [1111] = {.lex_state = 102, .external_lex_state = 18},
  [1112] = {.lex_state = 105, .external_lex_state = 17},
  [1113] = {.lex_state = 101, .external_lex_state = 19},
  [1114] = {.lex_state = 105, .external_lex_state = 17},
  [1115] = {.lex_state = 101, .external_lex_state = 19},
  [1116] = {.lex_state = 101, .external_lex_state = 19},
  [1117] = {.lex_state = 105, .external_lex_state = 17},
  [1118] = {.lex_state = 105, .external_lex_state = 17},
  [1119] = {.lex_state = 101, .external_lex_state = 19},
  [1120] = {.lex_state = 105, .external_lex_state = 17},
  [1121] = {.lex_state = 105, .external_lex_state = 17},
  [1122] = {.lex_state = 105, .external_lex_state = 17},
  [1123] = {.lex_state = 105, .external_lex_state = 17},
  [1124] = {.lex_state = 105, .external_lex_state = 17},
  [1125] = {.lex_state = 105, .external_lex_state = 17},
  [1126] = {.lex_state = 105, .external_lex_state = 17},
  [1127] = {.lex_state = 105, .external_lex_state = 17},
  [1128] = {.lex_state = 105, .external_lex_state = 17},
  [1129] = {.lex_state = 105, .external_lex_state = 17},
  [1130] = {.lex_state = 105, .external_lex_state = 17},
  [1131] = {.lex_state = 105, .external_lex_state = 17},
  [1132] = {.lex_state = 105, .external_lex_state = 17},
  [1133] = {.lex_state = 105, .external_lex_state = 17},
  [1134] = {.lex_state = 105, .external_lex_state = 17},
  [1135] = {.lex_state = 105, .external_lex_state = 17},
  [1136] = {.lex_state = 105, .external_lex_state = 17},
  [1137] = {.lex_state = 105, .external_lex_state = 17},
  [1138] = {.lex_state = 102, .external_lex_state = 19},
  [1139] = {.lex_state = 101, .external_lex_state = 19},
  [1140] = {.lex_state = 105, .external_lex_state = 17},
  [1141] = {.lex_state = 105, .external_lex_state = 17},
  [1142] = {.lex_state = 105, .external_lex_state = 17},
  [1143] = {.lex_state = 102, .external_lex_state = 18},
  [1144] = {.lex_state = 105, .external_lex_state = 17},
  [1145] = {.lex_state = 105, .external_lex_state = 17},
  [1146] = {.lex_state = 105, .external_lex_state = 17},
  [1147] = {.lex_state = 105, .external_lex_state = 17},
  [1148] = {.lex_state = 105, .external_lex_state = 17},
  [1149] = {.lex_state = 105, .external_lex_state = 17},
  [1150] = {.lex_state = 105, .external_lex_state = 17},
  [1151] = {.lex_state = 105, .external_lex_state = 17},
  [1152] = {.lex_state = 102, .external_lex_state = 18},
  [1153] = {.lex_state = 105, .external_lex_state = 17},
  [1154] = {.lex_state = 105, .external_lex_state = 17},
  [1155] = {.lex_state = 102, .external_lex_state = 18},
  [1156] = {.lex_state = 105, .external_lex_state = 17},
  [1157] = {.lex_state = 105, .external_lex_state = 17},
  [1158] = {.lex_state = 105, .external_lex_state = 17},
  [1159] = {.lex_state = 105, .external_lex_state = 17},
  [1160] = {.lex_state = 105, .external_lex_state = 17},
  [1161] = {.lex_state = 105, .external_lex_state = 17},
  [1162] = {.lex_state = 105, .external_lex_state = 17},
  [1163] = {.lex_state = 105, .external_lex_state = 17},
  [1164] = {.lex_state = 105, .external_lex_state = 17},
  [1165] = {.lex_state = 105, .external_lex_state = 17},
  [1166] = {.lex_state = 105, .external_lex_state = 17},
  [1167] = {.lex_state = 105, .external_lex_state = 17},
  [1168] = {.lex_state = 105, .external_lex_state = 17},
  [1169] = {.lex_state = 105, .external_lex_state = 17},
  [1170] = {.lex_state = 105, .external_lex_state = 17},
  [1171] = {.lex_state = 105, .external_lex_state = 17},
  [1172] = {.lex_state = 105, .external_lex_state = 17},
  [1173] = {.lex_state = 105, .external_lex_state = 17},
  [1174] = {.lex_state = 105, .external_lex_state = 17},
  [1175] = {.lex_state = 105, .external_lex_state = 17},
  [1176] = {.lex_state = 105, .external_lex_state = 17},
  [1177] = {.lex_state = 105, .external_lex_state = 17},
  [1178] = {.lex_state = 105, .external_lex_state = 17},
  [1179] = {.lex_state = 105, .external_lex_state = 17},
  [1180] = {.lex_state = 105, .external_lex_state = 17},
  [1181] = {.lex_state = 105, .external_lex_state = 17},
  [1182] = {.lex_state = 105, .external_lex_state = 17},
  [1183] = {.lex_state = 105, .external_lex_state = 17},
  [1184] = {.lex_state = 105, .external_lex_state = 17},
  [1185] = {.lex_state = 105, .external_lex_state = 17},
  [1186] = {.lex_state = 105, .external_lex_state = 17},
  [1187] = {.lex_state = 105, .external_lex_state = 17},
  [1188] = {.lex_state = 105, .external_lex_state = 17},
  [1189] = {.lex_state = 101, .external_lex_state = 19},
  [1190] = {.lex_state = 105, .external_lex_state = 17},
  [1191] = {.lex_state = 105, .external_lex_state = 17},
  [1192] = {.lex_state = 105, .external_lex_state = 17},
  [1193] = {.lex_state = 105, .external_lex_state = 17},
  [1194] = {.lex_state = 105, .external_lex_state = 17},
  [1195] = {.lex_state = 102, .external_lex_state = 19},
  [1196] = {.lex_state = 101, .external_lex_state = 17},
  [1197] = {.lex_state = 105, .external_lex_state = 17},
  [1198] = {.lex_state = 102, .external_lex_state = 19},
  [1199] = {.lex_state = 105, .external_lex_state = 17},
  [1200] = {.lex_state = 102, .external_lex_state = 17},
  [1201] = {.lex_state = 101, .external_lex_state = 19},
  [1202] = {.lex_state = 102, .external_lex_state = 17},
  [1203] = {.lex_state = 102, .external_lex_state = 17},
  [1204] = {.lex_state = 101, .external_lex_state = 19},
  [1205] = {.lex_state = 101, .external_lex_state = 19},
  [1206] = {.lex_state = 101, .external_lex_state = 19},
  [1207] = {.lex_state = 101, .external_lex_state = 19},
  [1208] = {.lex_state = 101, .external_lex_state = 19},
  [1209] = {.lex_state = 101, .external_lex_state = 19},
  [1210] = {.lex_state = 102, .external_lex_state = 19},
  [1211] = {.lex_state = 101, .external_lex_state = 19},
  [1212] = {.lex_state = 101, .external_lex_state = 19},
  [1213] = {.lex_state = 101, .external_lex_state = 19},
  [1214] = {.lex_state = 101, .external_lex_state = 19},
  [1215] = {.lex_state = 101, .external_lex_state = 19},
  [1216] = {.lex_state = 102, .external_lex_state = 17},
  [1217] = {.lex_state = 101, .external_lex_state = 19},
  [1218] = {.lex_state = 107, .external_lex_state = 17},
  [1219] = {.lex_state = 101, .external_lex_state = 19},
  [1220] = {.lex_state = 101, .external_lex_state = 19},
  [1221] = {.lex_state = 101, .external_lex_state = 19},
  [1222] = {.lex_state = 101, .external_lex_state = 19},
  [1223] = {.lex_state = 101, .external_lex_state = 19},
  [1224] = {.lex_state = 107, .external_lex_state = 17},
  [1225] = {.lex_state = 107, .external_lex_state = 17},
  [1226] = {.lex_state = 101, .external_lex_state = 19},
  [1227] = {.lex_state = 101, .external_lex_state = 19},
  [1228] = {.lex_state = 101, .external_lex_state = 19},
  [1229] = {.lex_state = 107, .external_lex_state = 17},
  [1230] = {.lex_state = 107, .external_lex_state = 17},
  [1231] = {.lex_state = 107, .external_lex_state = 17},
  [1232] = {.lex_state = 107, .external_lex_state = 17},
  [1233] = {.lex_state = 107, .external_lex_state = 17},
  [1234] = {.lex_state = 107, .external_lex_state = 17},
  [1235] = {.lex_state = 107, .external_lex_state = 17},
  [1236] = {.lex_state = 107, .external_lex_state = 17},
  [1237] = {.lex_state = 102, .external_lex_state = 19},
  [1238] = {.lex_state = 107, .external_lex_state = 17},
  [1239] = {.lex_state = 107, .external_lex_state = 17},
  [1240] = {.lex_state = 102, .external_lex_state = 19},
  [1241] = {.lex_state = 107, .external_lex_state = 17},
  [1242] = {.lex_state = 107, .external_lex_state = 17},
  [1243] = {.lex_state = 107, .external_lex_state = 17},
  [1244] = {.lex_state = 107, .external_lex_state = 17},
  [1245] = {.lex_state = 107, .external_lex_state = 17},
  [1246] = {.lex_state = 102, .external_lex_state = 19},
  [1247] = {.lex_state = 107, .external_lex_state = 17},
  [1248] = {.lex_state = 107, .external_lex_state = 17},
  [1249] = {.lex_state = 107, .external_lex_state = 17},
  [1250] = {.lex_state = 107, .external_lex_state = 17},
  [1251] = {.lex_state = 107, .external_lex_state = 17},
  [1252] = {.lex_state = 107, .external_lex_state = 17},
  [1253] = {.lex_state = 107, .external_lex_state = 17},
  [1254] = {.lex_state = 107, .external_lex_state = 17},
  [1255] = {.lex_state = 107, .external_lex_state = 17},
  [1256] = {.lex_state = 107, .external_lex_state = 17},
  [1257] = {.lex_state = 107, .external_lex_state = 17},
  [1258] = {.lex_state = 101, .external_lex_state = 19},
  [1259] = {.lex_state = 107, .external_lex_state = 17},
  [1260] = {.lex_state = 107, .external_lex_state = 17},
  [1261] = {.lex_state = 107, .external_lex_state = 17},
  [1262] = {.lex_state = 107, .external_lex_state = 17},
  [1263] = {.lex_state = 107, .external_lex_state = 17},
  [1264] = {.lex_state = 107, .external_lex_state = 17},
  [1265] = {.lex_state = 107, .external_lex_state = 17},
  [1266] = {.lex_state = 107, .external_lex_state = 17},
  [1267] = {.lex_state = 105, .external_lex_state = 17},
  [1268] = {.lex_state = 107, .external_lex_state = 17},
  [1269] = {.lex_state = 107, .external_lex_state = 17},
  [1270] = {.lex_state = 107, .external_lex_state = 17},
  [1271] = {.lex_state = 107, .external_lex_state = 17},
  [1272] = {.lex_state = 107, .external_lex_state = 17},
  [1273] = {.lex_state = 107, .external_lex_state = 17},
  [1274] = {.lex_state = 107, .external_lex_state = 17},
  [1275] = {.lex_state = 107, .external_lex_state = 17},
  [1276] = {.lex_state = 107, .external_lex_state = 17},
  [1277] = {.lex_state = 107, .external_lex_state = 17},
  [1278] = {.lex_state = 107, .external_lex_state = 17},
  [1279] = {.lex_state = 107, .external_lex_state = 17},
  [1280] = {.lex_state = 107, .external_lex_state = 17},
  [1281] = {.lex_state = 107, .external_lex_state = 17},
  [1282] = {.lex_state = 107, .external_lex_state = 17},
  [1283] = {.lex_state = 107, .external_lex_state = 17},
  [1284] = {.lex_state = 107, .external_lex_state = 17},
  [1285] = {.lex_state = 107, .external_lex_state = 17},
  [1286] = {.lex_state = 107, .external_lex_state = 17},
  [1287] = {.lex_state = 107, .external_lex_state = 17},
  [1288] = {.lex_state = 107, .external_lex_state = 17},
  [1289] = {.lex_state = 107, .external_lex_state = 17},
  [1290] = {.lex_state = 107, .external_lex_state = 17},
  [1291] = {.lex_state = 107, .external_lex_state = 17},
  [1292] = {.lex_state = 107, .external_lex_state = 17},
  [1293] = {.lex_state = 107, .external_lex_state = 17},
  [1294] = {.lex_state = 107, .external_lex_state = 17},
  [1295] = {.lex_state = 107, .external_lex_state = 17},
  [1296] = {.lex_state = 107, .external_lex_state = 17},
  [1297] = {.lex_state = 107, .external_lex_state = 17},
  [1298] = {.lex_state = 107, .external_lex_state = 17},
  [1299] = {.lex_state = 107, .external_lex_state = 17},
  [1300] = {.lex_state = 107, .external_lex_state = 17},
  [1301] = {.lex_state = 107, .external_lex_state = 17},
  [1302] = {.lex_state = 107, .external_lex_state = 17},
  [1303] = {.lex_state = 107, .external_lex_state = 17},
  [1304] = {.lex_state = 107, .external_lex_state = 17},
  [1305] = {.lex_state = 107, .external_lex_state = 17},
  [1306] = {.lex_state = 107, .external_lex_state = 17},
  [1307] = {.lex_state = 107, .external_lex_state = 17},
  [1308] = {.lex_state = 107, .external_lex_state = 17},
  [1309] = {.lex_state = 107, .external_lex_state = 17},
  [1310] = {.lex_state = 107, .external_lex_state = 17},
  [1311] = {.lex_state = 107, .external_lex_state = 17},
  [1312] = {.lex_state = 107, .external_lex_state = 17},
  [1313] = {.lex_state = 107, .external_lex_state = 17},
  [1314] = {.lex_state = 107, .external_lex_state = 17},
  [1315] = {.lex_state = 107, .external_lex_state = 17},
  [1316] = {.lex_state = 107, .external_lex_state = 17},
  [1317] = {.lex_state = 107, .external_lex_state = 17},
  [1318] = {.lex_state = 107, .external_lex_state = 17},
  [1319] = {.lex_state = 107, .external_lex_state = 17},
  [1320] = {.lex_state = 107, .external_lex_state = 17},
  [1321] = {.lex_state = 107, .external_lex_state = 17},
  [1322] = {.lex_state = 107, .external_lex_state = 17},
  [1323] = {.lex_state = 107, .external_lex_state = 17},
  [1324] = {.lex_state = 107, .external_lex_state = 17},
  [1325] = {.lex_state = 107, .external_lex_state = 17},
  [1326] = {.lex_state = 107, .external_lex_state = 17},
  [1327] = {.lex_state = 107, .external_lex_state = 17},
  [1328] = {.lex_state = 107, .external_lex_state = 17},
  [1329] = {.lex_state = 107, .external_lex_state = 17},
  [1330] = {.lex_state = 107, .external_lex_state = 17},
  [1331] = {.lex_state = 107, .external_lex_state = 17},
  [1332] = {.lex_state = 107, .external_lex_state = 17},
  [1333] = {.lex_state = 107, .external_lex_state = 17},
  [1334] = {.lex_state = 107, .external_lex_state = 17},
  [1335] = {.lex_state = 107, .external_lex_state = 17},
  [1336] = {.lex_state = 107, .external_lex_state = 17},
  [1337] = {.lex_state = 107, .external_lex_state = 17},
  [1338] = {.lex_state = 107, .external_lex_state = 17},
  [1339] = {.lex_state = 107, .external_lex_state = 17},
  [1340] = {.lex_state = 107, .external_lex_state = 17},
  [1341] = {.lex_state = 107, .external_lex_state = 17},
  [1342] = {.lex_state = 107, .external_lex_state = 17},
  [1343] = {.lex_state = 107, .external_lex_state = 17},
  [1344] = {.lex_state = 107, .external_lex_state = 17},
  [1345] = {.lex_state = 107, .external_lex_state = 17},
  [1346] = {.lex_state = 105, .external_lex_state = 20},
  [1347] = {.lex_state = 107, .external_lex_state = 17},
  [1348] = {.lex_state = 107, .external_lex_state = 17},
  [1349] = {.lex_state = 107, .external_lex_state = 17},
  [1350] = {.lex_state = 107, .external_lex_state = 17},
  [1351] = {.lex_state = 107, .external_lex_state = 17},
  [1352] = {.lex_state = 107, .external_lex_state = 17},
  [1353] = {.lex_state = 107, .external_lex_state = 17},
  [1354] = {.lex_state = 107, .external_lex_state = 17},
  [1355] = {.lex_state = 105, .external_lex_state = 17},
  [1356] = {.lex_state = 105, .external_lex_state = 21},
  [1357] = {.lex_state = 107, .external_lex_state = 17},
  [1358] = {.lex_state = 107, .external_lex_state = 17},
  [1359] = {.lex_state = 20, .external_lex_state = 22},
  [1360] = {.lex_state = 20, .external_lex_state = 22},
  [1361] = {.lex_state = 105, .external_lex_state = 21},
  [1362] = {.lex_state = 105, .external_lex_state = 21},
  [1363] = {.lex_state = 20, .external_lex_state = 22},
  [1364] = {.lex_state = 105, .external_lex_state = 21},
  [1365] = {.lex_state = 105, .external_lex_state = 23},
  [1366] = {.lex_state = 105, .external_lex_state = 18},
  [1367] = {.lex_state = 105, .external_lex_state = 23},
  [1368] = {.lex_state = 105, .external_lex_state = 21},
  [1369] = {.lex_state = 105, .external_lex_state = 21},
  [1370] = {.lex_state = 18, .external_lex_state = 19},
  [1371] = {.lex_state = 105, .external_lex_state = 18},
  [1372] = {.lex_state = 18, .external_lex_state = 19},
  [1373] = {.lex_state = 105, .external_lex_state = 18},
  [1374] = {.lex_state = 105, .external_lex_state = 18},
  [1375] = {.lex_state = 105, .external_lex_state = 18},
  [1376] = {.lex_state = 105, .external_lex_state = 23},
  [1377] = {.lex_state = 20, .external_lex_state = 24},
  [1378] = {.lex_state = 18, .external_lex_state = 19},
  [1379] = {.lex_state = 105, .external_lex_state = 18},
  [1380] = {.lex_state = 105, .external_lex_state = 21},
  [1381] = {.lex_state = 18, .external_lex_state = 19},
  [1382] = {.lex_state = 18, .external_lex_state = 19},
  [1383] = {.lex_state = 18, .external_lex_state = 19},
  [1384] = {.lex_state = 18, .external_lex_state = 19},
  [1385] = {.lex_state = 105, .external_lex_state = 23},
  [1386] = {.lex_state = 105, .external_lex_state = 17},
  [1387] = {.lex_state = 105, .external_lex_state = 18},
  [1388] = {.lex_state = 18, .external_lex_state = 23},
  [1389] = {.lex_state = 105, .external_lex_state = 18},
  [1390] = {.lex_state = 18, .external_lex_state = 19},
  [1391] = {.lex_state = 105, .external_lex_state = 23},
  [1392] = {.lex_state = 105, .external_lex_state = 18},
  [1393] = {.lex_state = 18, .external_lex_state = 19},
  [1394] = {.lex_state = 105, .external_lex_state = 18},
  [1395] = {.lex_state = 105, .external_lex_state = 18},
  [1396] = {.lex_state = 105, .external_lex_state = 18},
  [1397] = {.lex_state = 105, .external_lex_state = 18},
  [1398] = {.lex_state = 105, .external_lex_state = 18},
  [1399] = {.lex_state = 105, .external_lex_state = 18},
  [1400] = {.lex_state = 105, .external_lex_state = 18},
  [1401] = {.lex_state = 105, .external_lex_state = 18},
  [1402] = {.lex_state = 105, .external_lex_state = 18},
  [1403] = {.lex_state = 18, .external_lex_state = 19},
  [1404] = {.lex_state = 18, .external_lex_state = 19},
  [1405] = {.lex_state = 18, .external_lex_state = 19},
  [1406] = {.lex_state = 18, .external_lex_state = 19},
  [1407] = {.lex_state = 105, .external_lex_state = 18},
  [1408] = {.lex_state = 18, .external_lex_state = 19},
  [1409] = {.lex_state = 105, .external_lex_state = 18},
  [1410] = {.lex_state = 18, .external_lex_state = 19},
  [1411] = {.lex_state = 105, .external_lex_state = 18},
  [1412] = {.lex_state = 105, .external_lex_state = 18},
  [1413] = {.lex_state = 105, .external_lex_state = 18},
  [1414] = {.lex_state = 105, .external_lex_state = 18},
  [1415] = {.lex_state = 105, .external_lex_state = 18},
  [1416] = {.lex_state = 105, .external_lex_state = 18},
  [1417] = {.lex_state = 105, .external_lex_state = 18},
  [1418] = {.lex_state = 105, .external_lex_state = 18},
  [1419] = {.lex_state = 105, .external_lex_state = 18},
  [1420] = {.lex_state = 18, .external_lex_state = 19},
  [1421] = {.lex_state = 105, .external_lex_state = 18},
  [1422] = {.lex_state = 105, .external_lex_state = 18},
  [1423] = {.lex_state = 105, .external_lex_state = 18},
  [1424] = {.lex_state = 18, .external_lex_state = 19},
  [1425] = {.lex_state = 105, .external_lex_state = 18},
  [1426] = {.lex_state = 105, .external_lex_state = 18},
  [1427] = {.lex_state = 18, .external_lex_state = 19},
  [1428] = {.lex_state = 105, .external_lex_state = 18},
  [1429] = {.lex_state = 105, .external_lex_state = 18},
  [1430] = {.lex_state = 105, .external_lex_state = 18},
  [1431] = {.lex_state = 105, .external_lex_state = 18},
  [1432] = {.lex_state = 18, .external_lex_state = 19},
  [1433] = {.lex_state = 18, .external_lex_state = 19},
  [1434] = {.lex_state = 105, .external_lex_state = 18},
  [1435] = {.lex_state = 105, .external_lex_state = 18},
  [1436] = {.lex_state = 18, .external_lex_state = 19},
  [1437] = {.lex_state = 18, .external_lex_state = 19},
  [1438] = {.lex_state = 18, .external_lex_state = 19},
  [1439] = {.lex_state = 105, .external_lex_state = 18},
  [1440] = {.lex_state = 18, .external_lex_state = 19},
  [1441] = {.lex_state = 18, .external_lex_state = 19},
  [1442] = {.lex_state = 18, .external_lex_state = 19},
  [1443] = {.lex_state = 18, .external_lex_state = 19},
  [1444] = {.lex_state = 18, .external_lex_state = 19},
  [1445] = {.lex_state = 18, .external_lex_state = 19},
  [1446] = {.lex_state = 105, .external_lex_state = 18},
  [1447] = {.lex_state = 105, .external_lex_state = 18},
  [1448] = {.lex_state = 18, .external_lex_state = 19},
  [1449] = {.lex_state = 105, .external_lex_state = 18},
  [1450] = {.lex_state = 105, .external_lex_state = 18},
  [1451] = {.lex_state = 18, .external_lex_state = 19},
  [1452] = {.lex_state = 18, .external_lex_state = 19},
  [1453] = {.lex_state = 18, .external_lex_state = 19},
  [1454] = {.lex_state = 18, .external_lex_state = 19},
  [1455] = {.lex_state = 18, .external_lex_state = 19},
  [1456] = {.lex_state = 18, .external_lex_state = 19},
  [1457] = {.lex_state = 105, .external_lex_state = 18},
  [1458] = {.lex_state = 105, .external_lex_state = 18},
  [1459] = {.lex_state = 105, .external_lex_state = 18},
  [1460] = {.lex_state = 18, .external_lex_state = 19},
  [1461] = {.lex_state = 105, .external_lex_state = 18},
  [1462] = {.lex_state = 18, .external_lex_state = 19},
  [1463] = {.lex_state = 18, .external_lex_state = 19},
  [1464] = {.lex_state = 18, .external_lex_state = 19},
  [1465] = {.lex_state = 105, .external_lex_state = 18},
  [1466] = {.lex_state = 18, .external_lex_state = 19},
  [1467] = {.lex_state = 105, .external_lex_state = 18},
  [1468] = {.lex_state = 105, .external_lex_state = 18},
  [1469] = {.lex_state = 18, .external_lex_state = 19},
  [1470] = {.lex_state = 18, .external_lex_state = 19},
  [1471] = {.lex_state = 18, .external_lex_state = 19},
  [1472] = {.lex_state = 18, .external_lex_state = 19},
  [1473] = {.lex_state = 18, .external_lex_state = 19},
  [1474] = {.lex_state = 18, .external_lex_state = 19},
  [1475] = {.lex_state = 18, .external_lex_state = 19},
  [1476] = {.lex_state = 18, .external_lex_state = 19},
  [1477] = {.lex_state = 18, .external_lex_state = 19},
  [1478] = {.lex_state = 105, .external_lex_state = 18},
  [1479] = {.lex_state = 18, .external_lex_state = 19},
  [1480] = {.lex_state = 18, .external_lex_state = 19},
  [1481] = {.lex_state = 18, .external_lex_state = 19},
  [1482] = {.lex_state = 105, .external_lex_state = 18},
  [1483] = {.lex_state = 105, .external_lex_state = 18},
  [1484] = {.lex_state = 18, .external_lex_state = 19},
  [1485] = {.lex_state = 105, .external_lex_state = 18},
  [1486] = {.lex_state = 18, .external_lex_state = 19},
  [1487] = {.lex_state = 105, .external_lex_state = 18},
  [1488] = {.lex_state = 105, .external_lex_state = 18},
  [1489] = {.lex_state = 105, .external_lex_state = 18},
  [1490] = {.lex_state = 105, .external_lex_state = 18},
  [1491] = {.lex_state = 105, .external_lex_state = 18},
  [1492] = {.lex_state = 105, .external_lex_state = 18},
  [1493] = {.lex_state = 105, .external_lex_state = 18},
  [1494] = {.lex_state = 105, .external_lex_state = 18},
  [1495] = {.lex_state = 105, .external_lex_state = 18},
  [1496] = {.lex_state = 105, .external_lex_state = 18},
  [1497] = {.lex_state = 105, .external_lex_state = 18},
  [1498] = {.lex_state = 105, .external_lex_state = 18},
  [1499] = {.lex_state = 105, .external_lex_state = 18},
  [1500] = {.lex_state = 18, .external_lex_state = 19},
  [1501] = {.lex_state = 18, .external_lex_state = 19},
  [1502] = {.lex_state = 105, .external_lex_state = 18},
  [1503] = {.lex_state = 105, .external_lex_state = 18},
  [1504] = {.lex_state = 105, .external_lex_state = 18},
  [1505] = {.lex_state = 105, .external_lex_state = 18},
  [1506] = {.lex_state = 105, .external_lex_state = 18},
  [1507] = {.lex_state = 105, .external_lex_state = 18},
  [1508] = {.lex_state = 105, .external_lex_state = 18},
  [1509] = {.lex_state = 105, .external_lex_state = 18},
  [1510] = {.lex_state = 18, .external_lex_state = 19},
  [1511] = {.lex_state = 18, .external_lex_state = 19},
  [1512] = {.lex_state = 18, .external_lex_state = 19},
  [1513] = {.lex_state = 18, .external_lex_state = 19},
  [1514] = {.lex_state = 105, .external_lex_state = 18},
  [1515] = {.lex_state = 18, .external_lex_state = 19},
  [1516] = {.lex_state = 105, .external_lex_state = 18},
  [1517] = {.lex_state = 105, .external_lex_state = 18},
  [1518] = {.lex_state = 105, .external_lex_state = 18},
  [1519] = {.lex_state = 105, .external_lex_state = 18},
  [1520] = {.lex_state = 18, .external_lex_state = 19},
  [1521] = {.lex_state = 105, .external_lex_state = 18},
  [1522] = {.lex_state = 18, .external_lex_state = 19},
  [1523] = {.lex_state = 18, .external_lex_state = 19},
  [1524] = {.lex_state = 18, .external_lex_state = 19},
  [1525] = {.lex_state = 18, .external_lex_state = 19},
  [1526] = {.lex_state = 105, .external_lex_state = 18},
  [1527] = {.lex_state = 105, .external_lex_state = 18},
  [1528] = {.lex_state = 105, .external_lex_state = 18},
  [1529] = {.lex_state = 18, .external_lex_state = 19},
  [1530] = {.lex_state = 18, .external_lex_state = 19},
  [1531] = {.lex_state = 18, .external_lex_state = 19},
  [1532] = {.lex_state = 18, .external_lex_state = 19},
  [1533] = {.lex_state = 18, .external_lex_state = 19},
  [1534] = {.lex_state = 18, .external_lex_state = 19},
  [1535] = {.lex_state = 18, .external_lex_state = 19},
  [1536] = {.lex_state = 18, .external_lex_state = 19},
  [1537] = {.lex_state = 105, .external_lex_state = 18},
  [1538] = {.lex_state = 18, .external_lex_state = 19},
  [1539] = {.lex_state = 18, .external_lex_state = 19},
  [1540] = {.lex_state = 18, .external_lex_state = 19},
  [1541] = {.lex_state = 18, .external_lex_state = 19},
  [1542] = {.lex_state = 18, .external_lex_state = 19},
  [1543] = {.lex_state = 18, .external_lex_state = 19},
  [1544] = {.lex_state = 18, .external_lex_state = 19},
  [1545] = {.lex_state = 18, .external_lex_state = 19},
  [1546] = {.lex_state = 105, .external_lex_state = 18},
  [1547] = {.lex_state = 18, .external_lex_state = 19},
  [1548] = {.lex_state = 105, .external_lex_state = 18},
  [1549] = {.lex_state = 18, .external_lex_state = 19},
  [1550] = {.lex_state = 105, .external_lex_state = 18},
  [1551] = {.lex_state = 105, .external_lex_state = 18},
  [1552] = {.lex_state = 18, .external_lex_state = 19},
  [1553] = {.lex_state = 18, .external_lex_state = 19},
  [1554] = {.lex_state = 105, .external_lex_state = 18},
  [1555] = {.lex_state = 18, .external_lex_state = 19},
  [1556] = {.lex_state = 18, .external_lex_state = 19},
  [1557] = {.lex_state = 105, .external_lex_state = 18},
  [1558] = {.lex_state = 18, .external_lex_state = 19},
  [1559] = {.lex_state = 105, .external_lex_state = 18},
  [1560] = {.lex_state = 18, .external_lex_state = 19},
  [1561] = {.lex_state = 18, .external_lex_state = 19},
  [1562] = {.lex_state = 105, .external_lex_state = 18},
  [1563] = {.lex_state = 18, .external_lex_state = 19},
  [1564] = {.lex_state = 18, .external_lex_state = 19},
  [1565] = {.lex_state = 105, .external_lex_state = 18},
  [1566] = {.lex_state = 18, .external_lex_state = 19},
  [1567] = {.lex_state = 18, .external_lex_state = 19},
  [1568] = {.lex_state = 20, .external_lex_state = 22},
  [1569] = {.lex_state = 18, .external_lex_state = 19},
  [1570] = {.lex_state = 20, .external_lex_state = 22},
  [1571] = {.lex_state = 105, .external_lex_state = 23},
  [1572] = {.lex_state = 20, .external_lex_state = 22},
  [1573] = {.lex_state = 20, .external_lex_state = 22},
  [1574] = {.lex_state = 20, .external_lex_state = 22},
  [1575] = {.lex_state = 105, .external_lex_state = 18},
  [1576] = {.lex_state = 20, .external_lex_state = 22},
  [1577] = {.lex_state = 20, .external_lex_state = 22},
  [1578] = {.lex_state = 20, .external_lex_state = 22},
  [1579] = {.lex_state = 107, .external_lex_state = 17},
  [1580] = {.lex_state = 105, .external_lex_state = 17},
  [1581] = {.lex_state = 107, .external_lex_state = 17},
  [1582] = {.lex_state = 20, .external_lex_state = 22},
  [1583] = {.lex_state = 105, .external_lex_state = 17},
  [1584] = {.lex_state = 20, .external_lex_state = 22},
  [1585] = {.lex_state = 107, .external_lex_state = 17},
  [1586] = {.lex_state = 20, .external_lex_state = 22},
  [1587] = {.lex_state = 20, .external_lex_state = 24},
  [1588] = {.lex_state = 20, .external_lex_state = 22},
  [1589] = {.lex_state = 107, .external_lex_state = 17},
  [1590] = {.lex_state = 20, .external_lex_state = 22},
  [1591] = {.lex_state = 20, .external_lex_state = 24},
  [1592] = {.lex_state = 20, .external_lex_state = 22},
  [1593] = {.lex_state = 107, .external_lex_state = 18},
  [1594] = {.lex_state = 107, .external_lex_state = 18},
  [1595] = {.lex_state = 20, .external_lex_state = 24},
  [1596] = {.lex_state = 107, .external_lex_state = 17},
  [1597] = {.lex_state = 105, .external_lex_state = 18},
  [1598] = {.lex_state = 20, .external_lex_state = 24},
  [1599] = {.lex_state = 20, .external_lex_state = 24},
  [1600] = {.lex_state = 107, .external_lex_state = 18},
  [1601] = {.lex_state = 20, .external_lex_state = 24},
  [1602] = {.lex_state = 107, .external_lex_state = 18},
  [1603] = {.lex_state = 107, .external_lex_state = 17},
  [1604] = {.lex_state = 107, .external_lex_state = 18},
  [1605] = {.lex_state = 107, .external_lex_state = 17},
  [1606] = {.lex_state = 107, .external_lex_state = 17},
  [1607] = {.lex_state = 107, .external_lex_state = 18},
  [1608] = {.lex_state = 107, .external_lex_state = 17},
  [1609] = {.lex_state = 107, .external_lex_state = 18},
  [1610] = {.lex_state = 107, .external_lex_state = 17},
  [1611] = {.lex_state = 107, .external_lex_state = 18},
  [1612] = {.lex_state = 107, .external_lex_state = 18},
  [1613] = {.lex_state = 107, .external_lex_state = 18},
  [1614] = {.lex_state = 107, .external_lex_state = 18},
  [1615] = {.lex_state = 107, .external_lex_state = 18},
  [1616] = {.lex_state = 107, .external_lex_state = 18},
  [1617] = {.lex_state = 107, .external_lex_state = 18},
  [1618] = {.lex_state = 107, .external_lex_state = 17},
  [1619] = {.lex_state = 107, .external_lex_state = 18},
  [1620] = {.lex_state = 107, .external_lex_state = 18},
  [1621] = {.lex_state = 107, .external_lex_state = 18},
  [1622] = {.lex_state = 107, .external_lex_state = 18},
  [1623] = {.lex_state = 107, .external_lex_state = 17},
  [1624] = {.lex_state = 107, .external_lex_state = 18},
  [1625] = {.lex_state = 107, .external_lex_state = 18},
  [1626] = {.lex_state = 107, .external_lex_state = 18},
  [1627] = {.lex_state = 107, .external_lex_state = 18},
  [1628] = {.lex_state = 107, .external_lex_state = 19},
  [1629] = {.lex_state = 107, .external_lex_state = 17},
  [1630] = {.lex_state = 107, .external_lex_state = 18},
  [1631] = {.lex_state = 18, .external_lex_state = 23},
  [1632] = {.lex_state = 107, .external_lex_state = 18},
  [1633] = {.lex_state = 107, .external_lex_state = 18},
  [1634] = {.lex_state = 18, .external_lex_state = 23},
  [1635] = {.lex_state = 18, .external_lex_state = 23},
  [1636] = {.lex_state = 107, .external_lex_state = 19},
  [1637] = {.lex_state = 107, .external_lex_state = 17},
  [1638] = {.lex_state = 107, .external_lex_state = 17},
  [1639] = {.lex_state = 107, .external_lex_state = 17},
  [1640] = {.lex_state = 107, .external_lex_state = 19},
  [1641] = {.lex_state = 107, .external_lex_state = 17},
  [1642] = {.lex_state = 107, .external_lex_state = 18},
  [1643] = {.lex_state = 107, .external_lex_state = 17},
  [1644] = {.lex_state = 107, .external_lex_state = 17},
  [1645] = {.lex_state = 107, .external_lex_state = 17},
  [1646] = {.lex_state = 107, .external_lex_state = 17},
  [1647] = {.lex_state = 107, .external_lex_state = 18},
  [1648] = {.lex_state = 107, .external_lex_state = 18},
  [1649] = {.lex_state = 107, .external_lex_state = 17},
  [1650] = {.lex_state = 107, .external_lex_state = 17},
  [1651] = {.lex_state = 107, .external_lex_state = 18},
  [1652] = {.lex_state = 107, .external_lex_state = 18},
  [1653] = {.lex_state = 107, .external_lex_state = 19},
  [1654] = {.lex_state = 107, .external_lex_state = 18},
  [1655] = {.lex_state = 107, .external_lex_state = 18},
  [1656] = {.lex_state = 107, .external_lex_state = 18},
  [1657] = {.lex_state = 107, .external_lex_state = 18},
  [1658] = {.lex_state = 107, .external_lex_state = 18},
  [1659] = {.lex_state = 107, .external_lex_state = 18},
  [1660] = {.lex_state = 107, .external_lex_state = 18},
  [1661] = {.lex_state = 107, .external_lex_state = 18},
  [1662] = {.lex_state = 107, .external_lex_state = 18},
  [1663] = {.lex_state = 22, .external_lex_state = 22},
  [1664] = {.lex_state = 107, .external_lex_state = 18},
  [1665] = {.lex_state = 107, .external_lex_state = 18},
  [1666] = {.lex_state = 107, .external_lex_state = 18},
  [1667] = {.lex_state = 107, .external_lex_state = 18},
  [1668] = {.lex_state = 107, .external_lex_state = 18},
  [1669] = {.lex_state = 107, .external_lex_state = 18},
  [1670] = {.lex_state = 107, .external_lex_state = 18},
  [1671] = {.lex_state = 107, .external_lex_state = 18},
  [1672] = {.lex_state = 107, .external_lex_state = 18},
  [1673] = {.lex_state = 107, .external_lex_state = 18},
  [1674] = {.lex_state = 107, .external_lex_state = 18},
  [1675] = {.lex_state = 107, .external_lex_state = 18},
  [1676] = {.lex_state = 105, .external_lex_state = 19},
  [1677] = {.lex_state = 107, .external_lex_state = 18},
  [1678] = {.lex_state = 107, .external_lex_state = 18},
  [1679] = {.lex_state = 107, .external_lex_state = 18},
  [1680] = {.lex_state = 107, .external_lex_state = 18},
  [1681] = {.lex_state = 107, .external_lex_state = 18},
  [1682] = {.lex_state = 107, .external_lex_state = 18},
  [1683] = {.lex_state = 107, .external_lex_state = 18},
  [1684] = {.lex_state = 20, .external_lex_state = 22},
  [1685] = {.lex_state = 18, .external_lex_state = 23},
  [1686] = {.lex_state = 107, .external_lex_state = 18},
  [1687] = {.lex_state = 107, .external_lex_state = 18},
  [1688] = {.lex_state = 107, .external_lex_state = 18},
  [1689] = {.lex_state = 20, .external_lex_state = 22},
  [1690] = {.lex_state = 20, .external_lex_state = 22},
  [1691] = {.lex_state = 107, .external_lex_state = 18},
  [1692] = {.lex_state = 107, .external_lex_state = 18},
  [1693] = {.lex_state = 20, .external_lex_state = 22},
  [1694] = {.lex_state = 18, .external_lex_state = 23},
  [1695] = {.lex_state = 107, .external_lex_state = 18},
  [1696] = {.lex_state = 20, .external_lex_state = 22},
  [1697] = {.lex_state = 107, .external_lex_state = 18},
  [1698] = {.lex_state = 20, .external_lex_state = 22},
  [1699] = {.lex_state = 107, .external_lex_state = 18},
  [1700] = {.lex_state = 107, .external_lex_state = 18},
  [1701] = {.lex_state = 107, .external_lex_state = 18},
  [1702] = {.lex_state = 107, .external_lex_state = 18},
  [1703] = {.lex_state = 107, .external_lex_state = 18},
  [1704] = {.lex_state = 107, .external_lex_state = 18},
  [1705] = {.lex_state = 107, .external_lex_state = 18},
  [1706] = {.lex_state = 107, .external_lex_state = 18},
  [1707] = {.lex_state = 107, .external_lex_state = 18},
  [1708] = {.lex_state = 107, .external_lex_state = 18},
  [1709] = {.lex_state = 107, .external_lex_state = 18},
  [1710] = {.lex_state = 107, .external_lex_state = 18},
  [1711] = {.lex_state = 107, .external_lex_state = 18},
  [1712] = {.lex_state = 107, .external_lex_state = 18},
  [1713] = {.lex_state = 107, .external_lex_state = 18},
  [1714] = {.lex_state = 107, .external_lex_state = 18},
  [1715] = {.lex_state = 107, .external_lex_state = 18},
  [1716] = {.lex_state = 107, .external_lex_state = 18},
  [1717] = {.lex_state = 107, .external_lex_state = 18},
  [1718] = {.lex_state = 107, .external_lex_state = 17},
  [1719] = {.lex_state = 107, .external_lex_state = 18},
  [1720] = {.lex_state = 107, .external_lex_state = 17},
  [1721] = {.lex_state = 107, .external_lex_state = 19},
  [1722] = {.lex_state = 107, .external_lex_state = 18},
  [1723] = {.lex_state = 107, .external_lex_state = 18},
  [1724] = {.lex_state = 107, .external_lex_state = 19},
  [1725] = {.lex_state = 107, .external_lex_state = 18},
  [1726] = {.lex_state = 107, .external_lex_state = 18},
  [1727] = {.lex_state = 107, .external_lex_state = 18},
  [1728] = {.lex_state = 107, .external_lex_state = 19},
  [1729] = {.lex_state = 107, .external_lex_state = 18},
  [1730] = {.lex_state = 107, .external_lex_state = 18},
  [1731] = {.lex_state = 107, .external_lex_state = 19},
  [1732] = {.lex_state = 107, .external_lex_state = 18},
  [1733] = {.lex_state = 107, .external_lex_state = 18},
  [1734] = {.lex_state = 107, .external_lex_state = 18},
  [1735] = {.lex_state = 107, .external_lex_state = 18},
  [1736] = {.lex_state = 107, .external_lex_state = 18},
  [1737] = {.lex_state = 107, .external_lex_state = 18},
  [1738] = {.lex_state = 107, .external_lex_state = 17},
  [1739] = {.lex_state = 107, .external_lex_state = 17},
  [1740] = {.lex_state = 107, .external_lex_state = 18},
  [1741] = {.lex_state = 107, .external_lex_state = 18},
  [1742] = {.lex_state = 107, .external_lex_state = 18},
  [1743] = {.lex_state = 107, .external_lex_state = 18},
  [1744] = {.lex_state = 107, .external_lex_state = 18},
  [1745] = {.lex_state = 107, .external_lex_state = 18},
  [1746] = {.lex_state = 107, .external_lex_state = 17},
  [1747] = {.lex_state = 107, .external_lex_state = 18},
  [1748] = {.lex_state = 107, .external_lex_state = 18},
  [1749] = {.lex_state = 107, .external_lex_state = 19},
  [1750] = {.lex_state = 107, .external_lex_state = 17},
  [1751] = {.lex_state = 107, .external_lex_state = 17},
  [1752] = {.lex_state = 107, .external_lex_state = 17},
  [1753] = {.lex_state = 107, .external_lex_state = 17},
  [1754] = {.lex_state = 107, .external_lex_state = 17},
  [1755] = {.lex_state = 107, .external_lex_state = 17},
  [1756] = {.lex_state = 107, .external_lex_state = 17},
  [1757] = {.lex_state = 107, .external_lex_state = 17},
  [1758] = {.lex_state = 107, .external_lex_state = 17},
  [1759] = {.lex_state = 107, .external_lex_state = 17},
  [1760] = {.lex_state = 107, .external_lex_state = 19},
  [1761] = {.lex_state = 107, .external_lex_state = 19},
  [1762] = {.lex_state = 23, .external_lex_state = 25},
  [1763] = {.lex_state = 107, .external_lex_state = 19},
  [1764] = {.lex_state = 107, .external_lex_state = 19},
  [1765] = {.lex_state = 107, .external_lex_state = 18},
  [1766] = {.lex_state = 107, .external_lex_state = 17},
  [1767] = {.lex_state = 107, .external_lex_state = 17},
  [1768] = {.lex_state = 107, .external_lex_state = 18},
  [1769] = {.lex_state = 23, .external_lex_state = 25},
  [1770] = {.lex_state = 23, .external_lex_state = 25},
  [1771] = {.lex_state = 107, .external_lex_state = 19},
  [1772] = {.lex_state = 107, .external_lex_state = 18},
  [1773] = {.lex_state = 107, .external_lex_state = 17},
  [1774] = {.lex_state = 107, .external_lex_state = 18},
  [1775] = {.lex_state = 23, .external_lex_state = 25},
  [1776] = {.lex_state = 107, .external_lex_state = 17},
  [1777] = {.lex_state = 107, .external_lex_state = 18},
  [1778] = {.lex_state = 107, .external_lex_state = 18},
  [1779] = {.lex_state = 107, .external_lex_state = 18},
  [1780] = {.lex_state = 23, .external_lex_state = 25},
  [1781] = {.lex_state = 23, .external_lex_state = 25},
  [1782] = {.lex_state = 107, .external_lex_state = 17},
  [1783] = {.lex_state = 107, .external_lex_state = 17},
  [1784] = {.lex_state = 107, .external_lex_state = 17},
  [1785] = {.lex_state = 107, .external_lex_state = 19},
  [1786] = {.lex_state = 107, .external_lex_state = 19},
  [1787] = {.lex_state = 23, .external_lex_state = 25},
  [1788] = {.lex_state = 107, .external_lex_state = 18},
  [1789] = {.lex_state = 107, .external_lex_state = 18},
  [1790] = {.lex_state = 107, .external_lex_state = 18},
  [1791] = {.lex_state = 107, .external_lex_state = 18},
  [1792] = {.lex_state = 107, .external_lex_state = 19},
  [1793] = {.lex_state = 107, .external_lex_state = 17},
  [1794] = {.lex_state = 107, .external_lex_state = 19},
  [1795] = {.lex_state = 107, .external_lex_state = 19},
  [1796] = {.lex_state = 107, .external_lex_state = 19},
  [1797] = {.lex_state = 107, .external_lex_state = 19},
  [1798] = {.lex_state = 107, .external_lex_state = 19},
  [1799] = {.lex_state = 107, .external_lex_state = 19},
  [1800] = {.lex_state = 107, .external_lex_state = 17},
  [1801] = {.lex_state = 107, .external_lex_state = 17},
  [1802] = {.lex_state = 107, .external_lex_state = 19},
  [1803] = {.lex_state = 107, .external_lex_state = 19},
  [1804] = {.lex_state = 107, .external_lex_state = 19},
  [1805] = {.lex_state = 107, .external_lex_state = 17},
  [1806] = {.lex_state = 23, .external_lex_state = 25},
  [1807] = {.lex_state = 107, .external_lex_state = 18},
  [1808] = {.lex_state = 107, .external_lex_state = 18},
  [1809] = {.lex_state = 107, .external_lex_state = 17},
  [1810] = {.lex_state = 107, .external_lex_state = 17},
  [1811] = {.lex_state = 107, .external_lex_state = 17},
  [1812] = {.lex_state = 107, .external_lex_state = 17},
  [1813] = {.lex_state = 107, .external_lex_state = 17},
  [1814] = {.lex_state = 107, .external_lex_state = 17},
  [1815] = {.lex_state = 107, .external_lex_state = 19},
  [1816] = {.lex_state = 107, .external_lex_state = 17},
  [1817] = {.lex_state = 107, .external_lex_state = 19},
  [1818] = {.lex_state = 107, .external_lex_state = 17},
  [1819] = {.lex_state = 107, .external_lex_state = 18},
  [1820] = {.lex_state = 107, .external_lex_state = 17},
  [1821] = {.lex_state = 107, .external_lex_state = 17},
  [1822] = {.lex_state = 107, .external_lex_state = 17},
  [1823] = {.lex_state = 107, .external_lex_state = 17},
  [1824] = {.lex_state = 107, .external_lex_state = 17},
  [1825] = {.lex_state = 107, .external_lex_state = 17},
  [1826] = {.lex_state = 107, .external_lex_state = 18},
  [1827] = {.lex_state = 23, .external_lex_state = 25},
  [1828] = {.lex_state = 107, .external_lex_state = 19},
  [1829] = {.lex_state = 107, .external_lex_state = 18},
  [1830] = {.lex_state = 107, .external_lex_state = 19},
  [1831] = {.lex_state = 107, .external_lex_state = 18},
  [1832] = {.lex_state = 107, .external_lex_state = 18},
  [1833] = {.lex_state = 107, .external_lex_state = 17},
  [1834] = {.lex_state = 23, .external_lex_state = 25},
  [1835] = {.lex_state = 107, .external_lex_state = 17},
  [1836] = {.lex_state = 23, .external_lex_state = 26},
  [1837] = {.lex_state = 107, .external_lex_state = 19},
  [1838] = {.lex_state = 107, .external_lex_state = 19},
  [1839] = {.lex_state = 23, .external_lex_state = 26},
  [1840] = {.lex_state = 107, .external_lex_state = 19},
  [1841] = {.lex_state = 107, .external_lex_state = 27},
  [1842] = {.lex_state = 107, .external_lex_state = 27},
  [1843] = {.lex_state = 107, .external_lex_state = 19},
  [1844] = {.lex_state = 107, .external_lex_state = 17},
  [1845] = {.lex_state = 107, .external_lex_state = 17},
  [1846] = {.lex_state = 107, .external_lex_state = 17},
  [1847] = {.lex_state = 107, .external_lex_state = 17},
  [1848] = {.lex_state = 107, .external_lex_state = 17},
  [1849] = {.lex_state = 107, .external_lex_state = 19},
  [1850] = {.lex_state = 107, .external_lex_state = 17},
  [1851] = {.lex_state = 107, .external_lex_state = 17},
  [1852] = {.lex_state = 107, .external_lex_state = 19},
  [1853] = {.lex_state = 107, .external_lex_state = 17},
  [1854] = {.lex_state = 107, .external_lex_state = 17},
  [1855] = {.lex_state = 107, .external_lex_state = 17},
  [1856] = {.lex_state = 107, .external_lex_state = 17},
  [1857] = {.lex_state = 107, .external_lex_state = 17},
  [1858] = {.lex_state = 107, .external_lex_state = 17},
  [1859] = {.lex_state = 107, .external_lex_state = 19},
  [1860] = {.lex_state = 107, .external_lex_state = 19},
  [1861] = {.lex_state = 107, .external_lex_state = 19},
  [1862] = {.lex_state = 107, .external_lex_state = 19},
  [1863] = {.lex_state = 107, .external_lex_state = 19},
  [1864] = {.lex_state = 107, .external_lex_state = 19},
  [1865] = {.lex_state = 107, .external_lex_state = 19},
  [1866] = {.lex_state = 107, .external_lex_state = 19},
  [1867] = {.lex_state = 107, .external_lex_state = 17},
  [1868] = {.lex_state = 107, .external_lex_state = 17},
  [1869] = {.lex_state = 107, .external_lex_state = 19},
  [1870] = {.lex_state = 107, .external_lex_state = 17},
  [1871] = {.lex_state = 23, .external_lex_state = 26},
  [1872] = {.lex_state = 107, .external_lex_state = 17},
  [1873] = {.lex_state = 107, .external_lex_state = 19},
  [1874] = {.lex_state = 107, .external_lex_state = 17},
  [1875] = {.lex_state = 107, .external_lex_state = 19},
  [1876] = {.lex_state = 107, .external_lex_state = 17},
  [1877] = {.lex_state = 107, .external_lex_state = 17},
  [1878] = {.lex_state = 107, .external_lex_state = 17},
  [1879] = {.lex_state = 107, .external_lex_state = 17},
  [1880] = {.lex_state = 107, .external_lex_state = 17},
  [1881] = {.lex_state = 107, .external_lex_state = 19},
  [1882] = {.lex_state = 107, .external_lex_state = 17},
  [1883] = {.lex_state = 107, .external_lex_state = 17},
  [1884] = {.lex_state = 107, .external_lex_state = 19},
  [1885] = {.lex_state = 107, .external_lex_state = 19},
  [1886] = {.lex_state = 107, .external_lex_state = 17},
  [1887] = {.lex_state = 107, .external_lex_state = 17},
  [1888] = {.lex_state = 23, .external_lex_state = 26},
  [1889] = {.lex_state = 107, .external_lex_state = 17},
  [1890] = {.lex_state = 107, .external_lex_state = 17},
  [1891] = {.lex_state = 107, .external_lex_state = 19},
  [1892] = {.lex_state = 107, .external_lex_state = 19},
  [1893] = {.lex_state = 107, .external_lex_state = 17},
  [1894] = {.lex_state = 107, .external_lex_state = 17},
  [1895] = {.lex_state = 107, .external_lex_state = 17},
  [1896] = {.lex_state = 107, .external_lex_state = 17},
  [1897] = {.lex_state = 107, .external_lex_state = 17},
  [1898] = {.lex_state = 107, .external_lex_state = 17},
  [1899] = {.lex_state = 107, .external_lex_state = 19},
  [1900] = {.lex_state = 107, .external_lex_state = 19},
  [1901] = {.lex_state = 107, .external_lex_state = 19},
  [1902] = {.lex_state = 107, .external_lex_state = 19},
  [1903] = {.lex_state = 107, .external_lex_state = 17},
  [1904] = {.lex_state = 107, .external_lex_state = 17},
  [1905] = {.lex_state = 107, .external_lex_state = 17},
  [1906] = {.lex_state = 107, .external_lex_state = 17},
  [1907] = {.lex_state = 107, .external_lex_state = 19},
  [1908] = {.lex_state = 107, .external_lex_state = 17},
  [1909] = {.lex_state = 107, .external_lex_state = 17},
  [1910] = {.lex_state = 107, .external_lex_state = 17},
  [1911] = {.lex_state = 107, .external_lex_state = 17},
  [1912] = {.lex_state = 107, .external_lex_state = 17},
  [1913] = {.lex_state = 107, .external_lex_state = 19},
  [1914] = {.lex_state = 107, .external_lex_state = 19},
  [1915] = {.lex_state = 107, .external_lex_state = 17},
  [1916] = {.lex_state = 107, .external_lex_state = 19},
  [1917] = {.lex_state = 107, .external_lex_state = 17},
  [1918] = {.lex_state = 107, .external_lex_state = 17},
  [1919] = {.lex_state = 107, .external_lex_state = 19},
  [1920] = {.lex_state = 107, .external_lex_state = 19},
  [1921] = {.lex_state = 107, .external_lex_state = 19},
  [1922] = {.lex_state = 107, .external_lex_state = 17},
  [1923] = {.lex_state = 107, .external_lex_state = 17},
  [1924] = {.lex_state = 107, .external_lex_state = 19},
  [1925] = {.lex_state = 107, .external_lex_state = 17},
  [1926] = {.lex_state = 107, .external_lex_state = 17},
  [1927] = {.lex_state = 107, .external_lex_state = 19},
  [1928] = {.lex_state = 107, .external_lex_state = 19},
  [1929] = {.lex_state = 107, .external_lex_state = 17},
  [1930] = {.lex_state = 107, .external_lex_state = 17},
  [1931] = {.lex_state = 107, .external_lex_state = 17},
  [1932] = {.lex_state = 107, .external_lex_state = 17},
  [1933] = {.lex_state = 107, .external_lex_state = 19},
  [1934] = {.lex_state = 107, .external_lex_state = 17},
  [1935] = {.lex_state = 107, .external_lex_state = 19},
  [1936] = {.lex_state = 107, .external_lex_state = 17},
  [1937] = {.lex_state = 107, .external_lex_state = 19},
  [1938] = {.lex_state = 107, .external_lex_state = 19},
  [1939] = {.lex_state = 107, .external_lex_state = 17},
  [1940] = {.lex_state = 107, .external_lex_state = 17},
  [1941] = {.lex_state = 107, .external_lex_state = 19},
  [1942] = {.lex_state = 107, .external_lex_state = 17},
  [1943] = {.lex_state = 107, .external_lex_state = 19},
  [1944] = {.lex_state = 107, .external_lex_state = 19},
  [1945] = {.lex_state = 107, .external_lex_state = 17},
  [1946] = {.lex_state = 107, .external_lex_state = 19},
  [1947] = {.lex_state = 107, .external_lex_state = 19},
  [1948] = {.lex_state = 107, .external_lex_state = 19},
  [1949] = {.lex_state = 107, .external_lex_state = 19},
  [1950] = {.lex_state = 107, .external_lex_state = 19},
  [1951] = {.lex_state = 107, .external_lex_state = 19},
  [1952] = {.lex_state = 107, .external_lex_state = 19},
  [1953] = {.lex_state = 107, .external_lex_state = 19},
  [1954] = {.lex_state = 107, .external_lex_state = 19},
  [1955] = {.lex_state = 107, .external_lex_state = 19},
  [1956] = {.lex_state = 107, .external_lex_state = 19},
  [1957] = {.lex_state = 107, .external_lex_state = 19},
  [1958] = {.lex_state = 107, .external_lex_state = 19},
  [1959] = {.lex_state = 107, .external_lex_state = 19},
  [1960] = {.lex_state = 107, .external_lex_state = 19},
  [1961] = {.lex_state = 107, .external_lex_state = 17},
  [1962] = {.lex_state = 107, .external_lex_state = 17},
  [1963] = {.lex_state = 107, .external_lex_state = 17},
  [1964] = {.lex_state = 107, .external_lex_state = 19},
  [1965] = {.lex_state = 107, .external_lex_state = 19},
  [1966] = {.lex_state = 107, .external_lex_state = 17},
  [1967] = {.lex_state = 107, .external_lex_state = 19},
  [1968] = {.lex_state = 107, .external_lex_state = 19},
  [1969] = {.lex_state = 107, .external_lex_state = 19},
  [1970] = {.lex_state = 107, .external_lex_state = 27},
  [1971] = {.lex_state = 107, .external_lex_state = 19},
  [1972] = {.lex_state = 107, .external_lex_state = 19},
  [1973] = {.lex_state = 107, .external_lex_state = 17},
  [1974] = {.lex_state = 107, .external_lex_state = 17},
  [1975] = {.lex_state = 107, .external_lex_state = 17},
  [1976] = {.lex_state = 107, .external_lex_state = 17},
  [1977] = {.lex_state = 107, .external_lex_state = 17},
  [1978] = {.lex_state = 107, .external_lex_state = 17},
  [1979] = {.lex_state = 107, .external_lex_state = 17},
  [1980] = {.lex_state = 107, .external_lex_state = 17},
  [1981] = {.lex_state = 107, .external_lex_state = 17},
  [1982] = {.lex_state = 107, .external_lex_state = 19},
  [1983] = {.lex_state = 107, .external_lex_state = 17},
  [1984] = {.lex_state = 107, .external_lex_state = 19},
  [1985] = {.lex_state = 107, .external_lex_state = 19},
  [1986] = {.lex_state = 107, .external_lex_state = 19},
  [1987] = {.lex_state = 107, .external_lex_state = 19},
  [1988] = {.lex_state = 107, .external_lex_state = 19},
  [1989] = {.lex_state = 107, .external_lex_state = 19},
  [1990] = {.lex_state = 107, .external_lex_state = 17},
  [1991] = {.lex_state = 107, .external_lex_state = 19},
  [1992] = {.lex_state = 107, .external_lex_state = 17},
  [1993] = {.lex_state = 107, .external_lex_state = 17},
  [1994] = {.lex_state = 107, .external_lex_state = 17},
  [1995] = {.lex_state = 107, .external_lex_state = 19},
  [1996] = {.lex_state = 107, .external_lex_state = 27},
  [1997] = {.lex_state = 107, .external_lex_state = 19},
  [1998] = {.lex_state = 107, .external_lex_state = 19},
  [1999] = {.lex_state = 107, .external_lex_state = 17},
  [2000] = {.lex_state = 107, .external_lex_state = 19},
  [2001] = {.lex_state = 107, .external_lex_state = 19},
  [2002] = {.lex_state = 107, .external_lex_state = 17},
  [2003] = {.lex_state = 107, .external_lex_state = 19},
  [2004] = {.lex_state = 107, .external_lex_state = 19},
  [2005] = {.lex_state = 107, .external_lex_state = 19},
  [2006] = {.lex_state = 107, .external_lex_state = 19},
  [2007] = {.lex_state = 107, .external_lex_state = 19},
  [2008] = {.lex_state = 107, .external_lex_state = 19},
  [2009] = {.lex_state = 107, .external_lex_state = 19},
  [2010] = {.lex_state = 107, .external_lex_state = 19},
  [2011] = {.lex_state = 107, .external_lex_state = 19},
  [2012] = {.lex_state = 107, .external_lex_state = 19},
  [2013] = {.lex_state = 107, .external_lex_state = 19},
  [2014] = {.lex_state = 107, .external_lex_state = 19},
  [2015] = {.lex_state = 107, .external_lex_state = 19},
  [2016] = {.lex_state = 107, .external_lex_state = 19},
  [2017] = {.lex_state = 107, .external_lex_state = 19},
  [2018] = {.lex_state = 107, .external_lex_state = 19},
  [2019] = {.lex_state = 107, .external_lex_state = 19},
  [2020] = {.lex_state = 107, .external_lex_state = 19},
  [2021] = {.lex_state = 107, .external_lex_state = 19},
  [2022] = {.lex_state = 107, .external_lex_state = 19},
  [2023] = {.lex_state = 107, .external_lex_state = 19},
  [2024] = {.lex_state = 107, .external_lex_state = 19},
  [2025] = {.lex_state = 107, .external_lex_state = 19},
  [2026] = {.lex_state = 107, .external_lex_state = 19},
  [2027] = {.lex_state = 107, .external_lex_state = 19},
  [2028] = {.lex_state = 107, .external_lex_state = 19},
  [2029] = {.lex_state = 107, .external_lex_state = 19},
  [2030] = {.lex_state = 107, .external_lex_state = 19},
  [2031] = {.lex_state = 107, .external_lex_state = 19},
  [2032] = {.lex_state = 107, .external_lex_state = 19},
  [2033] = {.lex_state = 107, .external_lex_state = 19},
  [2034] = {.lex_state = 107, .external_lex_state = 19},
  [2035] = {.lex_state = 107, .external_lex_state = 19},
  [2036] = {.lex_state = 107, .external_lex_state = 19},
  [2037] = {.lex_state = 107, .external_lex_state = 19},
  [2038] = {.lex_state = 107, .external_lex_state = 19},
  [2039] = {.lex_state = 107, .external_lex_state = 19},
  [2040] = {.lex_state = 107, .external_lex_state = 19},
  [2041] = {.lex_state = 107, .external_lex_state = 19},
  [2042] = {.lex_state = 107, .external_lex_state = 19},
  [2043] = {.lex_state = 107, .external_lex_state = 19},
  [2044] = {.lex_state = 107, .external_lex_state = 19},
  [2045] = {.lex_state = 107, .external_lex_state = 19},
  [2046] = {.lex_state = 107, .external_lex_state = 19},
  [2047] = {.lex_state = 107, .external_lex_state = 19},
  [2048] = {.lex_state = 107, .external_lex_state = 19},
  [2049] = {.lex_state = 107, .external_lex_state = 19},
  [2050] = {.lex_state = 107, .external_lex_state = 19},
  [2051] = {.lex_state = 107, .external_lex_state = 19},
  [2052] = {.lex_state = 107, .external_lex_state = 19},
  [2053] = {.lex_state = 107, .external_lex_state = 19},
  [2054] = {.lex_state = 107, .external_lex_state = 19},
  [2055] = {.lex_state = 107, .external_lex_state = 19},
  [2056] = {.lex_state = 107, .external_lex_state = 19},
  [2057] = {.lex_state = 107, .external_lex_state = 19},
  [2058] = {.lex_state = 107, .external_lex_state = 19},
  [2059] = {.lex_state = 107, .external_lex_state = 19},
  [2060] = {.lex_state = 107, .external_lex_state = 19},
  [2061] = {.lex_state = 107, .external_lex_state = 19},
  [2062] = {.lex_state = 107, .external_lex_state = 19},
  [2063] = {.lex_state = 107, .external_lex_state = 19},
  [2064] = {.lex_state = 107, .external_lex_state = 19},
  [2065] = {.lex_state = 107, .external_lex_state = 19},
  [2066] = {.lex_state = 107, .external_lex_state = 19},
  [2067] = {.lex_state = 107, .external_lex_state = 19},
  [2068] = {.lex_state = 107, .external_lex_state = 19},
  [2069] = {.lex_state = 107, .external_lex_state = 19},
  [2070] = {.lex_state = 107, .external_lex_state = 19},
  [2071] = {.lex_state = 107, .external_lex_state = 19},
  [2072] = {.lex_state = 107, .external_lex_state = 19},
  [2073] = {.lex_state = 107, .external_lex_state = 19},
  [2074] = {.lex_state = 107, .external_lex_state = 19},
  [2075] = {.lex_state = 107, .external_lex_state = 18},
  [2076] = {.lex_state = 107, .external_lex_state = 18},
  [2077] = {.lex_state = 107, .external_lex_state = 18},
  [2078] = {.lex_state = 107, .external_lex_state = 18},
  [2079] = {.lex_state = 107, .external_lex_state = 18},
  [2080] = {.lex_state = 107, .external_lex_state = 18},
  [2081] = {.lex_state = 109, .external_lex_state = 28},
  [2082] = {.lex_state = 109, .external_lex_state = 28},
  [2083] = {.lex_state = 109, .external_lex_state = 28},
  [2084] = {.lex_state = 109, .external_lex_state = 28},
  [2085] = {.lex_state = 109, .external_lex_state = 28},
  [2086] = {.lex_state = 109, .external_lex_state = 28},
  [2087] = {.lex_state = 109, .external_lex_state = 28},
  [2088] = {.lex_state = 109, .external_lex_state = 28},
  [2089] = {.lex_state = 109, .external_lex_state = 28},
  [2090] = {.lex_state = 109, .external_lex_state = 28},
  [2091] = {.lex_state = 100, .external_lex_state = 28},
  [2092] = {.lex_state = 100, .external_lex_state = 28},
  [2093] = {.lex_state = 100, .external_lex_state = 28},
  [2094] = {.lex_state = 100, .external_lex_state = 28},
  [2095] = {.lex_state = 100, .external_lex_state = 28},
  [2096] = {.lex_state = 100, .external_lex_state = 28},
  [2097] = {.lex_state = 100, .external_lex_state = 28},
  [2098] = {.lex_state = 15, .external_lex_state = 28},
  [2099] = {.lex_state = 15, .external_lex_state = 28},
  [2100] = {.lex_state = 100, .external_lex_state = 28},
  [2101] = {.lex_state = 100, .external_lex_state = 28},
  [2102] = {.lex_state = 100, .external_lex_state = 28},
  [2103] = {.lex_state = 100, .external_lex_state = 28},
  [2104] = {.lex_state = 15, .external_lex_state = 28},
  [2105] = {.lex_state = 15, .external_lex_state = 28},
  [2106] = {.lex_state = 100, .external_lex_state = 28},
  [2107] = {.lex_state = 15, .external_lex_state = 28},
  [2108] = {.lex_state = 15, .external_lex_state = 28},
  [2109] = {.lex_state = 100, .external_lex_state = 28},
  [2110] = {.lex_state = 100, .external_lex_state = 28},
  [2111] = {.lex_state = 100, .external_lex_state = 28},
  [2112] = {.lex_state = 100, .external_lex_state = 28},
  [2113] = {.lex_state = 100, .external_lex_state = 28},
  [2114] = {.lex_state = 100, .external_lex_state = 28},
  [2115] = {.lex_state = 100, .external_lex_state = 28},
  [2116] = {.lex_state = 100, .external_lex_state = 28},
  [2117] = {.lex_state = 100, .external_lex_state = 28},
  [2118] = {.lex_state = 100, .external_lex_state = 28},
  [2119] = {.lex_state = 109, .external_lex_state = 28},
  [2120] = {.lex_state = 100, .external_lex_state = 28},
  [2121] = {.lex_state = 100, .external_lex_state = 28},
  [2122] = {.lex_state = 100, .external_lex_state = 28},
  [2123] = {.lex_state = 100, .external_lex_state = 28},
  [2124] = {.lex_state = 100, .external_lex_state = 28},
  [2125] = {.lex_state = 15, .external_lex_state = 29},
  [2126] = {.lex_state = 100, .external_lex_state = 28},
  [2127] = {.lex_state = 15, .external_lex_state = 29},
  [2128] = {.lex_state = 100, .external_lex_state = 28},
  [2129] = {.lex_state = 100, .external_lex_state = 28},
  [2130] = {.lex_state = 100, .external_lex_state = 28},
  [2131] = {.lex_state = 100, .external_lex_state = 28},
  [2132] = {.lex_state = 100, .external_lex_state = 28},
  [2133] = {.lex_state = 108, .external_lex_state = 28},
  [2134] = {.lex_state = 15, .external_lex_state = 29},
  [2135] = {.lex_state = 100, .external_lex_state = 28},
  [2136] = {.lex_state = 100, .external_lex_state = 28},
  [2137] = {.lex_state = 100, .external_lex_state = 28},
  [2138] = {.lex_state = 100, .external_lex_state = 28},
  [2139] = {.lex_state = 100, .external_lex_state = 28},
  [2140] = {.lex_state = 15},
  [2141] = {.lex_state = 15, .external_lex_state = 28},
  [2142] = {.lex_state = 15, .external_lex_state = 28},
  [2143] = {.lex_state = 15, .external_lex_state = 28},
  [2144] = {.lex_state = 15, .external_lex_state = 29},
  [2145] = {.lex_state = 15, .external_lex_state = 29},
  [2146] = {.lex_state = 15, .external_lex_state = 29},
  [2147] = {.lex_state = 100, .external_lex_state = 28},
  [2148] = {.lex_state = 15, .external_lex_state = 29},
  [2149] = {.lex_state = 15, .external_lex_state = 30},
  [2150] = {.lex_state = 15, .external_lex_state = 29},
  [2151] = {.lex_state = 109, .external_lex_state = 28},
  [2152] = {.lex_state = 109, .external_lex_state = 28},
  [2153] = {.lex_state = 15, .external_lex_state = 29},
  [2154] = {.lex_state = 109, .external_lex_state = 28},
  [2155] = {.lex_state = 100, .external_lex_state = 28},
  [2156] = {.lex_state = 109, .external_lex_state = 30},
  [2157] = {.lex_state = 28, .external_lex_state = 29},
  [2158] = {.lex_state = 109, .external_lex_state = 28},
  [2159] = {.lex_state = 109, .external_lex_state = 28},
  [2160] = {.lex_state = 15, .external_lex_state = 29},
  [2161] = {.lex_state = 109, .external_lex_state = 28},
  [2162] = {.lex_state = 15, .external_lex_state = 29},
  [2163] = {.lex_state = 15, .external_lex_state = 29},
  [2164] = {.lex_state = 109, .external_lex_state = 28},
  [2165] = {.lex_state = 15, .external_lex_state = 29},
  [2166] = {.lex_state = 15, .external_lex_state = 29},
  [2167] = {.lex_state = 109, .external_lex_state = 30},
  [2168] = {.lex_state = 15, .external_lex_state = 29},
  [2169] = {.lex_state = 15, .external_lex_state = 29},
  [2170] = {.lex_state = 109, .external_lex_state = 28},
  [2171] = {.lex_state = 109, .external_lex_state = 28},
  [2172] = {.lex_state = 28, .external_lex_state = 29},
  [2173] = {.lex_state = 109, .external_lex_state = 28},
  [2174] = {.lex_state = 109, .external_lex_state = 28},
  [2175] = {.lex_state = 109, .external_lex_state = 28},
  [2176] = {.lex_state = 109, .external_lex_state = 28},
  [2177] = {.lex_state = 28, .external_lex_state = 29},
  [2178] = {.lex_state = 100},
  [2179] = {.lex_state = 28, .external_lex_state = 29},
  [2180] = {.lex_state = 100},
  [2181] = {.lex_state = 100, .external_lex_state = 28},
  [2182] = {.lex_state = 28, .external_lex_state = 29},
  [2183] = {.lex_state = 100, .external_lex_state = 28},
  [2184] = {.lex_state = 100},
  [2185] = {.lex_state = 28, .external_lex_state = 29},
  [2186] = {.lex_state = 100, .external_lex_state = 28},
  [2187] = {.lex_state = 28, .external_lex_state = 29},
  [2188] = {.lex_state = 109, .external_lex_state = 28},
  [2189] = {.lex_state = 109, .external_lex_state = 28},
  [2190] = {.lex_state = 28, .external_lex_state = 29},
  [2191] = {.lex_state = 100},
  [2192] = {.lex_state = 100},
  [2193] = {.lex_state = 109, .external_lex_state = 30},
  [2194] = {.lex_state = 100, .external_lex_state = 28},
  [2195] = {.lex_state = 100, .external_lex_state = 28},
  [2196] = {.lex_state = 100, .external_lex_state = 28},
  [2197] = {.lex_state = 100, .external_lex_state = 28},
  [2198] = {.lex_state = 109, .external_lex_state = 28},
  [2199] = {.lex_state = 100, .external_lex_state = 28},
  [2200] = {.lex_state = 28, .external_lex_state = 29},
  [2201] = {.lex_state = 100, .external_lex_state = 28},
  [2202] = {.lex_state = 108, .external_lex_state = 28},
  [2203] = {.lex_state = 100, .external_lex_state = 28},
  [2204] = {.lex_state = 100, .external_lex_state = 28},
  [2205] = {.lex_state = 100, .external_lex_state = 28},
  [2206] = {.lex_state = 109, .external_lex_state = 28},
  [2207] = {.lex_state = 100, .external_lex_state = 28},
  [2208] = {.lex_state = 100, .external_lex_state = 28},
  [2209] = {.lex_state = 100, .external_lex_state = 28},
  [2210] = {.lex_state = 100, .external_lex_state = 28},
  [2211] = {.lex_state = 100, .external_lex_state = 28},
  [2212] = {.lex_state = 109, .external_lex_state = 28},
  [2213] = {.lex_state = 100, .external_lex_state = 28},
  [2214] = {.lex_state = 100, .external_lex_state = 28},
  [2215] = {.lex_state = 27, .external_lex_state = 28},
  [2216] = {.lex_state = 109, .external_lex_state = 28},
  [2217] = {.lex_state = 100, .external_lex_state = 28},
  [2218] = {.lex_state = 100},
  [2219] = {.lex_state = 100, .external_lex_state = 28},
  [2220] = {.lex_state = 109, .external_lex_state = 30},
  [2221] = {.lex_state = 109, .external_lex_state = 28},
  [2222] = {.lex_state = 100, .external_lex_state = 28},
  [2223] = {.lex_state = 100, .external_lex_state = 28},
  [2224] = {.lex_state = 100},
  [2225] = {.lex_state = 100, .external_lex_state = 30},
  [2226] = {.lex_state = 100},
  [2227] = {.lex_state = 100},
  [2228] = {.lex_state = 100},
  [2229] = {.lex_state = 100},
  [2230] = {.lex_state = 100},
  [2231] = {.lex_state = 100},
  [2232] = {.lex_state = 100},
  [2233] = {.lex_state = 100},
  [2234] = {.lex_state = 100},
  [2235] = {.lex_state = 100},
  [2236] = {.lex_state = 100},
  [2237] = {.lex_state = 15, .external_lex_state = 28},
  [2238] = {.lex_state = 100},
  [2239] = {.lex_state = 100},
  [2240] = {.lex_state = 100},
  [2241] = {.lex_state = 100, .external_lex_state = 30},
  [2242] = {.lex_state = 100, .external_lex_state = 29},
  [2243] = {.lex_state = 28, .external_lex_state = 29},
  [2244] = {.lex_state = 100, .external_lex_state = 29},
  [2245] = {.lex_state = 100, .external_lex_state = 29},
  [2246] = {.lex_state = 100, .external_lex_state = 29},
  [2247] = {.lex_state = 100, .external_lex_state = 29},
  [2248] = {.lex_state = 28, .external_lex_state = 29},
  [2249] = {.lex_state = 100, .external_lex_state = 28},
  [2250] = {.lex_state = 28, .external_lex_state = 29},
  [2251] = {.lex_state = 25, .external_lex_state = 31},
  [2252] = {.lex_state = 28, .external_lex_state = 29},
  [2253] = {.lex_state = 25, .external_lex_state = 31},
  [2254] = {.lex_state = 28, .external_lex_state = 29},
  [2255] = {.lex_state = 28, .external_lex_state = 29},
  [2256] = {.lex_state = 28, .external_lex_state = 29},
  [2257] = {.lex_state = 28, .external_lex_state = 29},
  [2258] = {.lex_state = 28, .external_lex_state = 29},
  [2259] = {.lex_state = 100, .external_lex_state = 29},
  [2260] = {.lex_state = 100, .external_lex_state = 29},
  [2261] = {.lex_state = 27, .external_lex_state = 28},
  [2262] = {.lex_state = 25, .external_lex_state = 31},
  [2263] = {.lex_state = 25, .external_lex_state = 31},
  [2264] = {.lex_state = 100, .external_lex_state = 29},
  [2265] = {.lex_state = 100, .external_lex_state = 29},
  [2266] = {.lex_state = 25, .external_lex_state = 31},
  [2267] = {.lex_state = 100, .external_lex_state = 29},
  [2268] = {.lex_state = 28, .external_lex_state = 29},
  [2269] = {.lex_state = 25, .external_lex_state = 31},
  [2270] = {.lex_state = 100, .external_lex_state = 29},
  [2271] = {.lex_state = 100, .external_lex_state = 29},
  [2272] = {.lex_state = 100, .external_lex_state = 29},
  [2273] = {.lex_state = 28, .external_lex_state = 29},
  [2274] = {.lex_state = 28, .external_lex_state = 29},
  [2275] = {.lex_state = 100, .external_lex_state = 29},
  [2276] = {.lex_state = 100, .external_lex_state = 29},
  [2277] = {.lex_state = 100, .external_lex_state = 29},
  [2278] = {.lex_state = 28, .external_lex_state = 29},
  [2279] = {.lex_state = 100, .external_lex_state = 29},
  [2280] = {.lex_state = 28, .external_lex_state = 29},
  [2281] = {.lex_state = 25, .external_lex_state = 31},
  [2282] = {.lex_state = 100, .external_lex_state = 29},
  [2283] = {.lex_state = 100, .external_lex_state = 29},
  [2284] = {.lex_state = 28, .external_lex_state = 29},
  [2285] = {.lex_state = 100, .external_lex_state = 29},
  [2286] = {.lex_state = 25, .external_lex_state = 31},
  [2287] = {.lex_state = 100, .external_lex_state = 29},
  [2288] = {.lex_state = 100, .external_lex_state = 29},
  [2289] = {.lex_state = 25, .external_lex_state = 31},
  [2290] = {.lex_state = 100, .external_lex_state = 29},
  [2291] = {.lex_state = 100, .external_lex_state = 29},
  [2292] = {.lex_state = 25, .external_lex_state = 31},
  [2293] = {.lex_state = 100, .external_lex_state = 29},
  [2294] = {.lex_state = 28, .external_lex_state = 29},
  [2295] = {.lex_state = 28, .external_lex_state = 29},
  [2296] = {.lex_state = 25, .external_lex_state = 31},
  [2297] = {.lex_state = 100, .external_lex_state = 29},
  [2298] = {.lex_state = 100, .external_lex_state = 29},
  [2299] = {.lex_state = 100, .external_lex_state = 29},
  [2300] = {.lex_state = 100, .external_lex_state = 29},
  [2301] = {.lex_state = 100, .external_lex_state = 29},
  [2302] = {.lex_state = 28, .external_lex_state = 29},
  [2303] = {.lex_state = 100, .external_lex_state = 29},
  [2304] = {.lex_state = 28, .external_lex_state = 29},
  [2305] = {.lex_state = 100, .external_lex_state = 29},
  [2306] = {.lex_state = 100, .external_lex_state = 29},
  [2307] = {.lex_state = 100, .external_lex_state = 29},
  [2308] = {.lex_state = 25, .external_lex_state = 31},
  [2309] = {.lex_state = 100, .external_lex_state = 29},
  [2310] = {.lex_state = 100, .external_lex_state = 28},
  [2311] = {.lex_state = 100, .external_lex_state = 29},
  [2312] = {.lex_state = 28, .external_lex_state = 29},
  [2313] = {.lex_state = 28, .external_lex_state = 29},
  [2314] = {.lex_state = 100, .external_lex_state = 29},
  [2315] = {.lex_state = 28, .external_lex_state = 29},
  [2316] = {.lex_state = 25, .external_lex_state = 31},
  [2317] = {.lex_state = 100, .external_lex_state = 29},
  [2318] = {.lex_state = 100, .external_lex_state = 29},
  [2319] = {.lex_state = 100},
  [2320] = {.lex_state = 100},
  [2321] = {.lex_state = 25, .external_lex_state = 31},
  [2322] = {.lex_state = 25, .external_lex_state = 31},
  [2323] = {.lex_state = 100},
  [2324] = {.lex_state = 100, .external_lex_state = 28},
  [2325] = {.lex_state = 100},
  [2326] = {.lex_state = 109, .external_lex_state = 32},
  [2327] = {.lex_state = 25, .external_lex_state = 33},
  [2328] = {.lex_state = 25, .external_lex_state = 31},
  [2329] = {.lex_state = 25, .external_lex_state = 31},
  [2330] = {.lex_state = 25, .external_lex_state = 33},
  [2331] = {.lex_state = 109, .external_lex_state = 32},
  [2332] = {.lex_state = 109, .external_lex_state = 28},
  [2333] = {.lex_state = 25, .external_lex_state = 31},
  [2334] = {.lex_state = 100},
  [2335] = {.lex_state = 108},
  [2336] = {.lex_state = 25, .external_lex_state = 31},
  [2337] = {.lex_state = 100},
  [2338] = {.lex_state = 100},
  [2339] = {.lex_state = 100, .external_lex_state = 28},
  [2340] = {.lex_state = 100},
  [2341] = {.lex_state = 100},
  [2342] = {.lex_state = 25, .external_lex_state = 31},
  [2343] = {.lex_state = 25, .external_lex_state = 31},
  [2344] = {.lex_state = 100},
  [2345] = {.lex_state = 109, .external_lex_state = 28},
  [2346] = {.lex_state = 109, .external_lex_state = 28},
  [2347] = {.lex_state = 109, .external_lex_state = 28},
  [2348] = {.lex_state = 100},
  [2349] = {.lex_state = 100},
  [2350] = {.lex_state = 100},
  [2351] = {.lex_state = 100},
  [2352] = {.lex_state = 100},
  [2353] = {.lex_state = 109, .external_lex_state = 28},
  [2354] = {.lex_state = 25, .external_lex_state = 31},
  [2355] = {.lex_state = 109, .external_lex_state = 28},
  [2356] = {.lex_state = 109, .external_lex_state = 28},
  [2357] = {.lex_state = 109, .external_lex_state = 28},
  [2358] = {.lex_state = 25, .external_lex_state = 31},
  [2359] = {.lex_state = 100},
  [2360] = {.lex_state = 109, .external_lex_state = 28},
  [2361] = {.lex_state = 100},
  [2362] = {.lex_state = 109, .external_lex_state = 28},
  [2363] = {.lex_state = 100},
  [2364] = {.lex_state = 100},
  [2365] = {.lex_state = 25, .external_lex_state = 31},
  [2366] = {.lex_state = 100},
  [2367] = {.lex_state = 100},
  [2368] = {.lex_state = 100},
  [2369] = {.lex_state = 100},
  [2370] = {.lex_state = 100},
  [2371] = {.lex_state = 100},
  [2372] = {.lex_state = 100},
  [2373] = {.lex_state = 100},
  [2374] = {.lex_state = 25, .external_lex_state = 33},
  [2375] = {.lex_state = 25, .external_lex_state = 33},
  [2376] = {.lex_state = 109, .external_lex_state = 28},
  [2377] = {.lex_state = 25, .external_lex_state = 31},
  [2378] = {.lex_state = 100},
  [2379] = {.lex_state = 100},
  [2380] = {.lex_state = 109, .external_lex_state = 32},
  [2381] = {.lex_state = 25, .external_lex_state = 31},
  [2382] = {.lex_state = 100, .external_lex_state = 28},
  [2383] = {.lex_state = 100},
  [2384] = {.lex_state = 109, .external_lex_state = 29},
  [2385] = {.lex_state = 100},
  [2386] = {.lex_state = 100},
  [2387] = {.lex_state = 100},
  [2388] = {.lex_state = 25, .external_lex_state = 31},
  [2389] = {.lex_state = 100, .external_lex_state = 29},
  [2390] = {.lex_state = 100, .external_lex_state = 29},
  [2391] = {.lex_state = 109, .external_lex_state = 29},
  [2392] = {.lex_state = 26, .external_lex_state = 31},
  [2393] = {.lex_state = 26, .external_lex_state = 31},
  [2394] = {.lex_state = 100, .external_lex_state = 29},
  [2395] = {.lex_state = 26, .external_lex_state = 31},
  [2396] = {.lex_state = 100, .external_lex_state = 29},
  [2397] = {.lex_state = 26, .external_lex_state = 31},
  [2398] = {.lex_state = 100, .external_lex_state = 29},
  [2399] = {.lex_state = 26, .external_lex_state = 31},
  [2400] = {.lex_state = 26, .external_lex_state = 31},
  [2401] = {.lex_state = 26, .external_lex_state = 31},
  [2402] = {.lex_state = 26, .external_lex_state = 31},
  [2403] = {.lex_state = 26, .external_lex_state = 31},
  [2404] = {.lex_state = 26, .external_lex_state = 31},
  [2405] = {.lex_state = 100, .external_lex_state = 29},
  [2406] = {.lex_state = 26, .external_lex_state = 31},
  [2407] = {.lex_state = 100, .external_lex_state = 29},
  [2408] = {.lex_state = 100, .external_lex_state = 29},
  [2409] = {.lex_state = 26, .external_lex_state = 31},
  [2410] = {.lex_state = 26, .external_lex_state = 31},
  [2411] = {.lex_state = 100, .external_lex_state = 29},
  [2412] = {.lex_state = 26, .external_lex_state = 31},
  [2413] = {.lex_state = 26, .external_lex_state = 31},
  [2414] = {.lex_state = 26, .external_lex_state = 31},
  [2415] = {.lex_state = 100},
  [2416] = {.lex_state = 26, .external_lex_state = 31},
  [2417] = {.lex_state = 26, .external_lex_state = 31},
  [2418] = {.lex_state = 26, .external_lex_state = 31},
  [2419] = {.lex_state = 100},
  [2420] = {.lex_state = 26, .external_lex_state = 31},
  [2421] = {.lex_state = 26, .external_lex_state = 31},
  [2422] = {.lex_state = 100, .external_lex_state = 29},
  [2423] = {.lex_state = 26, .external_lex_state = 31},
  [2424] = {.lex_state = 26, .external_lex_state = 31},
  [2425] = {.lex_state = 26, .external_lex_state = 31},
  [2426] = {.lex_state = 109, .external_lex_state = 29},
  [2427] = {.lex_state = 26, .external_lex_state = 31},
  [2428] = {.lex_state = 26, .external_lex_state = 31},
  [2429] = {.lex_state = 26, .external_lex_state = 31},
  [2430] = {.lex_state = 26, .external_lex_state = 31},
  [2431] = {.lex_state = 100, .external_lex_state = 28},
  [2432] = {.lex_state = 26, .external_lex_state = 31},
  [2433] = {.lex_state = 26, .external_lex_state = 31},
  [2434] = {.lex_state = 25, .external_lex_state = 33},
  [2435] = {.lex_state = 100, .external_lex_state = 29},
  [2436] = {.lex_state = 26, .external_lex_state = 31},
  [2437] = {.lex_state = 26, .external_lex_state = 31},
  [2438] = {.lex_state = 26, .external_lex_state = 31},
  [2439] = {.lex_state = 26, .external_lex_state = 31},
  [2440] = {.lex_state = 26, .external_lex_state = 31},
  [2441] = {.lex_state = 25, .external_lex_state = 33},
  [2442] = {.lex_state = 26, .external_lex_state = 31},
  [2443] = {.lex_state = 25, .external_lex_state = 33},
  [2444] = {.lex_state = 100, .external_lex_state = 29},
  [2445] = {.lex_state = 26, .external_lex_state = 31},
  [2446] = {.lex_state = 100},
  [2447] = {.lex_state = 100, .external_lex_state = 29},
  [2448] = {.lex_state = 26, .external_lex_state = 31},
  [2449] = {.lex_state = 100, .external_lex_state = 29},
  [2450] = {.lex_state = 26, .external_lex_state = 31},
  [2451] = {.lex_state = 100, .external_lex_state = 29},
  [2452] = {.lex_state = 109, .external_lex_state = 29},
  [2453] = {.lex_state = 100, .external_lex_state = 29},
  [2454] = {.lex_state = 26, .external_lex_state = 31},
  [2455] = {.lex_state = 26, .external_lex_state = 31},
  [2456] = {.lex_state = 100, .external_lex_state = 28},
  [2457] = {.lex_state = 100, .external_lex_state = 29},
  [2458] = {.lex_state = 100, .external_lex_state = 28},
  [2459] = {.lex_state = 25, .external_lex_state = 33},
  [2460] = {.lex_state = 26, .external_lex_state = 31},
  [2461] = {.lex_state = 100, .external_lex_state = 29},
  [2462] = {.lex_state = 26, .external_lex_state = 31},
  [2463] = {.lex_state = 26, .external_lex_state = 31},
  [2464] = {.lex_state = 26, .external_lex_state = 31},
  [2465] = {.lex_state = 26, .external_lex_state = 31},
  [2466] = {.lex_state = 100, .external_lex_state = 29},
  [2467] = {.lex_state = 100, .external_lex_state = 29},
  [2468] = {.lex_state = 100, .external_lex_state = 29},
  [2469] = {.lex_state = 100, .external_lex_state = 29},
  [2470] = {.lex_state = 100, .external_lex_state = 29},
  [2471] = {.lex_state = 26, .external_lex_state = 31},
  [2472] = {.lex_state = 100},
  [2473] = {.lex_state = 109, .external_lex_state = 29},
  [2474] = {.lex_state = 100},
  [2475] = {.lex_state = 100, .external_lex_state = 29},
  [2476] = {.lex_state = 26, .external_lex_state = 31},
  [2477] = {.lex_state = 100, .external_lex_state = 29},
  [2478] = {.lex_state = 100},
  [2479] = {.lex_state = 26, .external_lex_state = 31},
  [2480] = {.lex_state = 26, .external_lex_state = 31},
  [2481] = {.lex_state = 26, .external_lex_state = 31},
  [2482] = {.lex_state = 26, .external_lex_state = 31},
  [2483] = {.lex_state = 26, .external_lex_state = 31},
  [2484] = {.lex_state = 109, .external_lex_state = 29},
  [2485] = {.lex_state = 26, .external_lex_state = 31},
  [2486] = {.lex_state = 26, .external_lex_state = 31},
  [2487] = {.lex_state = 26, .external_lex_state = 31},
  [2488] = {.lex_state = 109, .external_lex_state = 29},
  [2489] = {.lex_state = 26, .external_lex_state = 31},
  [2490] = {.lex_state = 100, .external_lex_state = 29},
  [2491] = {.lex_state = 100, .external_lex_state = 28},
  [2492] = {.lex_state = 100, .external_lex_state = 29},
  [2493] = {.lex_state = 26, .external_lex_state = 33},
  [2494] = {.lex_state = 26, .external_lex_state = 33},
  [2495] = {.lex_state = 26, .external_lex_state = 34},
  [2496] = {.lex_state = 109, .external_lex_state = 29},
  [2497] = {.lex_state = 100, .external_lex_state = 29},
  [2498] = {.lex_state = 26, .external_lex_state = 33},
  [2499] = {.lex_state = 26, .external_lex_state = 33},
  [2500] = {.lex_state = 26, .external_lex_state = 33},
  [2501] = {.lex_state = 100, .external_lex_state = 29},
  [2502] = {.lex_state = 100, .external_lex_state = 28},
  [2503] = {.lex_state = 26, .external_lex_state = 33},
  [2504] = {.lex_state = 109, .external_lex_state = 32},
  [2505] = {.lex_state = 109, .external_lex_state = 32},
  [2506] = {.lex_state = 100, .external_lex_state = 28},
  [2507] = {.lex_state = 26, .external_lex_state = 33},
  [2508] = {.lex_state = 30, .external_lex_state = 29},
  [2509] = {.lex_state = 100},
  [2510] = {.lex_state = 25, .external_lex_state = 31},
  [2511] = {.lex_state = 26, .external_lex_state = 33},
  [2512] = {.lex_state = 100, .external_lex_state = 29},
  [2513] = {.lex_state = 100, .external_lex_state = 29},
  [2514] = {.lex_state = 30, .external_lex_state = 29},
  [2515] = {.lex_state = 26, .external_lex_state = 33},
  [2516] = {.lex_state = 26, .external_lex_state = 33},
  [2517] = {.lex_state = 26, .external_lex_state = 33},
  [2518] = {.lex_state = 100, .external_lex_state = 28},
  [2519] = {.lex_state = 100},
  [2520] = {.lex_state = 100},
  [2521] = {.lex_state = 26, .external_lex_state = 33},
  [2522] = {.lex_state = 100, .external_lex_state = 29},
  [2523] = {.lex_state = 25, .external_lex_state = 31},
  [2524] = {.lex_state = 100, .external_lex_state = 29},
  [2525] = {.lex_state = 100},
  [2526] = {.lex_state = 100},
  [2527] = {.lex_state = 108, .external_lex_state = 29},
  [2528] = {.lex_state = 100, .external_lex_state = 28},
  [2529] = {.lex_state = 100, .external_lex_state = 29},
  [2530] = {.lex_state = 26, .external_lex_state = 34},
  [2531] = {.lex_state = 26, .external_lex_state = 33},
  [2532] = {.lex_state = 26, .external_lex_state = 33},
  [2533] = {.lex_state = 100, .external_lex_state = 28},
  [2534] = {.lex_state = 100, .external_lex_state = 29},
  [2535] = {.lex_state = 26, .external_lex_state = 33},
  [2536] = {.lex_state = 26, .external_lex_state = 33},
  [2537] = {.lex_state = 100},
  [2538] = {.lex_state = 100},
  [2539] = {.lex_state = 100},
  [2540] = {.lex_state = 26, .external_lex_state = 33},
  [2541] = {.lex_state = 26, .external_lex_state = 35},
  [2542] = {.lex_state = 30, .external_lex_state = 28},
  [2543] = {.lex_state = 26, .external_lex_state = 35},
  [2544] = {.lex_state = 109, .external_lex_state = 32},
  [2545] = {.lex_state = 100},
  [2546] = {.lex_state = 26, .external_lex_state = 33},
  [2547] = {.lex_state = 26, .external_lex_state = 34},
  [2548] = {.lex_state = 108, .external_lex_state = 29},
  [2549] = {.lex_state = 100},
  [2550] = {.lex_state = 100, .external_lex_state = 28},
  [2551] = {.lex_state = 108, .external_lex_state = 29},
  [2552] = {.lex_state = 109, .external_lex_state = 29},
  [2553] = {.lex_state = 100},
  [2554] = {.lex_state = 100, .external_lex_state = 28},
  [2555] = {.lex_state = 100, .external_lex_state = 29},
  [2556] = {.lex_state = 100, .external_lex_state = 29},
  [2557] = {.lex_state = 100, .external_lex_state = 29},
  [2558] = {.lex_state = 100, .external_lex_state = 29},
  [2559] = {.lex_state = 109, .external_lex_state = 29},
  [2560] = {.lex_state = 100, .external_lex_state = 29},
  [2561] = {.lex_state = 109, .external_lex_state = 29},
  [2562] = {.lex_state = 100, .external_lex_state = 29},
  [2563] = {.lex_state = 109, .external_lex_state = 29},
  [2564] = {.lex_state = 30, .external_lex_state = 29},
  [2565] = {.lex_state = 109, .external_lex_state = 29},
  [2566] = {.lex_state = 100, .external_lex_state = 29},
  [2567] = {.lex_state = 109, .external_lex_state = 29},
  [2568] = {.lex_state = 109, .external_lex_state = 29},
  [2569] = {.lex_state = 109, .external_lex_state = 29},
  [2570] = {.lex_state = 109, .external_lex_state = 29},
  [2571] = {.lex_state = 100, .external_lex_state = 29},
  [2572] = {.lex_state = 109, .external_lex_state = 29},
  [2573] = {.lex_state = 109, .external_lex_state = 29},
  [2574] = {.lex_state = 109, .external_lex_state = 29},
  [2575] = {.lex_state = 100, .external_lex_state = 28},
  [2576] = {.lex_state = 100, .external_lex_state = 29},
  [2577] = {.lex_state = 109, .external_lex_state = 29},
  [2578] = {.lex_state = 100, .external_lex_state = 29},
  [2579] = {.lex_state = 109, .external_lex_state = 29},
  [2580] = {.lex_state = 100, .external_lex_state = 29},
  [2581] = {.lex_state = 109, .external_lex_state = 29},
  [2582] = {.lex_state = 109, .external_lex_state = 29},
  [2583] = {.lex_state = 109, .external_lex_state = 29},
  [2584] = {.lex_state = 109, .external_lex_state = 29},
  [2585] = {.lex_state = 100, .external_lex_state = 28},
  [2586] = {.lex_state = 109, .external_lex_state = 29},
  [2587] = {.lex_state = 100, .external_lex_state = 29},
  [2588] = {.lex_state = 109, .external_lex_state = 29},
  [2589] = {.lex_state = 109, .external_lex_state = 29},
  [2590] = {.lex_state = 109, .external_lex_state = 29},
  [2591] = {.lex_state = 109, .external_lex_state = 29},
  [2592] = {.lex_state = 109, .external_lex_state = 29},
  [2593] = {.lex_state = 109, .external_lex_state = 29},
  [2594] = {.lex_state = 109, .external_lex_state = 29},
  [2595] = {.lex_state = 26, .external_lex_state = 31},
  [2596] = {.lex_state = 109, .external_lex_state = 29},
  [2597] = {.lex_state = 109, .external_lex_state = 29},
  [2598] = {.lex_state = 26, .external_lex_state = 31},
  [2599] = {.lex_state = 109, .external_lex_state = 29},
  [2600] = {.lex_state = 109, .external_lex_state = 29},
  [2601] = {.lex_state = 109, .external_lex_state = 29},
  [2602] = {.lex_state = 109, .external_lex_state = 29},
  [2603] = {.lex_state = 100, .external_lex_state = 29},
  [2604] = {.lex_state = 109, .external_lex_state = 29},
  [2605] = {.lex_state = 109, .external_lex_state = 29},
  [2606] = {.lex_state = 109, .external_lex_state = 29},
  [2607] = {.lex_state = 100, .external_lex_state = 29},
  [2608] = {.lex_state = 109, .external_lex_state = 29},
  [2609] = {.lex_state = 109, .external_lex_state = 29},
  [2610] = {.lex_state = 109, .external_lex_state = 29},
  [2611] = {.lex_state = 109, .external_lex_state = 29},
  [2612] = {.lex_state = 109, .external_lex_state = 29},
  [2613] = {.lex_state = 109, .external_lex_state = 29},
  [2614] = {.lex_state = 109, .external_lex_state = 29},
  [2615] = {.lex_state = 109, .external_lex_state = 29},
  [2616] = {.lex_state = 109, .external_lex_state = 29},
  [2617] = {.lex_state = 109, .external_lex_state = 29},
  [2618] = {.lex_state = 109, .external_lex_state = 29},
  [2619] = {.lex_state = 100, .external_lex_state = 29},
  [2620] = {.lex_state = 100, .external_lex_state = 29},
  [2621] = {.lex_state = 108, .external_lex_state = 29},
  [2622] = {.lex_state = 109, .external_lex_state = 29},
  [2623] = {.lex_state = 109, .external_lex_state = 29},
  [2624] = {.lex_state = 100, .external_lex_state = 29},
  [2625] = {.lex_state = 109, .external_lex_state = 29},
  [2626] = {.lex_state = 100, .external_lex_state = 29},
  [2627] = {.lex_state = 100, .external_lex_state = 29},
  [2628] = {.lex_state = 109, .external_lex_state = 29},
  [2629] = {.lex_state = 100, .external_lex_state = 29},
  [2630] = {.lex_state = 100, .external_lex_state = 29},
  [2631] = {.lex_state = 109, .external_lex_state = 29},
  [2632] = {.lex_state = 109, .external_lex_state = 29},
  [2633] = {.lex_state = 109, .external_lex_state = 29},
  [2634] = {.lex_state = 100, .external_lex_state = 29},
  [2635] = {.lex_state = 109, .external_lex_state = 29},
  [2636] = {.lex_state = 109, .external_lex_state = 29},
  [2637] = {.lex_state = 109, .external_lex_state = 29},
  [2638] = {.lex_state = 109, .external_lex_state = 29},
  [2639] = {.lex_state = 109, .external_lex_state = 29},
  [2640] = {.lex_state = 109, .external_lex_state = 29},
  [2641] = {.lex_state = 109, .external_lex_state = 29},
  [2642] = {.lex_state = 109, .external_lex_state = 29},
  [2643] = {.lex_state = 100, .external_lex_state = 28},
  [2644] = {.lex_state = 100, .external_lex_state = 29},
  [2645] = {.lex_state = 109, .external_lex_state = 29},
  [2646] = {.lex_state = 109, .external_lex_state = 29},
  [2647] = {.lex_state = 109, .external_lex_state = 29},
  [2648] = {.lex_state = 109, .external_lex_state = 29},
  [2649] = {.lex_state = 109, .external_lex_state = 29},
  [2650] = {.lex_state = 109, .external_lex_state = 29},
  [2651] = {.lex_state = 109, .external_lex_state = 29},
  [2652] = {.lex_state = 100, .external_lex_state = 28},
  [2653] = {.lex_state = 100, .external_lex_state = 28},
  [2654] = {.lex_state = 109, .external_lex_state = 29},
  [2655] = {.lex_state = 108, .external_lex_state = 29},
  [2656] = {.lex_state = 100, .external_lex_state = 29},
  [2657] = {.lex_state = 109, .external_lex_state = 29},
  [2658] = {.lex_state = 100, .external_lex_state = 28},
  [2659] = {.lex_state = 109, .external_lex_state = 29},
  [2660] = {.lex_state = 109, .external_lex_state = 29},
  [2661] = {.lex_state = 109, .external_lex_state = 29},
  [2662] = {.lex_state = 109, .external_lex_state = 29},
  [2663] = {.lex_state = 109, .external_lex_state = 29},
  [2664] = {.lex_state = 109, .external_lex_state = 29},
  [2665] = {.lex_state = 109, .external_lex_state = 29},
  [2666] = {.lex_state = 109, .external_lex_state = 29},
  [2667] = {.lex_state = 100},
  [2668] = {.lex_state = 109, .external_lex_state = 29},
  [2669] = {.lex_state = 100, .external_lex_state = 30},
  [2670] = {.lex_state = 100, .external_lex_state = 29},
  [2671] = {.lex_state = 100, .external_lex_state = 29},
  [2672] = {.lex_state = 100, .external_lex_state = 28},
  [2673] = {.lex_state = 100, .external_lex_state = 29},
  [2674] = {.lex_state = 100, .external_lex_state = 28},
  [2675] = {.lex_state = 100, .external_lex_state = 28},
  [2676] = {.lex_state = 100, .external_lex_state = 29},
  [2677] = {.lex_state = 32, .external_lex_state = 36},
  [2678] = {.lex_state = 100, .external_lex_state = 28},
  [2679] = {.lex_state = 100, .external_lex_state = 29},
  [2680] = {.lex_state = 100, .external_lex_state = 29},
  [2681] = {.lex_state = 100},
  [2682] = {.lex_state = 32, .external_lex_state = 36},
  [2683] = {.lex_state = 100, .external_lex_state = 29},
  [2684] = {.lex_state = 100, .external_lex_state = 28},
  [2685] = {.lex_state = 100, .external_lex_state = 29},
  [2686] = {.lex_state = 100, .external_lex_state = 29},
  [2687] = {.lex_state = 100, .external_lex_state = 28},
  [2688] = {.lex_state = 100, .external_lex_state = 29},
  [2689] = {.lex_state = 100, .external_lex_state = 28},
  [2690] = {.lex_state = 100, .external_lex_state = 29},
  [2691] = {.lex_state = 100, .external_lex_state = 29},
  [2692] = {.lex_state = 100, .external_lex_state = 29},
  [2693] = {.lex_state = 26, .external_lex_state = 34},
  [2694] = {.lex_state = 100, .external_lex_state = 29},
  [2695] = {.lex_state = 100, .external_lex_state = 28},
  [2696] = {.lex_state = 32, .external_lex_state = 36},
  [2697] = {.lex_state = 32, .external_lex_state = 36},
  [2698] = {.lex_state = 100, .external_lex_state = 29},
  [2699] = {.lex_state = 100, .external_lex_state = 29},
  [2700] = {.lex_state = 32, .external_lex_state = 36},
  [2701] = {.lex_state = 100, .external_lex_state = 29},
  [2702] = {.lex_state = 32, .external_lex_state = 36},
  [2703] = {.lex_state = 32, .external_lex_state = 36},
  [2704] = {.lex_state = 100, .external_lex_state = 29},
  [2705] = {.lex_state = 32, .external_lex_state = 36},
  [2706] = {.lex_state = 100, .external_lex_state = 28},
  [2707] = {.lex_state = 100, .external_lex_state = 28},
  [2708] = {.lex_state = 32, .external_lex_state = 36},
  [2709] = {.lex_state = 100, .external_lex_state = 29},
  [2710] = {.lex_state = 100, .external_lex_state = 29},
  [2711] = {.lex_state = 100, .external_lex_state = 29},
  [2712] = {.lex_state = 100, .external_lex_state = 29},
  [2713] = {.lex_state = 100, .external_lex_state = 28},
  [2714] = {.lex_state = 100, .external_lex_state = 29},
  [2715] = {.lex_state = 100, .external_lex_state = 29},
  [2716] = {.lex_state = 32, .external_lex_state = 36},
  [2717] = {.lex_state = 100, .external_lex_state = 28},
  [2718] = {.lex_state = 100, .external_lex_state = 29},
  [2719] = {.lex_state = 100, .external_lex_state = 28},
  [2720] = {.lex_state = 100, .external_lex_state = 29},
  [2721] = {.lex_state = 100, .external_lex_state = 29},
  [2722] = {.lex_state = 100, .external_lex_state = 28},
  [2723] = {.lex_state = 100, .external_lex_state = 29},
  [2724] = {.lex_state = 100, .external_lex_state = 28},
  [2725] = {.lex_state = 100, .external_lex_state = 29},
  [2726] = {.lex_state = 100, .external_lex_state = 29},
  [2727] = {.lex_state = 100, .external_lex_state = 29},
  [2728] = {.lex_state = 100, .external_lex_state = 29},
  [2729] = {.lex_state = 32, .external_lex_state = 36},
  [2730] = {.lex_state = 32, .external_lex_state = 36},
  [2731] = {.lex_state = 32, .external_lex_state = 36},
  [2732] = {.lex_state = 100, .external_lex_state = 29},
  [2733] = {.lex_state = 100, .external_lex_state = 29},
  [2734] = {.lex_state = 32, .external_lex_state = 36},
  [2735] = {.lex_state = 100, .external_lex_state = 29},
  [2736] = {.lex_state = 100, .external_lex_state = 29},
  [2737] = {.lex_state = 100, .external_lex_state = 28},
  [2738] = {.lex_state = 105, .external_lex_state = 29},
  [2739] = {.lex_state = 105, .external_lex_state = 29},
  [2740] = {.lex_state = 100, .external_lex_state = 29},
  [2741] = {.lex_state = 105, .external_lex_state = 29},
  [2742] = {.lex_state = 105, .external_lex_state = 29},
  [2743] = {.lex_state = 105, .external_lex_state = 29},
  [2744] = {.lex_state = 105, .external_lex_state = 29},
  [2745] = {.lex_state = 100, .external_lex_state = 29},
  [2746] = {.lex_state = 105, .external_lex_state = 29},
  [2747] = {.lex_state = 105, .external_lex_state = 29},
  [2748] = {.lex_state = 105, .external_lex_state = 29},
  [2749] = {.lex_state = 105, .external_lex_state = 29},
  [2750] = {.lex_state = 32, .external_lex_state = 37},
  [2751] = {.lex_state = 100, .external_lex_state = 29},
  [2752] = {.lex_state = 105, .external_lex_state = 29},
  [2753] = {.lex_state = 100, .external_lex_state = 29},
  [2754] = {.lex_state = 105, .external_lex_state = 29},
  [2755] = {.lex_state = 32, .external_lex_state = 37},
  [2756] = {.lex_state = 100},
  [2757] = {.lex_state = 100, .external_lex_state = 29},
  [2758] = {.lex_state = 100, .external_lex_state = 29},
  [2759] = {.lex_state = 105, .external_lex_state = 29},
  [2760] = {.lex_state = 100, .external_lex_state = 29},
  [2761] = {.lex_state = 105, .external_lex_state = 29},
  [2762] = {.lex_state = 100, .external_lex_state = 29},
  [2763] = {.lex_state = 100, .external_lex_state = 29},
  [2764] = {.lex_state = 100, .external_lex_state = 29},
  [2765] = {.lex_state = 105, .external_lex_state = 29},
  [2766] = {.lex_state = 100, .external_lex_state = 29},
  [2767] = {.lex_state = 100, .external_lex_state = 29},
  [2768] = {.lex_state = 100, .external_lex_state = 29},
  [2769] = {.lex_state = 105, .external_lex_state = 29},
  [2770] = {.lex_state = 105, .external_lex_state = 29},
  [2771] = {.lex_state = 108, .external_lex_state = 29},
  [2772] = {.lex_state = 105, .external_lex_state = 29},
  [2773] = {.lex_state = 100, .external_lex_state = 30},
  [2774] = {.lex_state = 105, .external_lex_state = 29},
  [2775] = {.lex_state = 100, .external_lex_state = 29},
  [2776] = {.lex_state = 105, .external_lex_state = 29},
  [2777] = {.lex_state = 105, .external_lex_state = 29},
  [2778] = {.lex_state = 32, .external_lex_state = 37},
  [2779] = {.lex_state = 100, .external_lex_state = 29},
  [2780] = {.lex_state = 100, .external_lex_state = 29},
  [2781] = {.lex_state = 32, .external_lex_state = 37},
  [2782] = {.lex_state = 100},
  [2783] = {.lex_state = 100, .external_lex_state = 30},
  [2784] = {.lex_state = 100, .external_lex_state = 29},
  [2785] = {.lex_state = 20, .external_lex_state = 29},
  [2786] = {.lex_state = 100, .external_lex_state = 29},
  [2787] = {.lex_state = 108, .external_lex_state = 29},
  [2788] = {.lex_state = 108, .external_lex_state = 29},
  [2789] = {.lex_state = 100, .external_lex_state = 29},
  [2790] = {.lex_state = 100, .external_lex_state = 29},
  [2791] = {.lex_state = 108, .external_lex_state = 29},
  [2792] = {.lex_state = 108, .external_lex_state = 29},
  [2793] = {.lex_state = 100, .external_lex_state = 29},
  [2794] = {.lex_state = 108, .external_lex_state = 29},
  [2795] = {.lex_state = 100, .external_lex_state = 29},
  [2796] = {.lex_state = 108, .external_lex_state = 29},
  [2797] = {.lex_state = 100, .external_lex_state = 36},
  [2798] = {.lex_state = 100, .external_lex_state = 29},
  [2799] = {.lex_state = 100, .external_lex_state = 29},
  [2800] = {.lex_state = 100, .external_lex_state = 29},
  [2801] = {.lex_state = 100, .external_lex_state = 29},
  [2802] = {.lex_state = 100, .external_lex_state = 29},
  [2803] = {.lex_state = 100, .external_lex_state = 29},
  [2804] = {.lex_state = 108, .external_lex_state = 29},
  [2805] = {.lex_state = 100, .external_lex_state = 29},
  [2806] = {.lex_state = 108, .external_lex_state = 29},
  [2807] = {.lex_state = 108, .external_lex_state = 29},
  [2808] = {.lex_state = 100, .external_lex_state = 29},
  [2809] = {.lex_state = 100, .external_lex_state = 29},
  [2810] = {.lex_state = 100, .external_lex_state = 29},
  [2811] = {.lex_state = 108, .external_lex_state = 29},
  [2812] = {.lex_state = 100, .external_lex_state = 29},
  [2813] = {.lex_state = 100, .external_lex_state = 36},
  [2814] = {.lex_state = 115, .external_lex_state = 29},
  [2815] = {.lex_state = 100, .external_lex_state = 29},
  [2816] = {.lex_state = 100, .external_lex_state = 29},
  [2817] = {.lex_state = 100, .external_lex_state = 29},
  [2818] = {.lex_state = 100, .external_lex_state = 29},
  [2819] = {.lex_state = 100, .external_lex_state = 29},
  [2820] = {.lex_state = 108, .external_lex_state = 29},
  [2821] = {.lex_state = 100, .external_lex_state = 29},
  [2822] = {.lex_state = 100, .external_lex_state = 29},
  [2823] = {.lex_state = 100, .external_lex_state = 29},
  [2824] = {.lex_state = 100, .external_lex_state = 29},
  [2825] = {.lex_state = 100, .external_lex_state = 29},
  [2826] = {.lex_state = 100, .external_lex_state = 29},
  [2827] = {.lex_state = 108, .external_lex_state = 29},
  [2828] = {.lex_state = 100, .external_lex_state = 29},
  [2829] = {.lex_state = 108, .external_lex_state = 29},
  [2830] = {.lex_state = 100, .external_lex_state = 28},
  [2831] = {.lex_state = 105},
  [2832] = {.lex_state = 100, .external_lex_state = 29},
  [2833] = {.lex_state = 100, .external_lex_state = 29},
  [2834] = {.lex_state = 100, .external_lex_state = 29},
  [2835] = {.lex_state = 100, .external_lex_state = 29},
  [2836] = {.lex_state = 100, .external_lex_state = 29},
  [2837] = {.lex_state = 108, .external_lex_state = 29},
  [2838] = {.lex_state = 108, .external_lex_state = 29},
  [2839] = {.lex_state = 100, .external_lex_state = 29},
  [2840] = {.lex_state = 100, .external_lex_state = 29},
  [2841] = {.lex_state = 100, .external_lex_state = 29},
  [2842] = {.lex_state = 100, .external_lex_state = 29},
  [2843] = {.lex_state = 100, .external_lex_state = 29},
  [2844] = {.lex_state = 100, .external_lex_state = 29},
  [2845] = {.lex_state = 100, .external_lex_state = 29},
  [2846] = {.lex_state = 108, .external_lex_state = 29},
  [2847] = {.lex_state = 20, .external_lex_state = 29},
  [2848] = {.lex_state = 100, .external_lex_state = 29},
  [2849] = {.lex_state = 100, .external_lex_state = 29},
  [2850] = {.lex_state = 100, .external_lex_state = 29},
  [2851] = {.lex_state = 100, .external_lex_state = 29},
  [2852] = {.lex_state = 100, .external_lex_state = 29},
  [2853] = {.lex_state = 100, .external_lex_state = 29},
  [2854] = {.lex_state = 100, .external_lex_state = 29},
  [2855] = {.lex_state = 100, .external_lex_state = 29},
  [2856] = {.lex_state = 100, .external_lex_state = 28},
  [2857] = {.lex_state = 100, .external_lex_state = 29},
  [2858] = {.lex_state = 105},
  [2859] = {.lex_state = 100, .external_lex_state = 29},
  [2860] = {.lex_state = 105},
  [2861] = {.lex_state = 100, .external_lex_state = 29},
  [2862] = {.lex_state = 100, .external_lex_state = 29},
  [2863] = {.lex_state = 100, .external_lex_state = 29},
  [2864] = {.lex_state = 100, .external_lex_state = 29},
  [2865] = {.lex_state = 100, .external_lex_state = 29},
  [2866] = {.lex_state = 108, .external_lex_state = 29},
  [2867] = {.lex_state = 108, .external_lex_state = 29},
  [2868] = {.lex_state = 100, .external_lex_state = 29},
  [2869] = {.lex_state = 100, .external_lex_state = 29},
  [2870] = {.lex_state = 100, .external_lex_state = 29},
  [2871] = {.lex_state = 100, .external_lex_state = 29},
  [2872] = {.lex_state = 100, .external_lex_state = 29},
  [2873] = {.lex_state = 100, .external_lex_state = 29},
  [2874] = {.lex_state = 105},
  [2875] = {.lex_state = 100, .external_lex_state = 29},
  [2876] = {.lex_state = 100, .external_lex_state = 29},
  [2877] = {.lex_state = 100, .external_lex_state = 29},
  [2878] = {.lex_state = 100, .external_lex_state = 29},
  [2879] = {.lex_state = 100, .external_lex_state = 29},
  [2880] = {.lex_state = 100, .external_lex_state = 29},
  [2881] = {.lex_state = 100, .external_lex_state = 29},
  [2882] = {.lex_state = 100, .external_lex_state = 29},
  [2883] = {.lex_state = 105},
  [2884] = {.lex_state = 105},
  [2885] = {.lex_state = 100, .external_lex_state = 29},
  [2886] = {.lex_state = 108, .external_lex_state = 29},
  [2887] = {.lex_state = 108, .external_lex_state = 29},
  [2888] = {.lex_state = 100},
  [2889] = {.lex_state = 100, .external_lex_state = 29},
  [2890] = {.lex_state = 100, .external_lex_state = 29},
  [2891] = {.lex_state = 100, .external_lex_state = 29},
  [2892] = {.lex_state = 108, .external_lex_state = 29},
  [2893] = {.lex_state = 105},
  [2894] = {.lex_state = 100, .external_lex_state = 36},
  [2895] = {.lex_state = 108, .external_lex_state = 29},
  [2896] = {.lex_state = 108, .external_lex_state = 29},
  [2897] = {.lex_state = 108, .external_lex_state = 29},
  [2898] = {.lex_state = 115, .external_lex_state = 29},
  [2899] = {.lex_state = 105},
  [2900] = {.lex_state = 100, .external_lex_state = 29},
  [2901] = {.lex_state = 100, .external_lex_state = 29},
  [2902] = {.lex_state = 100, .external_lex_state = 29},
  [2903] = {.lex_state = 100, .external_lex_state = 29},
  [2904] = {.lex_state = 108, .external_lex_state = 29},
  [2905] = {.lex_state = 100, .external_lex_state = 29},
  [2906] = {.lex_state = 100, .external_lex_state = 29},
  [2907] = {.lex_state = 100, .external_lex_state = 29},
  [2908] = {.lex_state = 100, .external_lex_state = 29},
  [2909] = {.lex_state = 100, .external_lex_state = 29},
  [2910] = {.lex_state = 100, .external_lex_state = 29},
  [2911] = {.lex_state = 100, .external_lex_state = 29},
  [2912] = {.lex_state = 100, .external_lex_state = 29},
  [2913] = {.lex_state = 20, .external_lex_state = 29},
  [2914] = {.lex_state = 100, .external_lex_state = 29},
  [2915] = {.lex_state = 100, .external_lex_state = 29},
  [2916] = {.lex_state = 100, .external_lex_state = 29},
  [2917] = {.lex_state = 100},
  [2918] = {.lex_state = 100, .external_lex_state = 36},
  [2919] = {.lex_state = 100, .external_lex_state = 36},
  [2920] = {.lex_state = 100, .external_lex_state = 36},
  [2921] = {.lex_state = 100, .external_lex_state = 29},
  [2922] = {.lex_state = 100, .external_lex_state = 29},
  [2923] = {.lex_state = 100, .external_lex_state = 29},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 108},
  [2929] = {.lex_state = 0},
  [2930] = {.lex_state = 0},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 0, .external_lex_state = 37},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 0},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 0},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 0},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 0},
  [2942] = {.lex_state = 0},
  [2943] = {-1},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 108},
  [2947] = {.lex_state = 108},
  [2948] = {.lex_state = 0},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 0},
  [2952] = {.lex_state = 0, .external_lex_state = 37},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 0},
  [2955] = {.lex_state = 20},
  [2956] = {.lex_state = 108},
  [2957] = {.lex_state = 108},
  [2958] = {.lex_state = 0},
  [2959] = {.lex_state = 0},
  [2960] = {.lex_state = 0},
  [2961] = {.lex_state = 0},
  [2962] = {.lex_state = 0},
  [2963] = {.lex_state = 108},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 0},
  [2966] = {-1},
  [2967] = {.lex_state = 20},
  [2968] = {.lex_state = 0},
  [2969] = {.lex_state = 108},
};

enum {
  ts_external_token__line_break = 0,
  ts_external_token__simple_symbol = 1,
  ts_external_token__string_start = 2,
  ts_external_token__symbol_start = 3,
  ts_external_token__subshell_start = 4,
  ts_external_token__regex_start = 5,
  ts_external_token__string_array_start = 6,
  ts_external_token__symbol_array_start = 7,
  ts_external_token__heredoc_body_start = 8,
  ts_external_token__string_content = 9,
  ts_external_token__heredoc_content = 10,
  ts_external_token__string_end = 11,
  ts_external_token_heredoc_end = 12,
  ts_external_token_heredoc_beginning = 13,
  ts_external_token_SLASH = 14,
  ts_external_token__block_ampersand = 15,
  ts_external_token__splat_star = 16,
  ts_external_token__unary_minus = 17,
  ts_external_token__binary_minus = 18,
  ts_external_token__binary_star = 19,
  ts_external_token__singleton_class_left_angle_left_langle = 20,
  ts_external_token__identifier_hash_key = 21,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__simple_symbol] = sym__simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__heredoc_content] = sym__heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token__identifier_hash_key] = sym__identifier_hash_key,
};

static bool ts_external_scanner_states[38][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [2] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [4] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [5] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [6] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [7] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [8] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [9] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [10] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [11] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [12] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [13] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [14] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [15] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [16] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [17] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [18] = {
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [20] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [21] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [22] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [23] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [24] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [25] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [26] = {
    [ts_external_token_SLASH] = true,
  },
  [27] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [28] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [29] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [30] = {
    [ts_external_token__line_break] = true,
  },
  [31] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [32] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [33] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [34] = {
    [ts_external_token__heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [35] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
  },
  [36] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_end] = true,
  },
  [37] = {
    [ts_external_token__string_end] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_body] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_redo] = ACTIONS(1),
    [anon_sym_retry] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_rescue] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_ensure] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_constant] = ACTIONS(1),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_r] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_TRUE] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_FALSE] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_NIL] = ACTIONS(1),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [sym__line_break] = ACTIONS(1),
    [sym__simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__string_content] = ACTIONS(1),
    [sym__heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym__identifier_hash_key] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2877),
    [sym__statements] = STATE(2758),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2210),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2181),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(1),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(965),
    [aux_sym__statements_repeat1] = STATE(174),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym___END__] = ACTIONS(11),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [anon_sym_undef] = ACTIONS(69),
    [anon_sym_alias] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [2] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(2),
    [sym_call] = STATE(2),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2094),
    [sym_argument_list] = STATE(883),
    [sym__argument] = STATE(2095),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(895),
    [sym_block] = STATE(911),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(2),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(2),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(115),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(115),
    [anon_sym_elsif] = ACTIONS(115),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_then] = ACTIONS(115),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(107),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [3] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(2),
    [sym_call] = STATE(2),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(881),
    [sym__argument] = STATE(2095),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(895),
    [sym_block] = STATE(911),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(2),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(3),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(115),
    [anon_sym_elsif] = ACTIONS(115),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_then] = ACTIONS(115),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(107),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [4] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(2),
    [sym_call] = STATE(2),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(887),
    [sym__argument] = STATE(2095),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(945),
    [sym_block] = STATE(940),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(2),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(4),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(115),
    [anon_sym_elsif] = ACTIONS(115),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_then] = ACTIONS(115),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(107),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [5] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(6),
    [sym_call] = STATE(6),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(881),
    [sym__argument] = STATE(2095),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(895),
    [sym_block] = STATE(911),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(6),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(5),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_identifier] = ACTIONS(169),
    [anon_sym___END__] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(169),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [6] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(6),
    [sym_call] = STATE(6),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2094),
    [sym_argument_list] = STATE(883),
    [sym__argument] = STATE(2095),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(895),
    [sym_block] = STATE(911),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(6),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(6),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_identifier] = ACTIONS(169),
    [anon_sym___END__] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(115),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(169),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [7] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(6),
    [sym_call] = STATE(6),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2091),
    [sym_argument_list] = STATE(887),
    [sym__argument] = STATE(2095),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_do_block] = STATE(945),
    [sym_block] = STATE(940),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(6),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(7),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_identifier] = ACTIONS(169),
    [anon_sym___END__] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(169),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(111),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [8] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1625),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(996),
    [sym_command_argument_list] = STATE(2180),
    [sym_argument_list] = STATE(988),
    [sym__argument] = STATE(2192),
    [sym_splat_argument] = STATE(2192),
    [sym_hash_splat_argument] = STATE(2192),
    [sym_block_argument] = STATE(2192),
    [sym_do_block] = STATE(1019),
    [sym_block] = STATE(1021),
    [sym_assignment] = STATE(1625),
    [sym_operator_assignment] = STATE(1625),
    [sym_conditional] = STATE(1625),
    [sym_range] = STATE(1625),
    [sym_binary] = STATE(1625),
    [sym_unary] = STATE(1625),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1356),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(8),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2192),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(115),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(209),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(177),
    [sym_instance_variable] = ACTIONS(219),
    [sym_class_variable] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(227),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(253),
    [sym__splat_star] = ACTIONS(255),
    [sym__unary_minus] = ACTIONS(257),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(259),
  },
  [9] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1625),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(996),
    [sym_command_argument_list] = STATE(2178),
    [sym_argument_list] = STATE(990),
    [sym__argument] = STATE(2192),
    [sym_splat_argument] = STATE(2192),
    [sym_hash_splat_argument] = STATE(2192),
    [sym_block_argument] = STATE(2192),
    [sym_do_block] = STATE(1019),
    [sym_block] = STATE(1021),
    [sym_assignment] = STATE(1625),
    [sym_operator_assignment] = STATE(1625),
    [sym_conditional] = STATE(1625),
    [sym_range] = STATE(1625),
    [sym_binary] = STATE(1625),
    [sym_unary] = STATE(1625),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1356),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(9),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2192),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(209),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(177),
    [sym_instance_variable] = ACTIONS(219),
    [sym_class_variable] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(227),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(253),
    [sym__splat_star] = ACTIONS(255),
    [sym__unary_minus] = ACTIONS(257),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(259),
  },
  [10] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1625),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(8),
    [sym_call] = STATE(8),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(996),
    [sym_command_argument_list] = STATE(2178),
    [sym_argument_list] = STATE(1003),
    [sym__argument] = STATE(2192),
    [sym_splat_argument] = STATE(2192),
    [sym_hash_splat_argument] = STATE(2192),
    [sym_block_argument] = STATE(2192),
    [sym_do_block] = STATE(1075),
    [sym_block] = STATE(1050),
    [sym_assignment] = STATE(1625),
    [sym_operator_assignment] = STATE(1625),
    [sym_conditional] = STATE(1625),
    [sym_range] = STATE(1625),
    [sym_binary] = STATE(1625),
    [sym_unary] = STATE(1625),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(8),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1356),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(10),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2192),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(265),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(115),
    [anon_sym_unless] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(115),
    [anon_sym_until] = ACTIONS(115),
    [anon_sym_rescue] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(115),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(177),
    [sym_instance_variable] = ACTIONS(219),
    [sym_class_variable] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(227),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(253),
    [sym__splat_star] = ACTIONS(255),
    [sym__unary_minus] = ACTIONS(257),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
    [sym__identifier_hash_key] = ACTIONS(259),
  },
  [11] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2112),
    [sym_argument_list] = STATE(1146),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(11),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(273),
    [anon_sym_DOT] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(275),
    [anon_sym_elsif] = ACTIONS(275),
    [anon_sym_else] = ACTIONS(275),
    [anon_sym_then] = ACTIONS(275),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(273),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_COLON_COLON2] = ACTIONS(273),
    [anon_sym_AMP_DOT] = ACTIONS(273),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(273),
    [anon_sym_and] = ACTIONS(275),
    [anon_sym_or] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ_GT] = ACTIONS(273),
    [anon_sym_EQ_TILDE] = ACTIONS(273),
    [anon_sym_BANG_TILDE] = ACTIONS(273),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(273),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(273),
    [sym__binary_star] = ACTIONS(273),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [12] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2115),
    [sym_argument_list] = STATE(1167),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(12),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(297),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [anon_sym_rescue] = ACTIONS(297),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(297),
    [anon_sym_elsif] = ACTIONS(297),
    [anon_sym_else] = ACTIONS(297),
    [anon_sym_then] = ACTIONS(297),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(297),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_COLON_COLON2] = ACTIONS(295),
    [anon_sym_AMP_DOT] = ACTIONS(295),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(295),
    [anon_sym_CARET] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_PERCENT] = ACTIONS(295),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(295),
    [anon_sym_LT_EQ_GT] = ACTIONS(295),
    [anon_sym_EQ_TILDE] = ACTIONS(295),
    [anon_sym_BANG_TILDE] = ACTIONS(295),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(295),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(295),
    [sym__binary_star] = ACTIONS(295),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [13] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2114),
    [sym_argument_list] = STATE(1185),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(13),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(301),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_until] = ACTIONS(301),
    [anon_sym_rescue] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(301),
    [anon_sym_elsif] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(301),
    [anon_sym_then] = ACTIONS(301),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(301),
    [anon_sym_EQ_GT] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_COLON_COLON2] = ACTIONS(299),
    [anon_sym_AMP_DOT] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT_DOT] = ACTIONS(301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(299),
    [anon_sym_LT_EQ_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [anon_sym_BANG_TILDE] = ACTIONS(299),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(299),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(299),
    [sym__binary_star] = ACTIONS(299),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [14] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2113),
    [sym_argument_list] = STATE(1188),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(14),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_DOT] = ACTIONS(305),
    [anon_sym_COLON_COLON] = ACTIONS(117),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_unless] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_rescue] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(305),
    [anon_sym_elsif] = ACTIONS(305),
    [anon_sym_else] = ACTIONS(305),
    [anon_sym_then] = ACTIONS(305),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(305),
    [anon_sym_EQ_GT] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COLON_COLON2] = ACTIONS(303),
    [anon_sym_AMP_DOT] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_DOT_DOT] = ACTIONS(305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(303),
    [anon_sym_AMP_AMP] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(305),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(303),
    [anon_sym_LT_EQ_GT] = ACTIONS(303),
    [anon_sym_EQ_TILDE] = ACTIONS(303),
    [anon_sym_BANG_TILDE] = ACTIONS(303),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(271),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(303),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(303),
    [sym__binary_star] = ACTIONS(303),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [15] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2112),
    [sym_argument_list] = STATE(1146),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(15),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(273),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(275),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_COLON_COLON2] = ACTIONS(273),
    [anon_sym_AMP_DOT] = ACTIONS(273),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(273),
    [anon_sym_and] = ACTIONS(275),
    [anon_sym_or] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ_GT] = ACTIONS(273),
    [anon_sym_EQ_TILDE] = ACTIONS(273),
    [anon_sym_BANG_TILDE] = ACTIONS(273),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(273),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(273),
    [sym__binary_star] = ACTIONS(273),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [16] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2113),
    [sym_argument_list] = STATE(1188),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(16),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(303),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(305),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(305),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_unless] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_rescue] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COLON_COLON2] = ACTIONS(303),
    [anon_sym_AMP_DOT] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_DOT_DOT] = ACTIONS(305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(303),
    [anon_sym_AMP_AMP] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(305),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(303),
    [anon_sym_LT_EQ_GT] = ACTIONS(303),
    [anon_sym_EQ_TILDE] = ACTIONS(303),
    [anon_sym_BANG_TILDE] = ACTIONS(303),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(303),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(303),
    [sym__binary_star] = ACTIONS(303),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [17] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2114),
    [sym_argument_list] = STATE(1185),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(17),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(299),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_until] = ACTIONS(301),
    [anon_sym_rescue] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_COLON_COLON2] = ACTIONS(299),
    [anon_sym_AMP_DOT] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT_DOT] = ACTIONS(301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(299),
    [anon_sym_LT_EQ_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [anon_sym_BANG_TILDE] = ACTIONS(299),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(299),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(299),
    [sym__binary_star] = ACTIONS(299),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [18] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1355),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(5),
    [sym_call] = STATE(5),
    [sym_command_call] = STATE(2102),
    [sym_method_call] = STATE(907),
    [sym_command_argument_list] = STATE(2115),
    [sym_argument_list] = STATE(1167),
    [sym__argument] = STATE(2106),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(5),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(18),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [ts_builtin_sym_end] = ACTIONS(295),
    [sym_identifier] = ACTIONS(307),
    [anon_sym___END__] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [anon_sym_rescue] = ACTIONS(297),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_COLON_COLON2] = ACTIONS(295),
    [anon_sym_AMP_DOT] = ACTIONS(295),
    [anon_sym_LPAREN2] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(295),
    [anon_sym_CARET] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_PERCENT] = ACTIONS(295),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(295),
    [anon_sym_LT_EQ_GT] = ACTIONS(295),
    [anon_sym_EQ_TILDE] = ACTIONS(295),
    [anon_sym_BANG_TILDE] = ACTIONS(295),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(307),
    [sym_instance_variable] = ACTIONS(173),
    [sym_class_variable] = ACTIONS(173),
    [sym_global_variable] = ACTIONS(173),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(175),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(175),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(149),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(295),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(295),
    [sym__binary_star] = ACTIONS(295),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [19] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1687),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(1056),
    [sym_command_argument_list] = STATE(2364),
    [sym_argument_list] = STATE(1419),
    [sym__argument] = STATE(2231),
    [sym_splat_argument] = STATE(2231),
    [sym_hash_splat_argument] = STATE(2231),
    [sym_block_argument] = STATE(2231),
    [sym_assignment] = STATE(1687),
    [sym_operator_assignment] = STATE(1687),
    [sym_conditional] = STATE(1687),
    [sym_range] = STATE(1687),
    [sym_binary] = STATE(1687),
    [sym_unary] = STATE(1687),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(19),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2231),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(275),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(273),
    [anon_sym_COLON_COLON2] = ACTIONS(273),
    [anon_sym_AMP_DOT] = ACTIONS(273),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(273),
    [anon_sym_and] = ACTIONS(275),
    [anon_sym_or] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(275),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_SLASH] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ_GT] = ACTIONS(273),
    [anon_sym_EQ_TILDE] = ACTIONS(273),
    [anon_sym_BANG_TILDE] = ACTIONS(273),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(273),
    [sym__binary_star] = ACTIONS(273),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [20] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1687),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(1056),
    [sym_command_argument_list] = STATE(2368),
    [sym_argument_list] = STATE(1418),
    [sym__argument] = STATE(2231),
    [sym_splat_argument] = STATE(2231),
    [sym_hash_splat_argument] = STATE(2231),
    [sym_block_argument] = STATE(2231),
    [sym_assignment] = STATE(1687),
    [sym_operator_assignment] = STATE(1687),
    [sym_conditional] = STATE(1687),
    [sym_range] = STATE(1687),
    [sym_binary] = STATE(1687),
    [sym_unary] = STATE(1687),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(20),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2231),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(305),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_PIPE] = ACTIONS(305),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_unless] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_until] = ACTIONS(305),
    [anon_sym_rescue] = ACTIONS(305),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COLON_COLON2] = ACTIONS(303),
    [anon_sym_AMP_DOT] = ACTIONS(303),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_DOT_DOT] = ACTIONS(305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(303),
    [anon_sym_AMP_AMP] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_LT_EQ] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_SLASH] = ACTIONS(303),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(305),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(303),
    [anon_sym_LT_EQ_GT] = ACTIONS(303),
    [anon_sym_EQ_TILDE] = ACTIONS(303),
    [anon_sym_BANG_TILDE] = ACTIONS(303),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(303),
    [sym__binary_star] = ACTIONS(303),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [21] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1687),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(1056),
    [sym_command_argument_list] = STATE(2371),
    [sym_argument_list] = STATE(1417),
    [sym__argument] = STATE(2231),
    [sym_splat_argument] = STATE(2231),
    [sym_hash_splat_argument] = STATE(2231),
    [sym_block_argument] = STATE(2231),
    [sym_assignment] = STATE(1687),
    [sym_operator_assignment] = STATE(1687),
    [sym_conditional] = STATE(1687),
    [sym_range] = STATE(1687),
    [sym_binary] = STATE(1687),
    [sym_unary] = STATE(1687),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(21),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2231),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(301),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_until] = ACTIONS(301),
    [anon_sym_rescue] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_COLON_COLON2] = ACTIONS(299),
    [anon_sym_AMP_DOT] = ACTIONS(299),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT_DOT] = ACTIONS(301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_LT_EQ] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_EQ] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(301),
    [anon_sym_BANG_EQ] = ACTIONS(299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(299),
    [anon_sym_LT_EQ_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [anon_sym_BANG_TILDE] = ACTIONS(299),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(299),
    [sym__binary_star] = ACTIONS(299),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [22] = {
    [sym_method] = STATE(1422),
    [sym_singleton_method] = STATE(1422),
    [sym_class] = STATE(1422),
    [sym_singleton_class] = STATE(1422),
    [sym_module] = STATE(1422),
    [sym_return] = STATE(1422),
    [sym_yield] = STATE(1422),
    [sym_break] = STATE(1422),
    [sym_next] = STATE(1422),
    [sym_redo] = STATE(1422),
    [sym_retry] = STATE(1422),
    [sym_while] = STATE(1422),
    [sym_until] = STATE(1422),
    [sym_for] = STATE(1422),
    [sym_case] = STATE(1422),
    [sym_if] = STATE(1422),
    [sym_unless] = STATE(1422),
    [sym_begin] = STATE(1422),
    [sym__arg] = STATE(1687),
    [sym__primary] = STATE(1422),
    [sym_parenthesized_statements] = STATE(1422),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(9),
    [sym_call] = STATE(9),
    [sym_command_call] = STATE(2229),
    [sym_method_call] = STATE(1056),
    [sym_command_argument_list] = STATE(2373),
    [sym_argument_list] = STATE(1416),
    [sym__argument] = STATE(2231),
    [sym_splat_argument] = STATE(2231),
    [sym_hash_splat_argument] = STATE(2231),
    [sym_block_argument] = STATE(2231),
    [sym_assignment] = STATE(1687),
    [sym_operator_assignment] = STATE(1687),
    [sym_conditional] = STATE(1687),
    [sym_range] = STATE(1687),
    [sym_binary] = STATE(1687),
    [sym_unary] = STATE(1687),
    [sym_parenthesized_unary] = STATE(1422),
    [sym_unary_literal] = STATE(1422),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(9),
    [sym_rational] = STATE(1422),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1422),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1422),
    [sym_string_array] = STATE(1422),
    [sym_symbol_array] = STATE(1422),
    [sym_symbol] = STATE(1422),
    [sym_regex] = STATE(1422),
    [sym_heredoc_body] = STATE(22),
    [sym_array] = STATE(1422),
    [sym_hash] = STATE(1422),
    [sym_pair] = STATE(2231),
    [sym_lambda] = STATE(1422),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(297),
    [anon_sym_unless] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(297),
    [anon_sym_until] = ACTIONS(297),
    [anon_sym_rescue] = ACTIONS(297),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_COLON_COLON2] = ACTIONS(295),
    [anon_sym_AMP_DOT] = ACTIONS(295),
    [anon_sym_LPAREN2] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_GT_EQ] = ACTIONS(295),
    [anon_sym_CARET] = ACTIONS(295),
    [anon_sym_PLUS] = ACTIONS(297),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_PERCENT] = ACTIONS(295),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(295),
    [anon_sym_LT_EQ_GT] = ACTIONS(295),
    [anon_sym_EQ_TILDE] = ACTIONS(295),
    [anon_sym_BANG_TILDE] = ACTIONS(295),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(319),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(309),
    [sym_instance_variable] = ACTIONS(323),
    [sym_class_variable] = ACTIONS(323),
    [sym_global_variable] = ACTIONS(323),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(223),
    [sym_complex] = ACTIONS(225),
    [sym_super] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(325),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(225),
    [anon_sym_LBRACK2] = ACTIONS(235),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(225),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__binary_minus] = ACTIONS(295),
    [sym__binary_star] = ACTIONS(295),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [23] = {
    [sym__statements] = STATE(2279),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(41),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1054),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(23),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(54),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2277),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [24] = {
    [sym__statements] = STATE(2307),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(53),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2090),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(24),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(48),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [25] = {
    [sym__statements] = STATE(2297),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(45),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1220),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(25),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(40),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [26] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(44),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1104),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(26),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(43),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [27] = {
    [sym__statements] = STATE(2259),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(64),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(902),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(27),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(63),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2242),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [28] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(59),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2243),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(28),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(35),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [29] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(46),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1481),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(29),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [30] = {
    [sym__statements] = STATE(2300),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(49),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(927),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(30),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(36),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2299),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [31] = {
    [sym__statements] = STATE(2351),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(68),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1063),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(31),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(67),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2352),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(381),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [32] = {
    [sym__statements] = STATE(2369),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(70),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2236),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(32),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(73),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(383),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [33] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(66),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1514),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(33),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(76),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(385),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [34] = {
    [sym__statements] = STATE(2340),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(77),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1032),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(34),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(74),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(387),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [35] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(38),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2302),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(35),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [36] = {
    [sym__statements] = STATE(2300),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(37),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(939),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(36),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2299),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [37] = {
    [sym__statements] = STATE(2300),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(949),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(37),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(100),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2299),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [38] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2268),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(38),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(85),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [39] = {
    [sym__statements] = STATE(2297),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1204),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(39),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(84),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [40] = {
    [sym__statements] = STATE(2297),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(39),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1222),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(40),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [41] = {
    [sym__statements] = STATE(2279),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1055),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(41),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(88),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2277),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [42] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2636),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(42),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(107),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [43] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(50),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1121),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(43),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [44] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1121),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(44),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(115),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [45] = {
    [sym__statements] = STATE(2297),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1222),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(45),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(81),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [46] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1451),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(46),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [47] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(60),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1451),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(47),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [48] = {
    [sym__statements] = STATE(2307),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(62),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2082),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(48),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [49] = {
    [sym__statements] = STATE(2300),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(939),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(49),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(96),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2299),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [50] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1162),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(50),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(83),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [51] = {
    [sym__statements] = STATE(2259),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(925),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(51),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(111),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2242),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [52] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1182),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(52),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(80),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [53] = {
    [sym__statements] = STATE(2307),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2082),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(53),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(89),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [54] = {
    [sym__statements] = STATE(2279),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(56),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1055),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(54),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2277),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [55] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1132),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(55),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(91),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [56] = {
    [sym__statements] = STATE(2279),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1064),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(56),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(87),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2277),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [57] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1520),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(57),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(79),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [58] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2616),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(58),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [59] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2302),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(59),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(86),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [60] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1440),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(60),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(98),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [61] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1474),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(61),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(92),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [62] = {
    [sym__statements] = STATE(2307),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2084),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(62),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(90),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [63] = {
    [sym__statements] = STATE(2259),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(51),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(918),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(63),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2242),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [64] = {
    [sym__statements] = STATE(2259),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(918),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(64),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(103),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2242),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [65] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1413),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(65),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(116),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [66] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1502),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(66),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(127),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [67] = {
    [sym__statements] = STATE(2351),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(69),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1085),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(67),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2352),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [68] = {
    [sym__statements] = STATE(2351),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1085),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(68),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(119),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2352),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [69] = {
    [sym__statements] = STATE(2351),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1089),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(69),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(118),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2352),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [70] = {
    [sym__statements] = STATE(2369),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2238),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(70),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(126),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(399),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [71] = {
    [sym__statements] = STATE(2340),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1006),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(71),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(120),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(401),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [72] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1496),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(72),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(129),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [73] = {
    [sym__statements] = STATE(2369),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(78),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2238),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(73),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(399),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [74] = {
    [sym__statements] = STATE(2340),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(71),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1013),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(74),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [75] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1478),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(75),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(122),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [76] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(72),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1502),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(76),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [77] = {
    [sym__statements] = STATE(2340),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1013),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(77),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(117),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [78] = {
    [sym__statements] = STATE(2369),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2227),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(78),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(409),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [79] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1442),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(79),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [80] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1184),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(80),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [81] = {
    [sym__statements] = STATE(2297),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1204),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(81),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [82] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1477),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(82),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [83] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1109),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(83),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [84] = {
    [sym__statements] = STATE(2297),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1213),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(84),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2293),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [85] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2315),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(85),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [86] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2268),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(86),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [87] = {
    [sym__statements] = STATE(2279),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1070),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(87),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2277),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [88] = {
    [sym__statements] = STATE(2279),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1064),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(88),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2277),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(343),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [89] = {
    [sym__statements] = STATE(2307),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2084),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(89),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [90] = {
    [sym__statements] = STATE(2307),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2085),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(90),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [91] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1147),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(91),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [92] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1535),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(92),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [93] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1538),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(93),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [94] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1540),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(94),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [95] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1475),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(95),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [96] = {
    [sym__statements] = STATE(2300),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(949),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(96),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2299),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [97] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1186),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(97),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [98] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1437),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(98),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [99] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1180),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(99),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [100] = {
    [sym__statements] = STATE(2300),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(936),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(100),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2299),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [101] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1187),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(101),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [102] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1440),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(102),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [103] = {
    [sym__statements] = STATE(2259),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(925),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(103),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2242),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [104] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2666),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(104),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [105] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2604),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(105),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [106] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2647),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(106),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [107] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2605),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(107),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [108] = {
    [sym__statements] = STATE(2298),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1513),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(108),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2303),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [109] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2635),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(109),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [110] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1159),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(110),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [111] = {
    [sym__statements] = STATE(2259),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(923),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(111),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2242),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [112] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2632),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(112),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [113] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1156),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(113),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [114] = {
    [sym__statements] = STATE(2244),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2631),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(114),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [115] = {
    [sym__statements] = STATE(2275),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1162),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(115),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2309),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [116] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1407),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(116),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(411),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [117] = {
    [sym__statements] = STATE(2340),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1006),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(117),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(401),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [118] = {
    [sym__statements] = STATE(2351),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1092),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(118),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2352),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [119] = {
    [sym__statements] = STATE(2351),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1089),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(119),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2352),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [120] = {
    [sym__statements] = STATE(2340),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1010),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2341),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(415),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [121] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1505),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(121),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [122] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1508),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(122),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [123] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1507),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(123),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [124] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1493),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [125] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1499),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(125),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [126] = {
    [sym__statements] = STATE(2369),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2227),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(126),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(409),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [127] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1496),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(127),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [128] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1482),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(128),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [129] = {
    [sym__statements] = STATE(2386),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(1489),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(129),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [130] = {
    [sym__statements] = STATE(2369),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_else] = STATE(2571),
    [sym_begin] = STATE(1118),
    [sym_ensure] = STATE(2571),
    [sym_rescue] = STATE(2571),
    [sym__body_statement] = STATE(2226),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(130),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [aux_sym__body_statement_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(431),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [131] = {
    [sym__statements] = STATE(2825),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(131),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [132] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2147),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(132),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(457),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(457),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(457),
    [anon_sym_elsif] = ACTIONS(457),
    [anon_sym_else] = ACTIONS(457),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [133] = {
    [sym__statements] = STATE(2885),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(179),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(133),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [134] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2310),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(134),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(461),
    [anon_sym_BEGIN] = ACTIONS(464),
    [anon_sym_LBRACE] = ACTIONS(467),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_END] = ACTIONS(472),
    [anon_sym_def] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(478),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_COLON_COLON] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(484),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_class] = ACTIONS(490),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_end] = ACTIONS(496),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_yield] = ACTIONS(501),
    [anon_sym_break] = ACTIONS(504),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(510),
    [anon_sym_retry] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(516),
    [anon_sym_unless] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(522),
    [anon_sym_until] = ACTIONS(525),
    [anon_sym_rescue] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_case] = ACTIONS(531),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_elsif] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_begin] = ACTIONS(534),
    [anon_sym_ensure] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(537),
    [anon_sym_defined_QMARK] = ACTIONS(540),
    [anon_sym_not] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_TILDE] = ACTIONS(546),
    [sym_constant] = ACTIONS(461),
    [sym_instance_variable] = ACTIONS(549),
    [sym_class_variable] = ACTIONS(549),
    [sym_global_variable] = ACTIONS(549),
    [anon_sym_undef] = ACTIONS(552),
    [anon_sym_alias] = ACTIONS(555),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(558),
    [sym_float] = ACTIONS(561),
    [sym_complex] = ACTIONS(564),
    [sym_super] = ACTIONS(461),
    [anon_sym_true] = ACTIONS(567),
    [anon_sym_TRUE] = ACTIONS(567),
    [anon_sym_false] = ACTIONS(570),
    [anon_sym_FALSE] = ACTIONS(570),
    [sym_self] = ACTIONS(461),
    [anon_sym_nil] = ACTIONS(573),
    [anon_sym_NIL] = ACTIONS(573),
    [sym_character] = ACTIONS(564),
    [anon_sym_LBRACK2] = ACTIONS(576),
    [anon_sym_DASH_GT] = ACTIONS(579),
    [sym__simple_symbol] = ACTIONS(582),
    [sym__string_start] = ACTIONS(585),
    [sym__symbol_start] = ACTIONS(588),
    [sym__subshell_start] = ACTIONS(591),
    [sym__regex_start] = ACTIONS(594),
    [sym__string_array_start] = ACTIONS(597),
    [sym__symbol_array_start] = ACTIONS(600),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(564),
    [sym__unary_minus] = ACTIONS(603),
  },
  [135] = {
    [sym__statements] = STATE(2825),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(135),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [136] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2882),
    [sym_else] = STATE(2882),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(136),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(608),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [137] = {
    [sym__statements] = STATE(2407),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(137),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(614),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(614),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(614),
    [anon_sym_elsif] = ACTIONS(614),
    [anon_sym_else] = ACTIONS(614),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(614),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [138] = {
    [sym__statements] = STATE(2941),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(196),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_hash_splat_argument] = STATE(2756),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(138),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2756),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [139] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2912),
    [sym_else] = STATE(2912),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(139),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(618),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [140] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2911),
    [sym_else] = STATE(2911),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(140),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(620),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [141] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(141),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(622),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(622),
    [anon_sym_elsif] = ACTIONS(622),
    [anon_sym_else] = ACTIONS(622),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(622),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [142] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2839),
    [sym_else] = STATE(2839),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(142),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(624),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [143] = {
    [sym__statements] = STATE(2624),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(143),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [sym__terminator] = STATE(157),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(626),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(626),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [144] = {
    [sym__statements] = STATE(2941),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(196),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_hash_splat_argument] = STATE(2756),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(144),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2756),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [145] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2870),
    [sym_else] = STATE(2870),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(145),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [146] = {
    [sym__statements] = STATE(2950),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(203),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1605),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_hash_splat_argument] = STATE(2756),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(146),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2756),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(433),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [147] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2881),
    [sym_else] = STATE(2881),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(147),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [148] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2841),
    [sym_else] = STATE(2841),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(148),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(636),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [149] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(149),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [150] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2931),
    [sym_else] = STATE(2931),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(150),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(640),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [151] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_elsif] = STATE(2949),
    [sym_else] = STATE(2949),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(151),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_elsif] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [152] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(152),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(644),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(644),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(644),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [153] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(153),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [154] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(154),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(648),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(648),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(648),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [155] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(155),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [156] = {
    [sym__statements] = STATE(2626),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(156),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(652),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(652),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(652),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [157] = {
    [sym__statements] = STATE(2562),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(157),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_rescue] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_ensure] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [158] = {
    [sym__statements] = STATE(2469),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(158),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_when] = ACTIONS(656),
    [anon_sym_else] = ACTIONS(656),
    [anon_sym_then] = ACTIONS(612),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [159] = {
    [sym__statements] = STATE(2834),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(175),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(159),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(658),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [160] = {
    [sym__statements] = STATE(2819),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(195),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(160),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [161] = {
    [sym__statements] = STATE(2795),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(189),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(161),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [162] = {
    [sym__statements] = STATE(2885),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(179),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(162),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [163] = {
    [sym__statements] = STATE(2818),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(191),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(163),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [164] = {
    [sym__statements] = STATE(2864),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(181),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(164),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [165] = {
    [sym__statements] = STATE(2825),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(165),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [166] = {
    [sym__statements] = STATE(2914),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(184),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(166),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [167] = {
    [sym__statements] = STATE(2950),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(203),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(167),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [168] = {
    [sym__statements] = STATE(2961),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(204),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(168),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [169] = {
    [sym__statements] = STATE(2927),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(202),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(169),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [170] = {
    [sym__statements] = STATE(2941),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_block_parameters] = STATE(196),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(170),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [171] = {
    [sym__statements] = STATE(2909),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(171),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(682),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [172] = {
    [sym__statements] = STATE(2848),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2771),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(172),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [173] = {
    [sym__statements] = STATE(2891),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(173),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(686),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [174] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2213),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2181),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(174),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(965),
    [aux_sym__statements_repeat1] = STATE(178),
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym_identifier] = ACTIONS(9),
    [anon_sym___END__] = ACTIONS(457),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_SEMI] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [anon_sym_undef] = ACTIONS(69),
    [anon_sym_alias] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [175] = {
    [sym__statements] = STATE(2832),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(175),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [176] = {
    [sym__statements] = STATE(2923),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2771),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(176),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [177] = {
    [sym__statements] = STATE(2901),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2771),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(177),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [178] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2249),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(178),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(965),
    [aux_sym__statements_repeat1] = STATE(178),
    [ts_builtin_sym_end] = ACTIONS(470),
    [sym_identifier] = ACTIONS(461),
    [anon_sym___END__] = ACTIONS(496),
    [anon_sym_BEGIN] = ACTIONS(464),
    [anon_sym_LBRACE] = ACTIONS(467),
    [anon_sym_END] = ACTIONS(472),
    [anon_sym_def] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(478),
    [anon_sym_COLON_COLON] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_class] = ACTIONS(490),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_yield] = ACTIONS(501),
    [anon_sym_break] = ACTIONS(504),
    [anon_sym_next] = ACTIONS(507),
    [anon_sym_redo] = ACTIONS(510),
    [anon_sym_retry] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(516),
    [anon_sym_unless] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(522),
    [anon_sym_until] = ACTIONS(525),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_case] = ACTIONS(531),
    [anon_sym_begin] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(537),
    [anon_sym_defined_QMARK] = ACTIONS(540),
    [anon_sym_not] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_TILDE] = ACTIONS(546),
    [sym_constant] = ACTIONS(461),
    [sym_instance_variable] = ACTIONS(549),
    [sym_class_variable] = ACTIONS(549),
    [sym_global_variable] = ACTIONS(549),
    [anon_sym_undef] = ACTIONS(552),
    [anon_sym_alias] = ACTIONS(555),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(558),
    [sym_float] = ACTIONS(561),
    [sym_complex] = ACTIONS(564),
    [sym_super] = ACTIONS(461),
    [anon_sym_true] = ACTIONS(567),
    [anon_sym_TRUE] = ACTIONS(567),
    [anon_sym_false] = ACTIONS(570),
    [anon_sym_FALSE] = ACTIONS(570),
    [sym_self] = ACTIONS(461),
    [anon_sym_nil] = ACTIONS(573),
    [anon_sym_NIL] = ACTIONS(573),
    [sym_character] = ACTIONS(564),
    [anon_sym_LBRACK2] = ACTIONS(576),
    [anon_sym_DASH_GT] = ACTIONS(579),
    [sym__simple_symbol] = ACTIONS(582),
    [sym__string_start] = ACTIONS(585),
    [sym__symbol_start] = ACTIONS(588),
    [sym__subshell_start] = ACTIONS(591),
    [sym__regex_start] = ACTIONS(594),
    [sym__string_array_start] = ACTIONS(597),
    [sym__symbol_array_start] = ACTIONS(600),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(564),
    [sym__unary_minus] = ACTIONS(603),
  },
  [179] = {
    [sym__statements] = STATE(2850),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(179),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [180] = {
    [sym__statements] = STATE(2875),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(180),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(699),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [181] = {
    [sym__statements] = STATE(2861),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(181),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [182] = {
    [sym__statements] = STATE(2821),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(182),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [183] = {
    [sym__statements] = STATE(2910),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(183),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(705),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [184] = {
    [sym__statements] = STATE(2906),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(184),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [185] = {
    [sym__statements] = STATE(2843),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(185),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [186] = {
    [sym__statements] = STATE(2905),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(186),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [187] = {
    [sym__statements] = STATE(2852),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(187),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(713),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [188] = {
    [sym__statements] = STATE(2923),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(188),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [189] = {
    [sym__statements] = STATE(2802),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(189),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [190] = {
    [sym__statements] = STATE(2799),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(190),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [191] = {
    [sym__statements] = STATE(2817),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(191),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [192] = {
    [sym__statements] = STATE(2876),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(192),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [193] = {
    [sym__statements] = STATE(2823),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(193),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [194] = {
    [sym__statements] = STATE(2805),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(194),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [195] = {
    [sym__statements] = STATE(2842),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(195),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [196] = {
    [sym__statements] = STATE(2942),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(196),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [197] = {
    [sym__statements] = STATE(2933),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(197),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [198] = {
    [sym__statements] = STATE(2935),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(198),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [199] = {
    [sym__statements] = STATE(2925),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(199),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [200] = {
    [sym__statements] = STATE(2945),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(200),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [201] = {
    [sym__statements] = STATE(2964),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2771),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(201),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [202] = {
    [sym__statements] = STATE(2937),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(202),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [203] = {
    [sym__statements] = STATE(2968),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(203),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [204] = {
    [sym__statements] = STATE(2962),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(204),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [205] = {
    [sym__statements] = STATE(2938),
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2155),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(205),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_empty_statement] = STATE(946),
    [aux_sym__statements_repeat1] = STATE(132),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_end] = ACTIONS(747),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [206] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2209),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(206),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [207] = {
    [sym_begin_block] = STATE(2470),
    [sym_end_block] = STATE(2470),
    [sym__statement] = STATE(2470),
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2323),
    [sym_yield_command] = STATE(2323),
    [sym_break_command] = STATE(2323),
    [sym_next_command] = STATE(2323),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_if_modifier] = STATE(2470),
    [sym_unless_modifier] = STATE(2470),
    [sym_while_modifier] = STATE(2470),
    [sym_until_modifier] = STATE(2470),
    [sym_rescue_modifier] = STATE(2470),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2323),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2323),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2323),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2323),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_undef] = STATE(2470),
    [sym_alias] = STATE(2470),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(207),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_BEGIN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_END] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [anon_sym_undef] = ACTIONS(785),
    [anon_sym_alias] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [208] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2204),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(208),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [209] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2223),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(209),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [210] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2222),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(210),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [211] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2214),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(211),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [212] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2207),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(212),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [213] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2219),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(213),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [214] = {
    [sym_begin_block] = STATE(2398),
    [sym_end_block] = STATE(2398),
    [sym__statement] = STATE(2398),
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2323),
    [sym_yield_command] = STATE(2323),
    [sym_break_command] = STATE(2323),
    [sym_next_command] = STATE(2323),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_if_modifier] = STATE(2398),
    [sym_unless_modifier] = STATE(2398),
    [sym_while_modifier] = STATE(2398),
    [sym_until_modifier] = STATE(2398),
    [sym_rescue_modifier] = STATE(2398),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2323),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2323),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2323),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2323),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_undef] = STATE(2398),
    [sym_alias] = STATE(2398),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(214),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_BEGIN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_END] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [anon_sym_undef] = ACTIONS(785),
    [anon_sym_alias] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [215] = {
    [sym_begin_block] = STATE(2520),
    [sym_end_block] = STATE(2520),
    [sym__statement] = STATE(2520),
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2323),
    [sym_yield_command] = STATE(2323),
    [sym_break_command] = STATE(2323),
    [sym_next_command] = STATE(2323),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_if_modifier] = STATE(2520),
    [sym_unless_modifier] = STATE(2520),
    [sym_while_modifier] = STATE(2520),
    [sym_until_modifier] = STATE(2520),
    [sym_rescue_modifier] = STATE(2520),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2323),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2323),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2323),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2323),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_undef] = STATE(2520),
    [sym_alias] = STATE(2520),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(215),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_BEGIN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_END] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [anon_sym_undef] = ACTIONS(785),
    [anon_sym_alias] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [216] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2225),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(216),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [217] = {
    [sym_begin_block] = STATE(2138),
    [sym_end_block] = STATE(2138),
    [sym__statement] = STATE(2241),
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_if_modifier] = STATE(2138),
    [sym_unless_modifier] = STATE(2138),
    [sym_while_modifier] = STATE(2138),
    [sym_until_modifier] = STATE(2138),
    [sym_rescue_modifier] = STATE(2138),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2132),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_undef] = STATE(2138),
    [sym_alias] = STATE(2138),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(217),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_END] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_alias] = ACTIONS(363),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [218] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1307),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2867),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(961),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(218),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [219] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1299),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1303),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(219),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [220] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1589),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1585),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2838),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(989),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(220),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(815),
    [sym__unary_minus] = ACTIONS(291),
  },
  [221] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1581),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1277),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2838),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(989),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(221),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(815),
    [sym__unary_minus] = ACTIONS(291),
  },
  [222] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1299),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1303),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2867),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(961),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(222),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [223] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2116),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1307),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(223),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [224] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2784),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(224),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [225] = {
    [sym_heredoc_body] = STATE(225),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_when] = ACTIONS(907),
    [anon_sym_elsif] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_then] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_ensure] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [226] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2840),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(226),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [227] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2789),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(227),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [228] = {
    [sym_heredoc_body] = STATE(228),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_when] = ACTIONS(907),
    [anon_sym_elsif] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_then] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_ensure] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [229] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2367),
    [sym_yield_command] = STATE(2367),
    [sym_break_command] = STATE(2367),
    [sym_next_command] = STATE(2367),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2367),
    [sym__arg] = STATE(1695),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1152),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1152),
    [sym_splat_argument] = STATE(1716),
    [sym_assignment] = STATE(1695),
    [sym_command_assignment] = STATE(2367),
    [sym_operator_assignment] = STATE(1695),
    [sym_command_operator_assignment] = STATE(2367),
    [sym_conditional] = STATE(1695),
    [sym_range] = STATE(1695),
    [sym_binary] = STATE(1695),
    [sym_command_binary] = STATE(2367),
    [sym_unary] = STATE(1695),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2969),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1152),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1152),
    [sym_false] = STATE(1152),
    [sym_nil] = STATE(1152),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(229),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(927),
  },
  [230] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2816),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(230),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [231] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument] = STATE(2679),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(231),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [232] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2800),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(232),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [233] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument] = STATE(2679),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(233),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [234] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2833),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(234),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [235] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2826),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(235),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [236] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2828),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(236),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [237] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2879),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(237),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [238] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2367),
    [sym_yield_command] = STATE(2367),
    [sym_break_command] = STATE(2367),
    [sym_next_command] = STATE(2367),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2367),
    [sym__arg] = STATE(1711),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1152),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1152),
    [sym_splat_argument] = STATE(1710),
    [sym_assignment] = STATE(1711),
    [sym_command_assignment] = STATE(2367),
    [sym_operator_assignment] = STATE(1711),
    [sym_command_operator_assignment] = STATE(2367),
    [sym_conditional] = STATE(1711),
    [sym_range] = STATE(1711),
    [sym_binary] = STATE(1711),
    [sym_command_binary] = STATE(2367),
    [sym_unary] = STATE(1711),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2969),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1152),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1152),
    [sym_false] = STATE(1152),
    [sym_nil] = STATE(1152),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(238),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(927),
  },
  [239] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2793),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(239),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(945),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [240] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2921),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(240),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [241] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2824),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(241),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [242] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2801),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(242),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [243] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2865),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(243),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [244] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2916),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(244),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [245] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2836),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(245),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [246] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2863),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(246),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [247] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2922),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(247),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [248] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2890),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(248),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [249] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2790),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(249),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [250] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2878),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(250),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [251] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2960),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(251),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [252] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_then] = STATE(2620),
    [sym_begin] = STATE(1118),
    [sym_exceptions] = STATE(2339),
    [sym_exception_variable] = STATE(2533),
    [sym__arg] = STATE(1720),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(2456),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(252),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym__terminator] = STATE(153),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_then] = ACTIONS(975),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(365),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(991),
    [sym__unary_minus] = ACTIONS(993),
  },
  [253] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2965),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(253),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [254] = {
    [sym_heredoc_body] = STATE(254),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_next] = ACTIONS(997),
    [anon_sym_redo] = ACTIONS(997),
    [anon_sym_retry] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [sym_constant] = ACTIONS(997),
    [sym_instance_variable] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(999),
    [sym_global_variable] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [sym_complex] = ACTIONS(999),
    [sym_super] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_TRUE] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_FALSE] = ACTIONS(997),
    [sym_self] = ACTIONS(997),
    [anon_sym_nil] = ACTIONS(997),
    [anon_sym_NIL] = ACTIONS(997),
    [sym_character] = ACTIONS(999),
    [anon_sym_LBRACK2] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [sym__line_break] = ACTIONS(999),
    [sym__simple_symbol] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
    [sym__symbol_start] = ACTIONS(999),
    [sym__subshell_start] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(999),
    [sym__symbol_array_start] = ACTIONS(999),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(999),
    [sym__block_ampersand] = ACTIONS(999),
    [sym__splat_star] = ACTIONS(999),
    [sym__unary_minus] = ACTIONS(999),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
    [sym__identifier_hash_key] = ACTIONS(999),
  },
  [255] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2930),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(255),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [256] = {
    [sym_heredoc_body] = STATE(256),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_end] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_next] = ACTIONS(1003),
    [anon_sym_redo] = ACTIONS(1003),
    [anon_sym_retry] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_unless] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_when] = ACTIONS(1003),
    [anon_sym_elsif] = ACTIONS(1003),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_then] = ACTIONS(1003),
    [anon_sym_begin] = ACTIONS(1003),
    [anon_sym_ensure] = ACTIONS(1003),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1005),
    [sym_constant] = ACTIONS(1003),
    [sym_instance_variable] = ACTIONS(1005),
    [sym_class_variable] = ACTIONS(1005),
    [sym_global_variable] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_TRUE] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_FALSE] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
    [anon_sym_nil] = ACTIONS(1003),
    [anon_sym_NIL] = ACTIONS(1003),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1005),
    [sym__line_break] = ACTIONS(1005),
    [sym__simple_symbol] = ACTIONS(1005),
    [sym__string_start] = ACTIONS(1005),
    [sym__symbol_start] = ACTIONS(1005),
    [sym__subshell_start] = ACTIONS(1005),
    [sym__regex_start] = ACTIONS(1005),
    [sym__string_array_start] = ACTIONS(1005),
    [sym__symbol_array_start] = ACTIONS(1005),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__block_ampersand] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1005),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
    [sym__identifier_hash_key] = ACTIONS(1005),
  },
  [257] = {
    [sym_heredoc_body] = STATE(257),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(1007),
    [anon_sym_end] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [anon_sym_next] = ACTIONS(1007),
    [anon_sym_redo] = ACTIONS(1007),
    [anon_sym_retry] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_until] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_when] = ACTIONS(1007),
    [anon_sym_elsif] = ACTIONS(1007),
    [anon_sym_else] = ACTIONS(1007),
    [anon_sym_then] = ACTIONS(1007),
    [anon_sym_begin] = ACTIONS(1007),
    [anon_sym_ensure] = ACTIONS(1007),
    [anon_sym_EQ_GT] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1009),
    [anon_sym_not] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1009),
    [sym_constant] = ACTIONS(1007),
    [sym_instance_variable] = ACTIONS(1009),
    [sym_class_variable] = ACTIONS(1009),
    [sym_global_variable] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_TRUE] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_FALSE] = ACTIONS(1007),
    [sym_self] = ACTIONS(1007),
    [anon_sym_nil] = ACTIONS(1007),
    [anon_sym_NIL] = ACTIONS(1007),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1009),
    [sym__line_break] = ACTIONS(1009),
    [sym__simple_symbol] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1009),
    [sym__symbol_start] = ACTIONS(1009),
    [sym__subshell_start] = ACTIONS(1009),
    [sym__regex_start] = ACTIONS(1009),
    [sym__string_array_start] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(1009),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1009),
    [sym__block_ampersand] = ACTIONS(1009),
    [sym__splat_star] = ACTIONS(1009),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
    [sym__identifier_hash_key] = ACTIONS(1009),
  },
  [258] = {
    [sym_heredoc_body] = STATE(258),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_end] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_next] = ACTIONS(1011),
    [anon_sym_redo] = ACTIONS(1011),
    [anon_sym_retry] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_unless] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_until] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_when] = ACTIONS(1011),
    [anon_sym_elsif] = ACTIONS(1011),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_then] = ACTIONS(1011),
    [anon_sym_begin] = ACTIONS(1011),
    [anon_sym_ensure] = ACTIONS(1011),
    [anon_sym_EQ_GT] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [anon_sym_defined_QMARK] = ACTIONS(1013),
    [anon_sym_not] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1011),
    [sym_instance_variable] = ACTIONS(1013),
    [sym_class_variable] = ACTIONS(1013),
    [sym_global_variable] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [sym_complex] = ACTIONS(1013),
    [sym_super] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_TRUE] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [anon_sym_FALSE] = ACTIONS(1011),
    [sym_self] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(1011),
    [anon_sym_NIL] = ACTIONS(1011),
    [sym_character] = ACTIONS(1013),
    [anon_sym_LBRACK2] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1013),
    [sym__line_break] = ACTIONS(1013),
    [sym__simple_symbol] = ACTIONS(1013),
    [sym__string_start] = ACTIONS(1013),
    [sym__symbol_start] = ACTIONS(1013),
    [sym__subshell_start] = ACTIONS(1013),
    [sym__regex_start] = ACTIONS(1013),
    [sym__string_array_start] = ACTIONS(1013),
    [sym__symbol_array_start] = ACTIONS(1013),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1013),
    [sym__block_ampersand] = ACTIONS(1013),
    [sym__splat_star] = ACTIONS(1013),
    [sym__unary_minus] = ACTIONS(1013),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
    [sym__identifier_hash_key] = ACTIONS(1013),
  },
  [259] = {
    [sym_heredoc_body] = STATE(259),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_when] = ACTIONS(907),
    [anon_sym_elsif] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_then] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_ensure] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [260] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2936),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(260),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [261] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2951),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(261),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [262] = {
    [sym_heredoc_body] = STATE(262),
    [sym_identifier] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_module] = ACTIONS(1019),
    [anon_sym_end] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1019),
    [anon_sym_redo] = ACTIONS(1019),
    [anon_sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_unless] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_until] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(1019),
    [anon_sym_elsif] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1019),
    [anon_sym_then] = ACTIONS(1019),
    [anon_sym_begin] = ACTIONS(1019),
    [anon_sym_ensure] = ACTIONS(1019),
    [anon_sym_EQ_GT] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1019),
    [anon_sym_or] = ACTIONS(1019),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_constant] = ACTIONS(1019),
    [sym_instance_variable] = ACTIONS(1021),
    [sym_class_variable] = ACTIONS(1021),
    [sym_global_variable] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1021),
    [sym_super] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1019),
    [anon_sym_TRUE] = ACTIONS(1019),
    [anon_sym_false] = ACTIONS(1019),
    [anon_sym_FALSE] = ACTIONS(1019),
    [sym_self] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(1019),
    [anon_sym_NIL] = ACTIONS(1019),
    [sym_character] = ACTIONS(1021),
    [anon_sym_LBRACK2] = ACTIONS(1019),
    [anon_sym_DASH_GT] = ACTIONS(1021),
    [sym__line_break] = ACTIONS(1021),
    [sym__simple_symbol] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(1021),
    [sym__symbol_start] = ACTIONS(1021),
    [sym__subshell_start] = ACTIONS(1021),
    [sym__regex_start] = ACTIONS(1021),
    [sym__string_array_start] = ACTIONS(1021),
    [sym__symbol_array_start] = ACTIONS(1021),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1021),
    [sym__block_ampersand] = ACTIONS(1021),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1021),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
    [sym__identifier_hash_key] = ACTIONS(1021),
  },
  [263] = {
    [sym_heredoc_body] = STATE(263),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_end] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [anon_sym_next] = ACTIONS(1023),
    [anon_sym_redo] = ACTIONS(1023),
    [anon_sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_unless] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_until] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_when] = ACTIONS(1023),
    [anon_sym_elsif] = ACTIONS(1023),
    [anon_sym_else] = ACTIONS(1023),
    [anon_sym_then] = ACTIONS(1023),
    [anon_sym_begin] = ACTIONS(1023),
    [anon_sym_ensure] = ACTIONS(1023),
    [anon_sym_EQ_GT] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1023),
    [anon_sym_or] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_constant] = ACTIONS(1023),
    [sym_instance_variable] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1025),
    [sym_global_variable] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1025),
    [sym_super] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1023),
    [anon_sym_TRUE] = ACTIONS(1023),
    [anon_sym_false] = ACTIONS(1023),
    [anon_sym_FALSE] = ACTIONS(1023),
    [sym_self] = ACTIONS(1023),
    [anon_sym_nil] = ACTIONS(1023),
    [anon_sym_NIL] = ACTIONS(1023),
    [sym_character] = ACTIONS(1025),
    [anon_sym_LBRACK2] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1025),
    [sym__line_break] = ACTIONS(1025),
    [sym__simple_symbol] = ACTIONS(1025),
    [sym__string_start] = ACTIONS(1025),
    [sym__symbol_start] = ACTIONS(1025),
    [sym__subshell_start] = ACTIONS(1025),
    [sym__regex_start] = ACTIONS(1025),
    [sym__string_array_start] = ACTIONS(1025),
    [sym__symbol_array_start] = ACTIONS(1025),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1025),
    [sym__block_ampersand] = ACTIONS(1025),
    [sym__splat_star] = ACTIONS(1025),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
    [sym__identifier_hash_key] = ACTIONS(1025),
  },
  [264] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2953),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(264),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [265] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2954),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(265),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [266] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument_list_with_trailing_comma] = STATE(2944),
    [sym__argument] = STATE(2607),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(266),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [267] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2137),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(267),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [268] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1343),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(268),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [269] = {
    [sym_heredoc_body] = STATE(269),
    [sym_identifier] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_module] = ACTIONS(1019),
    [anon_sym_end] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1019),
    [anon_sym_redo] = ACTIONS(1019),
    [anon_sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_unless] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_until] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_when] = ACTIONS(1019),
    [anon_sym_elsif] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1019),
    [anon_sym_then] = ACTIONS(1019),
    [anon_sym_begin] = ACTIONS(1019),
    [anon_sym_ensure] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1019),
    [anon_sym_or] = ACTIONS(1019),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_constant] = ACTIONS(1019),
    [sym_instance_variable] = ACTIONS(1021),
    [sym_class_variable] = ACTIONS(1021),
    [sym_global_variable] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1021),
    [sym_super] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1019),
    [anon_sym_TRUE] = ACTIONS(1019),
    [anon_sym_false] = ACTIONS(1019),
    [anon_sym_FALSE] = ACTIONS(1019),
    [sym_self] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(1019),
    [anon_sym_NIL] = ACTIONS(1019),
    [sym_character] = ACTIONS(1021),
    [anon_sym_LBRACK2] = ACTIONS(1019),
    [anon_sym_DASH_GT] = ACTIONS(1021),
    [sym__line_break] = ACTIONS(1021),
    [sym__simple_symbol] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(1021),
    [sym__symbol_start] = ACTIONS(1021),
    [sym__subshell_start] = ACTIONS(1021),
    [sym__regex_start] = ACTIONS(1021),
    [sym__string_array_start] = ACTIONS(1021),
    [sym__symbol_array_start] = ACTIONS(1021),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1021),
    [sym__block_ampersand] = ACTIONS(1021),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1021),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
    [sym__identifier_hash_key] = ACTIONS(1021),
  },
  [270] = {
    [sym_heredoc_body] = STATE(270),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_end] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [anon_sym_next] = ACTIONS(1023),
    [anon_sym_redo] = ACTIONS(1023),
    [anon_sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_unless] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_until] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_when] = ACTIONS(1023),
    [anon_sym_elsif] = ACTIONS(1023),
    [anon_sym_else] = ACTIONS(1023),
    [anon_sym_then] = ACTIONS(1023),
    [anon_sym_begin] = ACTIONS(1023),
    [anon_sym_ensure] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1023),
    [anon_sym_or] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_constant] = ACTIONS(1023),
    [sym_instance_variable] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1025),
    [sym_global_variable] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1025),
    [sym_super] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1023),
    [anon_sym_TRUE] = ACTIONS(1023),
    [anon_sym_false] = ACTIONS(1023),
    [anon_sym_FALSE] = ACTIONS(1023),
    [sym_self] = ACTIONS(1023),
    [anon_sym_nil] = ACTIONS(1023),
    [anon_sym_NIL] = ACTIONS(1023),
    [sym_character] = ACTIONS(1025),
    [anon_sym_LBRACK2] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1025),
    [sym__line_break] = ACTIONS(1025),
    [sym__simple_symbol] = ACTIONS(1025),
    [sym__string_start] = ACTIONS(1025),
    [sym__symbol_start] = ACTIONS(1025),
    [sym__subshell_start] = ACTIONS(1025),
    [sym__regex_start] = ACTIONS(1025),
    [sym__string_array_start] = ACTIONS(1025),
    [sym__symbol_array_start] = ACTIONS(1025),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1025),
    [sym__block_ampersand] = ACTIONS(1025),
    [sym__splat_star] = ACTIONS(1025),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
    [sym__identifier_hash_key] = ACTIONS(1025),
  },
  [271] = {
    [sym_heredoc_body] = STATE(271),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_end] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_next] = ACTIONS(1003),
    [anon_sym_redo] = ACTIONS(1003),
    [anon_sym_retry] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_unless] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_when] = ACTIONS(1003),
    [anon_sym_elsif] = ACTIONS(1003),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_then] = ACTIONS(1003),
    [anon_sym_begin] = ACTIONS(1003),
    [anon_sym_ensure] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1005),
    [sym_constant] = ACTIONS(1003),
    [sym_instance_variable] = ACTIONS(1005),
    [sym_class_variable] = ACTIONS(1005),
    [sym_global_variable] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_TRUE] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_FALSE] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
    [anon_sym_nil] = ACTIONS(1003),
    [anon_sym_NIL] = ACTIONS(1003),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1005),
    [sym__line_break] = ACTIONS(1005),
    [sym__simple_symbol] = ACTIONS(1005),
    [sym__string_start] = ACTIONS(1005),
    [sym__symbol_start] = ACTIONS(1005),
    [sym__subshell_start] = ACTIONS(1005),
    [sym__regex_start] = ACTIONS(1005),
    [sym__string_array_start] = ACTIONS(1005),
    [sym__symbol_array_start] = ACTIONS(1005),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__block_ampersand] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1005),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
    [sym__identifier_hash_key] = ACTIONS(1005),
  },
  [272] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2194),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(272),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [273] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1306),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym__argument] = STATE(2097),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(1036),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(273),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(287),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(291),
    [sym__identifier_hash_key] = ACTIONS(293),
  },
  [274] = {
    [sym_heredoc_body] = STATE(274),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(1007),
    [anon_sym_end] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [anon_sym_next] = ACTIONS(1007),
    [anon_sym_redo] = ACTIONS(1007),
    [anon_sym_retry] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_until] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_when] = ACTIONS(1007),
    [anon_sym_elsif] = ACTIONS(1007),
    [anon_sym_else] = ACTIONS(1007),
    [anon_sym_then] = ACTIONS(1007),
    [anon_sym_begin] = ACTIONS(1007),
    [anon_sym_ensure] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1009),
    [anon_sym_not] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1009),
    [sym_constant] = ACTIONS(1007),
    [sym_instance_variable] = ACTIONS(1009),
    [sym_class_variable] = ACTIONS(1009),
    [sym_global_variable] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_TRUE] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_FALSE] = ACTIONS(1007),
    [sym_self] = ACTIONS(1007),
    [anon_sym_nil] = ACTIONS(1007),
    [anon_sym_NIL] = ACTIONS(1007),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1009),
    [sym__line_break] = ACTIONS(1009),
    [sym__simple_symbol] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1009),
    [sym__symbol_start] = ACTIONS(1009),
    [sym__subshell_start] = ACTIONS(1009),
    [sym__regex_start] = ACTIONS(1009),
    [sym__string_array_start] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(1009),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1009),
    [sym__block_ampersand] = ACTIONS(1009),
    [sym__splat_star] = ACTIONS(1009),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
    [sym__identifier_hash_key] = ACTIONS(1009),
  },
  [275] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2195),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(275),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [276] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2196),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(276),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [277] = {
    [sym_heredoc_body] = STATE(277),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_when] = ACTIONS(907),
    [anon_sym_elsif] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_then] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_ensure] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [278] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2197),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(278),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [279] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2199),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(279),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [280] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1643),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2895),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(982),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(280),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [281] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2111),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2886),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(983),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(281),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [282] = {
    [sym_heredoc_body] = STATE(282),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_end] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_next] = ACTIONS(1011),
    [anon_sym_redo] = ACTIONS(1011),
    [anon_sym_retry] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_unless] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_until] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_when] = ACTIONS(1011),
    [anon_sym_elsif] = ACTIONS(1011),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_then] = ACTIONS(1011),
    [anon_sym_begin] = ACTIONS(1011),
    [anon_sym_ensure] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [anon_sym_defined_QMARK] = ACTIONS(1013),
    [anon_sym_not] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1011),
    [sym_instance_variable] = ACTIONS(1013),
    [sym_class_variable] = ACTIONS(1013),
    [sym_global_variable] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [sym_complex] = ACTIONS(1013),
    [sym_super] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_TRUE] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [anon_sym_FALSE] = ACTIONS(1011),
    [sym_self] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(1011),
    [anon_sym_NIL] = ACTIONS(1011),
    [sym_character] = ACTIONS(1013),
    [anon_sym_LBRACK2] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1013),
    [sym__line_break] = ACTIONS(1013),
    [sym__simple_symbol] = ACTIONS(1013),
    [sym__string_start] = ACTIONS(1013),
    [sym__symbol_start] = ACTIONS(1013),
    [sym__subshell_start] = ACTIONS(1013),
    [sym__regex_start] = ACTIONS(1013),
    [sym__string_array_start] = ACTIONS(1013),
    [sym__symbol_array_start] = ACTIONS(1013),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1013),
    [sym__block_ampersand] = ACTIONS(1013),
    [sym__splat_star] = ACTIONS(1013),
    [sym__unary_minus] = ACTIONS(1013),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
    [sym__identifier_hash_key] = ACTIONS(1013),
  },
  [283] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1343),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(283),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [284] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1245),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym__argument] = STATE(2097),
    [sym_splat_argument] = STATE(2096),
    [sym_hash_splat_argument] = STATE(2096),
    [sym_block_argument] = STATE(2096),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(984),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(284),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_pair] = STATE(2096),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(1037),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__block_ampersand] = ACTIONS(151),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
  },
  [285] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2111),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(285),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [286] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2130),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(286),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [287] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1324),
    [sym__primary] = STATE(1386),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(7),
    [sym_call] = STATE(7),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2804),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(985),
    [sym__variable] = STATE(7),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(287),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_yield] = ACTIONS(35),
    [anon_sym_break] = ACTIONS(37),
    [anon_sym_next] = ACTIONS(39),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(9),
    [sym_instance_variable] = ACTIONS(67),
    [sym_class_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(9),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(9),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [288] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2131),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(288),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [289] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2136),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(289),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [290] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1596),
    [sym__primary] = STATE(1199),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(3),
    [sym_call] = STATE(3),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2838),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(989),
    [sym__variable] = STATE(3),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(290),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(141),
    [sym_instance_variable] = ACTIONS(139),
    [sym_class_variable] = ACTIONS(139),
    [sym_global_variable] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(141),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [291] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2121),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2827),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(959),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(291),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [292] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1843),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym__argument] = STATE(2679),
    [sym_splat_argument] = STATE(2670),
    [sym_hash_splat_argument] = STATE(2670),
    [sym_block_argument] = STATE(2670),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(292),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2670),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__block_ampersand] = ACTIONS(901),
    [sym__splat_star] = ACTIONS(903),
    [sym__unary_minus] = ACTIONS(905),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [293] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return_command] = STATE(2118),
    [sym_yield_command] = STATE(2118),
    [sym_break_command] = STATE(2118),
    [sym_next_command] = STATE(2118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__expression] = STATE(2117),
    [sym__arg] = STATE(1324),
    [sym__primary] = STATE(1267),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(4),
    [sym_call] = STATE(4),
    [sym_command_call] = STATE(2110),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_command_assignment] = STATE(2118),
    [sym_operator_assignment] = STATE(1256),
    [sym_command_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_command_binary] = STATE(2118),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2867),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(961),
    [sym__variable] = STATE(4),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(293),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(347),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_next] = ACTIONS(351),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(335),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [294] = {
    [sym_heredoc_body] = STATE(294),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_next] = ACTIONS(997),
    [anon_sym_redo] = ACTIONS(997),
    [anon_sym_retry] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [sym_constant] = ACTIONS(997),
    [sym_instance_variable] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(999),
    [sym_global_variable] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [sym_complex] = ACTIONS(999),
    [sym_super] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_TRUE] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_FALSE] = ACTIONS(997),
    [sym_self] = ACTIONS(997),
    [anon_sym_nil] = ACTIONS(997),
    [anon_sym_NIL] = ACTIONS(997),
    [sym_character] = ACTIONS(999),
    [anon_sym_LBRACK2] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [sym__line_break] = ACTIONS(999),
    [sym__simple_symbol] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
    [sym__symbol_start] = ACTIONS(999),
    [sym__subshell_start] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(999),
    [sym__symbol_array_start] = ACTIONS(999),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(999),
    [sym__block_ampersand] = ACTIONS(999),
    [sym__splat_star] = ACTIONS(999),
    [sym__unary_minus] = ACTIONS(999),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
    [sym__identifier_hash_key] = ACTIONS(999),
  },
  [295] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2361),
    [sym_yield_command] = STATE(2361),
    [sym_break_command] = STATE(2361),
    [sym_next_command] = STATE(2361),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2361),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2361),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2361),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2361),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(295),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [296] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2370),
    [sym_yield_command] = STATE(2370),
    [sym_break_command] = STATE(2370),
    [sym_next_command] = STATE(2370),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2370),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2370),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2370),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2370),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(296),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [297] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1687),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym__argument] = STATE(2218),
    [sym_splat_argument] = STATE(2218),
    [sym_hash_splat_argument] = STATE(2218),
    [sym_block_argument] = STATE(2218),
    [sym_assignment] = STATE(1687),
    [sym_operator_assignment] = STATE(1687),
    [sym_conditional] = STATE(1687),
    [sym_range] = STATE(1687),
    [sym_binary] = STATE(1687),
    [sym_unary] = STATE(1687),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1369),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(297),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_pair] = STATE(2218),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1047),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1043),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__block_ampersand] = ACTIONS(327),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(331),
    [sym__identifier_hash_key] = ACTIONS(333),
  },
  [298] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2366),
    [sym_yield_command] = STATE(2366),
    [sym_break_command] = STATE(2366),
    [sym_next_command] = STATE(2366),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2366),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2366),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2366),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2366),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(298),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [299] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2372),
    [sym_yield_command] = STATE(2372),
    [sym_break_command] = STATE(2372),
    [sym_next_command] = STATE(2372),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2372),
    [sym__arg] = STATE(1831),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1831),
    [sym_command_assignment] = STATE(2372),
    [sym_operator_assignment] = STATE(1831),
    [sym_command_operator_assignment] = STATE(2372),
    [sym_conditional] = STATE(1831),
    [sym_range] = STATE(1831),
    [sym_binary] = STATE(1831),
    [sym_command_binary] = STATE(2372),
    [sym_unary] = STATE(1831),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(299),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [300] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1625),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym__argument] = STATE(2218),
    [sym_splat_argument] = STATE(2218),
    [sym_hash_splat_argument] = STATE(2218),
    [sym_block_argument] = STATE(2218),
    [sym_assignment] = STATE(1625),
    [sym_operator_assignment] = STATE(1625),
    [sym_conditional] = STATE(1625),
    [sym_range] = STATE(1625),
    [sym_binary] = STATE(1625),
    [sym_unary] = STATE(1625),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1356),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(300),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_pair] = STATE(2218),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1059),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__block_ampersand] = ACTIONS(253),
    [sym__splat_star] = ACTIONS(255),
    [sym__unary_minus] = ACTIONS(257),
    [sym__identifier_hash_key] = ACTIONS(259),
  },
  [301] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2363),
    [sym_yield_command] = STATE(2363),
    [sym_break_command] = STATE(2363),
    [sym_next_command] = STATE(2363),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2363),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2363),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2363),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2363),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(301),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [302] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2334),
    [sym_yield_command] = STATE(2334),
    [sym_break_command] = STATE(2334),
    [sym_next_command] = STATE(2334),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2334),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2334),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2334),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2334),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(302),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [303] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2359),
    [sym_yield_command] = STATE(2359),
    [sym_break_command] = STATE(2359),
    [sym_next_command] = STATE(2359),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2359),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1143),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1143),
    [sym_assignment] = STATE(1807),
    [sym_command_assignment] = STATE(2359),
    [sym_operator_assignment] = STATE(1807),
    [sym_command_operator_assignment] = STATE(2359),
    [sym_conditional] = STATE(1807),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym_command_binary] = STATE(2359),
    [sym_unary] = STATE(1807),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2957),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1143),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1143),
    [sym_false] = STATE(1143),
    [sym_nil] = STATE(1143),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(303),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(801),
  },
  [304] = {
    [sym_method] = STATE(1597),
    [sym_singleton_method] = STATE(1597),
    [sym_class] = STATE(1597),
    [sym_singleton_class] = STATE(1597),
    [sym_module] = STATE(1597),
    [sym_return_command] = STATE(2372),
    [sym_yield_command] = STATE(2372),
    [sym_break_command] = STATE(2372),
    [sym_next_command] = STATE(2372),
    [sym_return] = STATE(1597),
    [sym_yield] = STATE(1597),
    [sym_break] = STATE(1597),
    [sym_next] = STATE(1597),
    [sym_redo] = STATE(1597),
    [sym_retry] = STATE(1597),
    [sym_while] = STATE(1597),
    [sym_until] = STATE(1597),
    [sym_for] = STATE(1597),
    [sym_case] = STATE(1597),
    [sym_if] = STATE(1597),
    [sym_unless] = STATE(1597),
    [sym_begin] = STATE(1597),
    [sym__expression] = STATE(2372),
    [sym__arg] = STATE(1717),
    [sym__primary] = STATE(1597),
    [sym_parenthesized_statements] = STATE(1597),
    [sym_element_reference] = STATE(1152),
    [sym_scope_resolution] = STATE(10),
    [sym_call] = STATE(10),
    [sym_command_call] = STATE(2325),
    [sym_method_call] = STATE(1152),
    [sym_assignment] = STATE(1717),
    [sym_command_assignment] = STATE(2372),
    [sym_operator_assignment] = STATE(1717),
    [sym_command_operator_assignment] = STATE(2372),
    [sym_conditional] = STATE(1717),
    [sym_range] = STATE(1717),
    [sym_binary] = STATE(1717),
    [sym_command_binary] = STATE(2372),
    [sym_unary] = STATE(1717),
    [sym_parenthesized_unary] = STATE(1597),
    [sym_unary_literal] = STATE(1597),
    [sym_left_assignment_list] = STATE(2969),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1152),
    [sym__variable] = STATE(10),
    [sym_rational] = STATE(1597),
    [sym_true] = STATE(1152),
    [sym_false] = STATE(1152),
    [sym_nil] = STATE(1152),
    [sym_chained_string] = STATE(1597),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1597),
    [sym_string_array] = STATE(1597),
    [sym_symbol_array] = STATE(1597),
    [sym_symbol] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_heredoc_body] = STATE(304),
    [sym_array] = STATE(1597),
    [sym_hash] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_next] = ACTIONS(765),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(749),
    [sym_instance_variable] = ACTIONS(783),
    [sym_class_variable] = ACTIONS(783),
    [sym_global_variable] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(789),
    [sym_complex] = ACTIONS(791),
    [sym_super] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(749),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(791),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(927),
  },
  [305] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(305),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [306] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2686),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(306),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2686),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [307] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(307),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [308] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(308),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [309] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(309),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2688),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [310] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(310),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [311] = {
    [sym_heredoc_body] = STATE(311),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [anon_sym___END__] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [312] = {
    [sym_heredoc_body] = STATE(312),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [anon_sym___END__] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [313] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(313),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [314] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(314),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [315] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2692),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(315),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2692),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [316] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2756),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(316),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2756),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [317] = {
    [sym_heredoc_body] = STATE(317),
    [ts_builtin_sym_end] = ACTIONS(1013),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym___END__] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_next] = ACTIONS(1011),
    [anon_sym_redo] = ACTIONS(1011),
    [anon_sym_retry] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_unless] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_until] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_begin] = ACTIONS(1011),
    [anon_sym_EQ_GT] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [anon_sym_defined_QMARK] = ACTIONS(1013),
    [anon_sym_not] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1011),
    [sym_instance_variable] = ACTIONS(1013),
    [sym_class_variable] = ACTIONS(1013),
    [sym_global_variable] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [sym_complex] = ACTIONS(1013),
    [sym_super] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_TRUE] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [anon_sym_FALSE] = ACTIONS(1011),
    [sym_self] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(1011),
    [anon_sym_NIL] = ACTIONS(1011),
    [sym_character] = ACTIONS(1013),
    [anon_sym_LBRACK2] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1013),
    [sym__line_break] = ACTIONS(1013),
    [sym__simple_symbol] = ACTIONS(1013),
    [sym__string_start] = ACTIONS(1013),
    [sym__symbol_start] = ACTIONS(1013),
    [sym__subshell_start] = ACTIONS(1013),
    [sym__regex_start] = ACTIONS(1013),
    [sym__string_array_start] = ACTIONS(1013),
    [sym__symbol_array_start] = ACTIONS(1013),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1013),
    [sym__block_ampersand] = ACTIONS(1013),
    [sym__splat_star] = ACTIONS(1013),
    [sym__unary_minus] = ACTIONS(1013),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
    [sym__identifier_hash_key] = ACTIONS(1013),
  },
  [318] = {
    [sym_heredoc_body] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [anon_sym___END__] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [319] = {
    [sym_heredoc_body] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym___END__] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [anon_sym_next] = ACTIONS(1023),
    [anon_sym_redo] = ACTIONS(1023),
    [anon_sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_unless] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_until] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_begin] = ACTIONS(1023),
    [anon_sym_EQ_GT] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1023),
    [anon_sym_or] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_constant] = ACTIONS(1023),
    [sym_instance_variable] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1025),
    [sym_global_variable] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1025),
    [sym_super] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1023),
    [anon_sym_TRUE] = ACTIONS(1023),
    [anon_sym_false] = ACTIONS(1023),
    [anon_sym_FALSE] = ACTIONS(1023),
    [sym_self] = ACTIONS(1023),
    [anon_sym_nil] = ACTIONS(1023),
    [anon_sym_NIL] = ACTIONS(1023),
    [sym_character] = ACTIONS(1025),
    [anon_sym_LBRACK2] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1025),
    [sym__line_break] = ACTIONS(1025),
    [sym__simple_symbol] = ACTIONS(1025),
    [sym__string_start] = ACTIONS(1025),
    [sym__symbol_start] = ACTIONS(1025),
    [sym__subshell_start] = ACTIONS(1025),
    [sym__regex_start] = ACTIONS(1025),
    [sym__string_array_start] = ACTIONS(1025),
    [sym__symbol_array_start] = ACTIONS(1025),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1025),
    [sym__block_ampersand] = ACTIONS(1025),
    [sym__splat_star] = ACTIONS(1025),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
    [sym__identifier_hash_key] = ACTIONS(1025),
  },
  [320] = {
    [sym_heredoc_body] = STATE(320),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [321] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(321),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [322] = {
    [sym_heredoc_body] = STATE(322),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym___END__] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_next] = ACTIONS(1003),
    [anon_sym_redo] = ACTIONS(1003),
    [anon_sym_retry] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_unless] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_begin] = ACTIONS(1003),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1005),
    [sym_constant] = ACTIONS(1003),
    [sym_instance_variable] = ACTIONS(1005),
    [sym_class_variable] = ACTIONS(1005),
    [sym_global_variable] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_TRUE] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_FALSE] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
    [anon_sym_nil] = ACTIONS(1003),
    [anon_sym_NIL] = ACTIONS(1003),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1005),
    [sym__line_break] = ACTIONS(1005),
    [sym__simple_symbol] = ACTIONS(1005),
    [sym__string_start] = ACTIONS(1005),
    [sym__symbol_start] = ACTIONS(1005),
    [sym__subshell_start] = ACTIONS(1005),
    [sym__regex_start] = ACTIONS(1005),
    [sym__string_array_start] = ACTIONS(1005),
    [sym__symbol_array_start] = ACTIONS(1005),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__block_ampersand] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1005),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
    [sym__identifier_hash_key] = ACTIONS(1005),
  },
  [323] = {
    [sym_heredoc_body] = STATE(323),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [sym_identifier] = ACTIONS(1019),
    [anon_sym___END__] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_module] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1019),
    [anon_sym_redo] = ACTIONS(1019),
    [anon_sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_unless] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_until] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_begin] = ACTIONS(1019),
    [anon_sym_EQ_GT] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1019),
    [anon_sym_or] = ACTIONS(1019),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_constant] = ACTIONS(1019),
    [sym_instance_variable] = ACTIONS(1021),
    [sym_class_variable] = ACTIONS(1021),
    [sym_global_variable] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1021),
    [sym_super] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1019),
    [anon_sym_TRUE] = ACTIONS(1019),
    [anon_sym_false] = ACTIONS(1019),
    [anon_sym_FALSE] = ACTIONS(1019),
    [sym_self] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(1019),
    [anon_sym_NIL] = ACTIONS(1019),
    [sym_character] = ACTIONS(1021),
    [anon_sym_LBRACK2] = ACTIONS(1019),
    [anon_sym_DASH_GT] = ACTIONS(1021),
    [sym__line_break] = ACTIONS(1021),
    [sym__simple_symbol] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(1021),
    [sym__symbol_start] = ACTIONS(1021),
    [sym__subshell_start] = ACTIONS(1021),
    [sym__regex_start] = ACTIONS(1021),
    [sym__string_array_start] = ACTIONS(1021),
    [sym__symbol_array_start] = ACTIONS(1021),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1021),
    [sym__block_ampersand] = ACTIONS(1021),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1021),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
    [sym__identifier_hash_key] = ACTIONS(1021),
  },
  [324] = {
    [sym_heredoc_body] = STATE(324),
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym_identifier] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_next] = ACTIONS(997),
    [anon_sym_redo] = ACTIONS(997),
    [anon_sym_retry] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [sym_constant] = ACTIONS(997),
    [sym_instance_variable] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(999),
    [sym_global_variable] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [sym_complex] = ACTIONS(999),
    [sym_super] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_TRUE] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_FALSE] = ACTIONS(997),
    [sym_self] = ACTIONS(997),
    [anon_sym_nil] = ACTIONS(997),
    [anon_sym_NIL] = ACTIONS(997),
    [sym_character] = ACTIONS(999),
    [anon_sym_LBRACK2] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [sym__line_break] = ACTIONS(999),
    [sym__simple_symbol] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
    [sym__symbol_start] = ACTIONS(999),
    [sym__subshell_start] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(999),
    [sym__symbol_array_start] = ACTIONS(999),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(999),
    [sym__block_ampersand] = ACTIONS(999),
    [sym__splat_star] = ACTIONS(999),
    [sym__unary_minus] = ACTIONS(999),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
    [sym__identifier_hash_key] = ACTIONS(999),
  },
  [325] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(325),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [326] = {
    [sym_heredoc_body] = STATE(326),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym___END__] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [anon_sym_next] = ACTIONS(1007),
    [anon_sym_redo] = ACTIONS(1007),
    [anon_sym_retry] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_until] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_begin] = ACTIONS(1007),
    [anon_sym_EQ_GT] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1009),
    [anon_sym_not] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1009),
    [sym_constant] = ACTIONS(1007),
    [sym_instance_variable] = ACTIONS(1009),
    [sym_class_variable] = ACTIONS(1009),
    [sym_global_variable] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_TRUE] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_FALSE] = ACTIONS(1007),
    [sym_self] = ACTIONS(1007),
    [anon_sym_nil] = ACTIONS(1007),
    [anon_sym_NIL] = ACTIONS(1007),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1009),
    [sym__line_break] = ACTIONS(1009),
    [sym__simple_symbol] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1009),
    [sym__symbol_start] = ACTIONS(1009),
    [sym__subshell_start] = ACTIONS(1009),
    [sym__regex_start] = ACTIONS(1009),
    [sym__string_array_start] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(1009),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1009),
    [sym__block_ampersand] = ACTIONS(1009),
    [sym__splat_star] = ACTIONS(1009),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
    [sym__identifier_hash_key] = ACTIONS(1009),
  },
  [327] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2015),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_hash_splat_argument] = STATE(2753),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(327),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_pair] = STATE(2753),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__identifier_hash_key] = ACTIONS(453),
  },
  [328] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1840),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1865),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(328),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1125),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [329] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1756),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1752),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(329),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1143),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [330] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1920),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_splat_argument] = STATE(1921),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(330),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1147),
    [sym__unary_minus] = ACTIONS(905),
  },
  [331] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1579),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1585),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(331),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(815),
    [sym__unary_minus] = ACTIONS(291),
  },
  [332] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1911),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(332),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1149),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [333] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(333),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [334] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1260),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1255),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(334),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [335] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1957),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1924),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(335),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1181),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [336] = {
    [sym_heredoc_body] = STATE(336),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym___END__] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_next] = ACTIONS(1003),
    [anon_sym_redo] = ACTIONS(1003),
    [anon_sym_retry] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_unless] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_begin] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1005),
    [sym_constant] = ACTIONS(1003),
    [sym_instance_variable] = ACTIONS(1005),
    [sym_class_variable] = ACTIONS(1005),
    [sym_global_variable] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_TRUE] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_FALSE] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
    [anon_sym_nil] = ACTIONS(1003),
    [anon_sym_NIL] = ACTIONS(1003),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1005),
    [sym__line_break] = ACTIONS(1005),
    [sym__simple_symbol] = ACTIONS(1005),
    [sym__string_start] = ACTIONS(1005),
    [sym__symbol_start] = ACTIONS(1005),
    [sym__subshell_start] = ACTIONS(1005),
    [sym__regex_start] = ACTIONS(1005),
    [sym__string_array_start] = ACTIONS(1005),
    [sym__symbol_array_start] = ACTIONS(1005),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__block_ampersand] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1005),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
    [sym__identifier_hash_key] = ACTIONS(1005),
  },
  [337] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_pattern] = STATE(2324),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1870),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(2585),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(337),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1185),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [338] = {
    [sym_heredoc_body] = STATE(338),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [sym_identifier] = ACTIONS(1019),
    [anon_sym___END__] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_module] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1019),
    [anon_sym_redo] = ACTIONS(1019),
    [anon_sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_unless] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_until] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_begin] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1019),
    [anon_sym_or] = ACTIONS(1019),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_constant] = ACTIONS(1019),
    [sym_instance_variable] = ACTIONS(1021),
    [sym_class_variable] = ACTIONS(1021),
    [sym_global_variable] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1021),
    [sym_super] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1019),
    [anon_sym_TRUE] = ACTIONS(1019),
    [anon_sym_false] = ACTIONS(1019),
    [anon_sym_FALSE] = ACTIONS(1019),
    [sym_self] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(1019),
    [anon_sym_NIL] = ACTIONS(1019),
    [sym_character] = ACTIONS(1021),
    [anon_sym_LBRACK2] = ACTIONS(1019),
    [anon_sym_DASH_GT] = ACTIONS(1021),
    [sym__line_break] = ACTIONS(1021),
    [sym__simple_symbol] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(1021),
    [sym__symbol_start] = ACTIONS(1021),
    [sym__subshell_start] = ACTIONS(1021),
    [sym__regex_start] = ACTIONS(1021),
    [sym__string_array_start] = ACTIONS(1021),
    [sym__symbol_array_start] = ACTIONS(1021),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1021),
    [sym__block_ampersand] = ACTIONS(1021),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1021),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
    [sym__identifier_hash_key] = ACTIONS(1021),
  },
  [339] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1934),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(339),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym__terminator] = STATE(2265),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1187),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [340] = {
    [sym_heredoc_body] = STATE(340),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [anon_sym___END__] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__line_break] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [341] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1718),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1739),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(341),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1199),
    [sym__unary_minus] = ACTIONS(993),
  },
  [342] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1751),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1753),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(342),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1209),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [343] = {
    [sym_heredoc_body] = STATE(343),
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym_identifier] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_next] = ACTIONS(997),
    [anon_sym_redo] = ACTIONS(997),
    [anon_sym_retry] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [sym_constant] = ACTIONS(997),
    [sym_instance_variable] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(999),
    [sym_global_variable] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [sym_complex] = ACTIONS(999),
    [sym_super] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_TRUE] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_FALSE] = ACTIONS(997),
    [sym_self] = ACTIONS(997),
    [anon_sym_nil] = ACTIONS(997),
    [anon_sym_NIL] = ACTIONS(997),
    [sym_character] = ACTIONS(999),
    [anon_sym_LBRACK2] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [sym__line_break] = ACTIONS(999),
    [sym__simple_symbol] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
    [sym__symbol_start] = ACTIONS(999),
    [sym__subshell_start] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(999),
    [sym__symbol_array_start] = ACTIONS(999),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(999),
    [sym__block_ampersand] = ACTIONS(999),
    [sym__splat_star] = ACTIONS(999),
    [sym__unary_minus] = ACTIONS(999),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
    [sym__identifier_hash_key] = ACTIONS(999),
  },
  [344] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1314),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1307),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(344),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [345] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1923),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(345),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym__terminator] = STATE(2311),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1187),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [346] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_pattern] = STATE(2575),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1870),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(2585),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(346),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1185),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [347] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1919),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1938),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(347),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1213),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [348] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1261),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1277),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(348),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(815),
    [sym__unary_minus] = ACTIONS(291),
  },
  [349] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1955),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1928),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(349),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1181),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [350] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1764),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_splat_argument] = STATE(1815),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(350),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1147),
    [sym__unary_minus] = ACTIONS(905),
  },
  [351] = {
    [sym_heredoc_body] = STATE(351),
    [ts_builtin_sym_end] = ACTIONS(1013),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym___END__] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_next] = ACTIONS(1011),
    [anon_sym_redo] = ACTIONS(1011),
    [anon_sym_retry] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_unless] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_until] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_begin] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [anon_sym_defined_QMARK] = ACTIONS(1013),
    [anon_sym_not] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1011),
    [sym_instance_variable] = ACTIONS(1013),
    [sym_class_variable] = ACTIONS(1013),
    [sym_global_variable] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [sym_complex] = ACTIONS(1013),
    [sym_super] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_TRUE] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [anon_sym_FALSE] = ACTIONS(1011),
    [sym_self] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(1011),
    [anon_sym_NIL] = ACTIONS(1011),
    [sym_character] = ACTIONS(1013),
    [anon_sym_LBRACK2] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1013),
    [sym__line_break] = ACTIONS(1013),
    [sym__simple_symbol] = ACTIONS(1013),
    [sym__string_start] = ACTIONS(1013),
    [sym__symbol_start] = ACTIONS(1013),
    [sym__subshell_start] = ACTIONS(1013),
    [sym__regex_start] = ACTIONS(1013),
    [sym__string_array_start] = ACTIONS(1013),
    [sym__symbol_array_start] = ACTIONS(1013),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1013),
    [sym__block_ampersand] = ACTIONS(1013),
    [sym__splat_star] = ACTIONS(1013),
    [sym__unary_minus] = ACTIONS(1013),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
    [sym__identifier_hash_key] = ACTIONS(1013),
  },
  [352] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1728),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1731),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_right_assignment_list] = STATE(1636),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(352),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1213),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [353] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1903),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1835),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(353),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1143),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [354] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1939),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(354),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym__terminator] = STATE(2267),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1187),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [355] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1811),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1793),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(355),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1209),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [356] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1225),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1229),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(356),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1215),
    [sym__unary_minus] = ACTIONS(155),
  },
  [357] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1312),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1303),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_right_assignment_list] = STATE(1235),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(357),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [358] = {
    [sym_heredoc_body] = STATE(358),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym___END__] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [anon_sym_next] = ACTIONS(1007),
    [anon_sym_redo] = ACTIONS(1007),
    [anon_sym_retry] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_until] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_begin] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1009),
    [anon_sym_not] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1009),
    [sym_constant] = ACTIONS(1007),
    [sym_instance_variable] = ACTIONS(1009),
    [sym_class_variable] = ACTIONS(1009),
    [sym_global_variable] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_TRUE] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_FALSE] = ACTIONS(1007),
    [sym_self] = ACTIONS(1007),
    [anon_sym_nil] = ACTIONS(1007),
    [anon_sym_NIL] = ACTIONS(1007),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1009),
    [sym__line_break] = ACTIONS(1009),
    [sym__simple_symbol] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1009),
    [sym__symbol_start] = ACTIONS(1009),
    [sym__subshell_start] = ACTIONS(1009),
    [sym__regex_start] = ACTIONS(1009),
    [sym__string_array_start] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(1009),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1009),
    [sym__block_ampersand] = ACTIONS(1009),
    [sym__splat_star] = ACTIONS(1009),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
    [sym__identifier_hash_key] = ACTIONS(1009),
  },
  [359] = {
    [sym_heredoc_body] = STATE(359),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym___END__] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [anon_sym_next] = ACTIONS(1023),
    [anon_sym_redo] = ACTIONS(1023),
    [anon_sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_unless] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_until] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_begin] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1023),
    [anon_sym_or] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_constant] = ACTIONS(1023),
    [sym_instance_variable] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1025),
    [sym_global_variable] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1025),
    [sym_super] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1023),
    [anon_sym_TRUE] = ACTIONS(1023),
    [anon_sym_false] = ACTIONS(1023),
    [anon_sym_FALSE] = ACTIONS(1023),
    [sym_self] = ACTIONS(1023),
    [anon_sym_nil] = ACTIONS(1023),
    [anon_sym_NIL] = ACTIONS(1023),
    [sym_character] = ACTIONS(1025),
    [anon_sym_LBRACK2] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1025),
    [sym__line_break] = ACTIONS(1025),
    [sym__simple_symbol] = ACTIONS(1025),
    [sym__string_start] = ACTIONS(1025),
    [sym__symbol_start] = ACTIONS(1025),
    [sym__subshell_start] = ACTIONS(1025),
    [sym__regex_start] = ACTIONS(1025),
    [sym__string_array_start] = ACTIONS(1025),
    [sym__symbol_array_start] = ACTIONS(1025),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1025),
    [sym__block_ampersand] = ACTIONS(1025),
    [sym__splat_star] = ACTIONS(1025),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
    [sym__identifier_hash_key] = ACTIONS(1025),
  },
  [360] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1904),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(360),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1143),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [361] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1691),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_splat_argument] = STATE(1710),
    [sym_assignment] = STATE(1691),
    [sym_operator_assignment] = STATE(1691),
    [sym_conditional] = STATE(1691),
    [sym_range] = STATE(1691),
    [sym_binary] = STATE(1691),
    [sym_unary] = STATE(1691),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(361),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(927),
  },
  [362] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1669),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_splat_argument] = STATE(1657),
    [sym_assignment] = STATE(1669),
    [sym_operator_assignment] = STATE(1669),
    [sym_conditional] = STATE(1669),
    [sym_range] = STATE(1669),
    [sym_binary] = STATE(1669),
    [sym_unary] = STATE(1669),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(362),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1227),
    [sym__unary_minus] = ACTIONS(331),
  },
  [363] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1970),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(363),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym__terminator] = STATE(2387),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__line_break] = ACTIONS(1187),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [364] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1647),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_splat_argument] = STATE(1604),
    [sym_assignment] = STATE(1647),
    [sym_operator_assignment] = STATE(1647),
    [sym_conditional] = STATE(1647),
    [sym_range] = STATE(1647),
    [sym_binary] = STATE(1647),
    [sym_unary] = STATE(1647),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(364),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(255),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [365] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1284),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(365),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [366] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1289),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(366),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(815),
    [sym__unary_minus] = ACTIONS(291),
  },
  [367] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1593),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_splat_argument] = STATE(1594),
    [sym_assignment] = STATE(1593),
    [sym_operator_assignment] = STATE(1593),
    [sym_conditional] = STATE(1593),
    [sym_range] = STATE(1593),
    [sym_binary] = STATE(1593),
    [sym_unary] = STATE(1593),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(367),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1243),
    [sym__unary_minus] = ACTIONS(257),
  },
  [368] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2003),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(368),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [369] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1849),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_splat_argument] = STATE(1628),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(369),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1147),
    [sym__unary_minus] = ACTIONS(905),
  },
  [370] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1242),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(370),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1215),
    [sym__unary_minus] = ACTIONS(155),
  },
  [371] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1916),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1628),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(371),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1125),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [372] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1905),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(372),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1209),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [373] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1776),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(373),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(1199),
    [sym__unary_minus] = ACTIONS(993),
  },
  [374] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1692),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_splat_argument] = STATE(1716),
    [sym_assignment] = STATE(1692),
    [sym_operator_assignment] = STATE(1692),
    [sym_conditional] = STATE(1692),
    [sym_range] = STATE(1692),
    [sym_binary] = STATE(1692),
    [sym_unary] = STATE(1692),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_right_assignment_list] = STATE(1651),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(374),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(927),
  },
  [375] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1972),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1628),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(375),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1181),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [376] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1828),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(1628),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(376),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__splat_star] = ACTIONS(1213),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [377] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1801),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_splat_argument] = STATE(2528),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(377),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(991),
    [sym__unary_minus] = ACTIONS(993),
  },
  [378] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1937),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(378),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [379] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1316),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_splat_argument] = STATE(1238),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(379),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__splat_star] = ACTIONS(289),
    [sym__unary_minus] = ACTIONS(811),
  },
  [380] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1658),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_splat_argument] = STATE(1652),
    [sym_assignment] = STATE(1658),
    [sym_operator_assignment] = STATE(1658),
    [sym_conditional] = STATE(1658),
    [sym_range] = STATE(1658),
    [sym_binary] = STATE(1658),
    [sym_unary] = STATE(1658),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(380),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(255),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [381] = {
    [sym_heredoc_body] = STATE(381),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(1247),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [382] = {
    [sym_heredoc_body] = STATE(382),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COLON_COLON] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_next] = ACTIONS(907),
    [anon_sym_redo] = ACTIONS(907),
    [anon_sym_retry] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_unless] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_rescue] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_begin] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(909),
    [sym_constant] = ACTIONS(907),
    [sym_instance_variable] = ACTIONS(909),
    [sym_class_variable] = ACTIONS(909),
    [sym_global_variable] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [sym_complex] = ACTIONS(909),
    [sym_super] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_TRUE] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [anon_sym_FALSE] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [anon_sym_nil] = ACTIONS(907),
    [anon_sym_NIL] = ACTIONS(907),
    [sym_character] = ACTIONS(909),
    [anon_sym_LBRACK2] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(909),
    [sym__simple_symbol] = ACTIONS(909),
    [sym__string_start] = ACTIONS(909),
    [sym__symbol_start] = ACTIONS(909),
    [sym__subshell_start] = ACTIONS(909),
    [sym__regex_start] = ACTIONS(909),
    [sym__string_array_start] = ACTIONS(909),
    [sym__symbol_array_start] = ACTIONS(909),
    [sym_heredoc_beginning] = ACTIONS(909),
    [sym__block_ampersand] = ACTIONS(909),
    [sym__splat_star] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(909),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_hash_key] = ACTIONS(909),
  },
  [383] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1683),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_splat_argument] = STATE(1652),
    [sym_assignment] = STATE(1683),
    [sym_operator_assignment] = STATE(1683),
    [sym_conditional] = STATE(1683),
    [sym_range] = STATE(1683),
    [sym_binary] = STATE(1683),
    [sym_unary] = STATE(1683),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(383),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1227),
    [sym__unary_minus] = ACTIONS(331),
  },
  [384] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1737),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_splat_argument] = STATE(1652),
    [sym_assignment] = STATE(1737),
    [sym_operator_assignment] = STATE(1737),
    [sym_conditional] = STATE(1737),
    [sym_range] = STATE(1737),
    [sym_binary] = STATE(1737),
    [sym_unary] = STATE(1737),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(384),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__splat_star] = ACTIONS(329),
    [sym__unary_minus] = ACTIONS(927),
  },
  [385] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1619),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_splat_argument] = STATE(1652),
    [sym_assignment] = STATE(1619),
    [sym_operator_assignment] = STATE(1619),
    [sym_conditional] = STATE(1619),
    [sym_range] = STATE(1619),
    [sym_binary] = STATE(1619),
    [sym_unary] = STATE(1619),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(385),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__splat_star] = ACTIONS(1243),
    [sym__unary_minus] = ACTIONS(257),
  },
  [386] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1852),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(386),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [387] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1344),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(387),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [388] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1327),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(388),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [389] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1326),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(389),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [390] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1325),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(390),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [391] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1824),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(391),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [392] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1354),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(392),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [393] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1352),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(393),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [394] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(394),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [395] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(395),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [396] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2022),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(396),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [397] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2023),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(397),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [398] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2025),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(398),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [399] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1323),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(399),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [400] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2004),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(400),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [401] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1998),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(401),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [402] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2000),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(402),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [403] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(403),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [404] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1823),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(404),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [405] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2001),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(405),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [406] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1821),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(406),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [407] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1818),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(407),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [408] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(408),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [409] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1816),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(409),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [410] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1814),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(410),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [411] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1813),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(411),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [412] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1273),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(412),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [413] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1812),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(413),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [414] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1810),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(414),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [415] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1809),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(415),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [416] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(416),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [417] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1233),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(417),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [418] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1259),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(418),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [419] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1750),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(419),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [420] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1283),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(420),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [421] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1253),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(421),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [422] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1262),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(422),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [423] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1850),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(423),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [424] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1960),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(424),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [425] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2043),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(425),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [426] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1959),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(426),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [427] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1766),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(427),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [428] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1958),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(428),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [429] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1956),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(429),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [430] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1802),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(430),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [431] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1954),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(431),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [432] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1953),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(432),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [433] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1949),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(433),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [434] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1947),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(434),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [435] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1946),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(435),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [436] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1944),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(436),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [437] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2059),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(437),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [438] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1943),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(438),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [439] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1941),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(439),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [440] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1914),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(440),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [441] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(441),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [442] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(442),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [443] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1800),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(443),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [444] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1610),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(444),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [445] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1608),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(445),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [446] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1606),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(446),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [447] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1908),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(447),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [448] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1799),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(448),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [449] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1889),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(449),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [450] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(450),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [451] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1887),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(451),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [452] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1798),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(452),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [453] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1886),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(453),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [454] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1883),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(454),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [455] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1797),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(455),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [456] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1882),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(456),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [457] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1880),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(457),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [458] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1879),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(458),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [459] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1796),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(459),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [460] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1893),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(460),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1279),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [461] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1894),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(461),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [462] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1878),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(462),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [463] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(463),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [464] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(464),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [465] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1874),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(465),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [466] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1872),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(466),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [467] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1348),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(467),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [468] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1795),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(468),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [469] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1794),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(469),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [470] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1792),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(470),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [471] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1786),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(471),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [472] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1785),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(472),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [473] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1771),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(473),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [474] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1749),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(474),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [475] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1301),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(475),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [476] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1330),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(476),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [477] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1318),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(477),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [478] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1900),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(478),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [479] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1901),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(479),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [480] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1902),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(480),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [481] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(481),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [482] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1287),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(482),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [483] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(483),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [484] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1804),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(484),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [485] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2007),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(485),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [486] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2008),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(486),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [487] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1884),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(487),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [488] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1881),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(488),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [489] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1875),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(489),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [490] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1873),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(490),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [491] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1869),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(491),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [492] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1866),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(492),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [493] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1864),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(493),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [494] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1863),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(494),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [495] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1862),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(495),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [496] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1315),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(496),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [497] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1895),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(497),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [498] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1966),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(498),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [499] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(499),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [500] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1861),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(500),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [501] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1896),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(501),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1279),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [502] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1897),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(502),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [503] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1860),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(503),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [504] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1898),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(504),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [505] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2019),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(505),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [506] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(506),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [507] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2020),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(507),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [508] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1913),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(508),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [509] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(509),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [510] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2011),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(510),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [511] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2050),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(511),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [512] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1331),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(512),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [513] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2048),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(513),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [514] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1803),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(514),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [515] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1332),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(515),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [516] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1859),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(516),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [517] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1885),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2829),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1201),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(517),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(905),
  },
  [518] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1279),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(518),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [519] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1280),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(519),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [520] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(520),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [521] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2056),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(521),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [522] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2021),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(522),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [523] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2012),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(523),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [524] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1767),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(524),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [525] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1891),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(525),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [526] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1322),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(526),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [527] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1892),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(527),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [528] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1942),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(528),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [529] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(529),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [530] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(530),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [531] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(2002),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(531),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [532] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1337),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(532),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [533] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1980),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(533),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [534] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1983),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(534),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1279),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [535] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2064),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(535),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [536] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1336),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(536),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [537] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2053),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(537),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [538] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1761),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(538),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [539] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2029),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(539),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [540] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1317),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(540),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [541] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1848),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(541),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [542] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2032),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(542),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [543] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2033),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(543),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [544] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2034),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(544),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [545] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1936),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(545),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [546] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2035),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(546),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [547] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2036),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(547),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [548] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(548),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [549] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2037),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(549),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [550] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1932),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(550),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [551] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1931),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(551),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [552] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2038),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(552),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [553] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2005),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(553),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [554] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(554),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [555] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2040),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(555),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [556] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2041),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(556),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [557] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2042),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(557),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [558] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1930),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(558),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [559] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2051),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(559),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [560] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1929),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(560),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [561] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1910),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(561),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [562] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1909),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(562),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [563] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1940),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(563),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [564] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1925),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(564),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [565] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1963),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(565),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [566] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1962),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(566),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [567] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(567),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [568] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1961),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(568),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [569] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1329),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(569),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [570] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1759),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(570),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [571] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1773),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(571),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [572] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2013),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(572),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [573] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1758),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(573),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [574] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1251),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(574),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [575] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1250),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(575),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [576] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1249),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(576),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [577] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1230),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(577),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [578] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1248),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(578),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [579] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(579),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [580] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1282),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(580),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [581] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2010),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(581),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [582] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2067),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(582),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [583] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(583),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [584] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(584),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [585] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1244),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(585),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [586] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1241),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(586),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [587] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1899),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(587),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [588] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1239),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(588),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [589] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1236),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(589),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [590] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1266),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(590),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [591] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1231),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(591),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [592] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1313),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(592),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [593] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2061),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(593),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [594] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1232),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(594),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [595] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2016),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(595),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [596] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2054),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(596),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [597] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1973),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(597),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [598] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1342),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(598),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [599] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1974),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(599),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [600] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1975),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(600),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [601] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1976),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(601),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [602] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1977),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(602),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [603] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(603),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [604] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1922),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(604),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [605] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1979),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(605),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [606] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1981),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(606),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [607] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1990),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(607),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [608] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1992),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(608),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [609] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1993),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(609),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [610] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1290),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(610),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [611] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1994),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(611),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [612] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1294),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(612),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [613] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(613),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [614] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1292),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(614),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [615] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2014),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(615),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [616] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1755),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(616),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [617] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1351),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(617),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [618] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1926),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(618),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [619] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1297),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(619),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [620] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1754),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(620),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [621] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2055),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(621),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [622] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2018),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(622),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [623] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1952),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(623),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [624] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1295),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(624),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [625] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1288),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(625),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [626] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1291),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(626),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [627] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1296),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(627),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [628] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1298),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(628),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [629] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(629),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [630] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1302),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(630),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [631] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1304),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(631),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [632] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1305),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(632),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [633] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1308),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2896),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(937),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(633),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_defined_QMARK] = ACTIONS(279),
    [anon_sym_not] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(291),
  },
  [634] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1321),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(634),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [635] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1319),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(635),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [636] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1320),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(636),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [637] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1951),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(637),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [638] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1969),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(638),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [639] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1950),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(639),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [640] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1254),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(876),
    [sym_call] = STATE(876),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(888),
    [sym__variable] = STATE(876),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(640),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_defined_QMARK] = ACTIONS(131),
    [anon_sym_not] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(137),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(155),
  },
  [641] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2052),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(641),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [642] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2006),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(642),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [643] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2049),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(643),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [644] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2047),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(644),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [645] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2046),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(645),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [646] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2045),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(646),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [647] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1868),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(647),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [648] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2044),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(648),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [649] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2031),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(649),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [650] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2028),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(650),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [651] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2027),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(651),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [652] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1820),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(652),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [653] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2026),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(653),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [654] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1933),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(654),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [655] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1907),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(655),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [656] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1965),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(656),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [657] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(657),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [658] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1867),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(658),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [659] = {
    [sym_heredoc_body] = STATE(659),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [anon_sym_next] = ACTIONS(1023),
    [anon_sym_redo] = ACTIONS(1023),
    [anon_sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_unless] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_until] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_begin] = ACTIONS(1023),
    [anon_sym_EQ_GT] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1023),
    [anon_sym_or] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_constant] = ACTIONS(1023),
    [sym_instance_variable] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1025),
    [sym_global_variable] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1025),
    [sym_super] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1023),
    [anon_sym_TRUE] = ACTIONS(1023),
    [anon_sym_false] = ACTIONS(1023),
    [anon_sym_FALSE] = ACTIONS(1023),
    [sym_self] = ACTIONS(1023),
    [anon_sym_nil] = ACTIONS(1023),
    [anon_sym_NIL] = ACTIONS(1023),
    [sym_character] = ACTIONS(1025),
    [anon_sym_LBRACK2] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1025),
    [sym__simple_symbol] = ACTIONS(1025),
    [sym__string_start] = ACTIONS(1025),
    [sym__symbol_start] = ACTIONS(1025),
    [sym__subshell_start] = ACTIONS(1025),
    [sym__regex_start] = ACTIONS(1025),
    [sym__string_array_start] = ACTIONS(1025),
    [sym__symbol_array_start] = ACTIONS(1025),
    [sym_heredoc_beginning] = ACTIONS(1025),
    [sym__block_ampersand] = ACTIONS(1025),
    [sym__splat_star] = ACTIONS(1025),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
    [sym__identifier_hash_key] = ACTIONS(1025),
  },
  [660] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2017),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(660),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [661] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1858),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(661),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [662] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1857),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(662),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [663] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1856),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(663),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [664] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1906),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(664),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [665] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(665),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [666] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1935),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1138),
    [sym_call] = STATE(1138),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2794),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1210),
    [sym__variable] = STATE(1138),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(666),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_defined_QMARK] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1127),
  },
  [667] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1853),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(667),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [668] = {
    [sym_heredoc_body] = STATE(668),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_next] = ACTIONS(1011),
    [anon_sym_redo] = ACTIONS(1011),
    [anon_sym_retry] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_unless] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_until] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_begin] = ACTIONS(1011),
    [anon_sym_EQ_GT] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [anon_sym_defined_QMARK] = ACTIONS(1013),
    [anon_sym_not] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1011),
    [sym_instance_variable] = ACTIONS(1013),
    [sym_class_variable] = ACTIONS(1013),
    [sym_global_variable] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [sym_complex] = ACTIONS(1013),
    [sym_super] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_TRUE] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [anon_sym_FALSE] = ACTIONS(1011),
    [sym_self] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(1011),
    [anon_sym_NIL] = ACTIONS(1011),
    [sym_character] = ACTIONS(1013),
    [anon_sym_LBRACK2] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1013),
    [sym__simple_symbol] = ACTIONS(1013),
    [sym__string_start] = ACTIONS(1013),
    [sym__symbol_start] = ACTIONS(1013),
    [sym__subshell_start] = ACTIONS(1013),
    [sym__regex_start] = ACTIONS(1013),
    [sym__string_array_start] = ACTIONS(1013),
    [sym__symbol_array_start] = ACTIONS(1013),
    [sym_heredoc_beginning] = ACTIONS(1013),
    [sym__block_ampersand] = ACTIONS(1013),
    [sym__splat_star] = ACTIONS(1013),
    [sym__unary_minus] = ACTIONS(1013),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
    [sym__identifier_hash_key] = ACTIONS(1013),
  },
  [669] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1986),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(669),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [670] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1985),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(670),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [671] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1851),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(671),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [672] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1847),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(672),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [673] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1846),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(673),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [674] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1845),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(674),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [675] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2788),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(675),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_defined_QMARK] = ACTIONS(1203),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1211),
  },
  [676] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1784),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(676),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1279),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [677] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2009),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(677),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [678] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(678),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [679] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1782),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(679),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [680] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(680),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1279),
    [sym_float] = ACTIONS(1267),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [681] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1984),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(681),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [682] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1982),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(682),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [683] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(683),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [684] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1618),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(684),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [685] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1991),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(685),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [686] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1917),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(686),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [687] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1918),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1131),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(687),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [688] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(688),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [689] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1989),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(689),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [690] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1988),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(690),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [691] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1971),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(691),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [692] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1257),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2811),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1196),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(692),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_defined_QMARK] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(993),
  },
  [693] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1964),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(693),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [694] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1270),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(694),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [695] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1268),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(695),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [696] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1286),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(696),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [697] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1263),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(697),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [698] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1264),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(698),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [699] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1265),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(699),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [700] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1269),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(700),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [701] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1272),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(701),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [702] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1275),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(702),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [703] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1276),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(703),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [704] = {
    [sym_heredoc_body] = STATE(704),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [anon_sym_next] = ACTIONS(1007),
    [anon_sym_redo] = ACTIONS(1007),
    [anon_sym_retry] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_until] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_begin] = ACTIONS(1007),
    [anon_sym_EQ_GT] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1009),
    [anon_sym_not] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1009),
    [sym_constant] = ACTIONS(1007),
    [sym_instance_variable] = ACTIONS(1009),
    [sym_class_variable] = ACTIONS(1009),
    [sym_global_variable] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_TRUE] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_FALSE] = ACTIONS(1007),
    [sym_self] = ACTIONS(1007),
    [anon_sym_nil] = ACTIONS(1007),
    [anon_sym_NIL] = ACTIONS(1007),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1009),
    [sym__simple_symbol] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1009),
    [sym__symbol_start] = ACTIONS(1009),
    [sym__subshell_start] = ACTIONS(1009),
    [sym__regex_start] = ACTIONS(1009),
    [sym__string_array_start] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(1009),
    [sym_heredoc_beginning] = ACTIONS(1009),
    [sym__block_ampersand] = ACTIONS(1009),
    [sym__splat_star] = ACTIONS(1009),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
    [sym__identifier_hash_key] = ACTIONS(1009),
  },
  [705] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1278),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(705),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [706] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2066),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(706),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [707] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1967),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(707),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [708] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1912),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2792),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1202),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(708),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_defined_QMARK] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1145),
  },
  [709] = {
    [sym_heredoc_body] = STATE(709),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_next] = ACTIONS(997),
    [anon_sym_redo] = ACTIONS(997),
    [anon_sym_retry] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [sym_constant] = ACTIONS(997),
    [sym_instance_variable] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(999),
    [sym_global_variable] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [sym_complex] = ACTIONS(999),
    [sym_super] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_TRUE] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_FALSE] = ACTIONS(997),
    [sym_self] = ACTIONS(997),
    [anon_sym_nil] = ACTIONS(997),
    [anon_sym_NIL] = ACTIONS(997),
    [sym_character] = ACTIONS(999),
    [anon_sym_LBRACK2] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [sym__simple_symbol] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
    [sym__symbol_start] = ACTIONS(999),
    [sym__subshell_start] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(999),
    [sym__symbol_array_start] = ACTIONS(999),
    [sym_heredoc_beginning] = ACTIONS(999),
    [sym__block_ampersand] = ACTIONS(999),
    [sym__splat_star] = ACTIONS(999),
    [sym__unary_minus] = ACTIONS(999),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
    [sym__identifier_hash_key] = ACTIONS(999),
  },
  [710] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2063),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(710),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [711] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(711),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [712] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2072),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(712),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [713] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(713),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [714] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2073),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(714),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [715] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2071),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(715),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [716] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1281),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2904),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(899),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(716),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_defined_QMARK] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1169),
  },
  [717] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2065),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(717),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [718] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2062),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(718),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [719] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2060),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(719),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [720] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2058),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(720),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [721] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2057),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(721),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [722] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1760),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(722),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [723] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1353),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(723),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [724] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1341),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(724),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [725] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1345),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(725),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [726] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1641),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(726),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [727] = {
    [sym_heredoc_body] = STATE(727),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_next] = ACTIONS(1003),
    [anon_sym_redo] = ACTIONS(1003),
    [anon_sym_retry] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_unless] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_begin] = ACTIONS(1003),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1005),
    [sym_constant] = ACTIONS(1003),
    [sym_instance_variable] = ACTIONS(1005),
    [sym_class_variable] = ACTIONS(1005),
    [sym_global_variable] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_TRUE] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_FALSE] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
    [anon_sym_nil] = ACTIONS(1003),
    [anon_sym_NIL] = ACTIONS(1003),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1005),
    [sym__simple_symbol] = ACTIONS(1005),
    [sym__string_start] = ACTIONS(1005),
    [sym__symbol_start] = ACTIONS(1005),
    [sym__subshell_start] = ACTIONS(1005),
    [sym__regex_start] = ACTIONS(1005),
    [sym__string_array_start] = ACTIONS(1005),
    [sym__symbol_array_start] = ACTIONS(1005),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__block_ampersand] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1005),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
    [sym__identifier_hash_key] = ACTIONS(1005),
  },
  [728] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1649),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(728),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [729] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1645),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(729),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [730] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1650),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(730),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [731] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1639),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(731),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [732] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1638),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(732),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [733] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1637),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(733),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [734] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1603),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(734),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [735] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(735),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [736] = {
    [sym_heredoc_body] = STATE(736),
    [sym_identifier] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_module] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1019),
    [anon_sym_redo] = ACTIONS(1019),
    [anon_sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_unless] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_until] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_begin] = ACTIONS(1019),
    [anon_sym_EQ_GT] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1019),
    [anon_sym_or] = ACTIONS(1019),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_constant] = ACTIONS(1019),
    [sym_instance_variable] = ACTIONS(1021),
    [sym_class_variable] = ACTIONS(1021),
    [sym_global_variable] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1021),
    [sym_super] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1019),
    [anon_sym_TRUE] = ACTIONS(1019),
    [anon_sym_false] = ACTIONS(1019),
    [anon_sym_FALSE] = ACTIONS(1019),
    [sym_self] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(1019),
    [anon_sym_NIL] = ACTIONS(1019),
    [sym_character] = ACTIONS(1021),
    [anon_sym_LBRACK2] = ACTIONS(1019),
    [anon_sym_DASH_GT] = ACTIONS(1021),
    [sym__simple_symbol] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(1021),
    [sym__symbol_start] = ACTIONS(1021),
    [sym__subshell_start] = ACTIONS(1021),
    [sym__regex_start] = ACTIONS(1021),
    [sym__string_array_start] = ACTIONS(1021),
    [sym__symbol_array_start] = ACTIONS(1021),
    [sym_heredoc_beginning] = ACTIONS(1021),
    [sym__block_ampersand] = ACTIONS(1021),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1021),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
    [sym__identifier_hash_key] = ACTIONS(1021),
  },
  [737] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2024),
    [sym__primary] = STATE(1676),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1227),
    [sym_scope_resolution] = STATE(998),
    [sym_call] = STATE(998),
    [sym_method_call] = STATE(1227),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2846),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1258),
    [sym__variable] = STATE(998),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1227),
    [sym_false] = STATE(1227),
    [sym_nil] = STATE(1227),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(737),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(875),
    [sym_instance_variable] = ACTIONS(867),
    [sym_class_variable] = ACTIONS(867),
    [sym_global_variable] = ACTIONS(867),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_TRUE] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(879),
    [anon_sym_FALSE] = ACTIONS(879),
    [sym_self] = ACTIONS(875),
    [anon_sym_nil] = ACTIONS(881),
    [anon_sym_NIL] = ACTIONS(881),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1079),
  },
  [738] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1646),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(738),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [739] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1629),
    [sym__primary] = STATE(1114),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(907),
    [sym_scope_resolution] = STATE(877),
    [sym_call] = STATE(877),
    [sym_method_call] = STATE(907),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2796),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(986),
    [sym__variable] = STATE(877),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(907),
    [sym_false] = STATE(907),
    [sym_nil] = STATE(907),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(739),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_defined_QMARK] = ACTIONS(445),
    [anon_sym_not] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_constant] = ACTIONS(971),
    [sym_instance_variable] = ACTIONS(987),
    [sym_class_variable] = ACTIONS(987),
    [sym_global_variable] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(145),
    [anon_sym_FALSE] = ACTIONS(145),
    [sym_self] = ACTIONS(971),
    [anon_sym_nil] = ACTIONS(147),
    [anon_sym_NIL] = ACTIONS(147),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(451),
  },
  [740] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1333),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(740),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [741] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1334),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2806),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(951),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(741),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_defined_QMARK] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(811),
  },
  [742] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2070),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(742),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [743] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1338),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(743),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [744] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1339),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(744),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [745] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1358),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(745),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [746] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1347),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(746),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [747] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1350),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(747),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [748] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1349),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2892),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(950),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(748),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_defined_QMARK] = ACTIONS(61),
    [anon_sym_not] = ACTIONS(63),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_TILDE] = ACTIONS(65),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(75),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(105),
  },
  [749] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1995),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2897),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1246),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(749),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_defined_QMARK] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1177),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1183),
  },
  [750] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1653),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(750),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [751] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(1763),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1511),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1195),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(751),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_defined_QMARK] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_TILDE] = ACTIONS(1157),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1159),
  },
  [752] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1788),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1788),
    [sym_operator_assignment] = STATE(1788),
    [sym_conditional] = STATE(1788),
    [sym_range] = STATE(1788),
    [sym_binary] = STATE(1788),
    [sym_unary] = STATE(1788),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(752),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [753] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1668),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1668),
    [sym_operator_assignment] = STATE(1668),
    [sym_conditional] = STATE(1668),
    [sym_range] = STATE(1668),
    [sym_binary] = STATE(1668),
    [sym_unary] = STATE(1668),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(753),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [754] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1661),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1661),
    [sym_operator_assignment] = STATE(1661),
    [sym_conditional] = STATE(1661),
    [sym_range] = STATE(1661),
    [sym_binary] = STATE(1661),
    [sym_unary] = STATE(1661),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(754),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [755] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1745),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1745),
    [sym_operator_assignment] = STATE(1745),
    [sym_conditional] = STATE(1745),
    [sym_range] = STATE(1745),
    [sym_binary] = STATE(1745),
    [sym_unary] = STATE(1745),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(755),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [756] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1742),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1742),
    [sym_operator_assignment] = STATE(1742),
    [sym_conditional] = STATE(1742),
    [sym_range] = STATE(1742),
    [sym_binary] = STATE(1742),
    [sym_unary] = STATE(1742),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(756),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [757] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1741),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1741),
    [sym_operator_assignment] = STATE(1741),
    [sym_conditional] = STATE(1741),
    [sym_range] = STATE(1741),
    [sym_binary] = STATE(1741),
    [sym_unary] = STATE(1741),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(757),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [758] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1727),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1727),
    [sym_operator_assignment] = STATE(1727),
    [sym_conditional] = STATE(1727),
    [sym_range] = STATE(1727),
    [sym_binary] = STATE(1727),
    [sym_unary] = STATE(1727),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(758),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [759] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1729),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1729),
    [sym_operator_assignment] = STATE(1729),
    [sym_conditional] = STATE(1729),
    [sym_range] = STATE(1729),
    [sym_binary] = STATE(1729),
    [sym_unary] = STATE(1729),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(759),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [760] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1732),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1732),
    [sym_operator_assignment] = STATE(1732),
    [sym_conditional] = STATE(1732),
    [sym_range] = STATE(1732),
    [sym_binary] = STATE(1732),
    [sym_unary] = STATE(1732),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(760),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [761] = {
    [sym_heredoc_body] = STATE(761),
    [sym_identifier] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COLON_COLON] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_module] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1019),
    [anon_sym_redo] = ACTIONS(1019),
    [anon_sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_unless] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_until] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_begin] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1019),
    [anon_sym_or] = ACTIONS(1019),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1021),
    [sym_constant] = ACTIONS(1019),
    [sym_instance_variable] = ACTIONS(1021),
    [sym_class_variable] = ACTIONS(1021),
    [sym_global_variable] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1021),
    [sym_super] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1019),
    [anon_sym_TRUE] = ACTIONS(1019),
    [anon_sym_false] = ACTIONS(1019),
    [anon_sym_FALSE] = ACTIONS(1019),
    [sym_self] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(1019),
    [anon_sym_NIL] = ACTIONS(1019),
    [sym_character] = ACTIONS(1021),
    [anon_sym_LBRACK2] = ACTIONS(1019),
    [anon_sym_DASH_GT] = ACTIONS(1021),
    [sym__simple_symbol] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(1021),
    [sym__symbol_start] = ACTIONS(1021),
    [sym__subshell_start] = ACTIONS(1021),
    [sym__regex_start] = ACTIONS(1021),
    [sym__string_array_start] = ACTIONS(1021),
    [sym__symbol_array_start] = ACTIONS(1021),
    [sym_heredoc_beginning] = ACTIONS(1021),
    [sym__block_ampersand] = ACTIONS(1021),
    [sym__splat_star] = ACTIONS(1021),
    [sym__unary_minus] = ACTIONS(1021),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
    [sym__identifier_hash_key] = ACTIONS(1021),
  },
  [762] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1734),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1734),
    [sym_operator_assignment] = STATE(1734),
    [sym_conditional] = STATE(1734),
    [sym_range] = STATE(1734),
    [sym_binary] = STATE(1734),
    [sym_unary] = STATE(1734),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(762),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [763] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1736),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1736),
    [sym_operator_assignment] = STATE(1736),
    [sym_conditional] = STATE(1736),
    [sym_range] = STATE(1736),
    [sym_binary] = STATE(1736),
    [sym_unary] = STATE(1736),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(763),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [764] = {
    [sym_heredoc_body] = STATE(764),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COLON_COLON] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_module] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_next] = ACTIONS(1003),
    [anon_sym_redo] = ACTIONS(1003),
    [anon_sym_retry] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_unless] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_until] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_begin] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1005),
    [sym_constant] = ACTIONS(1003),
    [sym_instance_variable] = ACTIONS(1005),
    [sym_class_variable] = ACTIONS(1005),
    [sym_global_variable] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_TRUE] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_FALSE] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
    [anon_sym_nil] = ACTIONS(1003),
    [anon_sym_NIL] = ACTIONS(1003),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(1003),
    [anon_sym_DASH_GT] = ACTIONS(1005),
    [sym__simple_symbol] = ACTIONS(1005),
    [sym__string_start] = ACTIONS(1005),
    [sym__symbol_start] = ACTIONS(1005),
    [sym__subshell_start] = ACTIONS(1005),
    [sym__regex_start] = ACTIONS(1005),
    [sym__string_array_start] = ACTIONS(1005),
    [sym__symbol_array_start] = ACTIONS(1005),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__block_ampersand] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1005),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
    [sym__identifier_hash_key] = ACTIONS(1005),
  },
  [765] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(765),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [766] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1719),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1719),
    [sym_operator_assignment] = STATE(1719),
    [sym_conditional] = STATE(1719),
    [sym_range] = STATE(1719),
    [sym_binary] = STATE(1719),
    [sym_unary] = STATE(1719),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(766),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [767] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1642),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1642),
    [sym_operator_assignment] = STATE(1642),
    [sym_conditional] = STATE(1642),
    [sym_range] = STATE(1642),
    [sym_binary] = STATE(1642),
    [sym_unary] = STATE(1642),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(767),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [768] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1726),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1726),
    [sym_operator_assignment] = STATE(1726),
    [sym_conditional] = STATE(1726),
    [sym_range] = STATE(1726),
    [sym_binary] = STATE(1726),
    [sym_unary] = STATE(1726),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(768),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [769] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1655),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1655),
    [sym_operator_assignment] = STATE(1655),
    [sym_conditional] = STATE(1655),
    [sym_range] = STATE(1655),
    [sym_binary] = STATE(1655),
    [sym_unary] = STATE(1655),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(769),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [770] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1615),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1615),
    [sym_operator_assignment] = STATE(1615),
    [sym_conditional] = STATE(1615),
    [sym_range] = STATE(1615),
    [sym_binary] = STATE(1615),
    [sym_unary] = STATE(1615),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(770),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [771] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1673),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1673),
    [sym_operator_assignment] = STATE(1673),
    [sym_conditional] = STATE(1673),
    [sym_range] = STATE(1673),
    [sym_binary] = STATE(1673),
    [sym_unary] = STATE(1673),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(771),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [772] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1744),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1744),
    [sym_operator_assignment] = STATE(1744),
    [sym_conditional] = STATE(1744),
    [sym_range] = STATE(1744),
    [sym_binary] = STATE(1744),
    [sym_unary] = STATE(1744),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(772),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [773] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1617),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1617),
    [sym_operator_assignment] = STATE(1617),
    [sym_conditional] = STATE(1617),
    [sym_range] = STATE(1617),
    [sym_binary] = STATE(1617),
    [sym_unary] = STATE(1617),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(773),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [774] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1620),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1620),
    [sym_operator_assignment] = STATE(1620),
    [sym_conditional] = STATE(1620),
    [sym_range] = STATE(1620),
    [sym_binary] = STATE(1620),
    [sym_unary] = STATE(1620),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(774),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [775] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1679),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(775),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [776] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1677),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1677),
    [sym_operator_assignment] = STATE(1677),
    [sym_conditional] = STATE(1677),
    [sym_range] = STATE(1677),
    [sym_binary] = STATE(1677),
    [sym_unary] = STATE(1677),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(776),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [777] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1656),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1656),
    [sym_operator_assignment] = STATE(1656),
    [sym_conditional] = STATE(1656),
    [sym_range] = STATE(1656),
    [sym_binary] = STATE(1656),
    [sym_unary] = STATE(1656),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(777),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [778] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1715),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1715),
    [sym_operator_assignment] = STATE(1715),
    [sym_conditional] = STATE(1715),
    [sym_range] = STATE(1715),
    [sym_binary] = STATE(1715),
    [sym_unary] = STATE(1715),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(778),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [779] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1632),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1632),
    [sym_operator_assignment] = STATE(1632),
    [sym_conditional] = STATE(1632),
    [sym_range] = STATE(1632),
    [sym_binary] = STATE(1632),
    [sym_unary] = STATE(1632),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(779),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [780] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1654),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1654),
    [sym_operator_assignment] = STATE(1654),
    [sym_conditional] = STATE(1654),
    [sym_range] = STATE(1654),
    [sym_binary] = STATE(1654),
    [sym_unary] = STATE(1654),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(780),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [781] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2076),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(781),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [782] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1700),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1700),
    [sym_operator_assignment] = STATE(1700),
    [sym_conditional] = STATE(1700),
    [sym_range] = STATE(1700),
    [sym_binary] = STATE(1700),
    [sym_unary] = STATE(1700),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(782),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [783] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1707),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1707),
    [sym_operator_assignment] = STATE(1707),
    [sym_conditional] = STATE(1707),
    [sym_range] = STATE(1707),
    [sym_binary] = STATE(1707),
    [sym_unary] = STATE(1707),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(783),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [784] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1642),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1642),
    [sym_operator_assignment] = STATE(1642),
    [sym_conditional] = STATE(1642),
    [sym_range] = STATE(1642),
    [sym_binary] = STATE(1642),
    [sym_unary] = STATE(1642),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(784),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [785] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2078),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2791),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1237),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1367),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(785),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(889),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1289),
  },
  [786] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1747),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1747),
    [sym_operator_assignment] = STATE(1747),
    [sym_conditional] = STATE(1747),
    [sym_range] = STATE(1747),
    [sym_binary] = STATE(1747),
    [sym_unary] = STATE(1747),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(786),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [787] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2075),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(787),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [788] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1671),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1671),
    [sym_operator_assignment] = STATE(1671),
    [sym_conditional] = STATE(1671),
    [sym_range] = STATE(1671),
    [sym_binary] = STATE(1671),
    [sym_unary] = STATE(1671),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(788),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [789] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1675),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1675),
    [sym_operator_assignment] = STATE(1675),
    [sym_conditional] = STATE(1675),
    [sym_range] = STATE(1675),
    [sym_binary] = STATE(1675),
    [sym_unary] = STATE(1675),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(789),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [790] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1670),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1670),
    [sym_operator_assignment] = STATE(1670),
    [sym_conditional] = STATE(1670),
    [sym_range] = STATE(1670),
    [sym_binary] = STATE(1670),
    [sym_unary] = STATE(1670),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(790),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [791] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(791),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [792] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1996),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(879),
    [sym_call] = STATE(879),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2837),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1216),
    [sym__variable] = STATE(879),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(792),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1197),
  },
  [793] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1642),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1642),
    [sym_operator_assignment] = STATE(1642),
    [sym_conditional] = STATE(1642),
    [sym_range] = STATE(1642),
    [sym_binary] = STATE(1642),
    [sym_unary] = STATE(1642),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(793),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [794] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1743),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1743),
    [sym_operator_assignment] = STATE(1743),
    [sym_conditional] = STATE(1743),
    [sym_range] = STATE(1743),
    [sym_binary] = STATE(1743),
    [sym_unary] = STATE(1743),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(794),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [795] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1672),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1672),
    [sym_operator_assignment] = STATE(1672),
    [sym_conditional] = STATE(1672),
    [sym_range] = STATE(1672),
    [sym_binary] = STATE(1672),
    [sym_unary] = STATE(1672),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(795),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [796] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2080),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(796),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [797] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2079),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(797),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [798] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1808),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1808),
    [sym_operator_assignment] = STATE(1808),
    [sym_conditional] = STATE(1808),
    [sym_range] = STATE(1808),
    [sym_binary] = STATE(1808),
    [sym_unary] = STATE(1808),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(798),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [799] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1722),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1722),
    [sym_operator_assignment] = STATE(1722),
    [sym_conditional] = STATE(1722),
    [sym_range] = STATE(1722),
    [sym_binary] = STATE(1722),
    [sym_unary] = STATE(1722),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(799),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [800] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1733),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1733),
    [sym_operator_assignment] = STATE(1733),
    [sym_conditional] = STATE(1733),
    [sym_range] = STATE(1733),
    [sym_binary] = STATE(1733),
    [sym_unary] = STATE(1733),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(800),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [801] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1832),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1832),
    [sym_operator_assignment] = STATE(1832),
    [sym_conditional] = STATE(1832),
    [sym_range] = STATE(1832),
    [sym_binary] = STATE(1832),
    [sym_unary] = STATE(1832),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(801),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [802] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1841),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(802),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [803] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1730),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1730),
    [sym_operator_assignment] = STATE(1730),
    [sym_conditional] = STATE(1730),
    [sym_range] = STATE(1730),
    [sym_binary] = STATE(1730),
    [sym_unary] = STATE(1730),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(803),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [804] = {
    [sym_method] = STATE(1405),
    [sym_singleton_method] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_singleton_class] = STATE(1405),
    [sym_module] = STATE(1405),
    [sym_return] = STATE(1405),
    [sym_yield] = STATE(1405),
    [sym_break] = STATE(1405),
    [sym_next] = STATE(1405),
    [sym_redo] = STATE(1405),
    [sym_retry] = STATE(1405),
    [sym_while] = STATE(1405),
    [sym_until] = STATE(1405),
    [sym_for] = STATE(1405),
    [sym_case] = STATE(1405),
    [sym_if] = STATE(1405),
    [sym_unless] = STATE(1405),
    [sym_begin] = STATE(1405),
    [sym__arg] = STATE(2077),
    [sym__primary] = STATE(1569),
    [sym_parenthesized_statements] = STATE(1405),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(980),
    [sym_call] = STATE(980),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1640),
    [sym_operator_assignment] = STATE(1640),
    [sym_conditional] = STATE(1640),
    [sym_range] = STATE(1640),
    [sym_binary] = STATE(1640),
    [sym_unary] = STATE(1640),
    [sym_parenthesized_unary] = STATE(1405),
    [sym_unary_literal] = STATE(1405),
    [sym_left_assignment_list] = STATE(2807),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1240),
    [sym__variable] = STATE(980),
    [sym_rational] = STATE(1405),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(1405),
    [sym_string] = STATE(1635),
    [sym_subshell] = STATE(1405),
    [sym_string_array] = STATE(1405),
    [sym_symbol_array] = STATE(1405),
    [sym_symbol] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_heredoc_body] = STATE(804),
    [sym_array] = STATE(1405),
    [sym_hash] = STATE(1405),
    [sym_lambda] = STATE(1405),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_def] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_next] = ACTIONS(839),
    [anon_sym_redo] = ACTIONS(841),
    [anon_sym_retry] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_unless] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1105),
    [sym_instance_variable] = ACTIONS(1117),
    [sym_class_variable] = ACTIONS(1117),
    [sym_global_variable] = ACTIONS(1117),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(869),
    [sym_float] = ACTIONS(871),
    [sym_complex] = ACTIONS(873),
    [sym_super] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_FALSE] = ACTIONS(1121),
    [sym_self] = ACTIONS(1105),
    [anon_sym_nil] = ACTIONS(1123),
    [anon_sym_NIL] = ACTIONS(1123),
    [sym_character] = ACTIONS(873),
    [anon_sym_LBRACK2] = ACTIONS(883),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [sym__simple_symbol] = ACTIONS(887),
    [sym__string_start] = ACTIONS(1179),
    [sym__symbol_start] = ACTIONS(891),
    [sym__subshell_start] = ACTIONS(893),
    [sym__regex_start] = ACTIONS(895),
    [sym__string_array_start] = ACTIONS(897),
    [sym__symbol_array_start] = ACTIONS(899),
    [sym_heredoc_beginning] = ACTIONS(873),
    [sym__unary_minus] = ACTIONS(1259),
  },
  [805] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1680),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1680),
    [sym_operator_assignment] = STATE(1680),
    [sym_conditional] = STATE(1680),
    [sym_range] = STATE(1680),
    [sym_binary] = STATE(1680),
    [sym_unary] = STATE(1680),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(805),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [806] = {
    [sym_method] = STATE(1118),
    [sym_singleton_method] = STATE(1118),
    [sym_class] = STATE(1118),
    [sym_singleton_class] = STATE(1118),
    [sym_module] = STATE(1118),
    [sym_return] = STATE(1118),
    [sym_yield] = STATE(1118),
    [sym_break] = STATE(1118),
    [sym_next] = STATE(1118),
    [sym_redo] = STATE(1118),
    [sym_retry] = STATE(1118),
    [sym_while] = STATE(1118),
    [sym_until] = STATE(1118),
    [sym_for] = STATE(1118),
    [sym_case] = STATE(1118),
    [sym_if] = STATE(1118),
    [sym_unless] = STATE(1118),
    [sym_begin] = STATE(1118),
    [sym__arg] = STATE(1842),
    [sym__primary] = STATE(1197),
    [sym_parenthesized_statements] = STATE(1118),
    [sym_element_reference] = STATE(935),
    [sym_scope_resolution] = STATE(878),
    [sym_call] = STATE(878),
    [sym_method_call] = STATE(935),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_parenthesized_unary] = STATE(1118),
    [sym_unary_literal] = STATE(1118),
    [sym_left_assignment_list] = STATE(2866),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1200),
    [sym__variable] = STATE(878),
    [sym_rational] = STATE(1118),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_nil] = STATE(935),
    [sym_chained_string] = STATE(1118),
    [sym_string] = STATE(992),
    [sym_subshell] = STATE(1118),
    [sym_string_array] = STATE(1118),
    [sym_symbol_array] = STATE(1118),
    [sym_symbol] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_heredoc_body] = STATE(806),
    [sym_array] = STATE(1118),
    [sym_hash] = STATE(1118),
    [sym_lambda] = STATE(1118),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_module] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(121),
    [anon_sym_yield] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(125),
    [anon_sym_next] = ACTIONS(127),
    [anon_sym_redo] = ACTIONS(41),
    [anon_sym_retry] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [anon_sym_unless] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_case] = ACTIONS(55),
    [anon_sym_begin] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_defined_QMARK] = ACTIONS(1271),
    [anon_sym_not] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [sym_constant] = ACTIONS(1129),
    [sym_instance_variable] = ACTIONS(1141),
    [sym_class_variable] = ACTIONS(1141),
    [sym_global_variable] = ACTIONS(1141),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(77),
    [sym_complex] = ACTIONS(79),
    [sym_super] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(81),
    [anon_sym_TRUE] = ACTIONS(81),
    [anon_sym_false] = ACTIONS(83),
    [anon_sym_FALSE] = ACTIONS(83),
    [sym_self] = ACTIONS(1129),
    [anon_sym_nil] = ACTIONS(85),
    [anon_sym_NIL] = ACTIONS(85),
    [sym_character] = ACTIONS(79),
    [anon_sym_LBRACK2] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(89),
    [sym__simple_symbol] = ACTIONS(91),
    [sym__string_start] = ACTIONS(93),
    [sym__symbol_start] = ACTIONS(95),
    [sym__subshell_start] = ACTIONS(97),
    [sym__regex_start] = ACTIONS(99),
    [sym__string_array_start] = ACTIONS(101),
    [sym__symbol_array_start] = ACTIONS(103),
    [sym_heredoc_beginning] = ACTIONS(79),
    [sym__unary_minus] = ACTIONS(1277),
  },
  [807] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1648),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1648),
    [sym_operator_assignment] = STATE(1648),
    [sym_conditional] = STATE(1648),
    [sym_range] = STATE(1648),
    [sym_binary] = STATE(1648),
    [sym_unary] = STATE(1648),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(807),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [808] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1621),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1621),
    [sym_operator_assignment] = STATE(1621),
    [sym_conditional] = STATE(1621),
    [sym_range] = STATE(1621),
    [sym_binary] = STATE(1621),
    [sym_unary] = STATE(1621),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(808),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [809] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1622),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1622),
    [sym_operator_assignment] = STATE(1622),
    [sym_conditional] = STATE(1622),
    [sym_range] = STATE(1622),
    [sym_binary] = STATE(1622),
    [sym_unary] = STATE(1622),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(809),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [810] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1626),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1626),
    [sym_operator_assignment] = STATE(1626),
    [sym_conditional] = STATE(1626),
    [sym_range] = STATE(1626),
    [sym_binary] = STATE(1626),
    [sym_unary] = STATE(1626),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(810),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [811] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1627),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1627),
    [sym_operator_assignment] = STATE(1627),
    [sym_conditional] = STATE(1627),
    [sym_range] = STATE(1627),
    [sym_binary] = STATE(1627),
    [sym_unary] = STATE(1627),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(811),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [812] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(812),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [813] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1607),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1607),
    [sym_operator_assignment] = STATE(1607),
    [sym_conditional] = STATE(1607),
    [sym_range] = STATE(1607),
    [sym_binary] = STATE(1607),
    [sym_unary] = STATE(1607),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(813),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [814] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1611),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1611),
    [sym_operator_assignment] = STATE(1611),
    [sym_conditional] = STATE(1611),
    [sym_range] = STATE(1611),
    [sym_binary] = STATE(1611),
    [sym_unary] = STATE(1611),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(814),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [815] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1642),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1642),
    [sym_operator_assignment] = STATE(1642),
    [sym_conditional] = STATE(1642),
    [sym_range] = STATE(1642),
    [sym_binary] = STATE(1642),
    [sym_unary] = STATE(1642),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(815),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [816] = {
    [sym_heredoc_body] = STATE(816),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_next] = ACTIONS(997),
    [anon_sym_redo] = ACTIONS(997),
    [anon_sym_retry] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_begin] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [anon_sym_defined_QMARK] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [sym_constant] = ACTIONS(997),
    [sym_instance_variable] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(999),
    [sym_global_variable] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [sym_complex] = ACTIONS(999),
    [sym_super] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_TRUE] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_FALSE] = ACTIONS(997),
    [sym_self] = ACTIONS(997),
    [anon_sym_nil] = ACTIONS(997),
    [anon_sym_NIL] = ACTIONS(997),
    [sym_character] = ACTIONS(999),
    [anon_sym_LBRACK2] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(999),
    [sym__simple_symbol] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
    [sym__symbol_start] = ACTIONS(999),
    [sym__subshell_start] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(999),
    [sym__symbol_array_start] = ACTIONS(999),
    [sym_heredoc_beginning] = ACTIONS(999),
    [sym__block_ampersand] = ACTIONS(999),
    [sym__splat_star] = ACTIONS(999),
    [sym__unary_minus] = ACTIONS(999),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
    [sym__identifier_hash_key] = ACTIONS(999),
  },
  [817] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1819),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1819),
    [sym_operator_assignment] = STATE(1819),
    [sym_conditional] = STATE(1819),
    [sym_range] = STATE(1819),
    [sym_binary] = STATE(1819),
    [sym_unary] = STATE(1819),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(817),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [818] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1826),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1826),
    [sym_operator_assignment] = STATE(1826),
    [sym_conditional] = STATE(1826),
    [sym_range] = STATE(1826),
    [sym_binary] = STATE(1826),
    [sym_unary] = STATE(1826),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(818),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [819] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1612),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1612),
    [sym_operator_assignment] = STATE(1612),
    [sym_conditional] = STATE(1612),
    [sym_range] = STATE(1612),
    [sym_binary] = STATE(1612),
    [sym_unary] = STATE(1612),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(819),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [820] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1613),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1613),
    [sym_operator_assignment] = STATE(1613),
    [sym_conditional] = STATE(1613),
    [sym_range] = STATE(1613),
    [sym_binary] = STATE(1613),
    [sym_unary] = STATE(1613),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(820),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [821] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1723),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1723),
    [sym_operator_assignment] = STATE(1723),
    [sym_conditional] = STATE(1723),
    [sym_range] = STATE(1723),
    [sym_binary] = STATE(1723),
    [sym_unary] = STATE(1723),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(821),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [822] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1829),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1829),
    [sym_operator_assignment] = STATE(1829),
    [sym_conditional] = STATE(1829),
    [sym_range] = STATE(1829),
    [sym_binary] = STATE(1829),
    [sym_unary] = STATE(1829),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(822),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [823] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(823),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [824] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1666),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1666),
    [sym_operator_assignment] = STATE(1666),
    [sym_conditional] = STATE(1666),
    [sym_range] = STATE(1666),
    [sym_binary] = STATE(1666),
    [sym_unary] = STATE(1666),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(824),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [825] = {
    [sym_heredoc_body] = STATE(825),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COLON_COLON] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [anon_sym_next] = ACTIONS(1023),
    [anon_sym_redo] = ACTIONS(1023),
    [anon_sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_unless] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_until] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_begin] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1023),
    [anon_sym_or] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [sym_constant] = ACTIONS(1023),
    [sym_instance_variable] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1025),
    [sym_global_variable] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1025),
    [sym_super] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1023),
    [anon_sym_TRUE] = ACTIONS(1023),
    [anon_sym_false] = ACTIONS(1023),
    [anon_sym_FALSE] = ACTIONS(1023),
    [sym_self] = ACTIONS(1023),
    [anon_sym_nil] = ACTIONS(1023),
    [anon_sym_NIL] = ACTIONS(1023),
    [sym_character] = ACTIONS(1025),
    [anon_sym_LBRACK2] = ACTIONS(1023),
    [anon_sym_DASH_GT] = ACTIONS(1025),
    [sym__simple_symbol] = ACTIONS(1025),
    [sym__string_start] = ACTIONS(1025),
    [sym__symbol_start] = ACTIONS(1025),
    [sym__subshell_start] = ACTIONS(1025),
    [sym__regex_start] = ACTIONS(1025),
    [sym__string_array_start] = ACTIONS(1025),
    [sym__symbol_array_start] = ACTIONS(1025),
    [sym_heredoc_beginning] = ACTIONS(1025),
    [sym__block_ampersand] = ACTIONS(1025),
    [sym__splat_star] = ACTIONS(1025),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
    [sym__identifier_hash_key] = ACTIONS(1025),
  },
  [826] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1725),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1725),
    [sym_operator_assignment] = STATE(1725),
    [sym_conditional] = STATE(1725),
    [sym_range] = STATE(1725),
    [sym_binary] = STATE(1725),
    [sym_unary] = STATE(1725),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(826),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [827] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1665),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1665),
    [sym_operator_assignment] = STATE(1665),
    [sym_conditional] = STATE(1665),
    [sym_range] = STATE(1665),
    [sym_binary] = STATE(1665),
    [sym_unary] = STATE(1665),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(827),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1293),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [828] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1664),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1664),
    [sym_operator_assignment] = STATE(1664),
    [sym_conditional] = STATE(1664),
    [sym_range] = STATE(1664),
    [sym_binary] = STATE(1664),
    [sym_unary] = STATE(1664),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(828),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [829] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1662),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1537),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1662),
    [sym_operator_assignment] = STATE(1662),
    [sym_conditional] = STATE(1662),
    [sym_range] = STATE(1662),
    [sym_binary] = STATE(1662),
    [sym_unary] = STATE(1662),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(829),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [830] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1642),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1642),
    [sym_operator_assignment] = STATE(1642),
    [sym_conditional] = STATE(1642),
    [sym_range] = STATE(1642),
    [sym_binary] = STATE(1642),
    [sym_unary] = STATE(1642),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(830),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [831] = {
    [sym_heredoc_body] = STATE(831),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COLON_COLON] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_next] = ACTIONS(1011),
    [anon_sym_redo] = ACTIONS(1011),
    [anon_sym_retry] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_unless] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_until] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_begin] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [anon_sym_defined_QMARK] = ACTIONS(1013),
    [anon_sym_not] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1011),
    [sym_instance_variable] = ACTIONS(1013),
    [sym_class_variable] = ACTIONS(1013),
    [sym_global_variable] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [sym_complex] = ACTIONS(1013),
    [sym_super] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1011),
    [anon_sym_TRUE] = ACTIONS(1011),
    [anon_sym_false] = ACTIONS(1011),
    [anon_sym_FALSE] = ACTIONS(1011),
    [sym_self] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(1011),
    [anon_sym_NIL] = ACTIONS(1011),
    [sym_character] = ACTIONS(1013),
    [anon_sym_LBRACK2] = ACTIONS(1011),
    [anon_sym_DASH_GT] = ACTIONS(1013),
    [sym__simple_symbol] = ACTIONS(1013),
    [sym__string_start] = ACTIONS(1013),
    [sym__symbol_start] = ACTIONS(1013),
    [sym__subshell_start] = ACTIONS(1013),
    [sym__regex_start] = ACTIONS(1013),
    [sym__string_array_start] = ACTIONS(1013),
    [sym__symbol_array_start] = ACTIONS(1013),
    [sym_heredoc_beginning] = ACTIONS(1013),
    [sym__block_ampersand] = ACTIONS(1013),
    [sym__splat_star] = ACTIONS(1013),
    [sym__unary_minus] = ACTIONS(1013),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
    [sym__identifier_hash_key] = ACTIONS(1013),
  },
  [832] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1748),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(1748),
    [sym_operator_assignment] = STATE(1748),
    [sym_conditional] = STATE(1748),
    [sym_range] = STATE(1748),
    [sym_binary] = STATE(1748),
    [sym_unary] = STATE(1748),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2947),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(832),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_TILDE] = ACTIONS(925),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(927),
  },
  [833] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1706),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1706),
    [sym_operator_assignment] = STATE(1706),
    [sym_conditional] = STATE(1706),
    [sym_range] = STATE(1706),
    [sym_binary] = STATE(1706),
    [sym_unary] = STATE(1706),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(833),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [834] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1714),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1714),
    [sym_operator_assignment] = STATE(1714),
    [sym_conditional] = STATE(1714),
    [sym_range] = STATE(1714),
    [sym_binary] = STATE(1714),
    [sym_unary] = STATE(1714),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(834),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [835] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1713),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1713),
    [sym_operator_assignment] = STATE(1713),
    [sym_conditional] = STATE(1713),
    [sym_range] = STATE(1713),
    [sym_binary] = STATE(1713),
    [sym_unary] = STATE(1713),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(835),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [836] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1765),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1765),
    [sym_operator_assignment] = STATE(1765),
    [sym_conditional] = STATE(1765),
    [sym_range] = STATE(1765),
    [sym_binary] = STATE(1765),
    [sym_unary] = STATE(1765),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(836),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [837] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1699),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1699),
    [sym_operator_assignment] = STATE(1699),
    [sym_conditional] = STATE(1699),
    [sym_range] = STATE(1699),
    [sym_binary] = STATE(1699),
    [sym_unary] = STATE(1699),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(837),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [838] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1712),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1712),
    [sym_operator_assignment] = STATE(1712),
    [sym_conditional] = STATE(1712),
    [sym_range] = STATE(1712),
    [sym_binary] = STATE(1712),
    [sym_unary] = STATE(1712),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(838),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [839] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1709),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1709),
    [sym_operator_assignment] = STATE(1709),
    [sym_conditional] = STATE(1709),
    [sym_range] = STATE(1709),
    [sym_binary] = STATE(1709),
    [sym_unary] = STATE(1709),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(839),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [840] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1705),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1705),
    [sym_operator_assignment] = STATE(1705),
    [sym_conditional] = STATE(1705),
    [sym_range] = STATE(1705),
    [sym_binary] = STATE(1705),
    [sym_unary] = STATE(1705),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(840),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [841] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1704),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1704),
    [sym_operator_assignment] = STATE(1704),
    [sym_conditional] = STATE(1704),
    [sym_range] = STATE(1704),
    [sym_binary] = STATE(1704),
    [sym_unary] = STATE(1704),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(841),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [842] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1768),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1768),
    [sym_operator_assignment] = STATE(1768),
    [sym_conditional] = STATE(1768),
    [sym_range] = STATE(1768),
    [sym_binary] = STATE(1768),
    [sym_unary] = STATE(1768),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(842),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [843] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1772),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1772),
    [sym_operator_assignment] = STATE(1772),
    [sym_conditional] = STATE(1772),
    [sym_range] = STATE(1772),
    [sym_binary] = STATE(1772),
    [sym_unary] = STATE(1772),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(843),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [844] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1616),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(996),
    [sym_scope_resolution] = STATE(978),
    [sym_call] = STATE(978),
    [sym_method_call] = STATE(996),
    [sym_assignment] = STATE(1616),
    [sym_operator_assignment] = STATE(1616),
    [sym_conditional] = STATE(1616),
    [sym_range] = STATE(1616),
    [sym_binary] = STATE(1616),
    [sym_unary] = STATE(1616),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2928),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(996),
    [sym__variable] = STATE(978),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_nil] = STATE(996),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(844),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_defined_QMARK] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(217),
    [anon_sym_TILDE] = ACTIONS(217),
    [sym_constant] = ACTIONS(1067),
    [sym_instance_variable] = ACTIONS(1065),
    [sym_class_variable] = ACTIONS(1065),
    [sym_global_variable] = ACTIONS(1065),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1067),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(257),
  },
  [845] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1659),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1659),
    [sym_operator_assignment] = STATE(1659),
    [sym_conditional] = STATE(1659),
    [sym_range] = STATE(1659),
    [sym_binary] = STATE(1659),
    [sym_unary] = STATE(1659),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(845),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [846] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1701),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1701),
    [sym_operator_assignment] = STATE(1701),
    [sym_conditional] = STATE(1701),
    [sym_range] = STATE(1701),
    [sym_binary] = STATE(1701),
    [sym_unary] = STATE(1701),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(846),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [847] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1682),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1682),
    [sym_operator_assignment] = STATE(1682),
    [sym_conditional] = STATE(1682),
    [sym_range] = STATE(1682),
    [sym_binary] = STATE(1682),
    [sym_unary] = STATE(1682),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(847),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [848] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1697),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1697),
    [sym_operator_assignment] = STATE(1697),
    [sym_conditional] = STATE(1697),
    [sym_range] = STATE(1697),
    [sym_binary] = STATE(1697),
    [sym_unary] = STATE(1697),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(848),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [849] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1777),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1777),
    [sym_operator_assignment] = STATE(1777),
    [sym_conditional] = STATE(1777),
    [sym_range] = STATE(1777),
    [sym_binary] = STATE(1777),
    [sym_unary] = STATE(1777),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(849),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [850] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1686),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1686),
    [sym_operator_assignment] = STATE(1686),
    [sym_conditional] = STATE(1686),
    [sym_range] = STATE(1686),
    [sym_binary] = STATE(1686),
    [sym_unary] = STATE(1686),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(850),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [851] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1778),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1778),
    [sym_operator_assignment] = STATE(1778),
    [sym_conditional] = STATE(1778),
    [sym_range] = STATE(1778),
    [sym_binary] = STATE(1778),
    [sym_unary] = STATE(1778),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(851),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [852] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1779),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1779),
    [sym_operator_assignment] = STATE(1779),
    [sym_conditional] = STATE(1779),
    [sym_range] = STATE(1779),
    [sym_binary] = STATE(1779),
    [sym_unary] = STATE(1779),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(852),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [853] = {
    [sym_heredoc_body] = STATE(853),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COLON_COLON] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [anon_sym_next] = ACTIONS(1007),
    [anon_sym_redo] = ACTIONS(1007),
    [anon_sym_retry] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_until] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_begin] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [anon_sym_defined_QMARK] = ACTIONS(1009),
    [anon_sym_not] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1009),
    [sym_constant] = ACTIONS(1007),
    [sym_instance_variable] = ACTIONS(1009),
    [sym_class_variable] = ACTIONS(1009),
    [sym_global_variable] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_TRUE] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_FALSE] = ACTIONS(1007),
    [sym_self] = ACTIONS(1007),
    [anon_sym_nil] = ACTIONS(1007),
    [anon_sym_NIL] = ACTIONS(1007),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1007),
    [anon_sym_DASH_GT] = ACTIONS(1009),
    [sym__simple_symbol] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1009),
    [sym__symbol_start] = ACTIONS(1009),
    [sym__subshell_start] = ACTIONS(1009),
    [sym__regex_start] = ACTIONS(1009),
    [sym__string_array_start] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(1009),
    [sym_heredoc_beginning] = ACTIONS(1009),
    [sym__block_ampersand] = ACTIONS(1009),
    [sym__splat_star] = ACTIONS(1009),
    [sym__unary_minus] = ACTIONS(1009),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
    [sym__identifier_hash_key] = ACTIONS(1009),
  },
  [854] = {
    [sym_method] = STATE(1461),
    [sym_singleton_method] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_singleton_class] = STATE(1461),
    [sym_module] = STATE(1461),
    [sym_return] = STATE(1461),
    [sym_yield] = STATE(1461),
    [sym_break] = STATE(1461),
    [sym_next] = STATE(1461),
    [sym_redo] = STATE(1461),
    [sym_retry] = STATE(1461),
    [sym_while] = STATE(1461),
    [sym_until] = STATE(1461),
    [sym_for] = STATE(1461),
    [sym_case] = STATE(1461),
    [sym_if] = STATE(1461),
    [sym_unless] = STATE(1461),
    [sym_begin] = STATE(1461),
    [sym__arg] = STATE(1688),
    [sym__primary] = STATE(1461),
    [sym_parenthesized_statements] = STATE(1461),
    [sym_element_reference] = STATE(1056),
    [sym_scope_resolution] = STATE(971),
    [sym_call] = STATE(971),
    [sym_method_call] = STATE(1056),
    [sym_assignment] = STATE(1688),
    [sym_operator_assignment] = STATE(1688),
    [sym_conditional] = STATE(1688),
    [sym_range] = STATE(1688),
    [sym_binary] = STATE(1688),
    [sym_unary] = STATE(1688),
    [sym_parenthesized_unary] = STATE(1461),
    [sym_unary_literal] = STATE(1461),
    [sym_left_assignment_list] = STATE(2963),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1056),
    [sym__variable] = STATE(971),
    [sym_rational] = STATE(1461),
    [sym_true] = STATE(1056),
    [sym_false] = STATE(1056),
    [sym_nil] = STATE(1056),
    [sym_chained_string] = STATE(1461),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1461),
    [sym_string_array] = STATE(1461),
    [sym_symbol_array] = STATE(1461),
    [sym_symbol] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_heredoc_body] = STATE(854),
    [sym_array] = STATE(1461),
    [sym_hash] = STATE(1461),
    [sym_lambda] = STATE(1461),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(321),
    [sym_constant] = ACTIONS(1057),
    [sym_instance_variable] = ACTIONS(1051),
    [sym_class_variable] = ACTIONS(1051),
    [sym_global_variable] = ACTIONS(1051),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1053),
    [sym_complex] = ACTIONS(1055),
    [sym_super] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(229),
    [anon_sym_TRUE] = ACTIONS(229),
    [anon_sym_false] = ACTIONS(231),
    [anon_sym_FALSE] = ACTIONS(231),
    [sym_self] = ACTIONS(1057),
    [anon_sym_nil] = ACTIONS(233),
    [anon_sym_NIL] = ACTIONS(233),
    [sym_character] = ACTIONS(1055),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1055),
    [sym__unary_minus] = ACTIONS(331),
  },
  [855] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1789),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1789),
    [sym_operator_assignment] = STATE(1789),
    [sym_conditional] = STATE(1789),
    [sym_range] = STATE(1789),
    [sym_binary] = STATE(1789),
    [sym_unary] = STATE(1789),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(855),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [856] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(856),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [857] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1791),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1155),
    [sym_scope_resolution] = STATE(979),
    [sym_call] = STATE(979),
    [sym_method_call] = STATE(1155),
    [sym_assignment] = STATE(1791),
    [sym_operator_assignment] = STATE(1791),
    [sym_conditional] = STATE(1791),
    [sym_range] = STATE(1791),
    [sym_binary] = STATE(1791),
    [sym_unary] = STATE(1791),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2956),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1155),
    [sym__variable] = STATE(979),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1155),
    [sym_false] = STATE(1155),
    [sym_nil] = STATE(1155),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(857),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(777),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_TILDE] = ACTIONS(781),
    [sym_constant] = ACTIONS(1217),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1217),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(801),
  },
  [858] = {
    [sym_method] = STATE(1575),
    [sym_singleton_method] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_singleton_class] = STATE(1575),
    [sym_module] = STATE(1575),
    [sym_return] = STATE(1575),
    [sym_yield] = STATE(1575),
    [sym_break] = STATE(1575),
    [sym_next] = STATE(1575),
    [sym_redo] = STATE(1575),
    [sym_retry] = STATE(1575),
    [sym_while] = STATE(1575),
    [sym_until] = STATE(1575),
    [sym_for] = STATE(1575),
    [sym_case] = STATE(1575),
    [sym_if] = STATE(1575),
    [sym_unless] = STATE(1575),
    [sym_begin] = STATE(1575),
    [sym__arg] = STATE(1667),
    [sym__primary] = STATE(1575),
    [sym_parenthesized_statements] = STATE(1575),
    [sym_element_reference] = STATE(1024),
    [sym_scope_resolution] = STATE(981),
    [sym_call] = STATE(981),
    [sym_method_call] = STATE(1024),
    [sym_assignment] = STATE(1667),
    [sym_operator_assignment] = STATE(1667),
    [sym_conditional] = STATE(1667),
    [sym_range] = STATE(1667),
    [sym_binary] = STATE(1667),
    [sym_unary] = STATE(1667),
    [sym_parenthesized_unary] = STATE(1575),
    [sym_unary_literal] = STATE(1575),
    [sym_left_assignment_list] = STATE(2946),
    [sym__mlhs] = STATE(2887),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(1024),
    [sym__variable] = STATE(981),
    [sym_rational] = STATE(1575),
    [sym_true] = STATE(1024),
    [sym_false] = STATE(1024),
    [sym_nil] = STATE(1024),
    [sym_chained_string] = STATE(1575),
    [sym_string] = STATE(1364),
    [sym_subshell] = STATE(1575),
    [sym_string_array] = STATE(1575),
    [sym_symbol_array] = STATE(1575),
    [sym_symbol] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_heredoc_body] = STATE(858),
    [sym_array] = STATE(1575),
    [sym_hash] = STATE(1575),
    [sym_lambda] = STATE(1575),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_yield] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(195),
    [anon_sym_next] = ACTIONS(197),
    [anon_sym_redo] = ACTIONS(199),
    [anon_sym_retry] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_unless] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_begin] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_defined_QMARK] = ACTIONS(1233),
    [anon_sym_not] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [sym_constant] = ACTIONS(1229),
    [sym_instance_variable] = ACTIONS(1239),
    [sym_class_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(221),
    [sym_float] = ACTIONS(1223),
    [sym_complex] = ACTIONS(1225),
    [sym_super] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_TRUE] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(795),
    [anon_sym_FALSE] = ACTIONS(795),
    [sym_self] = ACTIONS(1229),
    [anon_sym_nil] = ACTIONS(797),
    [anon_sym_NIL] = ACTIONS(797),
    [sym_character] = ACTIONS(1225),
    [anon_sym_LBRACK2] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym__simple_symbol] = ACTIONS(239),
    [sym__string_start] = ACTIONS(241),
    [sym__symbol_start] = ACTIONS(243),
    [sym__subshell_start] = ACTIONS(245),
    [sym__regex_start] = ACTIONS(247),
    [sym__string_array_start] = ACTIONS(249),
    [sym__symbol_array_start] = ACTIONS(251),
    [sym_heredoc_beginning] = ACTIONS(1225),
    [sym__unary_minus] = ACTIONS(1241),
  },
  [859] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym_destructured_left_assignment] = STATE(2655),
    [sym_rest_assignment] = STATE(2655),
    [sym__lhs] = STATE(2250),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(859),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [860] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym_destructured_left_assignment] = STATE(2655),
    [sym_rest_assignment] = STATE(2655),
    [sym__lhs] = STATE(2250),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(860),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(1379),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [861] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__mlhs] = STATE(2745),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(2384),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(861),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [862] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2274),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(862),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1385),
    [anon_sym_EQ] = ACTIONS(1385),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1387),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [863] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__mlhs] = STATE(2757),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(2384),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(863),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [864] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__mlhs] = STATE(2763),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(2384),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(864),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [865] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__mlhs] = STATE(2924),
    [sym_destructured_left_assignment] = STATE(2548),
    [sym_rest_assignment] = STATE(2548),
    [sym__lhs] = STATE(2384),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(865),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [866] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2664),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2157),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym_destructured_left_assignment] = STATE(2655),
    [sym_rest_assignment] = STATE(2655),
    [sym__lhs] = STATE(2250),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(866),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [867] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2154),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(867),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1391),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1393),
  },
  [868] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2151),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(868),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1395),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1397),
  },
  [869] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2152),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(869),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1399),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1401),
  },
  [870] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2161),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(870),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1403),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [871] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2159),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(871),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1405),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [872] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2156),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(872),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1407),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1409),
  },
  [873] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2158),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(873),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [874] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2648),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2376),
    [sym_scope_resolution] = STATE(2164),
    [sym_call] = STATE(2164),
    [sym_method_call] = STATE(2376),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2332),
    [sym__variable] = STATE(2164),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2376),
    [sym_false] = STATE(2376),
    [sym_nil] = STATE(2376),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(874),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1413),
    [sym_instance_variable] = ACTIONS(1415),
    [sym_class_variable] = ACTIONS(1415),
    [sym_global_variable] = ACTIONS(1415),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1413),
    [anon_sym_true] = ACTIONS(1417),
    [anon_sym_TRUE] = ACTIONS(1417),
    [anon_sym_false] = ACTIONS(1419),
    [anon_sym_FALSE] = ACTIONS(1419),
    [sym_self] = ACTIONS(1413),
    [anon_sym_nil] = ACTIONS(1421),
    [anon_sym_NIL] = ACTIONS(1421),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [875] = {
    [sym_method] = STATE(2641),
    [sym_singleton_method] = STATE(2641),
    [sym_class] = STATE(2641),
    [sym_singleton_class] = STATE(2641),
    [sym_module] = STATE(2641),
    [sym_return] = STATE(2641),
    [sym_yield] = STATE(2641),
    [sym_break] = STATE(2641),
    [sym_next] = STATE(2641),
    [sym_redo] = STATE(2641),
    [sym_retry] = STATE(2641),
    [sym_while] = STATE(2641),
    [sym_until] = STATE(2641),
    [sym_for] = STATE(2641),
    [sym_case] = STATE(2641),
    [sym_if] = STATE(2641),
    [sym_unless] = STATE(2641),
    [sym_begin] = STATE(2641),
    [sym__primary] = STATE(2581),
    [sym_parenthesized_statements] = STATE(2641),
    [sym_element_reference] = STATE(2248),
    [sym_scope_resolution] = STATE(2167),
    [sym_call] = STATE(2157),
    [sym_method_call] = STATE(2248),
    [sym_parenthesized_unary] = STATE(2641),
    [sym_unary_literal] = STATE(2641),
    [sym__lhs] = STATE(2641),
    [sym__variable] = STATE(2157),
    [sym_rational] = STATE(2641),
    [sym_true] = STATE(2248),
    [sym_false] = STATE(2248),
    [sym_nil] = STATE(2248),
    [sym_chained_string] = STATE(2641),
    [sym_string] = STATE(2326),
    [sym_subshell] = STATE(2641),
    [sym_string_array] = STATE(2641),
    [sym_symbol_array] = STATE(2641),
    [sym_symbol] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_heredoc_body] = STATE(875),
    [sym_array] = STATE(2641),
    [sym_hash] = STATE(2641),
    [sym_lambda] = STATE(2641),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_def] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1389),
    [anon_sym_class] = ACTIONS(1307),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_next] = ACTIONS(1317),
    [anon_sym_redo] = ACTIONS(1319),
    [anon_sym_retry] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_unless] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1335),
    [anon_sym_begin] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_defined_QMARK] = ACTIONS(1341),
    [anon_sym_not] = ACTIONS(1343),
    [sym_constant] = ACTIONS(1423),
    [sym_instance_variable] = ACTIONS(1345),
    [sym_class_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1353),
    [anon_sym_TRUE] = ACTIONS(1353),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_FALSE] = ACTIONS(1355),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(1357),
    [anon_sym_NIL] = ACTIONS(1357),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [sym__simple_symbol] = ACTIONS(1363),
    [sym__string_start] = ACTIONS(1365),
    [sym__symbol_start] = ACTIONS(1367),
    [sym__subshell_start] = ACTIONS(1369),
    [sym__regex_start] = ACTIONS(1371),
    [sym__string_array_start] = ACTIONS(1373),
    [sym__symbol_array_start] = ACTIONS(1375),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__unary_minus] = ACTIONS(1377),
  },
  [876] = {
    [sym_argument_list] = STATE(883),
    [sym_do_block] = STATE(895),
    [sym_block] = STATE(911),
    [sym_heredoc_body] = STATE(876),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [877] = {
    [sym_argument_list] = STATE(881),
    [sym_do_block] = STATE(895),
    [sym_block] = STATE(911),
    [sym_heredoc_body] = STATE(877),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [878] = {
    [sym_argument_list] = STATE(889),
    [sym_do_block] = STATE(945),
    [sym_block] = STATE(940),
    [sym_heredoc_body] = STATE(878),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [879] = {
    [sym_argument_list] = STATE(887),
    [sym_do_block] = STATE(945),
    [sym_block] = STATE(940),
    [sym_heredoc_body] = STATE(879),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(1431),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_LPAREN2] = ACTIONS(167),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [880] = {
    [sym_heredoc_body] = STATE(880),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
  },
  [881] = {
    [sym_do_block] = STATE(909),
    [sym_block] = STATE(898),
    [sym_heredoc_body] = STATE(881),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [882] = {
    [sym_heredoc_body] = STATE(882),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_COLON] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
  },
  [883] = {
    [sym_do_block] = STATE(909),
    [sym_block] = STATE(898),
    [sym_heredoc_body] = STATE(883),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [884] = {
    [sym_heredoc_body] = STATE(884),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
  },
  [885] = {
    [sym_heredoc_body] = STATE(885),
    [sym_identifier] = ACTIONS(1437),
    [anon_sym_BEGIN] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [anon_sym_END] = ACTIONS(1437),
    [anon_sym_def] = ACTIONS(1437),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_COLON_COLON] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_class] = ACTIONS(1437),
    [anon_sym_module] = ACTIONS(1437),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_yield] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_next] = ACTIONS(1437),
    [anon_sym_redo] = ACTIONS(1437),
    [anon_sym_retry] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1437),
    [anon_sym_elsif] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_then] = ACTIONS(1437),
    [anon_sym_begin] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1437),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1439),
    [sym_constant] = ACTIONS(1437),
    [sym_instance_variable] = ACTIONS(1439),
    [sym_class_variable] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1439),
    [anon_sym_undef] = ACTIONS(1437),
    [anon_sym_alias] = ACTIONS(1437),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1437),
    [sym_float] = ACTIONS(1437),
    [sym_complex] = ACTIONS(1439),
    [sym_super] = ACTIONS(1437),
    [anon_sym_true] = ACTIONS(1437),
    [anon_sym_TRUE] = ACTIONS(1437),
    [anon_sym_false] = ACTIONS(1437),
    [anon_sym_FALSE] = ACTIONS(1437),
    [sym_self] = ACTIONS(1437),
    [anon_sym_nil] = ACTIONS(1437),
    [anon_sym_NIL] = ACTIONS(1437),
    [sym_character] = ACTIONS(1439),
    [anon_sym_LBRACK2] = ACTIONS(1439),
    [anon_sym_DASH_GT] = ACTIONS(1439),
    [sym__simple_symbol] = ACTIONS(1439),
    [sym__string_start] = ACTIONS(1439),
    [sym__symbol_start] = ACTIONS(1439),
    [sym__subshell_start] = ACTIONS(1439),
    [sym__regex_start] = ACTIONS(1439),
    [sym__string_array_start] = ACTIONS(1439),
    [sym__symbol_array_start] = ACTIONS(1439),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1439),
    [sym__unary_minus] = ACTIONS(1439),
  },
  [886] = {
    [sym_heredoc_body] = STATE(886),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [anon_sym___END__] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_end] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_unless] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_until] = ACTIONS(1005),
    [anon_sym_rescue] = ACTIONS(1005),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_when] = ACTIONS(1005),
    [anon_sym_elsif] = ACTIONS(1005),
    [anon_sym_else] = ACTIONS(1005),
    [anon_sym_then] = ACTIONS(1005),
    [anon_sym_ensure] = ACTIONS(1005),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1005),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1005),
    [anon_sym_or] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1005),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
  },
  [887] = {
    [sym_do_block] = STATE(928),
    [sym_block] = STATE(929),
    [sym_heredoc_body] = STATE(887),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1431),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [888] = {
    [sym_heredoc_body] = STATE(888),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym___END__] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_do] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_EQ_GT] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1447),
    [anon_sym_DASH_EQ] = ACTIONS(1447),
    [anon_sym_STAR_EQ] = ACTIONS(1447),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1447),
    [anon_sym_SLASH_EQ] = ACTIONS(1447),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1447),
    [anon_sym_PIPE_EQ] = ACTIONS(1447),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1447),
    [anon_sym_AMP_EQ] = ACTIONS(1447),
    [anon_sym_PERCENT_EQ] = ACTIONS(1447),
    [anon_sym_GT_GT_EQ] = ACTIONS(1447),
    [anon_sym_LT_LT_EQ] = ACTIONS(1447),
    [anon_sym_CARET_EQ] = ACTIONS(1447),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [889] = {
    [sym_do_block] = STATE(928),
    [sym_block] = STATE(929),
    [sym_heredoc_body] = STATE(889),
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym___END__] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_unless] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_until] = ACTIONS(1433),
    [anon_sym_rescue] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_when] = ACTIONS(1433),
    [anon_sym_elsif] = ACTIONS(1433),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_then] = ACTIONS(1433),
    [anon_sym_ensure] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_COLON_COLON2] = ACTIONS(1433),
    [anon_sym_AMP_DOT] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1435),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1433),
    [anon_sym_LT_EQ_GT] = ACTIONS(1433),
    [anon_sym_EQ_TILDE] = ACTIONS(1433),
    [anon_sym_BANG_TILDE] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1433),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1433),
    [sym__binary_star] = ACTIONS(1433),
  },
  [890] = {
    [sym_heredoc_body] = STATE(890),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [anon_sym___END__] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_end] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_unless] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_until] = ACTIONS(1021),
    [anon_sym_rescue] = ACTIONS(1021),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_when] = ACTIONS(1021),
    [anon_sym_elsif] = ACTIONS(1021),
    [anon_sym_else] = ACTIONS(1021),
    [anon_sym_then] = ACTIONS(1021),
    [anon_sym_ensure] = ACTIONS(1021),
    [anon_sym_EQ_GT] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1021),
    [anon_sym_or] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1021),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
  },
  [891] = {
    [sym_heredoc_body] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [anon_sym___END__] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_end] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_unless] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1025),
    [anon_sym_rescue] = ACTIONS(1025),
    [anon_sym_do] = ACTIONS(1025),
    [anon_sym_when] = ACTIONS(1025),
    [anon_sym_elsif] = ACTIONS(1025),
    [anon_sym_else] = ACTIONS(1025),
    [anon_sym_then] = ACTIONS(1025),
    [anon_sym_ensure] = ACTIONS(1025),
    [anon_sym_EQ_GT] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1025),
    [anon_sym_or] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1025),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
  },
  [892] = {
    [sym_heredoc_body] = STATE(892),
    [ts_builtin_sym_end] = ACTIONS(999),
    [anon_sym___END__] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_end] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_unless] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [anon_sym_until] = ACTIONS(999),
    [anon_sym_rescue] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_when] = ACTIONS(999),
    [anon_sym_elsif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_then] = ACTIONS(999),
    [anon_sym_ensure] = ACTIONS(999),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(999),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
  },
  [893] = {
    [sym_heredoc_body] = STATE(893),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [anon_sym___END__] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_end] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_until] = ACTIONS(1009),
    [anon_sym_rescue] = ACTIONS(1009),
    [anon_sym_do] = ACTIONS(1009),
    [anon_sym_when] = ACTIONS(1009),
    [anon_sym_elsif] = ACTIONS(1009),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_then] = ACTIONS(1009),
    [anon_sym_ensure] = ACTIONS(1009),
    [anon_sym_EQ_GT] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1009),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1009),
    [anon_sym_or] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1009),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
  },
  [894] = {
    [sym_heredoc_body] = STATE(894),
    [ts_builtin_sym_end] = ACTIONS(1013),
    [anon_sym___END__] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_RPAREN] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_end] = ACTIONS(1013),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_unless] = ACTIONS(1013),
    [anon_sym_while] = ACTIONS(1013),
    [anon_sym_until] = ACTIONS(1013),
    [anon_sym_rescue] = ACTIONS(1013),
    [anon_sym_do] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(1013),
    [anon_sym_elsif] = ACTIONS(1013),
    [anon_sym_else] = ACTIONS(1013),
    [anon_sym_then] = ACTIONS(1013),
    [anon_sym_ensure] = ACTIONS(1013),
    [anon_sym_EQ_GT] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1013),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_or] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1013),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
  },
  [895] = {
    [sym_heredoc_body] = STATE(895),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym___END__] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_STAR_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_unless] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_until] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_when] = ACTIONS(1449),
    [anon_sym_elsif] = ACTIONS(1449),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_then] = ACTIONS(1449),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_EQ_GT] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_COLON_COLON2] = ACTIONS(1449),
    [anon_sym_AMP_DOT] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
    [anon_sym_STAR_EQ] = ACTIONS(1449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1449),
    [anon_sym_SLASH_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1449),
    [anon_sym_AMP_EQ] = ACTIONS(1449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1449),
    [anon_sym_CARET_EQ] = ACTIONS(1449),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1449),
    [anon_sym_and] = ACTIONS(1449),
    [anon_sym_or] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_LT_EQ_GT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_BANG_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1449),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1449),
    [sym__binary_star] = ACTIONS(1449),
  },
  [896] = {
    [sym_heredoc_body] = STATE(896),
    [ts_builtin_sym_end] = ACTIONS(1453),
    [anon_sym___END__] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_EQ] = ACTIONS(1455),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_end] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_unless] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_until] = ACTIONS(1453),
    [anon_sym_rescue] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_when] = ACTIONS(1453),
    [anon_sym_elsif] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1453),
    [anon_sym_then] = ACTIONS(1453),
    [anon_sym_ensure] = ACTIONS(1453),
    [anon_sym_EQ_GT] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_COLON_COLON2] = ACTIONS(1453),
    [anon_sym_AMP_DOT] = ACTIONS(1453),
    [anon_sym_PLUS_EQ] = ACTIONS(1453),
    [anon_sym_DASH_EQ] = ACTIONS(1453),
    [anon_sym_STAR_EQ] = ACTIONS(1453),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1453),
    [anon_sym_SLASH_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1453),
    [anon_sym_AMP_EQ] = ACTIONS(1453),
    [anon_sym_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_GT_GT_EQ] = ACTIONS(1453),
    [anon_sym_LT_LT_EQ] = ACTIONS(1453),
    [anon_sym_CARET_EQ] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1453),
    [anon_sym_and] = ACTIONS(1453),
    [anon_sym_or] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1455),
    [anon_sym_AMP_AMP] = ACTIONS(1455),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1455),
    [anon_sym_EQ_EQ] = ACTIONS(1455),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1453),
    [anon_sym_LT_EQ_GT] = ACTIONS(1453),
    [anon_sym_EQ_TILDE] = ACTIONS(1453),
    [anon_sym_BANG_TILDE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1453),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__binary_star] = ACTIONS(1453),
  },
  [897] = {
    [sym_heredoc_body] = STATE(897),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_EQ_GT] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [898] = {
    [sym_heredoc_body] = STATE(898),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_EQ_GT] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [899] = {
    [sym_heredoc_body] = STATE(899),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym___END__] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_do] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1467),
    [anon_sym_DASH_EQ] = ACTIONS(1467),
    [anon_sym_STAR_EQ] = ACTIONS(1467),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1467),
    [anon_sym_SLASH_EQ] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1467),
    [anon_sym_PIPE_EQ] = ACTIONS(1467),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1467),
    [anon_sym_AMP_EQ] = ACTIONS(1467),
    [anon_sym_PERCENT_EQ] = ACTIONS(1467),
    [anon_sym_GT_GT_EQ] = ACTIONS(1467),
    [anon_sym_LT_LT_EQ] = ACTIONS(1467),
    [anon_sym_CARET_EQ] = ACTIONS(1467),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [900] = {
    [sym_heredoc_body] = STATE(900),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [anon_sym___END__] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_end] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_unless] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_until] = ACTIONS(1005),
    [anon_sym_rescue] = ACTIONS(1005),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_when] = ACTIONS(1005),
    [anon_sym_elsif] = ACTIONS(1005),
    [anon_sym_else] = ACTIONS(1005),
    [anon_sym_then] = ACTIONS(1005),
    [anon_sym_ensure] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_COLON_COLON2] = ACTIONS(1005),
    [anon_sym_AMP_DOT] = ACTIONS(1005),
    [anon_sym_LPAREN2] = ACTIONS(1005),
    [anon_sym_PLUS_EQ] = ACTIONS(1005),
    [anon_sym_DASH_EQ] = ACTIONS(1005),
    [anon_sym_STAR_EQ] = ACTIONS(1005),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_PIPE_EQ] = ACTIONS(1005),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1005),
    [anon_sym_AMP_EQ] = ACTIONS(1005),
    [anon_sym_PERCENT_EQ] = ACTIONS(1005),
    [anon_sym_GT_GT_EQ] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(1005),
    [anon_sym_CARET_EQ] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1005),
    [anon_sym_DOT_DOT] = ACTIONS(1003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1005),
    [anon_sym_or] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1003),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_LT_EQ_GT] = ACTIONS(1005),
    [anon_sym_EQ_TILDE] = ACTIONS(1005),
    [anon_sym_BANG_TILDE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1005),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1005),
    [sym__binary_star] = ACTIONS(1005),
  },
  [901] = {
    [sym_heredoc_body] = STATE(901),
    [ts_builtin_sym_end] = ACTIONS(1469),
    [anon_sym___END__] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_DOT] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_STAR_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_end] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_unless] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_until] = ACTIONS(1469),
    [anon_sym_rescue] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_when] = ACTIONS(1469),
    [anon_sym_elsif] = ACTIONS(1469),
    [anon_sym_else] = ACTIONS(1469),
    [anon_sym_then] = ACTIONS(1469),
    [anon_sym_ensure] = ACTIONS(1469),
    [anon_sym_EQ_GT] = ACTIONS(1469),
    [anon_sym_LBRACK] = ACTIONS(1469),
    [anon_sym_COLON_COLON2] = ACTIONS(1469),
    [anon_sym_AMP_DOT] = ACTIONS(1469),
    [anon_sym_PLUS_EQ] = ACTIONS(1469),
    [anon_sym_DASH_EQ] = ACTIONS(1469),
    [anon_sym_STAR_EQ] = ACTIONS(1469),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1469),
    [anon_sym_SLASH_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1469),
    [anon_sym_AMP_EQ] = ACTIONS(1469),
    [anon_sym_PERCENT_EQ] = ACTIONS(1469),
    [anon_sym_GT_GT_EQ] = ACTIONS(1469),
    [anon_sym_LT_LT_EQ] = ACTIONS(1469),
    [anon_sym_CARET_EQ] = ACTIONS(1469),
    [anon_sym_QMARK] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1469),
    [anon_sym_or] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(1471),
    [anon_sym_LT_EQ] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_EQ] = ACTIONS(1469),
    [anon_sym_CARET] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_SLASH] = ACTIONS(1471),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_EQ_EQ] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1469),
    [anon_sym_LT_EQ_GT] = ACTIONS(1469),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_BANG_TILDE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1469),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1469),
    [sym__binary_star] = ACTIONS(1469),
  },
  [902] = {
    [sym_heredoc_body] = STATE(902),
    [ts_builtin_sym_end] = ACTIONS(1473),
    [anon_sym___END__] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_end] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_unless] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_until] = ACTIONS(1473),
    [anon_sym_rescue] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_when] = ACTIONS(1473),
    [anon_sym_elsif] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_then] = ACTIONS(1473),
    [anon_sym_ensure] = ACTIONS(1473),
    [anon_sym_EQ_GT] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_COLON_COLON2] = ACTIONS(1473),
    [anon_sym_AMP_DOT] = ACTIONS(1473),
    [anon_sym_PLUS_EQ] = ACTIONS(1473),
    [anon_sym_DASH_EQ] = ACTIONS(1473),
    [anon_sym_STAR_EQ] = ACTIONS(1473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1473),
    [anon_sym_SLASH_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1473),
    [anon_sym_AMP_EQ] = ACTIONS(1473),
    [anon_sym_PERCENT_EQ] = ACTIONS(1473),
    [anon_sym_GT_GT_EQ] = ACTIONS(1473),
    [anon_sym_LT_LT_EQ] = ACTIONS(1473),
    [anon_sym_CARET_EQ] = ACTIONS(1473),
    [anon_sym_QMARK] = ACTIONS(1473),
    [anon_sym_DOT_DOT] = ACTIONS(1475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1473),
    [anon_sym_or] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_LT_EQ_GT] = ACTIONS(1473),
    [anon_sym_EQ_TILDE] = ACTIONS(1473),
    [anon_sym_BANG_TILDE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1473),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1473),
    [sym__binary_star] = ACTIONS(1473),
  },
  [903] = {
    [sym_heredoc_body] = STATE(903),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_EQ_GT] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1481),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [904] = {
    [sym_heredoc_body] = STATE(904),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [anon_sym___END__] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_DOT] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_STAR_STAR] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1485),
    [anon_sym_end] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(1483),
    [anon_sym_unless] = ACTIONS(1483),
    [anon_sym_while] = ACTIONS(1483),
    [anon_sym_until] = ACTIONS(1483),
    [anon_sym_rescue] = ACTIONS(1483),
    [anon_sym_do] = ACTIONS(1483),
    [anon_sym_when] = ACTIONS(1483),
    [anon_sym_elsif] = ACTIONS(1483),
    [anon_sym_else] = ACTIONS(1483),
    [anon_sym_then] = ACTIONS(1483),
    [anon_sym_ensure] = ACTIONS(1483),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_COLON_COLON2] = ACTIONS(1483),
    [anon_sym_AMP_DOT] = ACTIONS(1483),
    [anon_sym_PLUS_EQ] = ACTIONS(1483),
    [anon_sym_DASH_EQ] = ACTIONS(1483),
    [anon_sym_STAR_EQ] = ACTIONS(1483),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1483),
    [anon_sym_SLASH_EQ] = ACTIONS(1483),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1483),
    [anon_sym_PIPE_EQ] = ACTIONS(1483),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1483),
    [anon_sym_AMP_EQ] = ACTIONS(1483),
    [anon_sym_PERCENT_EQ] = ACTIONS(1483),
    [anon_sym_GT_GT_EQ] = ACTIONS(1483),
    [anon_sym_LT_LT_EQ] = ACTIONS(1483),
    [anon_sym_CARET_EQ] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_DOT_DOT] = ACTIONS(1485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_and] = ACTIONS(1483),
    [anon_sym_or] = ACTIONS(1483),
    [anon_sym_PIPE_PIPE] = ACTIONS(1485),
    [anon_sym_AMP_AMP] = ACTIONS(1485),
    [anon_sym_LT_LT] = ACTIONS(1485),
    [anon_sym_GT_GT] = ACTIONS(1485),
    [anon_sym_LT_EQ] = ACTIONS(1485),
    [anon_sym_GT] = ACTIONS(1485),
    [anon_sym_GT_EQ] = ACTIONS(1483),
    [anon_sym_CARET] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(1485),
    [anon_sym_EQ_EQ] = ACTIONS(1485),
    [anon_sym_BANG_EQ] = ACTIONS(1483),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1483),
    [anon_sym_LT_EQ_GT] = ACTIONS(1483),
    [anon_sym_EQ_TILDE] = ACTIONS(1483),
    [anon_sym_BANG_TILDE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1483),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1483),
    [sym__binary_star] = ACTIONS(1483),
  },
  [905] = {
    [sym_heredoc_body] = STATE(905),
    [ts_builtin_sym_end] = ACTIONS(999),
    [anon_sym___END__] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_end] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_unless] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [anon_sym_until] = ACTIONS(999),
    [anon_sym_rescue] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_when] = ACTIONS(999),
    [anon_sym_elsif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_then] = ACTIONS(999),
    [anon_sym_ensure] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_COLON_COLON2] = ACTIONS(999),
    [anon_sym_AMP_DOT] = ACTIONS(999),
    [anon_sym_LPAREN2] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_LT_EQ_GT] = ACTIONS(999),
    [anon_sym_EQ_TILDE] = ACTIONS(999),
    [anon_sym_BANG_TILDE] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(999),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(999),
    [sym__binary_star] = ACTIONS(999),
  },
  [906] = {
    [sym_heredoc_body] = STATE(906),
    [ts_builtin_sym_end] = ACTIONS(1487),
    [anon_sym___END__] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_STAR_STAR] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_end] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_unless] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_until] = ACTIONS(1487),
    [anon_sym_rescue] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1487),
    [anon_sym_elsif] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_then] = ACTIONS(1487),
    [anon_sym_ensure] = ACTIONS(1487),
    [anon_sym_EQ_GT] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_COLON_COLON2] = ACTIONS(1487),
    [anon_sym_AMP_DOT] = ACTIONS(1487),
    [anon_sym_PLUS_EQ] = ACTIONS(1487),
    [anon_sym_DASH_EQ] = ACTIONS(1487),
    [anon_sym_STAR_EQ] = ACTIONS(1487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1487),
    [anon_sym_SLASH_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1487),
    [anon_sym_AMP_EQ] = ACTIONS(1487),
    [anon_sym_PERCENT_EQ] = ACTIONS(1487),
    [anon_sym_GT_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_LT_EQ] = ACTIONS(1487),
    [anon_sym_CARET_EQ] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1487),
    [anon_sym_and] = ACTIONS(1487),
    [anon_sym_or] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1489),
    [anon_sym_AMP_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1489),
    [anon_sym_GT_GT] = ACTIONS(1489),
    [anon_sym_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1489),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_SLASH] = ACTIONS(1489),
    [anon_sym_PERCENT] = ACTIONS(1489),
    [anon_sym_EQ_EQ] = ACTIONS(1489),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ_GT] = ACTIONS(1487),
    [anon_sym_EQ_TILDE] = ACTIONS(1487),
    [anon_sym_BANG_TILDE] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1487),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1487),
    [sym__binary_star] = ACTIONS(1487),
  },
  [907] = {
    [sym_heredoc_body] = STATE(907),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [908] = {
    [sym_heredoc_body] = STATE(908),
    [ts_builtin_sym_end] = ACTIONS(1491),
    [anon_sym___END__] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(1491),
    [anon_sym_DOT] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_EQ] = ACTIONS(1493),
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_end] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_unless] = ACTIONS(1491),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_until] = ACTIONS(1491),
    [anon_sym_rescue] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_when] = ACTIONS(1491),
    [anon_sym_elsif] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_then] = ACTIONS(1491),
    [anon_sym_ensure] = ACTIONS(1491),
    [anon_sym_EQ_GT] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_COLON_COLON2] = ACTIONS(1491),
    [anon_sym_AMP_DOT] = ACTIONS(1491),
    [anon_sym_PLUS_EQ] = ACTIONS(1491),
    [anon_sym_DASH_EQ] = ACTIONS(1491),
    [anon_sym_STAR_EQ] = ACTIONS(1491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1491),
    [anon_sym_SLASH_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1491),
    [anon_sym_AMP_EQ] = ACTIONS(1491),
    [anon_sym_PERCENT_EQ] = ACTIONS(1491),
    [anon_sym_GT_GT_EQ] = ACTIONS(1491),
    [anon_sym_LT_LT_EQ] = ACTIONS(1491),
    [anon_sym_CARET_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1491),
    [anon_sym_DOT_DOT] = ACTIONS(1493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1491),
    [anon_sym_or] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1493),
    [anon_sym_AMP_AMP] = ACTIONS(1493),
    [anon_sym_LT_LT] = ACTIONS(1493),
    [anon_sym_GT_GT] = ACTIONS(1493),
    [anon_sym_LT_EQ] = ACTIONS(1493),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_CARET] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1493),
    [anon_sym_PERCENT] = ACTIONS(1493),
    [anon_sym_EQ_EQ] = ACTIONS(1493),
    [anon_sym_BANG_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_LT_EQ_GT] = ACTIONS(1491),
    [anon_sym_EQ_TILDE] = ACTIONS(1491),
    [anon_sym_BANG_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1491),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1491),
    [sym__binary_star] = ACTIONS(1491),
  },
  [909] = {
    [sym_heredoc_body] = STATE(909),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_EQ_GT] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [910] = {
    [sym_heredoc_body] = STATE(910),
    [ts_builtin_sym_end] = ACTIONS(1495),
    [anon_sym___END__] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_DOT] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_STAR_STAR] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_LT] = ACTIONS(1497),
    [anon_sym_end] = ACTIONS(1495),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_unless] = ACTIONS(1495),
    [anon_sym_while] = ACTIONS(1495),
    [anon_sym_until] = ACTIONS(1495),
    [anon_sym_rescue] = ACTIONS(1495),
    [anon_sym_do] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(1495),
    [anon_sym_elsif] = ACTIONS(1495),
    [anon_sym_else] = ACTIONS(1495),
    [anon_sym_then] = ACTIONS(1495),
    [anon_sym_ensure] = ACTIONS(1495),
    [anon_sym_EQ_GT] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1495),
    [anon_sym_COLON_COLON2] = ACTIONS(1495),
    [anon_sym_AMP_DOT] = ACTIONS(1495),
    [anon_sym_PLUS_EQ] = ACTIONS(1495),
    [anon_sym_DASH_EQ] = ACTIONS(1495),
    [anon_sym_STAR_EQ] = ACTIONS(1495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1495),
    [anon_sym_SLASH_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1495),
    [anon_sym_AMP_EQ] = ACTIONS(1495),
    [anon_sym_PERCENT_EQ] = ACTIONS(1495),
    [anon_sym_GT_GT_EQ] = ACTIONS(1495),
    [anon_sym_LT_LT_EQ] = ACTIONS(1495),
    [anon_sym_CARET_EQ] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(1495),
    [anon_sym_DOT_DOT] = ACTIONS(1497),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1495),
    [anon_sym_and] = ACTIONS(1495),
    [anon_sym_or] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE] = ACTIONS(1497),
    [anon_sym_AMP_AMP] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1497),
    [anon_sym_GT_GT] = ACTIONS(1497),
    [anon_sym_LT_EQ] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1497),
    [anon_sym_GT_EQ] = ACTIONS(1495),
    [anon_sym_CARET] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_SLASH] = ACTIONS(1497),
    [anon_sym_PERCENT] = ACTIONS(1497),
    [anon_sym_EQ_EQ] = ACTIONS(1497),
    [anon_sym_BANG_EQ] = ACTIONS(1495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1495),
    [anon_sym_LT_EQ_GT] = ACTIONS(1495),
    [anon_sym_EQ_TILDE] = ACTIONS(1495),
    [anon_sym_BANG_TILDE] = ACTIONS(1495),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1495),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__binary_star] = ACTIONS(1495),
  },
  [911] = {
    [sym_heredoc_body] = STATE(911),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym___END__] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_STAR_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_unless] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_until] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_when] = ACTIONS(1449),
    [anon_sym_elsif] = ACTIONS(1449),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_then] = ACTIONS(1449),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_EQ_GT] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_COLON_COLON2] = ACTIONS(1449),
    [anon_sym_AMP_DOT] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
    [anon_sym_STAR_EQ] = ACTIONS(1449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1449),
    [anon_sym_SLASH_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1449),
    [anon_sym_AMP_EQ] = ACTIONS(1449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1449),
    [anon_sym_CARET_EQ] = ACTIONS(1449),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1449),
    [anon_sym_and] = ACTIONS(1449),
    [anon_sym_or] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_LT_EQ_GT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_BANG_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1449),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1449),
    [sym__binary_star] = ACTIONS(1449),
  },
  [912] = {
    [sym_heredoc_body] = STATE(912),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_EQ_GT] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1481),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [913] = {
    [sym_heredoc_body] = STATE(913),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1479),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_EQ_GT] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1481),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [914] = {
    [sym_heredoc_body] = STATE(914),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [anon_sym___END__] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_STAR_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1007),
    [anon_sym_end] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_until] = ACTIONS(1009),
    [anon_sym_rescue] = ACTIONS(1009),
    [anon_sym_do] = ACTIONS(1009),
    [anon_sym_when] = ACTIONS(1009),
    [anon_sym_elsif] = ACTIONS(1009),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_then] = ACTIONS(1009),
    [anon_sym_ensure] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_COLON_COLON2] = ACTIONS(1009),
    [anon_sym_AMP_DOT] = ACTIONS(1009),
    [anon_sym_LPAREN2] = ACTIONS(1009),
    [anon_sym_PLUS_EQ] = ACTIONS(1009),
    [anon_sym_DASH_EQ] = ACTIONS(1009),
    [anon_sym_STAR_EQ] = ACTIONS(1009),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1009),
    [anon_sym_SLASH_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_PIPE_EQ] = ACTIONS(1009),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1009),
    [anon_sym_AMP_EQ] = ACTIONS(1009),
    [anon_sym_PERCENT_EQ] = ACTIONS(1009),
    [anon_sym_GT_GT_EQ] = ACTIONS(1009),
    [anon_sym_LT_LT_EQ] = ACTIONS(1009),
    [anon_sym_CARET_EQ] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1009),
    [anon_sym_DOT_DOT] = ACTIONS(1007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1009),
    [anon_sym_and] = ACTIONS(1009),
    [anon_sym_or] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1007),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_EQ] = ACTIONS(1007),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_CARET] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1007),
    [anon_sym_PERCENT] = ACTIONS(1007),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_LT_EQ_GT] = ACTIONS(1009),
    [anon_sym_EQ_TILDE] = ACTIONS(1009),
    [anon_sym_BANG_TILDE] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1009),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1009),
    [sym__binary_star] = ACTIONS(1009),
  },
  [915] = {
    [sym_heredoc_body] = STATE(915),
    [ts_builtin_sym_end] = ACTIONS(1499),
    [anon_sym___END__] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_unless] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_until] = ACTIONS(1499),
    [anon_sym_rescue] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_when] = ACTIONS(1499),
    [anon_sym_elsif] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_then] = ACTIONS(1499),
    [anon_sym_ensure] = ACTIONS(1499),
    [anon_sym_EQ_GT] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_COLON_COLON2] = ACTIONS(1499),
    [anon_sym_AMP_DOT] = ACTIONS(1499),
    [anon_sym_PLUS_EQ] = ACTIONS(1499),
    [anon_sym_DASH_EQ] = ACTIONS(1499),
    [anon_sym_STAR_EQ] = ACTIONS(1499),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1499),
    [anon_sym_SLASH_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1499),
    [anon_sym_AMP_EQ] = ACTIONS(1499),
    [anon_sym_PERCENT_EQ] = ACTIONS(1499),
    [anon_sym_GT_GT_EQ] = ACTIONS(1499),
    [anon_sym_LT_LT_EQ] = ACTIONS(1499),
    [anon_sym_CARET_EQ] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1499),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_and] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1499),
    [anon_sym_LT_EQ_GT] = ACTIONS(1499),
    [anon_sym_EQ_TILDE] = ACTIONS(1499),
    [anon_sym_BANG_TILDE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1499),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1499),
    [sym__binary_star] = ACTIONS(1499),
  },
  [916] = {
    [sym_heredoc_body] = STATE(916),
    [ts_builtin_sym_end] = ACTIONS(1503),
    [anon_sym___END__] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_RBRACE] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_DOT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_PIPE] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_STAR_STAR] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1505),
    [anon_sym_EQ] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_unless] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_until] = ACTIONS(1503),
    [anon_sym_rescue] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(1503),
    [anon_sym_elsif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_then] = ACTIONS(1503),
    [anon_sym_ensure] = ACTIONS(1503),
    [anon_sym_EQ_GT] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_COLON_COLON2] = ACTIONS(1503),
    [anon_sym_AMP_DOT] = ACTIONS(1503),
    [anon_sym_PLUS_EQ] = ACTIONS(1503),
    [anon_sym_DASH_EQ] = ACTIONS(1503),
    [anon_sym_STAR_EQ] = ACTIONS(1503),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1503),
    [anon_sym_SLASH_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1503),
    [anon_sym_AMP_EQ] = ACTIONS(1503),
    [anon_sym_PERCENT_EQ] = ACTIONS(1503),
    [anon_sym_GT_GT_EQ] = ACTIONS(1503),
    [anon_sym_LT_LT_EQ] = ACTIONS(1503),
    [anon_sym_CARET_EQ] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_and] = ACTIONS(1503),
    [anon_sym_or] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE] = ACTIONS(1505),
    [anon_sym_AMP_AMP] = ACTIONS(1505),
    [anon_sym_LT_LT] = ACTIONS(1505),
    [anon_sym_GT_GT] = ACTIONS(1505),
    [anon_sym_LT_EQ] = ACTIONS(1505),
    [anon_sym_GT] = ACTIONS(1505),
    [anon_sym_GT_EQ] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(1505),
    [anon_sym_PERCENT] = ACTIONS(1505),
    [anon_sym_EQ_EQ] = ACTIONS(1505),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1503),
    [anon_sym_LT_EQ_GT] = ACTIONS(1503),
    [anon_sym_EQ_TILDE] = ACTIONS(1503),
    [anon_sym_BANG_TILDE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1503),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1503),
    [sym__binary_star] = ACTIONS(1503),
  },
  [917] = {
    [sym_heredoc_body] = STATE(917),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [anon_sym___END__] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_end] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_unless] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1025),
    [anon_sym_rescue] = ACTIONS(1025),
    [anon_sym_do] = ACTIONS(1025),
    [anon_sym_when] = ACTIONS(1025),
    [anon_sym_elsif] = ACTIONS(1025),
    [anon_sym_else] = ACTIONS(1025),
    [anon_sym_then] = ACTIONS(1025),
    [anon_sym_ensure] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_COLON_COLON2] = ACTIONS(1025),
    [anon_sym_AMP_DOT] = ACTIONS(1025),
    [anon_sym_LPAREN2] = ACTIONS(1025),
    [anon_sym_PLUS_EQ] = ACTIONS(1025),
    [anon_sym_DASH_EQ] = ACTIONS(1025),
    [anon_sym_STAR_EQ] = ACTIONS(1025),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1025),
    [anon_sym_SLASH_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_EQ] = ACTIONS(1025),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1025),
    [anon_sym_AMP_EQ] = ACTIONS(1025),
    [anon_sym_PERCENT_EQ] = ACTIONS(1025),
    [anon_sym_GT_GT_EQ] = ACTIONS(1025),
    [anon_sym_LT_LT_EQ] = ACTIONS(1025),
    [anon_sym_CARET_EQ] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_DOT_DOT] = ACTIONS(1023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1025),
    [anon_sym_or] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_EQ] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_PERCENT] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_LT_EQ_GT] = ACTIONS(1025),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_BANG_TILDE] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1025),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(1025),
  },
  [918] = {
    [sym_heredoc_body] = STATE(918),
    [ts_builtin_sym_end] = ACTIONS(1507),
    [anon_sym___END__] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_RPAREN] = ACTIONS(1507),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(1509),
    [anon_sym_end] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_unless] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_until] = ACTIONS(1507),
    [anon_sym_rescue] = ACTIONS(1507),
    [anon_sym_do] = ACTIONS(1507),
    [anon_sym_when] = ACTIONS(1507),
    [anon_sym_elsif] = ACTIONS(1507),
    [anon_sym_else] = ACTIONS(1507),
    [anon_sym_then] = ACTIONS(1507),
    [anon_sym_ensure] = ACTIONS(1507),
    [anon_sym_EQ_GT] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1507),
    [anon_sym_COLON_COLON2] = ACTIONS(1507),
    [anon_sym_AMP_DOT] = ACTIONS(1507),
    [anon_sym_PLUS_EQ] = ACTIONS(1507),
    [anon_sym_DASH_EQ] = ACTIONS(1507),
    [anon_sym_STAR_EQ] = ACTIONS(1507),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1507),
    [anon_sym_SLASH_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1507),
    [anon_sym_AMP_EQ] = ACTIONS(1507),
    [anon_sym_PERCENT_EQ] = ACTIONS(1507),
    [anon_sym_GT_GT_EQ] = ACTIONS(1507),
    [anon_sym_LT_LT_EQ] = ACTIONS(1507),
    [anon_sym_CARET_EQ] = ACTIONS(1507),
    [anon_sym_QMARK] = ACTIONS(1507),
    [anon_sym_DOT_DOT] = ACTIONS(1509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1507),
    [anon_sym_and] = ACTIONS(1507),
    [anon_sym_or] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE] = ACTIONS(1509),
    [anon_sym_AMP_AMP] = ACTIONS(1509),
    [anon_sym_LT_LT] = ACTIONS(1509),
    [anon_sym_GT_GT] = ACTIONS(1509),
    [anon_sym_LT_EQ] = ACTIONS(1509),
    [anon_sym_GT] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(1507),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_EQ] = ACTIONS(1509),
    [anon_sym_BANG_EQ] = ACTIONS(1507),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1507),
    [anon_sym_LT_EQ_GT] = ACTIONS(1507),
    [anon_sym_EQ_TILDE] = ACTIONS(1507),
    [anon_sym_BANG_TILDE] = ACTIONS(1507),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1507),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1507),
    [sym__binary_star] = ACTIONS(1507),
  },
  [919] = {
    [sym_heredoc_body] = STATE(919),
    [ts_builtin_sym_end] = ACTIONS(1013),
    [anon_sym___END__] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_RPAREN] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_STAR_STAR] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_end] = ACTIONS(1013),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_unless] = ACTIONS(1013),
    [anon_sym_while] = ACTIONS(1013),
    [anon_sym_until] = ACTIONS(1013),
    [anon_sym_rescue] = ACTIONS(1013),
    [anon_sym_do] = ACTIONS(1013),
    [anon_sym_when] = ACTIONS(1013),
    [anon_sym_elsif] = ACTIONS(1013),
    [anon_sym_else] = ACTIONS(1013),
    [anon_sym_then] = ACTIONS(1013),
    [anon_sym_ensure] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_COLON_COLON2] = ACTIONS(1013),
    [anon_sym_AMP_DOT] = ACTIONS(1013),
    [anon_sym_LPAREN2] = ACTIONS(1013),
    [anon_sym_PLUS_EQ] = ACTIONS(1013),
    [anon_sym_DASH_EQ] = ACTIONS(1013),
    [anon_sym_STAR_EQ] = ACTIONS(1013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1013),
    [anon_sym_SLASH_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_PIPE_EQ] = ACTIONS(1013),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1013),
    [anon_sym_AMP_EQ] = ACTIONS(1013),
    [anon_sym_PERCENT_EQ] = ACTIONS(1013),
    [anon_sym_GT_GT_EQ] = ACTIONS(1013),
    [anon_sym_LT_LT_EQ] = ACTIONS(1013),
    [anon_sym_CARET_EQ] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1013),
    [anon_sym_DOT_DOT] = ACTIONS(1011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1013),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_or] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1011),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_EQ] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1011),
    [anon_sym_GT_EQ] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(1011),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1013),
    [anon_sym_LT_EQ_GT] = ACTIONS(1013),
    [anon_sym_EQ_TILDE] = ACTIONS(1013),
    [anon_sym_BANG_TILDE] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1013),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1013),
    [sym__binary_star] = ACTIONS(1013),
  },
  [920] = {
    [sym_heredoc_body] = STATE(920),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_EQ_GT] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1481),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [921] = {
    [sym_heredoc_body] = STATE(921),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_STAR_STAR] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(1511),
    [anon_sym_DOT_DOT] = ACTIONS(1513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_LT_EQ] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_EQ] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1513),
    [anon_sym_PERCENT] = ACTIONS(1513),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1511),
    [anon_sym_LT_EQ_GT] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(1511),
  },
  [922] = {
    [sym_heredoc_body] = STATE(922),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [anon_sym___END__] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_STAR_STAR] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_end] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_unless] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_until] = ACTIONS(1021),
    [anon_sym_rescue] = ACTIONS(1021),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_when] = ACTIONS(1021),
    [anon_sym_elsif] = ACTIONS(1021),
    [anon_sym_else] = ACTIONS(1021),
    [anon_sym_then] = ACTIONS(1021),
    [anon_sym_ensure] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [anon_sym_COLON_COLON2] = ACTIONS(1021),
    [anon_sym_AMP_DOT] = ACTIONS(1021),
    [anon_sym_LPAREN2] = ACTIONS(1021),
    [anon_sym_PLUS_EQ] = ACTIONS(1021),
    [anon_sym_DASH_EQ] = ACTIONS(1021),
    [anon_sym_STAR_EQ] = ACTIONS(1021),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1021),
    [anon_sym_SLASH_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_PIPE_EQ] = ACTIONS(1021),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1021),
    [anon_sym_AMP_EQ] = ACTIONS(1021),
    [anon_sym_PERCENT_EQ] = ACTIONS(1021),
    [anon_sym_GT_GT_EQ] = ACTIONS(1021),
    [anon_sym_LT_LT_EQ] = ACTIONS(1021),
    [anon_sym_CARET_EQ] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1021),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1021),
    [anon_sym_or] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1019),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1021),
    [anon_sym_CARET] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1019),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1021),
    [anon_sym_LT_EQ_GT] = ACTIONS(1021),
    [anon_sym_EQ_TILDE] = ACTIONS(1021),
    [anon_sym_BANG_TILDE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1021),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1021),
    [sym__binary_star] = ACTIONS(1021),
  },
  [923] = {
    [sym_heredoc_body] = STATE(923),
    [ts_builtin_sym_end] = ACTIONS(1515),
    [anon_sym___END__] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_RPAREN] = ACTIONS(1515),
    [anon_sym_DOT] = ACTIONS(1517),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1517),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_end] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_unless] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_until] = ACTIONS(1515),
    [anon_sym_rescue] = ACTIONS(1515),
    [anon_sym_do] = ACTIONS(1515),
    [anon_sym_when] = ACTIONS(1515),
    [anon_sym_elsif] = ACTIONS(1515),
    [anon_sym_else] = ACTIONS(1515),
    [anon_sym_then] = ACTIONS(1515),
    [anon_sym_ensure] = ACTIONS(1515),
    [anon_sym_EQ_GT] = ACTIONS(1515),
    [anon_sym_LBRACK] = ACTIONS(1515),
    [anon_sym_COLON_COLON2] = ACTIONS(1515),
    [anon_sym_AMP_DOT] = ACTIONS(1515),
    [anon_sym_PLUS_EQ] = ACTIONS(1515),
    [anon_sym_DASH_EQ] = ACTIONS(1515),
    [anon_sym_STAR_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1515),
    [anon_sym_SLASH_EQ] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1515),
    [anon_sym_PIPE_EQ] = ACTIONS(1515),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1515),
    [anon_sym_AMP_EQ] = ACTIONS(1515),
    [anon_sym_PERCENT_EQ] = ACTIONS(1515),
    [anon_sym_GT_GT_EQ] = ACTIONS(1515),
    [anon_sym_LT_LT_EQ] = ACTIONS(1515),
    [anon_sym_CARET_EQ] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(1515),
    [anon_sym_or] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_PERCENT] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1515),
  },
  [924] = {
    [sym_heredoc_body] = STATE(924),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_LPAREN2] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(909),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(909),
    [sym__binary_star] = ACTIONS(909),
  },
  [925] = {
    [sym_heredoc_body] = STATE(925),
    [ts_builtin_sym_end] = ACTIONS(1519),
    [anon_sym___END__] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_RPAREN] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_end] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_unless] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_until] = ACTIONS(1519),
    [anon_sym_rescue] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(1519),
    [anon_sym_elsif] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_then] = ACTIONS(1519),
    [anon_sym_ensure] = ACTIONS(1519),
    [anon_sym_EQ_GT] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1519),
    [anon_sym_COLON_COLON2] = ACTIONS(1519),
    [anon_sym_AMP_DOT] = ACTIONS(1519),
    [anon_sym_PLUS_EQ] = ACTIONS(1519),
    [anon_sym_DASH_EQ] = ACTIONS(1519),
    [anon_sym_STAR_EQ] = ACTIONS(1519),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1519),
    [anon_sym_SLASH_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1519),
    [anon_sym_AMP_EQ] = ACTIONS(1519),
    [anon_sym_PERCENT_EQ] = ACTIONS(1519),
    [anon_sym_GT_GT_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_EQ] = ACTIONS(1519),
    [anon_sym_CARET_EQ] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1519),
    [anon_sym_DOT_DOT] = ACTIONS(1521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1519),
    [anon_sym_and] = ACTIONS(1519),
    [anon_sym_or] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1519),
    [anon_sym_LT_EQ_GT] = ACTIONS(1519),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_BANG_TILDE] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1519),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1519),
    [sym__binary_star] = ACTIONS(1519),
  },
  [926] = {
    [sym_heredoc_body] = STATE(926),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [anon_sym___END__] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_DOT] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_STAR_STAR] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1485),
    [anon_sym_end] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(1483),
    [anon_sym_unless] = ACTIONS(1483),
    [anon_sym_while] = ACTIONS(1483),
    [anon_sym_until] = ACTIONS(1483),
    [anon_sym_rescue] = ACTIONS(1483),
    [anon_sym_do] = ACTIONS(1483),
    [anon_sym_when] = ACTIONS(1483),
    [anon_sym_elsif] = ACTIONS(1483),
    [anon_sym_else] = ACTIONS(1483),
    [anon_sym_then] = ACTIONS(1483),
    [anon_sym_ensure] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_COLON_COLON2] = ACTIONS(1483),
    [anon_sym_AMP_DOT] = ACTIONS(1483),
    [anon_sym_PLUS_EQ] = ACTIONS(1483),
    [anon_sym_DASH_EQ] = ACTIONS(1483),
    [anon_sym_STAR_EQ] = ACTIONS(1483),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1483),
    [anon_sym_SLASH_EQ] = ACTIONS(1483),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1483),
    [anon_sym_PIPE_EQ] = ACTIONS(1483),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1483),
    [anon_sym_AMP_EQ] = ACTIONS(1483),
    [anon_sym_PERCENT_EQ] = ACTIONS(1483),
    [anon_sym_GT_GT_EQ] = ACTIONS(1483),
    [anon_sym_LT_LT_EQ] = ACTIONS(1483),
    [anon_sym_CARET_EQ] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_DOT_DOT] = ACTIONS(1485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_and] = ACTIONS(1483),
    [anon_sym_or] = ACTIONS(1483),
    [anon_sym_PIPE_PIPE] = ACTIONS(1485),
    [anon_sym_AMP_AMP] = ACTIONS(1485),
    [anon_sym_LT_LT] = ACTIONS(1485),
    [anon_sym_GT_GT] = ACTIONS(1485),
    [anon_sym_LT_EQ] = ACTIONS(1485),
    [anon_sym_GT] = ACTIONS(1485),
    [anon_sym_GT_EQ] = ACTIONS(1483),
    [anon_sym_CARET] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(1485),
    [anon_sym_EQ_EQ] = ACTIONS(1485),
    [anon_sym_BANG_EQ] = ACTIONS(1483),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1483),
    [anon_sym_LT_EQ_GT] = ACTIONS(1483),
    [anon_sym_EQ_TILDE] = ACTIONS(1483),
    [anon_sym_BANG_TILDE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1483),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1483),
    [sym__binary_star] = ACTIONS(1483),
  },
  [927] = {
    [sym_heredoc_body] = STATE(927),
    [ts_builtin_sym_end] = ACTIONS(1473),
    [anon_sym___END__] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1473),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_STAR_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_EQ] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_end] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_unless] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_until] = ACTIONS(1473),
    [anon_sym_rescue] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_when] = ACTIONS(1473),
    [anon_sym_elsif] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_then] = ACTIONS(1473),
    [anon_sym_ensure] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1473),
    [anon_sym_COLON_COLON2] = ACTIONS(1473),
    [anon_sym_AMP_DOT] = ACTIONS(1473),
    [anon_sym_PLUS_EQ] = ACTIONS(1473),
    [anon_sym_DASH_EQ] = ACTIONS(1473),
    [anon_sym_STAR_EQ] = ACTIONS(1473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1473),
    [anon_sym_SLASH_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_PIPE_EQ] = ACTIONS(1473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1473),
    [anon_sym_AMP_EQ] = ACTIONS(1473),
    [anon_sym_PERCENT_EQ] = ACTIONS(1473),
    [anon_sym_GT_GT_EQ] = ACTIONS(1473),
    [anon_sym_LT_LT_EQ] = ACTIONS(1473),
    [anon_sym_CARET_EQ] = ACTIONS(1473),
    [anon_sym_QMARK] = ACTIONS(1473),
    [anon_sym_DOT_DOT] = ACTIONS(1475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1473),
    [anon_sym_and] = ACTIONS(1473),
    [anon_sym_or] = ACTIONS(1473),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(1475),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_LT_EQ] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1475),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1473),
    [anon_sym_LT_EQ_GT] = ACTIONS(1473),
    [anon_sym_EQ_TILDE] = ACTIONS(1473),
    [anon_sym_BANG_TILDE] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1473),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1473),
    [sym__binary_star] = ACTIONS(1473),
  },
  [928] = {
    [sym_heredoc_body] = STATE(928),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [929] = {
    [sym_heredoc_body] = STATE(929),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym___END__] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1461),
    [anon_sym_STAR_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_end] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_unless] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_until] = ACTIONS(1461),
    [anon_sym_rescue] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_when] = ACTIONS(1461),
    [anon_sym_elsif] = ACTIONS(1461),
    [anon_sym_else] = ACTIONS(1461),
    [anon_sym_then] = ACTIONS(1461),
    [anon_sym_ensure] = ACTIONS(1461),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_COLON_COLON2] = ACTIONS(1461),
    [anon_sym_AMP_DOT] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_STAR_EQ] = ACTIONS(1461),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1461),
    [anon_sym_SLASH_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1461),
    [anon_sym_AMP_EQ] = ACTIONS(1461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1461),
    [anon_sym_GT_GT_EQ] = ACTIONS(1461),
    [anon_sym_LT_LT_EQ] = ACTIONS(1461),
    [anon_sym_CARET_EQ] = ACTIONS(1461),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1461),
    [anon_sym_and] = ACTIONS(1461),
    [anon_sym_or] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_CARET] = ACTIONS(1463),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1461),
    [anon_sym_LT_EQ_GT] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_BANG_TILDE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1461),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(1461),
  },
  [930] = {
    [sym_heredoc_body] = STATE(930),
    [ts_builtin_sym_end] = ACTIONS(1487),
    [anon_sym___END__] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_STAR_STAR] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_end] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_unless] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_until] = ACTIONS(1487),
    [anon_sym_rescue] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1487),
    [anon_sym_elsif] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_then] = ACTIONS(1487),
    [anon_sym_ensure] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_COLON_COLON2] = ACTIONS(1487),
    [anon_sym_AMP_DOT] = ACTIONS(1487),
    [anon_sym_PLUS_EQ] = ACTIONS(1487),
    [anon_sym_DASH_EQ] = ACTIONS(1487),
    [anon_sym_STAR_EQ] = ACTIONS(1487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1487),
    [anon_sym_SLASH_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_PIPE_EQ] = ACTIONS(1487),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1487),
    [anon_sym_AMP_EQ] = ACTIONS(1487),
    [anon_sym_PERCENT_EQ] = ACTIONS(1487),
    [anon_sym_GT_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_LT_EQ] = ACTIONS(1487),
    [anon_sym_CARET_EQ] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1487),
    [anon_sym_and] = ACTIONS(1487),
    [anon_sym_or] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1489),
    [anon_sym_AMP_AMP] = ACTIONS(1489),
    [anon_sym_LT_LT] = ACTIONS(1489),
    [anon_sym_GT_GT] = ACTIONS(1489),
    [anon_sym_LT_EQ] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1489),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_SLASH] = ACTIONS(1489),
    [anon_sym_PERCENT] = ACTIONS(1489),
    [anon_sym_EQ_EQ] = ACTIONS(1489),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ_GT] = ACTIONS(1487),
    [anon_sym_EQ_TILDE] = ACTIONS(1487),
    [anon_sym_BANG_TILDE] = ACTIONS(1487),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1487),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1487),
    [sym__binary_star] = ACTIONS(1487),
  },
  [931] = {
    [sym_heredoc_body] = STATE(931),
    [ts_builtin_sym_end] = ACTIONS(1491),
    [anon_sym___END__] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(1491),
    [anon_sym_DOT] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_EQ] = ACTIONS(1493),
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_end] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_unless] = ACTIONS(1491),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_until] = ACTIONS(1491),
    [anon_sym_rescue] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_when] = ACTIONS(1491),
    [anon_sym_elsif] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_then] = ACTIONS(1491),
    [anon_sym_ensure] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_COLON_COLON2] = ACTIONS(1491),
    [anon_sym_AMP_DOT] = ACTIONS(1491),
    [anon_sym_PLUS_EQ] = ACTIONS(1491),
    [anon_sym_DASH_EQ] = ACTIONS(1491),
    [anon_sym_STAR_EQ] = ACTIONS(1491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1491),
    [anon_sym_SLASH_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_PIPE_EQ] = ACTIONS(1491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1491),
    [anon_sym_AMP_EQ] = ACTIONS(1491),
    [anon_sym_PERCENT_EQ] = ACTIONS(1491),
    [anon_sym_GT_GT_EQ] = ACTIONS(1491),
    [anon_sym_LT_LT_EQ] = ACTIONS(1491),
    [anon_sym_CARET_EQ] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1491),
    [anon_sym_DOT_DOT] = ACTIONS(1493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1491),
    [anon_sym_or] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1493),
    [anon_sym_AMP_AMP] = ACTIONS(1493),
    [anon_sym_LT_LT] = ACTIONS(1493),
    [anon_sym_GT_GT] = ACTIONS(1493),
    [anon_sym_LT_EQ] = ACTIONS(1493),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_CARET] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1493),
    [anon_sym_PERCENT] = ACTIONS(1493),
    [anon_sym_EQ_EQ] = ACTIONS(1493),
    [anon_sym_BANG_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_LT_EQ_GT] = ACTIONS(1491),
    [anon_sym_EQ_TILDE] = ACTIONS(1491),
    [anon_sym_BANG_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1491),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1491),
    [sym__binary_star] = ACTIONS(1491),
  },
  [932] = {
    [sym_heredoc_body] = STATE(932),
    [ts_builtin_sym_end] = ACTIONS(1453),
    [anon_sym___END__] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_EQ] = ACTIONS(1455),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_end] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_unless] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_until] = ACTIONS(1453),
    [anon_sym_rescue] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_when] = ACTIONS(1453),
    [anon_sym_elsif] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1453),
    [anon_sym_then] = ACTIONS(1453),
    [anon_sym_ensure] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_COLON_COLON2] = ACTIONS(1453),
    [anon_sym_AMP_DOT] = ACTIONS(1453),
    [anon_sym_PLUS_EQ] = ACTIONS(1453),
    [anon_sym_DASH_EQ] = ACTIONS(1453),
    [anon_sym_STAR_EQ] = ACTIONS(1453),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1453),
    [anon_sym_SLASH_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1453),
    [anon_sym_AMP_EQ] = ACTIONS(1453),
    [anon_sym_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_GT_GT_EQ] = ACTIONS(1453),
    [anon_sym_LT_LT_EQ] = ACTIONS(1453),
    [anon_sym_CARET_EQ] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1453),
    [anon_sym_and] = ACTIONS(1453),
    [anon_sym_or] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1455),
    [anon_sym_AMP_AMP] = ACTIONS(1455),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1455),
    [anon_sym_EQ_EQ] = ACTIONS(1455),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1453),
    [anon_sym_LT_EQ_GT] = ACTIONS(1453),
    [anon_sym_EQ_TILDE] = ACTIONS(1453),
    [anon_sym_BANG_TILDE] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1453),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1453),
    [sym__binary_star] = ACTIONS(1453),
  },
  [933] = {
    [sym_heredoc_body] = STATE(933),
    [sym_identifier] = ACTIONS(496),
    [anon_sym_BEGIN] = ACTIONS(496),
    [anon_sym_LBRACE] = ACTIONS(470),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_END] = ACTIONS(496),
    [anon_sym_def] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(470),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_COLON_COLON] = ACTIONS(470),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_class] = ACTIONS(496),
    [anon_sym_module] = ACTIONS(496),
    [anon_sym_end] = ACTIONS(496),
    [anon_sym_return] = ACTIONS(496),
    [anon_sym_yield] = ACTIONS(496),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_next] = ACTIONS(496),
    [anon_sym_redo] = ACTIONS(496),
    [anon_sym_retry] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_unless] = ACTIONS(496),
    [anon_sym_while] = ACTIONS(496),
    [anon_sym_until] = ACTIONS(496),
    [anon_sym_rescue] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(496),
    [anon_sym_case] = ACTIONS(496),
    [anon_sym_when] = ACTIONS(496),
    [anon_sym_elsif] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_begin] = ACTIONS(496),
    [anon_sym_ensure] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_defined_QMARK] = ACTIONS(470),
    [anon_sym_not] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_TILDE] = ACTIONS(470),
    [sym_constant] = ACTIONS(496),
    [sym_instance_variable] = ACTIONS(470),
    [sym_class_variable] = ACTIONS(470),
    [sym_global_variable] = ACTIONS(470),
    [anon_sym_undef] = ACTIONS(496),
    [anon_sym_alias] = ACTIONS(496),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(496),
    [sym_float] = ACTIONS(496),
    [sym_complex] = ACTIONS(470),
    [sym_super] = ACTIONS(496),
    [anon_sym_true] = ACTIONS(496),
    [anon_sym_TRUE] = ACTIONS(496),
    [anon_sym_false] = ACTIONS(496),
    [anon_sym_FALSE] = ACTIONS(496),
    [sym_self] = ACTIONS(496),
    [anon_sym_nil] = ACTIONS(496),
    [anon_sym_NIL] = ACTIONS(496),
    [sym_character] = ACTIONS(470),
    [anon_sym_LBRACK2] = ACTIONS(470),
    [anon_sym_DASH_GT] = ACTIONS(470),
    [sym__simple_symbol] = ACTIONS(470),
    [sym__string_start] = ACTIONS(470),
    [sym__symbol_start] = ACTIONS(470),
    [sym__subshell_start] = ACTIONS(470),
    [sym__regex_start] = ACTIONS(470),
    [sym__string_array_start] = ACTIONS(470),
    [sym__symbol_array_start] = ACTIONS(470),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(470),
    [sym__unary_minus] = ACTIONS(470),
  },
  [934] = {
    [sym_heredoc_body] = STATE(934),
    [ts_builtin_sym_end] = ACTIONS(1495),
    [anon_sym___END__] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_DOT] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_STAR_STAR] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_LT] = ACTIONS(1497),
    [anon_sym_end] = ACTIONS(1495),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_unless] = ACTIONS(1495),
    [anon_sym_while] = ACTIONS(1495),
    [anon_sym_until] = ACTIONS(1495),
    [anon_sym_rescue] = ACTIONS(1495),
    [anon_sym_do] = ACTIONS(1495),
    [anon_sym_when] = ACTIONS(1495),
    [anon_sym_elsif] = ACTIONS(1495),
    [anon_sym_else] = ACTIONS(1495),
    [anon_sym_then] = ACTIONS(1495),
    [anon_sym_ensure] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1495),
    [anon_sym_COLON_COLON2] = ACTIONS(1495),
    [anon_sym_AMP_DOT] = ACTIONS(1495),
    [anon_sym_PLUS_EQ] = ACTIONS(1495),
    [anon_sym_DASH_EQ] = ACTIONS(1495),
    [anon_sym_STAR_EQ] = ACTIONS(1495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1495),
    [anon_sym_SLASH_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_PIPE_EQ] = ACTIONS(1495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1495),
    [anon_sym_AMP_EQ] = ACTIONS(1495),
    [anon_sym_PERCENT_EQ] = ACTIONS(1495),
    [anon_sym_GT_GT_EQ] = ACTIONS(1495),
    [anon_sym_LT_LT_EQ] = ACTIONS(1495),
    [anon_sym_CARET_EQ] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(1495),
    [anon_sym_DOT_DOT] = ACTIONS(1497),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1495),
    [anon_sym_and] = ACTIONS(1495),
    [anon_sym_or] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE] = ACTIONS(1497),
    [anon_sym_AMP_AMP] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1497),
    [anon_sym_GT_GT] = ACTIONS(1497),
    [anon_sym_LT_EQ] = ACTIONS(1497),
    [anon_sym_GT] = ACTIONS(1497),
    [anon_sym_GT_EQ] = ACTIONS(1495),
    [anon_sym_CARET] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_SLASH] = ACTIONS(1497),
    [anon_sym_PERCENT] = ACTIONS(1497),
    [anon_sym_EQ_EQ] = ACTIONS(1497),
    [anon_sym_BANG_EQ] = ACTIONS(1495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1495),
    [anon_sym_LT_EQ_GT] = ACTIONS(1495),
    [anon_sym_EQ_TILDE] = ACTIONS(1495),
    [anon_sym_BANG_TILDE] = ACTIONS(1495),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1495),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__binary_star] = ACTIONS(1495),
  },
  [935] = {
    [sym_heredoc_body] = STATE(935),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym___END__] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_end] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_until] = ACTIONS(111),
    [anon_sym_rescue] = ACTIONS(111),
    [anon_sym_do] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(111),
    [anon_sym_elsif] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(111),
    [anon_sym_then] = ACTIONS(111),
    [anon_sym_ensure] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_COLON_COLON2] = ACTIONS(111),
    [anon_sym_AMP_DOT] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(111),
    [anon_sym_and] = ACTIONS(111),
    [anon_sym_or] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_LT_EQ_GT] = ACTIONS(111),
    [anon_sym_EQ_TILDE] = ACTIONS(111),
    [anon_sym_BANG_TILDE] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(111),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(111),
    [sym__binary_star] = ACTIONS(111),
  },
  [936] = {
    [sym_heredoc_body] = STATE(936),
    [ts_builtin_sym_end] = ACTIONS(1515),
    [anon_sym___END__] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_RPAREN] = ACTIONS(1515),
    [anon_sym_DOT] = ACTIONS(1517),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1517),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_end] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_unless] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_until] = ACTIONS(1515),
    [anon_sym_rescue] = ACTIONS(1515),
    [anon_sym_do] = ACTIONS(1515),
    [anon_sym_when] = ACTIONS(1515),
    [anon_sym_elsif] = ACTIONS(1515),
    [anon_sym_else] = ACTIONS(1515),
    [anon_sym_then] = ACTIONS(1515),
    [anon_sym_ensure] = ACTIONS(1515),
    [anon_sym_LBRACK] = ACTIONS(1515),
    [anon_sym_COLON_COLON2] = ACTIONS(1515),
    [anon_sym_AMP_DOT] = ACTIONS(1515),
    [anon_sym_PLUS_EQ] = ACTIONS(1515),
    [anon_sym_DASH_EQ] = ACTIONS(1515),
    [anon_sym_STAR_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1515),
    [anon_sym_SLASH_EQ] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1515),
    [anon_sym_PIPE_EQ] = ACTIONS(1515),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1515),
    [anon_sym_AMP_EQ] = ACTIONS(1515),
    [anon_sym_PERCENT_EQ] = ACTIONS(1515),
    [anon_sym_GT_GT_EQ] = ACTIONS(1515),
    [anon_sym_LT_LT_EQ] = ACTIONS(1515),
    [anon_sym_CARET_EQ] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(1515),
    [anon_sym_or] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1517),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_PERCENT] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1515),
  },
  [937] = {
    [sym_heredoc_body] = STATE(937),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym___END__] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_EQ_GT] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1525),
    [anon_sym_DASH_EQ] = ACTIONS(1525),
    [anon_sym_STAR_EQ] = ACTIONS(1525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1525),
    [anon_sym_SLASH_EQ] = ACTIONS(1525),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1525),
    [anon_sym_PIPE_EQ] = ACTIONS(1525),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1525),
    [anon_sym_AMP_EQ] = ACTIONS(1525),
    [anon_sym_PERCENT_EQ] = ACTIONS(1525),
    [anon_sym_GT_GT_EQ] = ACTIONS(1525),
    [anon_sym_LT_LT_EQ] = ACTIONS(1525),
    [anon_sym_CARET_EQ] = ACTIONS(1525),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [938] = {
    [sym_heredoc_body] = STATE(938),
    [ts_builtin_sym_end] = ACTIONS(1477),
    [anon_sym___END__] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1477),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_unless] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_until] = ACTIONS(1477),
    [anon_sym_rescue] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_elsif] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1477),
    [anon_sym_ensure] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1477),
    [anon_sym_COLON_COLON2] = ACTIONS(1477),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [anon_sym_PLUS_EQ] = ACTIONS(1477),
    [anon_sym_DASH_EQ] = ACTIONS(1477),
    [anon_sym_STAR_EQ] = ACTIONS(1477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1477),
    [anon_sym_SLASH_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_PIPE_EQ] = ACTIONS(1477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1477),
    [anon_sym_AMP_EQ] = ACTIONS(1477),
    [anon_sym_PERCENT_EQ] = ACTIONS(1477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1477),
    [anon_sym_CARET_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1477),
    [anon_sym_and] = ACTIONS(1477),
    [anon_sym_or] = ACTIONS(1477),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1481),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ_GT] = ACTIONS(1477),
    [anon_sym_EQ_TILDE] = ACTIONS(1477),
    [anon_sym_BANG_TILDE] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1477),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(1477),
  },
  [939] = {
    [sym_heredoc_body] = STATE(939),
    [ts_builtin_sym_end] = ACTIONS(1507),
    [anon_sym___END__] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_RPAREN] = ACTIONS(1507),
    [anon_sym_DOT] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(1509),
    [anon_sym_end] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_unless] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_until] = ACTIONS(1507),
    [anon_sym_rescue] = ACTIONS(1507),
    [anon_sym_do] = ACTIONS(1507),
    [anon_sym_when] = ACTIONS(1507),
    [anon_sym_elsif] = ACTIONS(1507),
    [anon_sym_else] = ACTIONS(1507),
    [anon_sym_then] = ACTIONS(1507),
    [anon_sym_ensure] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1507),
    [anon_sym_COLON_COLON2] = ACTIONS(1507),
    [anon_sym_AMP_DOT] = ACTIONS(1507),
    [anon_sym_PLUS_EQ] = ACTIONS(1507),
    [anon_sym_DASH_EQ] = ACTIONS(1507),
    [anon_sym_STAR_EQ] = ACTIONS(1507),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1507),
    [anon_sym_SLASH_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_PIPE_EQ] = ACTIONS(1507),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1507),
    [anon_sym_AMP_EQ] = ACTIONS(1507),
    [anon_sym_PERCENT_EQ] = ACTIONS(1507),
    [anon_sym_GT_GT_EQ] = ACTIONS(1507),
    [anon_sym_LT_LT_EQ] = ACTIONS(1507),
    [anon_sym_CARET_EQ] = ACTIONS(1507),
    [anon_sym_QMARK] = ACTIONS(1507),
    [anon_sym_DOT_DOT] = ACTIONS(1509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1507),
    [anon_sym_and] = ACTIONS(1507),
    [anon_sym_or] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE] = ACTIONS(1509),
    [anon_sym_AMP_AMP] = ACTIONS(1509),
    [anon_sym_LT_LT] = ACTIONS(1509),
    [anon_sym_GT_GT] = ACTIONS(1509),
    [anon_sym_LT_EQ] = ACTIONS(1509),
    [anon_sym_GT] = ACTIONS(1509),
    [anon_sym_GT_EQ] = ACTIONS(1507),
    [anon_sym_CARET] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_EQ] = ACTIONS(1509),
    [anon_sym_BANG_EQ] = ACTIONS(1507),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1507),
    [anon_sym_LT_EQ_GT] = ACTIONS(1507),
    [anon_sym_EQ_TILDE] = ACTIONS(1507),
    [anon_sym_BANG_TILDE] = ACTIONS(1507),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1507),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1507),
    [sym__binary_star] = ACTIONS(1507),
  },
  [940] = {
    [sym_heredoc_body] = STATE(940),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym___END__] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_STAR_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_unless] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_until] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_when] = ACTIONS(1449),
    [anon_sym_elsif] = ACTIONS(1449),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_then] = ACTIONS(1449),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_COLON_COLON2] = ACTIONS(1449),
    [anon_sym_AMP_DOT] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
    [anon_sym_STAR_EQ] = ACTIONS(1449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1449),
    [anon_sym_SLASH_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1449),
    [anon_sym_AMP_EQ] = ACTIONS(1449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1449),
    [anon_sym_CARET_EQ] = ACTIONS(1449),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1449),
    [anon_sym_and] = ACTIONS(1449),
    [anon_sym_or] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_LT_EQ_GT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_BANG_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1449),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1449),
    [sym__binary_star] = ACTIONS(1449),
  },
  [941] = {
    [sym_heredoc_body] = STATE(941),
    [ts_builtin_sym_end] = ACTIONS(1499),
    [anon_sym___END__] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_DOT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_STAR_STAR] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1501),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_unless] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_until] = ACTIONS(1499),
    [anon_sym_rescue] = ACTIONS(1499),
    [anon_sym_do] = ACTIONS(1499),
    [anon_sym_when] = ACTIONS(1499),
    [anon_sym_elsif] = ACTIONS(1499),
    [anon_sym_else] = ACTIONS(1499),
    [anon_sym_then] = ACTIONS(1499),
    [anon_sym_ensure] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_COLON_COLON2] = ACTIONS(1499),
    [anon_sym_AMP_DOT] = ACTIONS(1499),
    [anon_sym_PLUS_EQ] = ACTIONS(1499),
    [anon_sym_DASH_EQ] = ACTIONS(1499),
    [anon_sym_STAR_EQ] = ACTIONS(1499),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1499),
    [anon_sym_SLASH_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_PIPE_EQ] = ACTIONS(1499),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1499),
    [anon_sym_AMP_EQ] = ACTIONS(1499),
    [anon_sym_PERCENT_EQ] = ACTIONS(1499),
    [anon_sym_GT_GT_EQ] = ACTIONS(1499),
    [anon_sym_LT_LT_EQ] = ACTIONS(1499),
    [anon_sym_CARET_EQ] = ACTIONS(1499),
    [anon_sym_QMARK] = ACTIONS(1499),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_and] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(1499),
    [anon_sym_PIPE_PIPE] = ACTIONS(1501),
    [anon_sym_AMP_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1501),
    [anon_sym_GT_GT] = ACTIONS(1501),
    [anon_sym_LT_EQ] = ACTIONS(1501),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_GT_EQ] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1501),
    [anon_sym_EQ_EQ] = ACTIONS(1501),
    [anon_sym_BANG_EQ] = ACTIONS(1499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1499),
    [anon_sym_LT_EQ_GT] = ACTIONS(1499),
    [anon_sym_EQ_TILDE] = ACTIONS(1499),
    [anon_sym_BANG_TILDE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1499),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1499),
    [sym__binary_star] = ACTIONS(1499),
  },
  [942] = {
    [sym_heredoc_body] = STATE(942),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BEGIN] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_END] = ACTIONS(1527),
    [anon_sym_def] = ACTIONS(1527),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_COLON_COLON] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(1527),
    [anon_sym_module] = ACTIONS(1527),
    [anon_sym_end] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_yield] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_next] = ACTIONS(1527),
    [anon_sym_redo] = ACTIONS(1527),
    [anon_sym_retry] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_unless] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_until] = ACTIONS(1527),
    [anon_sym_rescue] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_when] = ACTIONS(1527),
    [anon_sym_elsif] = ACTIONS(1527),
    [anon_sym_else] = ACTIONS(1527),
    [anon_sym_begin] = ACTIONS(1527),
    [anon_sym_ensure] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1527),
    [anon_sym_BANG] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [sym_constant] = ACTIONS(1527),
    [sym_instance_variable] = ACTIONS(1529),
    [sym_class_variable] = ACTIONS(1529),
    [sym_global_variable] = ACTIONS(1529),
    [anon_sym_undef] = ACTIONS(1527),
    [anon_sym_alias] = ACTIONS(1527),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1527),
    [sym_float] = ACTIONS(1527),
    [sym_complex] = ACTIONS(1529),
    [sym_super] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_TRUE] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [anon_sym_FALSE] = ACTIONS(1527),
    [sym_self] = ACTIONS(1527),
    [anon_sym_nil] = ACTIONS(1527),
    [anon_sym_NIL] = ACTIONS(1527),
    [sym_character] = ACTIONS(1529),
    [anon_sym_LBRACK2] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1529),
    [sym__simple_symbol] = ACTIONS(1529),
    [sym__string_start] = ACTIONS(1529),
    [sym__symbol_start] = ACTIONS(1529),
    [sym__subshell_start] = ACTIONS(1529),
    [sym__regex_start] = ACTIONS(1529),
    [sym__string_array_start] = ACTIONS(1529),
    [sym__symbol_array_start] = ACTIONS(1529),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1529),
    [sym__unary_minus] = ACTIONS(1529),
  },
  [943] = {
    [sym_heredoc_body] = STATE(943),
    [ts_builtin_sym_end] = ACTIONS(1469),
    [anon_sym___END__] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_DOT] = ACTIONS(1471),
    [anon_sym_COMMA] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_STAR_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_end] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_unless] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_until] = ACTIONS(1469),
    [anon_sym_rescue] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_when] = ACTIONS(1469),
    [anon_sym_elsif] = ACTIONS(1469),
    [anon_sym_else] = ACTIONS(1469),
    [anon_sym_then] = ACTIONS(1469),
    [anon_sym_ensure] = ACTIONS(1469),
    [anon_sym_LBRACK] = ACTIONS(1469),
    [anon_sym_COLON_COLON2] = ACTIONS(1469),
    [anon_sym_AMP_DOT] = ACTIONS(1469),
    [anon_sym_PLUS_EQ] = ACTIONS(1469),
    [anon_sym_DASH_EQ] = ACTIONS(1469),
    [anon_sym_STAR_EQ] = ACTIONS(1469),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1469),
    [anon_sym_SLASH_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_PIPE_EQ] = ACTIONS(1469),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1469),
    [anon_sym_AMP_EQ] = ACTIONS(1469),
    [anon_sym_PERCENT_EQ] = ACTIONS(1469),
    [anon_sym_GT_GT_EQ] = ACTIONS(1469),
    [anon_sym_LT_LT_EQ] = ACTIONS(1469),
    [anon_sym_CARET_EQ] = ACTIONS(1469),
    [anon_sym_QMARK] = ACTIONS(1469),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1469),
    [anon_sym_and] = ACTIONS(1469),
    [anon_sym_or] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1471),
    [anon_sym_GT_GT] = ACTIONS(1471),
    [anon_sym_LT_EQ] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1471),
    [anon_sym_GT_EQ] = ACTIONS(1469),
    [anon_sym_CARET] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1471),
    [anon_sym_SLASH] = ACTIONS(1471),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_EQ_EQ] = ACTIONS(1471),
    [anon_sym_BANG_EQ] = ACTIONS(1469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1469),
    [anon_sym_LT_EQ_GT] = ACTIONS(1469),
    [anon_sym_EQ_TILDE] = ACTIONS(1469),
    [anon_sym_BANG_TILDE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1469),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1469),
    [sym__binary_star] = ACTIONS(1469),
  },
  [944] = {
    [sym_heredoc_body] = STATE(944),
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym___END__] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_unless] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_until] = ACTIONS(1457),
    [anon_sym_rescue] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_when] = ACTIONS(1457),
    [anon_sym_elsif] = ACTIONS(1457),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_then] = ACTIONS(1457),
    [anon_sym_ensure] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_COLON_COLON2] = ACTIONS(1457),
    [anon_sym_AMP_DOT] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1457),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1457),
    [anon_sym_LT_EQ_GT] = ACTIONS(1457),
    [anon_sym_EQ_TILDE] = ACTIONS(1457),
    [anon_sym_BANG_TILDE] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1457),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1457),
    [sym__binary_star] = ACTIONS(1457),
  },
  [945] = {
    [sym_heredoc_body] = STATE(945),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym___END__] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_DOT] = ACTIONS(1451),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_STAR_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_unless] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_until] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_when] = ACTIONS(1449),
    [anon_sym_elsif] = ACTIONS(1449),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_then] = ACTIONS(1449),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_COLON_COLON2] = ACTIONS(1449),
    [anon_sym_AMP_DOT] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
    [anon_sym_STAR_EQ] = ACTIONS(1449),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1449),
    [anon_sym_SLASH_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_EQ] = ACTIONS(1449),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1449),
    [anon_sym_AMP_EQ] = ACTIONS(1449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1449),
    [anon_sym_CARET_EQ] = ACTIONS(1449),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1449),
    [anon_sym_and] = ACTIONS(1449),
    [anon_sym_or] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1451),
    [anon_sym_SLASH] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1451),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_LT_EQ_GT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_BANG_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1449),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1449),
    [sym__binary_star] = ACTIONS(1449),
  },
  [946] = {
    [sym_heredoc_body] = STATE(946),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_BEGIN] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_END] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(1531),
    [anon_sym_LPAREN] = ACTIONS(1533),
    [anon_sym_RPAREN] = ACTIONS(1533),
    [anon_sym_COLON_COLON] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1531),
    [anon_sym_module] = ACTIONS(1531),
    [anon_sym_end] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_yield] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_next] = ACTIONS(1531),
    [anon_sym_redo] = ACTIONS(1531),
    [anon_sym_retry] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_unless] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_until] = ACTIONS(1531),
    [anon_sym_rescue] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_when] = ACTIONS(1531),
    [anon_sym_elsif] = ACTIONS(1531),
    [anon_sym_else] = ACTIONS(1531),
    [anon_sym_begin] = ACTIONS(1531),
    [anon_sym_ensure] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_defined_QMARK] = ACTIONS(1533),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1533),
    [sym_constant] = ACTIONS(1531),
    [sym_instance_variable] = ACTIONS(1533),
    [sym_class_variable] = ACTIONS(1533),
    [sym_global_variable] = ACTIONS(1533),
    [anon_sym_undef] = ACTIONS(1531),
    [anon_sym_alias] = ACTIONS(1531),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1531),
    [sym_float] = ACTIONS(1531),
    [sym_complex] = ACTIONS(1533),
    [sym_super] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_TRUE] = ACTIONS(1531),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_FALSE] = ACTIONS(1531),
    [sym_self] = ACTIONS(1531),
    [anon_sym_nil] = ACTIONS(1531),
    [anon_sym_NIL] = ACTIONS(1531),
    [sym_character] = ACTIONS(1533),
    [anon_sym_LBRACK2] = ACTIONS(1533),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [sym__simple_symbol] = ACTIONS(1533),
    [sym__string_start] = ACTIONS(1533),
    [sym__symbol_start] = ACTIONS(1533),
    [sym__subshell_start] = ACTIONS(1533),
    [sym__regex_start] = ACTIONS(1533),
    [sym__string_array_start] = ACTIONS(1533),
    [sym__symbol_array_start] = ACTIONS(1533),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1533),
    [sym__unary_minus] = ACTIONS(1533),
  },
  [947] = {
    [sym_heredoc_body] = STATE(947),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_STAR_STAR] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(1511),
    [anon_sym_DOT_DOT] = ACTIONS(1513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1513),
    [anon_sym_LT_LT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_LT_EQ] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_EQ] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1513),
    [anon_sym_PERCENT] = ACTIONS(1513),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1511),
    [anon_sym_LT_EQ_GT] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(1511),
  },
  [948] = {
    [sym_heredoc_body] = STATE(948),
    [ts_builtin_sym_end] = ACTIONS(1503),
    [anon_sym___END__] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_RBRACE] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_DOT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_PIPE] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_STAR_STAR] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1505),
    [anon_sym_EQ] = ACTIONS(1505),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_unless] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_until] = ACTIONS(1503),
    [anon_sym_rescue] = ACTIONS(1503),
    [anon_sym_do] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(1503),
    [anon_sym_elsif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_then] = ACTIONS(1503),
    [anon_sym_ensure] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_COLON_COLON2] = ACTIONS(1503),
    [anon_sym_AMP_DOT] = ACTIONS(1503),
    [anon_sym_PLUS_EQ] = ACTIONS(1503),
    [anon_sym_DASH_EQ] = ACTIONS(1503),
    [anon_sym_STAR_EQ] = ACTIONS(1503),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1503),
    [anon_sym_SLASH_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1503),
    [anon_sym_AMP_EQ] = ACTIONS(1503),
    [anon_sym_PERCENT_EQ] = ACTIONS(1503),
    [anon_sym_GT_GT_EQ] = ACTIONS(1503),
    [anon_sym_LT_LT_EQ] = ACTIONS(1503),
    [anon_sym_CARET_EQ] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_and] = ACTIONS(1503),
    [anon_sym_or] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE] = ACTIONS(1505),
    [anon_sym_AMP_AMP] = ACTIONS(1505),
    [anon_sym_LT_LT] = ACTIONS(1505),
    [anon_sym_GT_GT] = ACTIONS(1505),
    [anon_sym_LT_EQ] = ACTIONS(1505),
    [anon_sym_GT] = ACTIONS(1505),
    [anon_sym_GT_EQ] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(1505),
    [anon_sym_PERCENT] = ACTIONS(1505),
    [anon_sym_EQ_EQ] = ACTIONS(1505),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1503),
    [anon_sym_LT_EQ_GT] = ACTIONS(1503),
    [anon_sym_EQ_TILDE] = ACTIONS(1503),
    [anon_sym_BANG_TILDE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1503),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1503),
    [sym__binary_star] = ACTIONS(1503),
  },
  [949] = {
    [sym_heredoc_body] = STATE(949),
    [ts_builtin_sym_end] = ACTIONS(1519),
    [anon_sym___END__] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1519),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_RPAREN] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1519),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_EQ] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_end] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_unless] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_until] = ACTIONS(1519),
    [anon_sym_rescue] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(1519),
    [anon_sym_elsif] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_then] = ACTIONS(1519),
    [anon_sym_ensure] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1519),
    [anon_sym_COLON_COLON2] = ACTIONS(1519),
    [anon_sym_AMP_DOT] = ACTIONS(1519),
    [anon_sym_PLUS_EQ] = ACTIONS(1519),
    [anon_sym_DASH_EQ] = ACTIONS(1519),
    [anon_sym_STAR_EQ] = ACTIONS(1519),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1519),
    [anon_sym_SLASH_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_PIPE_EQ] = ACTIONS(1519),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1519),
    [anon_sym_AMP_EQ] = ACTIONS(1519),
    [anon_sym_PERCENT_EQ] = ACTIONS(1519),
    [anon_sym_GT_GT_EQ] = ACTIONS(1519),
    [anon_sym_LT_LT_EQ] = ACTIONS(1519),
    [anon_sym_CARET_EQ] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1519),
    [anon_sym_DOT_DOT] = ACTIONS(1521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1519),
    [anon_sym_and] = ACTIONS(1519),
    [anon_sym_or] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1519),
    [anon_sym_LT_EQ_GT] = ACTIONS(1519),
    [anon_sym_EQ_TILDE] = ACTIONS(1519),
    [anon_sym_BANG_TILDE] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1519),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1519),
    [sym__binary_star] = ACTIONS(1519),
  },
  [950] = {
    [sym_heredoc_body] = STATE(950),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym___END__] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1539),
    [anon_sym_DASH_EQ] = ACTIONS(1539),
    [anon_sym_STAR_EQ] = ACTIONS(1539),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1539),
    [anon_sym_PIPE_EQ] = ACTIONS(1539),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1539),
    [anon_sym_AMP_EQ] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1539),
    [anon_sym_GT_GT_EQ] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [951] = {
    [sym_heredoc_body] = STATE(951),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym___END__] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1543),
    [anon_sym_DASH_EQ] = ACTIONS(1543),
    [anon_sym_STAR_EQ] = ACTIONS(1543),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1543),
    [anon_sym_SLASH_EQ] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1543),
    [anon_sym_PIPE_EQ] = ACTIONS(1543),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1543),
    [anon_sym_AMP_EQ] = ACTIONS(1543),
    [anon_sym_PERCENT_EQ] = ACTIONS(1543),
    [anon_sym_GT_GT_EQ] = ACTIONS(1543),
    [anon_sym_LT_LT_EQ] = ACTIONS(1543),
    [anon_sym_CARET_EQ] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [952] = {
    [sym_heredoc_body] = STATE(952),
    [sym_identifier] = ACTIONS(1545),
    [anon_sym_BEGIN] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_END] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_COLON_COLON] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1545),
    [anon_sym_end] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_yield] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_next] = ACTIONS(1545),
    [anon_sym_redo] = ACTIONS(1545),
    [anon_sym_retry] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_unless] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_until] = ACTIONS(1545),
    [anon_sym_rescue] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_begin] = ACTIONS(1545),
    [anon_sym_ensure] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_defined_QMARK] = ACTIONS(1547),
    [anon_sym_not] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1547),
    [sym_constant] = ACTIONS(1545),
    [sym_instance_variable] = ACTIONS(1547),
    [sym_class_variable] = ACTIONS(1547),
    [sym_global_variable] = ACTIONS(1547),
    [anon_sym_undef] = ACTIONS(1545),
    [anon_sym_alias] = ACTIONS(1545),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1545),
    [sym_float] = ACTIONS(1545),
    [sym_complex] = ACTIONS(1547),
    [sym_super] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(1545),
    [anon_sym_false] = ACTIONS(1545),
    [anon_sym_FALSE] = ACTIONS(1545),
    [sym_self] = ACTIONS(1545),
    [anon_sym_nil] = ACTIONS(1545),
    [anon_sym_NIL] = ACTIONS(1545),
    [sym_character] = ACTIONS(1547),
    [anon_sym_LBRACK2] = ACTIONS(1547),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [sym__line_break] = ACTIONS(1547),
    [sym__simple_symbol] = ACTIONS(1547),
    [sym__string_start] = ACTIONS(1547),
    [sym__symbol_start] = ACTIONS(1547),
    [sym__subshell_start] = ACTIONS(1547),
    [sym__regex_start] = ACTIONS(1547),
    [sym__string_array_start] = ACTIONS(1547),
    [sym__symbol_array_start] = ACTIONS(1547),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1547),
    [sym__unary_minus] = ACTIONS(1547),
  },
  [953] = {
    [sym_heredoc_body] = STATE(953),
    [sym_identifier] = ACTIONS(1549),
    [anon_sym_BEGIN] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_END] = ACTIONS(1549),
    [anon_sym_def] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_COLON_COLON] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_class] = ACTIONS(1549),
    [anon_sym_module] = ACTIONS(1549),
    [anon_sym_end] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_next] = ACTIONS(1549),
    [anon_sym_redo] = ACTIONS(1549),
    [anon_sym_retry] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_unless] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_rescue] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_begin] = ACTIONS(1549),
    [anon_sym_ensure] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_defined_QMARK] = ACTIONS(1551),
    [anon_sym_not] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_constant] = ACTIONS(1549),
    [sym_instance_variable] = ACTIONS(1551),
    [sym_class_variable] = ACTIONS(1551),
    [sym_global_variable] = ACTIONS(1551),
    [anon_sym_undef] = ACTIONS(1549),
    [anon_sym_alias] = ACTIONS(1549),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1549),
    [sym_float] = ACTIONS(1549),
    [sym_complex] = ACTIONS(1551),
    [sym_super] = ACTIONS(1549),
    [anon_sym_true] = ACTIONS(1549),
    [anon_sym_TRUE] = ACTIONS(1549),
    [anon_sym_false] = ACTIONS(1549),
    [anon_sym_FALSE] = ACTIONS(1549),
    [sym_self] = ACTIONS(1549),
    [anon_sym_nil] = ACTIONS(1549),
    [anon_sym_NIL] = ACTIONS(1549),
    [sym_character] = ACTIONS(1551),
    [anon_sym_LBRACK2] = ACTIONS(1551),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [sym__line_break] = ACTIONS(1551),
    [sym__simple_symbol] = ACTIONS(1551),
    [sym__string_start] = ACTIONS(1551),
    [sym__symbol_start] = ACTIONS(1551),
    [sym__subshell_start] = ACTIONS(1551),
    [sym__regex_start] = ACTIONS(1551),
    [sym__string_array_start] = ACTIONS(1551),
    [sym__symbol_array_start] = ACTIONS(1551),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1551),
    [sym__unary_minus] = ACTIONS(1551),
  },
  [954] = {
    [sym_heredoc_body] = STATE(954),
    [sym_identifier] = ACTIONS(1553),
    [anon_sym_BEGIN] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_END] = ACTIONS(1553),
    [anon_sym_def] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_COLON_COLON] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_class] = ACTIONS(1553),
    [anon_sym_module] = ACTIONS(1553),
    [anon_sym_end] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1553),
    [anon_sym_redo] = ACTIONS(1553),
    [anon_sym_retry] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_unless] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_until] = ACTIONS(1553),
    [anon_sym_rescue] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(1553),
    [anon_sym_ensure] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1555),
    [anon_sym_not] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_TILDE] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1553),
    [sym_instance_variable] = ACTIONS(1555),
    [sym_class_variable] = ACTIONS(1555),
    [sym_global_variable] = ACTIONS(1555),
    [anon_sym_undef] = ACTIONS(1553),
    [anon_sym_alias] = ACTIONS(1553),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1553),
    [sym_float] = ACTIONS(1553),
    [sym_complex] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(1553),
    [anon_sym_TRUE] = ACTIONS(1553),
    [anon_sym_false] = ACTIONS(1553),
    [anon_sym_FALSE] = ACTIONS(1553),
    [sym_self] = ACTIONS(1553),
    [anon_sym_nil] = ACTIONS(1553),
    [anon_sym_NIL] = ACTIONS(1553),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACK2] = ACTIONS(1555),
    [anon_sym_DASH_GT] = ACTIONS(1555),
    [sym__line_break] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1555),
    [sym__string_start] = ACTIONS(1555),
    [sym__symbol_start] = ACTIONS(1555),
    [sym__subshell_start] = ACTIONS(1555),
    [sym__regex_start] = ACTIONS(1555),
    [sym__string_array_start] = ACTIONS(1555),
    [sym__symbol_array_start] = ACTIONS(1555),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [sym__unary_minus] = ACTIONS(1555),
  },
  [955] = {
    [sym_heredoc_body] = STATE(955),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_BEGIN] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_END] = ACTIONS(1557),
    [anon_sym_def] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1559),
    [anon_sym_COLON_COLON] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_class] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_end] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_next] = ACTIONS(1557),
    [anon_sym_redo] = ACTIONS(1557),
    [anon_sym_retry] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_until] = ACTIONS(1557),
    [anon_sym_rescue] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_begin] = ACTIONS(1557),
    [anon_sym_ensure] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym_constant] = ACTIONS(1557),
    [sym_instance_variable] = ACTIONS(1559),
    [sym_class_variable] = ACTIONS(1559),
    [sym_global_variable] = ACTIONS(1559),
    [anon_sym_undef] = ACTIONS(1557),
    [anon_sym_alias] = ACTIONS(1557),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1557),
    [sym_float] = ACTIONS(1557),
    [sym_complex] = ACTIONS(1559),
    [sym_super] = ACTIONS(1557),
    [anon_sym_true] = ACTIONS(1557),
    [anon_sym_TRUE] = ACTIONS(1557),
    [anon_sym_false] = ACTIONS(1557),
    [anon_sym_FALSE] = ACTIONS(1557),
    [sym_self] = ACTIONS(1557),
    [anon_sym_nil] = ACTIONS(1557),
    [anon_sym_NIL] = ACTIONS(1557),
    [sym_character] = ACTIONS(1559),
    [anon_sym_LBRACK2] = ACTIONS(1559),
    [anon_sym_DASH_GT] = ACTIONS(1559),
    [sym__line_break] = ACTIONS(1559),
    [sym__simple_symbol] = ACTIONS(1559),
    [sym__string_start] = ACTIONS(1559),
    [sym__symbol_start] = ACTIONS(1559),
    [sym__subshell_start] = ACTIONS(1559),
    [sym__regex_start] = ACTIONS(1559),
    [sym__string_array_start] = ACTIONS(1559),
    [sym__symbol_array_start] = ACTIONS(1559),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1559),
    [sym__unary_minus] = ACTIONS(1559),
  },
  [956] = {
    [sym_heredoc_body] = STATE(956),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_BEGIN] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_END] = ACTIONS(1561),
    [anon_sym_def] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1563),
    [anon_sym_COLON_COLON] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_end] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_next] = ACTIONS(1561),
    [anon_sym_redo] = ACTIONS(1561),
    [anon_sym_retry] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_unless] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_until] = ACTIONS(1561),
    [anon_sym_rescue] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_begin] = ACTIONS(1561),
    [anon_sym_ensure] = ACTIONS(1561),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1561),
    [sym_instance_variable] = ACTIONS(1563),
    [sym_class_variable] = ACTIONS(1563),
    [sym_global_variable] = ACTIONS(1563),
    [anon_sym_undef] = ACTIONS(1561),
    [anon_sym_alias] = ACTIONS(1561),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1561),
    [sym_float] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1563),
    [sym_super] = ACTIONS(1561),
    [anon_sym_true] = ACTIONS(1561),
    [anon_sym_TRUE] = ACTIONS(1561),
    [anon_sym_false] = ACTIONS(1561),
    [anon_sym_FALSE] = ACTIONS(1561),
    [sym_self] = ACTIONS(1561),
    [anon_sym_nil] = ACTIONS(1561),
    [anon_sym_NIL] = ACTIONS(1561),
    [sym_character] = ACTIONS(1563),
    [anon_sym_LBRACK2] = ACTIONS(1563),
    [anon_sym_DASH_GT] = ACTIONS(1563),
    [sym__line_break] = ACTIONS(1563),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym__string_start] = ACTIONS(1563),
    [sym__symbol_start] = ACTIONS(1563),
    [sym__subshell_start] = ACTIONS(1563),
    [sym__regex_start] = ACTIONS(1563),
    [sym__string_array_start] = ACTIONS(1563),
    [sym__symbol_array_start] = ACTIONS(1563),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1563),
    [sym__unary_minus] = ACTIONS(1563),
  },
  [957] = {
    [sym_heredoc_body] = STATE(957),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_BEGIN] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_END] = ACTIONS(1565),
    [anon_sym_def] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_COLON_COLON] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_class] = ACTIONS(1565),
    [anon_sym_module] = ACTIONS(1565),
    [anon_sym_end] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_yield] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_next] = ACTIONS(1565),
    [anon_sym_redo] = ACTIONS(1565),
    [anon_sym_retry] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_unless] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_until] = ACTIONS(1565),
    [anon_sym_rescue] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_begin] = ACTIONS(1565),
    [anon_sym_ensure] = ACTIONS(1565),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_defined_QMARK] = ACTIONS(1567),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1567),
    [sym_class_variable] = ACTIONS(1567),
    [sym_global_variable] = ACTIONS(1567),
    [anon_sym_undef] = ACTIONS(1565),
    [anon_sym_alias] = ACTIONS(1565),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1565),
    [sym_float] = ACTIONS(1565),
    [sym_complex] = ACTIONS(1567),
    [sym_super] = ACTIONS(1565),
    [anon_sym_true] = ACTIONS(1565),
    [anon_sym_TRUE] = ACTIONS(1565),
    [anon_sym_false] = ACTIONS(1565),
    [anon_sym_FALSE] = ACTIONS(1565),
    [sym_self] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(1565),
    [anon_sym_NIL] = ACTIONS(1565),
    [sym_character] = ACTIONS(1567),
    [anon_sym_LBRACK2] = ACTIONS(1567),
    [anon_sym_DASH_GT] = ACTIONS(1567),
    [sym__line_break] = ACTIONS(1567),
    [sym__simple_symbol] = ACTIONS(1567),
    [sym__string_start] = ACTIONS(1567),
    [sym__symbol_start] = ACTIONS(1567),
    [sym__subshell_start] = ACTIONS(1567),
    [sym__regex_start] = ACTIONS(1567),
    [sym__string_array_start] = ACTIONS(1567),
    [sym__symbol_array_start] = ACTIONS(1567),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1567),
    [sym__unary_minus] = ACTIONS(1567),
  },
  [958] = {
    [sym_heredoc_body] = STATE(958),
    [sym_identifier] = ACTIONS(1437),
    [anon_sym_BEGIN] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_END] = ACTIONS(1437),
    [anon_sym_def] = ACTIONS(1437),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_COLON_COLON] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_class] = ACTIONS(1437),
    [anon_sym_module] = ACTIONS(1437),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_yield] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_next] = ACTIONS(1437),
    [anon_sym_redo] = ACTIONS(1437),
    [anon_sym_retry] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_unless] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_until] = ACTIONS(1437),
    [anon_sym_rescue] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_begin] = ACTIONS(1437),
    [anon_sym_ensure] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_defined_QMARK] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(1437),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1439),
    [sym_constant] = ACTIONS(1437),
    [sym_instance_variable] = ACTIONS(1439),
    [sym_class_variable] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1439),
    [anon_sym_undef] = ACTIONS(1437),
    [anon_sym_alias] = ACTIONS(1437),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1437),
    [sym_float] = ACTIONS(1437),
    [sym_complex] = ACTIONS(1439),
    [sym_super] = ACTIONS(1437),
    [anon_sym_true] = ACTIONS(1437),
    [anon_sym_TRUE] = ACTIONS(1437),
    [anon_sym_false] = ACTIONS(1437),
    [anon_sym_FALSE] = ACTIONS(1437),
    [sym_self] = ACTIONS(1437),
    [anon_sym_nil] = ACTIONS(1437),
    [anon_sym_NIL] = ACTIONS(1437),
    [sym_character] = ACTIONS(1439),
    [anon_sym_LBRACK2] = ACTIONS(1439),
    [anon_sym_DASH_GT] = ACTIONS(1439),
    [sym__simple_symbol] = ACTIONS(1439),
    [sym__string_start] = ACTIONS(1439),
    [sym__symbol_start] = ACTIONS(1439),
    [sym__subshell_start] = ACTIONS(1439),
    [sym__regex_start] = ACTIONS(1439),
    [sym__string_array_start] = ACTIONS(1439),
    [sym__symbol_array_start] = ACTIONS(1439),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1439),
    [sym__unary_minus] = ACTIONS(1439),
  },
  [959] = {
    [sym_heredoc_body] = STATE(959),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1571),
    [anon_sym_DASH_EQ] = ACTIONS(1571),
    [anon_sym_STAR_EQ] = ACTIONS(1571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1571),
    [anon_sym_SLASH_EQ] = ACTIONS(1571),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1571),
    [anon_sym_PIPE_EQ] = ACTIONS(1571),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1571),
    [anon_sym_AMP_EQ] = ACTIONS(1571),
    [anon_sym_PERCENT_EQ] = ACTIONS(1571),
    [anon_sym_GT_GT_EQ] = ACTIONS(1571),
    [anon_sym_LT_LT_EQ] = ACTIONS(1571),
    [anon_sym_CARET_EQ] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [960] = {
    [sym_heredoc_body] = STATE(960),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_BEGIN] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_END] = ACTIONS(1573),
    [anon_sym_def] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_class] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_end] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_next] = ACTIONS(1573),
    [anon_sym_redo] = ACTIONS(1573),
    [anon_sym_retry] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_unless] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_until] = ACTIONS(1573),
    [anon_sym_rescue] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(1573),
    [anon_sym_ensure] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1575),
    [sym_constant] = ACTIONS(1573),
    [sym_instance_variable] = ACTIONS(1575),
    [sym_class_variable] = ACTIONS(1575),
    [sym_global_variable] = ACTIONS(1575),
    [anon_sym_undef] = ACTIONS(1573),
    [anon_sym_alias] = ACTIONS(1573),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [sym_complex] = ACTIONS(1575),
    [sym_super] = ACTIONS(1573),
    [anon_sym_true] = ACTIONS(1573),
    [anon_sym_TRUE] = ACTIONS(1573),
    [anon_sym_false] = ACTIONS(1573),
    [anon_sym_FALSE] = ACTIONS(1573),
    [sym_self] = ACTIONS(1573),
    [anon_sym_nil] = ACTIONS(1573),
    [anon_sym_NIL] = ACTIONS(1573),
    [sym_character] = ACTIONS(1575),
    [anon_sym_LBRACK2] = ACTIONS(1575),
    [anon_sym_DASH_GT] = ACTIONS(1575),
    [sym__line_break] = ACTIONS(1575),
    [sym__simple_symbol] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1575),
    [sym__symbol_start] = ACTIONS(1575),
    [sym__subshell_start] = ACTIONS(1575),
    [sym__regex_start] = ACTIONS(1575),
    [sym__string_array_start] = ACTIONS(1575),
    [sym__symbol_array_start] = ACTIONS(1575),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1575),
    [sym__unary_minus] = ACTIONS(1575),
  },
  [961] = {
    [sym_heredoc_body] = STATE(961),
    [aux_sym__mlhs_repeat1] = STATE(2527),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_end] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_unless] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_until] = ACTIONS(1441),
    [anon_sym_rescue] = ACTIONS(1441),
    [anon_sym_when] = ACTIONS(1441),
    [anon_sym_elsif] = ACTIONS(1441),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_then] = ACTIONS(1441),
    [anon_sym_ensure] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_COLON_COLON2] = ACTIONS(1441),
    [anon_sym_AMP_DOT] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1579),
    [anon_sym_DASH_EQ] = ACTIONS(1579),
    [anon_sym_STAR_EQ] = ACTIONS(1579),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1579),
    [anon_sym_SLASH_EQ] = ACTIONS(1579),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1579),
    [anon_sym_PIPE_EQ] = ACTIONS(1579),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1579),
    [anon_sym_AMP_EQ] = ACTIONS(1579),
    [anon_sym_PERCENT_EQ] = ACTIONS(1579),
    [anon_sym_GT_GT_EQ] = ACTIONS(1579),
    [anon_sym_LT_LT_EQ] = ACTIONS(1579),
    [anon_sym_CARET_EQ] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1443),
    [anon_sym_AMP_AMP] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1443),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1441),
    [anon_sym_LT_EQ_GT] = ACTIONS(1441),
    [anon_sym_EQ_TILDE] = ACTIONS(1441),
    [anon_sym_BANG_TILDE] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(1441),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(1441),
    [sym__binary_star] = ACTIONS(1441),
  },
  [962] = {
    [sym_heredoc_body] = STATE(962),
    [sym_identifier] = ACTIONS(1581),
    [anon_sym_BEGIN] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1583),
    [anon_sym_END] = ACTIONS(1581),
    [anon_sym_def] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_COLON_COLON] = ACTIONS(1583),
    [anon_sym_SEMI] = ACTIONS(1583),
    [anon_sym_STAR] = ACTIONS(1583),
    [anon_sym_class] = ACTIONS(1581),
    [anon_sym_module] = ACTIONS(1581),
    [anon_sym_end] = ACTIONS(1581),
    [anon_sym_return] = ACTIONS(1581),
    [anon_sym_yield] = ACTIONS(1581),
    [anon_sym_break] = ACTIONS(1581),
    [anon_sym_next] = ACTIONS(1581),
    [anon_sym_redo] = ACTIONS(1581),
    [anon_sym_retry] = ACTIONS(1581),
    [anon_sym_if] = ACTIONS(1581),
    [anon_sym_unless] = ACTIONS(1581),
    [anon_sym_while] = ACTIONS(1581),
    [anon_sym_until] = ACTIONS(1581),
    [anon_sym_rescue] = ACTIONS(1581),
    [anon_sym_for] = ACTIONS(1581),
    [anon_sym_case] = ACTIONS(1581),
    [anon_sym_else] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(1581),
    [anon_sym_ensure] = ACTIONS(1581),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1581),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_constant] = ACTIONS(1581),
    [sym_instance_variable] = ACTIONS(1583),
    [sym_class_variable] = ACTIONS(1583),
    [sym_global_variable] = ACTIONS(1583),
    [anon_sym_undef] = ACTIONS(1581),
    [anon_sym_alias] = ACTIONS(1581),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1581),
    [sym_float] = ACTIONS(1581),
    [sym_complex] = ACTIONS(1583),
    [sym_super] = ACTIONS(1581),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_TRUE] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [anon_sym_FALSE] = ACTIONS(1581),
    [sym_self] = ACTIONS(1581),
    [anon_sym_nil] = ACTIONS(1581),
    [anon_sym_NIL] = ACTIONS(1581),
    [sym_character] = ACTIONS(1583),
    [anon_sym_LBRACK2] = ACTIONS(1583),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym__line_break] = ACTIONS(1583),
    [sym__simple_symbol] = ACTIONS(1583),
    [sym__string_start] = ACTIONS(1583),
    [sym__symbol_start] = ACTIONS(1583),
    [sym__subshell_start] = ACTIONS(1583),
    [sym__regex_start] = ACTIONS(1583),
    [sym__string_array_start] = ACTIONS(1583),
    [sym__symbol_array_start] = ACTIONS(1583),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1583),
    [sym__unary_minus] = ACTIONS(1583),
  },
  [963] = {
    [sym_heredoc_body] = STATE(963),
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_BEGIN] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_END] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_COLON_COLON] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(1587),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_end] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_next] = ACTIONS(1585),
    [anon_sym_redo] = ACTIONS(1585),
    [anon_sym_retry] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_unless] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_until] = ACTIONS(1585),
    [anon_sym_rescue] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_begin] = ACTIONS(1585),
    [anon_sym_ensure] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_defined_QMARK] = ACTIONS(1587),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(1585),
    [sym_instance_variable] = ACTIONS(1587),
    [sym_class_variable] = ACTIONS(1587),
    [sym_global_variable] = ACTIONS(1587),
    [anon_sym_undef] = ACTIONS(1585),
    [anon_sym_alias] = ACTIONS(1585),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1585),
    [sym_float] = ACTIONS(1585),
    [sym_complex] = ACTIONS(1587),
    [sym_super] = ACTIONS(1585),
    [anon_sym_true] = ACTIONS(1585),
    [anon_sym_TRUE] = ACTIONS(1585),
    [anon_sym_false] = ACTIONS(1585),
    [anon_sym_FALSE] = ACTIONS(1585),
    [sym_self] = ACTIONS(1585),
    [anon_sym_nil] = ACTIONS(1585),
    [anon_sym_NIL] = ACTIONS(1585),
    [sym_character] = ACTIONS(1587),
    [anon_sym_LBRACK2] = ACTIONS(1587),
    [anon_sym_DASH_GT] = ACTIONS(1587),
    [sym__line_break] = ACTIONS(1587),
    [sym__simple_symbol] = ACTIONS(1587),
    [sym__string_start] = ACTIONS(1587),
    [sym__symbol_start] = ACTIONS(1587),
    [sym__subshell_start] = ACTIONS(1587),
    [sym__regex_start] = ACTIONS(1587),
    [sym__string_array_start] = ACTIONS(1587),
    [sym__symbol_array_start] = ACTIONS(1587),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1587),
    [sym__unary_minus] = ACTIONS(1587),
  },
  [964] = {
    [sym_heredoc_body] = STATE(964),
    [sym_identifier] = ACTIONS(1589),
    [anon_sym_BEGIN] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1591),
    [anon_sym_END] = ACTIONS(1589),
    [anon_sym_def] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_COLON_COLON] = ACTIONS(1591),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_class] = ACTIONS(1589),
    [anon_sym_module] = ACTIONS(1589),
    [anon_sym_end] = ACTIONS(1589),
    [anon_sym_return] = ACTIONS(1589),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_break] = ACTIONS(1589),
    [anon_sym_next] = ACTIONS(1589),
    [anon_sym_redo] = ACTIONS(1589),
    [anon_sym_retry] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1589),
    [anon_sym_unless] = ACTIONS(1589),
    [anon_sym_while] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1589),
    [anon_sym_rescue] = ACTIONS(1589),
    [anon_sym_for] = ACTIONS(1589),
    [anon_sym_case] = ACTIONS(1589),
    [anon_sym_else] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(1589),
    [anon_sym_ensure] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1589),
    [anon_sym_defined_QMARK] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_TILDE] = ACTIONS(1591),
    [sym_constant] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(1591),
    [sym_class_variable] = ACTIONS(1591),
    [sym_global_variable] = ACTIONS(1591),
    [anon_sym_undef] = ACTIONS(1589),
    [anon_sym_alias] = ACTIONS(1589),
    [sym_comment] = ACTIONS(73),
    [sym_integer] = ACTIONS(1589),
    [sym_float] = ACTIONS(1589),
    [sym_complex] = ACTIONS(1591),
    [sym_super] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(1589),
    [anon_sym_TRUE] = ACTIONS(1589),
    [anon_sym_false] = ACTIONS(1589),
    [anon_sym_FALSE] = ACTIONS(1589),
    [sym_self] = ACTIONS(1589),
    [anon_sym_nil] = ACTIONS(1589),
    [anon_sym_NIL] = ACTIONS(1589),
    [sym_character] = ACTIONS(1591),
    [anon_sym_LBRACK2] = ACTIONS(1591),
    [anon_sym_DASH_GT] = ACTIONS(1591),
    [sym__line_break] = ACTIONS(1591),
    [sym__simple_symbol] = ACTIONS(1591),
    [sym__string_start] = ACTIONS(1591),
    [sym__symbol_start] = ACTIONS(1591),
    [sym__subshell_start] = ACTIONS(1591),
    [sym__regex_start] = ACTIONS(1591),
    [sym__string_array_start] = ACTIONS(1591),
    [sym__symbol_array_start] = ACTIONS(1591),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1591),
    [sym__unary_minus] = ACTIONS(1591),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(965), 1,
      sym_heredoc_body,
    ACTIONS(1533), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1531), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [74] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(966), 1,
      sym_heredoc_body,
    ACTIONS(470), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(496), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [148] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(967), 1,
      sym_heredoc_body,
    ACTIONS(1439), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1437), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [222] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(968), 1,
      sym_heredoc_body,
    ACTIONS(1529), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1527), 35,
      anon_sym___END__,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [296] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(969), 1,
      sym_heredoc_body,
    ACTIONS(1555), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1553), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [369] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(970), 1,
      sym_heredoc_body,
    ACTIONS(1595), 24,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1593), 35,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_end,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [442] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_LPAREN2,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    ACTIONS(1599), 1,
      anon_sym_do,
    STATE(971), 1,
      sym_heredoc_body,
    STATE(990), 1,
      sym_argument_list,
    STATE(1019), 1,
      sym_do_block,
    STATE(1021), 1,
      sym_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [525] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(972), 1,
      sym_heredoc_body,
    ACTIONS(1575), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1573), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [598] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(973), 1,
      sym_heredoc_body,
    ACTIONS(1551), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1549), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [671] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(974), 1,
      sym_heredoc_body,
    ACTIONS(1591), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1589), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [744] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(975), 1,
      sym_heredoc_body,
    ACTIONS(1583), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1581), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [817] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(976), 1,
      sym_heredoc_body,
    ACTIONS(1567), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1565), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [890] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(977), 1,
      sym_heredoc_body,
    ACTIONS(1587), 25,
      sym__simple_symbol,
      sym__string_start,
      sym__symbol_start,
      sym__subshell_start,
      sym__regex_start,
      sym__string_array_start,
      sym__symbol_array_start,
      sym_heredoc_beginning,
      sym__unary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_defined_QMARK,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      sym_complex,
      sym_character,
      anon_sym_LBRACK2,
      anon_sym_DASH_GT,
    ACTIONS(1585), 34,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_def,
      anon_sym_class,
      anon_sym_module,
      anon_sym_return,
      anon_sym_yield,
      anon_sym_break,
      anon_sym_next,
      anon_sym_redo,
      anon_sym_retry,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_for,
      anon_sym_case,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_not,
      sym_constant,
      sym_identifier,
      anon_sym_undef,
      anon_sym_alias,
      sym_integer,
      sym_float,
      sym_super,
      anon_sym_true,
      anon_sym_TRUE,
      anon_sym_false,
      anon_sym_FALSE,
      sym_self,
      anon_sym_nil,
      anon_sym_NIL,
  [963] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_LPAREN2,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    STATE(978), 1,
      sym_heredoc_body,
    STATE(988), 1,
      sym_argument_list,
    STATE(1019), 1,
      sym_do_block,
    STATE(1021), 1,
      sym_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1044] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LPAREN2,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1603), 1,
      anon_sym_do,
    STATE(979), 1,
      sym_heredoc_body,
    STATE(1003), 1,
      sym_argument_list,
    STATE(1050), 1,
      sym_block,
    STATE(1075), 1,
      sym_do_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1126] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    ACTIONS(1607), 1,
      anon_sym_do,
    ACTIONS(1609), 1,
      anon_sym_LPAREN2,
    STATE(980), 1,
      sym_heredoc_body,
    STATE(1004), 1,
      sym_argument_list,
    STATE(1091), 1,
      sym_block,
    STATE(1093), 1,
      sym_do_block,
    ACTIONS(115), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 33,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LPAREN2,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    STATE(981), 1,
      sym_heredoc_body,
    STATE(993), 1,
      sym_argument_list,
    STATE(1050), 1,
      sym_block,
    STATE(1075), 1,
      sym_do_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1290] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 1,
      anon_sym_EQ,
    STATE(982), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1613), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1369] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(1615), 1,
      anon_sym_EQ,
    STATE(983), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1617), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1448] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    ACTIONS(1619), 1,
      anon_sym_COLON,
    STATE(984), 1,
      sym_heredoc_body,
    STATE(994), 1,
      aux_sym_chained_string_repeat1,
    STATE(1083), 1,
      sym_string,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1527] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1621), 1,
      anon_sym_EQ,
    STATE(985), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1623), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(1625), 1,
      anon_sym_EQ,
    STATE(986), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1627), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_COLON,
    STATE(987), 1,
      sym_heredoc_body,
    ACTIONS(907), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(909), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1754] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    STATE(988), 1,
      sym_heredoc_body,
    STATE(1035), 1,
      sym_block,
    STATE(1040), 1,
      sym_do_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(989), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1631), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_LBRACE,
    ACTIONS(1599), 1,
      anon_sym_do,
    STATE(990), 1,
      sym_heredoc_body,
    STATE(1035), 1,
      sym_block,
    STATE(1040), 1,
      sym_do_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_COLON,
    STATE(991), 1,
      sym_heredoc_body,
    ACTIONS(907), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(909), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2054] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    STATE(992), 1,
      sym_heredoc_body,
    STATE(994), 1,
      aux_sym_chained_string_repeat1,
    STATE(1083), 1,
      sym_string,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2130] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    STATE(993), 1,
      sym_heredoc_body,
    STATE(1079), 1,
      sym_block,
    STATE(1082), 1,
      sym_do_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2204] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    STATE(994), 1,
      sym_heredoc_body,
    STATE(995), 1,
      aux_sym_chained_string_repeat1,
    STATE(1083), 1,
      sym_string,
    ACTIONS(1635), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2280] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1641), 1,
      sym__string_start,
    STATE(1083), 1,
      sym_string,
    STATE(995), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1639), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1637), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2354] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 1,
      anon_sym_EQ,
    STATE(996), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1646), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(997), 1,
      sym_heredoc_body,
    ACTIONS(1007), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1009), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2496] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1648), 1,
      anon_sym_LBRACE,
    ACTIONS(1650), 1,
      anon_sym_do,
    ACTIONS(1652), 1,
      anon_sym_LPAREN2,
    STATE(998), 1,
      sym_heredoc_body,
    STATE(1084), 1,
      sym_argument_list,
    STATE(1219), 1,
      sym_do_block,
    STATE(1223), 1,
      sym_block,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(999), 1,
      sym_heredoc_body,
    ACTIONS(1023), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1025), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1000), 1,
      sym_heredoc_body,
    ACTIONS(1019), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1001), 1,
      sym_heredoc_body,
    ACTIONS(1011), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1013), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1002), 1,
      sym_heredoc_body,
    ACTIONS(997), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(999), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1603), 1,
      anon_sym_do,
    STATE(1003), 1,
      sym_heredoc_body,
    STATE(1079), 1,
      sym_block,
    STATE(1082), 1,
      sym_do_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    ACTIONS(1607), 1,
      anon_sym_do,
    STATE(1004), 1,
      sym_heredoc_body,
    STATE(1069), 1,
      sym_block,
    STATE(1072), 1,
      sym_do_block,
    ACTIONS(1435), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 33,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1005), 1,
      sym_heredoc_body,
    ACTIONS(1003), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 39,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1006), 1,
      sym_heredoc_body,
    ACTIONS(1521), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1007), 1,
      sym_heredoc_body,
    ACTIONS(1011), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1013), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1008), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3275] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1009), 1,
      sym_heredoc_body,
    STATE(1148), 1,
      sym_argument_list,
    ACTIONS(1656), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1654), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1010), 1,
      sym_heredoc_body,
    ACTIONS(1517), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1011), 1,
      sym_heredoc_body,
    ACTIONS(1003), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1012), 1,
      sym_heredoc_body,
    ACTIONS(1513), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1013), 1,
      sym_heredoc_body,
    ACTIONS(1509), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1014), 1,
      sym_heredoc_body,
    ACTIONS(1505), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3685] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1015), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 46,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3754] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1016), 1,
      sym_heredoc_body,
    STATE(1146), 1,
      sym_argument_list,
    ACTIONS(275), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(273), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1017), 1,
      sym_heredoc_body,
    ACTIONS(1007), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1009), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1018), 1,
      sym_heredoc_body,
    ACTIONS(997), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(999), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1019), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1020), 1,
      sym_heredoc_body,
    ACTIONS(1479), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_EQ_GT,
    ACTIONS(1481), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1021), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1022), 1,
      sym_heredoc_body,
    ACTIONS(1497), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1023), 1,
      sym_heredoc_body,
    ACTIONS(1011), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1013), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4302] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    STATE(1024), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1664), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1025), 1,
      sym_heredoc_body,
    ACTIONS(1003), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1026), 1,
      sym_heredoc_body,
    ACTIONS(1493), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1027), 1,
      sym_heredoc_body,
    ACTIONS(1481), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1028), 1,
      sym_heredoc_body,
    ACTIONS(1481), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1029), 1,
      sym_heredoc_body,
    ACTIONS(1007), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1009), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4710] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1030), 1,
      sym_heredoc_body,
    STATE(1188), 1,
      sym_argument_list,
    ACTIONS(305), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(303), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1031), 1,
      sym_heredoc_body,
    ACTIONS(1023), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1025), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1032), 1,
      sym_heredoc_body,
    ACTIONS(1475), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1033), 1,
      sym_heredoc_body,
    ACTIONS(1019), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4984] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1034), 1,
      sym_heredoc_body,
    STATE(1151), 1,
      sym_argument_list,
    ACTIONS(1668), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1666), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1035), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5124] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    ACTIONS(1670), 1,
      anon_sym_COLON,
    STATE(994), 1,
      aux_sym_chained_string_repeat1,
    STATE(1036), 1,
      sym_heredoc_body,
    STATE(1083), 1,
      sym_string,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1037), 1,
      sym_heredoc_body,
    ACTIONS(1455), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1038), 1,
      sym_heredoc_body,
    ACTIONS(1019), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5337] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1039), 1,
      sym_heredoc_body,
    STATE(1185), 1,
      sym_argument_list,
    ACTIONS(301), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(299), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1040), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1041), 1,
      sym_heredoc_body,
    ACTIONS(1023), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1025), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1042), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1043), 1,
      sym_heredoc_body,
    ACTIONS(997), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(999), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5680] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(277), 1,
      anon_sym_LPAREN2,
    STATE(1044), 1,
      sym_heredoc_body,
    STATE(1167), 1,
      sym_argument_list,
    ACTIONS(297), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(295), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1045), 1,
      sym_heredoc_body,
    ACTIONS(907), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(909), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1046), 1,
      sym_heredoc_body,
    ACTIONS(1479), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(1481), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 36,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5891] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1047), 1,
      sym_heredoc_body,
    ACTIONS(1674), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 46,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1048), 1,
      sym_heredoc_body,
    ACTIONS(1485), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1483), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1049), 1,
      sym_heredoc_body,
    ACTIONS(1471), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 38,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1050), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1051), 1,
      sym_heredoc_body,
    ACTIONS(1505), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1052), 1,
      sym_heredoc_body,
    ACTIONS(1497), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1053), 1,
      sym_heredoc_body,
    ACTIONS(1481), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1054), 1,
      sym_heredoc_body,
    ACTIONS(1475), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1055), 1,
      sym_heredoc_body,
    ACTIONS(1509), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_EQ,
    STATE(1056), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1678), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1057), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1058), 1,
      sym_heredoc_body,
    ACTIONS(1489), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1059), 1,
      sym_heredoc_body,
    ACTIONS(1513), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1060), 1,
      sym_heredoc_body,
    ACTIONS(1455), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1061), 1,
      sym_heredoc_body,
    ACTIONS(1493), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1062), 1,
      sym_heredoc_body,
    ACTIONS(1481), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1063), 1,
      sym_heredoc_body,
    ACTIONS(1475), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1064), 1,
      sym_heredoc_body,
    ACTIONS(1521), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1065), 1,
      sym_heredoc_body,
    ACTIONS(115), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1066), 1,
      sym_heredoc_body,
    ACTIONS(1455), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1067), 1,
      sym_heredoc_body,
    ACTIONS(1485), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1483), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1068), 1,
      sym_heredoc_body,
    ACTIONS(1471), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7380] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1069), 1,
      sym_heredoc_body,
    ACTIONS(1463), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1070), 1,
      sym_heredoc_body,
    ACTIONS(1517), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1071), 1,
      sym_heredoc_body,
    ACTIONS(1459), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1072), 1,
      sym_heredoc_body,
    ACTIONS(1463), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1073), 1,
      sym_heredoc_body,
    ACTIONS(1493), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1099), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      sym_heredoc_body,
    ACTIONS(907), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(909), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1075), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1076), 1,
      sym_heredoc_body,
    ACTIONS(1471), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1077), 1,
      sym_heredoc_body,
    ACTIONS(1501), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1078), 1,
      sym_heredoc_body,
    ACTIONS(1485), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1483), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1079), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1080), 1,
      sym_heredoc_body,
    ACTIONS(1497), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1081), 1,
      sym_heredoc_body,
    ACTIONS(1505), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1082), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8318] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1083), 1,
      sym_heredoc_body,
    ACTIONS(1682), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1680), 46,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1648), 1,
      anon_sym_LBRACE,
    ACTIONS(1650), 1,
      anon_sym_do,
    STATE(1084), 1,
      sym_heredoc_body,
    STATE(1207), 1,
      sym_do_block,
    STATE(1209), 1,
      sym_block,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1085), 1,
      sym_heredoc_body,
    ACTIONS(1509), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8528] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_r,
    STATE(1086), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1087), 1,
      sym_heredoc_body,
    ACTIONS(1513), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8664] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_r,
    STATE(1088), 1,
      sym_heredoc_body,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1089), 1,
      sym_heredoc_body,
    ACTIONS(1521), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1090), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1091), 1,
      sym_heredoc_body,
    ACTIONS(1451), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1092), 1,
      sym_heredoc_body,
    ACTIONS(1517), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 37,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1093), 1,
      sym_heredoc_body,
    ACTIONS(1451), 19,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9068] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1094), 1,
      sym_heredoc_body,
    ACTIONS(1692), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1690), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9135] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1095), 1,
      sym_heredoc_body,
    ACTIONS(1696), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1694), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9202] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1096), 1,
      sym_heredoc_body,
    ACTIONS(1700), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1698), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1097), 1,
      sym_heredoc_body,
    ACTIONS(1019), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9336] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1098), 1,
      sym_heredoc_body,
    ACTIONS(1704), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1702), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9403] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1099), 1,
      sym_heredoc_body,
    ACTIONS(1497), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9470] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1100), 1,
      sym_heredoc_body,
    ACTIONS(1708), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1706), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1101), 1,
      sym_heredoc_body,
    ACTIONS(1712), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1710), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9604] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1102), 1,
      sym_heredoc_body,
    ACTIONS(1481), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9671] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1103), 1,
      sym_heredoc_body,
    ACTIONS(1716), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1714), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9738] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1104), 1,
      sym_heredoc_body,
    ACTIONS(1475), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9805] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1105), 1,
      sym_heredoc_body,
    ACTIONS(1720), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1718), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9872] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1106), 1,
      sym_heredoc_body,
    ACTIONS(1724), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1722), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9939] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1107), 1,
      sym_heredoc_body,
    ACTIONS(1728), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1726), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10006] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1108), 1,
      sym_heredoc_body,
    ACTIONS(1732), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1730), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10073] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1109), 1,
      sym_heredoc_body,
    ACTIONS(1517), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10140] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1110), 1,
      sym_heredoc_body,
    ACTIONS(1736), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1734), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10207] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 1,
      anon_sym_EQ,
    STATE(1111), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1740), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10278] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1112), 1,
      sym_heredoc_body,
    ACTIONS(1744), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1742), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1113), 1,
      sym_heredoc_body,
    ACTIONS(1023), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1025), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10412] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_DOT,
    ACTIONS(1752), 1,
      anon_sym_LBRACK,
    ACTIONS(1754), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(1756), 1,
      anon_sym_AMP_DOT,
    STATE(1114), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1115), 1,
      sym_heredoc_body,
    ACTIONS(1007), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1009), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1116), 1,
      sym_heredoc_body,
    ACTIONS(1003), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10621] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1117), 1,
      sym_heredoc_body,
    ACTIONS(1760), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1758), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10688] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1118), 1,
      sym_heredoc_body,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1119), 1,
      sym_heredoc_body,
    ACTIONS(1011), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1013), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10822] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1120), 1,
      sym_heredoc_body,
    ACTIONS(1764), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1762), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10889] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1121), 1,
      sym_heredoc_body,
    ACTIONS(1509), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10956] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1122), 1,
      sym_heredoc_body,
    ACTIONS(1505), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1123), 1,
      sym_heredoc_body,
    ACTIONS(1768), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1766), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11090] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1124), 1,
      sym_heredoc_body,
    ACTIONS(1772), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1770), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11157] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1125), 1,
      sym_heredoc_body,
    ACTIONS(1776), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11224] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1126), 1,
      sym_heredoc_body,
    ACTIONS(1780), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1778), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1127), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11358] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1128), 1,
      sym_heredoc_body,
    ACTIONS(1784), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1782), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11425] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1129), 1,
      sym_heredoc_body,
    ACTIONS(1788), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1786), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11492] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1130), 1,
      sym_heredoc_body,
    ACTIONS(1792), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11559] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1131), 1,
      sym_heredoc_body,
    ACTIONS(1796), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1794), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11626] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1132), 1,
      sym_heredoc_body,
    ACTIONS(1800), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1798), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11693] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1133), 1,
      sym_heredoc_body,
    ACTIONS(1804), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11760] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1134), 1,
      sym_heredoc_body,
    ACTIONS(1808), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1806), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11827] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1135), 1,
      sym_heredoc_body,
    ACTIONS(1489), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11894] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1136), 1,
      sym_heredoc_body,
    ACTIONS(1812), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1810), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11961] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1137), 1,
      sym_heredoc_body,
    ACTIONS(1816), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1814), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12028] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    ACTIONS(1609), 1,
      anon_sym_LPAREN2,
    STATE(1091), 1,
      sym_block,
    STATE(1093), 1,
      sym_do_block,
    STATE(1138), 1,
      sym_heredoc_body,
    STATE(1198), 1,
      sym_argument_list,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1139), 1,
      sym_heredoc_body,
    ACTIONS(997), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(999), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12172] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1140), 1,
      sym_heredoc_body,
    ACTIONS(1820), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1818), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12239] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1141), 1,
      sym_heredoc_body,
    ACTIONS(1824), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1822), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12306] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1142), 1,
      sym_heredoc_body,
    ACTIONS(1828), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1826), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(1830), 1,
      anon_sym_EQ,
    STATE(1143), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1832), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12446] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1144), 1,
      sym_heredoc_body,
    ACTIONS(1836), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1834), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12513] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1145), 1,
      sym_heredoc_body,
    ACTIONS(1840), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1838), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12580] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1146), 1,
      sym_heredoc_body,
    ACTIONS(1844), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1842), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12647] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1147), 1,
      sym_heredoc_body,
    ACTIONS(1848), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1846), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12714] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1148), 1,
      sym_heredoc_body,
    ACTIONS(1852), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1850), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12781] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1149), 1,
      sym_heredoc_body,
    ACTIONS(1856), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1854), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12848] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1150), 1,
      sym_heredoc_body,
    ACTIONS(1860), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1858), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12915] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1151), 1,
      sym_heredoc_body,
    ACTIONS(1864), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1862), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12982] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_EQ,
    STATE(1152), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1868), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13053] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1153), 1,
      sym_heredoc_body,
    ACTIONS(1872), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1870), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13120] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1154), 1,
      sym_heredoc_body,
    ACTIONS(1019), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13187] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(1874), 1,
      anon_sym_EQ,
    STATE(1155), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1876), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13260] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1156), 1,
      sym_heredoc_body,
    ACTIONS(1880), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1878), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13327] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1157), 1,
      sym_heredoc_body,
    ACTIONS(1884), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1882), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13394] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1158), 1,
      sym_heredoc_body,
    ACTIONS(1888), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1886), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13461] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1159), 1,
      sym_heredoc_body,
    ACTIONS(1892), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1890), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13528] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1160), 1,
      sym_heredoc_body,
    ACTIONS(1896), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1894), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13595] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1161), 1,
      sym_heredoc_body,
    ACTIONS(1900), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1898), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13662] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1162), 1,
      sym_heredoc_body,
    ACTIONS(1521), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13729] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1163), 1,
      sym_heredoc_body,
    ACTIONS(1904), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1902), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13796] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1164), 1,
      sym_heredoc_body,
    ACTIONS(1908), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1906), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13863] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1165), 1,
      sym_heredoc_body,
    ACTIONS(1912), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1910), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13930] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1166), 1,
      sym_heredoc_body,
    ACTIONS(1513), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13997] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1167), 1,
      sym_heredoc_body,
    ACTIONS(1916), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1914), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14064] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1168), 1,
      sym_heredoc_body,
    ACTIONS(1920), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1918), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14131] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1169), 1,
      sym_heredoc_body,
    ACTIONS(1924), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1922), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14198] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1170), 1,
      sym_heredoc_body,
    ACTIONS(1928), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1926), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14265] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1171), 1,
      sym_heredoc_body,
    ACTIONS(1932), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1930), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14332] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1172), 1,
      sym_heredoc_body,
    ACTIONS(1936), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1934), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14399] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1173), 1,
      sym_heredoc_body,
    ACTIONS(1940), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1938), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14466] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1174), 1,
      sym_heredoc_body,
    ACTIONS(1944), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1942), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14533] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1175), 1,
      sym_heredoc_body,
    ACTIONS(1948), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1946), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14600] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1176), 1,
      sym_heredoc_body,
    ACTIONS(1952), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1950), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14667] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1177), 1,
      sym_heredoc_body,
    ACTIONS(1956), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1954), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14734] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1178), 1,
      sym_heredoc_body,
    ACTIONS(1960), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1958), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14801] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1179), 1,
      sym_heredoc_body,
    ACTIONS(1962), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1479), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1180), 1,
      sym_heredoc_body,
    ACTIONS(1966), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1964), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14935] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1181), 1,
      sym_heredoc_body,
    ACTIONS(1970), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1968), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15002] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1182), 1,
      sym_heredoc_body,
    ACTIONS(1974), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1972), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15069] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1183), 1,
      sym_heredoc_body,
    ACTIONS(1978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1976), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15136] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1184), 1,
      sym_heredoc_body,
    ACTIONS(1982), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1980), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15203] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1185), 1,
      sym_heredoc_body,
    ACTIONS(1986), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1984), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15270] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1186), 1,
      sym_heredoc_body,
    ACTIONS(1990), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1988), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15337] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1187), 1,
      sym_heredoc_body,
    ACTIONS(1994), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1992), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15404] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1188), 1,
      sym_heredoc_body,
    ACTIONS(1998), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1996), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1189), 1,
      sym_heredoc_body,
    ACTIONS(907), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(909), 35,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15538] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1190), 1,
      sym_heredoc_body,
    ACTIONS(2002), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2000), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15605] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1191), 1,
      sym_heredoc_body,
    ACTIONS(2006), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2004), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15672] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1192), 1,
      sym_heredoc_body,
    ACTIONS(1003), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15739] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1193), 1,
      sym_heredoc_body,
    ACTIONS(1455), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15806] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1194), 1,
      sym_heredoc_body,
    ACTIONS(2010), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2008), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15873] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2012), 1,
      anon_sym_EQ,
    STATE(1195), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2014), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 20,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15945] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2016), 1,
      anon_sym_EQ,
    STATE(1196), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2018), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16017] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_DOT,
    ACTIONS(2022), 1,
      anon_sym_LBRACK,
    ACTIONS(2024), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2026), 1,
      anon_sym_AMP_DOT,
    STATE(1197), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    STATE(1069), 1,
      sym_block,
    STATE(1072), 1,
      sym_do_block,
    STATE(1198), 1,
      sym_heredoc_body,
    ACTIONS(1435), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1433), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16162] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_LBRACK,
    ACTIONS(2028), 1,
      anon_sym_DOT,
    ACTIONS(2030), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2032), 1,
      anon_sym_AMP_DOT,
    STATE(1199), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16235] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(2034), 1,
      anon_sym_EQ,
    STATE(1200), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2036), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 18,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16308] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2038), 1,
      anon_sym_EQ,
    STATE(1201), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2040), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 19,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2042), 1,
      anon_sym_EQ,
    STATE(1202), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2044), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2046), 1,
      anon_sym_EQ,
    STATE(1203), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2048), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1204), 1,
      sym_heredoc_body,
    ACTIONS(1521), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1205), 1,
      sym_heredoc_body,
    ACTIONS(1489), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1206), 1,
      sym_heredoc_body,
    ACTIONS(1471), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1469), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1207), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1208), 1,
      sym_heredoc_body,
    ACTIONS(1485), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1483), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1209), 1,
      sym_heredoc_body,
    ACTIONS(1463), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1461), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2050), 1,
      anon_sym_EQ,
    STATE(1210), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2052), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 18,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1211), 1,
      sym_heredoc_body,
    ACTIONS(1493), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1491), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1212), 1,
      sym_heredoc_body,
    ACTIONS(1497), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1213), 1,
      sym_heredoc_body,
    ACTIONS(1517), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1214), 1,
      sym_heredoc_body,
    ACTIONS(1455), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1215), 1,
      sym_heredoc_body,
    ACTIONS(1481), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17295] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(2054), 1,
      anon_sym_EQ,
    STATE(1216), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2056), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1441), 17,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [17367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1217), 1,
      sym_heredoc_body,
    ACTIONS(1505), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17431] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(1218), 1,
      sym_heredoc_body,
    STATE(1224), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1219), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1220), 1,
      sym_heredoc_body,
    ACTIONS(1475), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1221), 1,
      sym_heredoc_body,
    ACTIONS(1459), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1457), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1222), 1,
      sym_heredoc_body,
    ACTIONS(1509), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1223), 1,
      sym_heredoc_body,
    ACTIONS(1451), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1449), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17819] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2066), 1,
      anon_sym_COMMA,
    STATE(1224), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17885] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1218), 1,
      aux_sym_exceptions_repeat1,
    STATE(1225), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [17979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1226), 1,
      sym_heredoc_body,
    ACTIONS(1513), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1227), 1,
      sym_heredoc_body,
    ACTIONS(115), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(111), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(1228), 1,
      sym_heredoc_body,
    ACTIONS(1501), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(1499), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18171] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1218), 1,
      aux_sym_exceptions_repeat1,
    STATE(1229), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18237] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    STATE(1230), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18302] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1231), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [18393] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1232), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [18484] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1233), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [18575] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_COMMA,
    STATE(1234), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18640] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1235), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18703] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    STATE(1236), 1,
      sym_heredoc_body,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 27,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [18788] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(2118), 1,
      anon_sym_EQ,
    STATE(1237), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2120), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1441), 16,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [18859] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1238), 1,
      sym_heredoc_body,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18922] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    STATE(1239), 1,
      sym_heredoc_body,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 36,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18991] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(2122), 1,
      anon_sym_EQ,
    STATE(1240), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2124), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1441), 15,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1443), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [19062] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_heredoc_body,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 27,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [19147] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1242), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [19238] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1243), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [19329] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1244), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 24,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [19418] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2130), 1,
      anon_sym_EQ_GT,
    STATE(1245), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2128), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [19511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2132), 1,
      anon_sym_EQ,
    STATE(1246), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2134), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1441), 16,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1443), 18,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [19580] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    STATE(1247), 1,
      sym_heredoc_body,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19657] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    STATE(1248), 1,
      sym_heredoc_body,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 34,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19728] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    STATE(1249), 1,
      sym_heredoc_body,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 34,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19801] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    STATE(1250), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19866] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    STATE(1251), 1,
      sym_heredoc_body,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 38,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19933] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2136), 1,
      anon_sym_COMMA,
    STATE(1234), 1,
      aux_sym_exceptions_repeat1,
    STATE(1252), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20000] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    STATE(1253), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20065] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1254), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [20156] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1252), 1,
      aux_sym_exceptions_repeat1,
    STATE(1255), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20221] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1256), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20284] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1257), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20347] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(2142), 1,
      anon_sym_EQ,
    STATE(1258), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2144), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(1441), 16,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1443), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [20418] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2073), 1,
      anon_sym_PIPE,
    ACTIONS(2075), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2077), 1,
      anon_sym_AMP,
    ACTIONS(2081), 1,
      anon_sym_QMARK,
    ACTIONS(2083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_GT_EQ,
    ACTIONS(2093), 1,
      anon_sym_CARET,
    ACTIONS(2099), 1,
      anon_sym_EQ_EQ,
    STATE(1259), 1,
      sym_heredoc_body,
    ACTIONS(2087), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2089), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2079), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2097), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2101), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [20509] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1252), 1,
      aux_sym_exceptions_repeat1,
    STATE(1260), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20602] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1261), 1,
      sym_heredoc_body,
    STATE(1274), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [20694] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1262), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [20784] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    STATE(1263), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20848] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    STATE(1264), 1,
      sym_heredoc_body,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20918] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    STATE(1265), 1,
      sym_heredoc_body,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20994] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1266), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2206), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [21084] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 1,
      anon_sym_DOT,
    ACTIONS(2210), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2212), 1,
      anon_sym_AMP_DOT,
    STATE(1267), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21154] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    STATE(1268), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21218] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1269), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [21306] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    STATE(1270), 1,
      sym_heredoc_body,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 37,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21372] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1271), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [21462] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1272), 1,
      sym_heredoc_body,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 26,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [21546] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    STATE(1273), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21610] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_COMMA,
    STATE(1274), 1,
      sym_heredoc_body,
    STATE(1285), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21676] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    STATE(1275), 1,
      sym_heredoc_body,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 35,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21744] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1276), 1,
      sym_heredoc_body,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 26,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [21828] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1274), 1,
      aux_sym_exceptions_repeat1,
    STATE(1277), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21892] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1278), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [21982] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1279), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2216), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22072] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1280), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2218), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22162] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1281), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22252] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1282), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22342] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1283), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22432] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1284), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22522] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_COMMA,
    STATE(1285), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22586] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    STATE(1286), 1,
      sym_heredoc_body,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22658] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_PIPE,
    ACTIONS(2148), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2150), 1,
      anon_sym_AMP,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2158), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2164), 1,
      anon_sym_GT_EQ,
    ACTIONS(2166), 1,
      anon_sym_CARET,
    ACTIONS(2172), 1,
      anon_sym_EQ_EQ,
    STATE(1287), 1,
      sym_heredoc_body,
    ACTIONS(2160), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2162), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2168), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2152), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2170), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2174), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2223), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [22748] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    STATE(1288), 1,
      sym_heredoc_body,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 34,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22815] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1289), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [22904] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    STATE(1290), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22967] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1291), 1,
      sym_heredoc_body,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23050] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1292), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23139] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1293), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23228] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1294), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23317] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1295), 1,
      sym_heredoc_body,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23400] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1296), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [23487] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1297), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23576] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    STATE(1298), 1,
      sym_heredoc_body,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 31,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23651] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1299), 1,
      sym_heredoc_body,
    STATE(1311), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [23744] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    STATE(1300), 1,
      sym_heredoc_body,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23813] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1301), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [23902] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    STATE(1302), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23965] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(1303), 1,
      sym_heredoc_body,
    STATE(1311), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24030] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    STATE(1304), 1,
      sym_heredoc_body,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24101] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    STATE(1305), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24164] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2257), 1,
      anon_sym_EQ_GT,
    STATE(1306), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2128), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24255] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1307), 1,
      sym_heredoc_body,
    STATE(1311), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24318] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    STATE(1308), 1,
      sym_heredoc_body,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 36,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24383] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1309), 1,
      sym_heredoc_body,
    STATE(1311), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24474] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    STATE(1310), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24537] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(1310), 1,
      aux_sym_exceptions_repeat1,
    STATE(1311), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24602] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1311), 1,
      aux_sym_exceptions_repeat1,
    STATE(1312), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24695] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1313), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [24784] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1311), 1,
      aux_sym_exceptions_repeat1,
    STATE(1314), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [24875] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1315), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24937] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1316), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25025] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1317), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25113] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1318), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25201] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1319), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2223), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25289] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1320), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25377] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1321), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2206), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25465] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1322), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25553] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1323), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25641] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1324), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [25729] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1325), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 24,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [25811] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1326), 1,
      sym_heredoc_body,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 33,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25877] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1327), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 24,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [25959] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1328), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [26047] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1329), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [26133] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    STATE(1330), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 30,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26207] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1331), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 31,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26275] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1332), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26337] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1333), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2216), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [26425] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      anon_sym_QMARK,
    ACTIONS(2237), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2239), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2245), 1,
      anon_sym_GT_EQ,
    ACTIONS(2247), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_EQ_EQ,
    STATE(1334), 1,
      sym_heredoc_body,
    ACTIONS(2241), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2233), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2255), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2218), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [26513] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2231), 1,
      anon_sym_AMP,
    STATE(1335), 1,
      sym_heredoc_body,
    ACTIONS(2243), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2249), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 31,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26583] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1336), 1,
      sym_heredoc_body,
    ACTIONS(2251), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 35,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26647] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_STAR_STAR,
    STATE(1337), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26709] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    STATE(1338), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 29,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26782] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1339), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 30,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26849] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1340), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [26936] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1341), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [27017] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1342), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 23,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [27098] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1343), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27185] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1344), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27272] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1345), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [27357] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym__string_start,
    ACTIONS(2292), 1,
      anon_sym_COLON,
    STATE(994), 1,
      aux_sym_chained_string_repeat1,
    STATE(1083), 1,
      sym_string,
    STATE(1346), 1,
      sym_heredoc_body,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27424] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    STATE(1347), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 30,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27493] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1348), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27580] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1349), 1,
      sym_heredoc_body,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 34,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27643] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1350), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27704] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1351), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27765] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1352), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [27852] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1353), 1,
      sym_heredoc_body,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 32,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27917] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1354), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [28004] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_LBRACK,
    ACTIONS(2294), 1,
      anon_sym_DOT,
    ACTIONS(2296), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2298), 1,
      anon_sym_AMP_DOT,
    STATE(1355), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28071] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(241), 1,
      sym__string_start,
    ACTIONS(2300), 1,
      anon_sym_COLON,
    STATE(1356), 1,
      sym_heredoc_body,
    STATE(1362), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28134] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_PIPE,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2266), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2278), 1,
      anon_sym_QMARK,
    ACTIONS(2280), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2282), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2286), 1,
      anon_sym_GT_EQ,
    ACTIONS(2288), 1,
      anon_sym_EQ_EQ,
    STATE(1357), 1,
      sym_heredoc_body,
    ACTIONS(2268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2290), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2302), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [28221] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_STAR_STAR,
    STATE(1358), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28282] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2306), 1,
      anon_sym_LPAREN,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    STATE(1128), 1,
      sym__method_rest,
    STATE(1359), 1,
      sym_heredoc_body,
    STATE(2142), 1,
      sym__method_name,
    STATE(2767), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28360] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2320), 1,
      anon_sym_LPAREN,
    STATE(1360), 1,
      sym_heredoc_body,
    STATE(1536), 1,
      sym__method_rest,
    STATE(2141), 1,
      sym__method_name,
    STATE(2762), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28438] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2322), 1,
      sym__string_start,
    STATE(1361), 3,
      sym_string,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1639), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1637), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28496] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(241), 1,
      sym__string_start,
    STATE(1362), 1,
      sym_heredoc_body,
    STATE(1361), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1635), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28556] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2325), 1,
      anon_sym_LPAREN,
    STATE(1363), 1,
      sym_heredoc_body,
    STATE(2143), 1,
      sym__method_name,
    STATE(2589), 1,
      sym__method_rest,
    STATE(2768), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28634] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(241), 1,
      sym__string_start,
    STATE(1364), 1,
      sym_heredoc_body,
    STATE(1362), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28694] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(889), 1,
      sym__string_start,
    STATE(1365), 1,
      sym_heredoc_body,
    STATE(1376), 1,
      aux_sym_chained_string_repeat1,
    STATE(1388), 1,
      sym_string,
    ACTIONS(1635), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28757] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1366), 1,
      sym_heredoc_body,
    STATE(1414), 1,
      sym_argument_list,
    ACTIONS(1656), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1654), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28816] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(889), 1,
      sym__string_start,
    STATE(1365), 1,
      aux_sym_chained_string_repeat1,
    STATE(1367), 1,
      sym_heredoc_body,
    STATE(1388), 1,
      sym_string,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28879] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1368), 1,
      sym_heredoc_body,
    ACTIONS(1674), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28934] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(241), 1,
      sym__string_start,
    ACTIONS(2327), 1,
      anon_sym_COLON,
    STATE(1369), 1,
      sym_heredoc_body,
    STATE(1362), 2,
      sym_string,
      aux_sym_chained_string_repeat1,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28995] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_LPAREN2,
    STATE(1370), 1,
      sym_heredoc_body,
    STATE(1564), 1,
      sym_argument_list,
    ACTIONS(1656), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1654), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29056] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1371), 1,
      sym_heredoc_body,
    STATE(1416), 1,
      sym_argument_list,
    ACTIONS(297), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(295), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29115] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_LPAREN2,
    STATE(1372), 1,
      sym_heredoc_body,
    STATE(1448), 1,
      sym_argument_list,
    ACTIONS(1668), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1666), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29176] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1373), 1,
      sym_heredoc_body,
    STATE(1417), 1,
      sym_argument_list,
    ACTIONS(301), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(299), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29235] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1374), 1,
      sym_heredoc_body,
    STATE(1418), 1,
      sym_argument_list,
    ACTIONS(305), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(303), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29294] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1375), 1,
      sym_heredoc_body,
    STATE(1419), 1,
      sym_argument_list,
    ACTIONS(275), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(273), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29353] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2331), 1,
      sym__string_start,
    STATE(1388), 1,
      sym_string,
    STATE(1376), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1639), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1637), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29414] = 14,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2304), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2334), 1,
      anon_sym_LPAREN,
    STATE(1377), 1,
      sym_heredoc_body,
    STATE(1423), 1,
      sym__method_rest,
    STATE(2149), 1,
      sym__method_name,
    STATE(2888), 1,
      sym__variable,
    ACTIONS(2314), 2,
      sym_super,
      sym_self,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2312), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29489] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_LPAREN2,
    STATE(1378), 1,
      sym_heredoc_body,
    STATE(1556), 1,
      sym_argument_list,
    ACTIONS(297), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(295), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29550] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(313), 1,
      anon_sym_LPAREN2,
    STATE(1379), 1,
      sym_heredoc_body,
    STATE(1415), 1,
      sym_argument_list,
    ACTIONS(1668), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1666), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29609] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1380), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29664] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_LPAREN2,
    STATE(1381), 1,
      sym_heredoc_body,
    STATE(1555), 1,
      sym_argument_list,
    ACTIONS(301), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(299), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29725] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_LPAREN2,
    STATE(1382), 1,
      sym_heredoc_body,
    STATE(1547), 1,
      sym_argument_list,
    ACTIONS(275), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(273), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29786] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_LPAREN2,
    STATE(1383), 1,
      sym_heredoc_body,
    STATE(1549), 1,
      sym_argument_list,
    ACTIONS(305), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(303), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29847] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_r,
    STATE(1384), 1,
      sym_heredoc_body,
    ACTIONS(1443), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29905] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1385), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 33,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29961] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_LBRACK,
    ACTIONS(2338), 1,
      anon_sym_DOT,
    ACTIONS(2340), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2342), 1,
      anon_sym_AMP_DOT,
    STATE(1386), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30025] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2344), 1,
      anon_sym_r,
    STATE(1387), 1,
      sym_heredoc_body,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30081] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1388), 1,
      sym_heredoc_body,
    ACTIONS(1682), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1680), 33,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30137] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2344), 1,
      anon_sym_r,
    STATE(1389), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30193] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_r,
    STATE(1390), 1,
      sym_heredoc_body,
    ACTIONS(1686), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30251] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1391), 1,
      sym_heredoc_body,
    ACTIONS(1674), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 33,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30307] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1392), 1,
      sym_heredoc_body,
    ACTIONS(1505), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30360] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1393), 1,
      sym_heredoc_body,
    ACTIONS(1788), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1786), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30415] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1394), 1,
      sym_heredoc_body,
    ACTIONS(1788), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1786), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30468] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1395), 1,
      sym_heredoc_body,
    ACTIONS(1780), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1778), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30521] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1396), 1,
      sym_heredoc_body,
    ACTIONS(1764), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1762), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30574] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1397), 1,
      sym_heredoc_body,
    ACTIONS(1960), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1958), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30627] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1398), 1,
      sym_heredoc_body,
    ACTIONS(1716), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1714), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30680] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1399), 1,
      sym_heredoc_body,
    ACTIONS(1816), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1814), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30733] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1400), 1,
      sym_heredoc_body,
    ACTIONS(1840), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1838), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30786] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1401), 1,
      sym_heredoc_body,
    ACTIONS(1970), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1968), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30839] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1402), 1,
      sym_heredoc_body,
    ACTIONS(1896), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1894), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30892] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1403), 1,
      sym_heredoc_body,
    ACTIONS(1912), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1910), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30947] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1404), 1,
      sym_heredoc_body,
    ACTIONS(1828), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1826), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31002] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1405), 1,
      sym_heredoc_body,
    ACTIONS(1443), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31057] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1406), 1,
      sym_heredoc_body,
    ACTIONS(1896), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1894), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31112] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1407), 1,
      sym_heredoc_body,
    ACTIONS(1848), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1846), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31165] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1408), 1,
      sym_heredoc_body,
    ACTIONS(1888), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1886), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31220] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1409), 1,
      sym_heredoc_body,
    ACTIONS(1732), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1730), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31273] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1410), 1,
      sym_heredoc_body,
    ACTIONS(1768), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1766), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31328] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1411), 1,
      sym_heredoc_body,
    ACTIONS(1744), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1742), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31381] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1412), 1,
      sym_heredoc_body,
    ACTIONS(1760), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1758), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31434] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1413), 1,
      sym_heredoc_body,
    ACTIONS(1800), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1798), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31487] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1414), 1,
      sym_heredoc_body,
    ACTIONS(1852), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1850), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31540] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1415), 1,
      sym_heredoc_body,
    ACTIONS(1864), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1862), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31593] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1416), 1,
      sym_heredoc_body,
    ACTIONS(1916), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1914), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31646] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1417), 1,
      sym_heredoc_body,
    ACTIONS(1986), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1984), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31699] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1418), 1,
      sym_heredoc_body,
    ACTIONS(1998), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1996), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31752] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1419), 1,
      sym_heredoc_body,
    ACTIONS(1844), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1842), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31805] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1420), 1,
      sym_heredoc_body,
    ACTIONS(1840), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1838), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31860] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1421), 1,
      sym_heredoc_body,
    ACTIONS(1712), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1710), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31913] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2346), 1,
      anon_sym_DOT,
    ACTIONS(2348), 1,
      anon_sym_LBRACK,
    ACTIONS(2350), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2352), 1,
      anon_sym_AMP_DOT,
    STATE(1422), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31974] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1423), 1,
      sym_heredoc_body,
    ACTIONS(1784), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1782), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32027] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1424), 1,
      sym_heredoc_body,
    ACTIONS(1804), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32082] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1425), 1,
      sym_heredoc_body,
    ACTIONS(1455), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32135] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1426), 1,
      sym_heredoc_body,
    ACTIONS(1962), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1479), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32188] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1427), 1,
      sym_heredoc_body,
    ACTIONS(1816), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1814), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32243] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1428), 1,
      sym_heredoc_body,
    ACTIONS(1720), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1718), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32296] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1429), 1,
      sym_heredoc_body,
    ACTIONS(1704), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1702), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32349] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1430), 1,
      sym_heredoc_body,
    ACTIONS(1736), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1734), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32402] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1431), 1,
      sym_heredoc_body,
    ACTIONS(1724), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1722), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32455] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1432), 1,
      sym_heredoc_body,
    ACTIONS(1924), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1922), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32510] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1433), 1,
      sym_heredoc_body,
    ACTIONS(1960), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1958), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32565] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1434), 1,
      sym_heredoc_body,
    ACTIONS(1700), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1698), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32618] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1435), 1,
      sym_heredoc_body,
    ACTIONS(1728), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1726), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32671] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1436), 1,
      sym_heredoc_body,
    ACTIONS(1970), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1968), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32726] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1437), 1,
      sym_heredoc_body,
    ACTIONS(1517), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32781] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1438), 1,
      sym_heredoc_body,
    ACTIONS(1455), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1453), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32836] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1439), 1,
      sym_heredoc_body,
    ACTIONS(1497), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32889] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1440), 1,
      sym_heredoc_body,
    ACTIONS(1521), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32944] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1441), 1,
      sym_heredoc_body,
    ACTIONS(1513), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32999] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1442), 1,
      sym_heredoc_body,
    ACTIONS(1848), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1846), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33054] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1443), 1,
      sym_heredoc_body,
    ACTIONS(2006), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2004), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33109] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1444), 1,
      sym_heredoc_body,
    ACTIONS(1700), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1698), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33164] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1445), 1,
      sym_heredoc_body,
    ACTIONS(1728), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1726), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33219] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1446), 1,
      sym_heredoc_body,
    ACTIONS(1900), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1898), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33272] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1447), 1,
      sym_heredoc_body,
    ACTIONS(1908), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1906), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33325] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1448), 1,
      sym_heredoc_body,
    ACTIONS(1864), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1862), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33380] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1449), 1,
      sym_heredoc_body,
    ACTIONS(1932), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1930), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33433] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1450), 1,
      sym_heredoc_body,
    ACTIONS(1952), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1950), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33486] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1451), 1,
      sym_heredoc_body,
    ACTIONS(1509), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33541] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1452), 1,
      sym_heredoc_body,
    ACTIONS(1505), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1503), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33596] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1453), 1,
      sym_heredoc_body,
    ACTIONS(1732), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1730), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33651] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1454), 1,
      sym_heredoc_body,
    ACTIONS(1900), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1898), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33706] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1455), 1,
      sym_heredoc_body,
    ACTIONS(1908), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1906), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33761] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1456), 1,
      sym_heredoc_body,
    ACTIONS(1932), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1930), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33816] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1457), 1,
      sym_heredoc_body,
    ACTIONS(1940), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1938), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33869] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1458), 1,
      sym_heredoc_body,
    ACTIONS(1696), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1694), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33922] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1459), 1,
      sym_heredoc_body,
    ACTIONS(1978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1976), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33975] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1460), 1,
      sym_heredoc_body,
    ACTIONS(1952), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1950), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34030] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2348), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_DOT,
    ACTIONS(2356), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2358), 1,
      anon_sym_AMP_DOT,
    STATE(1461), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34091] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1462), 1,
      sym_heredoc_body,
    ACTIONS(1019), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34146] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1463), 1,
      sym_heredoc_body,
    ACTIONS(1003), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34201] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1464), 1,
      sym_heredoc_body,
    ACTIONS(1696), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1694), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34256] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1465), 1,
      sym_heredoc_body,
    ACTIONS(1824), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1822), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34309] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1466), 1,
      sym_heredoc_body,
    ACTIONS(1978), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1976), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34364] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1467), 1,
      sym_heredoc_body,
    ACTIONS(2010), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2008), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34417] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1468), 1,
      sym_heredoc_body,
    ACTIONS(1956), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1954), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34470] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1469), 1,
      sym_heredoc_body,
    ACTIONS(1856), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1854), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34525] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1470), 1,
      sym_heredoc_body,
    ACTIONS(2010), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2008), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34580] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1471), 1,
      sym_heredoc_body,
    ACTIONS(1724), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1722), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34635] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1472), 1,
      sym_heredoc_body,
    ACTIONS(1744), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1742), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34690] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1473), 1,
      sym_heredoc_body,
    ACTIONS(1956), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1954), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34745] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1474), 1,
      sym_heredoc_body,
    ACTIONS(1974), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1972), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34800] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1475), 1,
      sym_heredoc_body,
    ACTIONS(1966), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1964), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34855] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1476), 1,
      sym_heredoc_body,
    ACTIONS(1760), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1758), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34910] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1477), 1,
      sym_heredoc_body,
    ACTIONS(1880), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1878), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34965] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1478), 1,
      sym_heredoc_body,
    ACTIONS(1974), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1972), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35018] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1479), 1,
      sym_heredoc_body,
    ACTIONS(1736), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1734), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35073] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1480), 1,
      sym_heredoc_body,
    ACTIONS(1704), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1702), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1481), 1,
      sym_heredoc_body,
    ACTIONS(1475), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35183] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1482), 1,
      sym_heredoc_body,
    ACTIONS(1966), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1964), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35236] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1483), 1,
      sym_heredoc_body,
    ACTIONS(1884), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1882), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35289] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1484), 1,
      sym_heredoc_body,
    ACTIONS(1481), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35344] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1485), 1,
      sym_heredoc_body,
    ACTIONS(2006), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2004), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1486), 1,
      sym_heredoc_body,
    ACTIONS(1872), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1870), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35452] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1487), 1,
      sym_heredoc_body,
    ACTIONS(1768), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1766), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35505] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1488), 1,
      sym_heredoc_body,
    ACTIONS(1888), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1886), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35558] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1489), 1,
      sym_heredoc_body,
    ACTIONS(1517), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1515), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35611] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1490), 1,
      sym_heredoc_body,
    ACTIONS(1920), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1918), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35664] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1491), 1,
      sym_heredoc_body,
    ACTIONS(1928), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1926), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35717] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1492), 1,
      sym_heredoc_body,
    ACTIONS(1936), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1934), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35770] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1493), 1,
      sym_heredoc_body,
    ACTIONS(1880), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1878), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35823] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1494), 1,
      sym_heredoc_body,
    ACTIONS(1944), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1942), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35876] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1495), 1,
      sym_heredoc_body,
    ACTIONS(1948), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1946), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35929] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1496), 1,
      sym_heredoc_body,
    ACTIONS(1521), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1519), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35982] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1497), 1,
      sym_heredoc_body,
    ACTIONS(1513), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1511), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36035] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1498), 1,
      sym_heredoc_body,
    ACTIONS(2002), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2000), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36088] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1499), 1,
      sym_heredoc_body,
    ACTIONS(1892), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1890), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36141] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1500), 1,
      sym_heredoc_body,
    ACTIONS(1720), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1718), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36196] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1501), 1,
      sym_heredoc_body,
    ACTIONS(1860), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1858), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36251] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1502), 1,
      sym_heredoc_body,
    ACTIONS(1509), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1507), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36304] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1503), 1,
      sym_heredoc_body,
    ACTIONS(1804), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1802), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36357] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1504), 1,
      sym_heredoc_body,
    ACTIONS(1924), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1922), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36410] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1505), 1,
      sym_heredoc_body,
    ACTIONS(1994), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1992), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36463] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1506), 1,
      sym_heredoc_body,
    ACTIONS(1019), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1021), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36516] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1507), 1,
      sym_heredoc_body,
    ACTIONS(1990), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1988), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36569] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1508), 1,
      sym_heredoc_body,
    ACTIONS(1982), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1980), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36622] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1509), 1,
      sym_heredoc_body,
    ACTIONS(1904), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1902), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36675] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1510), 1,
      sym_heredoc_body,
    ACTIONS(1692), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1690), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36730] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1511), 1,
      sym_heredoc_body,
    ACTIONS(1796), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1794), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36785] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1512), 1,
      sym_heredoc_body,
    ACTIONS(1776), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36840] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1513), 1,
      sym_heredoc_body,
    ACTIONS(1892), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1890), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36895] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1514), 1,
      sym_heredoc_body,
    ACTIONS(1475), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1473), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36948] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1515), 1,
      sym_heredoc_body,
    ACTIONS(1708), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1706), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37003] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1516), 1,
      sym_heredoc_body,
    ACTIONS(1003), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1005), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37056] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1517), 1,
      sym_heredoc_body,
    ACTIONS(1836), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1834), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37109] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1518), 1,
      sym_heredoc_body,
    ACTIONS(1872), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1870), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37162] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1519), 1,
      sym_heredoc_body,
    ACTIONS(1828), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1826), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37215] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1520), 1,
      sym_heredoc_body,
    ACTIONS(1800), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1798), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37270] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1521), 1,
      sym_heredoc_body,
    ACTIONS(1812), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1810), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37323] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1522), 1,
      sym_heredoc_body,
    ACTIONS(1772), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1770), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37378] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1523), 1,
      sym_heredoc_body,
    ACTIONS(1497), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1495), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37433] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1524), 1,
      sym_heredoc_body,
    ACTIONS(1489), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1487), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37488] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1525), 1,
      sym_heredoc_body,
    ACTIONS(1792), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37543] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1526), 1,
      sym_heredoc_body,
    ACTIONS(1856), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1854), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37596] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1527), 1,
      sym_heredoc_body,
    ACTIONS(1808), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1806), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37649] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1528), 1,
      sym_heredoc_body,
    ACTIONS(1792), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37702] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1529), 1,
      sym_heredoc_body,
    ACTIONS(1686), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37757] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1530), 1,
      sym_heredoc_body,
    ACTIONS(1962), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1479), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37812] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1531), 1,
      sym_heredoc_body,
    ACTIONS(1808), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1806), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37867] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1532), 1,
      sym_heredoc_body,
    ACTIONS(1812), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1810), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37922] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1533), 1,
      sym_heredoc_body,
    ACTIONS(1836), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1834), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37977] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1534), 1,
      sym_heredoc_body,
    ACTIONS(1904), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1902), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38032] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1535), 1,
      sym_heredoc_body,
    ACTIONS(1982), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1980), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38087] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1536), 1,
      sym_heredoc_body,
    ACTIONS(1784), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1782), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38142] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1537), 1,
      sym_heredoc_body,
    ACTIONS(1796), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1794), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38195] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1538), 1,
      sym_heredoc_body,
    ACTIONS(1990), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1988), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38250] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1539), 1,
      sym_heredoc_body,
    ACTIONS(1712), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1710), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38305] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1540), 1,
      sym_heredoc_body,
    ACTIONS(1994), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1992), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38360] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1541), 1,
      sym_heredoc_body,
    ACTIONS(2002), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2000), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38415] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1542), 1,
      sym_heredoc_body,
    ACTIONS(1948), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1946), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38470] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1543), 1,
      sym_heredoc_body,
    ACTIONS(1944), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1942), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38525] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1544), 1,
      sym_heredoc_body,
    ACTIONS(1940), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1938), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38580] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1545), 1,
      sym_heredoc_body,
    ACTIONS(1936), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1934), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38635] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1546), 1,
      sym_heredoc_body,
    ACTIONS(1860), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1858), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38688] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1547), 1,
      sym_heredoc_body,
    ACTIONS(1844), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1842), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38743] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1548), 1,
      sym_heredoc_body,
    ACTIONS(1912), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1910), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38796] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1549), 1,
      sym_heredoc_body,
    ACTIONS(1998), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1996), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38851] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1550), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38904] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1551), 1,
      sym_heredoc_body,
    ACTIONS(1772), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1770), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38957] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1552), 1,
      sym_heredoc_body,
    ACTIONS(1928), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1926), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39012] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1553), 1,
      sym_heredoc_body,
    ACTIONS(1920), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1918), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39067] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1554), 1,
      sym_heredoc_body,
    ACTIONS(1481), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1477), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39120] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1555), 1,
      sym_heredoc_body,
    ACTIONS(1986), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1984), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39175] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1556), 1,
      sym_heredoc_body,
    ACTIONS(1916), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1914), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39230] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1557), 1,
      sym_heredoc_body,
    ACTIONS(1692), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1690), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39283] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1558), 1,
      sym_heredoc_body,
    ACTIONS(1884), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1882), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39338] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1559), 1,
      sym_heredoc_body,
    ACTIONS(1708), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1706), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39391] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1560), 1,
      sym_heredoc_body,
    ACTIONS(1824), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1822), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39446] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1561), 1,
      sym_heredoc_body,
    ACTIONS(1820), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1818), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39501] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1562), 1,
      sym_heredoc_body,
    ACTIONS(1820), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1818), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39554] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1563), 1,
      sym_heredoc_body,
    ACTIONS(1780), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1778), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39609] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1564), 1,
      sym_heredoc_body,
    ACTIONS(1852), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1850), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39664] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1565), 1,
      sym_heredoc_body,
    ACTIONS(1776), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 34,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39717] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1566), 1,
      sym_heredoc_body,
    ACTIONS(1764), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1762), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39772] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1567), 1,
      sym_heredoc_body,
    ACTIONS(1716), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1714), 32,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39827] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1140), 1,
      sym__method_rest,
    STATE(1568), 1,
      sym_heredoc_body,
    STATE(2142), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [39895] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_DOT,
    ACTIONS(2366), 1,
      anon_sym_LBRACK,
    ACTIONS(2368), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2370), 1,
      anon_sym_AMP_DOT,
    STATE(1569), 1,
      sym_heredoc_body,
    ACTIONS(1750), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39957] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1473), 1,
      sym__method_rest,
    STATE(1570), 1,
      sym_heredoc_body,
    STATE(2141), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40025] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(889), 1,
      sym__string_start,
    ACTIONS(2292), 1,
      anon_sym_COLON,
    STATE(1365), 1,
      aux_sym_chained_string_repeat1,
    STATE(1388), 1,
      sym_string,
    STATE(1571), 1,
      sym_heredoc_body,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40087] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1572), 1,
      sym_heredoc_body,
    STATE(2143), 1,
      sym__method_name,
    STATE(2639), 1,
      sym__method_rest,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40155] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1561), 1,
      sym__method_rest,
    STATE(1573), 1,
      sym_heredoc_body,
    STATE(2141), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40223] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1574), 1,
      sym_heredoc_body,
    STATE(2143), 1,
      sym__method_name,
    STATE(2582), 1,
      sym__method_rest,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40291] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2372), 1,
      anon_sym_DOT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2378), 1,
      anon_sym_AMP_DOT,
    STATE(1575), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40351] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1177), 1,
      sym__method_rest,
    STATE(1576), 1,
      sym_heredoc_body,
    STATE(2142), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40419] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2380), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      sym__simple_symbol,
    ACTIONS(2390), 1,
      sym__symbol_start,
    STATE(1577), 1,
      sym_heredoc_body,
    STATE(2135), 1,
      sym__method_name,
    STATE(2217), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2386), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2384), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2382), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40484] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2392), 1,
      sym_identifier,
    ACTIONS(2400), 1,
      sym__simple_symbol,
    ACTIONS(2402), 1,
      sym__symbol_start,
    STATE(1578), 1,
      sym_heredoc_body,
    STATE(1590), 1,
      sym__method_name,
    STATE(1693), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2398), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2396), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2394), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40549] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2214), 1,
      anon_sym_COMMA,
    STATE(1274), 1,
      aux_sym_exceptions_repeat1,
    STATE(1579), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [40634] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_r,
    STATE(1580), 1,
      sym_heredoc_body,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40689] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1274), 1,
      aux_sym_exceptions_repeat1,
    STATE(1581), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 12,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [40772] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2406), 1,
      sym_identifier,
    STATE(1582), 1,
      sym_heredoc_body,
    STATE(2120), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40837] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_r,
    STATE(1583), 1,
      sym_heredoc_body,
    ACTIONS(1686), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1684), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40892] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2380), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      sym__simple_symbol,
    ACTIONS(2390), 1,
      sym__symbol_start,
    STATE(1584), 1,
      sym_heredoc_body,
    STATE(2201), 1,
      sym__method_name,
    STATE(2217), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2386), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2384), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2382), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [40957] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_COMMA,
    STATE(1274), 1,
      aux_sym_exceptions_repeat1,
    STATE(1585), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41014] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2380), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      sym__simple_symbol,
    ACTIONS(2390), 1,
      sym__symbol_start,
    STATE(1586), 1,
      sym_heredoc_body,
    STATE(2120), 1,
      sym__method_name,
    STATE(2217), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2386), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2384), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2382), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41079] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1468), 1,
      sym__method_rest,
    STATE(1587), 1,
      sym_heredoc_body,
    STATE(2149), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41144] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2392), 1,
      sym_identifier,
    ACTIONS(2400), 1,
      sym__simple_symbol,
    ACTIONS(2402), 1,
      sym__symbol_start,
    STATE(1577), 1,
      sym__method_name,
    STATE(1588), 1,
      sym_heredoc_body,
    STATE(1693), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2398), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2396), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2394), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41209] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2214), 1,
      anon_sym_COMMA,
    STATE(1274), 1,
      aux_sym_exceptions_repeat1,
    STATE(1589), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41294] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2406), 1,
      sym_identifier,
    STATE(1590), 1,
      sym_heredoc_body,
    STATE(2135), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41359] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2360), 1,
      sym_identifier,
    STATE(1562), 1,
      sym__method_rest,
    STATE(1591), 1,
      sym_heredoc_body,
    STATE(2149), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41424] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2316), 1,
      sym__simple_symbol,
    ACTIONS(2318), 1,
      sym__symbol_start,
    ACTIONS(2406), 1,
      sym_identifier,
    STATE(1592), 1,
      sym_heredoc_body,
    STATE(2129), 1,
      sym__method_name,
    STATE(2107), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2362), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2310), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2308), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41489] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1593), 1,
      sym_heredoc_body,
    STATE(1600), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41569] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1594), 1,
      sym_heredoc_body,
    STATE(1600), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41621] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2438), 1,
      sym_identifier,
    ACTIONS(2446), 1,
      sym__simple_symbol,
    ACTIONS(2448), 1,
      sym__symbol_start,
    STATE(1595), 1,
      sym_heredoc_body,
    ACTIONS(2444), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(2519), 4,
      sym_operator,
      sym__method_name,
      sym_setter,
      sym_symbol,
    ACTIONS(2442), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2440), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41681] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_PIPE,
    ACTIONS(2178), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2180), 1,
      anon_sym_AMP,
    ACTIONS(2184), 1,
      anon_sym_QMARK,
    ACTIONS(2186), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2188), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2194), 1,
      anon_sym_GT_EQ,
    ACTIONS(2196), 1,
      anon_sym_CARET,
    ACTIONS(2202), 1,
      anon_sym_EQ_EQ,
    STATE(1596), 1,
      sym_heredoc_body,
    ACTIONS(2190), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2192), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2198), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2182), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2200), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2204), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 12,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [41761] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_DOT,
    ACTIONS(2452), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2454), 1,
      anon_sym_AMP_DOT,
    STATE(1597), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41819] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2438), 1,
      sym_identifier,
    ACTIONS(2446), 1,
      sym__simple_symbol,
    ACTIONS(2448), 1,
      sym__symbol_start,
    STATE(1598), 1,
      sym_heredoc_body,
    ACTIONS(2456), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(2383), 4,
      sym_operator,
      sym__method_name,
      sym_setter,
      sym_symbol,
    ACTIONS(2442), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2440), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41879] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2438), 1,
      sym_identifier,
    ACTIONS(2446), 1,
      sym__simple_symbol,
    ACTIONS(2448), 1,
      sym__symbol_start,
    STATE(1599), 1,
      sym_heredoc_body,
    ACTIONS(2458), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(2472), 4,
      sym_operator,
      sym__method_name,
      sym_setter,
      sym_symbol,
    ACTIONS(2442), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2440), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [41939] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_COMMA,
    STATE(1600), 1,
      sym_heredoc_body,
    STATE(1602), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41993] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2392), 1,
      sym_identifier,
    ACTIONS(2400), 1,
      sym__simple_symbol,
    ACTIONS(2402), 1,
      sym__symbol_start,
    STATE(1595), 1,
      sym__method_name,
    STATE(1601), 1,
      sym_heredoc_body,
    STATE(1693), 3,
      sym_operator,
      sym_setter,
      sym_symbol,
    ACTIONS(2398), 4,
      sym_constant,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    ACTIONS(2396), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2394), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [42055] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_COMMA,
    STATE(1602), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42107] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1603), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42160] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1604), 1,
      sym_heredoc_body,
    STATE(1633), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42211] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2473), 1,
      anon_sym_EQ_GT,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1605), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2302), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [42292] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1606), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42371] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1607), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [42446] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1608), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42525] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1609), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42602] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1610), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42655] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1611), 1,
      sym_heredoc_body,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [42726] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    STATE(1612), 1,
      sym_heredoc_body,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 25,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42781] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1613), 1,
      sym_heredoc_body,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [42852] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1614), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [42929] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1615), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [43006] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1616), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [43083] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1617), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [43160] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1618), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [43239] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1619), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [43316] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    STATE(1620), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43367] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    STATE(1621), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43418] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    STATE(1622), 1,
      sym_heredoc_body,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43477] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    STATE(1623), 1,
      sym_heredoc_body,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43538] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2497), 1,
      anon_sym_COMMA,
    STATE(1624), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43589] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2500), 1,
      anon_sym_EQ_GT,
    STATE(1625), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2128), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [43668] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    STATE(1626), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43719] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    STATE(1627), 1,
      sym_heredoc_body,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43776] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1628), 1,
      sym_heredoc_body,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43827] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1629), 1,
      sym_heredoc_body,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 26,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43882] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    STATE(1630), 1,
      sym_heredoc_body,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43945] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1179), 1,
      sym__string_start,
    STATE(1388), 1,
      sym_string,
    STATE(1631), 1,
      sym_heredoc_body,
    STATE(1634), 1,
      aux_sym_chained_string_repeat1,
    ACTIONS(1635), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1633), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44002] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2412), 1,
      anon_sym_AMP,
    ACTIONS(2416), 1,
      anon_sym_QMARK,
    ACTIONS(2418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2426), 1,
      anon_sym_GT_EQ,
    ACTIONS(2428), 1,
      anon_sym_CARET,
    ACTIONS(2434), 1,
      anon_sym_EQ_EQ,
    STATE(1632), 1,
      sym_heredoc_body,
    ACTIONS(2422), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2430), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2414), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2436), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44079] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    STATE(1624), 1,
      aux_sym_exceptions_repeat1,
    STATE(1633), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44132] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2504), 1,
      sym__string_start,
    STATE(1388), 1,
      sym_string,
    STATE(1634), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1639), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1637), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44187] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1179), 1,
      sym__string_start,
    STATE(1388), 1,
      sym_string,
    STATE(1631), 1,
      aux_sym_chained_string_repeat1,
    STATE(1635), 1,
      sym_heredoc_body,
    ACTIONS(1443), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1441), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44244] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1636), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44295] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1637), 1,
      sym_heredoc_body,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44354] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    STATE(1638), 1,
      sym_heredoc_body,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44419] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1639), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 12,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [44496] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1640), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44547] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1641), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44626] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1642), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44675] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1643), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44754] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2475), 1,
      anon_sym_QMARK,
    ACTIONS(2477), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2479), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1644), 1,
      sym_heredoc_body,
    ACTIONS(2481), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 11,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [44833] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1645), 1,
      sym_heredoc_body,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44890] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    STATE(1646), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44943] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1633), 1,
      aux_sym_exceptions_repeat1,
    STATE(1647), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45022] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_STAR_STAR,
    STATE(1648), 1,
      sym_heredoc_body,
    ACTIONS(2432), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 27,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45075] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1649), 1,
      sym_heredoc_body,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45148] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2465), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2467), 1,
      anon_sym_PIPE,
    ACTIONS(2469), 1,
      anon_sym_AMP,
    ACTIONS(2485), 1,
      anon_sym_GT_EQ,
    ACTIONS(2487), 1,
      anon_sym_CARET,
    ACTIONS(2493), 1,
      anon_sym_EQ_EQ,
    STATE(1650), 1,
      sym_heredoc_body,
    ACTIONS(2483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2489), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2471), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2491), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45221] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1651), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45270] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1652), 1,
      sym_heredoc_body,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 31,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45319] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1653), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 30,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45370] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    STATE(1654), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45420] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    STATE(1655), 1,
      sym_heredoc_body,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45474] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    STATE(1656), 1,
      sym_heredoc_body,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45530] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1657), 1,
      sym_heredoc_body,
    STATE(1681), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45580] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1658), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45656] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1659), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45732] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    STATE(1660), 1,
      sym_heredoc_body,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 26,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45784] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1661), 1,
      sym_heredoc_body,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45854] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1662), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [45930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2541), 1,
      anon_sym_EQ,
    STATE(1663), 1,
      sym_heredoc_body,
    ACTIONS(2539), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2537), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [45982] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1664), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46058] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    STATE(1665), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46108] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1666), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2223), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46184] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1667), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2206), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46260] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1668), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2216), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46336] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1669), 1,
      sym_heredoc_body,
    STATE(1681), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [46414] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    STATE(1670), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 29,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46464] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    STATE(1671), 1,
      sym_heredoc_body,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46522] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1672), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2218), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46598] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1673), 1,
      sym_heredoc_body,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [46668] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_COMMA,
    STATE(1674), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46718] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1675), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46794] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_DOT,
    ACTIONS(2578), 1,
      anon_sym_LBRACK,
    ACTIONS(2580), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(2582), 1,
      anon_sym_AMP_DOT,
    STATE(1676), 1,
      sym_heredoc_body,
    ACTIONS(1750), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1746), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46852] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    STATE(1677), 1,
      sym_heredoc_body,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46914] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1678), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [46990] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1679), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [47064] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2511), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_QMARK,
    ACTIONS(2517), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2519), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2525), 1,
      anon_sym_GT_EQ,
    ACTIONS(2527), 1,
      anon_sym_CARET,
    ACTIONS(2533), 1,
      anon_sym_EQ_EQ,
    STATE(1680), 1,
      sym_heredoc_body,
    ACTIONS(2521), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2523), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [47140] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_COMMA,
    STATE(1674), 1,
      aux_sym_exceptions_repeat1,
    STATE(1681), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47192] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    STATE(1682), 1,
      sym_heredoc_body,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47245] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1683), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [47320] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1684), 1,
      sym_heredoc_body,
    ACTIONS(2588), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2586), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47369] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1685), 1,
      sym_heredoc_body,
    ACTIONS(1674), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1672), 26,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47418] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1686), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [47493] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2590), 1,
      anon_sym_EQ_GT,
    STATE(1687), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2128), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [47570] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1688), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [47645] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1689), 1,
      sym_heredoc_body,
    ACTIONS(1912), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(1910), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1690), 1,
      sym_heredoc_body,
    ACTIONS(1856), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(1854), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47743] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1691), 1,
      sym_heredoc_body,
    STATE(1708), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [47820] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1692), 1,
      sym_heredoc_body,
    STATE(1708), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [47899] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1693), 1,
      sym_heredoc_body,
    ACTIONS(2539), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2537), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [47948] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1694), 1,
      sym_heredoc_body,
    ACTIONS(1660), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON2,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(1658), 26,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47997] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1695), 1,
      sym_heredoc_body,
    STATE(1708), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [48076] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1696), 1,
      sym_heredoc_body,
    ACTIONS(997), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(999), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [48125] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1697), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [48194] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1698), 1,
      sym_heredoc_body,
    ACTIONS(1828), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(1826), 26,
      sym__simple_symbol,
      sym__symbol_start,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      sym_constant,
      sym_identifier,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [48243] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1699), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48318] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1700), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48393] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1701), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [48462] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_COMMA,
    STATE(1702), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48511] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1703), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48586] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1704), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [48659] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    STATE(1705), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48720] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    STATE(1706), 1,
      sym_heredoc_body,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 25,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48771] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    ACTIONS(2551), 1,
      anon_sym_QMARK,
    ACTIONS(2553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2561), 1,
      anon_sym_GT_EQ,
    ACTIONS(2563), 1,
      anon_sym_CARET,
    ACTIONS(2569), 1,
      anon_sym_EQ_EQ,
    STATE(1707), 1,
      sym_heredoc_body,
    ACTIONS(2557), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2549), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [48846] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1702), 1,
      aux_sym_exceptions_repeat1,
    STATE(1708), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48897] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    STATE(1709), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48952] = 5,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1708), 1,
      aux_sym_exceptions_repeat1,
    STATE(1710), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49001] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1708), 1,
      aux_sym_exceptions_repeat1,
    STATE(1711), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49078] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    STATE(1712), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49127] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2547), 1,
      anon_sym_AMP,
    STATE(1713), 1,
      sym_heredoc_body,
    ACTIONS(2559), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2565), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2567), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49184] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    STATE(1714), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49233] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_STAR_STAR,
    STATE(1715), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49282] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1708), 1,
      aux_sym_exceptions_repeat1,
    STATE(1716), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49333] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1717), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49407] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1718), 1,
      sym_heredoc_body,
    STATE(1738), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [49485] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1719), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2218), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49559] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2657), 1,
      anon_sym_COMMA,
    STATE(1720), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2661), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2659), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49641] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2663), 1,
      anon_sym_COMMA,
    STATE(1721), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49691] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1722), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49765] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1723), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [49839] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2666), 1,
      anon_sym_COMMA,
    STATE(1721), 1,
      aux_sym_exceptions_repeat1,
    STATE(1724), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49891] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    STATE(1725), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49939] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1726), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2216), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50013] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    STATE(1727), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50061] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1724), 1,
      aux_sym_exceptions_repeat1,
    STATE(1728), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [50139] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    STATE(1729), 1,
      sym_heredoc_body,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50193] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1730), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50267] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1724), 1,
      aux_sym_exceptions_repeat1,
    STATE(1731), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50317] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    STATE(1732), 1,
      sym_heredoc_body,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50377] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1733), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2223), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50451] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1734), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [50523] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1735), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50597] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1736), 1,
      sym_heredoc_body,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [50665] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1737), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [50739] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2698), 1,
      anon_sym_COMMA,
    STATE(1738), 1,
      sym_heredoc_body,
    STATE(1746), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50791] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1738), 1,
      aux_sym_exceptions_repeat1,
    STATE(1739), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50841] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    STATE(1740), 1,
      sym_heredoc_body,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50893] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    STATE(1741), 1,
      sym_heredoc_body,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50949] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    STATE(1742), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50997] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1743), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2206), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51071] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1744), 1,
      sym_heredoc_body,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [51139] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    STATE(1745), 1,
      sym_heredoc_body,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51189] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    STATE(1746), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51239] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1747), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51313] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_PIPE,
    ACTIONS(2594), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2596), 1,
      anon_sym_AMP,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_GT_EQ,
    ACTIONS(2612), 1,
      anon_sym_CARET,
    ACTIONS(2618), 1,
      anon_sym_EQ_EQ,
    STATE(1748), 1,
      sym_heredoc_body,
    ACTIONS(2606), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [51387] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    STATE(1749), 1,
      sym_heredoc_body,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51438] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    STATE(1750), 1,
      sym_heredoc_body,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51489] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1751), 1,
      sym_heredoc_body,
    STATE(1833), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [51566] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1752), 1,
      sym_heredoc_body,
    STATE(1805), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51615] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1753), 1,
      sym_heredoc_body,
    STATE(1833), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51664] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(171), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1754), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51747] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(183), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1755), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51830] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1756), 1,
      sym_heredoc_body,
    STATE(1805), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [51907] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_COMMA,
    STATE(1757), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51956] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(182), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1758), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52039] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(185), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1759), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52122] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    STATE(1760), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52171] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1761), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [52246] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2806), 1,
      anon_sym_LPAREN2,
    STATE(1762), 1,
      sym_heredoc_body,
    ACTIONS(2800), 2,
      sym_constant,
      sym_identifier,
    STATE(359), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2804), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2802), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [52299] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1763), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [52374] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1764), 1,
      sym_heredoc_body,
    STATE(1830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2071), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [52451] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    STATE(1765), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 12,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [52518] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(180), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1766), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52601] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(192), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1767), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52684] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    STATE(1768), 1,
      sym_heredoc_body,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52735] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_LPAREN2,
    STATE(1769), 1,
      sym_heredoc_body,
    ACTIONS(2860), 2,
      sym_constant,
      sym_identifier,
    STATE(2206), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2384), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2382), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [52788] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN2,
    STATE(1770), 1,
      sym_heredoc_body,
    ACTIONS(2864), 2,
      sym_constant,
      sym_identifier,
    STATE(891), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2868), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2866), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [52841] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    STATE(1771), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52890] = 15,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    STATE(1772), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 12,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [52957] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1773), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53032] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1774), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [53105] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1775), 1,
      sym_heredoc_body,
    ACTIONS(2878), 2,
      sym_constant,
      sym_identifier,
    STATE(263), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2882), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2880), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [53158] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1776), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53233] = 17,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1777), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 9,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [53304] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    STATE(1778), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53363] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    STATE(1779), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53416] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1609), 1,
      anon_sym_LPAREN2,
    STATE(1780), 1,
      sym_heredoc_body,
    ACTIONS(2886), 2,
      sym_constant,
      sym_identifier,
    STATE(1041), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2890), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2888), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [53469] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LPAREN2,
    STATE(1781), 1,
      sym_heredoc_body,
    ACTIONS(2892), 2,
      sym_constant,
      sym_identifier,
    STATE(319), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2896), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2894), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [53522] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1782), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53597] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1783), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [53672] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    STATE(1784), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53721] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    STATE(1785), 1,
      sym_heredoc_body,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53778] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    STATE(1786), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53827] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(1787), 1,
      sym_heredoc_body,
    ACTIONS(2900), 2,
      sym_constant,
      sym_identifier,
    STATE(2177), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2904), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2902), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [53880] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    STATE(1788), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53927] = 9,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    STATE(1789), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53982] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    STATE(1790), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54029] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    STATE(1791), 1,
      sym_heredoc_body,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54078] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    STATE(1792), 1,
      sym_heredoc_body,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54133] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2908), 1,
      anon_sym_COMMA,
    STATE(1793), 1,
      sym_heredoc_body,
    STATE(1833), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54184] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    STATE(1794), 1,
      sym_heredoc_body,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54245] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1795), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [54318] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1796), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [54393] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1797), 1,
      sym_heredoc_body,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54462] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    STATE(1798), 1,
      sym_heredoc_body,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54515] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1799), 1,
      sym_heredoc_body,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54584] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1800), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [54659] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1801), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2661), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2064), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54736] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1802), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [54811] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1803), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [54886] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1804), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [54961] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    STATE(1805), 1,
      sym_heredoc_body,
    STATE(1822), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55012] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_LPAREN2,
    STATE(1806), 1,
      sym_heredoc_body,
    ACTIONS(2912), 2,
      sym_constant,
      sym_identifier,
    STATE(270), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2916), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2914), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [55065] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1807), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2302), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [55138] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1808), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [55211] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    STATE(1809), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55260] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    STATE(1810), 1,
      sym_heredoc_body,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55317] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2908), 1,
      anon_sym_COMMA,
    STATE(1811), 1,
      sym_heredoc_body,
    STATE(1833), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2071), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55396] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    STATE(1812), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55445] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    STATE(1813), 1,
      sym_heredoc_body,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55500] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    STATE(1814), 1,
      sym_heredoc_body,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55561] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1815), 1,
      sym_heredoc_body,
    STATE(1830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55610] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1816), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [55683] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_COMMA,
    STATE(1817), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55732] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1818), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [55807] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1819), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [55880] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1820), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2661), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2140), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55957] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1821), 1,
      sym_heredoc_body,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [56026] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    STATE(1822), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56075] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    STATE(1823), 1,
      sym_heredoc_body,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56128] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2635), 1,
      anon_sym_QMARK,
    ACTIONS(2637), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1824), 1,
      sym_heredoc_body,
    ACTIONS(2641), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56203] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2629), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2631), 1,
      anon_sym_AMP,
    ACTIONS(2645), 1,
      anon_sym_GT_EQ,
    ACTIONS(2647), 1,
      anon_sym_CARET,
    ACTIONS(2653), 1,
      anon_sym_EQ_EQ,
    STATE(1825), 1,
      sym_heredoc_body,
    ACTIONS(2643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2649), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2633), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2651), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2655), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [56272] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1826), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [56345] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(167), 1,
      anon_sym_LPAREN2,
    STATE(1827), 1,
      sym_heredoc_body,
    ACTIONS(2926), 2,
      sym_constant,
      sym_identifier,
    STATE(917), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2930), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2928), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [56398] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1828), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [56473] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    STATE(1829), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56520] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_COMMA,
    STATE(1817), 1,
      aux_sym_exceptions_repeat1,
    STATE(1830), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56571] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1831), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [56644] = 18,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2842), 1,
      anon_sym_AMP,
    ACTIONS(2848), 1,
      anon_sym_GT_EQ,
    ACTIONS(2850), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2870), 1,
      anon_sym_QMARK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1832), 1,
      sym_heredoc_body,
    ACTIONS(2846), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2852), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2844), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2854), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2858), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [56717] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2908), 1,
      anon_sym_COMMA,
    STATE(1757), 1,
      aux_sym_exceptions_repeat1,
    STATE(1833), 1,
      sym_heredoc_body,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56768] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_LPAREN2,
    STATE(1834), 1,
      sym_heredoc_body,
    ACTIONS(2934), 2,
      sym_constant,
      sym_identifier,
    STATE(1113), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2938), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2936), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [56821] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    STATE(1805), 1,
      aux_sym_exceptions_repeat1,
    STATE(1835), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56871] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_LPAREN2,
    STATE(1836), 1,
      sym_heredoc_body,
    ACTIONS(2940), 2,
      sym_constant,
      sym_identifier,
    STATE(659), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2944), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2942), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [56921] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2948), 1,
      anon_sym_COMMA,
    STATE(1837), 1,
      sym_heredoc_body,
    STATE(1838), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56971] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COMMA,
    STATE(1838), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57019] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_LPAREN2,
    STATE(1839), 1,
      sym_heredoc_body,
    ACTIONS(2953), 2,
      sym_constant,
      sym_identifier,
    STATE(825), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(2957), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2955), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [57069] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1837), 1,
      aux_sym_exceptions_repeat1,
    STATE(1840), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2071), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57145] = 22,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(198), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1841), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57225] = 22,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2741), 1,
      anon_sym_do,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(197), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(1842), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57305] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_EQ_GT,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1843), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2991), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2128), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57383] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    STATE(1844), 1,
      sym_heredoc_body,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57433] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    STATE(1845), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57481] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    STATE(1846), 1,
      sym_heredoc_body,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57537] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    STATE(1847), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57585] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1848), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2993), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2140), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57661] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1849), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57735] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1850), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [57809] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    STATE(1851), 1,
      sym_heredoc_body,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57863] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1852), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57937] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    STATE(1853), 1,
      sym_heredoc_body,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57997] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1854), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [58069] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1855), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58143] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1856), 1,
      sym_heredoc_body,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [58211] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    STATE(1857), 1,
      sym_heredoc_body,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58263] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1858), 1,
      sym_heredoc_body,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [58331] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1859), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [58405] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1860), 1,
      sym_heredoc_body,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [58473] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    STATE(1861), 1,
      sym_heredoc_body,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58525] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1862), 1,
      sym_heredoc_body,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [58593] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1863), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [58667] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1864), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [58739] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1837), 1,
      aux_sym_exceptions_repeat1,
    STATE(1865), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58787] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    STATE(1866), 1,
      sym_heredoc_body,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58847] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1867), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58921] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1868), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58995] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    STATE(1869), 1,
      sym_heredoc_body,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59049] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1870), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2993), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2995), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59125] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_LPAREN2,
    STATE(1871), 1,
      sym_heredoc_body,
    ACTIONS(2997), 2,
      sym_constant,
      sym_identifier,
    STATE(999), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(3001), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2999), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [59175] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    STATE(1872), 1,
      sym_heredoc_body,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59225] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    STATE(1873), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59273] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    STATE(1874), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59321] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    STATE(1875), 1,
      sym_heredoc_body,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59377] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    STATE(1876), 1,
      sym_heredoc_body,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59433] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    STATE(1877), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59481] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    STATE(1878), 1,
      sym_heredoc_body,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59535] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    STATE(1879), 1,
      sym_heredoc_body,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59595] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1880), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [59667] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    STATE(1881), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59715] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1882), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [59789] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1883), 1,
      sym_heredoc_body,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59857] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    STATE(1884), 1,
      sym_heredoc_body,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59907] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1885), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [59981] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    STATE(1886), 1,
      sym_heredoc_body,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60033] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1887), 1,
      sym_heredoc_body,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [60101] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_LPAREN2,
    STATE(1888), 1,
      sym_heredoc_body,
    ACTIONS(3003), 2,
      sym_constant,
      sym_identifier,
    STATE(1031), 2,
      sym_argument_list,
      sym_operator,
    ACTIONS(3007), 9,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3005), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [60151] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1889), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2109), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [60225] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1890), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2111), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [60299] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1891), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2218), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60375] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1892), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2216), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60451] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    STATE(1893), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60499] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1894), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [60573] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1895), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [60647] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    STATE(1896), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60695] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1897), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [60769] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1898), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [60843] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1899), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2223), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60919] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    STATE(1900), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60967] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1901), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [61041] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    STATE(1902), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2113), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [61115] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    STATE(1805), 1,
      aux_sym_exceptions_repeat1,
    STATE(1903), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2071), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61193] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1904), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [61267] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_PIPE,
    ACTIONS(2705), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2707), 1,
      anon_sym_AMP,
    ACTIONS(2711), 1,
      anon_sym_QMARK,
    ACTIONS(2713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2715), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2721), 1,
      anon_sym_GT_EQ,
    ACTIONS(2723), 1,
      anon_sym_CARET,
    ACTIONS(2729), 1,
      anon_sym_EQ_EQ,
    STATE(1905), 1,
      sym_heredoc_body,
    ACTIONS(2717), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2719), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2709), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2727), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2731), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2064), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [61341] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1906), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2140), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [61415] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1907), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2140), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61490] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1908), 1,
      sym_heredoc_body,
    ACTIONS(2749), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3011), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61565] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    STATE(1909), 1,
      sym_heredoc_body,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61624] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1910), 1,
      sym_heredoc_body,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [61695] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1911), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2993), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3013), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61770] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_PIPE,
    ACTIONS(2769), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2771), 1,
      anon_sym_AMP,
    ACTIONS(2775), 1,
      anon_sym_QMARK,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2785), 1,
      anon_sym_GT_EQ,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2793), 1,
      anon_sym_EQ_EQ,
    STATE(1912), 1,
      sym_heredoc_body,
    ACTIONS(2781), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2783), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2789), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2993), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2773), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2791), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3015), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2795), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61845] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1913), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2140), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61918] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1914), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2109), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61991] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    STATE(1915), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62038] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1916), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2064), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62111] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1917), 1,
      sym_heredoc_body,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62184] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1918), 1,
      sym_heredoc_body,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62257] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2666), 1,
      anon_sym_COMMA,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1724), 1,
      aux_sym_exceptions_repeat1,
    STATE(1919), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2071), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62334] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2820), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2826), 1,
      anon_sym_GT_EQ,
    ACTIONS(2828), 1,
      anon_sym_CARET,
    ACTIONS(2834), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2932), 1,
      anon_sym_COMMA,
    STATE(1830), 1,
      aux_sym_exceptions_repeat1,
    STATE(1920), 1,
      sym_heredoc_body,
    ACTIONS(2822), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2824), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2830), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2071), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2814), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2832), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2836), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62411] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_COMMA,
    STATE(1830), 1,
      aux_sym_exceptions_repeat1,
    STATE(1921), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62460] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(106), 1,
      sym__terminator,
    STATE(1922), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62537] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1923), 1,
      sym_heredoc_body,
    STATE(2282), 1,
      sym__terminator,
    ACTIONS(1187), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62614] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(1924), 1,
      sym_heredoc_body,
    STATE(1927), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62661] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(93), 1,
      sym__terminator,
    STATE(1925), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62738] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(97), 1,
      sym__terminator,
    STATE(1926), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62815] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_COMMA,
    STATE(1927), 1,
      sym_heredoc_body,
    STATE(1948), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2062), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2058), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62864] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_COMMA,
    STATE(1927), 1,
      aux_sym_exceptions_repeat1,
    STATE(1928), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62913] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1929), 1,
      sym_heredoc_body,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2105), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62986] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1930), 1,
      sym_heredoc_body,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [63053] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    STATE(1931), 1,
      sym_heredoc_body,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63104] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1932), 1,
      sym_heredoc_body,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [63171] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(1933), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2206), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63246] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1934), 1,
      sym_heredoc_body,
    STATE(2264), 1,
      sym__terminator,
    ACTIONS(1187), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63323] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1935), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3051), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3015), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63398] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1936), 1,
      sym_heredoc_body,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2109), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63471] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1937), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3051), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3013), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63546] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2666), 1,
      anon_sym_COMMA,
    STATE(1724), 1,
      aux_sym_exceptions_repeat1,
    STATE(1938), 1,
      sym_heredoc_body,
    ACTIONS(2103), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2071), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63595] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1939), 1,
      sym_heredoc_body,
    STATE(2247), 1,
      sym__terminator,
    ACTIONS(1187), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63672] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    STATE(1940), 1,
      sym_heredoc_body,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63725] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    STATE(1941), 1,
      sym_heredoc_body,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63774] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_PIPE,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    ACTIONS(2745), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2747), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2755), 1,
      anon_sym_GT_EQ,
    ACTIONS(2757), 1,
      anon_sym_CARET,
    ACTIONS(2763), 1,
      anon_sym_EQ_EQ,
    STATE(1942), 1,
      sym_heredoc_body,
    ACTIONS(2751), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2739), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2765), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63847] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    STATE(1943), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63894] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    STATE(1944), 1,
      sym_heredoc_body,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63949] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    STATE(1945), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63996] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    STATE(1946), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64043] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    STATE(1947), 1,
      sym_heredoc_body,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64096] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_COMMA,
    STATE(1948), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2069), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2064), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64143] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    STATE(1949), 1,
      sym_heredoc_body,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64202] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1950), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64275] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1951), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64348] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    STATE(1952), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64395] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1953), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2126), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [64466] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1954), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2105), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64539] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_COMMA,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1927), 1,
      aux_sym_exceptions_repeat1,
    STATE(1955), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2071), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64616] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1956), 1,
      sym_heredoc_body,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [64683] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1927), 1,
      aux_sym_exceptions_repeat1,
    STATE(1957), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2071), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64758] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    STATE(1958), 1,
      sym_heredoc_body,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64809] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1959), 1,
      sym_heredoc_body,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [64876] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_PIPE,
    ACTIONS(2963), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2965), 1,
      anon_sym_AMP,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2973), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2979), 1,
      anon_sym_GT_EQ,
    ACTIONS(2981), 1,
      anon_sym_CARET,
    ACTIONS(2987), 1,
      anon_sym_EQ_EQ,
    STATE(1960), 1,
      sym_heredoc_body,
    ACTIONS(2975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2983), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2967), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2985), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2989), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64949] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    STATE(1961), 1,
      sym_heredoc_body,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 20,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64998] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2737), 1,
      anon_sym_AMP,
    STATE(1962), 1,
      sym_heredoc_body,
    ACTIONS(2753), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2761), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65053] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_STAR_STAR,
    STATE(1963), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65100] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1964), 1,
      sym_heredoc_body,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65150] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1965), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [65216] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1966), 1,
      sym_heredoc_body,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3086), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65290] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3088), 1,
      anon_sym_PIPE,
    STATE(1967), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3015), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65364] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3090), 1,
      anon_sym_PIPE,
    STATE(1968), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3013), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65438] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1969), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65510] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1970), 1,
      sym_heredoc_body,
    STATE(2348), 1,
      sym__terminator,
    ACTIONS(1187), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65584] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1971), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2109), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65656] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1972), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2064), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65728] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    STATE(1973), 1,
      sym_heredoc_body,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65776] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    STATE(1974), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65822] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    STATE(1975), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65876] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    STATE(1976), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65922] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    STATE(1977), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65974] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    STATE(1978), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66032] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1979), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2126), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66102] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1980), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66174] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1981), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2105), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66246] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1982), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66298] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    STATE(1983), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66344] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    STATE(1984), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66402] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1985), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2126), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66472] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1986), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [66538] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1987), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2105), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66610] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1988), 1,
      sym_heredoc_body,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 19,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66658] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1989), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66704] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1990), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [66770] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    STATE(1991), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66824] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    STATE(1992), 1,
      sym_heredoc_body,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 17,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66874] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1993), 1,
      sym_heredoc_body,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [66940] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1994), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2109), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67012] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(1995), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2140), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67084] = 20,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(123), 1,
      sym__terminator,
    STATE(1996), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3031), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67158] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1997), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67204] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    STATE(1998), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67250] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(1999), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2111), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67322] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(2000), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67394] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3060), 1,
      anon_sym_AMP,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    ACTIONS(3066), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3074), 1,
      anon_sym_GT_EQ,
    ACTIONS(3076), 1,
      anon_sym_CARET,
    ACTIONS(3082), 1,
      anon_sym_EQ_EQ,
    STATE(2001), 1,
      sym_heredoc_body,
    ACTIONS(3070), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3072), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3078), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3062), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3080), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3084), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67466] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    ACTIONS(3019), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_AMP,
    ACTIONS(3025), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3029), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3037), 1,
      anon_sym_GT_EQ,
    ACTIONS(3039), 1,
      anon_sym_CARET,
    ACTIONS(3045), 1,
      anon_sym_EQ_EQ,
    STATE(2002), 1,
      sym_heredoc_body,
    ACTIONS(3033), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3041), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3023), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3043), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3047), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67538] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(2003), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3013), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67612] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    ACTIONS(2670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2672), 1,
      anon_sym_AMP,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2686), 1,
      anon_sym_GT_EQ,
    ACTIONS(2688), 1,
      anon_sym_CARET,
    ACTIONS(2694), 1,
      anon_sym_EQ_EQ,
    STATE(2004), 1,
      sym_heredoc_body,
    ACTIONS(2682), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2690), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3009), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3015), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2674), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2692), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2696), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67686] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    STATE(2005), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67737] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    STATE(2006), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67782] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3110), 1,
      anon_sym_COLON2,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2007), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67855] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3128), 1,
      anon_sym_COLON2,
    STATE(2008), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67928] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3138), 1,
      anon_sym_QMARK,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2009), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2111), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67999] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3160), 1,
      anon_sym_COLON2,
    STATE(2010), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68072] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2011), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68143] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3190), 1,
      anon_sym_COLON2,
    STATE(2012), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68216] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3192), 1,
      anon_sym_COLON2,
    STATE(2013), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68289] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2014), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2109), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68360] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_EQ_GT,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3138), 1,
      anon_sym_QMARK,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2015), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3194), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68433] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3196), 1,
      anon_sym_RPAREN,
    STATE(2016), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3198), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68506] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2017), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2111), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68577] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2018), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2109), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68648] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3200), 1,
      anon_sym_COLON2,
    STATE(2019), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68721] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3202), 1,
      anon_sym_COLON2,
    STATE(2020), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68794] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3204), 1,
      anon_sym_COLON2,
    STATE(2021), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68867] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2022), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2113), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68938] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2023), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2113), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69009] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3138), 1,
      anon_sym_QMARK,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2024), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2109), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69080] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    STATE(2025), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69125] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2026), 1,
      sym_heredoc_body,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69190] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    STATE(2027), 1,
      sym_heredoc_body,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69239] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2028), 1,
      sym_heredoc_body,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69304] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3206), 1,
      anon_sym_COLON2,
    STATE(2029), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69377] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3208), 1,
      anon_sym_COLON2,
    STATE(2030), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69450] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2031), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2105), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69521] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2032), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2111), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69592] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2033), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69657] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    STATE(2034), 1,
      sym_heredoc_body,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69706] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2035), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69771] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2036), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69842] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    STATE(2037), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(2126), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69911] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    STATE(2038), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 13,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69968] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    STATE(2039), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70013] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    STATE(2040), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70066] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    STATE(2041), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70111] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    STATE(2042), 1,
      sym_heredoc_body,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      sym__binary_minus,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70158] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3210), 1,
      anon_sym_COLON2,
    STATE(2043), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70231] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2044), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2126), 4,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70300] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    STATE(2045), 1,
      sym_heredoc_body,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 13,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70357] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    STATE(2046), 1,
      sym_heredoc_body,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70408] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    STATE(2047), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70453] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    STATE(2048), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70498] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    STATE(2049), 1,
      sym_heredoc_body,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70551] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    STATE(2050), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70622] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    STATE(2051), 1,
      sym_heredoc_body,
    ACTIONS(2138), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2113), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70667] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    STATE(2052), 1,
      sym_heredoc_body,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70714] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3212), 1,
      anon_sym_COLON2,
    STATE(2053), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70787] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3214), 1,
      anon_sym_RPAREN,
    STATE(2054), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3198), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70860] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3216), 1,
      anon_sym_COLON2,
    STATE(2055), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70933] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3218), 1,
      anon_sym_COLON2,
    STATE(2056), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71006] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2057), 1,
      sym_heredoc_body,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [71071] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    STATE(2058), 1,
      sym_heredoc_body,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 16,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71120] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3220), 1,
      anon_sym_COLON2,
    STATE(2059), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71193] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2060), 1,
      sym_heredoc_body,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2105), 7,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [71258] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3222), 1,
      anon_sym_COLON2,
    STATE(2061), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71331] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3138), 1,
      anon_sym_QMARK,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2062), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2105), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71402] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    STATE(2063), 1,
      sym_heredoc_body,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 18,
      sym__binary_minus,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71449] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3224), 1,
      anon_sym_COLON2,
    STATE(2064), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71522] = 18,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2065), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2126), 4,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71591] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3226), 1,
      anon_sym_RPAREN,
    STATE(2066), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3198), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71664] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3138), 1,
      anon_sym_QMARK,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2067), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71735] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3138), 1,
      anon_sym_QMARK,
    ACTIONS(3140), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3148), 1,
      anon_sym_GT_EQ,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    ACTIONS(3156), 1,
      anon_sym_EQ_EQ,
    STATE(2068), 1,
      sym_heredoc_body,
    ACTIONS(3144), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(2113), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3136), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3158), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71806] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    STATE(2069), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71851] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3228), 1,
      anon_sym_COLON2,
    STATE(2070), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71924] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    ACTIONS(3150), 1,
      anon_sym_CARET,
    STATE(2071), 1,
      sym_heredoc_body,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 13,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71981] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3134), 1,
      anon_sym_AMP,
    STATE(2072), 1,
      sym_heredoc_body,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72034] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    STATE(2073), 1,
      sym_heredoc_body,
    ACTIONS(3146), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3152), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3154), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 14,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72085] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_STAR_STAR,
    STATE(2074), 1,
      sym_heredoc_body,
    ACTIONS(2107), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2105), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72130] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3230), 1,
      anon_sym_COLON2,
    STATE(2075), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72200] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3232), 1,
      anon_sym_COLON2,
    STATE(2076), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72270] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3234), 1,
      anon_sym_COLON2,
    STATE(2077), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72340] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 1,
      anon_sym_AMP,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    ACTIONS(3170), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3172), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3178), 1,
      anon_sym_GT_EQ,
    ACTIONS(3180), 1,
      anon_sym_CARET,
    ACTIONS(3186), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3236), 1,
      anon_sym_RPAREN,
    STATE(2078), 1,
      sym_heredoc_body,
    ACTIONS(3174), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3176), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3182), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3198), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3166), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3184), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3188), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72410] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3238), 1,
      anon_sym_COLON2,
    STATE(2079), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72480] = 19,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 1,
      anon_sym_AMP,
    ACTIONS(3108), 1,
      anon_sym_QMARK,
    ACTIONS(3112), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3114), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3120), 1,
      anon_sym_GT_EQ,
    ACTIONS(3122), 1,
      anon_sym_CARET,
    ACTIONS(3124), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3240), 1,
      anon_sym_COLON2,
    STATE(2080), 1,
      sym_heredoc_body,
    ACTIONS(3094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3096), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3116), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3098), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3106), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3126), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2081), 1,
      sym_heredoc_body,
    ACTIONS(1477), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72587] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2082), 1,
      sym_heredoc_body,
    ACTIONS(1507), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72624] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2083), 1,
      sym_heredoc_body,
    ACTIONS(1511), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72661] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2084), 1,
      sym_heredoc_body,
    ACTIONS(1519), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72698] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2085), 1,
      sym_heredoc_body,
    ACTIONS(1515), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72735] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2086), 1,
      sym_heredoc_body,
    ACTIONS(1487), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72772] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2087), 1,
      sym_heredoc_body,
    ACTIONS(1453), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72809] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2088), 1,
      sym_heredoc_body,
    ACTIONS(1503), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72846] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2089), 1,
      sym_heredoc_body,
    ACTIONS(1495), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72883] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2090), 1,
      sym_heredoc_body,
    ACTIONS(1473), 25,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72920] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_do,
    STATE(2091), 1,
      sym_heredoc_body,
    STATE(2103), 1,
      sym_block,
    STATE(2109), 1,
      sym_do_block,
    ACTIONS(3242), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [72963] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(2092), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3248), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73000] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3255), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2093), 1,
      sym_heredoc_body,
    ACTIONS(3253), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73039] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    STATE(2094), 1,
      sym_heredoc_body,
    STATE(2103), 1,
      sym_block,
    STATE(2109), 1,
      sym_do_block,
    ACTIONS(3242), 20,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73080] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3255), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2095), 1,
      sym_heredoc_body,
    ACTIONS(3257), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73119] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2096), 1,
      sym_heredoc_body,
    ACTIONS(2128), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73153] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2097), 1,
      sym_heredoc_body,
    ACTIONS(3248), 22,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73187] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2098), 1,
      sym_heredoc_body,
    ACTIONS(2586), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2588), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73222] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2099), 1,
      sym_heredoc_body,
    ACTIONS(999), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(997), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73257] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3259), 1,
      anon_sym_COMMA,
    STATE(2100), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3248), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73292] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_COMMA,
    STATE(2100), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2101), 1,
      sym_heredoc_body,
    ACTIONS(3253), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73329] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2102), 1,
      sym_heredoc_body,
    ACTIONS(3257), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73362] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2103), 1,
      sym_heredoc_body,
    ACTIONS(3264), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73395] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2104), 1,
      sym_heredoc_body,
    ACTIONS(1854), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(1856), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73430] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2105), 1,
      sym_heredoc_body,
    ACTIONS(1826), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(1828), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73465] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_COMMA,
    STATE(2101), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2106), 1,
      sym_heredoc_body,
    ACTIONS(3257), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73502] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2107), 1,
      sym_heredoc_body,
    ACTIONS(2537), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2539), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2108), 1,
      sym_heredoc_body,
    ACTIONS(1910), 8,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(1912), 13,
      anon_sym_STAR,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [73572] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2109), 1,
      sym_heredoc_body,
    ACTIONS(3264), 21,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73605] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2110), 1,
      sym_heredoc_body,
    ACTIONS(3266), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73636] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2111), 1,
      sym_heredoc_body,
    ACTIONS(3268), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73667] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2112), 1,
      sym_heredoc_body,
    ACTIONS(3270), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73698] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2113), 1,
      sym_heredoc_body,
    ACTIONS(3272), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73729] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2114), 1,
      sym_heredoc_body,
    ACTIONS(3274), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73760] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2115), 1,
      sym_heredoc_body,
    ACTIONS(3276), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73791] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2116), 1,
      sym_heredoc_body,
    ACTIONS(3278), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73822] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2117), 1,
      sym_heredoc_body,
    ACTIONS(3280), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73853] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2118), 1,
      sym_heredoc_body,
    ACTIONS(2302), 19,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [73884] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2119), 1,
      sym_heredoc_body,
    ACTIONS(999), 18,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [73914] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2120), 1,
      sym_heredoc_body,
    ACTIONS(3282), 18,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [73944] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2121), 1,
      sym_heredoc_body,
    ACTIONS(3286), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3284), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [73975] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2122), 1,
      sym_heredoc_body,
    ACTIONS(3288), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74004] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2123), 1,
      sym_heredoc_body,
    ACTIONS(3290), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_COMMA,
    STATE(2124), 1,
      sym_heredoc_body,
    STATE(2126), 1,
      aux_sym_undef_repeat1,
    ACTIONS(3292), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74066] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3296), 1,
      sym_identifier,
    ACTIONS(3298), 1,
      anon_sym_LBRACE,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3308), 1,
      anon_sym_do,
    STATE(2125), 1,
      sym_heredoc_body,
    STATE(2630), 1,
      sym__simple_formal_parameter,
    STATE(1108), 2,
      sym_do_block,
      sym_block,
    STATE(2627), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74115] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3310), 1,
      anon_sym_COMMA,
    STATE(2126), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(3282), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74146] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3296), 1,
      sym_identifier,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3313), 1,
      anon_sym_LBRACE,
    ACTIONS(3315), 1,
      anon_sym_do,
    STATE(2127), 1,
      sym_heredoc_body,
    STATE(2630), 1,
      sym__simple_formal_parameter,
    STATE(1453), 2,
      sym_do_block,
      sym_block,
    STATE(2629), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74195] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2128), 1,
      sym_heredoc_body,
    ACTIONS(3317), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74224] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_COMMA,
    STATE(2124), 1,
      aux_sym_undef_repeat1,
    STATE(2129), 1,
      sym_heredoc_body,
    ACTIONS(3319), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74257] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2130), 1,
      sym_heredoc_body,
    ACTIONS(3286), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3321), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74288] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2131), 1,
      sym_heredoc_body,
    ACTIONS(3286), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3323), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74319] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2132), 1,
      sym_heredoc_body,
    ACTIONS(3286), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3325), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3327), 1,
      anon_sym_EQ,
    STATE(2133), 1,
      sym_heredoc_body,
    ACTIONS(2537), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74381] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3296), 1,
      sym_identifier,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3331), 1,
      anon_sym_do,
    STATE(2134), 1,
      sym_heredoc_body,
    STATE(2630), 1,
      sym__simple_formal_parameter,
    STATE(2634), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2637), 2,
      sym_do_block,
      sym_block,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74430] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2135), 1,
      sym_heredoc_body,
    ACTIONS(3333), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74459] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2136), 1,
      sym_heredoc_body,
    ACTIONS(3286), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3335), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74490] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2137), 1,
      sym_heredoc_body,
    ACTIONS(3286), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3337), 15,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74521] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2138), 1,
      sym_heredoc_body,
    ACTIONS(3325), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2139), 1,
      sym_heredoc_body,
    ACTIONS(3339), 17,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [74579] = 13,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3296), 1,
      sym_identifier,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3341), 1,
      anon_sym_LBRACE,
    ACTIONS(3343), 1,
      anon_sym_do,
    STATE(2140), 1,
      sym_heredoc_body,
    STATE(2630), 1,
      sym__simple_formal_parameter,
    STATE(1409), 2,
      sym_do_block,
      sym_block,
    STATE(2681), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74625] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3345), 1,
      sym_identifier,
    ACTIONS(3347), 1,
      anon_sym_LPAREN,
    ACTIONS(3349), 1,
      anon_sym_STAR,
    ACTIONS(3351), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3353), 1,
      anon_sym_AMP,
    STATE(61), 1,
      sym_parameters,
    STATE(95), 1,
      sym__terminator,
    STATE(2141), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      sym__simple_formal_parameter,
    STATE(2707), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2678), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74673] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3345), 1,
      sym_identifier,
    ACTIONS(3347), 1,
      anon_sym_LPAREN,
    ACTIONS(3349), 1,
      anon_sym_STAR,
    ACTIONS(3351), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3353), 1,
      anon_sym_AMP,
    STATE(52), 1,
      sym_parameters,
    STATE(99), 1,
      sym__terminator,
    STATE(2142), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      sym__simple_formal_parameter,
    STATE(2713), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2678), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74721] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3345), 1,
      sym_identifier,
    ACTIONS(3347), 1,
      anon_sym_LPAREN,
    ACTIONS(3349), 1,
      anon_sym_STAR,
    ACTIONS(3351), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3353), 1,
      anon_sym_AMP,
    STATE(42), 1,
      sym_parameters,
    STATE(109), 1,
      sym__terminator,
    STATE(2143), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      sym__simple_formal_parameter,
    STATE(2724), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2678), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74769] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_COMMA,
    ACTIONS(3359), 1,
      anon_sym_PIPE,
    ACTIONS(3361), 1,
      anon_sym_SEMI,
    STATE(2144), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2619), 1,
      sym__formal_parameter,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74819] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3363), 1,
      anon_sym_COMMA,
    ACTIONS(3365), 1,
      anon_sym_PIPE,
    ACTIONS(3367), 1,
      anon_sym_SEMI,
    STATE(2145), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2557), 1,
      sym__formal_parameter,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74869] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3369), 1,
      anon_sym_PIPE,
    ACTIONS(3371), 1,
      anon_sym_SEMI,
    STATE(2146), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [74916] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    STATE(933), 1,
      sym__terminator,
    STATE(2147), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(3373), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [74957] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3385), 1,
      anon_sym_PIPE,
    ACTIONS(3387), 1,
      anon_sym_SEMI,
    STATE(2148), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75004] = 13,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3345), 1,
      sym_identifier,
    ACTIONS(3347), 1,
      anon_sym_LPAREN,
    ACTIONS(3349), 1,
      anon_sym_STAR,
    ACTIONS(3351), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3353), 1,
      anon_sym_AMP,
    STATE(75), 1,
      sym_parameters,
    STATE(128), 1,
      sym__terminator,
    STATE(2149), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      sym__simple_formal_parameter,
    STATE(2773), 1,
      sym_bare_parameters,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2678), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75049] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3389), 1,
      anon_sym_PIPE,
    ACTIONS(3391), 1,
      anon_sym_SEMI,
    STATE(2150), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75096] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3393), 1,
      anon_sym_LT,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(108), 1,
      sym__terminator,
    STATE(2151), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    STATE(2717), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75143] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3393), 1,
      anon_sym_LT,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(110), 1,
      sym__terminator,
    STATE(2152), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    STATE(2737), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75190] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_SEMI,
    STATE(2153), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75237] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3393), 1,
      anon_sym_LT,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(112), 1,
      sym__terminator,
    STATE(2154), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    STATE(2722), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75284] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    STATE(933), 1,
      sym__terminator,
    STATE(2155), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(455), 7,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [75325] = 13,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3393), 1,
      anon_sym_LT,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(125), 1,
      sym__terminator,
    STATE(2156), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    STATE(2783), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75369] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(2157), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    ACTIONS(111), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75407] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    ACTIONS(3401), 1,
      anon_sym_end,
    STATE(114), 1,
      sym__terminator,
    STATE(2158), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75451] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    ACTIONS(3403), 1,
      anon_sym_end,
    STATE(82), 1,
      sym__terminator,
    STATE(2159), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75495] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(3407), 1,
      anon_sym_RPAREN,
    STATE(2160), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2715), 1,
      sym__formal_parameter,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75539] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    ACTIONS(3409), 1,
      anon_sym_end,
    STATE(113), 1,
      sym__terminator,
    STATE(2161), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75583] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(3411), 1,
      anon_sym_RPAREN,
    STATE(2162), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2685), 1,
      sym__formal_parameter,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75627] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(3413), 1,
      anon_sym_RPAREN,
    STATE(2163), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2690), 1,
      sym__formal_parameter,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75671] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_LPAREN2,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_do,
    STATE(2164), 1,
      sym_heredoc_body,
    STATE(2188), 1,
      sym_argument_list,
    STATE(2345), 1,
      sym_block,
    STATE(2353), 1,
      sym_do_block,
    ACTIONS(111), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75708] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3405), 1,
      sym_identifier,
    STATE(2165), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75749] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3355), 1,
      sym_identifier,
    STATE(2166), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75790] = 12,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    ACTIONS(3415), 1,
      anon_sym_end,
    STATE(124), 1,
      sym__terminator,
    STATE(2167), 1,
      sym_heredoc_body,
    STATE(2172), 1,
      sym_argument_list,
    STATE(2294), 1,
      sym_do_block,
    STATE(2295), 1,
      sym_block,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(111), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [75831] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_STAR,
    ACTIONS(3304), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3306), 1,
      anon_sym_AMP,
    ACTIONS(3417), 1,
      sym_identifier,
    STATE(2168), 1,
      sym_heredoc_body,
    STATE(2389), 1,
      sym__simple_formal_parameter,
    STATE(2396), 1,
      sym__formal_parameter,
    STATE(2466), 1,
      sym_parameters,
    STATE(2422), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75872] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3345), 1,
      sym_identifier,
    ACTIONS(3349), 1,
      anon_sym_STAR,
    ACTIONS(3351), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3353), 1,
      anon_sym_AMP,
    ACTIONS(3419), 1,
      anon_sym_LPAREN,
    STATE(2169), 1,
      sym_heredoc_body,
    STATE(2674), 1,
      sym__formal_parameter,
    STATE(2675), 1,
      sym_parameters,
    STATE(2684), 1,
      sym__simple_formal_parameter,
    STATE(2678), 5,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [75913] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_LT,
    STATE(108), 1,
      sym__terminator,
    STATE(2170), 1,
      sym_heredoc_body,
    STATE(2717), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [75945] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2171), 1,
      sym_heredoc_body,
    ACTIONS(1009), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LT,
      anon_sym_end,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [75969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(2172), 1,
      sym_heredoc_body,
    STATE(2256), 1,
      sym_do_block,
    STATE(2304), 1,
      sym_block,
    ACTIONS(1433), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [76001] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_LT,
    STATE(112), 1,
      sym__terminator,
    STATE(2173), 1,
      sym_heredoc_body,
    STATE(2722), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76033] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_LT,
    STATE(110), 1,
      sym__terminator,
    STATE(2174), 1,
      sym_heredoc_body,
    STATE(2737), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76065] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2175), 1,
      sym_heredoc_body,
    ACTIONS(1013), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LT,
      anon_sym_end,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76089] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_end,
    STATE(113), 1,
      sym__terminator,
    STATE(2176), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2177), 1,
      sym_heredoc_body,
    ACTIONS(1025), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76141] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    ACTIONS(3423), 1,
      anon_sym_do,
    STATE(2178), 1,
      sym_heredoc_body,
    STATE(2232), 1,
      sym_block,
    STATE(2234), 1,
      sym_do_block,
    ACTIONS(3242), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [76170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2179), 1,
      sym_heredoc_body,
    ACTIONS(1009), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76193] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_heredoc_body,
    STATE(2232), 1,
      sym_block,
    STATE(2234), 1,
      sym_do_block,
    ACTIONS(3242), 9,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76220] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2181), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3325), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2182), 1,
      sym_heredoc_body,
    ACTIONS(999), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76268] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_COMMA,
    STATE(2183), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(3282), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76293] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    STATE(2184), 1,
      sym_heredoc_body,
    STATE(2191), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3253), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2185), 1,
      sym_heredoc_body,
    ACTIONS(909), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76341] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3432), 1,
      anon_sym_COMMA,
    STATE(2183), 1,
      aux_sym_undef_repeat1,
    STATE(2186), 1,
      sym_heredoc_body,
    ACTIONS(3292), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2187), 1,
      sym_heredoc_body,
    ACTIONS(1013), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76391] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    ACTIONS(3246), 1,
      anon_sym_do,
    STATE(2188), 1,
      sym_heredoc_body,
    STATE(2346), 1,
      sym_do_block,
    STATE(2355), 1,
      sym_block,
    ACTIONS(1433), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [76422] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_end,
    STATE(114), 1,
      sym__terminator,
    STATE(2189), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2190), 1,
      sym_heredoc_body,
    ACTIONS(1005), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76474] = 4,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3434), 1,
      anon_sym_COMMA,
    STATE(2191), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3248), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76497] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    STATE(2184), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2192), 1,
      sym_heredoc_body,
    ACTIONS(3257), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76522] = 7,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_LT,
    STATE(125), 1,
      sym__terminator,
    STATE(2193), 1,
      sym_heredoc_body,
    STATE(2783), 1,
      sym_superclass,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76551] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2194), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3284), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76576] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2195), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3337), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76601] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2196), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3335), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76626] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2197), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3323), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76651] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_end,
    STATE(82), 1,
      sym__terminator,
    STATE(2198), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76680] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2199), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3321), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2200), 1,
      sym_heredoc_body,
    ACTIONS(1021), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76728] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3432), 1,
      anon_sym_COMMA,
    STATE(2186), 1,
      aux_sym_undef_repeat1,
    STATE(2201), 1,
      sym_heredoc_body,
    ACTIONS(3319), 9,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3437), 1,
      anon_sym_EQ,
    STATE(2202), 1,
      sym_heredoc_body,
    ACTIONS(2537), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76780] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2203), 1,
      sym_heredoc_body,
    ACTIONS(1854), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76802] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(147), 1,
      sym__terminator,
    STATE(2204), 1,
      sym_heredoc_body,
    STATE(2534), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [76840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2205), 1,
      sym_heredoc_body,
    ACTIONS(1826), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76862] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2206), 1,
      sym_heredoc_body,
    ACTIONS(1025), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [76884] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(145), 1,
      sym__terminator,
    STATE(2207), 1,
      sym_heredoc_body,
    STATE(2492), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [76922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2208), 1,
      sym_heredoc_body,
    ACTIONS(2586), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [76944] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(148), 1,
      sym__terminator,
    STATE(2209), 1,
      sym_heredoc_body,
    STATE(2524), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [76982] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_if,
    ACTIONS(3445), 1,
      anon_sym_unless,
    ACTIONS(3447), 1,
      anon_sym_while,
    ACTIONS(3449), 1,
      anon_sym_until,
    ACTIONS(3451), 1,
      anon_sym_rescue,
    STATE(966), 1,
      sym__terminator,
    STATE(2210), 1,
      sym_heredoc_body,
    ACTIONS(455), 2,
      ts_builtin_sym_end,
      anon_sym___END__,
    ACTIONS(3441), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77018] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2211), 1,
      sym_heredoc_body,
    ACTIONS(1910), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [77040] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2212), 1,
      sym_heredoc_body,
    ACTIONS(1021), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77062] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_if,
    ACTIONS(3445), 1,
      anon_sym_unless,
    ACTIONS(3447), 1,
      anon_sym_while,
    ACTIONS(3449), 1,
      anon_sym_until,
    ACTIONS(3451), 1,
      anon_sym_rescue,
    STATE(966), 1,
      sym__terminator,
    STATE(2213), 1,
      sym_heredoc_body,
    ACTIONS(3373), 2,
      ts_builtin_sym_end,
      anon_sym___END__,
    ACTIONS(3441), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77098] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(142), 1,
      sym__terminator,
    STATE(2214), 1,
      sym_heredoc_body,
    STATE(2529), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77136] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2539), 1,
      anon_sym_STAR,
    ACTIONS(3327), 1,
      anon_sym_EQ,
    STATE(2215), 1,
      sym_heredoc_body,
    ACTIONS(909), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(2537), 6,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [77164] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2216), 1,
      sym_heredoc_body,
    ACTIONS(1005), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77186] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2217), 1,
      sym_heredoc_body,
    ACTIONS(2537), 10,
      sym__line_break,
      ts_builtin_sym_end,
      anon_sym___END__,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [77208] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2218), 1,
      sym_heredoc_body,
    ACTIONS(3248), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77228] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(140), 1,
      sym__terminator,
    STATE(2219), 1,
      sym_heredoc_body,
    STATE(2512), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77266] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_end,
    STATE(124), 1,
      sym__terminator,
    STATE(2220), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(909), 7,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77292] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2221), 1,
      sym_heredoc_body,
    ACTIONS(909), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_LPAREN2,
  [77314] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(139), 1,
      sym__terminator,
    STATE(2222), 1,
      sym_heredoc_body,
    STATE(2513), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77352] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(136), 1,
      sym__terminator,
    STATE(2223), 1,
      sym_heredoc_body,
    STATE(2522), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77390] = 4,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3453), 1,
      anon_sym_COMMA,
    STATE(2224), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3248), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [77411] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(150), 1,
      sym__terminator,
    STATE(2225), 1,
      sym_heredoc_body,
    STATE(2667), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77446] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2226), 1,
      sym_heredoc_body,
    ACTIONS(1515), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77465] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2227), 1,
      sym_heredoc_body,
    ACTIONS(1519), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77484] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2228), 1,
      sym_heredoc_body,
    ACTIONS(1495), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77503] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2229), 1,
      sym_heredoc_body,
    ACTIONS(3257), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77522] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2230), 1,
      sym_heredoc_body,
    ACTIONS(1503), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77541] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3456), 1,
      anon_sym_COMMA,
    STATE(2231), 1,
      sym_heredoc_body,
    STATE(2233), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(3257), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [77564] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2232), 1,
      sym_heredoc_body,
    ACTIONS(3264), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77583] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3456), 1,
      anon_sym_COMMA,
    STATE(2224), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2233), 1,
      sym_heredoc_body,
    ACTIONS(3253), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [77606] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2234), 1,
      sym_heredoc_body,
    ACTIONS(3264), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77625] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2235), 1,
      sym_heredoc_body,
    ACTIONS(1453), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77644] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2236), 1,
      sym_heredoc_body,
    ACTIONS(1473), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77663] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_STAR,
    STATE(2237), 1,
      sym_heredoc_body,
    ACTIONS(909), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(2537), 6,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [77688] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2238), 1,
      sym_heredoc_body,
    ACTIONS(1507), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77707] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2239), 1,
      sym_heredoc_body,
    ACTIONS(1511), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77726] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2240), 1,
      sym_heredoc_body,
    ACTIONS(1477), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [77745] = 11,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(151), 1,
      sym__terminator,
    STATE(2241), 1,
      sym_heredoc_body,
    STATE(2553), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [77780] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_end,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    STATE(2242), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2243), 1,
      sym_heredoc_body,
    ACTIONS(1473), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [77830] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3466), 1,
      anon_sym_end,
    STATE(2244), 1,
      sym_heredoc_body,
    STATE(2285), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77860] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3466), 1,
      anon_sym_end,
    STATE(2245), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [77890] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3470), 1,
      anon_sym_end,
    ACTIONS(3472), 1,
      anon_sym_when,
    STATE(2246), 1,
      sym_heredoc_body,
    STATE(2405), 1,
      aux_sym_case_repeat2,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2728), 1,
      sym_when,
    STATE(2854), 1,
      sym_else,
  [77924] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3474), 1,
      anon_sym_end,
    STATE(2247), 1,
      sym_heredoc_body,
    STATE(2271), 1,
      aux_sym_case_repeat1,
    STATE(2408), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2873), 1,
      sym_else,
  [77958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2248), 1,
      sym_heredoc_body,
    ACTIONS(111), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [77978] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    STATE(966), 1,
      sym__terminator,
    STATE(2249), 1,
      sym_heredoc_body,
    ACTIONS(3441), 2,
      sym__line_break,
      anon_sym_SEMI,
  [78010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2250), 1,
      sym_heredoc_body,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(3476), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [78032] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3480), 1,
      aux_sym_string_array_token1,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3486), 1,
      sym__string_end,
    STATE(2251), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2682), 1,
      aux_sym_symbol_array_repeat1,
  [78066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2252), 1,
      sym_heredoc_body,
    ACTIONS(1483), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78086] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3488), 1,
      aux_sym_string_array_token1,
    ACTIONS(3490), 1,
      sym__string_end,
    STATE(2253), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2716), 1,
      aux_sym_symbol_array_repeat1,
  [78120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2254), 1,
      sym_heredoc_body,
    ACTIONS(1469), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2255), 1,
      sym_heredoc_body,
    ACTIONS(1495), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2256), 1,
      sym_heredoc_body,
    ACTIONS(1461), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2257), 1,
      sym_heredoc_body,
    ACTIONS(1499), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2258), 1,
      sym_heredoc_body,
    ACTIONS(1477), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78220] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_end,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    STATE(2259), 1,
      sym_heredoc_body,
    STATE(2276), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78250] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3492), 1,
      anon_sym_end,
    STATE(2260), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2539), 1,
      anon_sym_STAR,
    ACTIONS(3327), 1,
      anon_sym_EQ,
    STATE(2261), 1,
      sym_heredoc_body,
    ACTIONS(2537), 6,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [78304] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3494), 1,
      aux_sym_string_array_token1,
    ACTIONS(3496), 1,
      sym__string_end,
    STATE(2262), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2702), 1,
      aux_sym_string_array_repeat1,
  [78338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3498), 1,
      aux_sym_string_array_token1,
    ACTIONS(3500), 1,
      sym__string_end,
    STATE(2263), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2696), 1,
      aux_sym_string_array_repeat1,
  [78372] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3502), 1,
      anon_sym_end,
    STATE(2264), 1,
      sym_heredoc_body,
    STATE(2305), 1,
      aux_sym_case_repeat1,
    STATE(2490), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2844), 1,
      sym_else,
  [78406] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3504), 1,
      anon_sym_end,
    STATE(2265), 1,
      sym_heredoc_body,
    STATE(2272), 1,
      aux_sym_case_repeat1,
    STATE(2447), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2798), 1,
      sym_else,
  [78440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3506), 1,
      aux_sym_string_array_token1,
    ACTIONS(3508), 1,
      sym__string_end,
    STATE(2266), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2703), 1,
      aux_sym_symbol_array_repeat1,
  [78474] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3510), 1,
      anon_sym_end,
    STATE(2246), 1,
      aux_sym_case_repeat1,
    STATE(2267), 1,
      sym_heredoc_body,
    STATE(2435), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2889), 1,
      sym_else,
  [78508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2268), 1,
      sym_heredoc_body,
    ACTIONS(1519), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78528] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3512), 1,
      aux_sym_string_array_token1,
    ACTIONS(3514), 1,
      sym__string_end,
    STATE(2269), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2705), 1,
      aux_sym_symbol_array_repeat1,
  [78562] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3516), 1,
      anon_sym_end,
    STATE(2270), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78592] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3518), 1,
      anon_sym_end,
    STATE(2271), 1,
      sym_heredoc_body,
    STATE(2477), 1,
      aux_sym_case_repeat2,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2728), 1,
      sym_when,
    STATE(2812), 1,
      sym_else,
  [78626] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3520), 1,
      anon_sym_end,
    STATE(2272), 1,
      sym_heredoc_body,
    STATE(2461), 1,
      aux_sym_case_repeat2,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2728), 1,
      sym_when,
    STATE(2845), 1,
      sym_else,
  [78660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2273), 1,
      sym_heredoc_body,
    ACTIONS(1511), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2274), 1,
      sym_heredoc_body,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(3522), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [78702] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3524), 1,
      anon_sym_end,
    STATE(2275), 1,
      sym_heredoc_body,
    STATE(2290), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78732] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3526), 1,
      anon_sym_end,
    STATE(2276), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78762] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3528), 1,
      anon_sym_end,
    STATE(2277), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2278), 1,
      sym_heredoc_body,
    ACTIONS(1453), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78812] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3528), 1,
      anon_sym_end,
    STATE(2270), 1,
      aux_sym__body_statement_repeat1,
    STATE(2279), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [78842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2280), 1,
      sym_heredoc_body,
    ACTIONS(1487), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78862] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3530), 1,
      aux_sym_string_array_token1,
    ACTIONS(3532), 1,
      sym__string_end,
    STATE(2281), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2697), 1,
      aux_sym_symbol_array_repeat1,
  [78896] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3534), 1,
      anon_sym_end,
    STATE(2282), 1,
      sym_heredoc_body,
    STATE(2314), 1,
      aux_sym_case_repeat1,
    STATE(2475), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2908), 1,
      sym_else,
  [78930] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3536), 1,
      anon_sym_end,
    STATE(2283), 1,
      sym_heredoc_body,
    STATE(2467), 1,
      aux_sym_case_repeat2,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2728), 1,
      sym_when,
    STATE(2907), 1,
      sym_else,
  [78964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2284), 1,
      sym_heredoc_body,
    ACTIONS(1503), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [78984] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3538), 1,
      anon_sym_end,
    STATE(2285), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79014] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3540), 1,
      aux_sym_string_array_token1,
    ACTIONS(3542), 1,
      sym__string_end,
    STATE(2286), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2677), 1,
      aux_sym_string_array_repeat1,
  [79048] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3544), 1,
      anon_sym_end,
    STATE(2287), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79078] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3546), 1,
      anon_sym_end,
    STATE(2288), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79108] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3548), 1,
      aux_sym_string_array_token1,
    ACTIONS(3550), 1,
      sym__string_end,
    STATE(2289), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2731), 1,
      aux_sym_string_array_repeat1,
  [79142] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3552), 1,
      anon_sym_end,
    STATE(2290), 1,
      sym_heredoc_body,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79172] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_end,
    ACTIONS(3556), 1,
      anon_sym_rescue,
    ACTIONS(3559), 1,
      anon_sym_else,
    ACTIONS(3562), 1,
      anon_sym_ensure,
    STATE(2291), 2,
      sym_heredoc_body,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79200] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3565), 1,
      aux_sym_string_array_token1,
    ACTIONS(3567), 1,
      sym__string_end,
    STATE(2292), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2734), 1,
      aux_sym_string_array_repeat1,
  [79234] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3569), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2293), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2294), 1,
      sym_heredoc_body,
    ACTIONS(1449), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2295), 1,
      sym_heredoc_body,
    ACTIONS(1449), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79304] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3571), 1,
      aux_sym_string_array_token1,
    ACTIONS(3573), 1,
      sym__string_end,
    STATE(2296), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2730), 1,
      aux_sym_symbol_array_repeat1,
  [79338] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3569), 1,
      anon_sym_end,
    STATE(2288), 1,
      aux_sym__body_statement_repeat1,
    STATE(2297), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79368] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3575), 1,
      anon_sym_end,
    STATE(2260), 1,
      aux_sym__body_statement_repeat1,
    STATE(2298), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79398] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3577), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2299), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79428] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3577), 1,
      anon_sym_end,
    STATE(2287), 1,
      aux_sym__body_statement_repeat1,
    STATE(2300), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79458] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3579), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2301), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2302), 1,
      sym_heredoc_body,
    ACTIONS(1507), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79508] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3575), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2303), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2304), 1,
      sym_heredoc_body,
    ACTIONS(1461), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79558] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3581), 1,
      anon_sym_end,
    STATE(2305), 1,
      sym_heredoc_body,
    STATE(2411), 1,
      aux_sym_case_repeat2,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2728), 1,
      sym_when,
    STATE(2853), 1,
      sym_else,
  [79592] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3583), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2306), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79622] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3583), 1,
      anon_sym_end,
    STATE(2301), 1,
      aux_sym__body_statement_repeat1,
    STATE(2307), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79652] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3585), 1,
      aux_sym_string_array_token1,
    ACTIONS(3587), 1,
      sym__string_end,
    STATE(2308), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2729), 1,
      aux_sym_string_array_repeat1,
  [79686] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3524), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2309), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79716] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_if,
    ACTIONS(3377), 1,
      anon_sym_unless,
    ACTIONS(3379), 1,
      anon_sym_while,
    ACTIONS(3381), 1,
      anon_sym_until,
    ACTIONS(3383), 1,
      anon_sym_rescue,
    STATE(933), 1,
      sym__terminator,
    STATE(2310), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [79748] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3589), 1,
      anon_sym_end,
    STATE(2283), 1,
      aux_sym_case_repeat1,
    STATE(2311), 1,
      sym_heredoc_body,
    STATE(2390), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2915), 1,
      sym_else,
  [79782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2312), 1,
      sym_heredoc_body,
    ACTIONS(1457), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2313), 1,
      sym_heredoc_body,
    ACTIONS(1491), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79822] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3591), 1,
      anon_sym_end,
    STATE(2314), 1,
      sym_heredoc_body,
    STATE(2449), 1,
      aux_sym_case_repeat2,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2728), 1,
      sym_when,
    STATE(2903), 1,
      sym_else,
  [79856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2315), 1,
      sym_heredoc_body,
    ACTIONS(1515), 8,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [79876] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3593), 1,
      aux_sym_string_array_token1,
    ACTIONS(3595), 1,
      sym__string_end,
    STATE(2263), 1,
      aux_sym__literal_contents,
    STATE(2316), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [79907] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3597), 1,
      sym_identifier,
    ACTIONS(3601), 1,
      anon_sym_do,
    STATE(2317), 1,
      sym_heredoc_body,
    ACTIONS(3599), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [79930] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3603), 1,
      sym_identifier,
    ACTIONS(3607), 1,
      anon_sym_do,
    STATE(2318), 1,
      sym_heredoc_body,
    ACTIONS(3605), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [79953] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3609), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2319), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [79980] = 4,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_COMMA,
    STATE(2320), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(3282), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [79999] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3614), 1,
      aux_sym_string_array_token1,
    ACTIONS(3616), 1,
      sym__string_end,
    STATE(2296), 1,
      aux_sym__literal_contents,
    STATE(2321), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80030] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3618), 1,
      aux_sym_string_array_token1,
    ACTIONS(3620), 1,
      sym__string_end,
    STATE(2281), 1,
      aux_sym__literal_contents,
    STATE(2322), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80061] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2323), 1,
      sym_heredoc_body,
    ACTIONS(3622), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3325), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80080] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_then,
    ACTIONS(3624), 1,
      anon_sym_COMMA,
    STATE(155), 1,
      sym__terminator,
    STATE(2324), 1,
      sym_heredoc_body,
    STATE(2382), 1,
      aux_sym_when_repeat1,
    STATE(2676), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [80109] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2325), 1,
      sym_heredoc_body,
    ACTIONS(3266), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [80126] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1365), 1,
      sym__string_start,
    STATE(2326), 1,
      sym_heredoc_body,
    STATE(2331), 1,
      aux_sym_chained_string_repeat1,
    STATE(2505), 1,
      sym_string,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3626), 1,
      aux_sym_string_array_token1,
    ACTIONS(3628), 1,
      sym__string_end,
    STATE(2327), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2778), 1,
      aux_sym_string_array_repeat1,
  [80182] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3630), 1,
      aux_sym_string_array_token1,
    ACTIONS(3632), 1,
      sym__string_end,
    STATE(2328), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
  [80213] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3634), 1,
      aux_sym_string_array_token1,
    ACTIONS(3636), 1,
      sym__string_end,
    STATE(2292), 1,
      aux_sym__literal_contents,
    STATE(2329), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3638), 1,
      aux_sym_string_array_token1,
    ACTIONS(3640), 1,
      sym__string_end,
    STATE(2330), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2781), 1,
      aux_sym_symbol_array_repeat1,
  [80275] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1365), 1,
      sym__string_start,
    STATE(2331), 1,
      sym_heredoc_body,
    STATE(2380), 1,
      aux_sym_chained_string_repeat1,
    STATE(2505), 1,
      sym_string,
    ACTIONS(1633), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80300] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2332), 1,
      sym_heredoc_body,
    ACTIONS(3642), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80321] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3644), 1,
      aux_sym_string_array_token1,
    ACTIONS(3646), 1,
      sym__string_end,
    STATE(2266), 1,
      aux_sym__literal_contents,
    STATE(2333), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80352] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2334), 1,
      sym_heredoc_body,
    ACTIONS(3268), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [80369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 1,
      anon_sym_EQ,
    STATE(2335), 1,
      sym_heredoc_body,
    ACTIONS(2537), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80388] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3650), 1,
      aux_sym_string_array_token1,
    ACTIONS(3652), 1,
      sym__string_end,
    STATE(2308), 1,
      aux_sym__literal_contents,
    STATE(2336), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80419] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3654), 1,
      anon_sym_end,
    STATE(2337), 1,
      sym_heredoc_body,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2526), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2939), 1,
      sym_else,
  [80450] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3656), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2338), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80477] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(977), 1,
      anon_sym_EQ_GT,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(152), 1,
      sym__terminator,
    STATE(2339), 1,
      sym_heredoc_body,
    STATE(2506), 1,
      sym_exception_variable,
    STATE(2578), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [80506] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3658), 1,
      anon_sym_end,
    STATE(2340), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80533] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3658), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2341), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80560] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3660), 1,
      aux_sym_string_array_token1,
    ACTIONS(3662), 1,
      sym__string_end,
    STATE(2253), 1,
      aux_sym__literal_contents,
    STATE(2342), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80591] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3664), 1,
      aux_sym_string_array_token1,
    ACTIONS(3666), 1,
      sym__string_end,
    STATE(2262), 1,
      aux_sym__literal_contents,
    STATE(2343), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80622] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3668), 1,
      anon_sym_end,
    STATE(2344), 1,
      sym_heredoc_body,
    STATE(2497), 1,
      aux_sym_case_repeat1,
    STATE(2509), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2926), 1,
      sym_else,
  [80653] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2345), 1,
      sym_heredoc_body,
    ACTIONS(1449), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80672] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2346), 1,
      sym_heredoc_body,
    ACTIONS(1461), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80691] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2347), 1,
      sym_heredoc_body,
    ACTIONS(1499), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80710] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3670), 1,
      anon_sym_end,
    STATE(2337), 1,
      aux_sym_case_repeat1,
    STATE(2348), 1,
      sym_heredoc_body,
    STATE(2537), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2934), 1,
      sym_else,
  [80741] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3672), 1,
      anon_sym_COMMA,
    STATE(2320), 1,
      aux_sym_undef_repeat1,
    STATE(2349), 1,
      sym_heredoc_body,
    ACTIONS(3292), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [80762] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3674), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2350), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80789] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3676), 1,
      anon_sym_end,
    STATE(2319), 1,
      aux_sym__body_statement_repeat1,
    STATE(2351), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80816] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3676), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2352), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [80843] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2353), 1,
      sym_heredoc_body,
    ACTIONS(1449), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80862] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3678), 1,
      aux_sym_string_array_token1,
    ACTIONS(3680), 1,
      sym__string_end,
    STATE(2289), 1,
      aux_sym__literal_contents,
    STATE(2354), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80893] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2355), 1,
      sym_heredoc_body,
    ACTIONS(1461), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80912] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2356), 1,
      sym_heredoc_body,
    ACTIONS(1483), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80931] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2357), 1,
      sym_heredoc_body,
    ACTIONS(1469), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [80950] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3682), 1,
      aux_sym_string_array_token1,
    ACTIONS(3684), 1,
      sym__string_end,
    STATE(2251), 1,
      aux_sym__literal_contents,
    STATE(2358), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [80981] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2359), 1,
      sym_heredoc_body,
    ACTIONS(3622), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3284), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81000] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2360), 1,
      sym_heredoc_body,
    ACTIONS(1457), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81019] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2361), 1,
      sym_heredoc_body,
    ACTIONS(3622), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3337), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81038] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2362), 1,
      sym_heredoc_body,
    ACTIONS(1491), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81057] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2363), 1,
      sym_heredoc_body,
    ACTIONS(3622), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3335), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81076] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2364), 1,
      sym_heredoc_body,
    ACTIONS(3270), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81093] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3686), 1,
      aux_sym_string_array_token1,
    ACTIONS(3688), 1,
      sym__string_end,
    STATE(2269), 1,
      aux_sym__literal_contents,
    STATE(2365), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [81124] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2366), 1,
      sym_heredoc_body,
    ACTIONS(3622), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3323), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81143] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2367), 1,
      sym_heredoc_body,
    ACTIONS(3278), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81160] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2368), 1,
      sym_heredoc_body,
    ACTIONS(3272), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81177] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3690), 1,
      anon_sym_end,
    STATE(2369), 1,
      sym_heredoc_body,
    STATE(2379), 1,
      aux_sym__body_statement_repeat1,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [81204] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2370), 1,
      sym_heredoc_body,
    ACTIONS(3622), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3321), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81223] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2371), 1,
      sym_heredoc_body,
    ACTIONS(3274), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81240] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2372), 1,
      sym_heredoc_body,
    ACTIONS(3280), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81257] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2373), 1,
      sym_heredoc_body,
    ACTIONS(3276), 8,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
  [81274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3692), 1,
      aux_sym_string_array_token1,
    ACTIONS(3694), 1,
      sym__string_end,
    STATE(2374), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2755), 1,
      aux_sym_symbol_array_repeat1,
  [81305] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3696), 1,
      aux_sym_string_array_token1,
    ACTIONS(3698), 1,
      sym__string_end,
    STATE(2375), 1,
      sym_heredoc_body,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2750), 1,
      aux_sym_string_array_repeat1,
  [81336] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2376), 1,
      sym_heredoc_body,
    ACTIONS(111), 7,
      sym__line_break,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81355] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3700), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3703), 1,
      aux_sym_string_array_token1,
    ACTIONS(3705), 1,
      sym_escape_sequence,
    ACTIONS(3708), 1,
      sym__string_content,
    ACTIONS(3711), 1,
      sym__string_end,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2377), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [81384] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3690), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2378), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [81411] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3713), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2379), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [81438] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3715), 1,
      sym__string_start,
    STATE(2505), 1,
      sym_string,
    STATE(2380), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(1637), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81461] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3718), 1,
      aux_sym_string_array_token1,
    ACTIONS(3720), 1,
      sym__string_end,
    STATE(2286), 1,
      aux_sym__literal_contents,
    STATE(2381), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [81492] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_then,
    ACTIONS(3624), 1,
      anon_sym_COMMA,
    STATE(158), 1,
      sym__terminator,
    STATE(2382), 1,
      sym_heredoc_body,
    STATE(2502), 1,
      aux_sym_when_repeat1,
    STATE(2694), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [81521] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3672), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      aux_sym_undef_repeat1,
    STATE(2383), 1,
      sym_heredoc_body,
    ACTIONS(3319), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [81542] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    ACTIONS(3722), 1,
      anon_sym_in,
    STATE(2384), 1,
      sym_heredoc_body,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81567] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3724), 1,
      anon_sym_end,
    STATE(2291), 1,
      aux_sym__body_statement_repeat1,
    STATE(2385), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [81594] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_rescue,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3464), 1,
      anon_sym_ensure,
    ACTIONS(3724), 1,
      anon_sym_end,
    STATE(2338), 1,
      aux_sym__body_statement_repeat1,
    STATE(2386), 1,
      sym_heredoc_body,
    STATE(2571), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [81621] = 10,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3468), 1,
      anon_sym_SEMI,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3726), 1,
      anon_sym_end,
    STATE(2344), 1,
      aux_sym_case_repeat1,
    STATE(2387), 1,
      sym_heredoc_body,
    STATE(2525), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2929), 1,
      sym_else,
  [81652] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3728), 1,
      aux_sym_string_array_token1,
    ACTIONS(3730), 1,
      sym__string_end,
    STATE(2377), 1,
      aux_sym__literal_contents,
    STATE(2388), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [81683] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2389), 1,
      sym_heredoc_body,
    ACTIONS(3732), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [81701] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3536), 1,
      anon_sym_end,
    STATE(2390), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2907), 1,
      sym_else,
  [81729] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(2391), 1,
      sym_heredoc_body,
    STATE(2613), 1,
      sym_argument_list,
    ACTIONS(295), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [81751] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3738), 1,
      sym__string_end,
    STATE(2392), 1,
      sym_heredoc_body,
    STATE(2423), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [81777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3740), 1,
      sym__string_end,
    STATE(2393), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [81803] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2394), 1,
      sym_heredoc_body,
    ACTIONS(1559), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [81821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3742), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2395), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [81847] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2396), 1,
      sym_heredoc_body,
    ACTIONS(3744), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [81865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3746), 1,
      sym__string_end,
    STATE(2397), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [81891] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_RBRACE,
    ACTIONS(3750), 1,
      anon_sym_if,
    ACTIONS(3752), 1,
      anon_sym_unless,
    ACTIONS(3754), 1,
      anon_sym_while,
    ACTIONS(3756), 1,
      anon_sym_until,
    ACTIONS(3758), 1,
      anon_sym_rescue,
    STATE(2398), 1,
      sym_heredoc_body,
  [81919] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3760), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2399), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [81945] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3762), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2400), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [81971] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3764), 1,
      sym__string_end,
    STATE(2401), 1,
      sym_heredoc_body,
    STATE(2420), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [81997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3766), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2402), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3768), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2403), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3770), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2404), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82075] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3772), 1,
      anon_sym_end,
    STATE(2405), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2815), 1,
      sym_else,
  [82103] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3774), 1,
      sym__string_end,
    STATE(2406), 1,
      sym_heredoc_body,
    STATE(2436), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82129] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2407), 1,
      sym_heredoc_body,
    ACTIONS(3776), 6,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [82147] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3518), 1,
      anon_sym_end,
    STATE(2408), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2812), 1,
      sym_else,
  [82175] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3778), 1,
      sym__string_end,
    STATE(2409), 1,
      sym_heredoc_body,
    STATE(2437), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3780), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2410), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82227] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3782), 1,
      anon_sym_end,
    STATE(2411), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2862), 1,
      sym_else,
  [82255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3784), 1,
      sym__string_end,
    STATE(2412), 1,
      sym_heredoc_body,
    STATE(2413), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82281] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3786), 1,
      sym__string_end,
    STATE(2413), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3788), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2414), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82333] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2415), 1,
      sym_heredoc_body,
    ACTIONS(1826), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [82349] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3790), 1,
      sym__string_end,
    STATE(2416), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82375] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3792), 1,
      sym__string_end,
    STATE(2417), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82401] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3794), 1,
      sym__string_end,
    STATE(2418), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82427] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2419), 1,
      sym_heredoc_body,
    ACTIONS(1854), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [82443] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3796), 1,
      sym__string_end,
    STATE(2420), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3798), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2421), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82495] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2422), 1,
      sym_heredoc_body,
    ACTIONS(3800), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [82513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3802), 1,
      sym__string_end,
    STATE(2423), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3804), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2424), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3806), 1,
      sym__string_end,
    STATE(2425), 1,
      sym_heredoc_body,
    STATE(2433), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82591] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(2426), 1,
      sym_heredoc_body,
    STATE(2608), 1,
      sym_argument_list,
    ACTIONS(299), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [82613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3808), 1,
      sym__string_end,
    STATE(2418), 1,
      aux_sym__literal_contents,
    STATE(2427), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82639] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3810), 1,
      sym__string_end,
    STATE(2417), 1,
      aux_sym__literal_contents,
    STATE(2428), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3812), 1,
      sym__string_end,
    STATE(2416), 1,
      aux_sym__literal_contents,
    STATE(2429), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82691] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3814), 1,
      sym__string_end,
    STATE(2430), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82717] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3816), 1,
      anon_sym_COMMA,
    STATE(2431), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(2064), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [82737] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3819), 1,
      sym__string_end,
    STATE(2432), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3821), 1,
      sym__string_end,
    STATE(2433), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3823), 1,
      aux_sym_string_array_token1,
    ACTIONS(3825), 1,
      sym__string_end,
    STATE(2330), 1,
      aux_sym__literal_contents,
    STATE(2434), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [82817] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3470), 1,
      anon_sym_end,
    ACTIONS(3472), 1,
      anon_sym_when,
    STATE(2435), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2854), 1,
      sym_else,
  [82845] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3827), 1,
      sym__string_end,
    STATE(2436), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3829), 1,
      sym__string_end,
    STATE(2437), 1,
      sym_heredoc_body,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82897] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3831), 1,
      sym__string_end,
    STATE(2432), 1,
      aux_sym__literal_contents,
    STATE(2438), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [82923] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3833), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2439), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82949] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3835), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2440), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [82975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3837), 1,
      aux_sym_string_array_token1,
    ACTIONS(3839), 1,
      sym__string_end,
    STATE(2374), 1,
      aux_sym__literal_contents,
    STATE(2441), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [83003] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3841), 1,
      sym__string_end,
    STATE(2430), 1,
      aux_sym__literal_contents,
    STATE(2442), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [83029] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3843), 1,
      aux_sym_string_array_token1,
    ACTIONS(3845), 1,
      sym__string_end,
    STATE(2375), 1,
      aux_sym__literal_contents,
    STATE(2443), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [83057] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2444), 1,
      sym_heredoc_body,
    ACTIONS(1547), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3847), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2445), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83101] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2446), 1,
      sym_heredoc_body,
    ACTIONS(1910), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [83117] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3520), 1,
      anon_sym_end,
    STATE(2447), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2845), 1,
      sym_else,
  [83145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3849), 1,
      sym__string_end,
    STATE(2397), 1,
      aux_sym__literal_contents,
    STATE(2448), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [83171] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3851), 1,
      anon_sym_end,
    STATE(2449), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2900), 1,
      sym_else,
  [83199] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3853), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2450), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83225] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2451), 1,
      sym_heredoc_body,
    ACTIONS(3855), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83243] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(2452), 1,
      sym_heredoc_body,
    STATE(2559), 1,
      sym_argument_list,
    ACTIONS(1666), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83265] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2453), 1,
      sym_heredoc_body,
    ACTIONS(3857), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3859), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2454), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3861), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2455), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83335] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_COMMA,
    STATE(2456), 1,
      sym_heredoc_body,
    STATE(2458), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(2659), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [83357] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2457), 1,
      sym_heredoc_body,
    ACTIONS(3863), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83375] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_COMMA,
    STATE(2431), 1,
      aux_sym_exceptions_repeat1,
    STATE(2458), 1,
      sym_heredoc_body,
    ACTIONS(3865), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [83397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3482), 1,
      sym_escape_sequence,
    ACTIONS(3484), 1,
      sym__string_content,
    ACTIONS(3867), 1,
      aux_sym_string_array_token1,
    ACTIONS(3869), 1,
      sym__string_end,
    STATE(2327), 1,
      aux_sym__literal_contents,
    STATE(2459), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
  [83425] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3711), 1,
      sym__string_end,
    ACTIONS(3871), 1,
      anon_sym_POUND_LBRACE,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3874), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2460), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [83449] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3877), 1,
      anon_sym_end,
    STATE(2461), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2855), 1,
      sym_else,
  [83477] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3879), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2462), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3881), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2463), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3883), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2464), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83555] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3885), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2465), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [83581] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2466), 1,
      sym_heredoc_body,
    ACTIONS(3887), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83599] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3889), 1,
      anon_sym_end,
    STATE(2467), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2902), 1,
      sym_else,
  [83627] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2468), 1,
      sym_heredoc_body,
    ACTIONS(1563), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [83645] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2469), 1,
      sym_heredoc_body,
    ACTIONS(3891), 6,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [83663] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3750), 1,
      anon_sym_if,
    ACTIONS(3752), 1,
      anon_sym_unless,
    ACTIONS(3754), 1,
      anon_sym_while,
    ACTIONS(3756), 1,
      anon_sym_until,
    ACTIONS(3758), 1,
      anon_sym_rescue,
    ACTIONS(3893), 1,
      anon_sym_RBRACE,
    STATE(2470), 1,
      sym_heredoc_body,
  [83691] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3895), 1,
      sym__string_end,
    STATE(2465), 1,
      aux_sym__literal_contents,
    STATE(2471), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [83717] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2472), 1,
      sym_heredoc_body,
    ACTIONS(3282), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [83733] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(2473), 1,
      sym_heredoc_body,
    STATE(2615), 1,
      sym_argument_list,
    ACTIONS(1654), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [83755] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2474), 1,
      sym_heredoc_body,
    ACTIONS(2586), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [83771] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3591), 1,
      anon_sym_end,
    STATE(2475), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2903), 1,
      sym_else,
  [83799] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3897), 1,
      sym__string_end,
    STATE(2393), 1,
      aux_sym__literal_contents,
    STATE(2476), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [83825] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3899), 1,
      anon_sym_end,
    STATE(2477), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2822), 1,
      sym_else,
  [83853] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2478), 1,
      sym_heredoc_body,
    ACTIONS(999), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [83869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3901), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2479), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3903), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2480), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3905), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2481), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3907), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2482), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [83973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3909), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2483), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [83999] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(2484), 1,
      sym_heredoc_body,
    STATE(2597), 1,
      sym_argument_list,
    ACTIONS(273), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84021] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3911), 1,
      sym__string_end,
    STATE(2485), 1,
      sym_heredoc_body,
    STATE(2487), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3913), 1,
      sym__string_end,
    STATE(2482), 1,
      aux_sym__literal_contents,
    STATE(2486), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84073] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3915), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2487), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84099] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_LPAREN2,
    STATE(2488), 1,
      sym_heredoc_body,
    STATE(2599), 1,
      sym_argument_list,
    ACTIONS(303), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3917), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2489), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [84147] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3581), 1,
      anon_sym_end,
    STATE(2490), 1,
      sym_heredoc_body,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2728), 1,
      sym_when,
    STATE(2853), 1,
      sym_else,
  [84175] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_do,
    STATE(187), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(2491), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [84198] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3919), 1,
      anon_sym_end,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    STATE(2492), 1,
      sym_heredoc_body,
    STATE(2870), 2,
      sym_elsif,
      sym_else,
  [84221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3923), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2493), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [84244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3925), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2494), 1,
      sym_heredoc_body,
    STATE(2510), 1,
      sym_interpolation,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [84267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3933), 1,
      sym_heredoc_end,
    ACTIONS(3930), 2,
      sym__heredoc_content,
      sym_escape_sequence,
    STATE(2495), 3,
      sym_interpolation,
      sym_heredoc_body,
      aux_sym_heredoc_body_repeat1,
  [84286] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3935), 1,
      anon_sym_r,
    STATE(2496), 1,
      sym_heredoc_body,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84305] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3937), 1,
      anon_sym_SEMI,
    STATE(2497), 2,
      sym_heredoc_body,
      aux_sym_case_repeat1,
    ACTIONS(3940), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [84324] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3942), 1,
      sym__string_end,
    STATE(2498), 1,
      sym_heredoc_body,
    STATE(2511), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84347] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3944), 1,
      sym__string_end,
    STATE(2499), 1,
      sym_heredoc_body,
    STATE(2515), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84370] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3946), 1,
      sym__string_end,
    STATE(2500), 1,
      sym_heredoc_body,
    STATE(2516), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84393] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3950), 1,
      anon_sym_when,
    STATE(2728), 1,
      sym_when,
    ACTIONS(3948), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(2501), 2,
      sym_heredoc_body,
      aux_sym_case_repeat2,
  [84414] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3953), 1,
      anon_sym_COMMA,
    STATE(2502), 2,
      sym_heredoc_body,
      aux_sym_when_repeat1,
    ACTIONS(3956), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [84433] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3958), 1,
      sym__string_end,
    STATE(2503), 1,
      sym_heredoc_body,
    STATE(2517), 1,
      aux_sym__literal_contents,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84456] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2504), 1,
      sym_heredoc_body,
    ACTIONS(1658), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84473] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2505), 1,
      sym_heredoc_body,
    ACTIONS(1680), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [84490] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(149), 1,
      sym__terminator,
    STATE(2506), 1,
      sym_heredoc_body,
    STATE(2555), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [84513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3960), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2507), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3962), 1,
      anon_sym_COLON,
    ACTIONS(3964), 1,
      anon_sym_EQ,
    STATE(2508), 1,
      sym_heredoc_body,
    ACTIONS(3800), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
  [84557] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3966), 1,
      anon_sym_end,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2509), 1,
      sym_heredoc_body,
    STATE(2728), 1,
      sym_when,
    STATE(2940), 1,
      sym_else,
  [84582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2510), 1,
      sym_heredoc_body,
    ACTIONS(3970), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(3968), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
  [84601] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3972), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2511), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84624] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(3974), 1,
      anon_sym_end,
    STATE(2512), 1,
      sym_heredoc_body,
    STATE(2911), 2,
      sym_elsif,
      sym_else,
  [84647] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(3976), 1,
      anon_sym_end,
    STATE(2513), 1,
      sym_heredoc_body,
    STATE(2912), 2,
      sym_elsif,
      sym_else,
  [84670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3978), 1,
      anon_sym_COLON,
    ACTIONS(3980), 1,
      anon_sym_EQ,
    STATE(2514), 1,
      sym_heredoc_body,
    ACTIONS(3800), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [84691] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3982), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2515), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84714] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3984), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2516), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84737] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3986), 1,
      sym__string_end,
    STATE(2460), 1,
      aux_sym__literal_contents,
    STATE(2517), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [84760] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_do,
    STATE(186), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(2518), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [84783] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2519), 1,
      sym_heredoc_body,
    ACTIONS(3333), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [84798] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3750), 1,
      anon_sym_if,
    ACTIONS(3752), 1,
      anon_sym_unless,
    ACTIONS(3754), 1,
      anon_sym_while,
    ACTIONS(3756), 1,
      anon_sym_until,
    ACTIONS(3758), 1,
      anon_sym_rescue,
    ACTIONS(3988), 1,
      anon_sym_RBRACE,
    STATE(2520), 1,
      sym_heredoc_body,
  [84823] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(3990), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2521), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [84846] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(3992), 1,
      anon_sym_end,
    STATE(2522), 1,
      sym_heredoc_body,
    STATE(2882), 2,
      sym_elsif,
      sym_else,
  [84869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2523), 1,
      sym_heredoc_body,
    ACTIONS(3996), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(3994), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
  [84888] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(3998), 1,
      anon_sym_end,
    STATE(2524), 1,
      sym_heredoc_body,
    STATE(2841), 2,
      sym_elsif,
      sym_else,
  [84911] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3668), 1,
      anon_sym_end,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2525), 1,
      sym_heredoc_body,
    STATE(2728), 1,
      sym_when,
    STATE(2926), 1,
      sym_else,
  [84936] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(4000), 1,
      anon_sym_end,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2526), 1,
      sym_heredoc_body,
    STATE(2728), 1,
      sym_when,
    STATE(2948), 1,
      sym_else,
  [84961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4002), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      sym_heredoc_body,
    STATE(2551), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(1303), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [84982] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2528), 1,
      sym_heredoc_body,
    ACTIONS(2064), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_EQ_GT,
  [84999] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(4004), 1,
      anon_sym_end,
    STATE(2529), 1,
      sym_heredoc_body,
    STATE(2839), 2,
      sym_elsif,
      sym_else,
  [85022] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4010), 1,
      sym_heredoc_end,
    STATE(2530), 1,
      sym_heredoc_body,
    ACTIONS(4008), 2,
      sym__heredoc_content,
      sym_escape_sequence,
    STATE(2547), 2,
      sym_interpolation,
      aux_sym_heredoc_body_repeat1,
  [85043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4012), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2531), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85066] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4014), 1,
      sym__string_end,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2532), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85089] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_then,
    STATE(154), 1,
      sym__terminator,
    STATE(2533), 1,
      sym_heredoc_body,
    STATE(2576), 1,
      sym_then,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [85112] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(4016), 1,
      anon_sym_end,
    STATE(2534), 1,
      sym_heredoc_body,
    STATE(2881), 2,
      sym_elsif,
      sym_else,
  [85135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4018), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2535), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85158] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4020), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2536), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85181] = 8,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3472), 1,
      anon_sym_when,
    ACTIONS(3654), 1,
      anon_sym_end,
    STATE(2501), 1,
      aux_sym_case_repeat2,
    STATE(2537), 1,
      sym_heredoc_body,
    STATE(2728), 1,
      sym_when,
    STATE(2939), 1,
      sym_else,
  [85206] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2538), 1,
      sym_heredoc_body,
    ACTIONS(3290), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [85221] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2539), 1,
      sym_heredoc_body,
    ACTIONS(3288), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [85236] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4022), 1,
      sym__string_end,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2540), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    STATE(2328), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2541), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4024), 1,
      anon_sym_COLON,
    ACTIONS(4026), 1,
      anon_sym_EQ,
    STATE(2542), 1,
      sym_heredoc_body,
    ACTIONS(3800), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85303] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3478), 1,
      anon_sym_POUND_LBRACE,
    STATE(2388), 1,
      aux_sym__literal_contents,
    STATE(2510), 1,
      sym_interpolation,
    STATE(2543), 1,
      sym_heredoc_body,
    ACTIONS(3484), 2,
      sym__string_content,
      sym_escape_sequence,
  [85326] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2544), 1,
      sym_heredoc_body,
    ACTIONS(1672), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85343] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2545), 1,
      sym_heredoc_body,
    ACTIONS(3317), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [85358] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4028), 1,
      sym__string_end,
    STATE(2507), 1,
      aux_sym__literal_contents,
    STATE(2546), 1,
      sym_heredoc_body,
    STATE(2598), 1,
      sym_interpolation,
    ACTIONS(3736), 2,
      sym__string_content,
      sym_escape_sequence,
  [85381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(4032), 1,
      sym_heredoc_end,
    STATE(2547), 1,
      sym_heredoc_body,
    ACTIONS(4030), 2,
      sym__heredoc_content,
      sym_escape_sequence,
    STATE(2495), 2,
      sym_interpolation,
      aux_sym_heredoc_body_repeat1,
  [85402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym__mlhs_repeat1,
    STATE(2548), 1,
      sym_heredoc_body,
    ACTIONS(3722), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [85423] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2549), 1,
      sym_heredoc_body,
    ACTIONS(3339), 6,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_rescue,
  [85438] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_do,
    STATE(173), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(2550), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [85461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4034), 1,
      anon_sym_COMMA,
    STATE(2551), 2,
      sym_heredoc_body,
      aux_sym__mlhs_repeat1,
    ACTIONS(3476), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [85480] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2552), 1,
      sym_heredoc_body,
    ACTIONS(1838), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85496] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(4037), 1,
      anon_sym_end,
    STATE(2553), 1,
      sym_heredoc_body,
    STATE(2949), 2,
      sym_elsif,
      sym_else,
  [85516] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4039), 1,
      anon_sym_COMMA,
    ACTIONS(3744), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(2554), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [85534] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2555), 1,
      sym_heredoc_body,
    ACTIONS(4042), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85550] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_COMMA,
    ACTIONS(3744), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    STATE(2556), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [85568] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_COMMA,
    ACTIONS(4049), 1,
      anon_sym_PIPE,
    ACTIONS(4051), 1,
      anon_sym_SEMI,
    STATE(2557), 1,
      sym_heredoc_body,
    STATE(2566), 1,
      aux_sym_parameters_repeat1,
  [85590] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2558), 1,
      sym_heredoc_body,
    ACTIONS(1439), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [85606] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2559), 1,
      sym_heredoc_body,
    ACTIONS(1862), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85622] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4053), 1,
      anon_sym_COMMA,
    ACTIONS(3248), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2560), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
  [85640] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2561), 1,
      sym_heredoc_body,
    ACTIONS(1870), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85656] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2562), 1,
      sym_heredoc_body,
    ACTIONS(4056), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85672] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2563), 1,
      sym_heredoc_body,
    ACTIONS(1910), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4058), 1,
      anon_sym_COLON,
    ACTIONS(4060), 1,
      anon_sym_EQ,
    STATE(2564), 1,
      sym_heredoc_body,
    ACTIONS(3800), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [85708] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2565), 1,
      sym_heredoc_body,
    ACTIONS(1722), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85724] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_PIPE,
    ACTIONS(3391), 1,
      anon_sym_SEMI,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    STATE(2566), 1,
      sym_heredoc_body,
    STATE(2580), 1,
      aux_sym_parameters_repeat1,
  [85746] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2567), 1,
      sym_heredoc_body,
    ACTIONS(1734), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85762] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2568), 1,
      sym_heredoc_body,
    ACTIONS(1702), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85778] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2569), 1,
      sym_heredoc_body,
    ACTIONS(1854), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85794] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2570), 1,
      sym_heredoc_body,
    ACTIONS(1718), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85810] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2571), 1,
      sym_heredoc_body,
    ACTIONS(4064), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85826] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2572), 1,
      sym_heredoc_body,
    ACTIONS(1826), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85842] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2573), 1,
      sym_heredoc_body,
    ACTIONS(1714), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85858] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2574), 1,
      sym_heredoc_body,
    ACTIONS(1762), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85874] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2575), 1,
      sym_heredoc_body,
    ACTIONS(3956), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [85890] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2576), 1,
      sym_heredoc_body,
    ACTIONS(4066), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85906] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2577), 1,
      sym_heredoc_body,
    ACTIONS(1778), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2578), 1,
      sym_heredoc_body,
    ACTIONS(4068), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [85938] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2579), 1,
      sym_heredoc_body,
    ACTIONS(1786), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [85954] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_COMMA,
    ACTIONS(3744), 2,
      anon_sym_PIPE,
      anon_sym_SEMI,
    STATE(2580), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [85972] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_LBRACK,
    ACTIONS(4077), 1,
      anon_sym_COLON_COLON2,
    STATE(2581), 1,
      sym_heredoc_body,
    ACTIONS(4073), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [85992] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2582), 1,
      sym_heredoc_body,
    ACTIONS(1818), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86008] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2583), 1,
      sym_heredoc_body,
    ACTIONS(1822), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86024] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2584), 1,
      sym_heredoc_body,
    ACTIONS(1479), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86040] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2585), 1,
      sym_heredoc_body,
    ACTIONS(2995), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [86056] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2586), 1,
      sym_heredoc_body,
    ACTIONS(1882), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86072] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_SEMI,
    ACTIONS(4079), 1,
      anon_sym_COMMA,
    STATE(2580), 1,
      aux_sym_parameters_repeat1,
    STATE(2587), 1,
      sym_heredoc_body,
  [86094] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2588), 1,
      sym_heredoc_body,
    ACTIONS(1918), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86110] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2589), 1,
      sym_heredoc_body,
    ACTIONS(1782), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86126] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2590), 1,
      sym_heredoc_body,
    ACTIONS(1926), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86142] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2591), 1,
      sym_heredoc_body,
    ACTIONS(1684), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86158] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2592), 1,
      sym_heredoc_body,
    ACTIONS(1794), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86174] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2593), 1,
      sym_heredoc_body,
    ACTIONS(1934), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86190] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2594), 1,
      sym_heredoc_body,
    ACTIONS(1938), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3994), 1,
      anon_sym_POUND_LBRACE,
    STATE(2595), 1,
      sym_heredoc_body,
    ACTIONS(3996), 3,
      sym__string_content,
      sym__string_end,
      sym_escape_sequence,
  [86224] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2596), 1,
      sym_heredoc_body,
    ACTIONS(1710), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86240] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2597), 1,
      sym_heredoc_body,
    ACTIONS(1842), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3968), 1,
      anon_sym_POUND_LBRACE,
    STATE(2598), 1,
      sym_heredoc_body,
    ACTIONS(3970), 3,
      sym__string_content,
      sym__string_end,
      sym_escape_sequence,
  [86274] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2599), 1,
      sym_heredoc_body,
    ACTIONS(1996), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86290] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2600), 1,
      sym_heredoc_body,
    ACTIONS(1942), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86306] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2601), 1,
      sym_heredoc_body,
    ACTIONS(1946), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86322] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2602), 1,
      sym_heredoc_body,
    ACTIONS(2000), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86338] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2603), 1,
      sym_heredoc_body,
    ACTIONS(4081), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [86354] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2604), 1,
      sym_heredoc_body,
    ACTIONS(1992), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86370] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2605), 1,
      sym_heredoc_body,
    ACTIONS(1980), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86386] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2606), 1,
      sym_heredoc_body,
    ACTIONS(1902), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86402] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(2607), 1,
      sym_heredoc_body,
    STATE(2644), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(4083), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [86422] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2608), 1,
      sym_heredoc_body,
    ACTIONS(1984), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86438] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2609), 1,
      sym_heredoc_body,
    ACTIONS(1834), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86454] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2610), 1,
      sym_heredoc_body,
    ACTIONS(1810), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86470] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2611), 1,
      sym_heredoc_body,
    ACTIONS(1806), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86486] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2612), 1,
      sym_heredoc_body,
    ACTIONS(1790), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86502] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2613), 1,
      sym_heredoc_body,
    ACTIONS(1914), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86518] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2614), 1,
      sym_heredoc_body,
    ACTIONS(1950), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86534] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2615), 1,
      sym_heredoc_body,
    ACTIONS(1850), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2616), 1,
      sym_heredoc_body,
    ACTIONS(1798), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86566] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2617), 1,
      sym_heredoc_body,
    ACTIONS(1770), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2618), 1,
      sym_heredoc_body,
    ACTIONS(1706), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86598] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
    ACTIONS(4089), 1,
      anon_sym_PIPE,
    ACTIONS(4091), 1,
      anon_sym_SEMI,
    STATE(2587), 1,
      aux_sym_parameters_repeat1,
    STATE(2619), 1,
      sym_heredoc_body,
  [86620] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2620), 1,
      sym_heredoc_body,
    ACTIONS(4093), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2621), 1,
      sym_heredoc_body,
    ACTIONS(4095), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [86652] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2622), 1,
      sym_heredoc_body,
    ACTIONS(1774), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86668] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2623), 1,
      sym_heredoc_body,
    ACTIONS(1758), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86684] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2624), 1,
      sym_heredoc_body,
    ACTIONS(4097), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86700] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2625), 1,
      sym_heredoc_body,
    ACTIONS(1690), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86716] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2626), 1,
      sym_heredoc_body,
    ACTIONS(4099), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [86732] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LBRACE,
    ACTIONS(4101), 1,
      anon_sym_do,
    STATE(2627), 1,
      sym_heredoc_body,
    STATE(1107), 2,
      sym_do_block,
      sym_block,
  [86752] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2628), 1,
      sym_heredoc_body,
    ACTIONS(1858), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86768] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_LBRACE,
    ACTIONS(4103), 1,
      anon_sym_do,
    STATE(2629), 1,
      sym_heredoc_body,
    STATE(1445), 2,
      sym_do_block,
      sym_block,
  [86788] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4107), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      sym_heredoc_body,
    STATE(2656), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4105), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [86808] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2631), 1,
      sym_heredoc_body,
    ACTIONS(1878), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86824] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2632), 1,
      sym_heredoc_body,
    ACTIONS(1890), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2633), 1,
      sym_heredoc_body,
    ACTIONS(1742), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86856] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3329), 1,
      anon_sym_LBRACE,
    ACTIONS(3395), 1,
      anon_sym_do,
    STATE(2634), 1,
      sym_heredoc_body,
    STATE(2665), 2,
      sym_do_block,
      sym_block,
  [86876] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2635), 1,
      sym_heredoc_body,
    ACTIONS(1964), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86892] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2636), 1,
      sym_heredoc_body,
    ACTIONS(1972), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86908] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2637), 1,
      sym_heredoc_body,
    ACTIONS(1730), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86924] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2638), 1,
      sym_heredoc_body,
    ACTIONS(1894), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86940] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2639), 1,
      sym_heredoc_body,
    ACTIONS(1954), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86956] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2640), 1,
      sym_heredoc_body,
    ACTIONS(2008), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86972] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2641), 1,
      sym_heredoc_body,
    ACTIONS(1441), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [86988] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2642), 1,
      sym_heredoc_body,
    ACTIONS(1976), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87004] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(2554), 1,
      aux_sym_parameters_repeat1,
    STATE(2643), 1,
      sym_heredoc_body,
    ACTIONS(4111), 2,
      sym__line_break,
      anon_sym_SEMI,
  [87024] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4113), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(2644), 1,
      sym_heredoc_body,
    ACTIONS(935), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [87044] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2645), 1,
      sym_heredoc_body,
    ACTIONS(1694), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87060] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2646), 1,
      sym_heredoc_body,
    ACTIONS(1886), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87076] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2647), 1,
      sym_heredoc_body,
    ACTIONS(1988), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87092] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4077), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4117), 1,
      anon_sym_LBRACK,
    STATE(2648), 1,
      sym_heredoc_body,
    ACTIONS(4115), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [87112] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2649), 1,
      sym_heredoc_body,
    ACTIONS(1930), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87128] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2650), 1,
      sym_heredoc_body,
    ACTIONS(1906), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87144] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2651), 1,
      sym_heredoc_body,
    ACTIONS(1898), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87160] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    STATE(2652), 1,
      sym_heredoc_body,
    ACTIONS(3599), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87178] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4121), 1,
      sym_identifier,
    STATE(2653), 1,
      sym_heredoc_body,
    ACTIONS(3605), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87196] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2654), 1,
      sym_heredoc_body,
    ACTIONS(1814), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2655), 1,
      sym_heredoc_body,
    ACTIONS(3476), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
  [87228] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4107), 1,
      anon_sym_COMMA,
    STATE(2556), 1,
      aux_sym_parameters_repeat1,
    STATE(2656), 1,
      sym_heredoc_body,
    ACTIONS(4111), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [87248] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2657), 1,
      sym_heredoc_body,
    ACTIONS(1958), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87264] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(2643), 1,
      aux_sym_parameters_repeat1,
    STATE(2658), 1,
      sym_heredoc_body,
    ACTIONS(4105), 2,
      sym__line_break,
      anon_sym_SEMI,
  [87284] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2659), 1,
      sym_heredoc_body,
    ACTIONS(2004), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87300] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2660), 1,
      sym_heredoc_body,
    ACTIONS(1766), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87316] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2661), 1,
      sym_heredoc_body,
    ACTIONS(1802), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87332] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2662), 1,
      sym_heredoc_body,
    ACTIONS(1922), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87348] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2663), 1,
      sym_heredoc_body,
    ACTIONS(1968), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87364] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_LBRACK,
    ACTIONS(4123), 1,
      anon_sym_COLON_COLON2,
    STATE(2664), 1,
      sym_heredoc_body,
    ACTIONS(4073), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [87384] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2665), 1,
      sym_heredoc_body,
    ACTIONS(1726), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87400] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2666), 1,
      sym_heredoc_body,
    ACTIONS(1846), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87416] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_else,
    ACTIONS(3921), 1,
      anon_sym_elsif,
    ACTIONS(4125), 1,
      anon_sym_end,
    STATE(2667), 1,
      sym_heredoc_body,
    STATE(2931), 2,
      sym_elsif,
      sym_else,
  [87436] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2668), 1,
      sym_heredoc_body,
    ACTIONS(1698), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [87452] = 6,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_do,
    STATE(205), 1,
      sym__do,
    STATE(970), 1,
      sym__terminator,
    STATE(2669), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [87472] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2670), 1,
      sym_heredoc_body,
    ACTIONS(2128), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [87487] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_RPAREN,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    STATE(2671), 1,
      sym_heredoc_body,
    STATE(2673), 1,
      aux_sym_parameters_repeat1,
  [87506] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2672), 1,
      sym_heredoc_body,
    ACTIONS(1563), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87521] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_RPAREN,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    STATE(2673), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [87538] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2674), 1,
      sym_heredoc_body,
    ACTIONS(3744), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87553] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2675), 1,
      sym_heredoc_body,
    ACTIONS(3887), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87568] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2676), 1,
      sym_heredoc_body,
    ACTIONS(4134), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [87583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3798), 1,
      sym__string_end,
    ACTIONS(4136), 1,
      aux_sym_string_array_token1,
    STATE(2677), 1,
      sym_heredoc_body,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
  [87602] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2678), 1,
      sym_heredoc_body,
    ACTIONS(3800), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87617] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2679), 1,
      sym_heredoc_body,
    ACTIONS(3248), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [87632] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_PIPE,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2680), 1,
      sym_heredoc_body,
    STATE(2709), 1,
      aux_sym_block_parameters_repeat1,
  [87651] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_LBRACE,
    ACTIONS(4140), 1,
      anon_sym_do,
    STATE(2681), 1,
      sym_heredoc_body,
    STATE(1435), 2,
      sym_do_block,
      sym_block,
  [87668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3780), 1,
      sym__string_end,
    ACTIONS(4142), 1,
      aux_sym_string_array_token1,
    STATE(2682), 1,
      sym_heredoc_body,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
  [87687] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4144), 1,
      anon_sym_RPAREN,
    STATE(2673), 1,
      aux_sym_parameters_repeat1,
    STATE(2683), 1,
      sym_heredoc_body,
  [87706] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2684), 1,
      sym_heredoc_body,
    ACTIONS(3732), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87721] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4146), 1,
      anon_sym_RPAREN,
    STATE(2683), 1,
      aux_sym_parameters_repeat1,
    STATE(2685), 1,
      sym_heredoc_body,
  [87740] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4148), 1,
      anon_sym_RBRACE,
    ACTIONS(4150), 1,
      anon_sym_COMMA,
    STATE(2686), 1,
      sym_heredoc_body,
    STATE(2718), 1,
      aux_sym_hash_repeat1,
  [87759] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2687), 1,
      sym_heredoc_body,
    ACTIONS(3863), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87774] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_RBRACE,
    ACTIONS(4154), 1,
      anon_sym_COMMA,
    STATE(2688), 1,
      sym_heredoc_body,
    STATE(2698), 1,
      aux_sym_hash_repeat1,
  [87793] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2689), 1,
      sym_heredoc_body,
    ACTIONS(3857), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87808] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4156), 1,
      anon_sym_RPAREN,
    STATE(2671), 1,
      aux_sym_parameters_repeat1,
    STATE(2690), 1,
      sym_heredoc_body,
  [87827] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4158), 1,
      anon_sym_RPAREN,
    STATE(2673), 1,
      aux_sym_parameters_repeat1,
    STATE(2691), 1,
      sym_heredoc_body,
  [87846] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_RBRACE,
    ACTIONS(4162), 1,
      anon_sym_COMMA,
    STATE(2692), 1,
      sym_heredoc_body,
    STATE(2727), 1,
      aux_sym_hash_repeat1,
  [87865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 1,
      anon_sym_POUND_LBRACE,
    STATE(2693), 1,
      sym_heredoc_body,
    ACTIONS(3996), 3,
      sym__heredoc_content,
      sym_heredoc_end,
      sym_escape_sequence,
  [87880] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2694), 1,
      sym_heredoc_body,
    ACTIONS(4164), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [87895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2695), 1,
      sym_heredoc_body,
    ACTIONS(3855), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3742), 1,
      sym__string_end,
    ACTIONS(4166), 1,
      aux_sym_string_array_token1,
    STATE(2696), 1,
      sym_heredoc_body,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
  [87929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3835), 1,
      sym__string_end,
    ACTIONS(4168), 1,
      aux_sym_string_array_token1,
    STATE(2697), 1,
      sym_heredoc_body,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
  [87948] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_RBRACE,
    ACTIONS(4170), 1,
      anon_sym_COMMA,
    STATE(2698), 1,
      sym_heredoc_body,
    STATE(2714), 1,
      aux_sym_hash_repeat1,
  [87967] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_PIPE,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2699), 1,
      sym_heredoc_body,
    STATE(2704), 1,
      aux_sym_block_parameters_repeat1,
  [87986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4172), 1,
      aux_sym_string_array_token1,
    ACTIONS(4175), 1,
      sym__string_end,
    STATE(2700), 2,
      sym_heredoc_body,
      aux_sym_string_array_repeat1,
  [88003] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_PIPE,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2701), 1,
      sym_heredoc_body,
    STATE(2711), 1,
      aux_sym_block_parameters_repeat1,
  [88022] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3879), 1,
      sym__string_end,
    ACTIONS(4177), 1,
      aux_sym_string_array_token1,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
    STATE(2702), 1,
      sym_heredoc_body,
  [88041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3903), 1,
      sym__string_end,
    ACTIONS(4179), 1,
      aux_sym_string_array_token1,
    STATE(2703), 1,
      sym_heredoc_body,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
  [88060] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4181), 1,
      anon_sym_PIPE,
    STATE(2704), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3766), 1,
      sym__string_end,
    ACTIONS(4183), 1,
      aux_sym_string_array_token1,
    STATE(2705), 1,
      sym_heredoc_body,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
  [88098] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2706), 1,
      sym_heredoc_body,
    ACTIONS(1547), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88113] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(92), 1,
      sym__terminator,
    STATE(2707), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4185), 1,
      aux_sym_string_array_token1,
    ACTIONS(4188), 1,
      sym__string_end,
    STATE(2708), 2,
      sym_heredoc_body,
      aux_sym_symbol_array_repeat1,
  [88147] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_PIPE,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2709), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88166] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_PIPE,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      sym_heredoc_body,
    STATE(2712), 1,
      aux_sym_block_parameters_repeat1,
  [88185] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_PIPE,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    STATE(2711), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88204] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4190), 1,
      anon_sym_PIPE,
    STATE(2712), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88223] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(80), 1,
      sym__terminator,
    STATE(2713), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88240] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4192), 1,
      anon_sym_RBRACE,
    ACTIONS(4194), 1,
      anon_sym_COMMA,
    STATE(2714), 2,
      sym_heredoc_body,
      aux_sym_hash_repeat1,
  [88257] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4197), 1,
      anon_sym_RPAREN,
    STATE(2691), 1,
      aux_sym_parameters_repeat1,
    STATE(2715), 1,
      sym_heredoc_body,
  [88276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3853), 1,
      sym__string_end,
    ACTIONS(4199), 1,
      aux_sym_string_array_token1,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2716), 1,
      sym_heredoc_body,
  [88295] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(94), 1,
      sym__terminator,
    STATE(2717), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88312] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_RBRACE,
    ACTIONS(4201), 1,
      anon_sym_COMMA,
    STATE(2714), 1,
      aux_sym_hash_repeat1,
    STATE(2718), 1,
      sym_heredoc_body,
  [88331] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2719), 1,
      sym_heredoc_body,
    ACTIONS(1559), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88346] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4203), 1,
      anon_sym_PIPE,
    STATE(2720), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88365] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4205), 1,
      anon_sym_PIPE,
    STATE(2720), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2721), 1,
      sym_heredoc_body,
  [88384] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(105), 1,
      sym__terminator,
    STATE(2722), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88401] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4205), 1,
      anon_sym_PIPE,
    STATE(2723), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88420] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(107), 1,
      sym__terminator,
    STATE(2724), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88437] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4190), 1,
      anon_sym_PIPE,
    STATE(2725), 1,
      sym_heredoc_body,
    STATE(2726), 1,
      aux_sym_block_parameters_repeat1,
  [88456] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4207), 1,
      anon_sym_PIPE,
    STATE(2726), 1,
      sym_heredoc_body,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
  [88475] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_RBRACE,
    ACTIONS(4209), 1,
      anon_sym_COMMA,
    STATE(2714), 1,
      aux_sym_hash_repeat1,
    STATE(2727), 1,
      sym_heredoc_body,
  [88494] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2728), 1,
      sym_heredoc_body,
    ACTIONS(4211), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [88509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3909), 1,
      sym__string_end,
    ACTIONS(4213), 1,
      aux_sym_string_array_token1,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
    STATE(2729), 1,
      sym_heredoc_body,
  [88528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3847), 1,
      sym__string_end,
    ACTIONS(4215), 1,
      aux_sym_string_array_token1,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2730), 1,
      sym_heredoc_body,
  [88547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3833), 1,
      sym__string_end,
    ACTIONS(4217), 1,
      aux_sym_string_array_token1,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
    STATE(2731), 1,
      sym_heredoc_body,
  [88566] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4181), 1,
      anon_sym_PIPE,
    STATE(2723), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2732), 1,
      sym_heredoc_body,
  [88585] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4219), 1,
      anon_sym_COMMA,
    ACTIONS(4222), 1,
      anon_sym_PIPE,
    STATE(2733), 2,
      sym_heredoc_body,
      aux_sym_block_parameters_repeat1,
  [88602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3905), 1,
      sym__string_end,
    ACTIONS(4224), 1,
      aux_sym_string_array_token1,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
    STATE(2734), 1,
      sym_heredoc_body,
  [88621] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4226), 1,
      anon_sym_PIPE,
    STATE(2733), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2735), 1,
      sym_heredoc_body,
  [88640] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4207), 1,
      anon_sym_PIPE,
    STATE(2735), 1,
      aux_sym_block_parameters_repeat1,
    STATE(2736), 1,
      sym_heredoc_body,
  [88659] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(101), 1,
      sym__terminator,
    STATE(2737), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [88676] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2738), 1,
      sym_heredoc_body,
    ACTIONS(4228), 2,
      sym_constant,
      sym_identifier,
  [88690] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2739), 1,
      sym_heredoc_body,
    ACTIONS(4230), 2,
      sym_constant,
      sym_identifier,
  [88704] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2740), 1,
      sym_heredoc_body,
    ACTIONS(4222), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [88718] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2741), 1,
      sym_heredoc_body,
    ACTIONS(4232), 2,
      sym_constant,
      sym_identifier,
  [88732] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2742), 1,
      sym_heredoc_body,
    ACTIONS(4234), 2,
      sym_constant,
      sym_identifier,
  [88746] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2743), 1,
      sym_heredoc_body,
    ACTIONS(4236), 2,
      sym_constant,
      sym_identifier,
  [88760] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2744), 1,
      sym_heredoc_body,
    ACTIONS(4238), 2,
      sym_constant,
      sym_identifier,
  [88774] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_in,
    STATE(2491), 1,
      sym_in,
    STATE(2745), 1,
      sym_heredoc_body,
  [88790] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2746), 1,
      sym_heredoc_body,
    ACTIONS(4242), 2,
      sym_constant,
      sym_identifier,
  [88804] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2747), 1,
      sym_heredoc_body,
    ACTIONS(4244), 2,
      sym_constant,
      sym_identifier,
  [88818] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2748), 1,
      sym_heredoc_body,
    ACTIONS(4246), 2,
      sym_constant,
      sym_identifier,
  [88832] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2749), 1,
      sym_heredoc_body,
    ACTIONS(4248), 2,
      sym_constant,
      sym_identifier,
  [88846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4012), 1,
      sym__string_end,
    ACTIONS(4250), 1,
      aux_sym_string_array_token1,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
    STATE(2750), 1,
      sym_heredoc_body,
  [88862] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2751), 1,
      sym_heredoc_body,
    ACTIONS(4252), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [88876] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2752), 1,
      sym_heredoc_body,
    ACTIONS(4254), 2,
      sym_constant,
      sym_identifier,
  [88890] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2753), 1,
      sym_heredoc_body,
    ACTIONS(4192), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [88904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2754), 1,
      sym_heredoc_body,
    ACTIONS(4256), 2,
      sym_constant,
      sym_identifier,
  [88918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4018), 1,
      sym__string_end,
    ACTIONS(4258), 1,
      aux_sym_string_array_token1,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2755), 1,
      sym_heredoc_body,
  [88934] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_RBRACE,
    ACTIONS(4262), 1,
      anon_sym_COMMA,
    STATE(2756), 1,
      sym_heredoc_body,
    STATE(2782), 1,
      aux_sym_hash_repeat1,
  [88950] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_in,
    STATE(2550), 1,
      sym_in,
    STATE(2757), 1,
      sym_heredoc_body,
  [88966] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4264), 1,
      ts_builtin_sym_end,
    ACTIONS(4266), 1,
      anon_sym___END__,
    STATE(2758), 1,
      sym_heredoc_body,
  [88982] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2759), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      sym_constant,
      sym_identifier,
  [88996] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4089), 1,
      anon_sym_PIPE,
    ACTIONS(4091), 1,
      anon_sym_SEMI,
    STATE(2760), 1,
      sym_heredoc_body,
  [89012] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2761), 1,
      sym_heredoc_body,
    ACTIONS(4270), 2,
      sym_constant,
      sym_identifier,
  [89026] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2762), 1,
      sym_heredoc_body,
    ACTIONS(4272), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89040] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_in,
    STATE(2518), 1,
      sym_in,
    STATE(2763), 1,
      sym_heredoc_body,
  [89056] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2764), 1,
      sym_heredoc_body,
    ACTIONS(4274), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89070] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2765), 1,
      sym_heredoc_body,
    ACTIONS(4276), 2,
      sym_constant,
      sym_identifier,
  [89084] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2766), 1,
      sym_heredoc_body,
    ACTIONS(909), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89098] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2767), 1,
      sym_heredoc_body,
    ACTIONS(4278), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89112] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2768), 1,
      sym_heredoc_body,
    ACTIONS(4280), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89126] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2769), 1,
      sym_heredoc_body,
    ACTIONS(4282), 2,
      sym_constant,
      sym_identifier,
  [89140] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2770), 1,
      sym_heredoc_body,
    ACTIONS(4284), 2,
      sym_constant,
      sym_identifier,
  [89154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4286), 1,
      anon_sym_RPAREN,
    ACTIONS(4288), 1,
      anon_sym_EQ,
    STATE(2771), 1,
      sym_heredoc_body,
  [89170] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2772), 1,
      sym_heredoc_body,
    ACTIONS(4290), 2,
      sym_integer,
      sym_float,
  [89184] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(122), 1,
      sym__terminator,
    STATE(2773), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [89198] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2774), 1,
      sym_heredoc_body,
    ACTIONS(4292), 2,
      sym_constant,
      sym_identifier,
  [89212] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    STATE(2592), 1,
      sym_parenthesized_statements,
    STATE(2775), 1,
      sym_heredoc_body,
  [89228] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2776), 1,
      sym_heredoc_body,
    ACTIONS(4294), 2,
      sym_constant,
      sym_identifier,
  [89242] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2777), 1,
      sym_heredoc_body,
    ACTIONS(4296), 2,
      sym_constant,
      sym_identifier,
  [89256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3990), 1,
      sym__string_end,
    ACTIONS(4298), 1,
      aux_sym_string_array_token1,
    STATE(2700), 1,
      aux_sym_string_array_repeat1,
    STATE(2778), 1,
      sym_heredoc_body,
  [89272] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2779), 1,
      sym_heredoc_body,
    ACTIONS(4300), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [89286] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4049), 1,
      anon_sym_PIPE,
    ACTIONS(4051), 1,
      anon_sym_SEMI,
    STATE(2780), 1,
      sym_heredoc_body,
  [89302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym__string_end,
    ACTIONS(4302), 1,
      aux_sym_string_array_token1,
    STATE(2708), 1,
      aux_sym_symbol_array_repeat1,
    STATE(2781), 1,
      sym_heredoc_body,
  [89318] = 5,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(1101), 1,
      anon_sym_RBRACE,
    ACTIONS(4304), 1,
      anon_sym_COMMA,
    STATE(2714), 1,
      aux_sym_hash_repeat1,
    STATE(2782), 1,
      sym_heredoc_body,
  [89334] = 4,
    ACTIONS(73), 1,
      sym_comment,
    STATE(121), 1,
      sym__terminator,
    STATE(2783), 1,
      sym_heredoc_body,
    ACTIONS(365), 2,
      sym__line_break,
      anon_sym_SEMI,
  [89348] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4306), 1,
      anon_sym_RPAREN,
    STATE(2784), 1,
      sym_heredoc_body,
  [89361] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_COLON,
    STATE(2785), 1,
      sym_heredoc_body,
  [89374] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4308), 1,
      ts_builtin_sym_end,
    STATE(2786), 1,
      sym_heredoc_body,
  [89387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4310), 1,
      anon_sym_EQ,
    STATE(2787), 1,
      sym_heredoc_body,
  [89400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4312), 1,
      anon_sym_EQ,
    STATE(2788), 1,
      sym_heredoc_body,
  [89413] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4314), 1,
      anon_sym_RPAREN,
    STATE(2789), 1,
      sym_heredoc_body,
  [89426] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4316), 1,
      anon_sym_RPAREN,
    STATE(2790), 1,
      sym_heredoc_body,
  [89439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    STATE(2791), 1,
      sym_heredoc_body,
  [89452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    STATE(2792), 1,
      sym_heredoc_body,
  [89465] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4322), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      sym_heredoc_body,
  [89478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4324), 1,
      anon_sym_EQ,
    STATE(2794), 1,
      sym_heredoc_body,
  [89491] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(715), 1,
      anon_sym_RBRACE,
    STATE(2795), 1,
      sym_heredoc_body,
  [89504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4326), 1,
      anon_sym_EQ,
    STATE(2796), 1,
      sym_heredoc_body,
  [89517] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4328), 1,
      sym__string_end,
    STATE(2797), 1,
      sym_heredoc_body,
  [89530] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_end,
    STATE(2798), 1,
      sym_heredoc_body,
  [89543] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4330), 1,
      anon_sym_RBRACE,
    STATE(2799), 1,
      sym_heredoc_body,
  [89556] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4332), 1,
      anon_sym_RPAREN,
    STATE(2800), 1,
      sym_heredoc_body,
  [89569] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4334), 1,
      anon_sym_RPAREN,
    STATE(2801), 1,
      sym_heredoc_body,
  [89582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4336), 1,
      anon_sym_RBRACE,
    STATE(2802), 1,
      sym_heredoc_body,
  [89595] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4338), 1,
      sym_identifier,
    STATE(2803), 1,
      sym_heredoc_body,
  [89608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4340), 1,
      anon_sym_EQ,
    STATE(2804), 1,
      sym_heredoc_body,
  [89621] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4342), 1,
      anon_sym_RBRACE,
    STATE(2805), 1,
      sym_heredoc_body,
  [89634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4344), 1,
      anon_sym_EQ,
    STATE(2806), 1,
      sym_heredoc_body,
  [89647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4346), 1,
      anon_sym_EQ,
    STATE(2807), 1,
      sym_heredoc_body,
  [89660] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4348), 1,
      sym_identifier,
    STATE(2808), 1,
      sym_heredoc_body,
  [89673] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4350), 1,
      sym_identifier,
    STATE(2809), 1,
      sym_heredoc_body,
  [89686] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4352), 1,
      sym_identifier,
    STATE(2810), 1,
      sym_heredoc_body,
  [89699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4354), 1,
      anon_sym_EQ,
    STATE(2811), 1,
      sym_heredoc_body,
  [89712] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3899), 1,
      anon_sym_end,
    STATE(2812), 1,
      sym_heredoc_body,
  [89725] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4356), 1,
      sym__string_end,
    STATE(2813), 1,
      sym_heredoc_body,
  [89738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4358), 1,
      sym_uninterpreted,
    STATE(2814), 1,
      sym_heredoc_body,
  [89751] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4360), 1,
      anon_sym_end,
    STATE(2815), 1,
      sym_heredoc_body,
  [89764] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_RBRACK,
    STATE(2816), 1,
      sym_heredoc_body,
  [89777] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4364), 1,
      anon_sym_RBRACE,
    STATE(2817), 1,
      sym_heredoc_body,
  [89790] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(719), 1,
      anon_sym_RBRACE,
    STATE(2818), 1,
      sym_heredoc_body,
  [89803] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_RBRACE,
    STATE(2819), 1,
      sym_heredoc_body,
  [89816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4366), 1,
      anon_sym_EQ,
    STATE(2820), 1,
      sym_heredoc_body,
  [89829] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4368), 1,
      anon_sym_end,
    STATE(2821), 1,
      sym_heredoc_body,
  [89842] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4370), 1,
      anon_sym_end,
    STATE(2822), 1,
      sym_heredoc_body,
  [89855] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4372), 1,
      anon_sym_RBRACE,
    STATE(2823), 1,
      sym_heredoc_body,
  [89868] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4374), 1,
      anon_sym_RBRACK,
    STATE(2824), 1,
      sym_heredoc_body,
  [89881] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(723), 1,
      anon_sym_RBRACE,
    STATE(2825), 1,
      sym_heredoc_body,
  [89894] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4376), 1,
      anon_sym_RPAREN,
    STATE(2826), 1,
      sym_heredoc_body,
  [89907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4378), 1,
      anon_sym_EQ,
    STATE(2827), 1,
      sym_heredoc_body,
  [89920] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4380), 1,
      anon_sym_RBRACK,
    STATE(2828), 1,
      sym_heredoc_body,
  [89933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4382), 1,
      anon_sym_EQ,
    STATE(2829), 1,
      sym_heredoc_body,
  [89946] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4384), 1,
      sym__line_break,
    STATE(2830), 1,
      sym_heredoc_body,
  [89959] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2831), 1,
      sym_heredoc_body,
    ACTIONS(4386), 2,
      sym_constant,
      sym_identifier,
  [89970] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4388), 1,
      anon_sym_RBRACE,
    STATE(2832), 1,
      sym_heredoc_body,
  [89983] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4390), 1,
      anon_sym_RBRACK,
    STATE(2833), 1,
      sym_heredoc_body,
  [89996] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(688), 1,
      anon_sym_RBRACE,
    STATE(2834), 1,
      sym_heredoc_body,
  [90009] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4392), 1,
      sym_identifier,
    STATE(2835), 1,
      sym_heredoc_body,
  [90022] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_RPAREN,
    STATE(2836), 1,
      sym_heredoc_body,
  [90035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4396), 1,
      anon_sym_EQ,
    STATE(2837), 1,
      sym_heredoc_body,
  [90048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4398), 1,
      anon_sym_EQ,
    STATE(2838), 1,
      sym_heredoc_body,
  [90061] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4400), 1,
      anon_sym_end,
    STATE(2839), 1,
      sym_heredoc_body,
  [90074] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4402), 1,
      anon_sym_RBRACK,
    STATE(2840), 1,
      sym_heredoc_body,
  [90087] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_end,
    STATE(2841), 1,
      sym_heredoc_body,
  [90100] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4406), 1,
      anon_sym_RBRACE,
    STATE(2842), 1,
      sym_heredoc_body,
  [90113] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_end,
    STATE(2843), 1,
      sym_heredoc_body,
  [90126] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_end,
    STATE(2844), 1,
      sym_heredoc_body,
  [90139] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_end,
    STATE(2845), 1,
      sym_heredoc_body,
  [90152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4410), 1,
      anon_sym_EQ,
    STATE(2846), 1,
      sym_heredoc_body,
  [90165] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COLON,
    STATE(2847), 1,
      sym_heredoc_body,
  [90178] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_RPAREN,
    STATE(2848), 1,
      sym_heredoc_body,
  [90191] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4414), 1,
      sym_identifier,
    STATE(2849), 1,
      sym_heredoc_body,
  [90204] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4416), 1,
      anon_sym_RBRACE,
    STATE(2850), 1,
      sym_heredoc_body,
  [90217] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4418), 1,
      ts_builtin_sym_end,
    STATE(2851), 1,
      sym_heredoc_body,
  [90230] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4420), 1,
      anon_sym_end,
    STATE(2852), 1,
      sym_heredoc_body,
  [90243] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3782), 1,
      anon_sym_end,
    STATE(2853), 1,
      sym_heredoc_body,
  [90256] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_end,
    STATE(2854), 1,
      sym_heredoc_body,
  [90269] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4422), 1,
      anon_sym_end,
    STATE(2855), 1,
      sym_heredoc_body,
  [90282] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__line_break,
    STATE(2856), 1,
      sym_heredoc_body,
  [90295] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4426), 1,
      anon_sym_LBRACE,
    STATE(2857), 1,
      sym_heredoc_body,
  [90308] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2858), 1,
      sym_heredoc_body,
    ACTIONS(4428), 2,
      sym_constant,
      sym_identifier,
  [90319] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4430), 1,
      sym_identifier,
    STATE(2859), 1,
      sym_heredoc_body,
  [90332] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2860), 1,
      sym_heredoc_body,
    ACTIONS(4432), 2,
      sym_constant,
      sym_identifier,
  [90343] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4434), 1,
      anon_sym_RBRACE,
    STATE(2861), 1,
      sym_heredoc_body,
  [90356] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_end,
    STATE(2862), 1,
      sym_heredoc_body,
  [90369] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4438), 1,
      anon_sym_RBRACK,
    STATE(2863), 1,
      sym_heredoc_body,
  [90382] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(701), 1,
      anon_sym_RBRACE,
    STATE(2864), 1,
      sym_heredoc_body,
  [90395] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4440), 1,
      anon_sym_RPAREN,
    STATE(2865), 1,
      sym_heredoc_body,
  [90408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4442), 1,
      anon_sym_EQ,
    STATE(2866), 1,
      sym_heredoc_body,
  [90421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4444), 1,
      anon_sym_EQ,
    STATE(2867), 1,
      sym_heredoc_body,
  [90434] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4446), 1,
      sym_identifier,
    STATE(2868), 1,
      sym_heredoc_body,
  [90447] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4448), 1,
      sym_identifier,
    STATE(2869), 1,
      sym_heredoc_body,
  [90460] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4450), 1,
      anon_sym_end,
    STATE(2870), 1,
      sym_heredoc_body,
  [90473] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4452), 1,
      sym_identifier,
    STATE(2871), 1,
      sym_heredoc_body,
  [90486] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4454), 1,
      anon_sym_LBRACE,
    STATE(2872), 1,
      sym_heredoc_body,
  [90499] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3518), 1,
      anon_sym_end,
    STATE(2873), 1,
      sym_heredoc_body,
  [90512] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2874), 1,
      sym_heredoc_body,
    ACTIONS(4456), 2,
      sym_constant,
      sym_identifier,
  [90523] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4458), 1,
      anon_sym_end,
    STATE(2875), 1,
      sym_heredoc_body,
  [90536] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4460), 1,
      anon_sym_end,
    STATE(2876), 1,
      sym_heredoc_body,
  [90549] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4462), 1,
      ts_builtin_sym_end,
    STATE(2877), 1,
      sym_heredoc_body,
  [90562] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_RBRACK,
    STATE(2878), 1,
      sym_heredoc_body,
  [90575] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_RBRACK,
    STATE(2879), 1,
      sym_heredoc_body,
  [90588] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4468), 1,
      sym_identifier,
    STATE(2880), 1,
      sym_heredoc_body,
  [90601] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_end,
    STATE(2881), 1,
      sym_heredoc_body,
  [90614] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_end,
    STATE(2882), 1,
      sym_heredoc_body,
  [90627] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2883), 1,
      sym_heredoc_body,
    ACTIONS(4474), 2,
      sym_constant,
      sym_identifier,
  [90638] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2884), 1,
      sym_heredoc_body,
    ACTIONS(4476), 2,
      sym_constant,
      sym_identifier,
  [90649] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_RBRACE,
    STATE(2885), 1,
      sym_heredoc_body,
  [90662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    STATE(2886), 1,
      sym_heredoc_body,
  [90675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4288), 1,
      anon_sym_EQ,
    STATE(2887), 1,
      sym_heredoc_body,
  [90688] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2888), 1,
      sym_heredoc_body,
    ACTIONS(4480), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [90699] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_end,
    STATE(2889), 1,
      sym_heredoc_body,
  [90712] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_RPAREN,
    STATE(2890), 1,
      sym_heredoc_body,
  [90725] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_end,
    STATE(2891), 1,
      sym_heredoc_body,
  [90738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4486), 1,
      anon_sym_EQ,
    STATE(2892), 1,
      sym_heredoc_body,
  [90751] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2893), 1,
      sym_heredoc_body,
    ACTIONS(4488), 2,
      sym_constant,
      sym_identifier,
  [90762] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4490), 1,
      sym__string_end,
    STATE(2894), 1,
      sym_heredoc_body,
  [90775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4492), 1,
      anon_sym_EQ,
    STATE(2895), 1,
      sym_heredoc_body,
  [90788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4494), 1,
      anon_sym_EQ,
    STATE(2896), 1,
      sym_heredoc_body,
  [90801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4496), 1,
      anon_sym_EQ,
    STATE(2897), 1,
      sym_heredoc_body,
  [90814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4498), 1,
      sym_uninterpreted,
    STATE(2898), 1,
      sym_heredoc_body,
  [90827] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2899), 1,
      sym_heredoc_body,
    ACTIONS(4500), 2,
      sym_constant,
      sym_identifier,
  [90838] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_end,
    STATE(2900), 1,
      sym_heredoc_body,
  [90851] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4504), 1,
      anon_sym_RPAREN,
    STATE(2901), 1,
      sym_heredoc_body,
  [90864] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_end,
    STATE(2902), 1,
      sym_heredoc_body,
  [90877] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_end,
    STATE(2903), 1,
      sym_heredoc_body,
  [90890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    STATE(2904), 1,
      sym_heredoc_body,
  [90903] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_end,
    STATE(2905), 1,
      sym_heredoc_body,
  [90916] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_RBRACE,
    STATE(2906), 1,
      sym_heredoc_body,
  [90929] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_end,
    STATE(2907), 1,
      sym_heredoc_body,
  [90942] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym_end,
    STATE(2908), 1,
      sym_heredoc_body,
  [90955] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4514), 1,
      anon_sym_end,
    STATE(2909), 1,
      sym_heredoc_body,
  [90968] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4516), 1,
      anon_sym_end,
    STATE(2910), 1,
      sym_heredoc_body,
  [90981] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_end,
    STATE(2911), 1,
      sym_heredoc_body,
  [90994] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4520), 1,
      anon_sym_end,
    STATE(2912), 1,
      sym_heredoc_body,
  [91007] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_COLON,
    STATE(2913), 1,
      sym_heredoc_body,
  [91020] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_RBRACE,
    STATE(2914), 1,
      sym_heredoc_body,
  [91033] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_end,
    STATE(2915), 1,
      sym_heredoc_body,
  [91046] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_RPAREN,
    STATE(2916), 1,
      sym_heredoc_body,
  [91059] = 3,
    ACTIONS(73), 1,
      sym_comment,
    STATE(2917), 1,
      sym_heredoc_body,
    ACTIONS(4524), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [91070] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4526), 1,
      sym__string_end,
    STATE(2918), 1,
      sym_heredoc_body,
  [91083] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4528), 1,
      sym__string_end,
    STATE(2919), 1,
      sym_heredoc_body,
  [91096] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4530), 1,
      sym__string_end,
    STATE(2920), 1,
      sym_heredoc_body,
  [91109] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4532), 1,
      anon_sym_RBRACK,
    STATE(2921), 1,
      sym_heredoc_body,
  [91122] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_RPAREN,
    STATE(2922), 1,
      sym_heredoc_body,
  [91135] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(73), 1,
      sym_comment,
    ACTIONS(4536), 1,
      anon_sym_RPAREN,
    STATE(2923), 1,
      sym_heredoc_body,
  [91148] = 2,
    ACTIONS(4240), 1,
      anon_sym_in,
    STATE(2669), 1,
      sym_in,
  [91155] = 1,
    ACTIONS(4538), 1,
      anon_sym_RBRACE,
  [91159] = 1,
    ACTIONS(3966), 1,
      anon_sym_end,
  [91163] = 1,
    ACTIONS(741), 1,
      anon_sym_RBRACE,
  [91167] = 1,
    ACTIONS(4540), 1,
      anon_sym_EQ,
  [91171] = 1,
    ACTIONS(3668), 1,
      anon_sym_end,
  [91175] = 1,
    ACTIONS(4542), 1,
      anon_sym_RPAREN,
  [91179] = 1,
    ACTIONS(4544), 1,
      anon_sym_end,
  [91183] = 1,
    ACTIONS(4546), 1,
      sym__string_end,
  [91187] = 1,
    ACTIONS(4548), 1,
      anon_sym_end,
  [91191] = 1,
    ACTIONS(3654), 1,
      anon_sym_end,
  [91195] = 1,
    ACTIONS(4550), 1,
      anon_sym_end,
  [91199] = 1,
    ACTIONS(4552), 1,
      anon_sym_RBRACK,
  [91203] = 1,
    ACTIONS(4554), 1,
      anon_sym_RBRACE,
  [91207] = 1,
    ACTIONS(4556), 1,
      anon_sym_end,
  [91211] = 1,
    ACTIONS(4000), 1,
      anon_sym_end,
  [91215] = 1,
    ACTIONS(4558), 1,
      anon_sym_end,
  [91219] = 1,
    ACTIONS(729), 1,
      anon_sym_RBRACE,
  [91223] = 1,
    ACTIONS(4560), 1,
      anon_sym_RBRACE,
  [91227] = 1,
    ACTIONS(4562), 1,
      ts_builtin_sym_end,
  [91231] = 1,
    ACTIONS(4564), 1,
      anon_sym_RPAREN,
  [91235] = 1,
    ACTIONS(4566), 1,
      anon_sym_RBRACE,
  [91239] = 1,
    ACTIONS(4568), 1,
      anon_sym_EQ,
  [91243] = 1,
    ACTIONS(4570), 1,
      anon_sym_EQ,
  [91247] = 1,
    ACTIONS(4572), 1,
      anon_sym_end,
  [91251] = 1,
    ACTIONS(4574), 1,
      anon_sym_end,
  [91255] = 1,
    ACTIONS(743), 1,
      anon_sym_RBRACE,
  [91259] = 1,
    ACTIONS(4576), 1,
      anon_sym_RPAREN,
  [91263] = 1,
    ACTIONS(4578), 1,
      sym__string_end,
  [91267] = 1,
    ACTIONS(4580), 1,
      anon_sym_RBRACK,
  [91271] = 1,
    ACTIONS(4582), 1,
      anon_sym_RBRACK,
  [91275] = 1,
    ACTIONS(2590), 1,
      anon_sym_COLON,
  [91279] = 1,
    ACTIONS(4584), 1,
      anon_sym_EQ,
  [91283] = 1,
    ACTIONS(4586), 1,
      anon_sym_EQ,
  [91287] = 1,
    ACTIONS(4588), 1,
      anon_sym_LBRACE,
  [91291] = 1,
    ACTIONS(4590), 1,
      anon_sym_LBRACE,
  [91295] = 1,
    ACTIONS(4592), 1,
      anon_sym_RPAREN,
  [91299] = 1,
    ACTIONS(745), 1,
      anon_sym_RBRACE,
  [91303] = 1,
    ACTIONS(4594), 1,
      anon_sym_RBRACE,
  [91307] = 1,
    ACTIONS(4596), 1,
      anon_sym_EQ,
  [91311] = 1,
    ACTIONS(4598), 1,
      anon_sym_RPAREN,
  [91315] = 1,
    ACTIONS(4600), 1,
      anon_sym_RPAREN,
  [91319] = 1,
    ACTIONS(4602), 1,
      ts_builtin_sym_end,
  [91323] = 1,
    ACTIONS(2500), 1,
      anon_sym_COLON,
  [91327] = 1,
    ACTIONS(4604), 1,
      anon_sym_RBRACE,
  [91331] = 1,
    ACTIONS(4606), 1,
      anon_sym_EQ,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(965)] = 0,
  [SMALL_STATE(966)] = 74,
  [SMALL_STATE(967)] = 148,
  [SMALL_STATE(968)] = 222,
  [SMALL_STATE(969)] = 296,
  [SMALL_STATE(970)] = 369,
  [SMALL_STATE(971)] = 442,
  [SMALL_STATE(972)] = 525,
  [SMALL_STATE(973)] = 598,
  [SMALL_STATE(974)] = 671,
  [SMALL_STATE(975)] = 744,
  [SMALL_STATE(976)] = 817,
  [SMALL_STATE(977)] = 890,
  [SMALL_STATE(978)] = 963,
  [SMALL_STATE(979)] = 1044,
  [SMALL_STATE(980)] = 1126,
  [SMALL_STATE(981)] = 1210,
  [SMALL_STATE(982)] = 1290,
  [SMALL_STATE(983)] = 1369,
  [SMALL_STATE(984)] = 1448,
  [SMALL_STATE(985)] = 1527,
  [SMALL_STATE(986)] = 1604,
  [SMALL_STATE(987)] = 1683,
  [SMALL_STATE(988)] = 1754,
  [SMALL_STATE(989)] = 1829,
  [SMALL_STATE(990)] = 1906,
  [SMALL_STATE(991)] = 1983,
  [SMALL_STATE(992)] = 2054,
  [SMALL_STATE(993)] = 2130,
  [SMALL_STATE(994)] = 2204,
  [SMALL_STATE(995)] = 2280,
  [SMALL_STATE(996)] = 2354,
  [SMALL_STATE(997)] = 2428,
  [SMALL_STATE(998)] = 2496,
  [SMALL_STATE(999)] = 2578,
  [SMALL_STATE(1000)] = 2646,
  [SMALL_STATE(1001)] = 2714,
  [SMALL_STATE(1002)] = 2782,
  [SMALL_STATE(1003)] = 2850,
  [SMALL_STATE(1004)] = 2926,
  [SMALL_STATE(1005)] = 3004,
  [SMALL_STATE(1006)] = 3072,
  [SMALL_STATE(1007)] = 3139,
  [SMALL_STATE(1008)] = 3208,
  [SMALL_STATE(1009)] = 3275,
  [SMALL_STATE(1010)] = 3348,
  [SMALL_STATE(1011)] = 3415,
  [SMALL_STATE(1012)] = 3484,
  [SMALL_STATE(1013)] = 3551,
  [SMALL_STATE(1014)] = 3618,
  [SMALL_STATE(1015)] = 3685,
  [SMALL_STATE(1016)] = 3754,
  [SMALL_STATE(1017)] = 3827,
  [SMALL_STATE(1018)] = 3896,
  [SMALL_STATE(1019)] = 3965,
  [SMALL_STATE(1020)] = 4032,
  [SMALL_STATE(1021)] = 4101,
  [SMALL_STATE(1022)] = 4168,
  [SMALL_STATE(1023)] = 4235,
  [SMALL_STATE(1024)] = 4302,
  [SMALL_STATE(1025)] = 4375,
  [SMALL_STATE(1026)] = 4442,
  [SMALL_STATE(1027)] = 4509,
  [SMALL_STATE(1028)] = 4576,
  [SMALL_STATE(1029)] = 4643,
  [SMALL_STATE(1030)] = 4710,
  [SMALL_STATE(1031)] = 4783,
  [SMALL_STATE(1032)] = 4850,
  [SMALL_STATE(1033)] = 4917,
  [SMALL_STATE(1034)] = 4984,
  [SMALL_STATE(1035)] = 5057,
  [SMALL_STATE(1036)] = 5124,
  [SMALL_STATE(1037)] = 5201,
  [SMALL_STATE(1038)] = 5268,
  [SMALL_STATE(1039)] = 5337,
  [SMALL_STATE(1040)] = 5410,
  [SMALL_STATE(1041)] = 5477,
  [SMALL_STATE(1042)] = 5546,
  [SMALL_STATE(1043)] = 5613,
  [SMALL_STATE(1044)] = 5680,
  [SMALL_STATE(1045)] = 5753,
  [SMALL_STATE(1046)] = 5822,
  [SMALL_STATE(1047)] = 5891,
  [SMALL_STATE(1048)] = 5960,
  [SMALL_STATE(1049)] = 6027,
  [SMALL_STATE(1050)] = 6094,
  [SMALL_STATE(1051)] = 6160,
  [SMALL_STATE(1052)] = 6228,
  [SMALL_STATE(1053)] = 6296,
  [SMALL_STATE(1054)] = 6364,
  [SMALL_STATE(1055)] = 6432,
  [SMALL_STATE(1056)] = 6500,
  [SMALL_STATE(1057)] = 6572,
  [SMALL_STATE(1058)] = 6638,
  [SMALL_STATE(1059)] = 6706,
  [SMALL_STATE(1060)] = 6774,
  [SMALL_STATE(1061)] = 6840,
  [SMALL_STATE(1062)] = 6908,
  [SMALL_STATE(1063)] = 6974,
  [SMALL_STATE(1064)] = 7040,
  [SMALL_STATE(1065)] = 7108,
  [SMALL_STATE(1066)] = 7176,
  [SMALL_STATE(1067)] = 7244,
  [SMALL_STATE(1068)] = 7312,
  [SMALL_STATE(1069)] = 7380,
  [SMALL_STATE(1070)] = 7448,
  [SMALL_STATE(1071)] = 7516,
  [SMALL_STATE(1072)] = 7584,
  [SMALL_STATE(1073)] = 7652,
  [SMALL_STATE(1074)] = 7718,
  [SMALL_STATE(1075)] = 7788,
  [SMALL_STATE(1076)] = 7854,
  [SMALL_STATE(1077)] = 7920,
  [SMALL_STATE(1078)] = 7988,
  [SMALL_STATE(1079)] = 8054,
  [SMALL_STATE(1080)] = 8120,
  [SMALL_STATE(1081)] = 8186,
  [SMALL_STATE(1082)] = 8252,
  [SMALL_STATE(1083)] = 8318,
  [SMALL_STATE(1084)] = 8386,
  [SMALL_STATE(1085)] = 8462,
  [SMALL_STATE(1086)] = 8528,
  [SMALL_STATE(1087)] = 8598,
  [SMALL_STATE(1088)] = 8664,
  [SMALL_STATE(1089)] = 8734,
  [SMALL_STATE(1090)] = 8800,
  [SMALL_STATE(1091)] = 8866,
  [SMALL_STATE(1092)] = 8934,
  [SMALL_STATE(1093)] = 9000,
  [SMALL_STATE(1094)] = 9068,
  [SMALL_STATE(1095)] = 9135,
  [SMALL_STATE(1096)] = 9202,
  [SMALL_STATE(1097)] = 9269,
  [SMALL_STATE(1098)] = 9336,
  [SMALL_STATE(1099)] = 9403,
  [SMALL_STATE(1100)] = 9470,
  [SMALL_STATE(1101)] = 9537,
  [SMALL_STATE(1102)] = 9604,
  [SMALL_STATE(1103)] = 9671,
  [SMALL_STATE(1104)] = 9738,
  [SMALL_STATE(1105)] = 9805,
  [SMALL_STATE(1106)] = 9872,
  [SMALL_STATE(1107)] = 9939,
  [SMALL_STATE(1108)] = 10006,
  [SMALL_STATE(1109)] = 10073,
  [SMALL_STATE(1110)] = 10140,
  [SMALL_STATE(1111)] = 10207,
  [SMALL_STATE(1112)] = 10278,
  [SMALL_STATE(1113)] = 10345,
  [SMALL_STATE(1114)] = 10412,
  [SMALL_STATE(1115)] = 10487,
  [SMALL_STATE(1116)] = 10554,
  [SMALL_STATE(1117)] = 10621,
  [SMALL_STATE(1118)] = 10688,
  [SMALL_STATE(1119)] = 10755,
  [SMALL_STATE(1120)] = 10822,
  [SMALL_STATE(1121)] = 10889,
  [SMALL_STATE(1122)] = 10956,
  [SMALL_STATE(1123)] = 11023,
  [SMALL_STATE(1124)] = 11090,
  [SMALL_STATE(1125)] = 11157,
  [SMALL_STATE(1126)] = 11224,
  [SMALL_STATE(1127)] = 11291,
  [SMALL_STATE(1128)] = 11358,
  [SMALL_STATE(1129)] = 11425,
  [SMALL_STATE(1130)] = 11492,
  [SMALL_STATE(1131)] = 11559,
  [SMALL_STATE(1132)] = 11626,
  [SMALL_STATE(1133)] = 11693,
  [SMALL_STATE(1134)] = 11760,
  [SMALL_STATE(1135)] = 11827,
  [SMALL_STATE(1136)] = 11894,
  [SMALL_STATE(1137)] = 11961,
  [SMALL_STATE(1138)] = 12028,
  [SMALL_STATE(1139)] = 12105,
  [SMALL_STATE(1140)] = 12172,
  [SMALL_STATE(1141)] = 12239,
  [SMALL_STATE(1142)] = 12306,
  [SMALL_STATE(1143)] = 12373,
  [SMALL_STATE(1144)] = 12446,
  [SMALL_STATE(1145)] = 12513,
  [SMALL_STATE(1146)] = 12580,
  [SMALL_STATE(1147)] = 12647,
  [SMALL_STATE(1148)] = 12714,
  [SMALL_STATE(1149)] = 12781,
  [SMALL_STATE(1150)] = 12848,
  [SMALL_STATE(1151)] = 12915,
  [SMALL_STATE(1152)] = 12982,
  [SMALL_STATE(1153)] = 13053,
  [SMALL_STATE(1154)] = 13120,
  [SMALL_STATE(1155)] = 13187,
  [SMALL_STATE(1156)] = 13260,
  [SMALL_STATE(1157)] = 13327,
  [SMALL_STATE(1158)] = 13394,
  [SMALL_STATE(1159)] = 13461,
  [SMALL_STATE(1160)] = 13528,
  [SMALL_STATE(1161)] = 13595,
  [SMALL_STATE(1162)] = 13662,
  [SMALL_STATE(1163)] = 13729,
  [SMALL_STATE(1164)] = 13796,
  [SMALL_STATE(1165)] = 13863,
  [SMALL_STATE(1166)] = 13930,
  [SMALL_STATE(1167)] = 13997,
  [SMALL_STATE(1168)] = 14064,
  [SMALL_STATE(1169)] = 14131,
  [SMALL_STATE(1170)] = 14198,
  [SMALL_STATE(1171)] = 14265,
  [SMALL_STATE(1172)] = 14332,
  [SMALL_STATE(1173)] = 14399,
  [SMALL_STATE(1174)] = 14466,
  [SMALL_STATE(1175)] = 14533,
  [SMALL_STATE(1176)] = 14600,
  [SMALL_STATE(1177)] = 14667,
  [SMALL_STATE(1178)] = 14734,
  [SMALL_STATE(1179)] = 14801,
  [SMALL_STATE(1180)] = 14868,
  [SMALL_STATE(1181)] = 14935,
  [SMALL_STATE(1182)] = 15002,
  [SMALL_STATE(1183)] = 15069,
  [SMALL_STATE(1184)] = 15136,
  [SMALL_STATE(1185)] = 15203,
  [SMALL_STATE(1186)] = 15270,
  [SMALL_STATE(1187)] = 15337,
  [SMALL_STATE(1188)] = 15404,
  [SMALL_STATE(1189)] = 15471,
  [SMALL_STATE(1190)] = 15538,
  [SMALL_STATE(1191)] = 15605,
  [SMALL_STATE(1192)] = 15672,
  [SMALL_STATE(1193)] = 15739,
  [SMALL_STATE(1194)] = 15806,
  [SMALL_STATE(1195)] = 15873,
  [SMALL_STATE(1196)] = 15945,
  [SMALL_STATE(1197)] = 16017,
  [SMALL_STATE(1198)] = 16091,
  [SMALL_STATE(1199)] = 16162,
  [SMALL_STATE(1200)] = 16235,
  [SMALL_STATE(1201)] = 16308,
  [SMALL_STATE(1202)] = 16379,
  [SMALL_STATE(1203)] = 16450,
  [SMALL_STATE(1204)] = 16521,
  [SMALL_STATE(1205)] = 16585,
  [SMALL_STATE(1206)] = 16649,
  [SMALL_STATE(1207)] = 16713,
  [SMALL_STATE(1208)] = 16777,
  [SMALL_STATE(1209)] = 16841,
  [SMALL_STATE(1210)] = 16905,
  [SMALL_STATE(1211)] = 16975,
  [SMALL_STATE(1212)] = 17039,
  [SMALL_STATE(1213)] = 17103,
  [SMALL_STATE(1214)] = 17167,
  [SMALL_STATE(1215)] = 17231,
  [SMALL_STATE(1216)] = 17295,
  [SMALL_STATE(1217)] = 17367,
  [SMALL_STATE(1218)] = 17431,
  [SMALL_STATE(1219)] = 17499,
  [SMALL_STATE(1220)] = 17563,
  [SMALL_STATE(1221)] = 17627,
  [SMALL_STATE(1222)] = 17691,
  [SMALL_STATE(1223)] = 17755,
  [SMALL_STATE(1224)] = 17819,
  [SMALL_STATE(1225)] = 17885,
  [SMALL_STATE(1226)] = 17979,
  [SMALL_STATE(1227)] = 18043,
  [SMALL_STATE(1228)] = 18107,
  [SMALL_STATE(1229)] = 18171,
  [SMALL_STATE(1230)] = 18237,
  [SMALL_STATE(1231)] = 18302,
  [SMALL_STATE(1232)] = 18393,
  [SMALL_STATE(1233)] = 18484,
  [SMALL_STATE(1234)] = 18575,
  [SMALL_STATE(1235)] = 18640,
  [SMALL_STATE(1236)] = 18703,
  [SMALL_STATE(1237)] = 18788,
  [SMALL_STATE(1238)] = 18859,
  [SMALL_STATE(1239)] = 18922,
  [SMALL_STATE(1240)] = 18991,
  [SMALL_STATE(1241)] = 19062,
  [SMALL_STATE(1242)] = 19147,
  [SMALL_STATE(1243)] = 19238,
  [SMALL_STATE(1244)] = 19329,
  [SMALL_STATE(1245)] = 19418,
  [SMALL_STATE(1246)] = 19511,
  [SMALL_STATE(1247)] = 19580,
  [SMALL_STATE(1248)] = 19657,
  [SMALL_STATE(1249)] = 19728,
  [SMALL_STATE(1250)] = 19801,
  [SMALL_STATE(1251)] = 19866,
  [SMALL_STATE(1252)] = 19933,
  [SMALL_STATE(1253)] = 20000,
  [SMALL_STATE(1254)] = 20065,
  [SMALL_STATE(1255)] = 20156,
  [SMALL_STATE(1256)] = 20221,
  [SMALL_STATE(1257)] = 20284,
  [SMALL_STATE(1258)] = 20347,
  [SMALL_STATE(1259)] = 20418,
  [SMALL_STATE(1260)] = 20509,
  [SMALL_STATE(1261)] = 20602,
  [SMALL_STATE(1262)] = 20694,
  [SMALL_STATE(1263)] = 20784,
  [SMALL_STATE(1264)] = 20848,
  [SMALL_STATE(1265)] = 20918,
  [SMALL_STATE(1266)] = 20994,
  [SMALL_STATE(1267)] = 21084,
  [SMALL_STATE(1268)] = 21154,
  [SMALL_STATE(1269)] = 21218,
  [SMALL_STATE(1270)] = 21306,
  [SMALL_STATE(1271)] = 21372,
  [SMALL_STATE(1272)] = 21462,
  [SMALL_STATE(1273)] = 21546,
  [SMALL_STATE(1274)] = 21610,
  [SMALL_STATE(1275)] = 21676,
  [SMALL_STATE(1276)] = 21744,
  [SMALL_STATE(1277)] = 21828,
  [SMALL_STATE(1278)] = 21892,
  [SMALL_STATE(1279)] = 21982,
  [SMALL_STATE(1280)] = 22072,
  [SMALL_STATE(1281)] = 22162,
  [SMALL_STATE(1282)] = 22252,
  [SMALL_STATE(1283)] = 22342,
  [SMALL_STATE(1284)] = 22432,
  [SMALL_STATE(1285)] = 22522,
  [SMALL_STATE(1286)] = 22586,
  [SMALL_STATE(1287)] = 22658,
  [SMALL_STATE(1288)] = 22748,
  [SMALL_STATE(1289)] = 22815,
  [SMALL_STATE(1290)] = 22904,
  [SMALL_STATE(1291)] = 22967,
  [SMALL_STATE(1292)] = 23050,
  [SMALL_STATE(1293)] = 23139,
  [SMALL_STATE(1294)] = 23228,
  [SMALL_STATE(1295)] = 23317,
  [SMALL_STATE(1296)] = 23400,
  [SMALL_STATE(1297)] = 23487,
  [SMALL_STATE(1298)] = 23576,
  [SMALL_STATE(1299)] = 23651,
  [SMALL_STATE(1300)] = 23744,
  [SMALL_STATE(1301)] = 23813,
  [SMALL_STATE(1302)] = 23902,
  [SMALL_STATE(1303)] = 23965,
  [SMALL_STATE(1304)] = 24030,
  [SMALL_STATE(1305)] = 24101,
  [SMALL_STATE(1306)] = 24164,
  [SMALL_STATE(1307)] = 24255,
  [SMALL_STATE(1308)] = 24318,
  [SMALL_STATE(1309)] = 24383,
  [SMALL_STATE(1310)] = 24474,
  [SMALL_STATE(1311)] = 24537,
  [SMALL_STATE(1312)] = 24602,
  [SMALL_STATE(1313)] = 24695,
  [SMALL_STATE(1314)] = 24784,
  [SMALL_STATE(1315)] = 24875,
  [SMALL_STATE(1316)] = 24937,
  [SMALL_STATE(1317)] = 25025,
  [SMALL_STATE(1318)] = 25113,
  [SMALL_STATE(1319)] = 25201,
  [SMALL_STATE(1320)] = 25289,
  [SMALL_STATE(1321)] = 25377,
  [SMALL_STATE(1322)] = 25465,
  [SMALL_STATE(1323)] = 25553,
  [SMALL_STATE(1324)] = 25641,
  [SMALL_STATE(1325)] = 25729,
  [SMALL_STATE(1326)] = 25811,
  [SMALL_STATE(1327)] = 25877,
  [SMALL_STATE(1328)] = 25959,
  [SMALL_STATE(1329)] = 26047,
  [SMALL_STATE(1330)] = 26133,
  [SMALL_STATE(1331)] = 26207,
  [SMALL_STATE(1332)] = 26275,
  [SMALL_STATE(1333)] = 26337,
  [SMALL_STATE(1334)] = 26425,
  [SMALL_STATE(1335)] = 26513,
  [SMALL_STATE(1336)] = 26583,
  [SMALL_STATE(1337)] = 26647,
  [SMALL_STATE(1338)] = 26709,
  [SMALL_STATE(1339)] = 26782,
  [SMALL_STATE(1340)] = 26849,
  [SMALL_STATE(1341)] = 26936,
  [SMALL_STATE(1342)] = 27017,
  [SMALL_STATE(1343)] = 27098,
  [SMALL_STATE(1344)] = 27185,
  [SMALL_STATE(1345)] = 27272,
  [SMALL_STATE(1346)] = 27357,
  [SMALL_STATE(1347)] = 27424,
  [SMALL_STATE(1348)] = 27493,
  [SMALL_STATE(1349)] = 27580,
  [SMALL_STATE(1350)] = 27643,
  [SMALL_STATE(1351)] = 27704,
  [SMALL_STATE(1352)] = 27765,
  [SMALL_STATE(1353)] = 27852,
  [SMALL_STATE(1354)] = 27917,
  [SMALL_STATE(1355)] = 28004,
  [SMALL_STATE(1356)] = 28071,
  [SMALL_STATE(1357)] = 28134,
  [SMALL_STATE(1358)] = 28221,
  [SMALL_STATE(1359)] = 28282,
  [SMALL_STATE(1360)] = 28360,
  [SMALL_STATE(1361)] = 28438,
  [SMALL_STATE(1362)] = 28496,
  [SMALL_STATE(1363)] = 28556,
  [SMALL_STATE(1364)] = 28634,
  [SMALL_STATE(1365)] = 28694,
  [SMALL_STATE(1366)] = 28757,
  [SMALL_STATE(1367)] = 28816,
  [SMALL_STATE(1368)] = 28879,
  [SMALL_STATE(1369)] = 28934,
  [SMALL_STATE(1370)] = 28995,
  [SMALL_STATE(1371)] = 29056,
  [SMALL_STATE(1372)] = 29115,
  [SMALL_STATE(1373)] = 29176,
  [SMALL_STATE(1374)] = 29235,
  [SMALL_STATE(1375)] = 29294,
  [SMALL_STATE(1376)] = 29353,
  [SMALL_STATE(1377)] = 29414,
  [SMALL_STATE(1378)] = 29489,
  [SMALL_STATE(1379)] = 29550,
  [SMALL_STATE(1380)] = 29609,
  [SMALL_STATE(1381)] = 29664,
  [SMALL_STATE(1382)] = 29725,
  [SMALL_STATE(1383)] = 29786,
  [SMALL_STATE(1384)] = 29847,
  [SMALL_STATE(1385)] = 29905,
  [SMALL_STATE(1386)] = 29961,
  [SMALL_STATE(1387)] = 30025,
  [SMALL_STATE(1388)] = 30081,
  [SMALL_STATE(1389)] = 30137,
  [SMALL_STATE(1390)] = 30193,
  [SMALL_STATE(1391)] = 30251,
  [SMALL_STATE(1392)] = 30307,
  [SMALL_STATE(1393)] = 30360,
  [SMALL_STATE(1394)] = 30415,
  [SMALL_STATE(1395)] = 30468,
  [SMALL_STATE(1396)] = 30521,
  [SMALL_STATE(1397)] = 30574,
  [SMALL_STATE(1398)] = 30627,
  [SMALL_STATE(1399)] = 30680,
  [SMALL_STATE(1400)] = 30733,
  [SMALL_STATE(1401)] = 30786,
  [SMALL_STATE(1402)] = 30839,
  [SMALL_STATE(1403)] = 30892,
  [SMALL_STATE(1404)] = 30947,
  [SMALL_STATE(1405)] = 31002,
  [SMALL_STATE(1406)] = 31057,
  [SMALL_STATE(1407)] = 31112,
  [SMALL_STATE(1408)] = 31165,
  [SMALL_STATE(1409)] = 31220,
  [SMALL_STATE(1410)] = 31273,
  [SMALL_STATE(1411)] = 31328,
  [SMALL_STATE(1412)] = 31381,
  [SMALL_STATE(1413)] = 31434,
  [SMALL_STATE(1414)] = 31487,
  [SMALL_STATE(1415)] = 31540,
  [SMALL_STATE(1416)] = 31593,
  [SMALL_STATE(1417)] = 31646,
  [SMALL_STATE(1418)] = 31699,
  [SMALL_STATE(1419)] = 31752,
  [SMALL_STATE(1420)] = 31805,
  [SMALL_STATE(1421)] = 31860,
  [SMALL_STATE(1422)] = 31913,
  [SMALL_STATE(1423)] = 31974,
  [SMALL_STATE(1424)] = 32027,
  [SMALL_STATE(1425)] = 32082,
  [SMALL_STATE(1426)] = 32135,
  [SMALL_STATE(1427)] = 32188,
  [SMALL_STATE(1428)] = 32243,
  [SMALL_STATE(1429)] = 32296,
  [SMALL_STATE(1430)] = 32349,
  [SMALL_STATE(1431)] = 32402,
  [SMALL_STATE(1432)] = 32455,
  [SMALL_STATE(1433)] = 32510,
  [SMALL_STATE(1434)] = 32565,
  [SMALL_STATE(1435)] = 32618,
  [SMALL_STATE(1436)] = 32671,
  [SMALL_STATE(1437)] = 32726,
  [SMALL_STATE(1438)] = 32781,
  [SMALL_STATE(1439)] = 32836,
  [SMALL_STATE(1440)] = 32889,
  [SMALL_STATE(1441)] = 32944,
  [SMALL_STATE(1442)] = 32999,
  [SMALL_STATE(1443)] = 33054,
  [SMALL_STATE(1444)] = 33109,
  [SMALL_STATE(1445)] = 33164,
  [SMALL_STATE(1446)] = 33219,
  [SMALL_STATE(1447)] = 33272,
  [SMALL_STATE(1448)] = 33325,
  [SMALL_STATE(1449)] = 33380,
  [SMALL_STATE(1450)] = 33433,
  [SMALL_STATE(1451)] = 33486,
  [SMALL_STATE(1452)] = 33541,
  [SMALL_STATE(1453)] = 33596,
  [SMALL_STATE(1454)] = 33651,
  [SMALL_STATE(1455)] = 33706,
  [SMALL_STATE(1456)] = 33761,
  [SMALL_STATE(1457)] = 33816,
  [SMALL_STATE(1458)] = 33869,
  [SMALL_STATE(1459)] = 33922,
  [SMALL_STATE(1460)] = 33975,
  [SMALL_STATE(1461)] = 34030,
  [SMALL_STATE(1462)] = 34091,
  [SMALL_STATE(1463)] = 34146,
  [SMALL_STATE(1464)] = 34201,
  [SMALL_STATE(1465)] = 34256,
  [SMALL_STATE(1466)] = 34309,
  [SMALL_STATE(1467)] = 34364,
  [SMALL_STATE(1468)] = 34417,
  [SMALL_STATE(1469)] = 34470,
  [SMALL_STATE(1470)] = 34525,
  [SMALL_STATE(1471)] = 34580,
  [SMALL_STATE(1472)] = 34635,
  [SMALL_STATE(1473)] = 34690,
  [SMALL_STATE(1474)] = 34745,
  [SMALL_STATE(1475)] = 34800,
  [SMALL_STATE(1476)] = 34855,
  [SMALL_STATE(1477)] = 34910,
  [SMALL_STATE(1478)] = 34965,
  [SMALL_STATE(1479)] = 35018,
  [SMALL_STATE(1480)] = 35073,
  [SMALL_STATE(1481)] = 35128,
  [SMALL_STATE(1482)] = 35183,
  [SMALL_STATE(1483)] = 35236,
  [SMALL_STATE(1484)] = 35289,
  [SMALL_STATE(1485)] = 35344,
  [SMALL_STATE(1486)] = 35397,
  [SMALL_STATE(1487)] = 35452,
  [SMALL_STATE(1488)] = 35505,
  [SMALL_STATE(1489)] = 35558,
  [SMALL_STATE(1490)] = 35611,
  [SMALL_STATE(1491)] = 35664,
  [SMALL_STATE(1492)] = 35717,
  [SMALL_STATE(1493)] = 35770,
  [SMALL_STATE(1494)] = 35823,
  [SMALL_STATE(1495)] = 35876,
  [SMALL_STATE(1496)] = 35929,
  [SMALL_STATE(1497)] = 35982,
  [SMALL_STATE(1498)] = 36035,
  [SMALL_STATE(1499)] = 36088,
  [SMALL_STATE(1500)] = 36141,
  [SMALL_STATE(1501)] = 36196,
  [SMALL_STATE(1502)] = 36251,
  [SMALL_STATE(1503)] = 36304,
  [SMALL_STATE(1504)] = 36357,
  [SMALL_STATE(1505)] = 36410,
  [SMALL_STATE(1506)] = 36463,
  [SMALL_STATE(1507)] = 36516,
  [SMALL_STATE(1508)] = 36569,
  [SMALL_STATE(1509)] = 36622,
  [SMALL_STATE(1510)] = 36675,
  [SMALL_STATE(1511)] = 36730,
  [SMALL_STATE(1512)] = 36785,
  [SMALL_STATE(1513)] = 36840,
  [SMALL_STATE(1514)] = 36895,
  [SMALL_STATE(1515)] = 36948,
  [SMALL_STATE(1516)] = 37003,
  [SMALL_STATE(1517)] = 37056,
  [SMALL_STATE(1518)] = 37109,
  [SMALL_STATE(1519)] = 37162,
  [SMALL_STATE(1520)] = 37215,
  [SMALL_STATE(1521)] = 37270,
  [SMALL_STATE(1522)] = 37323,
  [SMALL_STATE(1523)] = 37378,
  [SMALL_STATE(1524)] = 37433,
  [SMALL_STATE(1525)] = 37488,
  [SMALL_STATE(1526)] = 37543,
  [SMALL_STATE(1527)] = 37596,
  [SMALL_STATE(1528)] = 37649,
  [SMALL_STATE(1529)] = 37702,
  [SMALL_STATE(1530)] = 37757,
  [SMALL_STATE(1531)] = 37812,
  [SMALL_STATE(1532)] = 37867,
  [SMALL_STATE(1533)] = 37922,
  [SMALL_STATE(1534)] = 37977,
  [SMALL_STATE(1535)] = 38032,
  [SMALL_STATE(1536)] = 38087,
  [SMALL_STATE(1537)] = 38142,
  [SMALL_STATE(1538)] = 38195,
  [SMALL_STATE(1539)] = 38250,
  [SMALL_STATE(1540)] = 38305,
  [SMALL_STATE(1541)] = 38360,
  [SMALL_STATE(1542)] = 38415,
  [SMALL_STATE(1543)] = 38470,
  [SMALL_STATE(1544)] = 38525,
  [SMALL_STATE(1545)] = 38580,
  [SMALL_STATE(1546)] = 38635,
  [SMALL_STATE(1547)] = 38688,
  [SMALL_STATE(1548)] = 38743,
  [SMALL_STATE(1549)] = 38796,
  [SMALL_STATE(1550)] = 38851,
  [SMALL_STATE(1551)] = 38904,
  [SMALL_STATE(1552)] = 38957,
  [SMALL_STATE(1553)] = 39012,
  [SMALL_STATE(1554)] = 39067,
  [SMALL_STATE(1555)] = 39120,
  [SMALL_STATE(1556)] = 39175,
  [SMALL_STATE(1557)] = 39230,
  [SMALL_STATE(1558)] = 39283,
  [SMALL_STATE(1559)] = 39338,
  [SMALL_STATE(1560)] = 39391,
  [SMALL_STATE(1561)] = 39446,
  [SMALL_STATE(1562)] = 39501,
  [SMALL_STATE(1563)] = 39554,
  [SMALL_STATE(1564)] = 39609,
  [SMALL_STATE(1565)] = 39664,
  [SMALL_STATE(1566)] = 39717,
  [SMALL_STATE(1567)] = 39772,
  [SMALL_STATE(1568)] = 39827,
  [SMALL_STATE(1569)] = 39895,
  [SMALL_STATE(1570)] = 39957,
  [SMALL_STATE(1571)] = 40025,
  [SMALL_STATE(1572)] = 40087,
  [SMALL_STATE(1573)] = 40155,
  [SMALL_STATE(1574)] = 40223,
  [SMALL_STATE(1575)] = 40291,
  [SMALL_STATE(1576)] = 40351,
  [SMALL_STATE(1577)] = 40419,
  [SMALL_STATE(1578)] = 40484,
  [SMALL_STATE(1579)] = 40549,
  [SMALL_STATE(1580)] = 40634,
  [SMALL_STATE(1581)] = 40689,
  [SMALL_STATE(1582)] = 40772,
  [SMALL_STATE(1583)] = 40837,
  [SMALL_STATE(1584)] = 40892,
  [SMALL_STATE(1585)] = 40957,
  [SMALL_STATE(1586)] = 41014,
  [SMALL_STATE(1587)] = 41079,
  [SMALL_STATE(1588)] = 41144,
  [SMALL_STATE(1589)] = 41209,
  [SMALL_STATE(1590)] = 41294,
  [SMALL_STATE(1591)] = 41359,
  [SMALL_STATE(1592)] = 41424,
  [SMALL_STATE(1593)] = 41489,
  [SMALL_STATE(1594)] = 41569,
  [SMALL_STATE(1595)] = 41621,
  [SMALL_STATE(1596)] = 41681,
  [SMALL_STATE(1597)] = 41761,
  [SMALL_STATE(1598)] = 41819,
  [SMALL_STATE(1599)] = 41879,
  [SMALL_STATE(1600)] = 41939,
  [SMALL_STATE(1601)] = 41993,
  [SMALL_STATE(1602)] = 42055,
  [SMALL_STATE(1603)] = 42107,
  [SMALL_STATE(1604)] = 42160,
  [SMALL_STATE(1605)] = 42211,
  [SMALL_STATE(1606)] = 42292,
  [SMALL_STATE(1607)] = 42371,
  [SMALL_STATE(1608)] = 42446,
  [SMALL_STATE(1609)] = 42525,
  [SMALL_STATE(1610)] = 42602,
  [SMALL_STATE(1611)] = 42655,
  [SMALL_STATE(1612)] = 42726,
  [SMALL_STATE(1613)] = 42781,
  [SMALL_STATE(1614)] = 42852,
  [SMALL_STATE(1615)] = 42929,
  [SMALL_STATE(1616)] = 43006,
  [SMALL_STATE(1617)] = 43083,
  [SMALL_STATE(1618)] = 43160,
  [SMALL_STATE(1619)] = 43239,
  [SMALL_STATE(1620)] = 43316,
  [SMALL_STATE(1621)] = 43367,
  [SMALL_STATE(1622)] = 43418,
  [SMALL_STATE(1623)] = 43477,
  [SMALL_STATE(1624)] = 43538,
  [SMALL_STATE(1625)] = 43589,
  [SMALL_STATE(1626)] = 43668,
  [SMALL_STATE(1627)] = 43719,
  [SMALL_STATE(1628)] = 43776,
  [SMALL_STATE(1629)] = 43827,
  [SMALL_STATE(1630)] = 43882,
  [SMALL_STATE(1631)] = 43945,
  [SMALL_STATE(1632)] = 44002,
  [SMALL_STATE(1633)] = 44079,
  [SMALL_STATE(1634)] = 44132,
  [SMALL_STATE(1635)] = 44187,
  [SMALL_STATE(1636)] = 44244,
  [SMALL_STATE(1637)] = 44295,
  [SMALL_STATE(1638)] = 44354,
  [SMALL_STATE(1639)] = 44419,
  [SMALL_STATE(1640)] = 44496,
  [SMALL_STATE(1641)] = 44547,
  [SMALL_STATE(1642)] = 44626,
  [SMALL_STATE(1643)] = 44675,
  [SMALL_STATE(1644)] = 44754,
  [SMALL_STATE(1645)] = 44833,
  [SMALL_STATE(1646)] = 44890,
  [SMALL_STATE(1647)] = 44943,
  [SMALL_STATE(1648)] = 45022,
  [SMALL_STATE(1649)] = 45075,
  [SMALL_STATE(1650)] = 45148,
  [SMALL_STATE(1651)] = 45221,
  [SMALL_STATE(1652)] = 45270,
  [SMALL_STATE(1653)] = 45319,
  [SMALL_STATE(1654)] = 45370,
  [SMALL_STATE(1655)] = 45420,
  [SMALL_STATE(1656)] = 45474,
  [SMALL_STATE(1657)] = 45530,
  [SMALL_STATE(1658)] = 45580,
  [SMALL_STATE(1659)] = 45656,
  [SMALL_STATE(1660)] = 45732,
  [SMALL_STATE(1661)] = 45784,
  [SMALL_STATE(1662)] = 45854,
  [SMALL_STATE(1663)] = 45930,
  [SMALL_STATE(1664)] = 45982,
  [SMALL_STATE(1665)] = 46058,
  [SMALL_STATE(1666)] = 46108,
  [SMALL_STATE(1667)] = 46184,
  [SMALL_STATE(1668)] = 46260,
  [SMALL_STATE(1669)] = 46336,
  [SMALL_STATE(1670)] = 46414,
  [SMALL_STATE(1671)] = 46464,
  [SMALL_STATE(1672)] = 46522,
  [SMALL_STATE(1673)] = 46598,
  [SMALL_STATE(1674)] = 46668,
  [SMALL_STATE(1675)] = 46718,
  [SMALL_STATE(1676)] = 46794,
  [SMALL_STATE(1677)] = 46852,
  [SMALL_STATE(1678)] = 46914,
  [SMALL_STATE(1679)] = 46990,
  [SMALL_STATE(1680)] = 47064,
  [SMALL_STATE(1681)] = 47140,
  [SMALL_STATE(1682)] = 47192,
  [SMALL_STATE(1683)] = 47245,
  [SMALL_STATE(1684)] = 47320,
  [SMALL_STATE(1685)] = 47369,
  [SMALL_STATE(1686)] = 47418,
  [SMALL_STATE(1687)] = 47493,
  [SMALL_STATE(1688)] = 47570,
  [SMALL_STATE(1689)] = 47645,
  [SMALL_STATE(1690)] = 47694,
  [SMALL_STATE(1691)] = 47743,
  [SMALL_STATE(1692)] = 47820,
  [SMALL_STATE(1693)] = 47899,
  [SMALL_STATE(1694)] = 47948,
  [SMALL_STATE(1695)] = 47997,
  [SMALL_STATE(1696)] = 48076,
  [SMALL_STATE(1697)] = 48125,
  [SMALL_STATE(1698)] = 48194,
  [SMALL_STATE(1699)] = 48243,
  [SMALL_STATE(1700)] = 48318,
  [SMALL_STATE(1701)] = 48393,
  [SMALL_STATE(1702)] = 48462,
  [SMALL_STATE(1703)] = 48511,
  [SMALL_STATE(1704)] = 48586,
  [SMALL_STATE(1705)] = 48659,
  [SMALL_STATE(1706)] = 48720,
  [SMALL_STATE(1707)] = 48771,
  [SMALL_STATE(1708)] = 48846,
  [SMALL_STATE(1709)] = 48897,
  [SMALL_STATE(1710)] = 48952,
  [SMALL_STATE(1711)] = 49001,
  [SMALL_STATE(1712)] = 49078,
  [SMALL_STATE(1713)] = 49127,
  [SMALL_STATE(1714)] = 49184,
  [SMALL_STATE(1715)] = 49233,
  [SMALL_STATE(1716)] = 49282,
  [SMALL_STATE(1717)] = 49333,
  [SMALL_STATE(1718)] = 49407,
  [SMALL_STATE(1719)] = 49485,
  [SMALL_STATE(1720)] = 49559,
  [SMALL_STATE(1721)] = 49641,
  [SMALL_STATE(1722)] = 49691,
  [SMALL_STATE(1723)] = 49765,
  [SMALL_STATE(1724)] = 49839,
  [SMALL_STATE(1725)] = 49891,
  [SMALL_STATE(1726)] = 49939,
  [SMALL_STATE(1727)] = 50013,
  [SMALL_STATE(1728)] = 50061,
  [SMALL_STATE(1729)] = 50139,
  [SMALL_STATE(1730)] = 50193,
  [SMALL_STATE(1731)] = 50267,
  [SMALL_STATE(1732)] = 50317,
  [SMALL_STATE(1733)] = 50377,
  [SMALL_STATE(1734)] = 50451,
  [SMALL_STATE(1735)] = 50523,
  [SMALL_STATE(1736)] = 50597,
  [SMALL_STATE(1737)] = 50665,
  [SMALL_STATE(1738)] = 50739,
  [SMALL_STATE(1739)] = 50791,
  [SMALL_STATE(1740)] = 50841,
  [SMALL_STATE(1741)] = 50893,
  [SMALL_STATE(1742)] = 50949,
  [SMALL_STATE(1743)] = 50997,
  [SMALL_STATE(1744)] = 51071,
  [SMALL_STATE(1745)] = 51139,
  [SMALL_STATE(1746)] = 51189,
  [SMALL_STATE(1747)] = 51239,
  [SMALL_STATE(1748)] = 51313,
  [SMALL_STATE(1749)] = 51387,
  [SMALL_STATE(1750)] = 51438,
  [SMALL_STATE(1751)] = 51489,
  [SMALL_STATE(1752)] = 51566,
  [SMALL_STATE(1753)] = 51615,
  [SMALL_STATE(1754)] = 51664,
  [SMALL_STATE(1755)] = 51747,
  [SMALL_STATE(1756)] = 51830,
  [SMALL_STATE(1757)] = 51907,
  [SMALL_STATE(1758)] = 51956,
  [SMALL_STATE(1759)] = 52039,
  [SMALL_STATE(1760)] = 52122,
  [SMALL_STATE(1761)] = 52171,
  [SMALL_STATE(1762)] = 52246,
  [SMALL_STATE(1763)] = 52299,
  [SMALL_STATE(1764)] = 52374,
  [SMALL_STATE(1765)] = 52451,
  [SMALL_STATE(1766)] = 52518,
  [SMALL_STATE(1767)] = 52601,
  [SMALL_STATE(1768)] = 52684,
  [SMALL_STATE(1769)] = 52735,
  [SMALL_STATE(1770)] = 52788,
  [SMALL_STATE(1771)] = 52841,
  [SMALL_STATE(1772)] = 52890,
  [SMALL_STATE(1773)] = 52957,
  [SMALL_STATE(1774)] = 53032,
  [SMALL_STATE(1775)] = 53105,
  [SMALL_STATE(1776)] = 53158,
  [SMALL_STATE(1777)] = 53233,
  [SMALL_STATE(1778)] = 53304,
  [SMALL_STATE(1779)] = 53363,
  [SMALL_STATE(1780)] = 53416,
  [SMALL_STATE(1781)] = 53469,
  [SMALL_STATE(1782)] = 53522,
  [SMALL_STATE(1783)] = 53597,
  [SMALL_STATE(1784)] = 53672,
  [SMALL_STATE(1785)] = 53721,
  [SMALL_STATE(1786)] = 53778,
  [SMALL_STATE(1787)] = 53827,
  [SMALL_STATE(1788)] = 53880,
  [SMALL_STATE(1789)] = 53927,
  [SMALL_STATE(1790)] = 53982,
  [SMALL_STATE(1791)] = 54029,
  [SMALL_STATE(1792)] = 54078,
  [SMALL_STATE(1793)] = 54133,
  [SMALL_STATE(1794)] = 54184,
  [SMALL_STATE(1795)] = 54245,
  [SMALL_STATE(1796)] = 54318,
  [SMALL_STATE(1797)] = 54393,
  [SMALL_STATE(1798)] = 54462,
  [SMALL_STATE(1799)] = 54515,
  [SMALL_STATE(1800)] = 54584,
  [SMALL_STATE(1801)] = 54659,
  [SMALL_STATE(1802)] = 54736,
  [SMALL_STATE(1803)] = 54811,
  [SMALL_STATE(1804)] = 54886,
  [SMALL_STATE(1805)] = 54961,
  [SMALL_STATE(1806)] = 55012,
  [SMALL_STATE(1807)] = 55065,
  [SMALL_STATE(1808)] = 55138,
  [SMALL_STATE(1809)] = 55211,
  [SMALL_STATE(1810)] = 55260,
  [SMALL_STATE(1811)] = 55317,
  [SMALL_STATE(1812)] = 55396,
  [SMALL_STATE(1813)] = 55445,
  [SMALL_STATE(1814)] = 55500,
  [SMALL_STATE(1815)] = 55561,
  [SMALL_STATE(1816)] = 55610,
  [SMALL_STATE(1817)] = 55683,
  [SMALL_STATE(1818)] = 55732,
  [SMALL_STATE(1819)] = 55807,
  [SMALL_STATE(1820)] = 55880,
  [SMALL_STATE(1821)] = 55957,
  [SMALL_STATE(1822)] = 56026,
  [SMALL_STATE(1823)] = 56075,
  [SMALL_STATE(1824)] = 56128,
  [SMALL_STATE(1825)] = 56203,
  [SMALL_STATE(1826)] = 56272,
  [SMALL_STATE(1827)] = 56345,
  [SMALL_STATE(1828)] = 56398,
  [SMALL_STATE(1829)] = 56473,
  [SMALL_STATE(1830)] = 56520,
  [SMALL_STATE(1831)] = 56571,
  [SMALL_STATE(1832)] = 56644,
  [SMALL_STATE(1833)] = 56717,
  [SMALL_STATE(1834)] = 56768,
  [SMALL_STATE(1835)] = 56821,
  [SMALL_STATE(1836)] = 56871,
  [SMALL_STATE(1837)] = 56921,
  [SMALL_STATE(1838)] = 56971,
  [SMALL_STATE(1839)] = 57019,
  [SMALL_STATE(1840)] = 57069,
  [SMALL_STATE(1841)] = 57145,
  [SMALL_STATE(1842)] = 57225,
  [SMALL_STATE(1843)] = 57305,
  [SMALL_STATE(1844)] = 57383,
  [SMALL_STATE(1845)] = 57433,
  [SMALL_STATE(1846)] = 57481,
  [SMALL_STATE(1847)] = 57537,
  [SMALL_STATE(1848)] = 57585,
  [SMALL_STATE(1849)] = 57661,
  [SMALL_STATE(1850)] = 57735,
  [SMALL_STATE(1851)] = 57809,
  [SMALL_STATE(1852)] = 57863,
  [SMALL_STATE(1853)] = 57937,
  [SMALL_STATE(1854)] = 57997,
  [SMALL_STATE(1855)] = 58069,
  [SMALL_STATE(1856)] = 58143,
  [SMALL_STATE(1857)] = 58211,
  [SMALL_STATE(1858)] = 58263,
  [SMALL_STATE(1859)] = 58331,
  [SMALL_STATE(1860)] = 58405,
  [SMALL_STATE(1861)] = 58473,
  [SMALL_STATE(1862)] = 58525,
  [SMALL_STATE(1863)] = 58593,
  [SMALL_STATE(1864)] = 58667,
  [SMALL_STATE(1865)] = 58739,
  [SMALL_STATE(1866)] = 58787,
  [SMALL_STATE(1867)] = 58847,
  [SMALL_STATE(1868)] = 58921,
  [SMALL_STATE(1869)] = 58995,
  [SMALL_STATE(1870)] = 59049,
  [SMALL_STATE(1871)] = 59125,
  [SMALL_STATE(1872)] = 59175,
  [SMALL_STATE(1873)] = 59225,
  [SMALL_STATE(1874)] = 59273,
  [SMALL_STATE(1875)] = 59321,
  [SMALL_STATE(1876)] = 59377,
  [SMALL_STATE(1877)] = 59433,
  [SMALL_STATE(1878)] = 59481,
  [SMALL_STATE(1879)] = 59535,
  [SMALL_STATE(1880)] = 59595,
  [SMALL_STATE(1881)] = 59667,
  [SMALL_STATE(1882)] = 59715,
  [SMALL_STATE(1883)] = 59789,
  [SMALL_STATE(1884)] = 59857,
  [SMALL_STATE(1885)] = 59907,
  [SMALL_STATE(1886)] = 59981,
  [SMALL_STATE(1887)] = 60033,
  [SMALL_STATE(1888)] = 60101,
  [SMALL_STATE(1889)] = 60151,
  [SMALL_STATE(1890)] = 60225,
  [SMALL_STATE(1891)] = 60299,
  [SMALL_STATE(1892)] = 60375,
  [SMALL_STATE(1893)] = 60451,
  [SMALL_STATE(1894)] = 60499,
  [SMALL_STATE(1895)] = 60573,
  [SMALL_STATE(1896)] = 60647,
  [SMALL_STATE(1897)] = 60695,
  [SMALL_STATE(1898)] = 60769,
  [SMALL_STATE(1899)] = 60843,
  [SMALL_STATE(1900)] = 60919,
  [SMALL_STATE(1901)] = 60967,
  [SMALL_STATE(1902)] = 61041,
  [SMALL_STATE(1903)] = 61115,
  [SMALL_STATE(1904)] = 61193,
  [SMALL_STATE(1905)] = 61267,
  [SMALL_STATE(1906)] = 61341,
  [SMALL_STATE(1907)] = 61415,
  [SMALL_STATE(1908)] = 61490,
  [SMALL_STATE(1909)] = 61565,
  [SMALL_STATE(1910)] = 61624,
  [SMALL_STATE(1911)] = 61695,
  [SMALL_STATE(1912)] = 61770,
  [SMALL_STATE(1913)] = 61845,
  [SMALL_STATE(1914)] = 61918,
  [SMALL_STATE(1915)] = 61991,
  [SMALL_STATE(1916)] = 62038,
  [SMALL_STATE(1917)] = 62111,
  [SMALL_STATE(1918)] = 62184,
  [SMALL_STATE(1919)] = 62257,
  [SMALL_STATE(1920)] = 62334,
  [SMALL_STATE(1921)] = 62411,
  [SMALL_STATE(1922)] = 62460,
  [SMALL_STATE(1923)] = 62537,
  [SMALL_STATE(1924)] = 62614,
  [SMALL_STATE(1925)] = 62661,
  [SMALL_STATE(1926)] = 62738,
  [SMALL_STATE(1927)] = 62815,
  [SMALL_STATE(1928)] = 62864,
  [SMALL_STATE(1929)] = 62913,
  [SMALL_STATE(1930)] = 62986,
  [SMALL_STATE(1931)] = 63053,
  [SMALL_STATE(1932)] = 63104,
  [SMALL_STATE(1933)] = 63171,
  [SMALL_STATE(1934)] = 63246,
  [SMALL_STATE(1935)] = 63323,
  [SMALL_STATE(1936)] = 63398,
  [SMALL_STATE(1937)] = 63471,
  [SMALL_STATE(1938)] = 63546,
  [SMALL_STATE(1939)] = 63595,
  [SMALL_STATE(1940)] = 63672,
  [SMALL_STATE(1941)] = 63725,
  [SMALL_STATE(1942)] = 63774,
  [SMALL_STATE(1943)] = 63847,
  [SMALL_STATE(1944)] = 63894,
  [SMALL_STATE(1945)] = 63949,
  [SMALL_STATE(1946)] = 63996,
  [SMALL_STATE(1947)] = 64043,
  [SMALL_STATE(1948)] = 64096,
  [SMALL_STATE(1949)] = 64143,
  [SMALL_STATE(1950)] = 64202,
  [SMALL_STATE(1951)] = 64275,
  [SMALL_STATE(1952)] = 64348,
  [SMALL_STATE(1953)] = 64395,
  [SMALL_STATE(1954)] = 64466,
  [SMALL_STATE(1955)] = 64539,
  [SMALL_STATE(1956)] = 64616,
  [SMALL_STATE(1957)] = 64683,
  [SMALL_STATE(1958)] = 64758,
  [SMALL_STATE(1959)] = 64809,
  [SMALL_STATE(1960)] = 64876,
  [SMALL_STATE(1961)] = 64949,
  [SMALL_STATE(1962)] = 64998,
  [SMALL_STATE(1963)] = 65053,
  [SMALL_STATE(1964)] = 65100,
  [SMALL_STATE(1965)] = 65150,
  [SMALL_STATE(1966)] = 65216,
  [SMALL_STATE(1967)] = 65290,
  [SMALL_STATE(1968)] = 65364,
  [SMALL_STATE(1969)] = 65438,
  [SMALL_STATE(1970)] = 65510,
  [SMALL_STATE(1971)] = 65584,
  [SMALL_STATE(1972)] = 65656,
  [SMALL_STATE(1973)] = 65728,
  [SMALL_STATE(1974)] = 65776,
  [SMALL_STATE(1975)] = 65822,
  [SMALL_STATE(1976)] = 65876,
  [SMALL_STATE(1977)] = 65922,
  [SMALL_STATE(1978)] = 65974,
  [SMALL_STATE(1979)] = 66032,
  [SMALL_STATE(1980)] = 66102,
  [SMALL_STATE(1981)] = 66174,
  [SMALL_STATE(1982)] = 66246,
  [SMALL_STATE(1983)] = 66298,
  [SMALL_STATE(1984)] = 66344,
  [SMALL_STATE(1985)] = 66402,
  [SMALL_STATE(1986)] = 66472,
  [SMALL_STATE(1987)] = 66538,
  [SMALL_STATE(1988)] = 66610,
  [SMALL_STATE(1989)] = 66658,
  [SMALL_STATE(1990)] = 66704,
  [SMALL_STATE(1991)] = 66770,
  [SMALL_STATE(1992)] = 66824,
  [SMALL_STATE(1993)] = 66874,
  [SMALL_STATE(1994)] = 66940,
  [SMALL_STATE(1995)] = 67012,
  [SMALL_STATE(1996)] = 67084,
  [SMALL_STATE(1997)] = 67158,
  [SMALL_STATE(1998)] = 67204,
  [SMALL_STATE(1999)] = 67250,
  [SMALL_STATE(2000)] = 67322,
  [SMALL_STATE(2001)] = 67394,
  [SMALL_STATE(2002)] = 67466,
  [SMALL_STATE(2003)] = 67538,
  [SMALL_STATE(2004)] = 67612,
  [SMALL_STATE(2005)] = 67686,
  [SMALL_STATE(2006)] = 67737,
  [SMALL_STATE(2007)] = 67782,
  [SMALL_STATE(2008)] = 67855,
  [SMALL_STATE(2009)] = 67928,
  [SMALL_STATE(2010)] = 67999,
  [SMALL_STATE(2011)] = 68072,
  [SMALL_STATE(2012)] = 68143,
  [SMALL_STATE(2013)] = 68216,
  [SMALL_STATE(2014)] = 68289,
  [SMALL_STATE(2015)] = 68360,
  [SMALL_STATE(2016)] = 68433,
  [SMALL_STATE(2017)] = 68506,
  [SMALL_STATE(2018)] = 68577,
  [SMALL_STATE(2019)] = 68648,
  [SMALL_STATE(2020)] = 68721,
  [SMALL_STATE(2021)] = 68794,
  [SMALL_STATE(2022)] = 68867,
  [SMALL_STATE(2023)] = 68938,
  [SMALL_STATE(2024)] = 69009,
  [SMALL_STATE(2025)] = 69080,
  [SMALL_STATE(2026)] = 69125,
  [SMALL_STATE(2027)] = 69190,
  [SMALL_STATE(2028)] = 69239,
  [SMALL_STATE(2029)] = 69304,
  [SMALL_STATE(2030)] = 69377,
  [SMALL_STATE(2031)] = 69450,
  [SMALL_STATE(2032)] = 69521,
  [SMALL_STATE(2033)] = 69592,
  [SMALL_STATE(2034)] = 69657,
  [SMALL_STATE(2035)] = 69706,
  [SMALL_STATE(2036)] = 69771,
  [SMALL_STATE(2037)] = 69842,
  [SMALL_STATE(2038)] = 69911,
  [SMALL_STATE(2039)] = 69968,
  [SMALL_STATE(2040)] = 70013,
  [SMALL_STATE(2041)] = 70066,
  [SMALL_STATE(2042)] = 70111,
  [SMALL_STATE(2043)] = 70158,
  [SMALL_STATE(2044)] = 70231,
  [SMALL_STATE(2045)] = 70300,
  [SMALL_STATE(2046)] = 70357,
  [SMALL_STATE(2047)] = 70408,
  [SMALL_STATE(2048)] = 70453,
  [SMALL_STATE(2049)] = 70498,
  [SMALL_STATE(2050)] = 70551,
  [SMALL_STATE(2051)] = 70622,
  [SMALL_STATE(2052)] = 70667,
  [SMALL_STATE(2053)] = 70714,
  [SMALL_STATE(2054)] = 70787,
  [SMALL_STATE(2055)] = 70860,
  [SMALL_STATE(2056)] = 70933,
  [SMALL_STATE(2057)] = 71006,
  [SMALL_STATE(2058)] = 71071,
  [SMALL_STATE(2059)] = 71120,
  [SMALL_STATE(2060)] = 71193,
  [SMALL_STATE(2061)] = 71258,
  [SMALL_STATE(2062)] = 71331,
  [SMALL_STATE(2063)] = 71402,
  [SMALL_STATE(2064)] = 71449,
  [SMALL_STATE(2065)] = 71522,
  [SMALL_STATE(2066)] = 71591,
  [SMALL_STATE(2067)] = 71664,
  [SMALL_STATE(2068)] = 71735,
  [SMALL_STATE(2069)] = 71806,
  [SMALL_STATE(2070)] = 71851,
  [SMALL_STATE(2071)] = 71924,
  [SMALL_STATE(2072)] = 71981,
  [SMALL_STATE(2073)] = 72034,
  [SMALL_STATE(2074)] = 72085,
  [SMALL_STATE(2075)] = 72130,
  [SMALL_STATE(2076)] = 72200,
  [SMALL_STATE(2077)] = 72270,
  [SMALL_STATE(2078)] = 72340,
  [SMALL_STATE(2079)] = 72410,
  [SMALL_STATE(2080)] = 72480,
  [SMALL_STATE(2081)] = 72550,
  [SMALL_STATE(2082)] = 72587,
  [SMALL_STATE(2083)] = 72624,
  [SMALL_STATE(2084)] = 72661,
  [SMALL_STATE(2085)] = 72698,
  [SMALL_STATE(2086)] = 72735,
  [SMALL_STATE(2087)] = 72772,
  [SMALL_STATE(2088)] = 72809,
  [SMALL_STATE(2089)] = 72846,
  [SMALL_STATE(2090)] = 72883,
  [SMALL_STATE(2091)] = 72920,
  [SMALL_STATE(2092)] = 72963,
  [SMALL_STATE(2093)] = 73000,
  [SMALL_STATE(2094)] = 73039,
  [SMALL_STATE(2095)] = 73080,
  [SMALL_STATE(2096)] = 73119,
  [SMALL_STATE(2097)] = 73153,
  [SMALL_STATE(2098)] = 73187,
  [SMALL_STATE(2099)] = 73222,
  [SMALL_STATE(2100)] = 73257,
  [SMALL_STATE(2101)] = 73292,
  [SMALL_STATE(2102)] = 73329,
  [SMALL_STATE(2103)] = 73362,
  [SMALL_STATE(2104)] = 73395,
  [SMALL_STATE(2105)] = 73430,
  [SMALL_STATE(2106)] = 73465,
  [SMALL_STATE(2107)] = 73502,
  [SMALL_STATE(2108)] = 73537,
  [SMALL_STATE(2109)] = 73572,
  [SMALL_STATE(2110)] = 73605,
  [SMALL_STATE(2111)] = 73636,
  [SMALL_STATE(2112)] = 73667,
  [SMALL_STATE(2113)] = 73698,
  [SMALL_STATE(2114)] = 73729,
  [SMALL_STATE(2115)] = 73760,
  [SMALL_STATE(2116)] = 73791,
  [SMALL_STATE(2117)] = 73822,
  [SMALL_STATE(2118)] = 73853,
  [SMALL_STATE(2119)] = 73884,
  [SMALL_STATE(2120)] = 73914,
  [SMALL_STATE(2121)] = 73944,
  [SMALL_STATE(2122)] = 73975,
  [SMALL_STATE(2123)] = 74004,
  [SMALL_STATE(2124)] = 74033,
  [SMALL_STATE(2125)] = 74066,
  [SMALL_STATE(2126)] = 74115,
  [SMALL_STATE(2127)] = 74146,
  [SMALL_STATE(2128)] = 74195,
  [SMALL_STATE(2129)] = 74224,
  [SMALL_STATE(2130)] = 74257,
  [SMALL_STATE(2131)] = 74288,
  [SMALL_STATE(2132)] = 74319,
  [SMALL_STATE(2133)] = 74350,
  [SMALL_STATE(2134)] = 74381,
  [SMALL_STATE(2135)] = 74430,
  [SMALL_STATE(2136)] = 74459,
  [SMALL_STATE(2137)] = 74490,
  [SMALL_STATE(2138)] = 74521,
  [SMALL_STATE(2139)] = 74550,
  [SMALL_STATE(2140)] = 74579,
  [SMALL_STATE(2141)] = 74625,
  [SMALL_STATE(2142)] = 74673,
  [SMALL_STATE(2143)] = 74721,
  [SMALL_STATE(2144)] = 74769,
  [SMALL_STATE(2145)] = 74819,
  [SMALL_STATE(2146)] = 74869,
  [SMALL_STATE(2147)] = 74916,
  [SMALL_STATE(2148)] = 74957,
  [SMALL_STATE(2149)] = 75004,
  [SMALL_STATE(2150)] = 75049,
  [SMALL_STATE(2151)] = 75096,
  [SMALL_STATE(2152)] = 75143,
  [SMALL_STATE(2153)] = 75190,
  [SMALL_STATE(2154)] = 75237,
  [SMALL_STATE(2155)] = 75284,
  [SMALL_STATE(2156)] = 75325,
  [SMALL_STATE(2157)] = 75369,
  [SMALL_STATE(2158)] = 75407,
  [SMALL_STATE(2159)] = 75451,
  [SMALL_STATE(2160)] = 75495,
  [SMALL_STATE(2161)] = 75539,
  [SMALL_STATE(2162)] = 75583,
  [SMALL_STATE(2163)] = 75627,
  [SMALL_STATE(2164)] = 75671,
  [SMALL_STATE(2165)] = 75708,
  [SMALL_STATE(2166)] = 75749,
  [SMALL_STATE(2167)] = 75790,
  [SMALL_STATE(2168)] = 75831,
  [SMALL_STATE(2169)] = 75872,
  [SMALL_STATE(2170)] = 75913,
  [SMALL_STATE(2171)] = 75945,
  [SMALL_STATE(2172)] = 75969,
  [SMALL_STATE(2173)] = 76001,
  [SMALL_STATE(2174)] = 76033,
  [SMALL_STATE(2175)] = 76065,
  [SMALL_STATE(2176)] = 76089,
  [SMALL_STATE(2177)] = 76118,
  [SMALL_STATE(2178)] = 76141,
  [SMALL_STATE(2179)] = 76170,
  [SMALL_STATE(2180)] = 76193,
  [SMALL_STATE(2181)] = 76220,
  [SMALL_STATE(2182)] = 76245,
  [SMALL_STATE(2183)] = 76268,
  [SMALL_STATE(2184)] = 76293,
  [SMALL_STATE(2185)] = 76318,
  [SMALL_STATE(2186)] = 76341,
  [SMALL_STATE(2187)] = 76368,
  [SMALL_STATE(2188)] = 76391,
  [SMALL_STATE(2189)] = 76422,
  [SMALL_STATE(2190)] = 76451,
  [SMALL_STATE(2191)] = 76474,
  [SMALL_STATE(2192)] = 76497,
  [SMALL_STATE(2193)] = 76522,
  [SMALL_STATE(2194)] = 76551,
  [SMALL_STATE(2195)] = 76576,
  [SMALL_STATE(2196)] = 76601,
  [SMALL_STATE(2197)] = 76626,
  [SMALL_STATE(2198)] = 76651,
  [SMALL_STATE(2199)] = 76680,
  [SMALL_STATE(2200)] = 76705,
  [SMALL_STATE(2201)] = 76728,
  [SMALL_STATE(2202)] = 76755,
  [SMALL_STATE(2203)] = 76780,
  [SMALL_STATE(2204)] = 76802,
  [SMALL_STATE(2205)] = 76840,
  [SMALL_STATE(2206)] = 76862,
  [SMALL_STATE(2207)] = 76884,
  [SMALL_STATE(2208)] = 76922,
  [SMALL_STATE(2209)] = 76944,
  [SMALL_STATE(2210)] = 76982,
  [SMALL_STATE(2211)] = 77018,
  [SMALL_STATE(2212)] = 77040,
  [SMALL_STATE(2213)] = 77062,
  [SMALL_STATE(2214)] = 77098,
  [SMALL_STATE(2215)] = 77136,
  [SMALL_STATE(2216)] = 77164,
  [SMALL_STATE(2217)] = 77186,
  [SMALL_STATE(2218)] = 77208,
  [SMALL_STATE(2219)] = 77228,
  [SMALL_STATE(2220)] = 77266,
  [SMALL_STATE(2221)] = 77292,
  [SMALL_STATE(2222)] = 77314,
  [SMALL_STATE(2223)] = 77352,
  [SMALL_STATE(2224)] = 77390,
  [SMALL_STATE(2225)] = 77411,
  [SMALL_STATE(2226)] = 77446,
  [SMALL_STATE(2227)] = 77465,
  [SMALL_STATE(2228)] = 77484,
  [SMALL_STATE(2229)] = 77503,
  [SMALL_STATE(2230)] = 77522,
  [SMALL_STATE(2231)] = 77541,
  [SMALL_STATE(2232)] = 77564,
  [SMALL_STATE(2233)] = 77583,
  [SMALL_STATE(2234)] = 77606,
  [SMALL_STATE(2235)] = 77625,
  [SMALL_STATE(2236)] = 77644,
  [SMALL_STATE(2237)] = 77663,
  [SMALL_STATE(2238)] = 77688,
  [SMALL_STATE(2239)] = 77707,
  [SMALL_STATE(2240)] = 77726,
  [SMALL_STATE(2241)] = 77745,
  [SMALL_STATE(2242)] = 77780,
  [SMALL_STATE(2243)] = 77810,
  [SMALL_STATE(2244)] = 77830,
  [SMALL_STATE(2245)] = 77860,
  [SMALL_STATE(2246)] = 77890,
  [SMALL_STATE(2247)] = 77924,
  [SMALL_STATE(2248)] = 77958,
  [SMALL_STATE(2249)] = 77978,
  [SMALL_STATE(2250)] = 78010,
  [SMALL_STATE(2251)] = 78032,
  [SMALL_STATE(2252)] = 78066,
  [SMALL_STATE(2253)] = 78086,
  [SMALL_STATE(2254)] = 78120,
  [SMALL_STATE(2255)] = 78140,
  [SMALL_STATE(2256)] = 78160,
  [SMALL_STATE(2257)] = 78180,
  [SMALL_STATE(2258)] = 78200,
  [SMALL_STATE(2259)] = 78220,
  [SMALL_STATE(2260)] = 78250,
  [SMALL_STATE(2261)] = 78280,
  [SMALL_STATE(2262)] = 78304,
  [SMALL_STATE(2263)] = 78338,
  [SMALL_STATE(2264)] = 78372,
  [SMALL_STATE(2265)] = 78406,
  [SMALL_STATE(2266)] = 78440,
  [SMALL_STATE(2267)] = 78474,
  [SMALL_STATE(2268)] = 78508,
  [SMALL_STATE(2269)] = 78528,
  [SMALL_STATE(2270)] = 78562,
  [SMALL_STATE(2271)] = 78592,
  [SMALL_STATE(2272)] = 78626,
  [SMALL_STATE(2273)] = 78660,
  [SMALL_STATE(2274)] = 78680,
  [SMALL_STATE(2275)] = 78702,
  [SMALL_STATE(2276)] = 78732,
  [SMALL_STATE(2277)] = 78762,
  [SMALL_STATE(2278)] = 78792,
  [SMALL_STATE(2279)] = 78812,
  [SMALL_STATE(2280)] = 78842,
  [SMALL_STATE(2281)] = 78862,
  [SMALL_STATE(2282)] = 78896,
  [SMALL_STATE(2283)] = 78930,
  [SMALL_STATE(2284)] = 78964,
  [SMALL_STATE(2285)] = 78984,
  [SMALL_STATE(2286)] = 79014,
  [SMALL_STATE(2287)] = 79048,
  [SMALL_STATE(2288)] = 79078,
  [SMALL_STATE(2289)] = 79108,
  [SMALL_STATE(2290)] = 79142,
  [SMALL_STATE(2291)] = 79172,
  [SMALL_STATE(2292)] = 79200,
  [SMALL_STATE(2293)] = 79234,
  [SMALL_STATE(2294)] = 79264,
  [SMALL_STATE(2295)] = 79284,
  [SMALL_STATE(2296)] = 79304,
  [SMALL_STATE(2297)] = 79338,
  [SMALL_STATE(2298)] = 79368,
  [SMALL_STATE(2299)] = 79398,
  [SMALL_STATE(2300)] = 79428,
  [SMALL_STATE(2301)] = 79458,
  [SMALL_STATE(2302)] = 79488,
  [SMALL_STATE(2303)] = 79508,
  [SMALL_STATE(2304)] = 79538,
  [SMALL_STATE(2305)] = 79558,
  [SMALL_STATE(2306)] = 79592,
  [SMALL_STATE(2307)] = 79622,
  [SMALL_STATE(2308)] = 79652,
  [SMALL_STATE(2309)] = 79686,
  [SMALL_STATE(2310)] = 79716,
  [SMALL_STATE(2311)] = 79748,
  [SMALL_STATE(2312)] = 79782,
  [SMALL_STATE(2313)] = 79802,
  [SMALL_STATE(2314)] = 79822,
  [SMALL_STATE(2315)] = 79856,
  [SMALL_STATE(2316)] = 79876,
  [SMALL_STATE(2317)] = 79907,
  [SMALL_STATE(2318)] = 79930,
  [SMALL_STATE(2319)] = 79953,
  [SMALL_STATE(2320)] = 79980,
  [SMALL_STATE(2321)] = 79999,
  [SMALL_STATE(2322)] = 80030,
  [SMALL_STATE(2323)] = 80061,
  [SMALL_STATE(2324)] = 80080,
  [SMALL_STATE(2325)] = 80109,
  [SMALL_STATE(2326)] = 80126,
  [SMALL_STATE(2327)] = 80151,
  [SMALL_STATE(2328)] = 80182,
  [SMALL_STATE(2329)] = 80213,
  [SMALL_STATE(2330)] = 80244,
  [SMALL_STATE(2331)] = 80275,
  [SMALL_STATE(2332)] = 80300,
  [SMALL_STATE(2333)] = 80321,
  [SMALL_STATE(2334)] = 80352,
  [SMALL_STATE(2335)] = 80369,
  [SMALL_STATE(2336)] = 80388,
  [SMALL_STATE(2337)] = 80419,
  [SMALL_STATE(2338)] = 80450,
  [SMALL_STATE(2339)] = 80477,
  [SMALL_STATE(2340)] = 80506,
  [SMALL_STATE(2341)] = 80533,
  [SMALL_STATE(2342)] = 80560,
  [SMALL_STATE(2343)] = 80591,
  [SMALL_STATE(2344)] = 80622,
  [SMALL_STATE(2345)] = 80653,
  [SMALL_STATE(2346)] = 80672,
  [SMALL_STATE(2347)] = 80691,
  [SMALL_STATE(2348)] = 80710,
  [SMALL_STATE(2349)] = 80741,
  [SMALL_STATE(2350)] = 80762,
  [SMALL_STATE(2351)] = 80789,
  [SMALL_STATE(2352)] = 80816,
  [SMALL_STATE(2353)] = 80843,
  [SMALL_STATE(2354)] = 80862,
  [SMALL_STATE(2355)] = 80893,
  [SMALL_STATE(2356)] = 80912,
  [SMALL_STATE(2357)] = 80931,
  [SMALL_STATE(2358)] = 80950,
  [SMALL_STATE(2359)] = 80981,
  [SMALL_STATE(2360)] = 81000,
  [SMALL_STATE(2361)] = 81019,
  [SMALL_STATE(2362)] = 81038,
  [SMALL_STATE(2363)] = 81057,
  [SMALL_STATE(2364)] = 81076,
  [SMALL_STATE(2365)] = 81093,
  [SMALL_STATE(2366)] = 81124,
  [SMALL_STATE(2367)] = 81143,
  [SMALL_STATE(2368)] = 81160,
  [SMALL_STATE(2369)] = 81177,
  [SMALL_STATE(2370)] = 81204,
  [SMALL_STATE(2371)] = 81223,
  [SMALL_STATE(2372)] = 81240,
  [SMALL_STATE(2373)] = 81257,
  [SMALL_STATE(2374)] = 81274,
  [SMALL_STATE(2375)] = 81305,
  [SMALL_STATE(2376)] = 81336,
  [SMALL_STATE(2377)] = 81355,
  [SMALL_STATE(2378)] = 81384,
  [SMALL_STATE(2379)] = 81411,
  [SMALL_STATE(2380)] = 81438,
  [SMALL_STATE(2381)] = 81461,
  [SMALL_STATE(2382)] = 81492,
  [SMALL_STATE(2383)] = 81521,
  [SMALL_STATE(2384)] = 81542,
  [SMALL_STATE(2385)] = 81567,
  [SMALL_STATE(2386)] = 81594,
  [SMALL_STATE(2387)] = 81621,
  [SMALL_STATE(2388)] = 81652,
  [SMALL_STATE(2389)] = 81683,
  [SMALL_STATE(2390)] = 81701,
  [SMALL_STATE(2391)] = 81729,
  [SMALL_STATE(2392)] = 81751,
  [SMALL_STATE(2393)] = 81777,
  [SMALL_STATE(2394)] = 81803,
  [SMALL_STATE(2395)] = 81821,
  [SMALL_STATE(2396)] = 81847,
  [SMALL_STATE(2397)] = 81865,
  [SMALL_STATE(2398)] = 81891,
  [SMALL_STATE(2399)] = 81919,
  [SMALL_STATE(2400)] = 81945,
  [SMALL_STATE(2401)] = 81971,
  [SMALL_STATE(2402)] = 81997,
  [SMALL_STATE(2403)] = 82023,
  [SMALL_STATE(2404)] = 82049,
  [SMALL_STATE(2405)] = 82075,
  [SMALL_STATE(2406)] = 82103,
  [SMALL_STATE(2407)] = 82129,
  [SMALL_STATE(2408)] = 82147,
  [SMALL_STATE(2409)] = 82175,
  [SMALL_STATE(2410)] = 82201,
  [SMALL_STATE(2411)] = 82227,
  [SMALL_STATE(2412)] = 82255,
  [SMALL_STATE(2413)] = 82281,
  [SMALL_STATE(2414)] = 82307,
  [SMALL_STATE(2415)] = 82333,
  [SMALL_STATE(2416)] = 82349,
  [SMALL_STATE(2417)] = 82375,
  [SMALL_STATE(2418)] = 82401,
  [SMALL_STATE(2419)] = 82427,
  [SMALL_STATE(2420)] = 82443,
  [SMALL_STATE(2421)] = 82469,
  [SMALL_STATE(2422)] = 82495,
  [SMALL_STATE(2423)] = 82513,
  [SMALL_STATE(2424)] = 82539,
  [SMALL_STATE(2425)] = 82565,
  [SMALL_STATE(2426)] = 82591,
  [SMALL_STATE(2427)] = 82613,
  [SMALL_STATE(2428)] = 82639,
  [SMALL_STATE(2429)] = 82665,
  [SMALL_STATE(2430)] = 82691,
  [SMALL_STATE(2431)] = 82717,
  [SMALL_STATE(2432)] = 82737,
  [SMALL_STATE(2433)] = 82763,
  [SMALL_STATE(2434)] = 82789,
  [SMALL_STATE(2435)] = 82817,
  [SMALL_STATE(2436)] = 82845,
  [SMALL_STATE(2437)] = 82871,
  [SMALL_STATE(2438)] = 82897,
  [SMALL_STATE(2439)] = 82923,
  [SMALL_STATE(2440)] = 82949,
  [SMALL_STATE(2441)] = 82975,
  [SMALL_STATE(2442)] = 83003,
  [SMALL_STATE(2443)] = 83029,
  [SMALL_STATE(2444)] = 83057,
  [SMALL_STATE(2445)] = 83075,
  [SMALL_STATE(2446)] = 83101,
  [SMALL_STATE(2447)] = 83117,
  [SMALL_STATE(2448)] = 83145,
  [SMALL_STATE(2449)] = 83171,
  [SMALL_STATE(2450)] = 83199,
  [SMALL_STATE(2451)] = 83225,
  [SMALL_STATE(2452)] = 83243,
  [SMALL_STATE(2453)] = 83265,
  [SMALL_STATE(2454)] = 83283,
  [SMALL_STATE(2455)] = 83309,
  [SMALL_STATE(2456)] = 83335,
  [SMALL_STATE(2457)] = 83357,
  [SMALL_STATE(2458)] = 83375,
  [SMALL_STATE(2459)] = 83397,
  [SMALL_STATE(2460)] = 83425,
  [SMALL_STATE(2461)] = 83449,
  [SMALL_STATE(2462)] = 83477,
  [SMALL_STATE(2463)] = 83503,
  [SMALL_STATE(2464)] = 83529,
  [SMALL_STATE(2465)] = 83555,
  [SMALL_STATE(2466)] = 83581,
  [SMALL_STATE(2467)] = 83599,
  [SMALL_STATE(2468)] = 83627,
  [SMALL_STATE(2469)] = 83645,
  [SMALL_STATE(2470)] = 83663,
  [SMALL_STATE(2471)] = 83691,
  [SMALL_STATE(2472)] = 83717,
  [SMALL_STATE(2473)] = 83733,
  [SMALL_STATE(2474)] = 83755,
  [SMALL_STATE(2475)] = 83771,
  [SMALL_STATE(2476)] = 83799,
  [SMALL_STATE(2477)] = 83825,
  [SMALL_STATE(2478)] = 83853,
  [SMALL_STATE(2479)] = 83869,
  [SMALL_STATE(2480)] = 83895,
  [SMALL_STATE(2481)] = 83921,
  [SMALL_STATE(2482)] = 83947,
  [SMALL_STATE(2483)] = 83973,
  [SMALL_STATE(2484)] = 83999,
  [SMALL_STATE(2485)] = 84021,
  [SMALL_STATE(2486)] = 84047,
  [SMALL_STATE(2487)] = 84073,
  [SMALL_STATE(2488)] = 84099,
  [SMALL_STATE(2489)] = 84121,
  [SMALL_STATE(2490)] = 84147,
  [SMALL_STATE(2491)] = 84175,
  [SMALL_STATE(2492)] = 84198,
  [SMALL_STATE(2493)] = 84221,
  [SMALL_STATE(2494)] = 84244,
  [SMALL_STATE(2495)] = 84267,
  [SMALL_STATE(2496)] = 84286,
  [SMALL_STATE(2497)] = 84305,
  [SMALL_STATE(2498)] = 84324,
  [SMALL_STATE(2499)] = 84347,
  [SMALL_STATE(2500)] = 84370,
  [SMALL_STATE(2501)] = 84393,
  [SMALL_STATE(2502)] = 84414,
  [SMALL_STATE(2503)] = 84433,
  [SMALL_STATE(2504)] = 84456,
  [SMALL_STATE(2505)] = 84473,
  [SMALL_STATE(2506)] = 84490,
  [SMALL_STATE(2507)] = 84513,
  [SMALL_STATE(2508)] = 84536,
  [SMALL_STATE(2509)] = 84557,
  [SMALL_STATE(2510)] = 84582,
  [SMALL_STATE(2511)] = 84601,
  [SMALL_STATE(2512)] = 84624,
  [SMALL_STATE(2513)] = 84647,
  [SMALL_STATE(2514)] = 84670,
  [SMALL_STATE(2515)] = 84691,
  [SMALL_STATE(2516)] = 84714,
  [SMALL_STATE(2517)] = 84737,
  [SMALL_STATE(2518)] = 84760,
  [SMALL_STATE(2519)] = 84783,
  [SMALL_STATE(2520)] = 84798,
  [SMALL_STATE(2521)] = 84823,
  [SMALL_STATE(2522)] = 84846,
  [SMALL_STATE(2523)] = 84869,
  [SMALL_STATE(2524)] = 84888,
  [SMALL_STATE(2525)] = 84911,
  [SMALL_STATE(2526)] = 84936,
  [SMALL_STATE(2527)] = 84961,
  [SMALL_STATE(2528)] = 84982,
  [SMALL_STATE(2529)] = 84999,
  [SMALL_STATE(2530)] = 85022,
  [SMALL_STATE(2531)] = 85043,
  [SMALL_STATE(2532)] = 85066,
  [SMALL_STATE(2533)] = 85089,
  [SMALL_STATE(2534)] = 85112,
  [SMALL_STATE(2535)] = 85135,
  [SMALL_STATE(2536)] = 85158,
  [SMALL_STATE(2537)] = 85181,
  [SMALL_STATE(2538)] = 85206,
  [SMALL_STATE(2539)] = 85221,
  [SMALL_STATE(2540)] = 85236,
  [SMALL_STATE(2541)] = 85259,
  [SMALL_STATE(2542)] = 85282,
  [SMALL_STATE(2543)] = 85303,
  [SMALL_STATE(2544)] = 85326,
  [SMALL_STATE(2545)] = 85343,
  [SMALL_STATE(2546)] = 85358,
  [SMALL_STATE(2547)] = 85381,
  [SMALL_STATE(2548)] = 85402,
  [SMALL_STATE(2549)] = 85423,
  [SMALL_STATE(2550)] = 85438,
  [SMALL_STATE(2551)] = 85461,
  [SMALL_STATE(2552)] = 85480,
  [SMALL_STATE(2553)] = 85496,
  [SMALL_STATE(2554)] = 85516,
  [SMALL_STATE(2555)] = 85534,
  [SMALL_STATE(2556)] = 85550,
  [SMALL_STATE(2557)] = 85568,
  [SMALL_STATE(2558)] = 85590,
  [SMALL_STATE(2559)] = 85606,
  [SMALL_STATE(2560)] = 85622,
  [SMALL_STATE(2561)] = 85640,
  [SMALL_STATE(2562)] = 85656,
  [SMALL_STATE(2563)] = 85672,
  [SMALL_STATE(2564)] = 85688,
  [SMALL_STATE(2565)] = 85708,
  [SMALL_STATE(2566)] = 85724,
  [SMALL_STATE(2567)] = 85746,
  [SMALL_STATE(2568)] = 85762,
  [SMALL_STATE(2569)] = 85778,
  [SMALL_STATE(2570)] = 85794,
  [SMALL_STATE(2571)] = 85810,
  [SMALL_STATE(2572)] = 85826,
  [SMALL_STATE(2573)] = 85842,
  [SMALL_STATE(2574)] = 85858,
  [SMALL_STATE(2575)] = 85874,
  [SMALL_STATE(2576)] = 85890,
  [SMALL_STATE(2577)] = 85906,
  [SMALL_STATE(2578)] = 85922,
  [SMALL_STATE(2579)] = 85938,
  [SMALL_STATE(2580)] = 85954,
  [SMALL_STATE(2581)] = 85972,
  [SMALL_STATE(2582)] = 85992,
  [SMALL_STATE(2583)] = 86008,
  [SMALL_STATE(2584)] = 86024,
  [SMALL_STATE(2585)] = 86040,
  [SMALL_STATE(2586)] = 86056,
  [SMALL_STATE(2587)] = 86072,
  [SMALL_STATE(2588)] = 86094,
  [SMALL_STATE(2589)] = 86110,
  [SMALL_STATE(2590)] = 86126,
  [SMALL_STATE(2591)] = 86142,
  [SMALL_STATE(2592)] = 86158,
  [SMALL_STATE(2593)] = 86174,
  [SMALL_STATE(2594)] = 86190,
  [SMALL_STATE(2595)] = 86206,
  [SMALL_STATE(2596)] = 86224,
  [SMALL_STATE(2597)] = 86240,
  [SMALL_STATE(2598)] = 86256,
  [SMALL_STATE(2599)] = 86274,
  [SMALL_STATE(2600)] = 86290,
  [SMALL_STATE(2601)] = 86306,
  [SMALL_STATE(2602)] = 86322,
  [SMALL_STATE(2603)] = 86338,
  [SMALL_STATE(2604)] = 86354,
  [SMALL_STATE(2605)] = 86370,
  [SMALL_STATE(2606)] = 86386,
  [SMALL_STATE(2607)] = 86402,
  [SMALL_STATE(2608)] = 86422,
  [SMALL_STATE(2609)] = 86438,
  [SMALL_STATE(2610)] = 86454,
  [SMALL_STATE(2611)] = 86470,
  [SMALL_STATE(2612)] = 86486,
  [SMALL_STATE(2613)] = 86502,
  [SMALL_STATE(2614)] = 86518,
  [SMALL_STATE(2615)] = 86534,
  [SMALL_STATE(2616)] = 86550,
  [SMALL_STATE(2617)] = 86566,
  [SMALL_STATE(2618)] = 86582,
  [SMALL_STATE(2619)] = 86598,
  [SMALL_STATE(2620)] = 86620,
  [SMALL_STATE(2621)] = 86636,
  [SMALL_STATE(2622)] = 86652,
  [SMALL_STATE(2623)] = 86668,
  [SMALL_STATE(2624)] = 86684,
  [SMALL_STATE(2625)] = 86700,
  [SMALL_STATE(2626)] = 86716,
  [SMALL_STATE(2627)] = 86732,
  [SMALL_STATE(2628)] = 86752,
  [SMALL_STATE(2629)] = 86768,
  [SMALL_STATE(2630)] = 86788,
  [SMALL_STATE(2631)] = 86808,
  [SMALL_STATE(2632)] = 86824,
  [SMALL_STATE(2633)] = 86840,
  [SMALL_STATE(2634)] = 86856,
  [SMALL_STATE(2635)] = 86876,
  [SMALL_STATE(2636)] = 86892,
  [SMALL_STATE(2637)] = 86908,
  [SMALL_STATE(2638)] = 86924,
  [SMALL_STATE(2639)] = 86940,
  [SMALL_STATE(2640)] = 86956,
  [SMALL_STATE(2641)] = 86972,
  [SMALL_STATE(2642)] = 86988,
  [SMALL_STATE(2643)] = 87004,
  [SMALL_STATE(2644)] = 87024,
  [SMALL_STATE(2645)] = 87044,
  [SMALL_STATE(2646)] = 87060,
  [SMALL_STATE(2647)] = 87076,
  [SMALL_STATE(2648)] = 87092,
  [SMALL_STATE(2649)] = 87112,
  [SMALL_STATE(2650)] = 87128,
  [SMALL_STATE(2651)] = 87144,
  [SMALL_STATE(2652)] = 87160,
  [SMALL_STATE(2653)] = 87178,
  [SMALL_STATE(2654)] = 87196,
  [SMALL_STATE(2655)] = 87212,
  [SMALL_STATE(2656)] = 87228,
  [SMALL_STATE(2657)] = 87248,
  [SMALL_STATE(2658)] = 87264,
  [SMALL_STATE(2659)] = 87284,
  [SMALL_STATE(2660)] = 87300,
  [SMALL_STATE(2661)] = 87316,
  [SMALL_STATE(2662)] = 87332,
  [SMALL_STATE(2663)] = 87348,
  [SMALL_STATE(2664)] = 87364,
  [SMALL_STATE(2665)] = 87384,
  [SMALL_STATE(2666)] = 87400,
  [SMALL_STATE(2667)] = 87416,
  [SMALL_STATE(2668)] = 87436,
  [SMALL_STATE(2669)] = 87452,
  [SMALL_STATE(2670)] = 87472,
  [SMALL_STATE(2671)] = 87487,
  [SMALL_STATE(2672)] = 87506,
  [SMALL_STATE(2673)] = 87521,
  [SMALL_STATE(2674)] = 87538,
  [SMALL_STATE(2675)] = 87553,
  [SMALL_STATE(2676)] = 87568,
  [SMALL_STATE(2677)] = 87583,
  [SMALL_STATE(2678)] = 87602,
  [SMALL_STATE(2679)] = 87617,
  [SMALL_STATE(2680)] = 87632,
  [SMALL_STATE(2681)] = 87651,
  [SMALL_STATE(2682)] = 87668,
  [SMALL_STATE(2683)] = 87687,
  [SMALL_STATE(2684)] = 87706,
  [SMALL_STATE(2685)] = 87721,
  [SMALL_STATE(2686)] = 87740,
  [SMALL_STATE(2687)] = 87759,
  [SMALL_STATE(2688)] = 87774,
  [SMALL_STATE(2689)] = 87793,
  [SMALL_STATE(2690)] = 87808,
  [SMALL_STATE(2691)] = 87827,
  [SMALL_STATE(2692)] = 87846,
  [SMALL_STATE(2693)] = 87865,
  [SMALL_STATE(2694)] = 87880,
  [SMALL_STATE(2695)] = 87895,
  [SMALL_STATE(2696)] = 87910,
  [SMALL_STATE(2697)] = 87929,
  [SMALL_STATE(2698)] = 87948,
  [SMALL_STATE(2699)] = 87967,
  [SMALL_STATE(2700)] = 87986,
  [SMALL_STATE(2701)] = 88003,
  [SMALL_STATE(2702)] = 88022,
  [SMALL_STATE(2703)] = 88041,
  [SMALL_STATE(2704)] = 88060,
  [SMALL_STATE(2705)] = 88079,
  [SMALL_STATE(2706)] = 88098,
  [SMALL_STATE(2707)] = 88113,
  [SMALL_STATE(2708)] = 88130,
  [SMALL_STATE(2709)] = 88147,
  [SMALL_STATE(2710)] = 88166,
  [SMALL_STATE(2711)] = 88185,
  [SMALL_STATE(2712)] = 88204,
  [SMALL_STATE(2713)] = 88223,
  [SMALL_STATE(2714)] = 88240,
  [SMALL_STATE(2715)] = 88257,
  [SMALL_STATE(2716)] = 88276,
  [SMALL_STATE(2717)] = 88295,
  [SMALL_STATE(2718)] = 88312,
  [SMALL_STATE(2719)] = 88331,
  [SMALL_STATE(2720)] = 88346,
  [SMALL_STATE(2721)] = 88365,
  [SMALL_STATE(2722)] = 88384,
  [SMALL_STATE(2723)] = 88401,
  [SMALL_STATE(2724)] = 88420,
  [SMALL_STATE(2725)] = 88437,
  [SMALL_STATE(2726)] = 88456,
  [SMALL_STATE(2727)] = 88475,
  [SMALL_STATE(2728)] = 88494,
  [SMALL_STATE(2729)] = 88509,
  [SMALL_STATE(2730)] = 88528,
  [SMALL_STATE(2731)] = 88547,
  [SMALL_STATE(2732)] = 88566,
  [SMALL_STATE(2733)] = 88585,
  [SMALL_STATE(2734)] = 88602,
  [SMALL_STATE(2735)] = 88621,
  [SMALL_STATE(2736)] = 88640,
  [SMALL_STATE(2737)] = 88659,
  [SMALL_STATE(2738)] = 88676,
  [SMALL_STATE(2739)] = 88690,
  [SMALL_STATE(2740)] = 88704,
  [SMALL_STATE(2741)] = 88718,
  [SMALL_STATE(2742)] = 88732,
  [SMALL_STATE(2743)] = 88746,
  [SMALL_STATE(2744)] = 88760,
  [SMALL_STATE(2745)] = 88774,
  [SMALL_STATE(2746)] = 88790,
  [SMALL_STATE(2747)] = 88804,
  [SMALL_STATE(2748)] = 88818,
  [SMALL_STATE(2749)] = 88832,
  [SMALL_STATE(2750)] = 88846,
  [SMALL_STATE(2751)] = 88862,
  [SMALL_STATE(2752)] = 88876,
  [SMALL_STATE(2753)] = 88890,
  [SMALL_STATE(2754)] = 88904,
  [SMALL_STATE(2755)] = 88918,
  [SMALL_STATE(2756)] = 88934,
  [SMALL_STATE(2757)] = 88950,
  [SMALL_STATE(2758)] = 88966,
  [SMALL_STATE(2759)] = 88982,
  [SMALL_STATE(2760)] = 88996,
  [SMALL_STATE(2761)] = 89012,
  [SMALL_STATE(2762)] = 89026,
  [SMALL_STATE(2763)] = 89040,
  [SMALL_STATE(2764)] = 89056,
  [SMALL_STATE(2765)] = 89070,
  [SMALL_STATE(2766)] = 89084,
  [SMALL_STATE(2767)] = 89098,
  [SMALL_STATE(2768)] = 89112,
  [SMALL_STATE(2769)] = 89126,
  [SMALL_STATE(2770)] = 89140,
  [SMALL_STATE(2771)] = 89154,
  [SMALL_STATE(2772)] = 89170,
  [SMALL_STATE(2773)] = 89184,
  [SMALL_STATE(2774)] = 89198,
  [SMALL_STATE(2775)] = 89212,
  [SMALL_STATE(2776)] = 89228,
  [SMALL_STATE(2777)] = 89242,
  [SMALL_STATE(2778)] = 89256,
  [SMALL_STATE(2779)] = 89272,
  [SMALL_STATE(2780)] = 89286,
  [SMALL_STATE(2781)] = 89302,
  [SMALL_STATE(2782)] = 89318,
  [SMALL_STATE(2783)] = 89334,
  [SMALL_STATE(2784)] = 89348,
  [SMALL_STATE(2785)] = 89361,
  [SMALL_STATE(2786)] = 89374,
  [SMALL_STATE(2787)] = 89387,
  [SMALL_STATE(2788)] = 89400,
  [SMALL_STATE(2789)] = 89413,
  [SMALL_STATE(2790)] = 89426,
  [SMALL_STATE(2791)] = 89439,
  [SMALL_STATE(2792)] = 89452,
  [SMALL_STATE(2793)] = 89465,
  [SMALL_STATE(2794)] = 89478,
  [SMALL_STATE(2795)] = 89491,
  [SMALL_STATE(2796)] = 89504,
  [SMALL_STATE(2797)] = 89517,
  [SMALL_STATE(2798)] = 89530,
  [SMALL_STATE(2799)] = 89543,
  [SMALL_STATE(2800)] = 89556,
  [SMALL_STATE(2801)] = 89569,
  [SMALL_STATE(2802)] = 89582,
  [SMALL_STATE(2803)] = 89595,
  [SMALL_STATE(2804)] = 89608,
  [SMALL_STATE(2805)] = 89621,
  [SMALL_STATE(2806)] = 89634,
  [SMALL_STATE(2807)] = 89647,
  [SMALL_STATE(2808)] = 89660,
  [SMALL_STATE(2809)] = 89673,
  [SMALL_STATE(2810)] = 89686,
  [SMALL_STATE(2811)] = 89699,
  [SMALL_STATE(2812)] = 89712,
  [SMALL_STATE(2813)] = 89725,
  [SMALL_STATE(2814)] = 89738,
  [SMALL_STATE(2815)] = 89751,
  [SMALL_STATE(2816)] = 89764,
  [SMALL_STATE(2817)] = 89777,
  [SMALL_STATE(2818)] = 89790,
  [SMALL_STATE(2819)] = 89803,
  [SMALL_STATE(2820)] = 89816,
  [SMALL_STATE(2821)] = 89829,
  [SMALL_STATE(2822)] = 89842,
  [SMALL_STATE(2823)] = 89855,
  [SMALL_STATE(2824)] = 89868,
  [SMALL_STATE(2825)] = 89881,
  [SMALL_STATE(2826)] = 89894,
  [SMALL_STATE(2827)] = 89907,
  [SMALL_STATE(2828)] = 89920,
  [SMALL_STATE(2829)] = 89933,
  [SMALL_STATE(2830)] = 89946,
  [SMALL_STATE(2831)] = 89959,
  [SMALL_STATE(2832)] = 89970,
  [SMALL_STATE(2833)] = 89983,
  [SMALL_STATE(2834)] = 89996,
  [SMALL_STATE(2835)] = 90009,
  [SMALL_STATE(2836)] = 90022,
  [SMALL_STATE(2837)] = 90035,
  [SMALL_STATE(2838)] = 90048,
  [SMALL_STATE(2839)] = 90061,
  [SMALL_STATE(2840)] = 90074,
  [SMALL_STATE(2841)] = 90087,
  [SMALL_STATE(2842)] = 90100,
  [SMALL_STATE(2843)] = 90113,
  [SMALL_STATE(2844)] = 90126,
  [SMALL_STATE(2845)] = 90139,
  [SMALL_STATE(2846)] = 90152,
  [SMALL_STATE(2847)] = 90165,
  [SMALL_STATE(2848)] = 90178,
  [SMALL_STATE(2849)] = 90191,
  [SMALL_STATE(2850)] = 90204,
  [SMALL_STATE(2851)] = 90217,
  [SMALL_STATE(2852)] = 90230,
  [SMALL_STATE(2853)] = 90243,
  [SMALL_STATE(2854)] = 90256,
  [SMALL_STATE(2855)] = 90269,
  [SMALL_STATE(2856)] = 90282,
  [SMALL_STATE(2857)] = 90295,
  [SMALL_STATE(2858)] = 90308,
  [SMALL_STATE(2859)] = 90319,
  [SMALL_STATE(2860)] = 90332,
  [SMALL_STATE(2861)] = 90343,
  [SMALL_STATE(2862)] = 90356,
  [SMALL_STATE(2863)] = 90369,
  [SMALL_STATE(2864)] = 90382,
  [SMALL_STATE(2865)] = 90395,
  [SMALL_STATE(2866)] = 90408,
  [SMALL_STATE(2867)] = 90421,
  [SMALL_STATE(2868)] = 90434,
  [SMALL_STATE(2869)] = 90447,
  [SMALL_STATE(2870)] = 90460,
  [SMALL_STATE(2871)] = 90473,
  [SMALL_STATE(2872)] = 90486,
  [SMALL_STATE(2873)] = 90499,
  [SMALL_STATE(2874)] = 90512,
  [SMALL_STATE(2875)] = 90523,
  [SMALL_STATE(2876)] = 90536,
  [SMALL_STATE(2877)] = 90549,
  [SMALL_STATE(2878)] = 90562,
  [SMALL_STATE(2879)] = 90575,
  [SMALL_STATE(2880)] = 90588,
  [SMALL_STATE(2881)] = 90601,
  [SMALL_STATE(2882)] = 90614,
  [SMALL_STATE(2883)] = 90627,
  [SMALL_STATE(2884)] = 90638,
  [SMALL_STATE(2885)] = 90649,
  [SMALL_STATE(2886)] = 90662,
  [SMALL_STATE(2887)] = 90675,
  [SMALL_STATE(2888)] = 90688,
  [SMALL_STATE(2889)] = 90699,
  [SMALL_STATE(2890)] = 90712,
  [SMALL_STATE(2891)] = 90725,
  [SMALL_STATE(2892)] = 90738,
  [SMALL_STATE(2893)] = 90751,
  [SMALL_STATE(2894)] = 90762,
  [SMALL_STATE(2895)] = 90775,
  [SMALL_STATE(2896)] = 90788,
  [SMALL_STATE(2897)] = 90801,
  [SMALL_STATE(2898)] = 90814,
  [SMALL_STATE(2899)] = 90827,
  [SMALL_STATE(2900)] = 90838,
  [SMALL_STATE(2901)] = 90851,
  [SMALL_STATE(2902)] = 90864,
  [SMALL_STATE(2903)] = 90877,
  [SMALL_STATE(2904)] = 90890,
  [SMALL_STATE(2905)] = 90903,
  [SMALL_STATE(2906)] = 90916,
  [SMALL_STATE(2907)] = 90929,
  [SMALL_STATE(2908)] = 90942,
  [SMALL_STATE(2909)] = 90955,
  [SMALL_STATE(2910)] = 90968,
  [SMALL_STATE(2911)] = 90981,
  [SMALL_STATE(2912)] = 90994,
  [SMALL_STATE(2913)] = 91007,
  [SMALL_STATE(2914)] = 91020,
  [SMALL_STATE(2915)] = 91033,
  [SMALL_STATE(2916)] = 91046,
  [SMALL_STATE(2917)] = 91059,
  [SMALL_STATE(2918)] = 91070,
  [SMALL_STATE(2919)] = 91083,
  [SMALL_STATE(2920)] = 91096,
  [SMALL_STATE(2921)] = 91109,
  [SMALL_STATE(2922)] = 91122,
  [SMALL_STATE(2923)] = 91135,
  [SMALL_STATE(2924)] = 91148,
  [SMALL_STATE(2925)] = 91155,
  [SMALL_STATE(2926)] = 91159,
  [SMALL_STATE(2927)] = 91163,
  [SMALL_STATE(2928)] = 91167,
  [SMALL_STATE(2929)] = 91171,
  [SMALL_STATE(2930)] = 91175,
  [SMALL_STATE(2931)] = 91179,
  [SMALL_STATE(2932)] = 91183,
  [SMALL_STATE(2933)] = 91187,
  [SMALL_STATE(2934)] = 91191,
  [SMALL_STATE(2935)] = 91195,
  [SMALL_STATE(2936)] = 91199,
  [SMALL_STATE(2937)] = 91203,
  [SMALL_STATE(2938)] = 91207,
  [SMALL_STATE(2939)] = 91211,
  [SMALL_STATE(2940)] = 91215,
  [SMALL_STATE(2941)] = 91219,
  [SMALL_STATE(2942)] = 91223,
  [SMALL_STATE(2943)] = 91227,
  [SMALL_STATE(2944)] = 91231,
  [SMALL_STATE(2945)] = 91235,
  [SMALL_STATE(2946)] = 91239,
  [SMALL_STATE(2947)] = 91243,
  [SMALL_STATE(2948)] = 91247,
  [SMALL_STATE(2949)] = 91251,
  [SMALL_STATE(2950)] = 91255,
  [SMALL_STATE(2951)] = 91259,
  [SMALL_STATE(2952)] = 91263,
  [SMALL_STATE(2953)] = 91267,
  [SMALL_STATE(2954)] = 91271,
  [SMALL_STATE(2955)] = 91275,
  [SMALL_STATE(2956)] = 91279,
  [SMALL_STATE(2957)] = 91283,
  [SMALL_STATE(2958)] = 91287,
  [SMALL_STATE(2959)] = 91291,
  [SMALL_STATE(2960)] = 91295,
  [SMALL_STATE(2961)] = 91299,
  [SMALL_STATE(2962)] = 91303,
  [SMALL_STATE(2963)] = 91307,
  [SMALL_STATE(2964)] = 91311,
  [SMALL_STATE(2965)] = 91315,
  [SMALL_STATE(2966)] = 91319,
  [SMALL_STATE(2967)] = 91323,
  [SMALL_STATE(2968)] = 91327,
  [SMALL_STATE(2969)] = 91331,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2530),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(340),
  [11] = {.count = 1, .reusable = false}, SHIFT(2856),
  [13] = {.count = 1, .reusable = false}, SHIFT(2857),
  [15] = {.count = 1, .reusable = true}, SHIFT(309),
  [17] = {.count = 1, .reusable = false}, SHIFT(2872),
  [19] = {.count = 1, .reusable = false}, SHIFT(1359),
  [21] = {.count = 1, .reusable = true}, SHIFT(177),
  [23] = {.count = 1, .reusable = true}, SHIFT(2774),
  [25] = {.count = 1, .reusable = true}, SHIFT(968),
  [27] = {.count = 1, .reusable = true}, SHIFT(862),
  [29] = {.count = 1, .reusable = false}, SHIFT(869),
  [31] = {.count = 1, .reusable = false}, SHIFT(870),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = false}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(1034),
  [43] = {.count = 1, .reusable = false}, SHIFT(1009),
  [45] = {.count = 1, .reusable = false}, SHIFT(211),
  [47] = {.count = 1, .reusable = false}, SHIFT(206),
  [49] = {.count = 1, .reusable = false}, SHIFT(573),
  [51] = {.count = 1, .reusable = false}, SHIFT(570),
  [53] = {.count = 1, .reusable = false}, SHIFT(861),
  [55] = {.count = 1, .reusable = false}, SHIFT(339),
  [57] = {.count = 1, .reusable = false}, SHIFT(55),
  [59] = {.count = 1, .reusable = false}, SHIFT(617),
  [61] = {.count = 1, .reusable = true}, SHIFT(392),
  [63] = {.count = 1, .reusable = false}, SHIFT(393),
  [65] = {.count = 1, .reusable = true}, SHIFT(394),
  [67] = {.count = 1, .reusable = true}, SHIFT(340),
  [69] = {.count = 1, .reusable = false}, SHIFT(1584),
  [71] = {.count = 1, .reusable = false}, SHIFT(1588),
  [73] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [75] = {.count = 1, .reusable = false}, SHIFT(1088),
  [77] = {.count = 1, .reusable = false}, SHIFT(1118),
  [79] = {.count = 1, .reusable = true}, SHIFT(1118),
  [81] = {.count = 1, .reusable = false}, SHIFT(944),
  [83] = {.count = 1, .reusable = false}, SHIFT(943),
  [85] = {.count = 1, .reusable = false}, SHIFT(926),
  [87] = {.count = 1, .reusable = true}, SHIFT(226),
  [89] = {.count = 1, .reusable = true}, SHIFT(2125),
  [91] = {.count = 1, .reusable = true}, SHIFT(1142),
  [93] = {.count = 1, .reusable = true}, SHIFT(2412),
  [95] = {.count = 1, .reusable = true}, SHIFT(2442),
  [97] = {.count = 1, .reusable = true}, SHIFT(2406),
  [99] = {.count = 1, .reusable = true}, SHIFT(2409),
  [101] = {.count = 1, .reusable = true}, SHIFT(2381),
  [103] = {.count = 1, .reusable = true}, SHIFT(2358),
  [105] = {.count = 1, .reusable = true}, SHIFT(617),
  [107] = {.count = 1, .reusable = false}, SHIFT(225),
  [109] = {.count = 1, .reusable = true}, SHIFT(131),
  [111] = {.count = 1, .reusable = true}, REDUCE(sym__lhs, 1),
  [113] = {.count = 1, .reusable = false}, SHIFT(177),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym__lhs, 1),
  [117] = {.count = 1, .reusable = false}, SHIFT(2742),
  [119] = {.count = 1, .reusable = false}, SHIFT(862),
  [121] = {.count = 1, .reusable = false}, SHIFT(1016),
  [123] = {.count = 1, .reusable = false}, SHIFT(1030),
  [125] = {.count = 1, .reusable = false}, SHIFT(1039),
  [127] = {.count = 1, .reusable = false}, SHIFT(1044),
  [129] = {.count = 1, .reusable = true}, SHIFT(235),
  [131] = {.count = 1, .reusable = true}, SHIFT(418),
  [133] = {.count = 1, .reusable = false}, SHIFT(417),
  [135] = {.count = 1, .reusable = false}, SHIFT(416),
  [137] = {.count = 1, .reusable = true}, SHIFT(416),
  [139] = {.count = 1, .reusable = true}, SHIFT(259),
  [141] = {.count = 1, .reusable = false}, SHIFT(259),
  [143] = {.count = 1, .reusable = false}, SHIFT(897),
  [145] = {.count = 1, .reusable = false}, SHIFT(901),
  [147] = {.count = 1, .reusable = false}, SHIFT(904),
  [149] = {.count = 1, .reusable = false}, SHIFT(226),
  [151] = {.count = 1, .reusable = true}, SHIFT(590),
  [153] = {.count = 1, .reusable = true}, SHIFT(580),
  [155] = {.count = 1, .reusable = true}, SHIFT(421),
  [157] = {.count = 1, .reusable = true}, SHIFT(2785),
  [159] = {.count = 1, .reusable = true}, SHIFT(135),
  [161] = {.count = 1, .reusable = false}, SHIFT(27),
  [163] = {.count = 1, .reusable = true}, SHIFT(133),
  [165] = {.count = 1, .reusable = false}, SHIFT(30),
  [167] = {.count = 1, .reusable = true}, SHIFT(248),
  [169] = {.count = 1, .reusable = false}, SHIFT(311),
  [171] = {.count = 1, .reusable = false}, SHIFT(2769),
  [173] = {.count = 1, .reusable = true}, SHIFT(318),
  [175] = {.count = 1, .reusable = false}, SHIFT(318),
  [177] = {.count = 1, .reusable = false}, SHIFT(381),
  [179] = {.count = 1, .reusable = true}, SHIFT(144),
  [181] = {.count = 1, .reusable = false}, SHIFT(1377),
  [183] = {.count = 1, .reusable = false}, SHIFT(201),
  [185] = {.count = 1, .reusable = false}, SHIFT(2899),
  [187] = {.count = 1, .reusable = false}, SHIFT(872),
  [189] = {.count = 1, .reusable = false}, SHIFT(875),
  [191] = {.count = 1, .reusable = false}, SHIFT(1375),
  [193] = {.count = 1, .reusable = false}, SHIFT(1374),
  [195] = {.count = 1, .reusable = false}, SHIFT(1373),
  [197] = {.count = 1, .reusable = false}, SHIFT(1371),
  [199] = {.count = 1, .reusable = false}, SHIFT(1379),
  [201] = {.count = 1, .reusable = false}, SHIFT(1366),
  [203] = {.count = 1, .reusable = false}, SHIFT(865),
  [205] = {.count = 1, .reusable = false}, SHIFT(363),
  [207] = {.count = 1, .reusable = false}, SHIFT(65),
  [209] = {.count = 1, .reusable = true}, SHIFT(255),
  [211] = {.count = 1, .reusable = true}, SHIFT(773),
  [213] = {.count = 1, .reusable = false}, SHIFT(770),
  [215] = {.count = 1, .reusable = false}, SHIFT(767),
  [217] = {.count = 1, .reusable = true}, SHIFT(767),
  [219] = {.count = 1, .reusable = true}, SHIFT(8),
  [221] = {.count = 1, .reusable = false}, SHIFT(1387),
  [223] = {.count = 1, .reusable = false}, SHIFT(1422),
  [225] = {.count = 1, .reusable = true}, SHIFT(1422),
  [227] = {.count = 1, .reusable = false}, SHIFT(8),
  [229] = {.count = 1, .reusable = false}, SHIFT(1008),
  [231] = {.count = 1, .reusable = false}, SHIFT(1049),
  [233] = {.count = 1, .reusable = false}, SHIFT(1048),
  [235] = {.count = 1, .reusable = false}, SHIFT(264),
  [237] = {.count = 1, .reusable = true}, SHIFT(2140),
  [239] = {.count = 1, .reusable = true}, SHIFT(1519),
  [241] = {.count = 1, .reusable = true}, SHIFT(2498),
  [243] = {.count = 1, .reusable = true}, SHIFT(2499),
  [245] = {.count = 1, .reusable = true}, SHIFT(2500),
  [247] = {.count = 1, .reusable = true}, SHIFT(2503),
  [249] = {.count = 1, .reusable = true}, SHIFT(2459),
  [251] = {.count = 1, .reusable = true}, SHIFT(2434),
  [253] = {.count = 1, .reusable = true}, SHIFT(858),
  [255] = {.count = 1, .reusable = true}, SHIFT(789),
  [257] = {.count = 1, .reusable = true}, SHIFT(774),
  [259] = {.count = 1, .reusable = true}, SHIFT(2967),
  [261] = {.count = 1, .reusable = true}, SHIFT(138),
  [263] = {.count = 1, .reusable = false}, SHIFT(34),
  [265] = {.count = 1, .reusable = true}, SHIFT(146),
  [267] = {.count = 1, .reusable = false}, SHIFT(31),
  [269] = {.count = 1, .reusable = true}, SHIFT(261),
  [271] = {.count = 1, .reusable = false}, SHIFT(228),
  [273] = {.count = 1, .reusable = true}, REDUCE(sym_return, 1),
  [275] = {.count = 1, .reusable = false}, REDUCE(sym_return, 1),
  [277] = {.count = 1, .reusable = true}, SHIFT(242),
  [279] = {.count = 1, .reusable = true}, SHIFT(614),
  [281] = {.count = 1, .reusable = false}, SHIFT(612),
  [283] = {.count = 1, .reusable = false}, SHIFT(483),
  [285] = {.count = 1, .reusable = true}, SHIFT(483),
  [287] = {.count = 1, .reusable = true}, SHIFT(634),
  [289] = {.count = 1, .reusable = true}, SHIFT(636),
  [291] = {.count = 1, .reusable = true}, SHIFT(610),
  [293] = {.count = 1, .reusable = true}, SHIFT(2847),
  [295] = {.count = 1, .reusable = true}, REDUCE(sym_next, 1),
  [297] = {.count = 1, .reusable = false}, REDUCE(sym_next, 1),
  [299] = {.count = 1, .reusable = true}, REDUCE(sym_break, 1),
  [301] = {.count = 1, .reusable = false}, REDUCE(sym_break, 1),
  [303] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [305] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 1),
  [307] = {.count = 1, .reusable = false}, SHIFT(312),
  [309] = {.count = 1, .reusable = false}, SHIFT(382),
  [311] = {.count = 1, .reusable = true}, SHIFT(316),
  [313] = {.count = 1, .reusable = true}, SHIFT(266),
  [315] = {.count = 1, .reusable = true}, SHIFT(782),
  [317] = {.count = 1, .reusable = false}, SHIFT(783),
  [319] = {.count = 1, .reusable = false}, SHIFT(784),
  [321] = {.count = 1, .reusable = true}, SHIFT(784),
  [323] = {.count = 1, .reusable = true}, SHIFT(9),
  [325] = {.count = 1, .reusable = false}, SHIFT(9),
  [327] = {.count = 1, .reusable = true}, SHIFT(794),
  [329] = {.count = 1, .reusable = true}, SHIFT(832),
  [331] = {.count = 1, .reusable = true}, SHIFT(778),
  [333] = {.count = 1, .reusable = true}, SHIFT(2955),
  [335] = {.count = 1, .reusable = false}, SHIFT(277),
  [337] = {.count = 1, .reusable = true}, SHIFT(2749),
  [339] = {.count = 1, .reusable = true}, SHIFT(2144),
  [341] = {.count = 1, .reusable = true}, SHIFT(958),
  [343] = {.count = 1, .reusable = false}, SHIFT(1058),
  [345] = {.count = 1, .reusable = false}, SHIFT(11),
  [347] = {.count = 1, .reusable = false}, SHIFT(14),
  [349] = {.count = 1, .reusable = false}, SHIFT(13),
  [351] = {.count = 1, .reusable = false}, SHIFT(12),
  [353] = {.count = 1, .reusable = false}, SHIFT(252),
  [355] = {.count = 1, .reusable = false}, SHIFT(143),
  [357] = {.count = 1, .reusable = false}, SHIFT(156),
  [359] = {.count = 1, .reusable = true}, SHIFT(277),
  [361] = {.count = 1, .reusable = false}, SHIFT(1592),
  [363] = {.count = 1, .reusable = false}, SHIFT(1578),
  [365] = {.count = 1, .reusable = true}, SHIFT(885),
  [367] = {.count = 1, .reusable = false}, SHIFT(2086),
  [369] = {.count = 1, .reusable = false}, SHIFT(1205),
  [371] = {.count = 1, .reusable = false}, SHIFT(1135),
  [373] = {.count = 1, .reusable = false}, SHIFT(906),
  [375] = {.count = 1, .reusable = false}, SHIFT(2280),
  [377] = {.count = 1, .reusable = false}, SHIFT(1524),
  [379] = {.count = 1, .reusable = false}, SHIFT(930),
  [381] = {.count = 1, .reusable = false}, SHIFT(1063),
  [383] = {.count = 1, .reusable = false}, SHIFT(2236),
  [385] = {.count = 1, .reusable = false}, SHIFT(1514),
  [387] = {.count = 1, .reusable = false}, SHIFT(1032),
  [389] = {.count = 1, .reusable = true}, SHIFT(942),
  [391] = {.count = 1, .reusable = false}, SHIFT(1413),
  [393] = {.count = 1, .reusable = false}, SHIFT(1502),
  [395] = {.count = 1, .reusable = false}, SHIFT(1085),
  [397] = {.count = 1, .reusable = false}, SHIFT(1089),
  [399] = {.count = 1, .reusable = false}, SHIFT(2238),
  [401] = {.count = 1, .reusable = false}, SHIFT(1006),
  [403] = {.count = 1, .reusable = false}, SHIFT(1496),
  [405] = {.count = 1, .reusable = false}, SHIFT(1013),
  [407] = {.count = 1, .reusable = false}, SHIFT(1478),
  [409] = {.count = 1, .reusable = false}, SHIFT(2227),
  [411] = {.count = 1, .reusable = false}, SHIFT(1407),
  [413] = {.count = 1, .reusable = false}, SHIFT(1092),
  [415] = {.count = 1, .reusable = false}, SHIFT(1010),
  [417] = {.count = 1, .reusable = false}, SHIFT(1505),
  [419] = {.count = 1, .reusable = false}, SHIFT(1508),
  [421] = {.count = 1, .reusable = false}, SHIFT(1507),
  [423] = {.count = 1, .reusable = false}, SHIFT(1493),
  [425] = {.count = 1, .reusable = false}, SHIFT(1499),
  [427] = {.count = 1, .reusable = false}, SHIFT(1482),
  [429] = {.count = 1, .reusable = false}, SHIFT(1489),
  [431] = {.count = 1, .reusable = false}, SHIFT(2226),
  [433] = {.count = 1, .reusable = false}, SHIFT(320),
  [435] = {.count = 1, .reusable = true}, SHIFT(912),
  [437] = {.count = 1, .reusable = true}, SHIFT(2742),
  [439] = {.count = 1, .reusable = true}, SHIFT(2145),
  [441] = {.count = 1, .reusable = true}, SHIFT(587),
  [443] = {.count = 1, .reusable = false}, SHIFT(444),
  [445] = {.count = 1, .reusable = true}, SHIFT(445),
  [447] = {.count = 1, .reusable = false}, SHIFT(446),
  [449] = {.count = 1, .reusable = true}, SHIFT(450),
  [451] = {.count = 1, .reusable = true}, SHIFT(444),
  [453] = {.count = 1, .reusable = true}, SHIFT(2913),
  [455] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [457] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [459] = {.count = 1, .reusable = true}, SHIFT(903),
  [461] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(277),
  [464] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2857),
  [467] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(309),
  [470] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [472] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2872),
  [475] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1359),
  [478] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(177),
  [481] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2749),
  [484] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(942),
  [487] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(862),
  [490] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(869),
  [493] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(870),
  [496] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [498] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [501] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [504] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [507] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(12),
  [510] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1034),
  [513] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1009),
  [516] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(211),
  [519] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(206),
  [522] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(573),
  [525] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(570),
  [528] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(861),
  [531] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(339),
  [534] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(55),
  [537] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(617),
  [540] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(392),
  [543] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(393),
  [546] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(394),
  [549] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(277),
  [552] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1592),
  [555] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1578),
  [558] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1088),
  [561] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1118),
  [564] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1118),
  [567] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(944),
  [570] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(943),
  [573] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(926),
  [576] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(226),
  [579] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2125),
  [582] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1142),
  [585] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2412),
  [588] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2442),
  [591] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2406),
  [594] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2409),
  [597] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2381),
  [600] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2358),
  [603] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(617),
  [606] = {.count = 1, .reusable = true}, SHIFT(913),
  [608] = {.count = 1, .reusable = false}, SHIFT(1486),
  [610] = {.count = 1, .reusable = false}, SHIFT(212),
  [612] = {.count = 1, .reusable = false}, SHIFT(137),
  [614] = {.count = 1, .reusable = false}, REDUCE(sym_then, 2),
  [616] = {.count = 1, .reusable = true}, SHIFT(1046),
  [618] = {.count = 1, .reusable = false}, SHIFT(2561),
  [620] = {.count = 1, .reusable = false}, SHIFT(2628),
  [622] = {.count = 1, .reusable = false}, REDUCE(sym_then, 1),
  [624] = {.count = 1, .reusable = false}, SHIFT(1153),
  [626] = {.count = 1, .reusable = false}, REDUCE(sym_else, 1),
  [628] = {.count = 1, .reusable = true}, SHIFT(1027),
  [630] = {.count = 1, .reusable = false}, REDUCE(sym_elsif, 3, .production_id = 41),
  [632] = {.count = 1, .reusable = true}, SHIFT(1020),
  [634] = {.count = 1, .reusable = false}, SHIFT(1501),
  [636] = {.count = 1, .reusable = false}, SHIFT(1150),
  [638] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 4, .production_id = 58),
  [640] = {.count = 1, .reusable = false}, SHIFT(1518),
  [642] = {.count = 1, .reusable = false}, SHIFT(1546),
  [644] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3, .production_id = 44),
  [646] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 2),
  [648] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3, .production_id = 46),
  [650] = {.count = 1, .reusable = false}, REDUCE(sym_when, 3, .production_id = 56),
  [652] = {.count = 1, .reusable = false}, REDUCE(sym_ensure, 1),
  [654] = {.count = 1, .reusable = false}, REDUCE(sym_else, 2, .production_id = 17),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_when, 4, .production_id = 64),
  [658] = {.count = 1, .reusable = true}, SHIFT(2258),
  [660] = {.count = 1, .reusable = true}, SHIFT(1102),
  [662] = {.count = 1, .reusable = true}, SHIFT(1053),
  [664] = {.count = 1, .reusable = true}, SHIFT(938),
  [666] = {.count = 1, .reusable = true}, SHIFT(2081),
  [668] = {.count = 1, .reusable = true}, SHIFT(1215),
  [670] = {.count = 1, .reusable = true}, SHIFT(920),
  [672] = {.count = 1, .reusable = true}, SHIFT(1484),
  [674] = {.count = 1, .reusable = true}, SHIFT(1062),
  [676] = {.count = 1, .reusable = true}, SHIFT(2240),
  [678] = {.count = 1, .reusable = true}, SHIFT(1554),
  [680] = {.count = 1, .reusable = true}, SHIFT(1028),
  [682] = {.count = 1, .reusable = false}, SHIFT(2622),
  [684] = {.count = 1, .reusable = true}, SHIFT(1539),
  [686] = {.count = 1, .reusable = false}, SHIFT(1545),
  [688] = {.count = 1, .reusable = true}, SHIFT(2284),
  [690] = {.count = 1, .reusable = true}, SHIFT(2596),
  [692] = {.count = 1, .reusable = true}, SHIFT(1101),
  [694] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(968),
  [697] = {.count = 1, .reusable = true}, SHIFT(948),
  [699] = {.count = 1, .reusable = false}, SHIFT(1512),
  [701] = {.count = 1, .reusable = true}, SHIFT(1217),
  [703] = {.count = 1, .reusable = false}, SHIFT(1094),
  [705] = {.count = 1, .reusable = false}, SHIFT(2625),
  [707] = {.count = 1, .reusable = true}, SHIFT(1452),
  [709] = {.count = 1, .reusable = false}, SHIFT(1125),
  [711] = {.count = 1, .reusable = false}, SHIFT(2593),
  [713] = {.count = 1, .reusable = false}, SHIFT(1172),
  [715] = {.count = 1, .reusable = true}, SHIFT(1051),
  [717] = {.count = 1, .reusable = true}, SHIFT(2123),
  [719] = {.count = 1, .reusable = true}, SHIFT(2088),
  [721] = {.count = 1, .reusable = false}, SHIFT(1510),
  [723] = {.count = 1, .reusable = true}, SHIFT(916),
  [725] = {.count = 1, .reusable = true}, SHIFT(2122),
  [727] = {.count = 1, .reusable = true}, SHIFT(1122),
  [729] = {.count = 1, .reusable = true}, SHIFT(1014),
  [731] = {.count = 1, .reusable = false}, SHIFT(1557),
  [733] = {.count = 1, .reusable = false}, SHIFT(1565),
  [735] = {.count = 1, .reusable = true}, SHIFT(2539),
  [737] = {.count = 1, .reusable = true}, SHIFT(2538),
  [739] = {.count = 1, .reusable = true}, SHIFT(1421),
  [741] = {.count = 1, .reusable = true}, SHIFT(1392),
  [743] = {.count = 1, .reusable = true}, SHIFT(1081),
  [745] = {.count = 1, .reusable = true}, SHIFT(2230),
  [747] = {.count = 1, .reusable = false}, SHIFT(1492),
  [749] = {.count = 1, .reusable = false}, SHIFT(10),
  [751] = {.count = 1, .reusable = false}, SHIFT(2959),
  [753] = {.count = 1, .reusable = false}, SHIFT(2958),
  [755] = {.count = 1, .reusable = true}, SHIFT(201),
  [757] = {.count = 1, .reusable = true}, SHIFT(2874),
  [759] = {.count = 1, .reusable = false}, SHIFT(19),
  [761] = {.count = 1, .reusable = false}, SHIFT(20),
  [763] = {.count = 1, .reusable = false}, SHIFT(21),
  [765] = {.count = 1, .reusable = false}, SHIFT(22),
  [767] = {.count = 1, .reusable = false}, SHIFT(216),
  [769] = {.count = 1, .reusable = false}, SHIFT(217),
  [771] = {.count = 1, .reusable = false}, SHIFT(806),
  [773] = {.count = 1, .reusable = false}, SHIFT(802),
  [775] = {.count = 1, .reusable = false}, SHIFT(822),
  [777] = {.count = 1, .reusable = true}, SHIFT(818),
  [779] = {.count = 1, .reusable = false}, SHIFT(817),
  [781] = {.count = 1, .reusable = true}, SHIFT(815),
  [783] = {.count = 1, .reusable = true}, SHIFT(10),
  [785] = {.count = 1, .reusable = false}, SHIFT(1598),
  [787] = {.count = 1, .reusable = false}, SHIFT(1601),
  [789] = {.count = 1, .reusable = false}, SHIFT(1597),
  [791] = {.count = 1, .reusable = true}, SHIFT(1597),
  [793] = {.count = 1, .reusable = false}, SHIFT(1057),
  [795] = {.count = 1, .reusable = false}, SHIFT(1076),
  [797] = {.count = 1, .reusable = false}, SHIFT(1078),
  [799] = {.count = 1, .reusable = true}, SHIFT(264),
  [801] = {.count = 1, .reusable = true}, SHIFT(822),
  [803] = {.count = 1, .reusable = false}, SHIFT(496),
  [805] = {.count = 1, .reusable = true}, SHIFT(526),
  [807] = {.count = 1, .reusable = false}, SHIFT(540),
  [809] = {.count = 1, .reusable = true}, SHIFT(548),
  [811] = {.count = 1, .reusable = true}, SHIFT(496),
  [813] = {.count = 1, .reusable = false}, SHIFT(610),
  [815] = {.count = 1, .reusable = true}, SHIFT(475),
  [817] = {.count = 1, .reusable = false}, SHIFT(1074),
  [819] = {.count = 1, .reusable = true}, SHIFT(306),
  [821] = {.count = 1, .reusable = false}, SHIFT(1360),
  [823] = {.count = 1, .reusable = true}, SHIFT(172),
  [825] = {.count = 1, .reusable = true}, SHIFT(336),
  [827] = {.count = 1, .reusable = true}, SHIFT(2777),
  [829] = {.count = 1, .reusable = false}, SHIFT(868),
  [831] = {.count = 1, .reusable = false}, SHIFT(871),
  [833] = {.count = 1, .reusable = false}, SHIFT(1382),
  [835] = {.count = 1, .reusable = false}, SHIFT(1383),
  [837] = {.count = 1, .reusable = false}, SHIFT(1381),
  [839] = {.count = 1, .reusable = false}, SHIFT(1378),
  [841] = {.count = 1, .reusable = false}, SHIFT(1372),
  [843] = {.count = 1, .reusable = false}, SHIFT(1370),
  [845] = {.count = 1, .reusable = false}, SHIFT(209),
  [847] = {.count = 1, .reusable = false}, SHIFT(208),
  [849] = {.count = 1, .reusable = false}, SHIFT(524),
  [851] = {.count = 1, .reusable = false}, SHIFT(427),
  [853] = {.count = 1, .reusable = false}, SHIFT(863),
  [855] = {.count = 1, .reusable = false}, SHIFT(354),
  [857] = {.count = 1, .reusable = false}, SHIFT(57),
  [859] = {.count = 1, .reusable = false}, SHIFT(478),
  [861] = {.count = 1, .reusable = true}, SHIFT(479),
  [863] = {.count = 1, .reusable = false}, SHIFT(480),
  [865] = {.count = 1, .reusable = true}, SHIFT(481),
  [867] = {.count = 1, .reusable = true}, SHIFT(1189),
  [869] = {.count = 1, .reusable = false}, SHIFT(1384),
  [871] = {.count = 1, .reusable = false}, SHIFT(1405),
  [873] = {.count = 1, .reusable = true}, SHIFT(1405),
  [875] = {.count = 1, .reusable = false}, SHIFT(1189),
  [877] = {.count = 1, .reusable = false}, SHIFT(1221),
  [879] = {.count = 1, .reusable = false}, SHIFT(1206),
  [881] = {.count = 1, .reusable = false}, SHIFT(1208),
  [883] = {.count = 1, .reusable = true}, SHIFT(237),
  [885] = {.count = 1, .reusable = true}, SHIFT(2127),
  [887] = {.count = 1, .reusable = true}, SHIFT(1404),
  [889] = {.count = 1, .reusable = true}, SHIFT(2392),
  [891] = {.count = 1, .reusable = true}, SHIFT(2476),
  [893] = {.count = 1, .reusable = true}, SHIFT(2401),
  [895] = {.count = 1, .reusable = true}, SHIFT(2438),
  [897] = {.count = 1, .reusable = true}, SHIFT(2329),
  [899] = {.count = 1, .reusable = true}, SHIFT(2322),
  [901] = {.count = 1, .reusable = true}, SHIFT(654),
  [903] = {.count = 1, .reusable = true}, SHIFT(655),
  [905] = {.count = 1, .reusable = true}, SHIFT(478),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym__variable, 1),
  [909] = {.count = 1, .reusable = true}, REDUCE(sym__variable, 1),
  [911] = {.count = 1, .reusable = false}, SHIFT(519),
  [913] = {.count = 1, .reusable = true}, SHIFT(1112),
  [915] = {.count = 1, .reusable = true}, SHIFT(271),
  [917] = {.count = 1, .reusable = false}, SHIFT(741),
  [919] = {.count = 1, .reusable = false}, SHIFT(826),
  [921] = {.count = 1, .reusable = true}, SHIFT(821),
  [923] = {.count = 1, .reusable = false}, SHIFT(799),
  [925] = {.count = 1, .reusable = true}, SHIFT(793),
  [927] = {.count = 1, .reusable = true}, SHIFT(826),
  [929] = {.count = 1, .reusable = true}, SHIFT(1228),
  [931] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 3),
  [933] = {.count = 1, .reusable = true}, SHIFT(1011),
  [935] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 2),
  [937] = {.count = 1, .reusable = true}, SHIFT(1077),
  [939] = {.count = 1, .reusable = true}, SHIFT(886),
  [941] = {.count = 1, .reusable = true}, SHIFT(941),
  [943] = {.count = 1, .reusable = true}, SHIFT(1472),
  [945] = {.count = 1, .reusable = true}, SHIFT(322),
  [947] = {.count = 1, .reusable = true}, SHIFT(2633),
  [949] = {.count = 1, .reusable = true}, SHIFT(2347),
  [951] = {.count = 1, .reusable = true}, SHIFT(1192),
  [953] = {.count = 1, .reusable = true}, SHIFT(1116),
  [955] = {.count = 1, .reusable = true}, SHIFT(1463),
  [957] = {.count = 1, .reusable = true}, SHIFT(2190),
  [959] = {.count = 1, .reusable = true}, SHIFT(915),
  [961] = {.count = 1, .reusable = true}, SHIFT(256),
  [963] = {.count = 1, .reusable = true}, SHIFT(900),
  [965] = {.count = 1, .reusable = true}, SHIFT(2216),
  [967] = {.count = 1, .reusable = true}, SHIFT(2257),
  [969] = {.count = 1, .reusable = true}, SHIFT(764),
  [971] = {.count = 1, .reusable = false}, SHIFT(884),
  [973] = {.count = 1, .reusable = true}, SHIFT(2741),
  [975] = {.count = 1, .reusable = false}, SHIFT(141),
  [977] = {.count = 1, .reusable = true}, SHIFT(874),
  [979] = {.count = 1, .reusable = false}, SHIFT(676),
  [981] = {.count = 1, .reusable = true}, SHIFT(678),
  [983] = {.count = 1, .reusable = false}, SHIFT(679),
  [985] = {.count = 1, .reusable = true}, SHIFT(692),
  [987] = {.count = 1, .reusable = true}, SHIFT(884),
  [989] = {.count = 1, .reusable = false}, SHIFT(1580),
  [991] = {.count = 1, .reusable = true}, SHIFT(652),
  [993] = {.count = 1, .reusable = true}, SHIFT(676),
  [995] = {.count = 1, .reusable = true}, SHIFT(727),
  [997] = {.count = 1, .reusable = false}, REDUCE(sym_operator, 1),
  [999] = {.count = 1, .reusable = true}, REDUCE(sym_operator, 1),
  [1001] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1003] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [1005] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [1007] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 3, .production_id = 27),
  [1009] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 3, .production_id = 27),
  [1011] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 2, .production_id = 7),
  [1013] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 2, .production_id = 7),
  [1015] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1017] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1019] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [1021] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym_call, 3, .production_id = 25),
  [1025] = {.count = 1, .reusable = true}, REDUCE(sym_call, 3, .production_id = 25),
  [1027] = {.count = 1, .reusable = true}, SHIFT(1411),
  [1029] = {.count = 1, .reusable = true}, SHIFT(1090),
  [1031] = {.count = 1, .reusable = true}, SHIFT(1516),
  [1033] = {.count = 1, .reusable = false}, SHIFT(880),
  [1035] = {.count = 1, .reusable = true}, SHIFT(635),
  [1037] = {.count = 1, .reusable = false}, SHIFT(882),
  [1039] = {.count = 1, .reusable = true}, SHIFT(482),
  [1041] = {.count = 1, .reusable = false}, SHIFT(421),
  [1043] = {.count = 1, .reusable = false}, SHIFT(991),
  [1045] = {.count = 1, .reusable = true}, SHIFT(2860),
  [1047] = {.count = 1, .reusable = true}, SHIFT(800),
  [1049] = {.count = 1, .reusable = false}, SHIFT(778),
  [1051] = {.count = 1, .reusable = true}, SHIFT(971),
  [1053] = {.count = 1, .reusable = false}, SHIFT(1461),
  [1055] = {.count = 1, .reusable = true}, SHIFT(1461),
  [1057] = {.count = 1, .reusable = false}, SHIFT(971),
  [1059] = {.count = 1, .reusable = false}, SHIFT(987),
  [1061] = {.count = 1, .reusable = true}, SHIFT(824),
  [1063] = {.count = 1, .reusable = false}, SHIFT(774),
  [1065] = {.count = 1, .reusable = true}, SHIFT(978),
  [1067] = {.count = 1, .reusable = false}, SHIFT(978),
  [1069] = {.count = 1, .reusable = true}, SHIFT(1163),
  [1071] = {.count = 1, .reusable = false}, SHIFT(559),
  [1073] = {.count = 1, .reusable = true}, SHIFT(582),
  [1075] = {.count = 1, .reusable = false}, SHIFT(583),
  [1077] = {.count = 1, .reusable = true}, SHIFT(584),
  [1079] = {.count = 1, .reusable = true}, SHIFT(559),
  [1081] = {.count = 1, .reusable = true}, SHIFT(1530),
  [1083] = {.count = 1, .reusable = true}, SHIFT(2606),
  [1085] = {.count = 1, .reusable = true}, SHIFT(1470),
  [1087] = {.count = 1, .reusable = true}, SHIFT(1179),
  [1089] = {.count = 1, .reusable = true}, SHIFT(2640),
  [1091] = {.count = 1, .reusable = true}, SHIFT(1534),
  [1093] = {.count = 1, .reusable = true}, SHIFT(1194),
  [1095] = {.count = 1, .reusable = true}, SHIFT(2584),
  [1097] = {.count = 1, .reusable = true}, SHIFT(1426),
  [1099] = {.count = 1, .reusable = false}, SHIFT(525),
  [1101] = {.count = 1, .reusable = true}, SHIFT(1467),
  [1103] = {.count = 1, .reusable = true}, SHIFT(1509),
  [1105] = {.count = 1, .reusable = false}, SHIFT(1045),
  [1107] = {.count = 1, .reusable = true}, SHIFT(2752),
  [1109] = {.count = 1, .reusable = false}, SHIFT(623),
  [1111] = {.count = 1, .reusable = true}, SHIFT(637),
  [1113] = {.count = 1, .reusable = false}, SHIFT(639),
  [1115] = {.count = 1, .reusable = true}, SHIFT(657),
  [1117] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1119] = {.count = 1, .reusable = false}, SHIFT(1071),
  [1121] = {.count = 1, .reusable = false}, SHIFT(1068),
  [1123] = {.count = 1, .reusable = false}, SHIFT(1067),
  [1125] = {.count = 1, .reusable = true}, SHIFT(508),
  [1127] = {.count = 1, .reusable = true}, SHIFT(623),
  [1129] = {.count = 1, .reusable = false}, SHIFT(924),
  [1131] = {.count = 1, .reusable = true}, SHIFT(2743),
  [1133] = {.count = 1, .reusable = false}, SHIFT(501),
  [1135] = {.count = 1, .reusable = true}, SHIFT(502),
  [1137] = {.count = 1, .reusable = false}, SHIFT(504),
  [1139] = {.count = 1, .reusable = true}, SHIFT(506),
  [1141] = {.count = 1, .reusable = true}, SHIFT(924),
  [1143] = {.count = 1, .reusable = true}, SHIFT(664),
  [1145] = {.count = 1, .reusable = true}, SHIFT(501),
  [1147] = {.count = 1, .reusable = true}, SHIFT(517),
  [1149] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 2, .production_id = 20),
  [1151] = {.count = 1, .reusable = false}, SHIFT(722),
  [1153] = {.count = 1, .reusable = true}, SHIFT(538),
  [1155] = {.count = 1, .reusable = false}, SHIFT(751),
  [1157] = {.count = 1, .reusable = true}, SHIFT(750),
  [1159] = {.count = 1, .reusable = true}, SHIFT(722),
  [1161] = {.count = 1, .reusable = false}, SHIFT(412),
  [1163] = {.count = 1, .reusable = true}, SHIFT(420),
  [1165] = {.count = 1, .reusable = false}, SHIFT(422),
  [1167] = {.count = 1, .reusable = true}, SHIFT(441),
  [1169] = {.count = 1, .reusable = true}, SHIFT(412),
  [1171] = {.count = 1, .reusable = false}, SHIFT(401),
  [1173] = {.count = 1, .reusable = true}, SHIFT(402),
  [1175] = {.count = 1, .reusable = false}, SHIFT(405),
  [1177] = {.count = 1, .reusable = true}, SHIFT(408),
  [1179] = {.count = 1, .reusable = true}, SHIFT(2485),
  [1181] = {.count = 1, .reusable = true}, SHIFT(749),
  [1183] = {.count = 1, .reusable = true}, SHIFT(401),
  [1185] = {.count = 1, .reusable = true}, SHIFT(541),
  [1187] = {.count = 1, .reusable = true}, SHIFT(2558),
  [1189] = {.count = 1, .reusable = false}, SHIFT(534),
  [1191] = {.count = 1, .reusable = true}, SHIFT(533),
  [1193] = {.count = 1, .reusable = false}, SHIFT(531),
  [1195] = {.count = 1, .reusable = true}, SHIFT(530),
  [1197] = {.count = 1, .reusable = true}, SHIFT(534),
  [1199] = {.count = 1, .reusable = true}, SHIFT(571),
  [1201] = {.count = 1, .reusable = false}, SHIFT(460),
  [1203] = {.count = 1, .reusable = true}, SHIFT(461),
  [1205] = {.count = 1, .reusable = false}, SHIFT(497),
  [1207] = {.count = 1, .reusable = true}, SHIFT(499),
  [1209] = {.count = 1, .reusable = true}, SHIFT(423),
  [1211] = {.count = 1, .reusable = true}, SHIFT(460),
  [1213] = {.count = 1, .reusable = true}, SHIFT(484),
  [1215] = {.count = 1, .reusable = true}, SHIFT(640),
  [1217] = {.count = 1, .reusable = false}, SHIFT(979),
  [1219] = {.count = 1, .reusable = true}, SHIFT(2831),
  [1221] = {.count = 1, .reusable = true}, SHIFT(979),
  [1223] = {.count = 1, .reusable = false}, SHIFT(1575),
  [1225] = {.count = 1, .reusable = true}, SHIFT(1575),
  [1227] = {.count = 1, .reusable = true}, SHIFT(837),
  [1229] = {.count = 1, .reusable = false}, SHIFT(981),
  [1231] = {.count = 1, .reusable = false}, SHIFT(827),
  [1233] = {.count = 1, .reusable = true}, SHIFT(828),
  [1235] = {.count = 1, .reusable = false}, SHIFT(829),
  [1237] = {.count = 1, .reusable = true}, SHIFT(830),
  [1239] = {.count = 1, .reusable = true}, SHIFT(981),
  [1241] = {.count = 1, .reusable = true}, SHIFT(827),
  [1243] = {.count = 1, .reusable = true}, SHIFT(779),
  [1245] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 2, .production_id = 20),
  [1247] = {.count = 1, .reusable = false}, SHIFT(795),
  [1249] = {.count = 1, .reusable = false}, SHIFT(766),
  [1251] = {.count = 1, .reusable = false}, SHIFT(398),
  [1253] = {.count = 1, .reusable = true}, SHIFT(397),
  [1255] = {.count = 1, .reusable = false}, SHIFT(396),
  [1257] = {.count = 1, .reusable = true}, SHIFT(395),
  [1259] = {.count = 1, .reusable = true}, SHIFT(398),
  [1261] = {.count = 1, .reusable = false}, SHIFT(1390),
  [1263] = {.count = 1, .reusable = false}, SHIFT(1529),
  [1265] = {.count = 1, .reusable = false}, SHIFT(1086),
  [1267] = {.count = 1, .reusable = false}, SHIFT(1127),
  [1269] = {.count = 1, .reusable = false}, SHIFT(680),
  [1271] = {.count = 1, .reusable = true}, SHIFT(686),
  [1273] = {.count = 1, .reusable = false}, SHIFT(687),
  [1275] = {.count = 1, .reusable = true}, SHIFT(688),
  [1277] = {.count = 1, .reusable = true}, SHIFT(680),
  [1279] = {.count = 1, .reusable = false}, SHIFT(1583),
  [1281] = {.count = 1, .reusable = false}, SHIFT(513),
  [1283] = {.count = 1, .reusable = true}, SHIFT(511),
  [1285] = {.count = 1, .reusable = false}, SHIFT(510),
  [1287] = {.count = 1, .reusable = true}, SHIFT(509),
  [1289] = {.count = 1, .reusable = true}, SHIFT(513),
  [1291] = {.count = 1, .reusable = false}, SHIFT(1389),
  [1293] = {.count = 1, .reusable = false}, SHIFT(1550),
  [1295] = {.count = 1, .reusable = false}, SHIFT(2185),
  [1297] = {.count = 1, .reusable = true}, SHIFT(315),
  [1299] = {.count = 1, .reusable = false}, SHIFT(1363),
  [1301] = {.count = 1, .reusable = true}, SHIFT(176),
  [1303] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 2),
  [1305] = {.count = 1, .reusable = true}, SHIFT(2747),
  [1307] = {.count = 1, .reusable = false}, SHIFT(867),
  [1309] = {.count = 1, .reusable = false}, SHIFT(873),
  [1311] = {.count = 1, .reusable = false}, SHIFT(2484),
  [1313] = {.count = 1, .reusable = false}, SHIFT(2488),
  [1315] = {.count = 1, .reusable = false}, SHIFT(2426),
  [1317] = {.count = 1, .reusable = false}, SHIFT(2391),
  [1319] = {.count = 1, .reusable = false}, SHIFT(2452),
  [1321] = {.count = 1, .reusable = false}, SHIFT(2473),
  [1323] = {.count = 1, .reusable = false}, SHIFT(210),
  [1325] = {.count = 1, .reusable = false}, SHIFT(213),
  [1327] = {.count = 1, .reusable = false}, SHIFT(616),
  [1329] = {.count = 1, .reusable = false}, SHIFT(620),
  [1331] = {.count = 1, .reusable = false}, SHIFT(864),
  [1333] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 2),
  [1335] = {.count = 1, .reusable = false}, SHIFT(345),
  [1337] = {.count = 1, .reusable = false}, SHIFT(58),
  [1339] = {.count = 1, .reusable = false}, SHIFT(2772),
  [1341] = {.count = 1, .reusable = true}, SHIFT(2775),
  [1343] = {.count = 1, .reusable = false}, SHIFT(2775),
  [1345] = {.count = 1, .reusable = true}, SHIFT(2185),
  [1347] = {.count = 1, .reusable = false}, SHIFT(2496),
  [1349] = {.count = 1, .reusable = false}, SHIFT(2641),
  [1351] = {.count = 1, .reusable = true}, SHIFT(2641),
  [1353] = {.count = 1, .reusable = false}, SHIFT(2312),
  [1355] = {.count = 1, .reusable = false}, SHIFT(2254),
  [1357] = {.count = 1, .reusable = false}, SHIFT(2252),
  [1359] = {.count = 1, .reusable = true}, SHIFT(240),
  [1361] = {.count = 1, .reusable = true}, SHIFT(2134),
  [1363] = {.count = 1, .reusable = true}, SHIFT(2572),
  [1365] = {.count = 1, .reusable = true}, SHIFT(2429),
  [1367] = {.count = 1, .reusable = true}, SHIFT(2486),
  [1369] = {.count = 1, .reusable = true}, SHIFT(2427),
  [1371] = {.count = 1, .reusable = true}, SHIFT(2425),
  [1373] = {.count = 1, .reusable = true}, SHIFT(2354),
  [1375] = {.count = 1, .reusable = true}, SHIFT(2321),
  [1377] = {.count = 1, .reusable = true}, SHIFT(2772),
  [1379] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 3),
  [1381] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 3),
  [1383] = {.count = 1, .reusable = true}, SHIFT(188),
  [1385] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 1),
  [1387] = {.count = 1, .reusable = false}, REDUCE(sym_rest_assignment, 1),
  [1389] = {.count = 1, .reusable = true}, SHIFT(2770),
  [1391] = {.count = 1, .reusable = false}, SHIFT(2173),
  [1393] = {.count = 1, .reusable = true}, SHIFT(604),
  [1395] = {.count = 1, .reusable = false}, SHIFT(2170),
  [1397] = {.count = 1, .reusable = true}, SHIFT(564),
  [1399] = {.count = 1, .reusable = false}, SHIFT(2174),
  [1401] = {.count = 1, .reusable = true}, SHIFT(618),
  [1403] = {.count = 1, .reusable = false}, SHIFT(2176),
  [1405] = {.count = 1, .reusable = false}, SHIFT(2198),
  [1407] = {.count = 1, .reusable = false}, SHIFT(2193),
  [1409] = {.count = 1, .reusable = true}, SHIFT(792),
  [1411] = {.count = 1, .reusable = false}, SHIFT(2189),
  [1413] = {.count = 1, .reusable = false}, SHIFT(2221),
  [1415] = {.count = 1, .reusable = true}, SHIFT(2221),
  [1417] = {.count = 1, .reusable = false}, SHIFT(2360),
  [1419] = {.count = 1, .reusable = false}, SHIFT(2357),
  [1421] = {.count = 1, .reusable = false}, SHIFT(2356),
  [1423] = {.count = 1, .reusable = false}, SHIFT(2220),
  [1425] = {.count = 1, .reusable = true}, SHIFT(165),
  [1427] = {.count = 1, .reusable = true}, SHIFT(27),
  [1429] = {.count = 1, .reusable = true}, SHIFT(162),
  [1431] = {.count = 1, .reusable = true}, SHIFT(30),
  [1433] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2, .production_id = 9),
  [1435] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2, .production_id = 9),
  [1437] = {.count = 1, .reusable = false}, REDUCE(sym__terminator, 1),
  [1439] = {.count = 1, .reusable = true}, REDUCE(sym__terminator, 1),
  [1441] = {.count = 1, .reusable = true}, REDUCE(sym__primary, 1),
  [1443] = {.count = 1, .reusable = false}, REDUCE(sym__primary, 1),
  [1445] = {.count = 1, .reusable = false}, SHIFT(356),
  [1447] = {.count = 1, .reusable = true}, SHIFT(591),
  [1449] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2, .production_id = 10),
  [1451] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2, .production_id = 10),
  [1453] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 2),
  [1455] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 2),
  [1457] = {.count = 1, .reusable = true}, REDUCE(sym_true, 1),
  [1459] = {.count = 1, .reusable = false}, REDUCE(sym_true, 1),
  [1461] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 3, .production_id = 28),
  [1463] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 3, .production_id = 28),
  [1465] = {.count = 1, .reusable = false}, SHIFT(334),
  [1467] = {.count = 1, .reusable = true}, SHIFT(705),
  [1469] = {.count = 1, .reusable = true}, REDUCE(sym_false, 1),
  [1471] = {.count = 1, .reusable = false}, REDUCE(sym_false, 1),
  [1473] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 2),
  [1475] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 2),
  [1477] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [1479] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 2),
  [1481] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [1483] = {.count = 1, .reusable = true}, REDUCE(sym_nil, 1),
  [1485] = {.count = 1, .reusable = false}, REDUCE(sym_nil, 1),
  [1487] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 1),
  [1489] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 1),
  [1491] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 4, .production_id = 26),
  [1493] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 4, .production_id = 26),
  [1495] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 3),
  [1497] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 3),
  [1499] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 3, .production_id = 26),
  [1501] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 3, .production_id = 26),
  [1503] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [1505] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [1507] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 3),
  [1509] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 3),
  [1511] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [1513] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [1515] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 5),
  [1517] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 5),
  [1519] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 4),
  [1521] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 4),
  [1523] = {.count = 1, .reusable = false}, SHIFT(348),
  [1525] = {.count = 1, .reusable = true}, SHIFT(619),
  [1527] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [1529] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [1531] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 1),
  [1533] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 1),
  [1535] = {.count = 1, .reusable = true}, SHIFT(859),
  [1537] = {.count = 1, .reusable = false}, SHIFT(357),
  [1539] = {.count = 1, .reusable = true}, SHIFT(387),
  [1541] = {.count = 1, .reusable = false}, SHIFT(344),
  [1543] = {.count = 1, .reusable = true}, SHIFT(399),
  [1545] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 4),
  [1547] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 4),
  [1549] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 4),
  [1551] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 4),
  [1553] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 2),
  [1555] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 2),
  [1557] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 3),
  [1559] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [1561] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 2),
  [1563] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [1565] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 3),
  [1567] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 3),
  [1569] = {.count = 1, .reusable = false}, SHIFT(222),
  [1571] = {.count = 1, .reusable = true}, SHIFT(283),
  [1573] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 8),
  [1575] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 8),
  [1577] = {.count = 1, .reusable = false}, SHIFT(218),
  [1579] = {.count = 1, .reusable = true}, SHIFT(293),
  [1581] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 5),
  [1583] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 5),
  [1585] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 6),
  [1587] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 6),
  [1589] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 7),
  [1591] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 7),
  [1593] = {.count = 1, .reusable = false}, REDUCE(sym__do, 1),
  [1595] = {.count = 1, .reusable = true}, REDUCE(sym__do, 1),
  [1597] = {.count = 1, .reusable = true}, SHIFT(170),
  [1599] = {.count = 1, .reusable = true}, SHIFT(34),
  [1601] = {.count = 1, .reusable = true}, SHIFT(167),
  [1603] = {.count = 1, .reusable = true}, SHIFT(31),
  [1605] = {.count = 1, .reusable = true}, SHIFT(161),
  [1607] = {.count = 1, .reusable = true}, SHIFT(23),
  [1609] = {.count = 1, .reusable = true}, SHIFT(232),
  [1611] = {.count = 1, .reusable = false}, SHIFT(220),
  [1613] = {.count = 1, .reusable = true}, SHIFT(280),
  [1615] = {.count = 1, .reusable = false}, SHIFT(219),
  [1617] = {.count = 1, .reusable = true}, SHIFT(268),
  [1619] = {.count = 1, .reusable = false}, SHIFT(518),
  [1621] = {.count = 1, .reusable = false}, SHIFT(223),
  [1623] = {.count = 1, .reusable = true}, SHIFT(287),
  [1625] = {.count = 1, .reusable = false}, SHIFT(331),
  [1627] = {.count = 1, .reusable = true}, SHIFT(726),
  [1629] = {.count = 1, .reusable = false}, SHIFT(221),
  [1631] = {.count = 1, .reusable = true}, SHIFT(290),
  [1633] = {.count = 1, .reusable = true}, REDUCE(sym_chained_string, 2),
  [1635] = {.count = 1, .reusable = false}, REDUCE(sym_chained_string, 2),
  [1637] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [1639] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [1641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2412),
  [1644] = {.count = 1, .reusable = false}, SHIFT(367),
  [1646] = {.count = 1, .reusable = true}, SHIFT(823),
  [1648] = {.count = 1, .reusable = true}, SHIFT(164),
  [1650] = {.count = 1, .reusable = true}, SHIFT(25),
  [1652] = {.count = 1, .reusable = true}, SHIFT(243),
  [1654] = {.count = 1, .reusable = true}, REDUCE(sym_retry, 1),
  [1656] = {.count = 1, .reusable = false}, REDUCE(sym_retry, 1),
  [1658] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .production_id = 11),
  [1660] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .production_id = 11),
  [1662] = {.count = 1, .reusable = false}, SHIFT(364),
  [1664] = {.count = 1, .reusable = true}, SHIFT(805),
  [1666] = {.count = 1, .reusable = true}, REDUCE(sym_redo, 1),
  [1668] = {.count = 1, .reusable = false}, REDUCE(sym_redo, 1),
  [1670] = {.count = 1, .reusable = false}, SHIFT(740),
  [1672] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .production_id = 2),
  [1674] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .production_id = 2),
  [1676] = {.count = 1, .reusable = false}, SHIFT(362),
  [1678] = {.count = 1, .reusable = true}, SHIFT(850),
  [1680] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 1),
  [1682] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 1),
  [1684] = {.count = 1, .reusable = true}, REDUCE(sym_unary_literal, 2),
  [1686] = {.count = 1, .reusable = false}, REDUCE(sym_unary_literal, 2),
  [1688] = {.count = 1, .reusable = false}, SHIFT(1117),
  [1690] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4, .production_id = 17),
  [1692] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4, .production_id = 17),
  [1694] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .production_id = 34),
  [1696] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .production_id = 34),
  [1698] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [1700] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [1702] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 2, .production_id = 5),
  [1704] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 2, .production_id = 5),
  [1706] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4, .production_id = 42),
  [1708] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4, .production_id = 42),
  [1710] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 2),
  [1712] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 2),
  [1714] = {.count = 1, .reusable = true}, REDUCE(sym_case, 7, .production_id = 42),
  [1716] = {.count = 1, .reusable = false}, REDUCE(sym_case, 7, .production_id = 42),
  [1718] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 2, .production_id = 5),
  [1720] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 2, .production_id = 5),
  [1722] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 2, .production_id = 3),
  [1724] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 2, .production_id = 3),
  [1726] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3, .production_id = 21),
  [1728] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 3, .production_id = 21),
  [1730] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 2, .production_id = 8),
  [1732] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 2, .production_id = 8),
  [1734] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2, .production_id = 4),
  [1736] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 2, .production_id = 4),
  [1738] = {.count = 1, .reusable = false}, SHIFT(361),
  [1740] = {.count = 1, .reusable = true}, SHIFT(803),
  [1742] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [1744] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [1746] = {.count = 1, .reusable = true}, REDUCE(sym__arg, 1),
  [1748] = {.count = 1, .reusable = false}, SHIFT(1770),
  [1750] = {.count = 1, .reusable = false}, REDUCE(sym__arg, 1),
  [1752] = {.count = 1, .reusable = true}, SHIFT(246),
  [1754] = {.count = 1, .reusable = true}, SHIFT(2746),
  [1756] = {.count = 1, .reusable = true}, SHIFT(1770),
  [1758] = {.count = 1, .reusable = true}, REDUCE(sym_rational, 2),
  [1760] = {.count = 1, .reusable = false}, REDUCE(sym_rational, 2),
  [1762] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6),
  [1764] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6),
  [1766] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 3),
  [1768] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 3),
  [1770] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4),
  [1772] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4),
  [1774] = {.count = 1, .reusable = true}, REDUCE(sym_until, 4, .production_id = 17),
  [1776] = {.count = 1, .reusable = false}, REDUCE(sym_until, 4, .production_id = 17),
  [1778] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6, .production_id = 42),
  [1780] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6, .production_id = 42),
  [1782] = {.count = 1, .reusable = true}, REDUCE(sym_method, 2, .production_id = 6),
  [1784] = {.count = 1, .reusable = false}, REDUCE(sym_method, 2, .production_id = 6),
  [1786] = {.count = 1, .reusable = true}, REDUCE(sym_for, 6, .production_id = 54),
  [1788] = {.count = 1, .reusable = false}, REDUCE(sym_for, 6, .production_id = 54),
  [1790] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .production_id = 48),
  [1792] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .production_id = 48),
  [1794] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_unary, 2),
  [1796] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_unary, 2),
  [1798] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 2),
  [1800] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 2),
  [1802] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 3),
  [1804] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 3),
  [1806] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .production_id = 49),
  [1808] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .production_id = 49),
  [1810] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .production_id = 50),
  [1812] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .production_id = 50),
  [1814] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .production_id = 15),
  [1816] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .production_id = 15),
  [1818] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 6, .production_id = 62),
  [1820] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 6, .production_id = 62),
  [1822] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 6, .production_id = 61),
  [1824] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 6, .production_id = 61),
  [1826] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 1),
  [1828] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 1),
  [1830] = {.count = 1, .reusable = false}, SHIFT(229),
  [1832] = {.count = 1, .reusable = true}, SHIFT(299),
  [1834] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .production_id = 51),
  [1836] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .production_id = 51),
  [1838] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .production_id = 14),
  [1840] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .production_id = 14),
  [1842] = {.count = 1, .reusable = true}, REDUCE(sym_return, 2),
  [1844] = {.count = 1, .reusable = false}, REDUCE(sym_return, 2),
  [1846] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 3),
  [1848] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 3),
  [1850] = {.count = 1, .reusable = true}, REDUCE(sym_retry, 2),
  [1852] = {.count = 1, .reusable = false}, REDUCE(sym_retry, 2),
  [1854] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 2, .production_id = 2),
  [1856] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 2, .production_id = 2),
  [1858] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 4, .production_id = 41),
  [1860] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 4, .production_id = 41),
  [1862] = {.count = 1, .reusable = true}, REDUCE(sym_redo, 2),
  [1864] = {.count = 1, .reusable = false}, REDUCE(sym_redo, 2),
  [1866] = {.count = 1, .reusable = false}, SHIFT(238),
  [1868] = {.count = 1, .reusable = true}, SHIFT(304),
  [1870] = {.count = 1, .reusable = true}, REDUCE(sym_if, 4, .production_id = 41),
  [1872] = {.count = 1, .reusable = false}, REDUCE(sym_if, 4, .production_id = 41),
  [1874] = {.count = 1, .reusable = false}, SHIFT(374),
  [1876] = {.count = 1, .reusable = true}, SHIFT(801),
  [1878] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4, .production_id = 7),
  [1880] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4, .production_id = 7),
  [1882] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 6, .production_id = 60),
  [1884] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 6, .production_id = 60),
  [1886] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 13),
  [1888] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 13),
  [1890] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 7),
  [1892] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 7),
  [1894] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3, .production_id = 12),
  [1896] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3, .production_id = 12),
  [1898] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .production_id = 30),
  [1900] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .production_id = 30),
  [1902] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 5),
  [1904] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 5),
  [1906] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .production_id = 31),
  [1908] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .production_id = 31),
  [1910] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 3, .production_id = 11),
  [1912] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 3, .production_id = 11),
  [1914] = {.count = 1, .reusable = true}, REDUCE(sym_next, 2),
  [1916] = {.count = 1, .reusable = false}, REDUCE(sym_next, 2),
  [1918] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5),
  [1920] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5),
  [1922] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3, .production_id = 7),
  [1924] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3, .production_id = 7),
  [1926] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5, .production_id = 42),
  [1928] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5, .production_id = 42),
  [1930] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .production_id = 32),
  [1932] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .production_id = 32),
  [1934] = {.count = 1, .reusable = true}, REDUCE(sym_for, 5, .production_id = 54),
  [1936] = {.count = 1, .reusable = false}, REDUCE(sym_for, 5, .production_id = 54),
  [1938] = {.count = 1, .reusable = true}, REDUCE(sym_until, 5, .production_id = 17),
  [1940] = {.count = 1, .reusable = false}, REDUCE(sym_until, 5, .production_id = 17),
  [1942] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5, .production_id = 17),
  [1944] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5, .production_id = 17),
  [1946] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 5, .production_id = 53),
  [1948] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 5, .production_id = 53),
  [1950] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .production_id = 30),
  [1952] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .production_id = 30),
  [1954] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 4, .production_id = 39),
  [1956] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 4, .production_id = 39),
  [1958] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .production_id = 14),
  [1960] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .production_id = 14),
  [1962] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 2),
  [1964] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3, .production_id = 20),
  [1966] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3, .production_id = 20),
  [1968] = {.count = 1, .reusable = true}, REDUCE(sym_case, 3),
  [1970] = {.count = 1, .reusable = false}, REDUCE(sym_case, 3),
  [1972] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3, .production_id = 40),
  [1974] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3, .production_id = 40),
  [1976] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .production_id = 35),
  [1978] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .production_id = 35),
  [1980] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 4, .production_id = 40),
  [1982] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 4, .production_id = 40),
  [1984] = {.count = 1, .reusable = true}, REDUCE(sym_break, 2),
  [1986] = {.count = 1, .reusable = false}, REDUCE(sym_break, 2),
  [1988] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_class, 5, .production_id = 52),
  [1990] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_class, 5, .production_id = 52),
  [1992] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 7),
  [1994] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 7),
  [1996] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [1998] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 2),
  [2000] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5, .production_id = 53),
  [2002] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5, .production_id = 53),
  [2004] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .production_id = 16),
  [2006] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .production_id = 16),
  [2008] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 4),
  [2010] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 4),
  [2012] = {.count = 1, .reusable = false}, SHIFT(352),
  [2014] = {.count = 1, .reusable = true}, SHIFT(514),
  [2016] = {.count = 1, .reusable = false}, SHIFT(341),
  [2018] = {.count = 1, .reusable = true}, SHIFT(443),
  [2020] = {.count = 1, .reusable = false}, SHIFT(1827),
  [2022] = {.count = 1, .reusable = true}, SHIFT(236),
  [2024] = {.count = 1, .reusable = true}, SHIFT(2738),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1827),
  [2028] = {.count = 1, .reusable = false}, SHIFT(1775),
  [2030] = {.count = 1, .reusable = true}, SHIFT(2744),
  [2032] = {.count = 1, .reusable = true}, SHIFT(1775),
  [2034] = {.count = 1, .reusable = false}, SHIFT(355),
  [2036] = {.count = 1, .reusable = true}, SHIFT(545),
  [2038] = {.count = 1, .reusable = false}, SHIFT(350),
  [2040] = {.count = 1, .reusable = true}, SHIFT(516),
  [2042] = {.count = 1, .reusable = false}, SHIFT(329),
  [2044] = {.count = 1, .reusable = true}, SHIFT(449),
  [2046] = {.count = 1, .reusable = false}, SHIFT(342),
  [2048] = {.count = 1, .reusable = true}, SHIFT(658),
  [2050] = {.count = 1, .reusable = false}, SHIFT(328),
  [2052] = {.count = 1, .reusable = true}, SHIFT(440),
  [2054] = {.count = 1, .reusable = false}, SHIFT(353),
  [2056] = {.count = 1, .reusable = true}, SHIFT(611),
  [2058] = {.count = 1, .reusable = true}, REDUCE(sym_right_assignment_list, 2),
  [2060] = {.count = 1, .reusable = true}, SHIFT(370),
  [2062] = {.count = 1, .reusable = false}, REDUCE(sym_right_assignment_list, 2),
  [2064] = {.count = 1, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [2066] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(370),
  [2069] = {.count = 1, .reusable = false}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [2071] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3, .production_id = 29),
  [2073] = {.count = 1, .reusable = false}, SHIFT(576),
  [2075] = {.count = 1, .reusable = true}, SHIFT(577),
  [2077] = {.count = 1, .reusable = false}, SHIFT(578),
  [2079] = {.count = 1, .reusable = false}, SHIFT(579),
  [2081] = {.count = 1, .reusable = true}, SHIFT(529),
  [2083] = {.count = 1, .reusable = false}, SHIFT(585),
  [2085] = {.count = 1, .reusable = true}, SHIFT(585),
  [2087] = {.count = 1, .reusable = true}, SHIFT(586),
  [2089] = {.count = 1, .reusable = true}, SHIFT(588),
  [2091] = {.count = 1, .reusable = true}, SHIFT(579),
  [2093] = {.count = 1, .reusable = true}, SHIFT(576),
  [2095] = {.count = 1, .reusable = true}, SHIFT(574),
  [2097] = {.count = 1, .reusable = true}, SHIFT(575),
  [2099] = {.count = 1, .reusable = false}, SHIFT(589),
  [2101] = {.count = 1, .reusable = true}, SHIFT(589),
  [2103] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3, .production_id = 29),
  [2105] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3, .production_id = 24),
  [2107] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3, .production_id = 24),
  [2109] = {.count = 1, .reusable = true}, REDUCE(sym_operator_assignment, 3, .production_id = 29),
  [2111] = {.count = 1, .reusable = true}, REDUCE(sym_conditional, 5, .production_id = 59),
  [2113] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2),
  [2115] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(365),
  [2118] = {.count = 1, .reusable = false}, SHIFT(347),
  [2120] = {.count = 1, .reusable = true}, SHIFT(622),
  [2122] = {.count = 1, .reusable = false}, SHIFT(349),
  [2124] = {.count = 1, .reusable = true}, SHIFT(615),
  [2126] = {.count = 1, .reusable = true}, REDUCE(sym_range, 3),
  [2128] = {.count = 1, .reusable = true}, REDUCE(sym__argument, 1),
  [2130] = {.count = 1, .reusable = true}, SHIFT(518),
  [2132] = {.count = 1, .reusable = false}, SHIFT(335),
  [2134] = {.count = 1, .reusable = true}, SHIFT(691),
  [2136] = {.count = 1, .reusable = true}, SHIFT(365),
  [2138] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2),
  [2140] = {.count = 1, .reusable = true}, REDUCE(sym_splat_argument, 2),
  [2142] = {.count = 1, .reusable = false}, SHIFT(330),
  [2144] = {.count = 1, .reusable = true}, SHIFT(737),
  [2146] = {.count = 1, .reusable = false}, SHIFT(696),
  [2148] = {.count = 1, .reusable = true}, SHIFT(697),
  [2150] = {.count = 1, .reusable = false}, SHIFT(698),
  [2152] = {.count = 1, .reusable = false}, SHIFT(699),
  [2154] = {.count = 1, .reusable = true}, SHIFT(621),
  [2156] = {.count = 1, .reusable = false}, SHIFT(700),
  [2158] = {.count = 1, .reusable = true}, SHIFT(700),
  [2160] = {.count = 1, .reusable = true}, SHIFT(701),
  [2162] = {.count = 1, .reusable = true}, SHIFT(702),
  [2164] = {.count = 1, .reusable = true}, SHIFT(699),
  [2166] = {.count = 1, .reusable = true}, SHIFT(696),
  [2168] = {.count = 1, .reusable = true}, SHIFT(694),
  [2170] = {.count = 1, .reusable = true}, SHIFT(695),
  [2172] = {.count = 1, .reusable = false}, SHIFT(703),
  [2174] = {.count = 1, .reusable = true}, SHIFT(703),
  [2176] = {.count = 1, .reusable = false}, SHIFT(631),
  [2178] = {.count = 1, .reusable = true}, SHIFT(630),
  [2180] = {.count = 1, .reusable = false}, SHIFT(629),
  [2182] = {.count = 1, .reusable = false}, SHIFT(628),
  [2184] = {.count = 1, .reusable = true}, SHIFT(593),
  [2186] = {.count = 1, .reusable = false}, SHIFT(627),
  [2188] = {.count = 1, .reusable = true}, SHIFT(627),
  [2190] = {.count = 1, .reusable = true}, SHIFT(626),
  [2192] = {.count = 1, .reusable = true}, SHIFT(625),
  [2194] = {.count = 1, .reusable = true}, SHIFT(628),
  [2196] = {.count = 1, .reusable = true}, SHIFT(631),
  [2198] = {.count = 1, .reusable = true}, SHIFT(633),
  [2200] = {.count = 1, .reusable = true}, SHIFT(632),
  [2202] = {.count = 1, .reusable = false}, SHIFT(624),
  [2204] = {.count = 1, .reusable = true}, SHIFT(624),
  [2206] = {.count = 1, .reusable = true}, REDUCE(sym_block_argument, 2),
  [2208] = {.count = 1, .reusable = false}, SHIFT(1806),
  [2210] = {.count = 1, .reusable = true}, SHIFT(2765),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1806),
  [2214] = {.count = 1, .reusable = true}, SHIFT(366),
  [2216] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 37),
  [2218] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 38),
  [2220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(366),
  [2223] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_argument, 2),
  [2225] = {.count = 1, .reusable = true}, SHIFT(379),
  [2227] = {.count = 1, .reusable = false}, SHIFT(520),
  [2229] = {.count = 1, .reusable = true}, SHIFT(515),
  [2231] = {.count = 1, .reusable = false}, SHIFT(512),
  [2233] = {.count = 1, .reusable = false}, SHIFT(476),
  [2235] = {.count = 1, .reusable = true}, SHIFT(425),
  [2237] = {.count = 1, .reusable = false}, SHIFT(569),
  [2239] = {.count = 1, .reusable = true}, SHIFT(569),
  [2241] = {.count = 1, .reusable = true}, SHIFT(388),
  [2243] = {.count = 1, .reusable = true}, SHIFT(389),
  [2245] = {.count = 1, .reusable = true}, SHIFT(476),
  [2247] = {.count = 1, .reusable = true}, SHIFT(520),
  [2249] = {.count = 1, .reusable = true}, SHIFT(536),
  [2251] = {.count = 1, .reusable = true}, SHIFT(532),
  [2253] = {.count = 1, .reusable = false}, SHIFT(390),
  [2255] = {.count = 1, .reusable = true}, SHIFT(390),
  [2257] = {.count = 1, .reusable = true}, SHIFT(740),
  [2259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(379),
  [2262] = {.count = 1, .reusable = false}, SHIFT(746),
  [2264] = {.count = 1, .reusable = true}, SHIFT(745),
  [2266] = {.count = 1, .reusable = false}, SHIFT(744),
  [2268] = {.count = 1, .reusable = true}, SHIFT(723),
  [2270] = {.count = 1, .reusable = true}, SHIFT(746),
  [2272] = {.count = 1, .reusable = true}, SHIFT(748),
  [2274] = {.count = 1, .reusable = true}, SHIFT(747),
  [2276] = {.count = 1, .reusable = false}, SHIFT(743),
  [2278] = {.count = 1, .reusable = true}, SHIFT(742),
  [2280] = {.count = 1, .reusable = false}, SHIFT(725),
  [2282] = {.count = 1, .reusable = true}, SHIFT(725),
  [2284] = {.count = 1, .reusable = true}, SHIFT(724),
  [2286] = {.count = 1, .reusable = true}, SHIFT(743),
  [2288] = {.count = 1, .reusable = false}, SHIFT(598),
  [2290] = {.count = 1, .reusable = true}, SHIFT(598),
  [2292] = {.count = 1, .reusable = false}, SHIFT(527),
  [2294] = {.count = 1, .reusable = false}, SHIFT(1781),
  [2296] = {.count = 1, .reusable = true}, SHIFT(2759),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1781),
  [2300] = {.count = 1, .reusable = false}, SHIFT(753),
  [2302] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [2304] = {.count = 1, .reusable = false}, SHIFT(2215),
  [2306] = {.count = 1, .reusable = true}, SHIFT(596),
  [2308] = {.count = 1, .reusable = true}, SHIFT(2099),
  [2310] = {.count = 1, .reusable = false}, SHIFT(2099),
  [2312] = {.count = 1, .reusable = true}, SHIFT(2237),
  [2314] = {.count = 1, .reusable = false}, SHIFT(2766),
  [2316] = {.count = 1, .reusable = true}, SHIFT(2105),
  [2318] = {.count = 1, .reusable = true}, SHIFT(2428),
  [2320] = {.count = 1, .reusable = true}, SHIFT(706),
  [2322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2498),
  [2325] = {.count = 1, .reusable = true}, SHIFT(595),
  [2327] = {.count = 1, .reusable = false}, SHIFT(768),
  [2329] = {.count = 1, .reusable = true}, SHIFT(244),
  [2331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2392),
  [2334] = {.count = 1, .reusable = true}, SHIFT(785),
  [2336] = {.count = 1, .reusable = true}, SHIFT(1476),
  [2338] = {.count = 1, .reusable = false}, SHIFT(1762),
  [2340] = {.count = 1, .reusable = true}, SHIFT(2776),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1762),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1412),
  [2346] = {.count = 1, .reusable = false}, SHIFT(1836),
  [2348] = {.count = 1, .reusable = true}, SHIFT(260),
  [2350] = {.count = 1, .reusable = true}, SHIFT(2893),
  [2352] = {.count = 1, .reusable = true}, SHIFT(1836),
  [2354] = {.count = 1, .reusable = false}, SHIFT(1871),
  [2356] = {.count = 1, .reusable = true}, SHIFT(2858),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1871),
  [2360] = {.count = 1, .reusable = true}, SHIFT(2261),
  [2362] = {.count = 1, .reusable = true}, SHIFT(2107),
  [2364] = {.count = 1, .reusable = false}, SHIFT(1780),
  [2366] = {.count = 1, .reusable = true}, SHIFT(234),
  [2368] = {.count = 1, .reusable = true}, SHIFT(2748),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1780),
  [2372] = {.count = 1, .reusable = false}, SHIFT(1888),
  [2374] = {.count = 1, .reusable = true}, SHIFT(265),
  [2376] = {.count = 1, .reusable = true}, SHIFT(2884),
  [2378] = {.count = 1, .reusable = true}, SHIFT(1888),
  [2380] = {.count = 1, .reusable = true}, SHIFT(2202),
  [2382] = {.count = 1, .reusable = true}, SHIFT(2119),
  [2384] = {.count = 1, .reusable = false}, SHIFT(2119),
  [2386] = {.count = 1, .reusable = true}, SHIFT(2217),
  [2388] = {.count = 1, .reusable = true}, SHIFT(2205),
  [2390] = {.count = 1, .reusable = true}, SHIFT(2471),
  [2392] = {.count = 1, .reusable = true}, SHIFT(1663),
  [2394] = {.count = 1, .reusable = true}, SHIFT(1696),
  [2396] = {.count = 1, .reusable = false}, SHIFT(1696),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1693),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1698),
  [2402] = {.count = 1, .reusable = true}, SHIFT(2448),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2406] = {.count = 1, .reusable = true}, SHIFT(2133),
  [2408] = {.count = 1, .reusable = false}, SHIFT(809),
  [2410] = {.count = 1, .reusable = true}, SHIFT(810),
  [2412] = {.count = 1, .reusable = false}, SHIFT(811),
  [2414] = {.count = 1, .reusable = false}, SHIFT(812),
  [2416] = {.count = 1, .reusable = true}, SHIFT(797),
  [2418] = {.count = 1, .reusable = false}, SHIFT(813),
  [2420] = {.count = 1, .reusable = true}, SHIFT(813),
  [2422] = {.count = 1, .reusable = true}, SHIFT(814),
  [2424] = {.count = 1, .reusable = true}, SHIFT(819),
  [2426] = {.count = 1, .reusable = true}, SHIFT(812),
  [2428] = {.count = 1, .reusable = true}, SHIFT(809),
  [2430] = {.count = 1, .reusable = true}, SHIFT(807),
  [2432] = {.count = 1, .reusable = true}, SHIFT(808),
  [2434] = {.count = 1, .reusable = false}, SHIFT(820),
  [2436] = {.count = 1, .reusable = true}, SHIFT(820),
  [2438] = {.count = 1, .reusable = true}, SHIFT(2335),
  [2440] = {.count = 1, .reusable = true}, SHIFT(2478),
  [2442] = {.count = 1, .reusable = false}, SHIFT(2478),
  [2444] = {.count = 1, .reusable = true}, SHIFT(2519),
  [2446] = {.count = 1, .reusable = true}, SHIFT(2415),
  [2448] = {.count = 1, .reusable = true}, SHIFT(2546),
  [2450] = {.count = 1, .reusable = false}, SHIFT(1839),
  [2452] = {.count = 1, .reusable = true}, SHIFT(2883),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1839),
  [2456] = {.count = 1, .reusable = true}, SHIFT(2383),
  [2458] = {.count = 1, .reusable = true}, SHIFT(2472),
  [2460] = {.count = 1, .reusable = true}, SHIFT(385),
  [2462] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(385),
  [2465] = {.count = 1, .reusable = true}, SHIFT(734),
  [2467] = {.count = 1, .reusable = false}, SHIFT(735),
  [2469] = {.count = 1, .reusable = false}, SHIFT(733),
  [2471] = {.count = 1, .reusable = false}, SHIFT(732),
  [2473] = {.count = 1, .reusable = true}, SHIFT(527),
  [2475] = {.count = 1, .reusable = true}, SHIFT(507),
  [2477] = {.count = 1, .reusable = false}, SHIFT(731),
  [2479] = {.count = 1, .reusable = true}, SHIFT(731),
  [2481] = {.count = 1, .reusable = true}, SHIFT(730),
  [2483] = {.count = 1, .reusable = true}, SHIFT(729),
  [2485] = {.count = 1, .reusable = true}, SHIFT(732),
  [2487] = {.count = 1, .reusable = true}, SHIFT(735),
  [2489] = {.count = 1, .reusable = true}, SHIFT(739),
  [2491] = {.count = 1, .reusable = true}, SHIFT(738),
  [2493] = {.count = 1, .reusable = false}, SHIFT(728),
  [2495] = {.count = 1, .reusable = true}, SHIFT(728),
  [2497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(380),
  [2500] = {.count = 1, .reusable = true}, SHIFT(753),
  [2502] = {.count = 1, .reusable = true}, SHIFT(380),
  [2504] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2485),
  [2507] = {.count = 1, .reusable = false}, SHIFT(788),
  [2509] = {.count = 1, .reusable = true}, SHIFT(780),
  [2511] = {.count = 1, .reusable = false}, SHIFT(777),
  [2513] = {.count = 1, .reusable = false}, SHIFT(776),
  [2515] = {.count = 1, .reusable = true}, SHIFT(787),
  [2517] = {.count = 1, .reusable = false}, SHIFT(775),
  [2519] = {.count = 1, .reusable = true}, SHIFT(775),
  [2521] = {.count = 1, .reusable = true}, SHIFT(771),
  [2523] = {.count = 1, .reusable = true}, SHIFT(769),
  [2525] = {.count = 1, .reusable = true}, SHIFT(776),
  [2527] = {.count = 1, .reusable = true}, SHIFT(788),
  [2529] = {.count = 1, .reusable = true}, SHIFT(791),
  [2531] = {.count = 1, .reusable = true}, SHIFT(790),
  [2533] = {.count = 1, .reusable = false}, SHIFT(754),
  [2535] = {.count = 1, .reusable = true}, SHIFT(754),
  [2537] = {.count = 1, .reusable = true}, REDUCE(sym__method_name, 1),
  [2539] = {.count = 1, .reusable = false}, REDUCE(sym__method_name, 1),
  [2541] = {.count = 1, .reusable = false}, SHIFT(1684),
  [2543] = {.count = 1, .reusable = false}, SHIFT(835),
  [2545] = {.count = 1, .reusable = true}, SHIFT(838),
  [2547] = {.count = 1, .reusable = false}, SHIFT(839),
  [2549] = {.count = 1, .reusable = false}, SHIFT(840),
  [2551] = {.count = 1, .reusable = true}, SHIFT(796),
  [2553] = {.count = 1, .reusable = false}, SHIFT(841),
  [2555] = {.count = 1, .reusable = true}, SHIFT(841),
  [2557] = {.count = 1, .reusable = true}, SHIFT(846),
  [2559] = {.count = 1, .reusable = true}, SHIFT(847),
  [2561] = {.count = 1, .reusable = true}, SHIFT(840),
  [2563] = {.count = 1, .reusable = true}, SHIFT(835),
  [2565] = {.count = 1, .reusable = true}, SHIFT(833),
  [2567] = {.count = 1, .reusable = true}, SHIFT(834),
  [2569] = {.count = 1, .reusable = false}, SHIFT(848),
  [2571] = {.count = 1, .reusable = true}, SHIFT(848),
  [2573] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(383),
  [2576] = {.count = 1, .reusable = false}, SHIFT(1834),
  [2578] = {.count = 1, .reusable = true}, SHIFT(230),
  [2580] = {.count = 1, .reusable = true}, SHIFT(2739),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1834),
  [2584] = {.count = 1, .reusable = true}, SHIFT(383),
  [2586] = {.count = 1, .reusable = true}, REDUCE(sym_setter, 2),
  [2588] = {.count = 1, .reusable = false}, REDUCE(sym_setter, 2),
  [2590] = {.count = 1, .reusable = true}, SHIFT(768),
  [2592] = {.count = 1, .reusable = false}, SHIFT(757),
  [2594] = {.count = 1, .reusable = true}, SHIFT(758),
  [2596] = {.count = 1, .reusable = false}, SHIFT(759),
  [2598] = {.count = 1, .reusable = false}, SHIFT(760),
  [2600] = {.count = 1, .reusable = true}, SHIFT(781),
  [2602] = {.count = 1, .reusable = false}, SHIFT(762),
  [2604] = {.count = 1, .reusable = true}, SHIFT(762),
  [2606] = {.count = 1, .reusable = true}, SHIFT(763),
  [2608] = {.count = 1, .reusable = true}, SHIFT(765),
  [2610] = {.count = 1, .reusable = true}, SHIFT(760),
  [2612] = {.count = 1, .reusable = true}, SHIFT(757),
  [2614] = {.count = 1, .reusable = true}, SHIFT(755),
  [2616] = {.count = 1, .reusable = true}, SHIFT(756),
  [2618] = {.count = 1, .reusable = false}, SHIFT(772),
  [2620] = {.count = 1, .reusable = true}, SHIFT(772),
  [2622] = {.count = 1, .reusable = true}, SHIFT(384),
  [2624] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(384),
  [2627] = {.count = 1, .reusable = false}, SHIFT(414),
  [2629] = {.count = 1, .reusable = true}, SHIFT(413),
  [2631] = {.count = 1, .reusable = false}, SHIFT(411),
  [2633] = {.count = 1, .reusable = false}, SHIFT(410),
  [2635] = {.count = 1, .reusable = true}, SHIFT(522),
  [2637] = {.count = 1, .reusable = false}, SHIFT(409),
  [2639] = {.count = 1, .reusable = true}, SHIFT(409),
  [2641] = {.count = 1, .reusable = true}, SHIFT(406),
  [2643] = {.count = 1, .reusable = true}, SHIFT(404),
  [2645] = {.count = 1, .reusable = true}, SHIFT(410),
  [2647] = {.count = 1, .reusable = true}, SHIFT(414),
  [2649] = {.count = 1, .reusable = true}, SHIFT(419),
  [2651] = {.count = 1, .reusable = true}, SHIFT(415),
  [2653] = {.count = 1, .reusable = false}, SHIFT(403),
  [2655] = {.count = 1, .reusable = true}, SHIFT(403),
  [2657] = {.count = 1, .reusable = true}, SHIFT(377),
  [2659] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 1),
  [2661] = {.count = 1, .reusable = true}, SHIFT(407),
  [2663] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(376),
  [2666] = {.count = 1, .reusable = true}, SHIFT(376),
  [2668] = {.count = 1, .reusable = false}, SHIFT(472),
  [2670] = {.count = 1, .reusable = true}, SHIFT(471),
  [2672] = {.count = 1, .reusable = false}, SHIFT(470),
  [2674] = {.count = 1, .reusable = false}, SHIFT(469),
  [2676] = {.count = 1, .reusable = true}, SHIFT(572),
  [2678] = {.count = 1, .reusable = false}, SHIFT(468),
  [2680] = {.count = 1, .reusable = true}, SHIFT(468),
  [2682] = {.count = 1, .reusable = true}, SHIFT(455),
  [2684] = {.count = 1, .reusable = true}, SHIFT(452),
  [2686] = {.count = 1, .reusable = true}, SHIFT(469),
  [2688] = {.count = 1, .reusable = true}, SHIFT(472),
  [2690] = {.count = 1, .reusable = true}, SHIFT(474),
  [2692] = {.count = 1, .reusable = true}, SHIFT(473),
  [2694] = {.count = 1, .reusable = false}, SHIFT(448),
  [2696] = {.count = 1, .reusable = true}, SHIFT(448),
  [2698] = {.count = 1, .reusable = true}, SHIFT(373),
  [2700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(373),
  [2703] = {.count = 1, .reusable = false}, SHIFT(673),
  [2705] = {.count = 1, .reusable = true}, SHIFT(672),
  [2707] = {.count = 1, .reusable = false}, SHIFT(671),
  [2709] = {.count = 1, .reusable = false}, SHIFT(667),
  [2711] = {.count = 1, .reusable = true}, SHIFT(505),
  [2713] = {.count = 1, .reusable = false}, SHIFT(665),
  [2715] = {.count = 1, .reusable = true}, SHIFT(665),
  [2717] = {.count = 1, .reusable = true}, SHIFT(663),
  [2719] = {.count = 1, .reusable = true}, SHIFT(662),
  [2721] = {.count = 1, .reusable = true}, SHIFT(667),
  [2723] = {.count = 1, .reusable = true}, SHIFT(673),
  [2725] = {.count = 1, .reusable = true}, SHIFT(675),
  [2727] = {.count = 1, .reusable = true}, SHIFT(674),
  [2729] = {.count = 1, .reusable = false}, SHIFT(661),
  [2731] = {.count = 1, .reusable = true}, SHIFT(661),
  [2733] = {.count = 1, .reusable = false}, SHIFT(566),
  [2735] = {.count = 1, .reusable = true}, SHIFT(565),
  [2737] = {.count = 1, .reusable = false}, SHIFT(563),
  [2739] = {.count = 1, .reusable = false}, SHIFT(562),
  [2741] = {.count = 1, .reusable = true}, SHIFT(970),
  [2743] = {.count = 1, .reusable = true}, SHIFT(539),
  [2745] = {.count = 1, .reusable = false}, SHIFT(561),
  [2747] = {.count = 1, .reusable = true}, SHIFT(561),
  [2749] = {.count = 1, .reusable = true}, SHIFT(560),
  [2751] = {.count = 1, .reusable = true}, SHIFT(558),
  [2753] = {.count = 1, .reusable = true}, SHIFT(551),
  [2755] = {.count = 1, .reusable = true}, SHIFT(562),
  [2757] = {.count = 1, .reusable = true}, SHIFT(566),
  [2759] = {.count = 1, .reusable = true}, SHIFT(568),
  [2761] = {.count = 1, .reusable = true}, SHIFT(567),
  [2763] = {.count = 1, .reusable = false}, SHIFT(550),
  [2765] = {.count = 1, .reusable = true}, SHIFT(550),
  [2767] = {.count = 1, .reusable = false}, SHIFT(464),
  [2769] = {.count = 1, .reusable = true}, SHIFT(463),
  [2771] = {.count = 1, .reusable = false}, SHIFT(462),
  [2773] = {.count = 1, .reusable = false}, SHIFT(458),
  [2775] = {.count = 1, .reusable = true}, SHIFT(486),
  [2777] = {.count = 1, .reusable = false}, SHIFT(457),
  [2779] = {.count = 1, .reusable = true}, SHIFT(457),
  [2781] = {.count = 1, .reusable = true}, SHIFT(454),
  [2783] = {.count = 1, .reusable = true}, SHIFT(453),
  [2785] = {.count = 1, .reusable = true}, SHIFT(458),
  [2787] = {.count = 1, .reusable = true}, SHIFT(464),
  [2789] = {.count = 1, .reusable = true}, SHIFT(466),
  [2791] = {.count = 1, .reusable = true}, SHIFT(465),
  [2793] = {.count = 1, .reusable = false}, SHIFT(451),
  [2795] = {.count = 1, .reusable = true}, SHIFT(451),
  [2797] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(372),
  [2800] = {.count = 1, .reusable = true}, SHIFT(359),
  [2802] = {.count = 1, .reusable = true}, SHIFT(343),
  [2804] = {.count = 1, .reusable = false}, SHIFT(343),
  [2806] = {.count = 1, .reusable = true}, SHIFT(224),
  [2808] = {.count = 1, .reusable = false}, SHIFT(489),
  [2810] = {.count = 1, .reusable = true}, SHIFT(490),
  [2812] = {.count = 1, .reusable = false}, SHIFT(491),
  [2814] = {.count = 1, .reusable = false}, SHIFT(492),
  [2816] = {.count = 1, .reusable = true}, SHIFT(535),
  [2818] = {.count = 1, .reusable = false}, SHIFT(493),
  [2820] = {.count = 1, .reusable = true}, SHIFT(493),
  [2822] = {.count = 1, .reusable = true}, SHIFT(495),
  [2824] = {.count = 1, .reusable = true}, SHIFT(500),
  [2826] = {.count = 1, .reusable = true}, SHIFT(492),
  [2828] = {.count = 1, .reusable = true}, SHIFT(489),
  [2830] = {.count = 1, .reusable = true}, SHIFT(487),
  [2832] = {.count = 1, .reusable = true}, SHIFT(488),
  [2834] = {.count = 1, .reusable = false}, SHIFT(503),
  [2836] = {.count = 1, .reusable = true}, SHIFT(503),
  [2838] = {.count = 1, .reusable = false}, SHIFT(855),
  [2840] = {.count = 1, .reusable = true}, SHIFT(752),
  [2842] = {.count = 1, .reusable = false}, SHIFT(852),
  [2844] = {.count = 1, .reusable = false}, SHIFT(851),
  [2846] = {.count = 1, .reusable = true}, SHIFT(842),
  [2848] = {.count = 1, .reusable = true}, SHIFT(851),
  [2850] = {.count = 1, .reusable = true}, SHIFT(855),
  [2852] = {.count = 1, .reusable = true}, SHIFT(857),
  [2854] = {.count = 1, .reusable = true}, SHIFT(856),
  [2856] = {.count = 1, .reusable = false}, SHIFT(836),
  [2858] = {.count = 1, .reusable = true}, SHIFT(836),
  [2860] = {.count = 1, .reusable = true}, SHIFT(2206),
  [2862] = {.count = 1, .reusable = true}, SHIFT(249),
  [2864] = {.count = 1, .reusable = true}, SHIFT(891),
  [2866] = {.count = 1, .reusable = true}, SHIFT(892),
  [2868] = {.count = 1, .reusable = false}, SHIFT(892),
  [2870] = {.count = 1, .reusable = true}, SHIFT(804),
  [2872] = {.count = 1, .reusable = false}, SHIFT(849),
  [2874] = {.count = 1, .reusable = true}, SHIFT(849),
  [2876] = {.count = 1, .reusable = true}, SHIFT(843),
  [2878] = {.count = 1, .reusable = true}, SHIFT(263),
  [2880] = {.count = 1, .reusable = true}, SHIFT(254),
  [2882] = {.count = 1, .reusable = false}, SHIFT(254),
  [2884] = {.count = 1, .reusable = true}, SHIFT(247),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2892] = {.count = 1, .reusable = true}, SHIFT(319),
  [2894] = {.count = 1, .reusable = true}, SHIFT(324),
  [2896] = {.count = 1, .reusable = false}, SHIFT(324),
  [2898] = {.count = 1, .reusable = true}, SHIFT(239),
  [2900] = {.count = 1, .reusable = true}, SHIFT(2177),
  [2902] = {.count = 1, .reusable = true}, SHIFT(2182),
  [2904] = {.count = 1, .reusable = false}, SHIFT(2182),
  [2906] = {.count = 1, .reusable = true}, SHIFT(245),
  [2908] = {.count = 1, .reusable = true}, SHIFT(372),
  [2910] = {.count = 1, .reusable = true}, SHIFT(360),
  [2912] = {.count = 1, .reusable = true}, SHIFT(270),
  [2914] = {.count = 1, .reusable = true}, SHIFT(294),
  [2916] = {.count = 1, .reusable = false}, SHIFT(294),
  [2918] = {.count = 1, .reusable = true}, SHIFT(227),
  [2920] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(369),
  [2923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(360),
  [2926] = {.count = 1, .reusable = true}, SHIFT(917),
  [2928] = {.count = 1, .reusable = true}, SHIFT(905),
  [2930] = {.count = 1, .reusable = false}, SHIFT(905),
  [2932] = {.count = 1, .reusable = true}, SHIFT(369),
  [2934] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2936] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2938] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2940] = {.count = 1, .reusable = true}, SHIFT(659),
  [2942] = {.count = 1, .reusable = true}, SHIFT(709),
  [2944] = {.count = 1, .reusable = false}, SHIFT(709),
  [2946] = {.count = 1, .reusable = true}, SHIFT(253),
  [2948] = {.count = 1, .reusable = true}, SHIFT(371),
  [2950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(371),
  [2953] = {.count = 1, .reusable = true}, SHIFT(825),
  [2955] = {.count = 1, .reusable = true}, SHIFT(816),
  [2957] = {.count = 1, .reusable = false}, SHIFT(816),
  [2959] = {.count = 1, .reusable = true}, SHIFT(251),
  [2961] = {.count = 1, .reusable = false}, SHIFT(436),
  [2963] = {.count = 1, .reusable = true}, SHIFT(435),
  [2965] = {.count = 1, .reusable = false}, SHIFT(434),
  [2967] = {.count = 1, .reusable = false}, SHIFT(433),
  [2969] = {.count = 1, .reusable = true}, SHIFT(485),
  [2971] = {.count = 1, .reusable = false}, SHIFT(432),
  [2973] = {.count = 1, .reusable = true}, SHIFT(432),
  [2975] = {.count = 1, .reusable = true}, SHIFT(429),
  [2977] = {.count = 1, .reusable = true}, SHIFT(428),
  [2979] = {.count = 1, .reusable = true}, SHIFT(433),
  [2981] = {.count = 1, .reusable = true}, SHIFT(436),
  [2983] = {.count = 1, .reusable = true}, SHIFT(439),
  [2985] = {.count = 1, .reusable = true}, SHIFT(438),
  [2987] = {.count = 1, .reusable = false}, SHIFT(426),
  [2989] = {.count = 1, .reusable = true}, SHIFT(426),
  [2991] = {.count = 1, .reusable = true}, SHIFT(494),
  [2993] = {.count = 1, .reusable = true}, SHIFT(456),
  [2995] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [2997] = {.count = 1, .reusable = true}, SHIFT(999),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1002),
  [3001] = {.count = 1, .reusable = false}, SHIFT(1002),
  [3003] = {.count = 1, .reusable = true}, SHIFT(1031),
  [3005] = {.count = 1, .reusable = true}, SHIFT(1043),
  [3007] = {.count = 1, .reusable = false}, SHIFT(1043),
  [3009] = {.count = 1, .reusable = true}, SHIFT(459),
  [3011] = {.count = 1, .reusable = true}, REDUCE(sym_in, 2),
  [3013] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 3, .production_id = 47),
  [3015] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 47),
  [3017] = {.count = 1, .reusable = false}, SHIFT(600),
  [3019] = {.count = 1, .reusable = true}, SHIFT(601),
  [3021] = {.count = 1, .reusable = false}, SHIFT(602),
  [3023] = {.count = 1, .reusable = false}, SHIFT(603),
  [3025] = {.count = 1, .reusable = true}, SHIFT(537),
  [3027] = {.count = 1, .reusable = false}, SHIFT(605),
  [3029] = {.count = 1, .reusable = true}, SHIFT(605),
  [3031] = {.count = 1, .reusable = true}, SHIFT(606),
  [3033] = {.count = 1, .reusable = true}, SHIFT(607),
  [3035] = {.count = 1, .reusable = true}, SHIFT(608),
  [3037] = {.count = 1, .reusable = true}, SHIFT(603),
  [3039] = {.count = 1, .reusable = true}, SHIFT(600),
  [3041] = {.count = 1, .reusable = true}, SHIFT(597),
  [3043] = {.count = 1, .reusable = true}, SHIFT(599),
  [3045] = {.count = 1, .reusable = false}, SHIFT(609),
  [3047] = {.count = 1, .reusable = true}, SHIFT(609),
  [3049] = {.count = 1, .reusable = true}, SHIFT(375),
  [3051] = {.count = 1, .reusable = true}, SHIFT(431),
  [3053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(375),
  [3056] = {.count = 1, .reusable = false}, SHIFT(685),
  [3058] = {.count = 1, .reusable = true}, SHIFT(683),
  [3060] = {.count = 1, .reusable = false}, SHIFT(682),
  [3062] = {.count = 1, .reusable = false}, SHIFT(681),
  [3064] = {.count = 1, .reusable = true}, SHIFT(437),
  [3066] = {.count = 1, .reusable = false}, SHIFT(670),
  [3068] = {.count = 1, .reusable = true}, SHIFT(670),
  [3070] = {.count = 1, .reusable = true}, SHIFT(669),
  [3072] = {.count = 1, .reusable = true}, SHIFT(693),
  [3074] = {.count = 1, .reusable = true}, SHIFT(681),
  [3076] = {.count = 1, .reusable = true}, SHIFT(685),
  [3078] = {.count = 1, .reusable = true}, SHIFT(690),
  [3080] = {.count = 1, .reusable = true}, SHIFT(689),
  [3082] = {.count = 1, .reusable = false}, SHIFT(656),
  [3084] = {.count = 1, .reusable = true}, SHIFT(656),
  [3086] = {.count = 1, .reusable = true}, REDUCE(sym_superclass, 2),
  [3088] = {.count = 1, .reusable = false}, REDUCE(sym_optional_parameter, 3, .production_id = 47),
  [3090] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 3, .production_id = 47),
  [3092] = {.count = 1, .reusable = true}, SHIFT(554),
  [3094] = {.count = 1, .reusable = true}, SHIFT(544),
  [3096] = {.count = 1, .reusable = true}, SHIFT(557),
  [3098] = {.count = 1, .reusable = true}, SHIFT(556),
  [3100] = {.count = 1, .reusable = true}, SHIFT(644),
  [3102] = {.count = 1, .reusable = false}, SHIFT(555),
  [3104] = {.count = 1, .reusable = false}, SHIFT(553),
  [3106] = {.count = 1, .reusable = false}, SHIFT(552),
  [3108] = {.count = 1, .reusable = true}, SHIFT(521),
  [3110] = {.count = 1, .reusable = true}, SHIFT(424),
  [3112] = {.count = 1, .reusable = false}, SHIFT(549),
  [3114] = {.count = 1, .reusable = true}, SHIFT(549),
  [3116] = {.count = 1, .reusable = true}, SHIFT(547),
  [3118] = {.count = 1, .reusable = true}, SHIFT(546),
  [3120] = {.count = 1, .reusable = true}, SHIFT(552),
  [3122] = {.count = 1, .reusable = true}, SHIFT(555),
  [3124] = {.count = 1, .reusable = false}, SHIFT(543),
  [3126] = {.count = 1, .reusable = true}, SHIFT(543),
  [3128] = {.count = 1, .reusable = true}, SHIFT(442),
  [3130] = {.count = 1, .reusable = false}, SHIFT(712),
  [3132] = {.count = 1, .reusable = true}, SHIFT(713),
  [3134] = {.count = 1, .reusable = false}, SHIFT(714),
  [3136] = {.count = 1, .reusable = false}, SHIFT(715),
  [3138] = {.count = 1, .reusable = true}, SHIFT(581),
  [3140] = {.count = 1, .reusable = false}, SHIFT(717),
  [3142] = {.count = 1, .reusable = true}, SHIFT(717),
  [3144] = {.count = 1, .reusable = true}, SHIFT(719),
  [3146] = {.count = 1, .reusable = true}, SHIFT(720),
  [3148] = {.count = 1, .reusable = true}, SHIFT(715),
  [3150] = {.count = 1, .reusable = true}, SHIFT(712),
  [3152] = {.count = 1, .reusable = true}, SHIFT(710),
  [3154] = {.count = 1, .reusable = true}, SHIFT(711),
  [3156] = {.count = 1, .reusable = false}, SHIFT(721),
  [3158] = {.count = 1, .reusable = true}, SHIFT(721),
  [3160] = {.count = 1, .reusable = true}, SHIFT(677),
  [3162] = {.count = 1, .reusable = false}, SHIFT(643),
  [3164] = {.count = 1, .reusable = false}, SHIFT(645),
  [3166] = {.count = 1, .reusable = false}, SHIFT(646),
  [3168] = {.count = 1, .reusable = true}, SHIFT(523),
  [3170] = {.count = 1, .reusable = false}, SHIFT(648),
  [3172] = {.count = 1, .reusable = true}, SHIFT(648),
  [3174] = {.count = 1, .reusable = true}, SHIFT(650),
  [3176] = {.count = 1, .reusable = true}, SHIFT(651),
  [3178] = {.count = 1, .reusable = true}, SHIFT(646),
  [3180] = {.count = 1, .reusable = true}, SHIFT(643),
  [3182] = {.count = 1, .reusable = true}, SHIFT(641),
  [3184] = {.count = 1, .reusable = true}, SHIFT(642),
  [3186] = {.count = 1, .reusable = false}, SHIFT(653),
  [3188] = {.count = 1, .reusable = true}, SHIFT(653),
  [3190] = {.count = 1, .reusable = true}, SHIFT(660),
  [3192] = {.count = 1, .reusable = true}, SHIFT(430),
  [3194] = {.count = 1, .reusable = true}, SHIFT(718),
  [3196] = {.count = 1, .reusable = true}, SHIFT(2764),
  [3198] = {.count = 1, .reusable = true}, SHIFT(649),
  [3200] = {.count = 1, .reusable = true}, SHIFT(647),
  [3202] = {.count = 1, .reusable = true}, SHIFT(684),
  [3204] = {.count = 1, .reusable = true}, SHIFT(391),
  [3206] = {.count = 1, .reusable = true}, SHIFT(528),
  [3208] = {.count = 1, .reusable = true}, SHIFT(594),
  [3210] = {.count = 1, .reusable = true}, SHIFT(477),
  [3212] = {.count = 1, .reusable = true}, SHIFT(613),
  [3214] = {.count = 1, .reusable = true}, SHIFT(2751),
  [3216] = {.count = 1, .reusable = true}, SHIFT(716),
  [3218] = {.count = 1, .reusable = true}, SHIFT(542),
  [3220] = {.count = 1, .reusable = true}, SHIFT(638),
  [3222] = {.count = 1, .reusable = true}, SHIFT(592),
  [3224] = {.count = 1, .reusable = true}, SHIFT(386),
  [3226] = {.count = 1, .reusable = true}, SHIFT(2779),
  [3228] = {.count = 1, .reusable = true}, SHIFT(467),
  [3230] = {.count = 1, .reusable = true}, SHIFT(845),
  [3232] = {.count = 1, .reusable = true}, SHIFT(786),
  [3234] = {.count = 1, .reusable = true}, SHIFT(798),
  [3236] = {.count = 1, .reusable = true}, SHIFT(2917),
  [3238] = {.count = 1, .reusable = true}, SHIFT(844),
  [3240] = {.count = 1, .reusable = true}, SHIFT(854),
  [3242] = {.count = 1, .reusable = true}, REDUCE(sym_command_call, 2, .production_id = 9),
  [3244] = {.count = 1, .reusable = true}, SHIFT(163),
  [3246] = {.count = 1, .reusable = true}, SHIFT(24),
  [3248] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2),
  [3250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(284),
  [3253] = {.count = 1, .reusable = true}, REDUCE(sym_command_argument_list, 2),
  [3255] = {.count = 1, .reusable = true}, SHIFT(284),
  [3257] = {.count = 1, .reusable = true}, REDUCE(sym_command_argument_list, 1),
  [3259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(273),
  [3262] = {.count = 1, .reusable = true}, SHIFT(273),
  [3264] = {.count = 1, .reusable = true}, REDUCE(sym_command_call, 3, .production_id = 28),
  [3266] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [3268] = {.count = 1, .reusable = true}, REDUCE(sym_command_binary, 3, .production_id = 24),
  [3270] = {.count = 1, .reusable = true}, REDUCE(sym_return_command, 2),
  [3272] = {.count = 1, .reusable = true}, REDUCE(sym_yield_command, 2),
  [3274] = {.count = 1, .reusable = true}, REDUCE(sym_break_command, 2),
  [3276] = {.count = 1, .reusable = true}, REDUCE(sym_next_command, 2),
  [3278] = {.count = 1, .reusable = true}, REDUCE(sym_command_assignment, 3, .production_id = 29),
  [3280] = {.count = 1, .reusable = true}, REDUCE(sym_command_operator_assignment, 3),
  [3282] = {.count = 1, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2),
  [3284] = {.count = 1, .reusable = true}, REDUCE(sym_if_modifier, 3, .production_id = 22),
  [3286] = {.count = 1, .reusable = true}, SHIFT(285),
  [3288] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 3),
  [3290] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 3),
  [3292] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 3),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3296] = {.count = 1, .reusable = false}, SHIFT(2508),
  [3298] = {.count = 1, .reusable = true}, SHIFT(160),
  [3300] = {.count = 1, .reusable = true}, SHIFT(2163),
  [3302] = {.count = 1, .reusable = false}, SHIFT(2317),
  [3304] = {.count = 1, .reusable = true}, SHIFT(2318),
  [3306] = {.count = 1, .reusable = true}, SHIFT(2835),
  [3308] = {.count = 1, .reusable = false}, SHIFT(26),
  [3310] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1582),
  [3313] = {.count = 1, .reusable = true}, SHIFT(166),
  [3315] = {.count = 1, .reusable = false}, SHIFT(29),
  [3317] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 4),
  [3319] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 2),
  [3321] = {.count = 1, .reusable = true}, REDUCE(sym_rescue_modifier, 3, .production_id = 23),
  [3323] = {.count = 1, .reusable = true}, REDUCE(sym_until_modifier, 3, .production_id = 22),
  [3325] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [3327] = {.count = 1, .reusable = true}, SHIFT(2098),
  [3329] = {.count = 1, .reusable = true}, SHIFT(159),
  [3331] = {.count = 1, .reusable = false}, SHIFT(28),
  [3333] = {.count = 1, .reusable = true}, REDUCE(sym_alias, 3, .production_id = 18),
  [3335] = {.count = 1, .reusable = true}, REDUCE(sym_while_modifier, 3, .production_id = 22),
  [3337] = {.count = 1, .reusable = true}, REDUCE(sym_unless_modifier, 3, .production_id = 22),
  [3339] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 4),
  [3341] = {.count = 1, .reusable = true}, SHIFT(169),
  [3343] = {.count = 1, .reusable = false}, SHIFT(33),
  [3345] = {.count = 1, .reusable = true}, SHIFT(2542),
  [3347] = {.count = 1, .reusable = true}, SHIFT(2162),
  [3349] = {.count = 1, .reusable = false}, SHIFT(2652),
  [3351] = {.count = 1, .reusable = true}, SHIFT(2653),
  [3353] = {.count = 1, .reusable = true}, SHIFT(2880),
  [3355] = {.count = 1, .reusable = true}, SHIFT(2514),
  [3357] = {.count = 1, .reusable = true}, SHIFT(2760),
  [3359] = {.count = 1, .reusable = true}, SHIFT(954),
  [3361] = {.count = 1, .reusable = true}, SHIFT(2803),
  [3363] = {.count = 1, .reusable = true}, SHIFT(2780),
  [3365] = {.count = 1, .reusable = true}, SHIFT(969),
  [3367] = {.count = 1, .reusable = true}, SHIFT(2849),
  [3369] = {.count = 1, .reusable = true}, SHIFT(962),
  [3371] = {.count = 1, .reusable = true}, SHIFT(2810),
  [3373] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [3375] = {.count = 1, .reusable = true}, SHIFT(291),
  [3377] = {.count = 1, .reusable = true}, SHIFT(267),
  [3379] = {.count = 1, .reusable = true}, SHIFT(289),
  [3381] = {.count = 1, .reusable = true}, SHIFT(288),
  [3383] = {.count = 1, .reusable = true}, SHIFT(286),
  [3385] = {.count = 1, .reusable = true}, SHIFT(975),
  [3387] = {.count = 1, .reusable = true}, SHIFT(2871),
  [3389] = {.count = 1, .reusable = true}, SHIFT(973),
  [3391] = {.count = 1, .reusable = true}, SHIFT(2869),
  [3393] = {.count = 1, .reusable = true}, SHIFT(498),
  [3395] = {.count = 1, .reusable = true}, SHIFT(28),
  [3397] = {.count = 1, .reusable = true}, SHIFT(953),
  [3399] = {.count = 1, .reusable = true}, SHIFT(2809),
  [3401] = {.count = 1, .reusable = true}, SHIFT(2662),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3405] = {.count = 1, .reusable = true}, SHIFT(2564),
  [3407] = {.count = 1, .reusable = true}, SHIFT(2672),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1169),
  [3411] = {.count = 1, .reusable = true}, SHIFT(956),
  [3413] = {.count = 1, .reusable = true}, SHIFT(2468),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3417] = {.count = 1, .reusable = true}, SHIFT(2508),
  [3419] = {.count = 1, .reusable = true}, SHIFT(2160),
  [3421] = {.count = 1, .reusable = true}, SHIFT(168),
  [3423] = {.count = 1, .reusable = true}, SHIFT(32),
  [3425] = {.count = 1, .reusable = true}, SHIFT(281),
  [3427] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1586),
  [3430] = {.count = 1, .reusable = true}, SHIFT(300),
  [3432] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3434] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(300),
  [3437] = {.count = 1, .reusable = true}, SHIFT(2208),
  [3439] = {.count = 1, .reusable = true}, SHIFT(141),
  [3441] = {.count = 1, .reusable = true}, SHIFT(967),
  [3443] = {.count = 1, .reusable = true}, SHIFT(272),
  [3445] = {.count = 1, .reusable = true}, SHIFT(275),
  [3447] = {.count = 1, .reusable = true}, SHIFT(276),
  [3449] = {.count = 1, .reusable = true}, SHIFT(278),
  [3451] = {.count = 1, .reusable = true}, SHIFT(279),
  [3453] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(297),
  [3456] = {.count = 1, .reusable = true}, SHIFT(297),
  [3458] = {.count = 1, .reusable = true}, SHIFT(896),
  [3460] = {.count = 1, .reusable = true}, SHIFT(252),
  [3462] = {.count = 1, .reusable = true}, SHIFT(143),
  [3464] = {.count = 1, .reusable = true}, SHIFT(156),
  [3466] = {.count = 1, .reusable = true}, SHIFT(2278),
  [3468] = {.count = 1, .reusable = true}, SHIFT(2603),
  [3470] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3472] = {.count = 1, .reusable = true}, SHIFT(337),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3476] = {.count = 1, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2),
  [3478] = {.count = 1, .reusable = false}, SHIFT(207),
  [3480] = {.count = 1, .reusable = false}, SHIFT(2410),
  [3482] = {.count = 1, .reusable = false}, SHIFT(2510),
  [3484] = {.count = 1, .reusable = true}, SHIFT(2510),
  [3486] = {.count = 1, .reusable = true}, SHIFT(1191),
  [3488] = {.count = 1, .reusable = false}, SHIFT(2450),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3492] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3494] = {.count = 1, .reusable = false}, SHIFT(2462),
  [3496] = {.count = 1, .reusable = true}, SHIFT(2650),
  [3498] = {.count = 1, .reusable = false}, SHIFT(2395),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1164),
  [3502] = {.count = 1, .reusable = true}, SHIFT(1100),
  [3504] = {.count = 1, .reusable = true}, SHIFT(1181),
  [3506] = {.count = 1, .reusable = false}, SHIFT(2480),
  [3508] = {.count = 1, .reusable = true}, SHIFT(2645),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3512] = {.count = 1, .reusable = false}, SHIFT(2402),
  [3514] = {.count = 1, .reusable = true}, SHIFT(1095),
  [3516] = {.count = 1, .reusable = true}, SHIFT(1052),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3520] = {.count = 1, .reusable = true}, SHIFT(1124),
  [3522] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 2),
  [3524] = {.count = 1, .reusable = true}, SHIFT(1193),
  [3526] = {.count = 1, .reusable = true}, SHIFT(910),
  [3528] = {.count = 1, .reusable = true}, SHIFT(1066),
  [3530] = {.count = 1, .reusable = false}, SHIFT(2440),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3534] = {.count = 1, .reusable = true}, SHIFT(2618),
  [3536] = {.count = 1, .reusable = true}, SHIFT(2617),
  [3538] = {.count = 1, .reusable = true}, SHIFT(2255),
  [3540] = {.count = 1, .reusable = false}, SHIFT(2421),
  [3542] = {.count = 1, .reusable = true}, SHIFT(1137),
  [3544] = {.count = 1, .reusable = true}, SHIFT(934),
  [3546] = {.count = 1, .reusable = true}, SHIFT(1212),
  [3548] = {.count = 1, .reusable = false}, SHIFT(2439),
  [3550] = {.count = 1, .reusable = true}, SHIFT(2654),
  [3552] = {.count = 1, .reusable = true}, SHIFT(1099),
  [3554] = {.count = 1, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2),
  [3556] = {.count = 2, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2), SHIFT_REPEAT(252),
  [3559] = {.count = 2, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2), SHIFT_REPEAT(143),
  [3562] = {.count = 2, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 2), SHIFT_REPEAT(156),
  [3565] = {.count = 1, .reusable = false}, SHIFT(2481),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1214),
  [3571] = {.count = 1, .reusable = false}, SHIFT(2445),
  [3573] = {.count = 1, .reusable = true}, SHIFT(2659),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3577] = {.count = 1, .reusable = true}, SHIFT(932),
  [3579] = {.count = 1, .reusable = true}, SHIFT(2089),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1170),
  [3583] = {.count = 1, .reusable = true}, SHIFT(2087),
  [3585] = {.count = 1, .reusable = false}, SHIFT(2483),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3589] = {.count = 1, .reusable = true}, SHIFT(2663),
  [3591] = {.count = 1, .reusable = true}, SHIFT(2590),
  [3593] = {.count = 1, .reusable = false}, SHIFT(2813),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1145),
  [3597] = {.count = 1, .reusable = false}, SHIFT(2457),
  [3599] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 1),
  [3601] = {.count = 1, .reusable = false}, REDUCE(sym_splat_parameter, 1),
  [3603] = {.count = 1, .reusable = false}, SHIFT(2453),
  [3605] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 1),
  [3607] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_parameter, 1),
  [3609] = {.count = 1, .reusable = true}, SHIFT(1080),
  [3611] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1599),
  [3614] = {.count = 1, .reusable = false}, SHIFT(2333),
  [3616] = {.count = 1, .reusable = true}, SHIFT(2570),
  [3618] = {.count = 1, .reusable = false}, SHIFT(2342),
  [3620] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3622] = {.count = 1, .reusable = true}, SHIFT(302),
  [3624] = {.count = 1, .reusable = true}, SHIFT(346),
  [3626] = {.count = 1, .reusable = false}, SHIFT(2521),
  [3628] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3630] = {.count = 1, .reusable = false}, REDUCE(aux_sym_symbol_array_repeat1, 2, .production_id = 36),
  [3632] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2, .production_id = 36),
  [3634] = {.count = 1, .reusable = false}, SHIFT(2336),
  [3636] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3638] = {.count = 1, .reusable = false}, SHIFT(2540),
  [3640] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3642] = {.count = 1, .reusable = true}, REDUCE(sym_exception_variable, 2),
  [3644] = {.count = 1, .reusable = false}, SHIFT(2918),
  [3646] = {.count = 1, .reusable = true}, SHIFT(2657),
  [3648] = {.count = 1, .reusable = true}, SHIFT(2474),
  [3650] = {.count = 1, .reusable = false}, SHIFT(2894),
  [3652] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3654] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3656] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3658] = {.count = 1, .reusable = true}, SHIFT(1037),
  [3660] = {.count = 1, .reusable = false}, SHIFT(2920),
  [3662] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3664] = {.count = 1, .reusable = false}, SHIFT(2919),
  [3666] = {.count = 1, .reusable = true}, SHIFT(2552),
  [3668] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3672] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3674] = {.count = 1, .reusable = true}, SHIFT(1022),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1060),
  [3678] = {.count = 1, .reusable = false}, SHIFT(2343),
  [3680] = {.count = 1, .reusable = true}, SHIFT(2568),
  [3682] = {.count = 1, .reusable = false}, SHIFT(2365),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1105),
  [3686] = {.count = 1, .reusable = false}, SHIFT(2797),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1178),
  [3690] = {.count = 1, .reusable = true}, SHIFT(2235),
  [3692] = {.count = 1, .reusable = false}, SHIFT(2535),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3696] = {.count = 1, .reusable = false}, SHIFT(2531),
  [3698] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3700] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(207),
  [3703] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents, 2),
  [3705] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(2510),
  [3708] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(2510),
  [3711] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents, 2),
  [3713] = {.count = 1, .reusable = true}, SHIFT(2228),
  [3715] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2429),
  [3718] = {.count = 1, .reusable = false}, SHIFT(2316),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1098),
  [3722] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 1),
  [3724] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1401),
  [3728] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_array_repeat1, 2, .production_id = 33),
  [3730] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2, .production_id = 33),
  [3732] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter, 1),
  [3734] = {.count = 1, .reusable = false}, SHIFT(214),
  [3736] = {.count = 1, .reusable = true}, SHIFT(2598),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3740] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3742] = {.count = 1, .reusable = true}, SHIFT(1130),
  [3744] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3748] = {.count = 1, .reusable = true}, SHIFT(2595),
  [3750] = {.count = 1, .reusable = true}, SHIFT(303),
  [3752] = {.count = 1, .reusable = true}, SHIFT(295),
  [3754] = {.count = 1, .reusable = true}, SHIFT(301),
  [3756] = {.count = 1, .reusable = true}, SHIFT(298),
  [3758] = {.count = 1, .reusable = true}, SHIFT(296),
  [3760] = {.count = 1, .reusable = true}, SHIFT(1157),
  [3762] = {.count = 1, .reusable = true}, SHIFT(1134),
  [3764] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3766] = {.count = 1, .reusable = true}, SHIFT(1136),
  [3768] = {.count = 1, .reusable = true}, SHIFT(1141),
  [3770] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3772] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3774] = {.count = 1, .reusable = true}, SHIFT(1106),
  [3776] = {.count = 1, .reusable = true}, REDUCE(sym_then, 3),
  [3778] = {.count = 1, .reusable = true}, SHIFT(1110),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1183),
  [3782] = {.count = 1, .reusable = true}, SHIFT(1126),
  [3784] = {.count = 1, .reusable = true}, SHIFT(1047),
  [3786] = {.count = 1, .reusable = true}, SHIFT(1015),
  [3788] = {.count = 1, .reusable = true}, SHIFT(1144),
  [3790] = {.count = 1, .reusable = true}, SHIFT(2504),
  [3792] = {.count = 1, .reusable = true}, SHIFT(2108),
  [3794] = {.count = 1, .reusable = true}, SHIFT(2638),
  [3796] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3798] = {.count = 1, .reusable = true}, SHIFT(1171),
  [3800] = {.count = 1, .reusable = true}, REDUCE(sym__simple_formal_parameter, 1),
  [3802] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3804] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3806] = {.count = 1, .reusable = true}, SHIFT(2567),
  [3808] = {.count = 1, .reusable = true}, SHIFT(2565),
  [3810] = {.count = 1, .reusable = true}, SHIFT(2104),
  [3812] = {.count = 1, .reusable = true}, SHIFT(2544),
  [3814] = {.count = 1, .reusable = true}, SHIFT(1165),
  [3816] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(377),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3821] = {.count = 1, .reusable = true}, SHIFT(2646),
  [3823] = {.count = 1, .reusable = false}, SHIFT(2441),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1160),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1158),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3833] = {.count = 1, .reusable = true}, SHIFT(2649),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3837] = {.count = 1, .reusable = false}, SHIFT(2932),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1149),
  [3843] = {.count = 1, .reusable = false}, SHIFT(2952),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3847] = {.count = 1, .reusable = true}, SHIFT(2642),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3851] = {.count = 1, .reusable = true}, SHIFT(2577),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3855] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameter, 2, .production_id = 7),
  [3857] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 2, .production_id = 7),
  [3859] = {.count = 1, .reusable = true}, SHIFT(2583),
  [3861] = {.count = 1, .reusable = true}, SHIFT(2586),
  [3863] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 2, .production_id = 7),
  [3865] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 2),
  [3867] = {.count = 1, .reusable = false}, SHIFT(2443),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3871] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(214),
  [3874] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents, 2), SHIFT_REPEAT(2598),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1168),
  [3879] = {.count = 1, .reusable = true}, SHIFT(2612),
  [3881] = {.count = 1, .reusable = true}, SHIFT(2611),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3885] = {.count = 1, .reusable = true}, SHIFT(2211),
  [3887] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter, 1, .production_id = 19),
  [3889] = {.count = 1, .reusable = true}, SHIFT(2588),
  [3891] = {.count = 1, .reusable = true}, REDUCE(sym_then, 2),
  [3893] = {.count = 1, .reusable = true}, SHIFT(2523),
  [3895] = {.count = 1, .reusable = true}, SHIFT(2203),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3899] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3903] = {.count = 1, .reusable = true}, SHIFT(2610),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3907] = {.count = 1, .reusable = true}, SHIFT(2563),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3913] = {.count = 1, .reusable = true}, SHIFT(2569),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3917] = {.count = 1, .reusable = true}, SHIFT(2609),
  [3919] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 3, .production_id = 41),
  [3921] = {.count = 1, .reusable = true}, SHIFT(212),
  [3923] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3927] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(215),
  [3930] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(2495),
  [3933] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3935] = {.count = 1, .reusable = true}, SHIFT(2623),
  [3937] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(2603),
  [3940] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3946] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3948] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2),
  [3950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2), SHIFT_REPEAT(337),
  [3953] = {.count = 2, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2), SHIFT_REPEAT(346),
  [3956] = {.count = 1, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3960] = {.count = 1, .reusable = true}, SHIFT(2446),
  [3962] = {.count = 1, .reusable = true}, SHIFT(378),
  [3964] = {.count = 1, .reusable = true}, SHIFT(666),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3968] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents, 1),
  [3970] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents, 1),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1380),
  [3974] = {.count = 1, .reusable = true}, SHIFT(2628),
  [3976] = {.count = 1, .reusable = true}, SHIFT(2561),
  [3978] = {.count = 1, .reusable = true}, SHIFT(333),
  [3980] = {.count = 1, .reusable = true}, SHIFT(707),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3988] = {.count = 1, .reusable = true}, SHIFT(2693),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3994] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [3996] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1150),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1395),
  [4002] = {.count = 1, .reusable = true}, SHIFT(860),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1153),
  [4006] = {.count = 1, .reusable = false}, SHIFT(215),
  [4008] = {.count = 1, .reusable = true}, SHIFT(2547),
  [4010] = {.count = 1, .reusable = true}, SHIFT(2943),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1528),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1527),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1501),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1521),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1517),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1459),
  [4024] = {.count = 1, .reusable = true}, SHIFT(332),
  [4026] = {.count = 1, .reusable = true}, SHIFT(708),
  [4028] = {.count = 1, .reusable = true}, SHIFT(2419),
  [4030] = {.count = 1, .reusable = true}, SHIFT(2495),
  [4032] = {.count = 1, .reusable = true}, SHIFT(2966),
  [4034] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(866),
  [4037] = {.count = 1, .reusable = true}, SHIFT(1546),
  [4039] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2169),
  [4042] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 4, .production_id = 57),
  [4044] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2168),
  [4047] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4049] = {.count = 1, .reusable = true}, SHIFT(976),
  [4051] = {.count = 1, .reusable = true}, SHIFT(2859),
  [4053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_argument_list_repeat1, 2), SHIFT_REPEAT(292),
  [4056] = {.count = 1, .reusable = true}, REDUCE(sym_else, 3, .production_id = 17),
  [4058] = {.count = 1, .reusable = true}, SHIFT(368),
  [4060] = {.count = 1, .reusable = true}, SHIFT(400),
  [4062] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4064] = {.count = 1, .reusable = true}, REDUCE(aux_sym__body_statement_repeat1, 1),
  [4066] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3, .production_id = 45),
  [4068] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3, .production_id = 43),
  [4070] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2166),
  [4073] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4075] = {.count = 1, .reusable = true}, SHIFT(250),
  [4077] = {.count = 1, .reusable = true}, SHIFT(2761),
  [4079] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4081] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 1),
  [4083] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 1),
  [4085] = {.count = 1, .reusable = true}, SHIFT(233),
  [4087] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4089] = {.count = 1, .reusable = true}, SHIFT(957),
  [4091] = {.count = 1, .reusable = true}, SHIFT(2808),
  [4093] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 2, .production_id = 8),
  [4095] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_left_assignment, 3),
  [4097] = {.count = 1, .reusable = true}, REDUCE(sym_else, 2),
  [4099] = {.count = 1, .reusable = true}, REDUCE(sym_ensure, 2),
  [4101] = {.count = 1, .reusable = true}, SHIFT(26),
  [4103] = {.count = 1, .reusable = true}, SHIFT(29),
  [4105] = {.count = 1, .reusable = true}, REDUCE(sym_bare_parameters, 1),
  [4107] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4109] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4111] = {.count = 1, .reusable = true}, REDUCE(sym_bare_parameters, 2),
  [4113] = {.count = 1, .reusable = true}, SHIFT(231),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4117] = {.count = 1, .reusable = true}, SHIFT(241),
  [4119] = {.count = 1, .reusable = true}, SHIFT(2687),
  [4121] = {.count = 1, .reusable = true}, SHIFT(2689),
  [4123] = {.count = 1, .reusable = true}, SHIFT(2754),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1518),
  [4127] = {.count = 1, .reusable = true}, SHIFT(2444),
  [4129] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4131] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2165),
  [4134] = {.count = 1, .reusable = true}, REDUCE(sym_when, 3, .production_id = 55),
  [4136] = {.count = 1, .reusable = true}, SHIFT(2400),
  [4138] = {.count = 1, .reusable = true}, SHIFT(2868),
  [4140] = {.count = 1, .reusable = true}, SHIFT(33),
  [4142] = {.count = 1, .reusable = true}, SHIFT(2414),
  [4144] = {.count = 1, .reusable = true}, SHIFT(952),
  [4146] = {.count = 1, .reusable = true}, SHIFT(955),
  [4148] = {.count = 1, .reusable = true}, SHIFT(1410),
  [4150] = {.count = 1, .reusable = true}, SHIFT(308),
  [4152] = {.count = 1, .reusable = true}, SHIFT(1123),
  [4154] = {.count = 1, .reusable = true}, SHIFT(314),
  [4156] = {.count = 1, .reusable = true}, SHIFT(2394),
  [4158] = {.count = 1, .reusable = true}, SHIFT(2706),
  [4160] = {.count = 1, .reusable = true}, SHIFT(2660),
  [4162] = {.count = 1, .reusable = true}, SHIFT(310),
  [4164] = {.count = 1, .reusable = true}, REDUCE(sym_when, 4, .production_id = 63),
  [4166] = {.count = 1, .reusable = true}, SHIFT(2399),
  [4168] = {.count = 1, .reusable = true}, SHIFT(2424),
  [4170] = {.count = 1, .reusable = true}, SHIFT(305),
  [4172] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2), SHIFT_REPEAT(2543),
  [4175] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2),
  [4177] = {.count = 1, .reusable = true}, SHIFT(2455),
  [4179] = {.count = 1, .reusable = true}, SHIFT(2454),
  [4181] = {.count = 1, .reusable = true}, SHIFT(977),
  [4183] = {.count = 1, .reusable = true}, SHIFT(2403),
  [4185] = {.count = 2, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2), SHIFT_REPEAT(2541),
  [4188] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2),
  [4190] = {.count = 1, .reusable = true}, SHIFT(963),
  [4192] = {.count = 1, .reusable = true}, REDUCE(aux_sym_hash_repeat1, 2),
  [4194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_hash_repeat1, 2), SHIFT_REPEAT(321),
  [4197] = {.count = 1, .reusable = true}, SHIFT(2719),
  [4199] = {.count = 1, .reusable = true}, SHIFT(2404),
  [4201] = {.count = 1, .reusable = true}, SHIFT(313),
  [4203] = {.count = 1, .reusable = true}, SHIFT(972),
  [4205] = {.count = 1, .reusable = true}, SHIFT(974),
  [4207] = {.count = 1, .reusable = true}, SHIFT(964),
  [4209] = {.count = 1, .reusable = true}, SHIFT(307),
  [4211] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat2, 1),
  [4213] = {.count = 1, .reusable = true}, SHIFT(2479),
  [4215] = {.count = 1, .reusable = true}, SHIFT(2489),
  [4217] = {.count = 1, .reusable = true}, SHIFT(2463),
  [4219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2), SHIFT_REPEAT(2868),
  [4222] = {.count = 1, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2),
  [4224] = {.count = 1, .reusable = true}, SHIFT(2464),
  [4226] = {.count = 1, .reusable = true}, SHIFT(960),
  [4228] = {.count = 1, .reusable = true}, SHIFT(914),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1115),
  [4232] = {.count = 1, .reusable = true}, SHIFT(894),
  [4234] = {.count = 1, .reusable = true}, SHIFT(258),
  [4236] = {.count = 1, .reusable = true}, SHIFT(919),
  [4238] = {.count = 1, .reusable = true}, SHIFT(257),
  [4240] = {.count = 1, .reusable = true}, SHIFT(447),
  [4242] = {.count = 1, .reusable = true}, SHIFT(893),
  [4244] = {.count = 1, .reusable = true}, SHIFT(2187),
  [4246] = {.count = 1, .reusable = true}, SHIFT(1017),
  [4248] = {.count = 1, .reusable = true}, SHIFT(282),
  [4250] = {.count = 1, .reusable = true}, SHIFT(2494),
  [4252] = {.count = 1, .reusable = true}, SHIFT(1568),
  [4254] = {.count = 1, .reusable = true}, SHIFT(1007),
  [4256] = {.count = 1, .reusable = true}, SHIFT(2179),
  [4258] = {.count = 1, .reusable = true}, SHIFT(2493),
  [4260] = {.count = 1, .reusable = true}, SHIFT(1487),
  [4262] = {.count = 1, .reusable = true}, SHIFT(325),
  [4264] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [4266] = {.count = 1, .reusable = true}, SHIFT(2830),
  [4268] = {.count = 1, .reusable = true}, SHIFT(326),
  [4270] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4272] = {.count = 1, .reusable = true}, SHIFT(1570),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1574),
  [4276] = {.count = 1, .reusable = true}, SHIFT(274),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1576),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1572),
  [4282] = {.count = 1, .reusable = true}, SHIFT(317),
  [4284] = {.count = 1, .reusable = true}, SHIFT(2175),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2621),
  [4288] = {.count = 1, .reusable = true}, REDUCE(sym_left_assignment_list, 1),
  [4290] = {.count = 1, .reusable = false}, SHIFT(2591),
  [4292] = {.count = 1, .reusable = true}, SHIFT(351),
  [4294] = {.count = 1, .reusable = true}, SHIFT(358),
  [4296] = {.count = 1, .reusable = true}, SHIFT(1119),
  [4298] = {.count = 1, .reusable = true}, SHIFT(2532),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1573),
  [4302] = {.count = 1, .reusable = true}, SHIFT(2536),
  [4304] = {.count = 1, .reusable = true}, SHIFT(327),
  [4306] = {.count = 1, .reusable = true}, SHIFT(338),
  [4308] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [4310] = {.count = 1, .reusable = true}, SHIFT(352),
  [4312] = {.count = 1, .reusable = true}, SHIFT(342),
  [4314] = {.count = 1, .reusable = true}, SHIFT(269),
  [4316] = {.count = 1, .reusable = true}, SHIFT(2212),
  [4318] = {.count = 1, .reusable = true}, SHIFT(347),
  [4320] = {.count = 1, .reusable = true}, SHIFT(329),
  [4322] = {.count = 1, .reusable = true}, SHIFT(323),
  [4324] = {.count = 1, .reusable = true}, SHIFT(328),
  [4326] = {.count = 1, .reusable = true}, SHIFT(331),
  [4328] = {.count = 1, .reusable = true}, SHIFT(1176),
  [4330] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4332] = {.count = 1, .reusable = true}, SHIFT(1038),
  [4334] = {.count = 1, .reusable = true}, SHIFT(1154),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1059),
  [4338] = {.count = 1, .reusable = true}, SHIFT(2701),
  [4340] = {.count = 1, .reusable = true}, SHIFT(223),
  [4342] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4344] = {.count = 1, .reusable = true}, SHIFT(344),
  [4346] = {.count = 1, .reusable = true}, SHIFT(349),
  [4348] = {.count = 1, .reusable = true}, SHIFT(2710),
  [4350] = {.count = 1, .reusable = true}, SHIFT(2725),
  [4352] = {.count = 1, .reusable = true}, SHIFT(2736),
  [4354] = {.count = 1, .reusable = true}, SHIFT(341),
  [4356] = {.count = 1, .reusable = true}, SHIFT(1161),
  [4358] = {.count = 1, .reusable = true}, SHIFT(2851),
  [4360] = {.count = 1, .reusable = true}, SHIFT(1566),
  [4362] = {.count = 1, .reusable = true}, SHIFT(1211),
  [4364] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4366] = {.count = 1, .reusable = true}, SHIFT(356),
  [4368] = {.count = 1, .reusable = true}, SHIFT(1174),
  [4370] = {.count = 1, .reusable = true}, SHIFT(1567),
  [4372] = {.count = 1, .reusable = true}, SHIFT(921),
  [4374] = {.count = 1, .reusable = true}, SHIFT(2362),
  [4376] = {.count = 1, .reusable = true}, SHIFT(890),
  [4378] = {.count = 1, .reusable = true}, SHIFT(222),
  [4380] = {.count = 1, .reusable = true}, SHIFT(931),
  [4382] = {.count = 1, .reusable = true}, SHIFT(350),
  [4384] = {.count = 1, .reusable = true}, SHIFT(2814),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1023),
  [4388] = {.count = 1, .reusable = true}, SHIFT(2273),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1061),
  [4392] = {.count = 1, .reusable = true}, SHIFT(2451),
  [4394] = {.count = 1, .reusable = true}, SHIFT(2200),
  [4396] = {.count = 1, .reusable = true}, SHIFT(353),
  [4398] = {.count = 1, .reusable = true}, SHIFT(221),
  [4400] = {.count = 1, .reusable = true}, SHIFT(1190),
  [4402] = {.count = 1, .reusable = true}, SHIFT(1096),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1175),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1166),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1173),
  [4410] = {.count = 1, .reusable = true}, SHIFT(330),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1424),
  [4414] = {.count = 1, .reusable = true}, SHIFT(2680),
  [4416] = {.count = 1, .reusable = true}, SHIFT(947),
  [4418] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [4420] = {.count = 1, .reusable = true}, SHIFT(1129),
  [4422] = {.count = 1, .reusable = true}, SHIFT(1120),
  [4424] = {.count = 1, .reusable = true}, SHIFT(2898),
  [4426] = {.count = 1, .reusable = true}, SHIFT(194),
  [4428] = {.count = 1, .reusable = true}, SHIFT(997),
  [4430] = {.count = 1, .reusable = true}, SHIFT(2699),
  [4432] = {.count = 1, .reusable = true}, SHIFT(1001),
  [4434] = {.count = 1, .reusable = true}, SHIFT(1226),
  [4436] = {.count = 1, .reusable = true}, SHIFT(1103),
  [4438] = {.count = 1, .reusable = true}, SHIFT(908),
  [4440] = {.count = 1, .reusable = true}, SHIFT(1097),
  [4442] = {.count = 1, .reusable = true}, SHIFT(355),
  [4444] = {.count = 1, .reusable = true}, SHIFT(218),
  [4446] = {.count = 1, .reusable = true}, SHIFT(2740),
  [4448] = {.count = 1, .reusable = true}, SHIFT(2732),
  [4450] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 4, .production_id = 53),
  [4452] = {.count = 1, .reusable = true}, SHIFT(2721),
  [4454] = {.count = 1, .reusable = true}, SHIFT(190),
  [4456] = {.count = 1, .reusable = true}, SHIFT(831),
  [4458] = {.count = 1, .reusable = true}, SHIFT(1544),
  [4460] = {.count = 1, .reusable = true}, SHIFT(1543),
  [4462] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [4464] = {.count = 1, .reusable = true}, SHIFT(2313),
  [4466] = {.count = 1, .reusable = true}, SHIFT(1444),
  [4468] = {.count = 1, .reusable = true}, SHIFT(2695),
  [4470] = {.count = 1, .reusable = true}, SHIFT(1542),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1541),
  [4474] = {.count = 1, .reusable = true}, SHIFT(853),
  [4476] = {.count = 1, .reusable = true}, SHIFT(1029),
  [4478] = {.count = 1, .reusable = true}, SHIFT(219),
  [4480] = {.count = 1, .reusable = true}, SHIFT(1587),
  [4482] = {.count = 1, .reusable = true}, SHIFT(922),
  [4484] = {.count = 1, .reusable = true}, SHIFT(1393),
  [4486] = {.count = 1, .reusable = true}, SHIFT(357),
  [4488] = {.count = 1, .reusable = true}, SHIFT(704),
  [4490] = {.count = 1, .reusable = true}, SHIFT(1454),
  [4492] = {.count = 1, .reusable = true}, SHIFT(220),
  [4494] = {.count = 1, .reusable = true}, SHIFT(348),
  [4496] = {.count = 1, .reusable = true}, SHIFT(335),
  [4498] = {.count = 1, .reusable = true}, SHIFT(2786),
  [4500] = {.count = 1, .reusable = true}, SHIFT(668),
  [4502] = {.count = 1, .reusable = true}, SHIFT(2573),
  [4504] = {.count = 1, .reusable = true}, SHIFT(1133),
  [4506] = {.count = 1, .reusable = true}, SHIFT(2574),
  [4508] = {.count = 1, .reusable = true}, SHIFT(334),
  [4510] = {.count = 1, .reusable = true}, SHIFT(2579),
  [4512] = {.count = 1, .reusable = true}, SHIFT(1441),
  [4514] = {.count = 1, .reusable = true}, SHIFT(2594),
  [4516] = {.count = 1, .reusable = true}, SHIFT(2600),
  [4518] = {.count = 1, .reusable = true}, SHIFT(2601),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2602),
  [4522] = {.count = 1, .reusable = true}, SHIFT(1462),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1591),
  [4526] = {.count = 1, .reusable = true}, SHIFT(2614),
  [4528] = {.count = 1, .reusable = true}, SHIFT(2651),
  [4530] = {.count = 1, .reusable = true}, SHIFT(1460),
  [4532] = {.count = 1, .reusable = true}, SHIFT(2668),
  [4534] = {.count = 1, .reusable = true}, SHIFT(262),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2661),
  [4538] = {.count = 1, .reusable = true}, SHIFT(2545),
  [4540] = {.count = 1, .reusable = true}, SHIFT(367),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1000),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1498),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1450),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1494),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1457),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1026),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1497),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1394),
  [4558] = {.count = 1, .reusable = true}, SHIFT(1396),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1012),
  [4562] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1506),
  [4566] = {.count = 1, .reusable = true}, SHIFT(2549),
  [4568] = {.count = 1, .reusable = true}, SHIFT(364),
  [4570] = {.count = 1, .reusable = true}, SHIFT(361),
  [4572] = {.count = 1, .reusable = true}, SHIFT(1398),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1495),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1033),
  [4578] = {.count = 1, .reusable = true}, SHIFT(1446),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1434),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1073),
  [4584] = {.count = 1, .reusable = true}, SHIFT(374),
  [4586] = {.count = 1, .reusable = true}, SHIFT(229),
  [4588] = {.count = 1, .reusable = true}, SHIFT(200),
  [4590] = {.count = 1, .reusable = true}, SHIFT(199),
  [4592] = {.count = 1, .reusable = true}, SHIFT(761),
  [4594] = {.count = 1, .reusable = true}, SHIFT(2239),
  [4596] = {.count = 1, .reusable = true}, SHIFT(362),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1503),
  [4600] = {.count = 1, .reusable = true}, SHIFT(736),
  [4602] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1087),
  [4606] = {.count = 1, .reusable = true}, SHIFT(238),
};

void *tree_sitter_ruby_external_scanner_create(void);
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ruby(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
  };
  return &language;
}
